/* Generated by wayland-scanner 1.23.0 */

#ifndef AURA_SHELL_CLIENT_PROTOCOL_H
#define AURA_SHELL_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_aura_shell The aura_shell protocol
 * @section page_ifaces_aura_shell Interfaces
 * - @subpage page_iface_zaura_shell - aura_shell
 * - @subpage page_iface_zaura_surface - aura shell interface to a wl_surface
 * - @subpage page_iface_zaura_output - aura shell interface to a wl_output
 * - @subpage page_iface_zaura_toplevel - aura shell interface to the toplevel shell
 * - @subpage page_iface_zaura_popup - aura shell interface to the popup shell
 * - @subpage page_iface_zaura_output_manager - aura shell interface to the output manager
 * @section page_copyright_aura_shell Copyright
 * <pre>
 *
 * Copyright 2017 The Chromium Authors
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 * </pre>
 */
struct wl_output;
struct wl_region;
struct wl_surface;
struct xdg_popup;
struct xdg_toplevel;
struct zaura_output;
struct zaura_output_manager;
struct zaura_popup;
struct zaura_shell;
struct zaura_surface;
struct zaura_toplevel;

#ifndef ZAURA_SHELL_INTERFACE
#define ZAURA_SHELL_INTERFACE
/**
 * @page page_iface_zaura_shell zaura_shell
 * @section page_iface_zaura_shell_desc Description
 *
 * The global interface exposing aura shell capabilities is used to
 * instantiate an interface extension for a wl_surface object.
 * This extended interface will then allow the client to use aura shell
 * specific functionality.
 * @section page_iface_zaura_shell_api API
 * See @ref iface_zaura_shell.
 */
/**
 * @defgroup iface_zaura_shell The zaura_shell interface
 *
 * The global interface exposing aura shell capabilities is used to
 * instantiate an interface extension for a wl_surface object.
 * This extended interface will then allow the client to use aura shell
 * specific functionality.
 */
extern const struct wl_interface zaura_shell_interface;
#endif
#ifndef ZAURA_SURFACE_INTERFACE
#define ZAURA_SURFACE_INTERFACE
/**
 * @page page_iface_zaura_surface zaura_surface
 * @section page_iface_zaura_surface_desc Description
 *
 * An additional interface to a wl_surface object, which allows the
 * client to access aura shell specific functionality for surface.
 * @section page_iface_zaura_surface_api API
 * See @ref iface_zaura_surface.
 */
/**
 * @defgroup iface_zaura_surface The zaura_surface interface
 *
 * An additional interface to a wl_surface object, which allows the
 * client to access aura shell specific functionality for surface.
 */
extern const struct wl_interface zaura_surface_interface;
#endif
#ifndef ZAURA_OUTPUT_INTERFACE
#define ZAURA_OUTPUT_INTERFACE
/**
 * @page page_iface_zaura_output zaura_output
 * @section page_iface_zaura_output_desc Description
 *
 * An additional interface to a wl_output object, which allows the
 * client to access aura shell specific functionality for output.
 * @section page_iface_zaura_output_api API
 * See @ref iface_zaura_output.
 */
/**
 * @defgroup iface_zaura_output The zaura_output interface
 *
 * An additional interface to a wl_output object, which allows the
 * client to access aura shell specific functionality for output.
 */
extern const struct wl_interface zaura_output_interface;
#endif
#ifndef ZAURA_TOPLEVEL_INTERFACE
#define ZAURA_TOPLEVEL_INTERFACE
/**
 * @page page_iface_zaura_toplevel zaura_toplevel
 * @section page_iface_zaura_toplevel_desc Description
 *
 * An interface to the toplevel shell, which allows the
 * client to access shell specific functionality.
 * @section page_iface_zaura_toplevel_api API
 * See @ref iface_zaura_toplevel.
 */
/**
 * @defgroup iface_zaura_toplevel The zaura_toplevel interface
 *
 * An interface to the toplevel shell, which allows the
 * client to access shell specific functionality.
 */
extern const struct wl_interface zaura_toplevel_interface;
#endif
#ifndef ZAURA_POPUP_INTERFACE
#define ZAURA_POPUP_INTERFACE
/**
 * @page page_iface_zaura_popup zaura_popup
 * @section page_iface_zaura_popup_desc Description
 *
 * An interface to the popup shell, which allows the
 * client to access shell specific functionality.
 * @section page_iface_zaura_popup_api API
 * See @ref iface_zaura_popup.
 */
/**
 * @defgroup iface_zaura_popup The zaura_popup interface
 *
 * An interface to the popup shell, which allows the
 * client to access shell specific functionality.
 */
extern const struct wl_interface zaura_popup_interface;
#endif
#ifndef ZAURA_OUTPUT_MANAGER_INTERFACE
#define ZAURA_OUTPUT_MANAGER_INTERFACE
/**
 * @page page_iface_zaura_output_manager zaura_output_manager
 * @section page_iface_zaura_output_manager_desc Description
 *
 * A global responsible for ensuring clients have a complete view of a given
 * output's state immediately following the bind of wl_output, and
 * subsequently as needed.
 *
 * Clients can expect that all the manager's events for a given wl_output
 * arrive before the associated wl_output.done event. Clients must bind to
 * the manager global before any output globals.
 * @section page_iface_zaura_output_manager_api API
 * See @ref iface_zaura_output_manager.
 */
/**
 * @defgroup iface_zaura_output_manager The zaura_output_manager interface
 *
 * A global responsible for ensuring clients have a complete view of a given
 * output's state immediately following the bind of wl_output, and
 * subsequently as needed.
 *
 * Clients can expect that all the manager's events for a given wl_output
 * arrive before the associated wl_output.done event. Clients must bind to
 * the manager global before any output globals.
 */
extern const struct wl_interface zaura_output_manager_interface;
#endif

#ifndef ZAURA_SHELL_ERROR_ENUM
#define ZAURA_SHELL_ERROR_ENUM
enum zaura_shell_error {
	/**
	 * the surface already has an aura surface object associated
	 */
	ZAURA_SHELL_ERROR_AURA_SURFACE_EXISTS = 0,
	/**
	 * the output already has an aura output object associated
	 */
	ZAURA_SHELL_ERROR_AURA_OUTPUT_EXISTS = 1,
};
#endif /* ZAURA_SHELL_ERROR_ENUM */

#ifndef ZAURA_SHELL_LAYOUT_MODE_ENUM
#define ZAURA_SHELL_LAYOUT_MODE_ENUM
/**
 * @ingroup iface_zaura_shell
 * the layout mode
 *
 * Specifies the server's window layout mode.
 */
enum zaura_shell_layout_mode {
	/**
	 * multiple windows
	 */
	ZAURA_SHELL_LAYOUT_MODE_WINDOWED = 1,
	/**
	 * restricted mode for tablet
	 */
	ZAURA_SHELL_LAYOUT_MODE_TABLET = 2,
};
#endif /* ZAURA_SHELL_LAYOUT_MODE_ENUM */

/**
 * @ingroup iface_zaura_shell
 * @struct zaura_shell_listener
 */
struct zaura_shell_listener {
	/**
	 * sends the layout_mode
	 *
	 * Sends the layout_mode used by the server.
	 * @param layout_mode layout_mode enum
	 * @since 11
	 */
	void (*layout_mode)(void *data,
			    struct zaura_shell *zaura_shell,
			    uint32_t layout_mode);
	/**
	 * sends a bug fix ID
	 *
	 * Sends a monorail ID of a bug fixed on the exo server that
	 * clients can use to gate functionality.
	 * @param id ID of a single bug fix
	 * @since 14
	 */
	void (*bug_fix)(void *data,
			struct zaura_shell *zaura_shell,
			uint32_t id);
	/**
	 * sends names of desks
	 *
	 * Notifies when there is a change in global desks state. This is
	 * emitted on desk name changes, desk addition/removal or desks are
	 * reordered. "desk_names" argument contains the set of null
	 * terminated strings as names of desks.
	 * @param desk_names an array of existing desks' names
	 * @since 22
	 */
	void (*desks_changed)(void *data,
			      struct zaura_shell *zaura_shell,
			      struct wl_array *desk_names);
	/**
	 * sends the index of the active desk
	 *
	 * Notifies when there is a change of the active desk.
	 * @param active_desk_index index of the active desk
	 * @since 22
	 */
	void (*desk_activation_changed)(void *data,
					struct zaura_shell *zaura_shell,
					int32_t active_desk_index);
	/**
	 * activated surface changed
	 *
	 * Notifies client that the activated surface changed.
	 * @since 24
	 */
	void (*activated)(void *data,
			  struct zaura_shell *zaura_shell,
			  struct wl_surface *gained_active,
			  struct wl_surface *lost_active);
	/**
	 * entered overview mode
	 *
	 * Notifies client that the server has entered overview mode.
	 * Overview mode displays all app windows associated with the
	 * current desk for the user.
	 * @since 57
	 */
	void (*set_overview_mode)(void *data,
				  struct zaura_shell *zaura_shell);
	/**
	 * exited overview mode
	 *
	 * Notifies client that the server has exited overview mode.
	 * @since 57
	 */
	void (*unset_overview_mode)(void *data,
				    struct zaura_shell *zaura_shell);
	/**
	 * sends the server version
	 *
	 * Sends the Exo compositor version information.
	 * @param version_label version string label
	 * @since 58
	 */
	void (*compositor_version)(void *data,
				   struct zaura_shell *zaura_shell,
				   const char *version_label);
	/**
	 * completed sending all bug fix ids
	 *
	 * Notifies client that all the IDs of a bug fixed on the exo
	 * server is sent. Bug fix ids are sent via `bug_fix` events which
	 * sends ids one by one, not an array. This event is used to
	 * confirm all ids are sent.
	 * @since 60
	 */
	void (*all_bug_fixes_sent)(void *data,
				   struct zaura_shell *zaura_shell);
	/**
	 * sends the radius of each corner the window
	 *
	 * Sends the radius of each corner of the window to the clients
	 * in dips.
	 * @since 61
	 */
	void (*window_corners_radii)(void *data,
				     struct zaura_shell *zaura_shell,
				     uint32_t upper_left_radius,
				     uint32_t upper_right_radius,
				     uint32_t lower_right_radius,
				     uint32_t lower_left_radius);
};

/**
 * @ingroup iface_zaura_shell
 */
static inline int
zaura_shell_add_listener(struct zaura_shell *zaura_shell,
			 const struct zaura_shell_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) zaura_shell,
				     (void (**)(void)) listener, data);
}

#define ZAURA_SHELL_GET_AURA_SURFACE 0
#define ZAURA_SHELL_GET_AURA_OUTPUT 1
#define ZAURA_SHELL_SURFACE_SUBMISSION_IN_PIXEL_COORDINATES 2
#define ZAURA_SHELL_GET_AURA_TOPLEVEL_FOR_XDG_TOPLEVEL 3
#define ZAURA_SHELL_GET_AURA_POPUP_FOR_XDG_POPUP 4
#define ZAURA_SHELL_RELEASE 5

/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_LAYOUT_MODE_SINCE_VERSION 11
/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_BUG_FIX_SINCE_VERSION 14
/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_DESKS_CHANGED_SINCE_VERSION 22
/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_DESK_ACTIVATION_CHANGED_SINCE_VERSION 22
/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_ACTIVATED_SINCE_VERSION 24
/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_SET_OVERVIEW_MODE_SINCE_VERSION 57
/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_UNSET_OVERVIEW_MODE_SINCE_VERSION 57
/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_COMPOSITOR_VERSION_SINCE_VERSION 58
/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_ALL_BUG_FIXES_SENT_SINCE_VERSION 60
/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_WINDOW_CORNERS_RADII_SINCE_VERSION 61

/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_GET_AURA_SURFACE_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_GET_AURA_OUTPUT_SINCE_VERSION 2
/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_SURFACE_SUBMISSION_IN_PIXEL_COORDINATES_SINCE_VERSION 26
/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_GET_AURA_TOPLEVEL_FOR_XDG_TOPLEVEL_SINCE_VERSION 27
/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_GET_AURA_POPUP_FOR_XDG_POPUP_SINCE_VERSION 28
/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_RELEASE_SINCE_VERSION 38

/** @ingroup iface_zaura_shell */
static inline void
zaura_shell_set_user_data(struct zaura_shell *zaura_shell, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zaura_shell, user_data);
}

/** @ingroup iface_zaura_shell */
static inline void *
zaura_shell_get_user_data(struct zaura_shell *zaura_shell)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zaura_shell);
}

static inline uint32_t
zaura_shell_get_version(struct zaura_shell *zaura_shell)
{
	return wl_proxy_get_version((struct wl_proxy *) zaura_shell);
}

/** @ingroup iface_zaura_shell */
static inline void
zaura_shell_destroy(struct zaura_shell *zaura_shell)
{
	wl_proxy_destroy((struct wl_proxy *) zaura_shell);
}

/**
 * @ingroup iface_zaura_shell
 *
 * Instantiate an interface extension for the given wl_surface to
 * provide aura shell functionality. If the given wl_surface is not
 * associated with a shell surface, the shell_surface_missing protocol
 * error is raised.
 */
static inline struct zaura_surface *
zaura_shell_get_aura_surface(struct zaura_shell *zaura_shell, struct wl_surface *surface)
{
	struct wl_proxy *id;

	id = wl_proxy_marshal_flags((struct wl_proxy *) zaura_shell,
			 ZAURA_SHELL_GET_AURA_SURFACE, &zaura_surface_interface, wl_proxy_get_version((struct wl_proxy *) zaura_shell), 0, NULL, surface);

	return (struct zaura_surface *) id;
}

/**
 * @ingroup iface_zaura_shell
 *
 * Instantiate an interface extension for the given wl_output to
 * provide aura shell functionality.
 */
static inline struct zaura_output *
zaura_shell_get_aura_output(struct zaura_shell *zaura_shell, struct wl_output *output)
{
	struct wl_proxy *id;

	id = wl_proxy_marshal_flags((struct wl_proxy *) zaura_shell,
			 ZAURA_SHELL_GET_AURA_OUTPUT, &zaura_output_interface, wl_proxy_get_version((struct wl_proxy *) zaura_shell), 0, NULL, output);

	return (struct zaura_output *) id;
}

/**
 * @ingroup iface_zaura_shell
 *
 * [Deprecated] Informs the server that when submitting surfaces, this
 * client will not use wl_surface_set_buffer_scale to report the scales,
 * nor will it apply scale via vp_viewporter. Instead the server should
 * apply an appropriate scale transform to have the submitted buffers
 * composited correctly.
 */
static inline void
zaura_shell_surface_submission_in_pixel_coordinates(struct zaura_shell *zaura_shell)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_shell,
			 ZAURA_SHELL_SURFACE_SUBMISSION_IN_PIXEL_COORDINATES, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_shell), 0);
}

/**
 * @ingroup iface_zaura_shell
 *
 * Retrieve the aura toplevel interface for a given xdg toplevel interface
 */
static inline struct zaura_toplevel *
zaura_shell_get_aura_toplevel_for_xdg_toplevel(struct zaura_shell *zaura_shell, struct xdg_toplevel *toplevel)
{
	struct wl_proxy *id;

	id = wl_proxy_marshal_flags((struct wl_proxy *) zaura_shell,
			 ZAURA_SHELL_GET_AURA_TOPLEVEL_FOR_XDG_TOPLEVEL, &zaura_toplevel_interface, wl_proxy_get_version((struct wl_proxy *) zaura_shell), 0, NULL, toplevel);

	return (struct zaura_toplevel *) id;
}

/**
 * @ingroup iface_zaura_shell
 *
 * Retrieve the aura popup interface for the given xdg popup interface
 */
static inline struct zaura_popup *
zaura_shell_get_aura_popup_for_xdg_popup(struct zaura_shell *zaura_shell, struct xdg_popup *popup)
{
	struct wl_proxy *id;

	id = wl_proxy_marshal_flags((struct wl_proxy *) zaura_shell,
			 ZAURA_SHELL_GET_AURA_POPUP_FOR_XDG_POPUP, &zaura_popup_interface, wl_proxy_get_version((struct wl_proxy *) zaura_shell), 0, NULL, popup);

	return (struct zaura_popup *) id;
}

/**
 * @ingroup iface_zaura_shell
 *
 * Using this request a client can tell the server that it is not going to
 * use the zaura_shell object anymore. This does not affect any other objects.
 *
 * This is named "release" because "destroy" is a special named function used for
 * freeing wl_proxy objects. Naming it "destroy" will cause marshalling errors
 * when running on lower versioned hosts. All "release" requests here should be
 * renamed to "destroy" if we move to aura-shell v2.
 */
static inline void
zaura_shell_release(struct zaura_shell *zaura_shell)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_shell,
			 ZAURA_SHELL_RELEASE, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_shell), WL_MARSHAL_FLAG_DESTROY);
}

#ifndef ZAURA_SURFACE_FRAME_TYPE_ENUM
#define ZAURA_SURFACE_FRAME_TYPE_ENUM
/**
 * @ingroup iface_zaura_surface
 * different frame types
 *
 * Frame types that can be used to decorate a surface.
 */
enum zaura_surface_frame_type {
	/**
	 * no frame
	 */
	ZAURA_SURFACE_FRAME_TYPE_NONE = 0,
	/**
	 * caption with shadow
	 */
	ZAURA_SURFACE_FRAME_TYPE_NORMAL = 1,
	/**
	 * shadow only
	 */
	ZAURA_SURFACE_FRAME_TYPE_SHADOW = 2,
};
#endif /* ZAURA_SURFACE_FRAME_TYPE_ENUM */

#ifndef ZAURA_SURFACE_OCCLUSION_CHANGE_REASON_ENUM
#define ZAURA_SURFACE_OCCLUSION_CHANGE_REASON_ENUM
/**
 * @ingroup iface_zaura_surface
 * occlusion change reason
 *
 * Enum describing why an occlusion change happened. An occlusion change as a
 * result of a user action could include things like the user moving a window,
 * changing occlusion, or opening/closing a window, changing the occlusion.
 */
enum zaura_surface_occlusion_change_reason {
	/**
	 * occlusion changed as a result of a user action
	 */
	ZAURA_SURFACE_OCCLUSION_CHANGE_REASON_USER_ACTION = 1,
};
#endif /* ZAURA_SURFACE_OCCLUSION_CHANGE_REASON_ENUM */

#ifndef ZAURA_SURFACE_FULLSCREEN_MODE_ENUM
#define ZAURA_SURFACE_FULLSCREEN_MODE_ENUM
/**
 * @ingroup iface_zaura_surface
 * Specifies the behavior of the surface in fullscreen.
 *
 * [Deprecated] Possible windowing system behaviors if this surface were to go
 * fullscreen.
 */
enum zaura_surface_fullscreen_mode {
	/**
	 * user can access system UIs such as the shelf and window frame           by pointing to, or swiping over, the screen edge
	 */
	ZAURA_SURFACE_FULLSCREEN_MODE_IMMERSIVE = 0,
	/**
	 * user cannot access system UIs using mouse/touches
	 */
	ZAURA_SURFACE_FULLSCREEN_MODE_PLAIN = 1,
};
#endif /* ZAURA_SURFACE_FULLSCREEN_MODE_ENUM */

#ifndef ZAURA_SURFACE_SNAP_DIRECTION_ENUM
#define ZAURA_SURFACE_SNAP_DIRECTION_ENUM
/**
 * @ingroup iface_zaura_surface
 * surface snap directions
 *
 * Surface snap directions.
 */
enum zaura_surface_snap_direction {
	/**
	 * 
	 */
	ZAURA_SURFACE_SNAP_DIRECTION_NONE = 0,
	/**
	 * 
	 */
	ZAURA_SURFACE_SNAP_DIRECTION_LEFT = 1,
	/**
	 * 
	 */
	ZAURA_SURFACE_SNAP_DIRECTION_RIGHT = 2,
};
#endif /* ZAURA_SURFACE_SNAP_DIRECTION_ENUM */

#ifndef ZAURA_SURFACE_OCCLUSION_STATE_ENUM
#define ZAURA_SURFACE_OCCLUSION_STATE_ENUM
/**
 * @ingroup iface_zaura_surface
 * surface occlusion state
 *
 * Describes the occlusion state of a surface.
 */
enum zaura_surface_occlusion_state {
	/**
	 * The surface's occlusion state isn't tracked
	 */
	ZAURA_SURFACE_OCCLUSION_STATE_UNKNOWN = 0,
	/**
	 * The surface is visible
	 */
	ZAURA_SURFACE_OCCLUSION_STATE_VISIBLE = 1,
	/**
	 * The surface is occluded
	 */
	ZAURA_SURFACE_OCCLUSION_STATE_OCCLUDED = 2,
	/**
	 * The surface is not visible
	 */
	ZAURA_SURFACE_OCCLUSION_STATE_HIDDEN = 3,
};
#endif /* ZAURA_SURFACE_OCCLUSION_STATE_ENUM */

#ifndef ZAURA_SURFACE_TOOLTIP_TRIGGER_ENUM
#define ZAURA_SURFACE_TOOLTIP_TRIGGER_ENUM
/**
 * @ingroup iface_zaura_surface
 * type of tooltip trigger
 *
 * Describes what triggered tooltip
 */
enum zaura_surface_tooltip_trigger {
	/**
	 * triggered by cursor
	 */
	ZAURA_SURFACE_TOOLTIP_TRIGGER_CURSOR = 0,
	/**
	 * triggered by keyboard
	 */
	ZAURA_SURFACE_TOOLTIP_TRIGGER_KEYBOARD = 1,
};
#endif /* ZAURA_SURFACE_TOOLTIP_TRIGGER_ENUM */

/**
 * @ingroup iface_zaura_surface
 * @struct zaura_surface_listener
 */
struct zaura_surface_listener {
	/**
	 * Notifies on an occlusion change
	 *
	 * Notifies when there is a change in the amount this surface is
	 * occluded. The occlusion update is sent as a fixed point number
	 * from 0 to 1, representing the proportion of occlusion.
	 * @since 8
	 */
	void (*occlusion_changed)(void *data,
				  struct zaura_surface *zaura_surface,
				  wl_fixed_t occlusion_fraction,
				  uint32_t occlusion_reason);
	/**
	 * Notify the client that server intent to lock window in normal or restore state
	 *
	 * Notifies the client to lock window in normal or restore state.
	 * When window is locked, the window frame should look like it is
	 * in restored state, but actually isn't. Locking happends while
	 * dragging a maximized window.
	 * @since 17
	 */
	void (*lock_frame_normal)(void *data,
				  struct zaura_surface *zaura_surface);
	/**
	 * Notify the client that server intent to unlock window's normal or restore state
	 *
	 * Notifies the client to unlock window if it is previously
	 * locked. Unlocking happends while dragging a maximized window.
	 * @since 17
	 */
	void (*unlock_frame_normal)(void *data,
				    struct zaura_surface *zaura_surface);
	/**
	 * Notify the client that the occlusion state changed
	 *
	 * Notifies the client that the occlusion state of a window has
	 * changed. Clients will only receive these messages if they
	 * previously request occlusion tracking via set_occlusion_tracking
	 * for a particular surface.
	 * @since 21
	 */
	void (*occlusion_state_changed)(void *data,
					struct zaura_surface *zaura_surface,
					uint32_t mode);
	/**
	 * window desk state changed
	 *
	 * Notifies when there is a change in the desk state of a window.
	 * This is emitted when a window is moved to another desk or when
	 * its assigned-to-all-desks state changes.
	 * @param state index of desk or -1 for a window assigned to all desks
	 * @since 22
	 */
	void (*desk_changed)(void *data,
			     struct zaura_surface *zaura_surface,
			     int32_t state);
	/**
	 * start throttling on the surface
	 *
	 * Informs the client to start throttling on the surface.
	 * @since 29
	 */
	void (*start_throttle)(void *data,
			       struct zaura_surface *zaura_surface);
	/**
	 * end throttling on the surface
	 *
	 * Informs the client to end throttling on the surface.
	 * @since 29
	 */
	void (*end_throttle)(void *data,
			     struct zaura_surface *zaura_surface);
	/**
	 * tooltip is shown by server side
	 *
	 * Informs the client that the tooltip is shown with states. `x`
	 * and `y` specifies the location of tooltip in surface local
	 * coordinates.
	 * @since 47
	 */
	void (*tooltip_shown)(void *data,
			      struct zaura_surface *zaura_surface,
			      const char *text,
			      int32_t x,
			      int32_t y,
			      int32_t width,
			      int32_t height);
	/**
	 * tooltip is hidden by server side
	 *
	 * Informs the client that the tooltip is hidden.
	 * @since 47
	 */
	void (*tooltip_hidden)(void *data,
			       struct zaura_surface *zaura_surface);
};

/**
 * @ingroup iface_zaura_surface
 */
static inline int
zaura_surface_add_listener(struct zaura_surface *zaura_surface,
			   const struct zaura_surface_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) zaura_surface,
				     (void (**)(void)) listener, data);
}

#define ZAURA_SURFACE_SET_FRAME 0
#define ZAURA_SURFACE_SET_PARENT 1
#define ZAURA_SURFACE_SET_FRAME_COLORS 2
#define ZAURA_SURFACE_SET_STARTUP_ID 3
#define ZAURA_SURFACE_SET_APPLICATION_ID 4
#define ZAURA_SURFACE_SET_CLIENT_SURFACE_ID 5
#define ZAURA_SURFACE_SET_OCCLUSION_TRACKING 6
#define ZAURA_SURFACE_UNSET_OCCLUSION_TRACKING 7
#define ZAURA_SURFACE_ACTIVATE 8
#define ZAURA_SURFACE_DRAW_ATTENTION 9
#define ZAURA_SURFACE_SET_FULLSCREEN_MODE 10
#define ZAURA_SURFACE_SET_CLIENT_SURFACE_STR_ID 11
#define ZAURA_SURFACE_SET_SERVER_START_RESIZE 12
#define ZAURA_SURFACE_INTENT_TO_SNAP 13
#define ZAURA_SURFACE_SET_SNAP_LEFT 14
#define ZAURA_SURFACE_SET_SNAP_RIGHT 15
#define ZAURA_SURFACE_UNSET_SNAP 16
#define ZAURA_SURFACE_SET_WINDOW_SESSION_ID 17
#define ZAURA_SURFACE_SET_CAN_GO_BACK 18
#define ZAURA_SURFACE_UNSET_CAN_GO_BACK 19
#define ZAURA_SURFACE_SET_PIP 20
#define ZAURA_SURFACE_UNSET_PIP 21
#define ZAURA_SURFACE_SET_ASPECT_RATIO 22
#define ZAURA_SURFACE_MOVE_TO_DESK 23
#define ZAURA_SURFACE_SET_INITIAL_WORKSPACE 24
#define ZAURA_SURFACE_SET_PIN 25
#define ZAURA_SURFACE_UNSET_PIN 26
#define ZAURA_SURFACE_RELEASE 27
#define ZAURA_SURFACE_SHOW_TOOLTIP 28
#define ZAURA_SURFACE_HIDE_TOOLTIP 29
#define ZAURA_SURFACE_SET_ACCESSIBILITY_ID 30

/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_OCCLUSION_CHANGED_SINCE_VERSION 8
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_LOCK_FRAME_NORMAL_SINCE_VERSION 17
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_UNLOCK_FRAME_NORMAL_SINCE_VERSION 17
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_OCCLUSION_STATE_CHANGED_SINCE_VERSION 21
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_DESK_CHANGED_SINCE_VERSION 22
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_START_THROTTLE_SINCE_VERSION 29
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_END_THROTTLE_SINCE_VERSION 29
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_TOOLTIP_SHOWN_SINCE_VERSION 47
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_TOOLTIP_HIDDEN_SINCE_VERSION 47

/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_FRAME_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_PARENT_SINCE_VERSION 2
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_FRAME_COLORS_SINCE_VERSION 3
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_STARTUP_ID_SINCE_VERSION 4
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_APPLICATION_ID_SINCE_VERSION 5
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_CLIENT_SURFACE_ID_SINCE_VERSION 7
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_OCCLUSION_TRACKING_SINCE_VERSION 8
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_UNSET_OCCLUSION_TRACKING_SINCE_VERSION 8
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_ACTIVATE_SINCE_VERSION 9
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_DRAW_ATTENTION_SINCE_VERSION 9
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_FULLSCREEN_MODE_SINCE_VERSION 10
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_CLIENT_SURFACE_STR_ID_SINCE_VERSION 12
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_SERVER_START_RESIZE_SINCE_VERSION 15
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_INTENT_TO_SNAP_SINCE_VERSION 16
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_SNAP_LEFT_SINCE_VERSION 16
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_SNAP_RIGHT_SINCE_VERSION 16
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_UNSET_SNAP_SINCE_VERSION 16
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_WINDOW_SESSION_ID_SINCE_VERSION 18
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_CAN_GO_BACK_SINCE_VERSION 19
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_UNSET_CAN_GO_BACK_SINCE_VERSION 19
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_PIP_SINCE_VERSION 20
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_UNSET_PIP_SINCE_VERSION 20
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_ASPECT_RATIO_SINCE_VERSION 20
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_MOVE_TO_DESK_SINCE_VERSION 22
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_INITIAL_WORKSPACE_SINCE_VERSION 23
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_PIN_SINCE_VERSION 25
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_UNSET_PIN_SINCE_VERSION 25
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_RELEASE_SINCE_VERSION 38
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SHOW_TOOLTIP_SINCE_VERSION 47
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_HIDE_TOOLTIP_SINCE_VERSION 47
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_ACCESSIBILITY_ID_SINCE_VERSION 51

/** @ingroup iface_zaura_surface */
static inline void
zaura_surface_set_user_data(struct zaura_surface *zaura_surface, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zaura_surface, user_data);
}

/** @ingroup iface_zaura_surface */
static inline void *
zaura_surface_get_user_data(struct zaura_surface *zaura_surface)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zaura_surface);
}

static inline uint32_t
zaura_surface_get_version(struct zaura_surface *zaura_surface)
{
	return wl_proxy_get_version((struct wl_proxy *) zaura_surface);
}

/** @ingroup iface_zaura_surface */
static inline void
zaura_surface_destroy(struct zaura_surface *zaura_surface)
{
	wl_proxy_destroy((struct wl_proxy *) zaura_surface);
}

/**
 * @ingroup iface_zaura_surface
 *
 * [Deprecated] Suggests a surface should use a specific frame. Deprecated
 * since M105. See the set_decoration method on zaura_toplevel and
 * zaura_popup.
 */
static inline void
zaura_surface_set_frame(struct zaura_surface *zaura_surface, uint32_t type)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_SET_FRAME, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0, type);
}

/**
 * @ingroup iface_zaura_surface
 *
 * Set the "parent" of this surface. "x" and "y" arguments specify the
 * initial position for surface relative to parent.
 */
static inline void
zaura_surface_set_parent(struct zaura_surface *zaura_surface, struct zaura_surface *parent, int32_t x, int32_t y)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_SET_PARENT, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0, parent, x, y);
}

/**
 * @ingroup iface_zaura_surface
 *
 * Set the frame colors.
 */
static inline void
zaura_surface_set_frame_colors(struct zaura_surface *zaura_surface, uint32_t active_color, uint32_t inactive_color)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_SET_FRAME_COLORS, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0, active_color, inactive_color);
}

/**
 * @ingroup iface_zaura_surface
 *
 * Set the startup ID.
 */
static inline void
zaura_surface_set_startup_id(struct zaura_surface *zaura_surface, const char *startup_id)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_SET_STARTUP_ID, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0, startup_id);
}

/**
 * @ingroup iface_zaura_surface
 *
 * Set the application ID.
 */
static inline void
zaura_surface_set_application_id(struct zaura_surface *zaura_surface, const char *application_id)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_SET_APPLICATION_ID, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0, application_id);
}

/**
 * @ingroup iface_zaura_surface
 *
 * Deprecated. Please use set_client_surface_str_id instead.
 * Set the identifier of the surface assigned by the client.
 */
static inline void
zaura_surface_set_client_surface_id(struct zaura_surface *zaura_surface, int32_t client_surface_id)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_SET_CLIENT_SURFACE_ID, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0, client_surface_id);
}

/**
 * @ingroup iface_zaura_surface
 *
 * Sets occlusion tracking on this surface. The client will be updated with a
 * new occlusion fraction when the amount of occlusion of this surface changes.
 */
static inline void
zaura_surface_set_occlusion_tracking(struct zaura_surface *zaura_surface)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_SET_OCCLUSION_TRACKING, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0);
}

/**
 * @ingroup iface_zaura_surface
 *
 * Unsets occlusion tracking for this surface.
 */
static inline void
zaura_surface_unset_occlusion_tracking(struct zaura_surface *zaura_surface)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_UNSET_OCCLUSION_TRACKING, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0);
}

/**
 * @ingroup iface_zaura_surface
 *
 * [Deprecated] Make this the active window. This usually implies something
 * like restacking this surface to the foreground. The compositor is free
 * to ignore this request if it deems the client to be misbehaving.
 * Typically this request will only be honoured in response to some user
 * driven event, such as executing an application or opening a file in a
 * window that already exists.
 */
static inline void
zaura_surface_activate(struct zaura_surface *zaura_surface)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_ACTIVATE, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0);
}

/**
 * @ingroup iface_zaura_surface
 *
 * Draw attention to this surface in a way that does not change the user's
 * focus. This usually means animating window decorations or taskbar icons.
 * The compositor can still ignore this request if it deems fit, but unlike
 * draw_focus, these requests are expected to come from background tasks,
 * and are more likely to be honoured.
 */
static inline void
zaura_surface_draw_attention(struct zaura_surface *zaura_surface)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_DRAW_ATTENTION, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0);
}

/**
 * @ingroup iface_zaura_surface
 *
 * [Deprecated] Use the set_fullscreen_mode in the toplevel interface.
 * Suggests how the windowing system should behave if this surface were
 * to go fullscreen. Does not make the surface fullscreen.
 *
 * Typically the default mode is "immersive".
 */
static inline void
zaura_surface_set_fullscreen_mode(struct zaura_surface *zaura_surface, uint32_t mode)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_SET_FULLSCREEN_MODE, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0, mode);
}

/**
 * @ingroup iface_zaura_surface
 *
 * Set the identifier of the surface assigned by the client.
 */
static inline void
zaura_surface_set_client_surface_str_id(struct zaura_surface *zaura_surface, const char *client_surface_id)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_SET_CLIENT_SURFACE_STR_ID, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0, client_surface_id);
}

/**
 * @ingroup iface_zaura_surface
 *
 * Suggests a surface to have client-side decoration, but
 * server-side decides when and where to start the resize. The server may also
 * apply visual effects to indicate that the resize operation is ongoing.
 */
static inline void
zaura_surface_set_server_start_resize(struct zaura_surface *zaura_surface)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_SET_SERVER_START_RESIZE, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0);
}

/**
 * @ingroup iface_zaura_surface
 *
 * [Deprecated] Use intent_to_snap on zaura_toplevel.
 * Notify (or inform) the server the client's intent to snap the window.
 * To inform it's no longer willing to snap, send 'none'.
 */
static inline void
zaura_surface_intent_to_snap(struct zaura_surface *zaura_surface, uint32_t direction)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_INTENT_TO_SNAP, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0, direction);
}

/**
 * @ingroup iface_zaura_surface
 *
 * [Deprecated] Use set_snap_primary on zaura_toplevel.
 * Request that surface is snapped to the left.
 */
static inline void
zaura_surface_set_snap_left(struct zaura_surface *zaura_surface)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_SET_SNAP_LEFT, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0);
}

/**
 * @ingroup iface_zaura_surface
 *
 * [Deprecated] Use set_snap_secondary on zaura_toplevel.
 * Request that surface is snapped to the right.
 */
static inline void
zaura_surface_set_snap_right(struct zaura_surface *zaura_surface)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_SET_SNAP_RIGHT, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0);
}

/**
 * @ingroup iface_zaura_surface
 *
 * [Deprecated] Use unset_snap on zaura_toplevel.
 * Request that surface resets snapping.
 */
static inline void
zaura_surface_unset_snap(struct zaura_surface *zaura_surface)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_UNSET_SNAP, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0);
}

/**
 * @ingroup iface_zaura_surface
 *
 * Set window session id to the surface.
 */
static inline void
zaura_surface_set_window_session_id(struct zaura_surface *zaura_surface, int32_t id)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_SET_WINDOW_SESSION_ID, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0, id);
}

/**
 * @ingroup iface_zaura_surface
 *
 * Sets that the surface can go back as per its navigation list.
 * This allows the server to react to by minimizing the window upon a
 * system wide back gesture.
 */
static inline void
zaura_surface_set_can_go_back(struct zaura_surface *zaura_surface)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_SET_CAN_GO_BACK, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0);
}

/**
 * @ingroup iface_zaura_surface
 *
 * Unsets that the surface can go back as per its navigation list.
 * See above.
 */
static inline void
zaura_surface_unset_can_go_back(struct zaura_surface *zaura_surface)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_UNSET_CAN_GO_BACK, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0);
}

/**
 * @ingroup iface_zaura_surface
 *
 * Requests that the surface is set to Picture-in-Picture (PIP).
 */
static inline void
zaura_surface_set_pip(struct zaura_surface *zaura_surface)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_SET_PIP, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0);
}

/**
 * @ingroup iface_zaura_surface
 *
 * Requests that the surface is unset from Picture-in-Picture (PIP).
 */
static inline void
zaura_surface_unset_pip(struct zaura_surface *zaura_surface)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_UNSET_PIP, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0);
}

/**
 * @ingroup iface_zaura_surface
 *
 * Sets the aspect ratio of the surface.
 */
static inline void
zaura_surface_set_aspect_ratio(struct zaura_surface *zaura_surface, int32_t width, int32_t height)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_SET_ASPECT_RATIO, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0, width, height);
}

/**
 * @ingroup iface_zaura_surface
 *
 * If |index| equals -1, requests that the server toggles whether client
 * is visible on all workspaces.
 * If |index| is not -1, requests that the server moves the client to the desk at
 * |index|.
 */
static inline void
zaura_surface_move_to_desk(struct zaura_surface *zaura_surface, int32_t index)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_MOVE_TO_DESK, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0, index);
}

/**
 * @ingroup iface_zaura_surface
 *
 * If |initial_workspace| equals '-1', a window is restored and visible on all workspaces,
 * Otherwise, set the initial workspace to restore the window to the corresponding workspace.
 * This is not double buffered and must be set before attaching a buffer.
 */
static inline void
zaura_surface_set_initial_workspace(struct zaura_surface *zaura_surface, const char *initial_workspace)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_SET_INITIAL_WORKSPACE, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0, initial_workspace);
}

/**
 * @ingroup iface_zaura_surface
 *
 * Requests that a window is pinned which means that the system does not allow
 * the user to leave the window until an exit criteria is met.
 *
 * This is a request to get the window pinned so that the user cannot get to any
 * other window / application. There are two modes:
 * A. trusted is 0 - which is slightly less restrictive and allows the user to
 * get out of the window by a predefined way of authentication.
 * B. trusted is not 0 in which case a trusted application was locking down the
 * system and needs to unlock. This is used for e.g. School tests.
 */
static inline void
zaura_surface_set_pin(struct zaura_surface *zaura_surface, int32_t trusted)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_SET_PIN, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0, trusted);
}

/**
 * @ingroup iface_zaura_surface
 *
 * Requests that the user can leave a previously pinned window.
 *
 * This is a request to unpin a previously pinned window. It does not matter if
 * the window was locked with the trusted state or not.
 */
static inline void
zaura_surface_unset_pin(struct zaura_surface *zaura_surface)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_UNSET_PIN, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0);
}

/**
 * @ingroup iface_zaura_surface
 *
 * Destroy the zaura_surface object. A client should destroy this object when the
 * role is unmapped from a wl_surface.
 *
 * See zaura_shell.release for destructor naming.
 */
static inline void
zaura_surface_release(struct zaura_surface *zaura_surface)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_RELEASE, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), WL_MARSHAL_FLAG_DESTROY);
}

/**
 * @ingroup iface_zaura_surface
 *
 * Show tooltip on server side.
 * `x` and `y` specifies the location of tooltip in surface local coordinates.
 * `hide_delay` and `show_delay` specify the time to wait until showing/hiding tooltip.
 * The unit is millisecond.
 */
static inline void
zaura_surface_show_tooltip(struct zaura_surface *zaura_surface, const char *text, int32_t x, int32_t y, uint32_t tooltip_trigger, uint32_t show_delay, uint32_t hide_delay)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_SHOW_TOOLTIP, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0, text, x, y, tooltip_trigger, show_delay, hide_delay);
}

/**
 * @ingroup iface_zaura_surface
 *
 * Hide tooltip created by the same client on server side.
 * This may be called even when there is no tooltip window to hide.
 */
static inline void
zaura_surface_hide_tooltip(struct zaura_surface *zaura_surface)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_HIDE_TOOLTIP, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0);
}

/**
 * @ingroup iface_zaura_surface
 *
 * Set accessibility window ID to the surface. A negative number removes
 * the existing accessibility ID from the surface.
 */
static inline void
zaura_surface_set_accessibility_id(struct zaura_surface *zaura_surface, int32_t id)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_surface,
			 ZAURA_SURFACE_SET_ACCESSIBILITY_ID, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_surface), 0, id);
}

#ifndef ZAURA_OUTPUT_SCALE_PROPERTY_ENUM
#define ZAURA_OUTPUT_SCALE_PROPERTY_ENUM
/**
 * @ingroup iface_zaura_output
 * scale information
 *
 * These flags describe properties of an output scale.
 * They are used in the flags bitfield of the scale event.
 */
enum zaura_output_scale_property {
	/**
	 * indicates this is the current scale
	 */
	ZAURA_OUTPUT_SCALE_PROPERTY_CURRENT = 0x1,
	/**
	 * indicates this is the preferred scale
	 */
	ZAURA_OUTPUT_SCALE_PROPERTY_PREFERRED = 0x2,
};
#endif /* ZAURA_OUTPUT_SCALE_PROPERTY_ENUM */

#ifndef ZAURA_OUTPUT_SCALE_FACTOR_ENUM
#define ZAURA_OUTPUT_SCALE_FACTOR_ENUM
enum zaura_output_scale_factor {
	ZAURA_OUTPUT_SCALE_FACTOR_0400 = 400,
	ZAURA_OUTPUT_SCALE_FACTOR_0500 = 500,
	ZAURA_OUTPUT_SCALE_FACTOR_0550 = 550,
	ZAURA_OUTPUT_SCALE_FACTOR_0600 = 600,
	ZAURA_OUTPUT_SCALE_FACTOR_0625 = 625,
	ZAURA_OUTPUT_SCALE_FACTOR_0650 = 650,
	ZAURA_OUTPUT_SCALE_FACTOR_0700 = 700,
	ZAURA_OUTPUT_SCALE_FACTOR_0750 = 750,
	ZAURA_OUTPUT_SCALE_FACTOR_0800 = 800,
	ZAURA_OUTPUT_SCALE_FACTOR_0850 = 850,
	ZAURA_OUTPUT_SCALE_FACTOR_0900 = 900,
	ZAURA_OUTPUT_SCALE_FACTOR_0950 = 950,
	ZAURA_OUTPUT_SCALE_FACTOR_1000 = 1000,
	ZAURA_OUTPUT_SCALE_FACTOR_1050 = 1050,
	ZAURA_OUTPUT_SCALE_FACTOR_1100 = 1100,
	ZAURA_OUTPUT_SCALE_FACTOR_1150 = 1150,
	ZAURA_OUTPUT_SCALE_FACTOR_1125 = 1125,
	ZAURA_OUTPUT_SCALE_FACTOR_1200 = 1200,
	ZAURA_OUTPUT_SCALE_FACTOR_1250 = 1250,
	ZAURA_OUTPUT_SCALE_FACTOR_1300 = 1300,
	ZAURA_OUTPUT_SCALE_FACTOR_1400 = 1400,
	ZAURA_OUTPUT_SCALE_FACTOR_1450 = 1450,
	ZAURA_OUTPUT_SCALE_FACTOR_1500 = 1500,
	ZAURA_OUTPUT_SCALE_FACTOR_1600 = 1600,
	ZAURA_OUTPUT_SCALE_FACTOR_1750 = 1750,
	ZAURA_OUTPUT_SCALE_FACTOR_1800 = 1800,
	ZAURA_OUTPUT_SCALE_FACTOR_2000 = 2000,
	ZAURA_OUTPUT_SCALE_FACTOR_2200 = 2200,
	ZAURA_OUTPUT_SCALE_FACTOR_2250 = 2250,
	ZAURA_OUTPUT_SCALE_FACTOR_2500 = 2500,
	ZAURA_OUTPUT_SCALE_FACTOR_2750 = 2750,
	ZAURA_OUTPUT_SCALE_FACTOR_3000 = 3000,
	ZAURA_OUTPUT_SCALE_FACTOR_3500 = 3500,
	ZAURA_OUTPUT_SCALE_FACTOR_4000 = 4000,
	ZAURA_OUTPUT_SCALE_FACTOR_4500 = 4500,
	ZAURA_OUTPUT_SCALE_FACTOR_5000 = 5000,
};
#endif /* ZAURA_OUTPUT_SCALE_FACTOR_ENUM */

#ifndef ZAURA_OUTPUT_CONNECTION_TYPE_ENUM
#define ZAURA_OUTPUT_CONNECTION_TYPE_ENUM
enum zaura_output_connection_type {
	ZAURA_OUTPUT_CONNECTION_TYPE_UNKNOWN = 0,
	ZAURA_OUTPUT_CONNECTION_TYPE_INTERNAL = 1,
};
#endif /* ZAURA_OUTPUT_CONNECTION_TYPE_ENUM */

/**
 * @ingroup iface_zaura_output
 * @struct zaura_output_listener
 */
struct zaura_output_listener {
	/**
	 * advertise available scales for the output
	 *
	 * The scale event describes an available scale for the output.
	 *
	 * The event is sent when binding to the output object and there
	 * will always be one scale, the current scale. The event is sent
	 * again if an output changes scale, for the scale that is now
	 * current. In other words, the current scale is always the last
	 * scale that was received with the current flag set.
	 * @param flags bitfield of scale flags
	 * @param scale output scale
	 * @since 2
	 */
	void (*scale)(void *data,
		      struct zaura_output *zaura_output,
		      uint32_t flags,
		      uint32_t scale);
	/**
	 * advertise connection for the output
	 *
	 * The connection event describes how the output is connected.
	 *
	 * The event is sent when binding to the output object.
	 * @param connection output connection
	 * @since 5
	 */
	void (*connection)(void *data,
			   struct zaura_output *zaura_output,
			   uint32_t connection);
	/**
	 * advertise device scale factor for the output
	 *
	 * This event describes the device specific scale factor for the
	 * output.
	 *
	 * The device specific scale factor is not expected the change
	 * during the lifetime of the output. And it is not limited to an
	 * integer value like the scale factor provided by wl_output
	 * interface. The exact contents scale used by the compositor can
	 * be determined by combining this device scale factor with the
	 * current output scale.
	 *
	 * The event is sent when binding to the output object.
	 * @param scale output device scale factor
	 * @since 5
	 */
	void (*device_scale_factor)(void *data,
				    struct zaura_output *zaura_output,
				    uint32_t scale);
	/**
	 * advertise the work area insets for the output
	 *
	 * This event describes the insets for the output in logical
	 * screen coordinates, from which the work area can be calculated.
	 *
	 * This event is sent before wl_output.done, after which the client
	 * would apply the change.
	 * @since 33
	 */
	void (*insets)(void *data,
		       struct zaura_output *zaura_output,
		       int32_t top,
		       int32_t left,
		       int32_t bottom,
		       int32_t right);
	/**
	 * advertise the output's logical transform
	 *
	 * This event describes the logical transform for the output.
	 * Whereas wl_output.geometry's transform corresponds to the
	 * display's panel rotation, the logical transform corresponds to
	 * the display's logical rotation.
	 *
	 * This event is sent before wl_output.done, after which the client
	 * would apply the change.
	 * @since 34
	 */
	void (*logical_transform)(void *data,
				  struct zaura_output *zaura_output,
				  int32_t transform);
	/**
	 * advertise the output's display id
	 *
	 * This event describes the 64bit display id assigned to each
	 * display by ChromeOS. The value is opaque and should not be
	 * interpreted.
	 * @since 43
	 */
	void (*display_id)(void *data,
			   struct zaura_output *zaura_output,
			   uint32_t display_id_hi,
			   uint32_t display_id_lo);
	/**
	 * target display for new windows
	 *
	 * Notifies that this output is now active output. It is
	 * typically used as a target when a new window is created without
	 * specific bounds.
	 * @since 45
	 */
	void (*activated)(void *data,
			  struct zaura_output *zaura_output);
};

/**
 * @ingroup iface_zaura_output
 */
static inline int
zaura_output_add_listener(struct zaura_output *zaura_output,
			  const struct zaura_output_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) zaura_output,
				     (void (**)(void)) listener, data);
}

#define ZAURA_OUTPUT_RELEASE 0

/**
 * @ingroup iface_zaura_output
 */
#define ZAURA_OUTPUT_SCALE_SINCE_VERSION 2
/**
 * @ingroup iface_zaura_output
 */
#define ZAURA_OUTPUT_CONNECTION_SINCE_VERSION 5
/**
 * @ingroup iface_zaura_output
 */
#define ZAURA_OUTPUT_DEVICE_SCALE_FACTOR_SINCE_VERSION 5
/**
 * @ingroup iface_zaura_output
 */
#define ZAURA_OUTPUT_INSETS_SINCE_VERSION 33
/**
 * @ingroup iface_zaura_output
 */
#define ZAURA_OUTPUT_LOGICAL_TRANSFORM_SINCE_VERSION 34
/**
 * @ingroup iface_zaura_output
 */
#define ZAURA_OUTPUT_DISPLAY_ID_SINCE_VERSION 43
/**
 * @ingroup iface_zaura_output
 */
#define ZAURA_OUTPUT_ACTIVATED_SINCE_VERSION 45

/**
 * @ingroup iface_zaura_output
 */
#define ZAURA_OUTPUT_RELEASE_SINCE_VERSION 38

/** @ingroup iface_zaura_output */
static inline void
zaura_output_set_user_data(struct zaura_output *zaura_output, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zaura_output, user_data);
}

/** @ingroup iface_zaura_output */
static inline void *
zaura_output_get_user_data(struct zaura_output *zaura_output)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zaura_output);
}

static inline uint32_t
zaura_output_get_version(struct zaura_output *zaura_output)
{
	return wl_proxy_get_version((struct wl_proxy *) zaura_output);
}

/** @ingroup iface_zaura_output */
static inline void
zaura_output_destroy(struct zaura_output *zaura_output)
{
	wl_proxy_destroy((struct wl_proxy *) zaura_output);
}

/**
 * @ingroup iface_zaura_output
 *
 * Destroy this zaura_shell object.
 *
 * Destroying a bound zaura_shell object while there are zaura_surfaces
 * still alive created by this zaura_shell object instance is illegal
 * and will result in a protocol error.
 *
 * See zaura_shell.release for destructor naming.
 */
static inline void
zaura_output_release(struct zaura_output *zaura_output)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_output,
			 ZAURA_OUTPUT_RELEASE, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_output), WL_MARSHAL_FLAG_DESTROY);
}

#ifndef ZAURA_TOPLEVEL_ORIENTATION_LOCK_ENUM
#define ZAURA_TOPLEVEL_ORIENTATION_LOCK_ENUM
/**
 * @ingroup iface_zaura_toplevel
 * orientation lock request
 *
 * Defines orientation request when a surface is in fullscreen.
 */
enum zaura_toplevel_orientation_lock {
	/**
	 * no orientation lock
	 */
	ZAURA_TOPLEVEL_ORIENTATION_LOCK_NONE = 1,
	/**
	 * primary or secondary portrait
	 */
	ZAURA_TOPLEVEL_ORIENTATION_LOCK_PORTRAIT = 2,
	/**
	 * primary or secondary landscape
	 */
	ZAURA_TOPLEVEL_ORIENTATION_LOCK_LANDSCAPE = 3,
	/**
	 * keep current orientation
	 */
	ZAURA_TOPLEVEL_ORIENTATION_LOCK_CURRENT = 4,
	/**
	 * primary portrait
	 */
	ZAURA_TOPLEVEL_ORIENTATION_LOCK_PORTRAIT_PRIMARY = 5,
	/**
	 * primary landscape
	 */
	ZAURA_TOPLEVEL_ORIENTATION_LOCK_LANDSCAPE_PRIMARY = 6,
	/**
	 * secondary portrait
	 */
	ZAURA_TOPLEVEL_ORIENTATION_LOCK_PORTRAIT_SECONDARY = 7,
	/**
	 * secondary landscape
	 */
	ZAURA_TOPLEVEL_ORIENTATION_LOCK_LANDSCAPE_SECONDARY = 8,
};
#endif /* ZAURA_TOPLEVEL_ORIENTATION_LOCK_ENUM */

#ifndef ZAURA_TOPLEVEL_STATE_ENUM
#define ZAURA_TOPLEVEL_STATE_ENUM
/**
 * @ingroup iface_zaura_toplevel
 * supplemental aura states to xdg states
 *
 * The states that are contained here are supplemental to the states
 * defined in the XDG shell and specific aura windows.
 */
enum zaura_toplevel_state {
	/**
	 * immersive mode with hidden title bar and shelf
	 *
	 * User can access system UIs such as the shelf and window frame
	 * by pointing to, or swiping over, the screen edge.
	 * @since 36
	 */
	ZAURA_TOPLEVEL_STATE_IMMERSIVE = 100,
	/**
	 * surface is minimized
	 *
	 * The window has been minimized.
	 * @since 36
	 */
	ZAURA_TOPLEVEL_STATE_MINIMIZED = 101,
	/**
	 * window is snapped in primary position
	 *
	 * The window is snapped to the left if the display is in
	 * landscape mode and at the top in portrait mode.
	 * @since 38
	 */
	ZAURA_TOPLEVEL_STATE_SNAPPED_PRIMARY = 102,
	/**
	 * window is snapped in secondary position
	 *
	 * The window is snapped to the right if the display is in
	 * landscape mode and at the bottom in portrait mode.
	 * @since 38
	 */
	ZAURA_TOPLEVEL_STATE_SNAPPED_SECONDARY = 103,
	/**
	 * window is floated on top
	 *
	 * The window is floated on top of other windows. One floated
	 * window is allowed per desk. Floating a window when there is
	 * already a floated window on the same desk will unfloat the
	 * floated window.
	 * @since 38
	 */
	ZAURA_TOPLEVEL_STATE_FLOATED = 104,
	/**
	 * window is PiP
	 *
	 * The window is in PiP mode.
	 * @since 54
	 */
	ZAURA_TOPLEVEL_STATE_PIP = 105,
	/**
	 * window is pinned
	 *
	 * The window is pinned.
	 * @since 64
	 */
	ZAURA_TOPLEVEL_STATE_PINNED = 106,
	/**
	 * window is trusted pinned
	 *
	 * The window is trusted pinned.
	 * @since 64
	 */
	ZAURA_TOPLEVEL_STATE_TRUSTED_PINNED = 107,
};
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_STATE_IMMERSIVE_SINCE_VERSION 36
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_STATE_MINIMIZED_SINCE_VERSION 36
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_STATE_SNAPPED_PRIMARY_SINCE_VERSION 38
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_STATE_SNAPPED_SECONDARY_SINCE_VERSION 38
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_STATE_FLOATED_SINCE_VERSION 38
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_STATE_PIP_SINCE_VERSION 54
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_STATE_PINNED_SINCE_VERSION 64
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_STATE_TRUSTED_PINNED_SINCE_VERSION 64
#endif /* ZAURA_TOPLEVEL_STATE_ENUM */

#ifndef ZAURA_TOPLEVEL_DECORATION_TYPE_ENUM
#define ZAURA_TOPLEVEL_DECORATION_TYPE_ENUM
/**
 * @ingroup iface_zaura_toplevel
 * different decoration types
 *
 * Decoration types are used to modify the surface (e.g. drop shadow).
 */
enum zaura_toplevel_decoration_type {
	/**
	 * no frame
	 */
	ZAURA_TOPLEVEL_DECORATION_TYPE_NONE = 0,
	/**
	 * caption with shadow
	 */
	ZAURA_TOPLEVEL_DECORATION_TYPE_NORMAL = 1,
	/**
	 * shadow only
	 */
	ZAURA_TOPLEVEL_DECORATION_TYPE_SHADOW = 2,
};
#endif /* ZAURA_TOPLEVEL_DECORATION_TYPE_ENUM */

#ifndef ZAURA_TOPLEVEL_Z_ORDER_LEVEL_ENUM
#define ZAURA_TOPLEVEL_Z_ORDER_LEVEL_ENUM
/**
 * @ingroup iface_zaura_toplevel
 * z order levels for windows
 *
 * Different z order levels that are used to set the z order for a toplevel surface.
 */
enum zaura_toplevel_z_order_level {
	/**
	 * the default level for windows
	 */
	ZAURA_TOPLEVEL_Z_ORDER_LEVEL_NORMAL = 0,
	/**
	 * a floating window z-ordered above other normal windows
	 */
	ZAURA_TOPLEVEL_Z_ORDER_LEVEL_FLOATING_WINDOW = 1,
	/**
	 * used to show non-window style UIs that are shown above floating windows
	 */
	ZAURA_TOPLEVEL_Z_ORDER_LEVEL_FLOATING_UI_ELEMENT = 2,
	/**
	 * cannot be interfered with or covered up
	 */
	ZAURA_TOPLEVEL_Z_ORDER_LEVEL_SECURITY_SURFACE = 3,
};
#endif /* ZAURA_TOPLEVEL_Z_ORDER_LEVEL_ENUM */

#ifndef ZAURA_TOPLEVEL_FULLSCREEN_MODE_ENUM
#define ZAURA_TOPLEVEL_FULLSCREEN_MODE_ENUM
/**
 * @ingroup iface_zaura_toplevel
 * Specifies the behavior of the surface in fullscreen.
 *
 * Possible windowing system behaviors if this surface were to go
 * fullscreen.
 */
enum zaura_toplevel_fullscreen_mode {
	/**
	 * user cannot access system UIs using mouse/touches
	 */
	ZAURA_TOPLEVEL_FULLSCREEN_MODE_PLAIN = 0,
	/**
	 * user can access system UIs such as the shelf and window frame           by pointing to, or swiping over, the screen edge
	 */
	ZAURA_TOPLEVEL_FULLSCREEN_MODE_IMMERSIVE = 1,
};
#endif /* ZAURA_TOPLEVEL_FULLSCREEN_MODE_ENUM */

#ifndef ZAURA_TOPLEVEL_SNAP_DIRECTION_ENUM
#define ZAURA_TOPLEVEL_SNAP_DIRECTION_ENUM
/**
 * @ingroup iface_zaura_toplevel
 * window snap directions
 *
 * Window snap directions.
 */
enum zaura_toplevel_snap_direction {
	/**
	 * unsnap the window
	 */
	ZAURA_TOPLEVEL_SNAP_DIRECTION_NONE = 0,
	/**
	 * snap the window to the left or         top in primary layout, right or bottom in secondary layout
	 */
	ZAURA_TOPLEVEL_SNAP_DIRECTION_PRIMARY = 1,
	/**
	 * snap the window to the right         or bottom in primary layout, top or left in secondary layout
	 */
	ZAURA_TOPLEVEL_SNAP_DIRECTION_SECONDARY = 2,
};
#endif /* ZAURA_TOPLEVEL_SNAP_DIRECTION_ENUM */

#ifndef ZAURA_TOPLEVEL_PERSISTABLE_ENUM
#define ZAURA_TOPLEVEL_PERSISTABLE_ENUM
/**
 * @ingroup iface_zaura_toplevel
 * Describes whether or not the value is persistable
 *
 * Binary enum maps to boolean, describes whether or not a value is
 * persistable.
 */
enum zaura_toplevel_persistable {
	/**
	 * the value is not persistable
	 */
	ZAURA_TOPLEVEL_PERSISTABLE_NOT_PERSISTABLE = 0,
	/**
	 * the value is persistable
	 */
	ZAURA_TOPLEVEL_PERSISTABLE_PERSISTABLE = 1,
};
#endif /* ZAURA_TOPLEVEL_PERSISTABLE_ENUM */

#ifndef ZAURA_TOPLEVEL_ROTATE_DIRECTION_ENUM
#define ZAURA_TOPLEVEL_ROTATE_DIRECTION_ENUM
enum zaura_toplevel_rotate_direction {
	ZAURA_TOPLEVEL_ROTATE_DIRECTION_BACKWARD = 0,
	ZAURA_TOPLEVEL_ROTATE_DIRECTION_FORWARD = 1,
};
#endif /* ZAURA_TOPLEVEL_ROTATE_DIRECTION_ENUM */

#ifndef ZAURA_TOPLEVEL_ROTATE_RESTART_STATE_ENUM
#define ZAURA_TOPLEVEL_ROTATE_RESTART_STATE_ENUM
enum zaura_toplevel_rotate_restart_state {
	ZAURA_TOPLEVEL_ROTATE_RESTART_STATE_NO_RESTART = 0,
	ZAURA_TOPLEVEL_ROTATE_RESTART_STATE_RESTART = 1,
};
#endif /* ZAURA_TOPLEVEL_ROTATE_RESTART_STATE_ENUM */

#ifndef ZAURA_TOPLEVEL_ROTATE_HANDLED_STATE_ENUM
#define ZAURA_TOPLEVEL_ROTATE_HANDLED_STATE_ENUM
enum zaura_toplevel_rotate_handled_state {
	ZAURA_TOPLEVEL_ROTATE_HANDLED_STATE_NOT_HANDLED = 0,
	ZAURA_TOPLEVEL_ROTATE_HANDLED_STATE_HANDLED = 1,
};
#endif /* ZAURA_TOPLEVEL_ROTATE_HANDLED_STATE_ENUM */

#ifndef ZAURA_TOPLEVEL_FLOAT_START_LOCATION_ENUM
#define ZAURA_TOPLEVEL_FLOAT_START_LOCATION_ENUM
/**
 * @ingroup iface_zaura_toplevel
 * Specifies the location of a surface that just got floated.
 *
 * Possible start locations if a surface gets floated.
 */
enum zaura_toplevel_float_start_location {
	/**
	 * On float, surface goes to the bottom right of the work area. This is the default.
	 */
	ZAURA_TOPLEVEL_FLOAT_START_LOCATION_BOTTOM_RIGHT = 0,
	/**
	 * On float, surface goes to the bottom left of the work area.
	 */
	ZAURA_TOPLEVEL_FLOAT_START_LOCATION_BOTTOM_LEFT = 1,
};
#endif /* ZAURA_TOPLEVEL_FLOAT_START_LOCATION_ENUM */

#ifndef ZAURA_TOPLEVEL_IN_OVERVIEW_ENUM
#define ZAURA_TOPLEVEL_IN_OVERVIEW_ENUM
/**
 * @ingroup iface_zaura_toplevel
 * Describes whether or not the value is in overview
 *
 * Binary enum maps to boolean, describes whether or not a value is in
 * overview.
 */
enum zaura_toplevel_in_overview {
	/**
	 * the value is not in overview
	 */
	ZAURA_TOPLEVEL_IN_OVERVIEW_NOT_IN_OVERVIEW = 0,
	/**
	 * the value is in overview
	 */
	ZAURA_TOPLEVEL_IN_OVERVIEW_IN_OVERVIEW = 1,
};
#endif /* ZAURA_TOPLEVEL_IN_OVERVIEW_ENUM */

/**
 * @ingroup iface_zaura_toplevel
 * @struct zaura_toplevel_listener
 */
struct zaura_toplevel_listener {
	/**
	 * suggest a surface change
	 *
	 * A configuration change that also includes the window origin in
	 * screen coordinates.
	 * @since 29
	 */
	void (*configure)(void *data,
			  struct zaura_toplevel *zaura_toplevel,
			  int32_t x,
			  int32_t y,
			  int32_t width,
			  int32_t height,
			  struct wl_array *states);
	/**
	 * window origin change
	 *
	 * A notification sent when the window origin has changed. Unlike
	 * a configure, this does not imply the client needs to resize. The
	 * values are in screen coordinates.
	 * @since 29
	 */
	void (*origin_change)(void *data,
			      struct zaura_toplevel *zaura_toplevel,
			      int32_t x,
			      int32_t y);
	/**
	 * set the raster scale during a configure
	 *
	 * Sets the raster scale of this window. This should be called
	 * during a configure event sequence. To do so we reinterpret_cast
	 * into a 32-bit uint and later cast back into a float. This is
	 * because wayland does not support native transport of floats. As
	 * different CPU architectures may use different endian
	 * representations for IEEE 754 floats, this protocol implicitly
	 * assumes that the caller and receiver are the same machine.
	 * @param scale Raster scale, in float format
	 * @since 50
	 */
	void (*configure_raster_scale)(void *data,
				       struct zaura_toplevel *zaura_toplevel,
				       uint32_t scale);
	/**
	 * rotate focus within window
	 *
	 * Rotates focus within the toplevel window. The window must sort
	 * its focusable view into a stable and linearly traversable order.
	 * Prior to rotating focus, the surface should already be activated
	 * and have keyboard focus. If the surface has not been activated
	 * or does not have keyboard focus, the server should first
	 * activate and enter keyboard focus for the window. An example of
	 * event order could be:
	 *
	 * 1. activate surface 2. enter keyboard focus 3. rotate focus
	 *
	 * If the window is not activated or does not have keyboard focus,
	 * the client should respond with a "not handled" and not perform
	 * any operation.
	 *
	 * To start a new series rotation, the server will set the
	 * "restart" arg to true. If the "restart" arg is set to true, the
	 * window should set the focus on the first UI element for the
	 * given direction and not perform any rotation.
	 *
	 * The client should respond with whether the rotation was
	 * successful via the "handled" field in the "ack_rotate_focus"
	 * request. The client should pass on the event serial and
	 * direction within the ack message.
	 * @param serial serial for the rotation event
	 * @param direction the direction for linear traversal
	 * @param restart whether or not to restart traversal
	 * @since 56
	 */
	void (*rotate_focus)(void *data,
			     struct zaura_toplevel *zaura_toplevel,
			     uint32_t serial,
			     uint32_t direction,
			     uint32_t restart);
	/**
	 * window is in overview
	 *
	 * The window is being shown in overview mode. Note that this is
	 * different than shell overview state, as not all windows will be
	 * part of the overview grid.
	 * @param in_overview in overview or not
	 * @since 62
	 */
	void (*overview_change)(void *data,
				struct zaura_toplevel *zaura_toplevel,
				uint32_t in_overview);
};

/**
 * @ingroup iface_zaura_toplevel
 */
static inline int
zaura_toplevel_add_listener(struct zaura_toplevel *zaura_toplevel,
			    const struct zaura_toplevel_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) zaura_toplevel,
				     (void (**)(void)) listener, data);
}

#define ZAURA_TOPLEVEL_SET_ORIENTATION_LOCK 0
#define ZAURA_TOPLEVEL_SURFACE_SUBMISSION_IN_PIXEL_COORDINATES 1
#define ZAURA_TOPLEVEL_SET_SUPPORTS_SCREEN_COORDINATES 2
#define ZAURA_TOPLEVEL_SET_WINDOW_BOUNDS 3
#define ZAURA_TOPLEVEL_SET_RESTORE_INFO 4
#define ZAURA_TOPLEVEL_SET_SYSTEM_MODAL 5
#define ZAURA_TOPLEVEL_UNSET_SYSTEM_MODAL 6
#define ZAURA_TOPLEVEL_SET_RESTORE_INFO_WITH_WINDOW_ID_SOURCE 7
#define ZAURA_TOPLEVEL_SET_DECORATION 8
#define ZAURA_TOPLEVEL_RELEASE 9
#define ZAURA_TOPLEVEL_SET_FLOAT 10
#define ZAURA_TOPLEVEL_UNSET_FLOAT 11
#define ZAURA_TOPLEVEL_SET_Z_ORDER 12
#define ZAURA_TOPLEVEL_SET_ORIGIN 13
#define ZAURA_TOPLEVEL_ACTIVATE 14
#define ZAURA_TOPLEVEL_DEACTIVATE 15
#define ZAURA_TOPLEVEL_SET_FULLSCREEN_MODE 16
#define ZAURA_TOPLEVEL_SET_SCALE_FACTOR 17
#define ZAURA_TOPLEVEL_SET_SNAP_PRIMARY 18
#define ZAURA_TOPLEVEL_SET_SNAP_SECONDARY 19
#define ZAURA_TOPLEVEL_INTENT_TO_SNAP 20
#define ZAURA_TOPLEVEL_UNSET_SNAP 21
#define ZAURA_TOPLEVEL_SET_PERSISTABLE 22
#define ZAURA_TOPLEVEL_SET_SHAPE 23
#define ZAURA_TOPLEVEL_SET_TOP_INSET 24
#define ZAURA_TOPLEVEL_ACK_ROTATE_FOCUS 25
#define ZAURA_TOPLEVEL_SET_CAN_MAXIMIZE 26
#define ZAURA_TOPLEVEL_UNSET_CAN_MAXIMIZE 27
#define ZAURA_TOPLEVEL_SET_CAN_FULLSCREEN 28
#define ZAURA_TOPLEVEL_UNSET_CAN_FULLSCREEN 29
#define ZAURA_TOPLEVEL_SET_FLOAT_TO_LOCATION 30
#define ZAURA_TOPLEVEL_SET_WINDOW_CORNER_RADII 31
#define ZAURA_TOPLEVEL_SET_SHADOW_CORNER_RADII 32

/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_CONFIGURE_SINCE_VERSION 29
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_ORIGIN_CHANGE_SINCE_VERSION 29
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_CONFIGURE_RASTER_SCALE_SINCE_VERSION 50
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_ROTATE_FOCUS_SINCE_VERSION 56
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_OVERVIEW_CHANGE_SINCE_VERSION 62

/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_ORIENTATION_LOCK_SINCE_VERSION 26
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SURFACE_SUBMISSION_IN_PIXEL_COORDINATES_SINCE_VERSION 28
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_SUPPORTS_SCREEN_COORDINATES_SINCE_VERSION 29
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_WINDOW_BOUNDS_SINCE_VERSION 29
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_RESTORE_INFO_SINCE_VERSION 30
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_SYSTEM_MODAL_SINCE_VERSION 31
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_UNSET_SYSTEM_MODAL_SINCE_VERSION 31
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_RESTORE_INFO_WITH_WINDOW_ID_SOURCE_SINCE_VERSION 32
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_DECORATION_SINCE_VERSION 35
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_RELEASE_SINCE_VERSION 38
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_FLOAT_SINCE_VERSION 39
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_UNSET_FLOAT_SINCE_VERSION 39
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_Z_ORDER_SINCE_VERSION 40
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_ORIGIN_SINCE_VERSION 41
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_ACTIVATE_SINCE_VERSION 42
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_DEACTIVATE_SINCE_VERSION 42
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_FULLSCREEN_MODE_SINCE_VERSION 44
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_SCALE_FACTOR_SINCE_VERSION 46
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_SNAP_PRIMARY_SINCE_VERSION 48
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_SNAP_SECONDARY_SINCE_VERSION 48
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_INTENT_TO_SNAP_SINCE_VERSION 49
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_UNSET_SNAP_SINCE_VERSION 49
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_PERSISTABLE_SINCE_VERSION 52
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_SHAPE_SINCE_VERSION 53
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_TOP_INSET_SINCE_VERSION 55
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_ACK_ROTATE_FOCUS_SINCE_VERSION 56
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_CAN_MAXIMIZE_SINCE_VERSION 58
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_UNSET_CAN_MAXIMIZE_SINCE_VERSION 58
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_CAN_FULLSCREEN_SINCE_VERSION 58
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_UNSET_CAN_FULLSCREEN_SINCE_VERSION 58
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_FLOAT_TO_LOCATION_SINCE_VERSION 59
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_WINDOW_CORNER_RADII_SINCE_VERSION 60
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_SHADOW_CORNER_RADII_SINCE_VERSION 63

/** @ingroup iface_zaura_toplevel */
static inline void
zaura_toplevel_set_user_data(struct zaura_toplevel *zaura_toplevel, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zaura_toplevel, user_data);
}

/** @ingroup iface_zaura_toplevel */
static inline void *
zaura_toplevel_get_user_data(struct zaura_toplevel *zaura_toplevel)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zaura_toplevel);
}

static inline uint32_t
zaura_toplevel_get_version(struct zaura_toplevel *zaura_toplevel)
{
	return wl_proxy_get_version((struct wl_proxy *) zaura_toplevel);
}

/** @ingroup iface_zaura_toplevel */
static inline void
zaura_toplevel_destroy(struct zaura_toplevel *zaura_toplevel)
{
	wl_proxy_destroy((struct wl_proxy *) zaura_toplevel);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Request a specific orientation behavior when this surface is in fullscreen.
 */
static inline void
zaura_toplevel_set_orientation_lock(struct zaura_toplevel *zaura_toplevel, uint32_t orientation_lock)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_SET_ORIENTATION_LOCK, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0, orientation_lock);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Informs the server that when submitting this surface, this client will not
 * use wl_surface_set_buffer_scale to report the scales, nor will it apply
 * scale via vp_viewporter. Instead the server should apply an appropriate
 * scale transform for the submitted buffers to be composited correctly.
 */
static inline void
zaura_toplevel_surface_submission_in_pixel_coordinates(struct zaura_toplevel *zaura_toplevel)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_SURFACE_SUBMISSION_IN_PIXEL_COORDINATES, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Requesting this will enable screen coordinates in surfaces
 * associated with aura_toplevel including sub surfaces and popup
 * windows who added this toplevel as a parent. This should be
 * set before first commit.
 */
static inline void
zaura_toplevel_set_supports_screen_coordinates(struct zaura_toplevel *zaura_toplevel)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_SET_SUPPORTS_SCREEN_COORDINATES, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Request a new location and bounds of the surface in DP screen
 * coordinates.  The size will be applied to visible bounds used
 * in set_geometry.  The output is a hint for the compositor to
 * determine which output the window should move to. If the
 * output is null, the compositor should make decision solely by
 * the given bounds. These parameters are just a request and the
 * compositor may ignore, adjust the size and position based on
 * the rule imposed by the window manager, or may preserve it for
 * future operations. For example, the compositor will not allow
 * a position outside of the output, or the compositor may just
 * store it if the toplevel surface is in maximiezd state, and
 * may use it upon unmaximized.
 */
static inline void
zaura_toplevel_set_window_bounds(struct zaura_toplevel *zaura_toplevel, int32_t x, int32_t y, int32_t width, int32_t height, struct wl_output *output)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_SET_WINDOW_BOUNDS, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0, x, y, width, height, output);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Request session id and restore id of a newly created browser window.
 * Set the information used by compositor to restore the toplevel
 * surface state, such as window position, window state, upon creation.
 * This is not double buffered and must be set before sending first commit.
 */
static inline void
zaura_toplevel_set_restore_info(struct zaura_toplevel *zaura_toplevel, int32_t restore_session_id, int32_t restore_window_id)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_SET_RESTORE_INFO, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0, restore_session_id, restore_window_id);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Requests that the toplevel surface should become a system modal. The
 * compositor will prevent other windows from receiving events. If there
 * are multiple system modal surfaces, the compositor will decide which
 * one to receive events.
 */
static inline void
zaura_toplevel_set_system_modal(struct zaura_toplevel *zaura_toplevel)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_SET_SYSTEM_MODAL, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Requests that the system modal state of the toplevel surface will be
 * unset. The compositor will then allow other windows to recieve events.
 */
static inline void
zaura_toplevel_unset_system_modal(struct zaura_toplevel *zaura_toplevel)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_UNSET_SYSTEM_MODAL, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Request session id and restore id of the window. Set the information used by compositor to restore the toplevel surface state, such as window position, window state, upon creation. This is not double buffered and must be set before sending first commit. This is different from set_restore_info, used for clients that create multiple windows associated with restore_id_source.
 */
static inline void
zaura_toplevel_set_restore_info_with_window_id_source(struct zaura_toplevel *zaura_toplevel, int32_t restore_session_id, const char *restore_window_id_source)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_SET_RESTORE_INFO_WITH_WINDOW_ID_SOURCE, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0, restore_session_id, restore_window_id_source);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Clients are allowed to request a particular decoration for a
 * zaura_toplevel. The server is not required to honor this request. See
 * decoration_type for available options. Available since M105.
 */
static inline void
zaura_toplevel_set_decoration(struct zaura_toplevel *zaura_toplevel, uint32_t type)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_SET_DECORATION, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0, type);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Destroy this zaura_toplevel object. A client should call destroy when the role
 * is unmapped from a wl_surface.
 *
 * See zaura_shell.release for destructor naming.
 */
static inline void
zaura_toplevel_release(struct zaura_toplevel *zaura_toplevel)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_RELEASE, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), WL_MARSHAL_FLAG_DESTROY);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * [Deprecated] Use set_float_to_location.
 * This is a request to place the surface above others.
 */
static inline void
zaura_toplevel_set_float(struct zaura_toplevel *zaura_toplevel)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_SET_FLOAT, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Request that the surface resets floating.
 */
static inline void
zaura_toplevel_unset_float(struct zaura_toplevel *zaura_toplevel)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_UNSET_FLOAT, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Sets the z order for a toplevel surface. See z_order_level for available options.
 */
static inline void
zaura_toplevel_set_z_order(struct zaura_toplevel *zaura_toplevel, uint32_t z_order)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_SET_Z_ORDER, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0, z_order);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Request a new location for the surface in device-independent pixels
 * (DPs), relative to the top-left corner of the given output.
 *
 * A null output means whichever output currently contains the surface.
 *
 * These parameters are just a request and the compositor may ignore
 * them, adjust them due to rules imposed by the window manager, or
 * preserve them for future operations. For example, the compositor will
 * not allow a position outside of the output; or the compositor may just
 * store it if the toplevel surface is in maximized state, and may use it
 * upon unmaximize.
 */
static inline void
zaura_toplevel_set_origin(struct zaura_toplevel *zaura_toplevel, int32_t x, int32_t y, struct wl_output *output)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_SET_ORIGIN, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0, x, y, output);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Activates this window. This is equivalent to bringing the window to the
 * foreground. The compositor is free to ignore this request if it deems
 * the client to be misbehaving.
 */
static inline void
zaura_toplevel_activate(struct zaura_toplevel *zaura_toplevel)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_ACTIVATE, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Deactivates this window. This is equivalent to requesting that the
 * window not be the foreground window. The exact behavior is
 * compositor-defined. The compositor is free to ignore this request
 * if it deems the client to be misbehaving.
 */
static inline void
zaura_toplevel_deactivate(struct zaura_toplevel *zaura_toplevel)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_DEACTIVATE, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Suggests how the windowing manager should behave if this surface were
 * to go fullscreen. Does not make the surface fullscreen.
 */
static inline void
zaura_toplevel_set_fullscreen_mode(struct zaura_toplevel *zaura_toplevel, uint32_t mode)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_SET_FULLSCREEN_MODE, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0, mode);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * The client has a 32-bit float scale factor that is associated with each
 * zaura toplevel. This scale factor must be propagated exactly to exo. To
 * do so we reinterpret_cast into a 32-bit uint and later cast back into a
 * float. This is because wayland does not support native transport of
 * floats. As different CPU architectures may use different endian
 * representations for IEEE 754 floats, this protocol implicitly assumes
 * that the caller and receiver are the same machine. To avoid redundant
 * messages, this request needs to only be called once when the zaura
 * toplevel scale factor changes. This is double buffered state and will be
 * applied in the next commit.
 */
static inline void
zaura_toplevel_set_scale_factor(struct zaura_toplevel *zaura_toplevel, uint32_t scale_factor_as_uint)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_SET_SCALE_FACTOR, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0, scale_factor_as_uint);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Request that surface is snapped to the left or top if primary layout,
 * right or bottom otherwise.
 */
static inline void
zaura_toplevel_set_snap_primary(struct zaura_toplevel *zaura_toplevel, uint32_t snap_ratio_as_uint)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_SET_SNAP_PRIMARY, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0, snap_ratio_as_uint);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Request that surface is snapped to the right or bottom if primary
 * layout, left or top otherwise.
 */
static inline void
zaura_toplevel_set_snap_secondary(struct zaura_toplevel *zaura_toplevel, uint32_t snap_ratio_as_uint)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_SET_SNAP_SECONDARY, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0, snap_ratio_as_uint);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Notify (or inform) the server the client's intent to snap the window.
 * To inform it's no longer willing to snap, send 'none'.
 */
static inline void
zaura_toplevel_intent_to_snap(struct zaura_toplevel *zaura_toplevel, uint32_t direction)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_INTENT_TO_SNAP, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0, direction);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Request that window unsets snapping.
 */
static inline void
zaura_toplevel_unset_snap(struct zaura_toplevel *zaura_toplevel)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_UNSET_SNAP, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Request the persistable status of a window.  Sets the persistable status
 * of the window in its window properties.  Should be called before first
 * commit.
 */
static inline void
zaura_toplevel_set_persistable(struct zaura_toplevel *zaura_toplevel, uint32_t persistable)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_SET_PERSISTABLE, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0, persistable);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Sets the shape of the toplevel window in DP. Passing NULL will reset the
 * shape of the window.
 *
 * This should be used only in support of the existing (deprecated) Chrome
 * Apps SetShape API and not for any other purpose.
 */
static inline void
zaura_toplevel_set_shape(struct zaura_toplevel *zaura_toplevel, struct wl_region *region)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_SET_SHAPE, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0, region);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Sets the top inset to the surface. This represents the header height
 * and should be non negative.
 */
static inline void
zaura_toplevel_set_top_inset(struct zaura_toplevel *zaura_toplevel, int32_t height)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_SET_TOP_INSET, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0, height);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * If the focus has been successfully rotated between UI elements inside
 * surface, client replies with 'handled'. If the focus didn't rotate, the
 * client reply with 'not_handled'. A server may use this to move the focus
 * to next focusable surface.
 *
 * Note that a delay in processing in the client could result in stale acks
 * received by the server.
 */
static inline void
zaura_toplevel_ack_rotate_focus(struct zaura_toplevel *zaura_toplevel, uint32_t serial, uint32_t handled)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_ACK_ROTATE_FOCUS, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0, serial, handled);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Hints to the window manager that the toplevel surface can be maximized.
 */
static inline void
zaura_toplevel_set_can_maximize(struct zaura_toplevel *zaura_toplevel)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_SET_CAN_MAXIMIZE, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Hints to the window manager that the toplevel surface should not be
 * maximized. Note that the window manager might still request the client
 * to be maximized. In such an event, the client should respect the
 * window manager's request and maximize. It may unset the maximized state
 * afterwards.
 */
static inline void
zaura_toplevel_unset_can_maximize(struct zaura_toplevel *zaura_toplevel)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_UNSET_CAN_MAXIMIZE, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Hints to the window manager that the toplevel surface can enter
 * fullscreen.
 */
static inline void
zaura_toplevel_set_can_fullscreen(struct zaura_toplevel *zaura_toplevel)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_SET_CAN_FULLSCREEN, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * Hints to the window manager that the toplevel surface should not be
 * enter fullscreen. Note that the window manager might still request the
 * client enter fullscreen. In such an event, the client should respect the
 * window manager's request and enter fullscreen. It may exit fullscreen
 * afterwards.
 */
static inline void
zaura_toplevel_unset_can_fullscreen(struct zaura_toplevel *zaura_toplevel)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_UNSET_CAN_FULLSCREEN, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * This is a request to place the surface above others.
 */
static inline void
zaura_toplevel_set_float_to_location(struct zaura_toplevel *zaura_toplevel, uint32_t mode)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_SET_FLOAT_TO_LOCATION, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0, mode);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * The client specifies the radius of each corner to be applied to the
 * window in DPs (device independent pixels).
 *
 * The window radius is double buffered, and will be applied at the
 * time wl_surface.commit of the corresponding wl_surface is called.
 *
 * Note: Rounded corner radii affects the wl_surface tree, including
 * subsurfaces. Once this protocol is called, surfaces cannot set
 * their own rounded corner bounds because rounded window bounds will be
 * applied to the whole surface tree.
 */
static inline void
zaura_toplevel_set_window_corner_radii(struct zaura_toplevel *zaura_toplevel, uint32_t upper_left_radius, uint32_t upper_right_radius, uint32_t lower_right_radius, uint32_t lower_left_radius)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_SET_WINDOW_CORNER_RADII, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0, upper_left_radius, upper_right_radius, lower_right_radius, lower_left_radius);
}

/**
 * @ingroup iface_zaura_toplevel
 *
 * The client specifies the radius of each corner to be applied to the shadow
 * associated with the aura toplevel surface in device independent pixels (DPs).
 *
 * The shadow radius is double buffered, and will be applied at the
 * time wl_surface.commit of the corresponding wl_surface is called.
 */
static inline void
zaura_toplevel_set_shadow_corner_radii(struct zaura_toplevel *zaura_toplevel, uint32_t upper_left_radius, uint32_t upper_right_radius, uint32_t lower_right_radius, uint32_t lower_left_radius)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_toplevel,
			 ZAURA_TOPLEVEL_SET_SHADOW_CORNER_RADII, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_toplevel), 0, upper_left_radius, upper_right_radius, lower_right_radius, lower_left_radius);
}

#ifndef ZAURA_POPUP_DECORATION_TYPE_ENUM
#define ZAURA_POPUP_DECORATION_TYPE_ENUM
/**
 * @ingroup iface_zaura_popup
 * different decoration types
 *
 * Decoration types are used to modify the surface (e.g. drop shadow).
 */
enum zaura_popup_decoration_type {
	/**
	 * no frame
	 */
	ZAURA_POPUP_DECORATION_TYPE_NONE = 0,
	/**
	 * caption with shadow
	 */
	ZAURA_POPUP_DECORATION_TYPE_NORMAL = 1,
	/**
	 * shadow only
	 */
	ZAURA_POPUP_DECORATION_TYPE_SHADOW = 2,
};
#endif /* ZAURA_POPUP_DECORATION_TYPE_ENUM */

#define ZAURA_POPUP_SURFACE_SUBMISSION_IN_PIXEL_COORDINATES 0
#define ZAURA_POPUP_SET_DECORATION 1
#define ZAURA_POPUP_SET_MENU 2
#define ZAURA_POPUP_RELEASE 3
#define ZAURA_POPUP_SET_SCALE_FACTOR 4


/**
 * @ingroup iface_zaura_popup
 */
#define ZAURA_POPUP_SURFACE_SUBMISSION_IN_PIXEL_COORDINATES_SINCE_VERSION 28
/**
 * @ingroup iface_zaura_popup
 */
#define ZAURA_POPUP_SET_DECORATION_SINCE_VERSION 35
/**
 * @ingroup iface_zaura_popup
 */
#define ZAURA_POPUP_SET_MENU_SINCE_VERSION 37
/**
 * @ingroup iface_zaura_popup
 */
#define ZAURA_POPUP_RELEASE_SINCE_VERSION 38
/**
 * @ingroup iface_zaura_popup
 */
#define ZAURA_POPUP_SET_SCALE_FACTOR_SINCE_VERSION 46

/** @ingroup iface_zaura_popup */
static inline void
zaura_popup_set_user_data(struct zaura_popup *zaura_popup, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zaura_popup, user_data);
}

/** @ingroup iface_zaura_popup */
static inline void *
zaura_popup_get_user_data(struct zaura_popup *zaura_popup)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zaura_popup);
}

static inline uint32_t
zaura_popup_get_version(struct zaura_popup *zaura_popup)
{
	return wl_proxy_get_version((struct wl_proxy *) zaura_popup);
}

/** @ingroup iface_zaura_popup */
static inline void
zaura_popup_destroy(struct zaura_popup *zaura_popup)
{
	wl_proxy_destroy((struct wl_proxy *) zaura_popup);
}

/**
 * @ingroup iface_zaura_popup
 *
 * Informs the server that when submitting this surface, this client will not
 * use wl_surface_set_buffer_scale to report the scales, nor will it apply
 * scale via vp_viewporter. Instead the server should apply an appropriate
 * scale transform for the submitted buffers to be composited correctly.
 */
static inline void
zaura_popup_surface_submission_in_pixel_coordinates(struct zaura_popup *zaura_popup)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_popup,
			 ZAURA_POPUP_SURFACE_SUBMISSION_IN_PIXEL_COORDINATES, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_popup), 0);
}

/**
 * @ingroup iface_zaura_popup
 *
 * Clients are allowed to request a particular decoration for a
 * zaura_toplevel. The server is not required to honor this request. See
 * decoration_type for available options. Available since M105.
 */
static inline void
zaura_popup_set_decoration(struct zaura_popup *zaura_popup, uint32_t type)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_popup,
			 ZAURA_POPUP_SET_DECORATION, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_popup), 0, type);
}

/**
 * @ingroup iface_zaura_popup
 *
 * Set popup type to menu
 */
static inline void
zaura_popup_set_menu(struct zaura_popup *zaura_popup)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_popup,
			 ZAURA_POPUP_SET_MENU, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_popup), 0);
}

/**
 * @ingroup iface_zaura_popup
 *
 * This request destroys the zaura_popup. A client should call destroy when the
 * role is unmapped from a wl_surface.
 *
 * See zaura_shell.release for destructor naming.
 */
static inline void
zaura_popup_release(struct zaura_popup *zaura_popup)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_popup,
			 ZAURA_POPUP_RELEASE, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_popup), WL_MARSHAL_FLAG_DESTROY);
}

/**
 * @ingroup iface_zaura_popup
 *
 * The client has a 32-bit float scale factor that is associated with each
 * zaura popup. This scale factor must be propagated exactly to exo. To
 * do so we reinterpret_cast into a 32-bit uint and later cast back into a
 * float. This is because wayland does not support native transport of
 * floats. As different CPU architectures may use different endian
 * representations for IEEE 754 floats, this protocol implicitly assumes
 * that the caller and receiver are the same machine. To avoid redundant
 * messages, this request needs to only be called once when the zaura
 * popup's scale factor changes.
 */
static inline void
zaura_popup_set_scale_factor(struct zaura_popup *zaura_popup, uint32_t scale_factor_as_uint)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zaura_popup,
			 ZAURA_POPUP_SET_SCALE_FACTOR, NULL, wl_proxy_get_version((struct wl_proxy *) zaura_popup), 0, scale_factor_as_uint);
}

/**
 * @ingroup iface_zaura_output_manager
 * @struct zaura_output_manager_listener
 */
struct zaura_output_manager_listener {
	/**
	 * sent all information about output
	 *
	 * This event is sent after all relevant properties of a
	 * zaura_output_manager for a given wl_output have been sent.
	 */
	void (*done)(void *data,
		     struct zaura_output_manager *zaura_output_manager,
		     struct wl_output *output);
	/**
	 * advertise the output's display id
	 *
	 * This event describes the 64bit display id assigned to each
	 * display by ChromeOS. The value is opaque and should not be
	 * interpreted.
	 *
	 * The event is sent when binding to the output object and
	 * subsequently as output state changes.
	 */
	void (*display_id)(void *data,
			   struct zaura_output_manager *zaura_output_manager,
			   struct wl_output *output,
			   uint32_t display_id_hi,
			   uint32_t display_id_lo);
	/**
	 * position of the output within the global compositor space
	 *
	 * The position event describes the location of the wl_output
	 * within the global compositor space.
	 *
	 * The event is sent when binding to the output object and
	 * subsequently as output state changes.
	 * @param x x position within the global compositor space
	 * @param y y position within the global compositor space
	 */
	void (*logical_position)(void *data,
				 struct zaura_output_manager *zaura_output_manager,
				 struct wl_output *output,
				 int32_t x,
				 int32_t y);
	/**
	 * size of the output in the global compositor space
	 *
	 * The logical_size event describes the logical size of the
	 * output in the global compositor space.
	 *
	 * The event is sent when binding to the output object and
	 * subsequently as output state changes.
	 * @param width width in global compositor space
	 * @param height height in global compositor space
	 */
	void (*logical_size)(void *data,
			     struct zaura_output_manager *zaura_output_manager,
			     struct wl_output *output,
			     int32_t width,
			     int32_t height);
	/**
	 * size of the output in pixels
	 *
	 * The physical resolution of the display in pixels. The value
	 * should not include any overscan insets or display rotation,
	 * except for any panel orientation adjustment.
	 *
	 * The event is sent when binding to the output object and
	 * subsequently as output state changes.
	 * @param width width in global compositor space
	 * @param height height in global compositor space
	 */
	void (*physical_size)(void *data,
			      struct zaura_output_manager *zaura_output_manager,
			      struct wl_output *output,
			      int32_t width,
			      int32_t height);
	/**
	 * advertise the work area insets for the output
	 *
	 * This event describes the insets for the output in logical
	 * screen coordinates, from which the work area can be calculated.
	 *
	 * The event is sent when binding to the output object and
	 * subsequently as output state changes.
	 */
	void (*insets)(void *data,
		       struct zaura_output_manager *zaura_output_manager,
		       struct wl_output *output,
		       int32_t top,
		       int32_t left,
		       int32_t bottom,
		       int32_t right);
	/**
	 * advertise device scale factor for the output
	 *
	 * The scale factor of the output device. We reinterpret_cast the
	 * float scale factor into a 32-bit uint and later cast back into a
	 * float. This is because wayland does not support native transport
	 * of floats. As different CPU architectures may use different
	 * endian representations for IEEE 754 floats, this protocol
	 * implicitly assumes that the caller and receiver are the same
	 * machine.
	 *
	 * The event is sent when binding to the output object and
	 * subsequently as output state changes.
	 * @param device_scale_factor display scale factor, in float format
	 */
	void (*device_scale_factor)(void *data,
				    struct zaura_output_manager *zaura_output_manager,
				    struct wl_output *output,
				    uint32_t device_scale_factor);
	/**
	 * logical transform of the output
	 *
	 * This event describes the logical transform for the output.
	 * Whereas panel transform corresponds to the display's panel
	 * rotation, the logical transform corresponds to the display's
	 * logical rotation.
	 *
	 * The event is sent when binding to the output object and
	 * subsequently as output state changes.
	 * @param transform transform that maps framebuffer to output
	 */
	void (*logical_transform)(void *data,
				  struct zaura_output_manager *zaura_output_manager,
				  struct wl_output *output,
				  int32_t transform);
	/**
	 * panel transform of the output
	 *
	 * This event describes the panel transform for the output, which
	 * is the associated display's panel rotation.
	 *
	 * The event is sent when binding to the output object and
	 * subsequently as output state changes.
	 * @param transform transform that maps framebuffer to output
	 */
	void (*panel_transform)(void *data,
				struct zaura_output_manager *zaura_output_manager,
				struct wl_output *output,
				int32_t transform);
	/**
	 * human-readable name of this output
	 *
	 * The name is a UTF-8 string with no convention defined for its
	 * contents.
	 *
	 * The event is sent when binding to the output object and
	 * subsequently as output state changes.
	 * @param name output name
	 */
	void (*name)(void *data,
		     struct zaura_output_manager *zaura_output_manager,
		     struct wl_output *output,
		     const char *name);
	/**
	 * human-readable description of this output
	 *
	 * The description is a UTF-8 string with no convention defined
	 * for its contents.
	 *
	 * The event is sent when binding to the output object and
	 * subsequently as output state changes.
	 * @param description output description
	 */
	void (*description)(void *data,
			    struct zaura_output_manager *zaura_output_manager,
			    struct wl_output *output,
			    const char *description);
	/**
	 * target display for new windows
	 *
	 * Notifies that this output is now active output. It is
	 * typically used as a target when a new window is created without
	 * specific bounds.
	 * @since 2
	 */
	void (*activated)(void *data,
			  struct zaura_output_manager *zaura_output_manager,
			  struct wl_output *output);
	/**
	 * advertise the overscan insets for the output
	 *
	 * This event describes the overscan insets for the output in
	 * physical pixels.
	 *
	 * The event is sent when binding to the output object and
	 * subsequently as output state changes.
	 * @since 3
	 */
	void (*overscan_insets)(void *data,
				struct zaura_output_manager *zaura_output_manager,
				struct wl_output *output,
				int32_t top,
				int32_t left,
				int32_t bottom,
				int32_t right);
};

/**
 * @ingroup iface_zaura_output_manager
 */
static inline int
zaura_output_manager_add_listener(struct zaura_output_manager *zaura_output_manager,
				  const struct zaura_output_manager_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) zaura_output_manager,
				     (void (**)(void)) listener, data);
}

/**
 * @ingroup iface_zaura_output_manager
 */
#define ZAURA_OUTPUT_MANAGER_DONE_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_output_manager
 */
#define ZAURA_OUTPUT_MANAGER_DISPLAY_ID_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_output_manager
 */
#define ZAURA_OUTPUT_MANAGER_LOGICAL_POSITION_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_output_manager
 */
#define ZAURA_OUTPUT_MANAGER_LOGICAL_SIZE_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_output_manager
 */
#define ZAURA_OUTPUT_MANAGER_PHYSICAL_SIZE_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_output_manager
 */
#define ZAURA_OUTPUT_MANAGER_INSETS_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_output_manager
 */
#define ZAURA_OUTPUT_MANAGER_DEVICE_SCALE_FACTOR_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_output_manager
 */
#define ZAURA_OUTPUT_MANAGER_LOGICAL_TRANSFORM_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_output_manager
 */
#define ZAURA_OUTPUT_MANAGER_PANEL_TRANSFORM_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_output_manager
 */
#define ZAURA_OUTPUT_MANAGER_NAME_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_output_manager
 */
#define ZAURA_OUTPUT_MANAGER_DESCRIPTION_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_output_manager
 */
#define ZAURA_OUTPUT_MANAGER_ACTIVATED_SINCE_VERSION 2
/**
 * @ingroup iface_zaura_output_manager
 */
#define ZAURA_OUTPUT_MANAGER_OVERSCAN_INSETS_SINCE_VERSION 3


/** @ingroup iface_zaura_output_manager */
static inline void
zaura_output_manager_set_user_data(struct zaura_output_manager *zaura_output_manager, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zaura_output_manager, user_data);
}

/** @ingroup iface_zaura_output_manager */
static inline void *
zaura_output_manager_get_user_data(struct zaura_output_manager *zaura_output_manager)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zaura_output_manager);
}

static inline uint32_t
zaura_output_manager_get_version(struct zaura_output_manager *zaura_output_manager)
{
	return wl_proxy_get_version((struct wl_proxy *) zaura_output_manager);
}

/** @ingroup iface_zaura_output_manager */
static inline void
zaura_output_manager_destroy(struct zaura_output_manager *zaura_output_manager)
{
	wl_proxy_destroy((struct wl_proxy *) zaura_output_manager);
}

#ifdef  __cplusplus
}
#endif

#endif
