// components/ml/mojom/ml_service.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "components/ml/mojom/ml_service.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/debug/alias.h"
#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/thread_pool/thread_pool_instance.h"
#include "base/trace_event/trace_event.h"
#include "base/trace_event/typed_macros.h"
#include "mojo/public/cpp/bindings/lib/default_construct_tag_internal.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/send_message_helper.h"
#include "mojo/public/cpp/bindings/lib/proxy_to_responder.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#include "mojo/public/cpp/bindings/urgent_message_scope.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "components/ml/mojom/ml_service.mojom-params-data.h"
#include "components/ml/mojom/ml_service.mojom-shared-message-ids.h"

#include "components/ml/mojom/ml_service.mojom-import-headers.h"
#include "components/ml/mojom/ml_service.mojom-test-utils.h"


namespace ml::model_loader::mojom {
const char MLService::Name_[] = "ml.model_loader.mojom.MLService";

MLService::IPCStableHashFunction MLService::MessageToMethodInfo_(mojo::Message& message) {
#if !BUILDFLAG(IS_FUCHSIA)
  switch (message.name()) {
    case internal::kMLService_CreateModelLoader_Name: {
      return &MLService::CreateModelLoader_Sym::IPCStableHash;
    }
  }
#endif  // !BUILDFLAG(IS_FUCHSIA)
  return nullptr;
}


const char* MLService::MessageToMethodName_(mojo::Message& message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (!is_response) {
    switch (message.name()) {
      case internal::kMLService_CreateModelLoader_Name:
            return "Receive ml::model_loader::mojom::MLService::CreateModelLoader";
    }
  } else {
    switch (message.name()) {
      case internal::kMLService_CreateModelLoader_Name:
            return "Receive reply ml::model_loader::mojom::MLService::CreateModelLoader";
    }
  }
  return "Receive unknown mojo message";
#else
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (is_response) {
    return "Receive mojo reply";
  } else {
    return "Receive mojo message";
  }
#endif // BUILDFLAG(MOJO_TRACE_ENABLED)
}

#if !BUILDFLAG(IS_FUCHSIA)
uint32_t MLService::CreateModelLoader_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)ml::model_loader::mojom::MLService::CreateModelLoader");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
# endif // !BUILDFLAG(IS_FUCHSIA)

class MLService_CreateModelLoader_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  MLService_CreateModelLoader_ForwardToCallback(
      MLService::CreateModelLoaderCallback callback
      ) : callback_(std::move(callback)) {
  }

  MLService_CreateModelLoader_ForwardToCallback(const MLService_CreateModelLoader_ForwardToCallback&) = delete;
  MLService_CreateModelLoader_ForwardToCallback& operator=(const MLService_CreateModelLoader_ForwardToCallback&) = delete;

  bool Accept(mojo::Message* message) override;
 private:
  MLService::CreateModelLoaderCallback callback_;
};

MLServiceProxy::MLServiceProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void MLServiceProxy::CreateModelLoader(
    ::ml::model_loader::mojom::CreateModelLoaderOptionsPtr in_options, CreateModelLoaderCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send ml::model_loader::mojom::MLService::CreateModelLoader", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("options"), in_options,
                        "<value of type ::ml::model_loader::mojom::CreateModelLoaderOptionsPtr>");
   });
#endif

  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  const bool is_urgent = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((is_urgent) ? mojo::Message::kFlagIsUrgent : 0);
  
  mojo::Message message(
      internal::kMLService_CreateModelLoader_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::ml::model_loader::mojom::internal::MLService_CreateModelLoader_Params_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<
      typename decltype(params->options)::BaseType> options_fragment(
          params.message());
  mojo::internal::Serialize<::ml::model_loader::mojom::CreateModelLoaderOptionsDataView>(
      in_options, options_fragment);
  params->options.Set(
      options_fragment.is_null() ? nullptr : options_fragment.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->options.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null options in MLService.CreateModelLoader request");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(MLService::Name_);
  message.set_method_name("CreateModelLoader");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new MLService_CreateModelLoader_ForwardToCallback(
          std::move(callback)));
  ::mojo::internal::SendMojoMessage(*receiver_, message, std::move(responder));
}
class MLService_CreateModelLoader_ProxyToResponder : public ::mojo::internal::ProxyToResponder {
 public:
  static MLService::CreateModelLoaderCallback CreateCallback(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<MLService_CreateModelLoader_ProxyToResponder> proxy(
        new MLService_CreateModelLoader_ProxyToResponder(
            message, std::move(responder)));
    return base::BindOnce(&MLService_CreateModelLoader_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~MLService_CreateModelLoader_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      // Instantiate a ScopedFizzleBlockShutdownTasks to allow this request to
      // fizzle if this happens after shutdown and the endpoint is bound to a
      // BLOCK_SHUTDOWN sequence.
      base::ThreadPoolInstance::ScopedFizzleBlockShutdownTasks fizzler;
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
  }

 private:
  MLService_CreateModelLoader_ProxyToResponder(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : ::mojo::internal::ProxyToResponder(message, std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "MLService::CreateModelLoaderCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      ::ml::model_loader::mojom::CreateModelLoaderResult in_result, ::mojo::PendingRemote<::ml::model_loader::mojom::ModelLoader> in_remote);
};

bool MLService_CreateModelLoader_ForwardToCallback::Accept(
    mojo::Message* message) {

  DCHECK(message->is_serialized());
  internal::MLService_CreateModelLoader_ResponseParams_Data* params =
      reinterpret_cast<
          internal::MLService_CreateModelLoader_ResponseParams_Data*>(
              message->mutable_payload());
  
  
  // Validation for MLService.0
  bool success = true;
  ::ml::model_loader::mojom::CreateModelLoaderResult p_result{};
  ::mojo::PendingRemote<::ml::model_loader::mojom::ModelLoader> p_remote{};
  MLService_CreateModelLoader_ResponseParamsDataView input_data_view(params, message);
  
  if (success && !input_data_view.ReadResult(&p_result))
    success = false;
  if (success) {
    p_remote =
        input_data_view.TakeRemote<decltype(p_remote)>();
  }
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        MLService::Name_, 0, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_result), 
std::move(p_remote));
  return true;
}

void MLService_CreateModelLoader_ProxyToResponder::Run(
    ::ml::model_loader::mojom::CreateModelLoaderResult in_result, ::mojo::PendingRemote<::ml::model_loader::mojom::ModelLoader> in_remote) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send reply ml::model_loader::mojom::MLService::CreateModelLoader", "async_response_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("result"), in_result,
                        "<value of type ::ml::model_loader::mojom::CreateModelLoaderResult>");
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("remote"), in_remote,
                        "<value of type ::mojo::PendingRemote<::ml::model_loader::mojom::ModelLoader>>");
   });
#endif
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0) |
      ((true) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((false) ? mojo::Message::kFlagIsUrgent : 0);
  
  mojo::Message message(
      internal::kMLService_CreateModelLoader_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::ml::model_loader::mojom::internal::MLService_CreateModelLoader_ResponseParams_Data> params(
          message);
  params.Allocate();
  mojo::internal::Serialize<::ml::model_loader::mojom::CreateModelLoaderResult>(
      in_result, &params->result);
  mojo::internal::Serialize<mojo::InterfacePtrDataView<::ml::model_loader::mojom::ModelLoaderInterfaceBase>>(
      in_remote, &params->remote, &params.message());

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(MLService::Name_);
  message.set_method_name("CreateModelLoader");
#endif

  message.set_request_id(request_id_);
  message.set_trace_nonce(trace_nonce_);
  ::mojo::internal::SendMojoMessage(*responder_, message);
  // SendMojoMessage() fails silently if the responder connection is closed,
  // or if the message is malformed.
  //
  // TODO(darin): If Accept() returns false due to a malformed message, that
  // may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool MLServiceStubDispatch::Accept(
    MLService* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kMLService_CreateModelLoader_Name: {
      break;
    }
  }
  return false;
}

// static
bool MLServiceStubDispatch::AcceptWithResponder(
    MLService* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  [[maybe_unused]] const bool message_is_sync =
      message->has_flag(mojo::Message::kFlagIsSync);
  [[maybe_unused]] const uint64_t request_id = message->request_id();
  switch (message->header()->name) {
    case internal::kMLService_CreateModelLoader_Name: {

      internal::MLService_CreateModelLoader_Params_Data* params =
          reinterpret_cast<
              internal::MLService_CreateModelLoader_Params_Data*>(
                  message->mutable_payload());
      
      
      // Validation for MLService.0
      bool success = true;
      ::ml::model_loader::mojom::CreateModelLoaderOptionsPtr p_options{};
      MLService_CreateModelLoader_ParamsDataView input_data_view(params, message);
      
      if (success && !input_data_view.ReadOptions(&p_options))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            MLService::Name_, 0, false);
        return false;
      }
      MLService::CreateModelLoaderCallback callback =
          MLService_CreateModelLoader_ProxyToResponder::CreateCallback(
              *message, std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->CreateModelLoader(        
        std::move(p_options), std::move(callback));
      return true;
    }
  }
  return false;
}
namespace {
}  // namespace
static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kMLServiceValidationInfo[] = {
    {internal::kMLService_CreateModelLoader_Name,
     { &internal::MLService_CreateModelLoader_Params_Data::Validate,
      &internal::MLService_CreateModelLoader_ResponseParams_Data::Validate}},
};

bool MLServiceRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::ml::model_loader::mojom::MLService::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kMLServiceValidationInfo);
}

bool MLServiceResponseValidator::Accept(mojo::Message* message) {
  const char* name = ::ml::model_loader::mojom::MLService::Name_;
  return mojo::internal::ValidateResponseGeneric(message, name, kMLServiceValidationInfo);

}


}  // ml::model_loader::mojom


namespace mojo {

}  // namespace mojo


// Symbols declared in the -test-utils.h header are defined here instead of a
// separate .cc file to save compile time.


namespace ml::model_loader::mojom {


void MLServiceInterceptorForTesting::CreateModelLoader(::ml::model_loader::mojom::CreateModelLoaderOptionsPtr options, CreateModelLoaderCallback callback) {
  GetForwardingInterface()->CreateModelLoader(std::move(options), std::move(callback));
}
MLServiceAsyncWaiter::MLServiceAsyncWaiter(
    MLService* proxy) : proxy_(proxy) {}

MLServiceAsyncWaiter::~MLServiceAsyncWaiter() = default;

void MLServiceAsyncWaiter::CreateModelLoader(
    ::ml::model_loader::mojom::CreateModelLoaderOptionsPtr options, ::ml::model_loader::mojom::CreateModelLoaderResult* out_result, ::mojo::PendingRemote<::ml::model_loader::mojom::ModelLoader>* out_remote) {
  base::RunLoop loop;
  proxy_->CreateModelLoader(std::move(options),
      base::BindOnce(
          [](base::RunLoop* loop,
             ::ml::model_loader::mojom::CreateModelLoaderResult* out_result
,
             ::mojo::PendingRemote<::ml::model_loader::mojom::ModelLoader>* out_remote
,
             ::ml::model_loader::mojom::CreateModelLoaderResult result,
             ::mojo::PendingRemote<::ml::model_loader::mojom::ModelLoader> remote) {*out_result = std::move(result);*out_remote = std::move(remote);
            loop->Quit();
          },
          &loop,
          out_result,
          out_remote));
  loop.Run();
}








}  // ml::model_loader::mojom


#if defined(__clang__)
#pragma clang diagnostic pop
#endif