// components/schema_org/common/metadata.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_SCHEMA_ORG_COMMON_METADATA_MOJOM_SHARED_H_
#define COMPONENTS_SCHEMA_ORG_COMMON_METADATA_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "components/schema_org/common/metadata.mojom-shared-internal.h"







namespace schema_org::mojom {
class PropertyDataView;

class EntityDataView;

class ValuesDataView;


}  // schema_org::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::schema_org::mojom::PropertyDataView> {
  using Data = ::schema_org::mojom::internal::Property_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::schema_org::mojom::EntityDataView> {
  using Data = ::schema_org::mojom::internal::Entity_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::schema_org::mojom::ValuesDataView> {
  using Data = ::schema_org::mojom::internal::Values_Data;
  using DataAsArrayElement = Data;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kUnion;
};

}  // namespace internal
}  // namespace mojo


namespace schema_org::mojom {


class PropertyDataView {
 public:
  PropertyDataView() = default;

  PropertyDataView(
      internal::Property_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetNameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadName(UserType* output) {
    
    auto* pointer = data_->name.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetValuesDataView(
      ValuesDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadValues(UserType* output) {
    
    auto* pointer = !data_->values.is_null() ? &data_->values : nullptr;
    return mojo::internal::Deserialize<::schema_org::mojom::ValuesDataView>(
        pointer, output, message_);
  }
 private:
  internal::Property_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


class EntityDataView {
 public:
  EntityDataView() = default;

  EntityDataView(
      internal::Entity_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetTypeDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadType(UserType* output) {
    
    auto* pointer = data_->type.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetPropertiesDataView(
      mojo::ArrayDataView<PropertyDataView>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadProperties(UserType* output) {
    
    auto* pointer = data_->properties.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::schema_org::mojom::PropertyDataView>>(
        pointer, output, message_);
  }
 private:
  internal::Entity_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


class ValuesDataView {
 public:
  using Tag = internal::Values_Data::Values_Tag;

  ValuesDataView() = default;

  ValuesDataView(
      internal::Values_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const {
    // For inlined unions, |data_| is always non-null. In that case we need to
    // check |data_->is_null()|.
    return !data_ || data_->is_null();
  }

  Tag tag() const { return data_->tag; }
  bool is_bool_values() const { return data_->tag == Tag::kBoolValues; }
  inline void GetBoolValuesDataView(
      mojo::ArrayDataView<bool>* output) const;

  template <typename UserType>
  [[nodiscard]] bool ReadBoolValues(UserType* output) const {
    
    CHECK(is_bool_values());
    return mojo::internal::Deserialize<mojo::ArrayDataView<bool>>(
        data_->data.f_bool_values.Get(), output, message_);
  }
  bool is_long_values() const { return data_->tag == Tag::kLongValues; }
  inline void GetLongValuesDataView(
      mojo::ArrayDataView<int64_t>* output) const;

  template <typename UserType>
  [[nodiscard]] bool ReadLongValues(UserType* output) const {
    
    CHECK(is_long_values());
    return mojo::internal::Deserialize<mojo::ArrayDataView<int64_t>>(
        data_->data.f_long_values.Get(), output, message_);
  }
  bool is_string_values() const { return data_->tag == Tag::kStringValues; }
  inline void GetStringValuesDataView(
      mojo::ArrayDataView<mojo::StringDataView>* output) const;

  template <typename UserType>
  [[nodiscard]] bool ReadStringValues(UserType* output) const {
    
    CHECK(is_string_values());
    return mojo::internal::Deserialize<mojo::ArrayDataView<mojo::StringDataView>>(
        data_->data.f_string_values.Get(), output, message_);
  }
  bool is_entity_values() const { return data_->tag == Tag::kEntityValues; }
  inline void GetEntityValuesDataView(
      mojo::ArrayDataView<EntityDataView>* output) const;

  template <typename UserType>
  [[nodiscard]] bool ReadEntityValues(UserType* output) const {
    
    CHECK(is_entity_values());
    return mojo::internal::Deserialize<mojo::ArrayDataView<::schema_org::mojom::EntityDataView>>(
        data_->data.f_entity_values.Get(), output, message_);
  }

 private:
  internal::Values_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



}  // schema_org::mojom

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::schema_org::mojom::PropertyDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::schema_org::mojom::PropertyDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::schema_org::mojom::internal::Property_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::name(input)) in_name = Traits::name(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->name)::BaseType> name_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_name, name_fragment);
    fragment->name.Set(
        name_fragment.is_null() ? nullptr : name_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->name.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null name in Property struct");
    decltype(Traits::values(input)) in_values = Traits::values(input);
    mojo::internal::MessageFragment<decltype(fragment->values)>
        values_fragment(fragment.message());
    values_fragment.Claim(&fragment->values);
    mojo::internal::Serialize<::schema_org::mojom::ValuesDataView>(
        in_values, values_fragment, true);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->values.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null values in Property struct");
  }

  static bool Deserialize(::schema_org::mojom::internal::Property_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::schema_org::mojom::PropertyDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::schema_org::mojom::EntityDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::schema_org::mojom::EntityDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::schema_org::mojom::internal::Entity_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::type(input)) in_type = Traits::type(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->type)::BaseType> type_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_type, type_fragment);
    fragment->type.Set(
        type_fragment.is_null() ? nullptr : type_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->type.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null type in Entity struct");
    decltype(Traits::properties(input)) in_properties = Traits::properties(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->properties)::BaseType>
        properties_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& properties_validate_params =
        mojo::internal::GetArrayValidator<0, false, nullptr>();
    mojo::internal::Serialize<mojo::ArrayDataView<::schema_org::mojom::PropertyDataView>>(
        in_properties, properties_fragment, &properties_validate_params);
    fragment->properties.Set(
        properties_fragment.is_null() ? nullptr : properties_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->properties.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null properties in Entity struct");
  }

  static bool Deserialize(::schema_org::mojom::internal::Entity_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::schema_org::mojom::EntityDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::schema_org::mojom::ValuesDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = UnionTraits<::schema_org::mojom::ValuesDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        MessageFragment<::schema_org::mojom::internal::Values_Data>& fragment,
                        bool inlined) {
    if (CallIsNullIfExists<Traits>(input)) {
       if (inlined)
        fragment->set_null();
      return;
    }

    if (!inlined)
      fragment.Allocate();

    // TODO(azani): Handle unknown and objects.
    // Set the not-null flag.
    fragment->size = kUnionDataSize;
    fragment->tag = Traits::GetTag(input);
    switch (fragment->tag) {
      case ::schema_org::mojom::ValuesDataView::Tag::kBoolValues: {
        decltype(Traits::bool_values(input))
            in_bool_values = Traits::bool_values(input);
        mojo::internal::MessageFragment<
            typename decltype(fragment->data.f_bool_values)::BaseType>
            value_fragment(fragment.message());
        constexpr const mojo::internal::ContainerValidateParams& bool_values_validate_params =
            mojo::internal::GetArrayValidator<0, false, nullptr>();
        mojo::internal::Serialize<mojo::ArrayDataView<bool>>(
            in_bool_values, value_fragment, &bool_values_validate_params);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_fragment.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null bool_values in Values union");
        fragment->data.f_bool_values.Set(
            value_fragment.is_null() ? nullptr : value_fragment.data());
        break;
      }
      case ::schema_org::mojom::ValuesDataView::Tag::kLongValues: {
        decltype(Traits::long_values(input))
            in_long_values = Traits::long_values(input);
        mojo::internal::MessageFragment<
            typename decltype(fragment->data.f_long_values)::BaseType>
            value_fragment(fragment.message());
        constexpr const mojo::internal::ContainerValidateParams& long_values_validate_params =
            mojo::internal::GetArrayValidator<0, false, nullptr>();
        mojo::internal::Serialize<mojo::ArrayDataView<int64_t>>(
            in_long_values, value_fragment, &long_values_validate_params);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_fragment.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null long_values in Values union");
        fragment->data.f_long_values.Set(
            value_fragment.is_null() ? nullptr : value_fragment.data());
        break;
      }
      case ::schema_org::mojom::ValuesDataView::Tag::kStringValues: {
        decltype(Traits::string_values(input))
            in_string_values = Traits::string_values(input);
        mojo::internal::MessageFragment<
            typename decltype(fragment->data.f_string_values)::BaseType>
            value_fragment(fragment.message());
        constexpr const mojo::internal::ContainerValidateParams& string_values_validate_params =
            mojo::internal::GetArrayValidator<0, false, &mojo::internal::GetArrayValidator<0, false, nullptr>()>();
        mojo::internal::Serialize<mojo::ArrayDataView<mojo::StringDataView>>(
            in_string_values, value_fragment, &string_values_validate_params);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_fragment.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null string_values in Values union");
        fragment->data.f_string_values.Set(
            value_fragment.is_null() ? nullptr : value_fragment.data());
        break;
      }
      case ::schema_org::mojom::ValuesDataView::Tag::kEntityValues: {
        decltype(Traits::entity_values(input))
            in_entity_values = Traits::entity_values(input);
        mojo::internal::MessageFragment<
            typename decltype(fragment->data.f_entity_values)::BaseType>
            value_fragment(fragment.message());
        constexpr const mojo::internal::ContainerValidateParams& entity_values_validate_params =
            mojo::internal::GetArrayValidator<0, false, nullptr>();
        mojo::internal::Serialize<mojo::ArrayDataView<::schema_org::mojom::EntityDataView>>(
            in_entity_values, value_fragment, &entity_values_validate_params);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_fragment.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null entity_values in Values union");
        fragment->data.f_entity_values.Set(
            value_fragment.is_null() ? nullptr : value_fragment.data());
        break;
      }
    }
  }

  static bool Deserialize(::schema_org::mojom::internal::Values_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input || input->is_null())
      return CallSetToNullIfExists<Traits>(output);

    ::schema_org::mojom::ValuesDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace schema_org::mojom {

inline void PropertyDataView::GetNameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->name.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void PropertyDataView::GetValuesDataView(
    ValuesDataView* output) {
  auto pointer = &data_->values;
  *output = ValuesDataView(pointer, message_);
}


inline void EntityDataView::GetTypeDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->type.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void EntityDataView::GetPropertiesDataView(
    mojo::ArrayDataView<PropertyDataView>* output) {
  auto pointer = data_->properties.Get();
  *output = mojo::ArrayDataView<PropertyDataView>(pointer, message_);
}


inline void ValuesDataView::GetBoolValuesDataView(
    mojo::ArrayDataView<bool>* output) const {
  CHECK(is_bool_values());
  *output = mojo::ArrayDataView<bool>(data_->data.f_bool_values.Get(), message_);
}
inline void ValuesDataView::GetLongValuesDataView(
    mojo::ArrayDataView<int64_t>* output) const {
  CHECK(is_long_values());
  *output = mojo::ArrayDataView<int64_t>(data_->data.f_long_values.Get(), message_);
}
inline void ValuesDataView::GetStringValuesDataView(
    mojo::ArrayDataView<mojo::StringDataView>* output) const {
  CHECK(is_string_values());
  *output = mojo::ArrayDataView<mojo::StringDataView>(data_->data.f_string_values.Get(), message_);
}
inline void ValuesDataView::GetEntityValuesDataView(
    mojo::ArrayDataView<EntityDataView>* output) const {
  CHECK(is_entity_values());
  *output = mojo::ArrayDataView<EntityDataView>(data_->data.f_entity_values.Get(), message_);
}


}  // schema_org::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // COMPONENTS_SCHEMA_ORG_COMMON_METADATA_MOJOM_SHARED_H_