// content/browser/attribution_reporting/attribution_internals.mojom-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_BROWSER_ATTRIBUTION_REPORTING_ATTRIBUTION_INTERNALS_MOJOM_TEST_UTILS_H_
#define CONTENT_BROWSER_ATTRIBUTION_REPORTING_ATTRIBUTION_INTERNALS_MOJOM_TEST_UTILS_H_

#include "content/browser/attribution_reporting/attribution_internals.mojom.h"


namespace attribution_internals::mojom {


class  ObserverInterceptorForTesting : public Observer {
  virtual Observer* GetForwardingInterface() = 0;
  void OnSourcesChanged() override;
  void OnReportsChanged() override;
  void OnSourceHandled(WebUISourceRegistrationPtr source) override;
  void OnReportSent(WebUIReportPtr report) override;
  void OnDebugReportSent(WebUIDebugReportPtr report) override;
  void OnReportDropped(WebUIReportPtr report) override;
  void OnTriggerHandled(WebUITriggerPtr trigger) override;
  void OnOsRegistration(WebUIOsRegistrationPtr registration) override;
};
class  ObserverAsyncWaiter {
 public:
  explicit ObserverAsyncWaiter(Observer* proxy);

  ObserverAsyncWaiter(const ObserverAsyncWaiter&) = delete;
  ObserverAsyncWaiter& operator=(const ObserverAsyncWaiter&) = delete;

  ~ObserverAsyncWaiter();

 private:
  Observer* const proxy_;
};


class  HandlerInterceptorForTesting : public Handler {
  virtual Handler* GetForwardingInterface() = 0;
  void IsAttributionReportingEnabled(IsAttributionReportingEnabledCallback callback) override;
  void GetActiveSources(GetActiveSourcesCallback callback) override;
  void GetReports(GetReportsCallback callback) override;
  void SendReports(const std::vector<::content::AttributionReport::Id>& ids, SendReportsCallback callback) override;
  void ClearStorage(ClearStorageCallback callback) override;
};
class  HandlerAsyncWaiter {
 public:
  explicit HandlerAsyncWaiter(Handler* proxy);

  HandlerAsyncWaiter(const HandlerAsyncWaiter&) = delete;
  HandlerAsyncWaiter& operator=(const HandlerAsyncWaiter&) = delete;

  ~HandlerAsyncWaiter();
  void IsAttributionReportingEnabled(
      bool* out_enabled, bool* out_debug_mode, ::network::mojom::AttributionSupport* out_attribution_support);
  
  void GetActiveSources(
      std::vector<WebUISourcePtr>* out_sources);
  std::vector<WebUISourcePtr> GetActiveSources();
  void GetReports(
      std::vector<WebUIReportPtr>* out_reports);
  std::vector<WebUIReportPtr> GetReports();
  void SendReports(
      const std::vector<::content::AttributionReport::Id>& ids);
  
  void ClearStorage(
      );
  

 private:
  Handler* const proxy_;
};


class  FactoryInterceptorForTesting : public Factory {
  virtual Factory* GetForwardingInterface() = 0;
  void Create(::mojo::PendingRemote<Observer> observer, ::mojo::PendingReceiver<Handler> handler) override;
};
class  FactoryAsyncWaiter {
 public:
  explicit FactoryAsyncWaiter(Factory* proxy);

  FactoryAsyncWaiter(const FactoryAsyncWaiter&) = delete;
  FactoryAsyncWaiter& operator=(const FactoryAsyncWaiter&) = delete;

  ~FactoryAsyncWaiter();

 private:
  Factory* const proxy_;
};




}  // attribution_internals::mojom

#endif  // CONTENT_BROWSER_ATTRIBUTION_REPORTING_ATTRIBUTION_INTERNALS_MOJOM_TEST_UTILS_H_