// content/browser/tracing/trace_report/trace_report.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "content/browser/tracing/trace_report/trace_report.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/debug/alias.h"
#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/thread_pool/thread_pool_instance.h"
#include "base/trace_event/trace_event.h"
#include "base/trace_event/typed_macros.h"
#include "mojo/public/cpp/bindings/lib/default_construct_tag_internal.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/send_message_helper.h"
#include "mojo/public/cpp/bindings/lib/proxy_to_responder.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#include "mojo/public/cpp/bindings/urgent_message_scope.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "content/browser/tracing/trace_report/trace_report.mojom-params-data.h"
#include "content/browser/tracing/trace_report/trace_report.mojom-shared-message-ids.h"

#include "content/browser/tracing/trace_report/trace_report.mojom-import-headers.h"
#include "content/browser/tracing/trace_report/trace_report.mojom-test-utils.h"


namespace trace_report::mojom {
ClientTraceReport::ClientTraceReport()
    : uuid(),
      creation_time(),
      scenario_name(),
      upload_rule_name(),
      total_size(),
      upload_state(),
      upload_time(),
      skip_reason() {}

ClientTraceReport::ClientTraceReport(
    const ::base::Token& uuid_in,
    ::base::Time creation_time_in,
    const std::string& scenario_name_in,
    const std::string& upload_rule_name_in,
    int64_t total_size_in,
    ::content::ReportUploadState upload_state_in,
    ::base::Time upload_time_in,
    ::content::SkipUploadReason skip_reason_in)
    : uuid(std::move(uuid_in)),
      creation_time(std::move(creation_time_in)),
      scenario_name(std::move(scenario_name_in)),
      upload_rule_name(std::move(upload_rule_name_in)),
      total_size(std::move(total_size_in)),
      upload_state(std::move(upload_state_in)),
      upload_time(std::move(upload_time_in)),
      skip_reason(std::move(skip_reason_in)) {}

ClientTraceReport::~ClientTraceReport() = default;

void ClientTraceReport::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "uuid"), this->uuid,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const ::base::Token&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "creation_time"), this->creation_time,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::base::Time>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "scenario_name"), this->scenario_name,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::string&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "upload_rule_name"), this->upload_rule_name,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::string&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "total_size"), this->total_size,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type int64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "upload_state"), this->upload_state,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::content::ReportUploadState>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "upload_time"), this->upload_time,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::base::Time>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "skip_reason"), this->skip_reason,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::content::SkipUploadReason>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool ClientTraceReport::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char TraceReportHandlerFactory::Name_[] = "trace_report.mojom.TraceReportHandlerFactory";

TraceReportHandlerFactory::IPCStableHashFunction TraceReportHandlerFactory::MessageToMethodInfo_(mojo::Message& message) {
#if !BUILDFLAG(IS_FUCHSIA)
  switch (message.name()) {
    case internal::kTraceReportHandlerFactory_CreatePageHandler_Name: {
      return &TraceReportHandlerFactory::CreatePageHandler_Sym::IPCStableHash;
    }
  }
#endif  // !BUILDFLAG(IS_FUCHSIA)
  return nullptr;
}


const char* TraceReportHandlerFactory::MessageToMethodName_(mojo::Message& message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (!is_response) {
    switch (message.name()) {
      case internal::kTraceReportHandlerFactory_CreatePageHandler_Name:
            return "Receive trace_report::mojom::TraceReportHandlerFactory::CreatePageHandler";
    }
  } else {
    switch (message.name()) {
      case internal::kTraceReportHandlerFactory_CreatePageHandler_Name:
            return "Receive reply trace_report::mojom::TraceReportHandlerFactory::CreatePageHandler";
    }
  }
  return "Receive unknown mojo message";
#else
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (is_response) {
    return "Receive mojo reply";
  } else {
    return "Receive mojo message";
  }
#endif // BUILDFLAG(MOJO_TRACE_ENABLED)
}

#if !BUILDFLAG(IS_FUCHSIA)
uint32_t TraceReportHandlerFactory::CreatePageHandler_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)trace_report::mojom::TraceReportHandlerFactory::CreatePageHandler");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
# endif // !BUILDFLAG(IS_FUCHSIA)

TraceReportHandlerFactoryProxy::TraceReportHandlerFactoryProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void TraceReportHandlerFactoryProxy::CreatePageHandler(
    ::mojo::PendingRemote<Page> in_page, ::mojo::PendingReceiver<PageHandler> in_handler) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send trace_report::mojom::TraceReportHandlerFactory::CreatePageHandler", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("page"), in_page,
                        "<value of type ::mojo::PendingRemote<Page>>");
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("handler"), in_handler,
                        "<value of type ::mojo::PendingReceiver<PageHandler>>");
   });
#endif

  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  const bool is_urgent = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((is_urgent) ? mojo::Message::kFlagIsUrgent : 0);
  
  mojo::Message message(
      internal::kTraceReportHandlerFactory_CreatePageHandler_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::trace_report::mojom::internal::TraceReportHandlerFactory_CreatePageHandler_Params_Data> params(
          message);
  params.Allocate();
  mojo::internal::Serialize<mojo::InterfacePtrDataView<::trace_report::mojom::PageInterfaceBase>>(
      in_page, &params->page, &params.message());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->page),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid page in TraceReportHandlerFactory.CreatePageHandler request");
  mojo::internal::Serialize<mojo::InterfaceRequestDataView<::trace_report::mojom::PageHandlerInterfaceBase>>(
      in_handler, &params->handler, &params.message());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->handler),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid handler in TraceReportHandlerFactory.CreatePageHandler request");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(TraceReportHandlerFactory::Name_);
  message.set_method_name("CreatePageHandler");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ::mojo::internal::SendMojoMessage(*receiver_, message);
}

// static
bool TraceReportHandlerFactoryStubDispatch::Accept(
    TraceReportHandlerFactory* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kTraceReportHandlerFactory_CreatePageHandler_Name: {

      DCHECK(message->is_serialized());
      internal::TraceReportHandlerFactory_CreatePageHandler_Params_Data* params =
          reinterpret_cast<internal::TraceReportHandlerFactory_CreatePageHandler_Params_Data*>(
              message->mutable_payload());
      
      
      // Validation for TraceReportHandlerFactory.0
      bool success = true;
      ::mojo::PendingRemote<Page> p_page{};
      ::mojo::PendingReceiver<PageHandler> p_handler{};
      TraceReportHandlerFactory_CreatePageHandler_ParamsDataView input_data_view(params, message);
      
      if (success) {
        p_page =
            input_data_view.TakePage<decltype(p_page)>();
      }
      if (success) {
        p_handler =
            input_data_view.TakeHandler<decltype(p_handler)>();
      }
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            TraceReportHandlerFactory::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->CreatePageHandler(        
        std::move(p_page), 
        std::move(p_handler));
      return true;
    }
  }
  return false;
}

// static
bool TraceReportHandlerFactoryStubDispatch::AcceptWithResponder(
    TraceReportHandlerFactory* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  [[maybe_unused]] const bool message_is_sync =
      message->has_flag(mojo::Message::kFlagIsSync);
  [[maybe_unused]] const uint64_t request_id = message->request_id();
  switch (message->header()->name) {
    case internal::kTraceReportHandlerFactory_CreatePageHandler_Name: {
      break;
    }
  }
  return false;
}
namespace {
}  // namespace
static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kTraceReportHandlerFactoryValidationInfo[] = {
    {internal::kTraceReportHandlerFactory_CreatePageHandler_Name,
     { &internal::TraceReportHandlerFactory_CreatePageHandler_Params_Data::Validate,
      nullptr /* no response */}},
};

bool TraceReportHandlerFactoryRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::trace_report::mojom::TraceReportHandlerFactory::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kTraceReportHandlerFactoryValidationInfo);
}

const char PageHandler::Name_[] = "trace_report.mojom.PageHandler";

PageHandler::IPCStableHashFunction PageHandler::MessageToMethodInfo_(mojo::Message& message) {
#if !BUILDFLAG(IS_FUCHSIA)
  switch (message.name()) {
    case internal::kPageHandler_GetAllTraceReports_Name: {
      return &PageHandler::GetAllTraceReports_Sym::IPCStableHash;
    }
    case internal::kPageHandler_DeleteSingleTrace_Name: {
      return &PageHandler::DeleteSingleTrace_Sym::IPCStableHash;
    }
    case internal::kPageHandler_DeleteAllTraces_Name: {
      return &PageHandler::DeleteAllTraces_Sym::IPCStableHash;
    }
    case internal::kPageHandler_UserUploadSingleTrace_Name: {
      return &PageHandler::UserUploadSingleTrace_Sym::IPCStableHash;
    }
    case internal::kPageHandler_DownloadTrace_Name: {
      return &PageHandler::DownloadTrace_Sym::IPCStableHash;
    }
  }
#endif  // !BUILDFLAG(IS_FUCHSIA)
  return nullptr;
}


const char* PageHandler::MessageToMethodName_(mojo::Message& message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (!is_response) {
    switch (message.name()) {
      case internal::kPageHandler_GetAllTraceReports_Name:
            return "Receive trace_report::mojom::PageHandler::GetAllTraceReports";
      case internal::kPageHandler_DeleteSingleTrace_Name:
            return "Receive trace_report::mojom::PageHandler::DeleteSingleTrace";
      case internal::kPageHandler_DeleteAllTraces_Name:
            return "Receive trace_report::mojom::PageHandler::DeleteAllTraces";
      case internal::kPageHandler_UserUploadSingleTrace_Name:
            return "Receive trace_report::mojom::PageHandler::UserUploadSingleTrace";
      case internal::kPageHandler_DownloadTrace_Name:
            return "Receive trace_report::mojom::PageHandler::DownloadTrace";
    }
  } else {
    switch (message.name()) {
      case internal::kPageHandler_GetAllTraceReports_Name:
            return "Receive reply trace_report::mojom::PageHandler::GetAllTraceReports";
      case internal::kPageHandler_DeleteSingleTrace_Name:
            return "Receive reply trace_report::mojom::PageHandler::DeleteSingleTrace";
      case internal::kPageHandler_DeleteAllTraces_Name:
            return "Receive reply trace_report::mojom::PageHandler::DeleteAllTraces";
      case internal::kPageHandler_UserUploadSingleTrace_Name:
            return "Receive reply trace_report::mojom::PageHandler::UserUploadSingleTrace";
      case internal::kPageHandler_DownloadTrace_Name:
            return "Receive reply trace_report::mojom::PageHandler::DownloadTrace";
    }
  }
  return "Receive unknown mojo message";
#else
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (is_response) {
    return "Receive mojo reply";
  } else {
    return "Receive mojo message";
  }
#endif // BUILDFLAG(MOJO_TRACE_ENABLED)
}

#if !BUILDFLAG(IS_FUCHSIA)
uint32_t PageHandler::GetAllTraceReports_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)trace_report::mojom::PageHandler::GetAllTraceReports");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
uint32_t PageHandler::DeleteSingleTrace_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)trace_report::mojom::PageHandler::DeleteSingleTrace");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
uint32_t PageHandler::DeleteAllTraces_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)trace_report::mojom::PageHandler::DeleteAllTraces");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
uint32_t PageHandler::UserUploadSingleTrace_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)trace_report::mojom::PageHandler::UserUploadSingleTrace");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
uint32_t PageHandler::DownloadTrace_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)trace_report::mojom::PageHandler::DownloadTrace");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
# endif // !BUILDFLAG(IS_FUCHSIA)

class PageHandler_GetAllTraceReports_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  PageHandler_GetAllTraceReports_ForwardToCallback(
      PageHandler::GetAllTraceReportsCallback callback
      ) : callback_(std::move(callback)) {
  }

  PageHandler_GetAllTraceReports_ForwardToCallback(const PageHandler_GetAllTraceReports_ForwardToCallback&) = delete;
  PageHandler_GetAllTraceReports_ForwardToCallback& operator=(const PageHandler_GetAllTraceReports_ForwardToCallback&) = delete;

  bool Accept(mojo::Message* message) override;
 private:
  PageHandler::GetAllTraceReportsCallback callback_;
};

class PageHandler_DeleteSingleTrace_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  PageHandler_DeleteSingleTrace_ForwardToCallback(
      PageHandler::DeleteSingleTraceCallback callback
      ) : callback_(std::move(callback)) {
  }

  PageHandler_DeleteSingleTrace_ForwardToCallback(const PageHandler_DeleteSingleTrace_ForwardToCallback&) = delete;
  PageHandler_DeleteSingleTrace_ForwardToCallback& operator=(const PageHandler_DeleteSingleTrace_ForwardToCallback&) = delete;

  bool Accept(mojo::Message* message) override;
 private:
  PageHandler::DeleteSingleTraceCallback callback_;
};

class PageHandler_DeleteAllTraces_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  PageHandler_DeleteAllTraces_ForwardToCallback(
      PageHandler::DeleteAllTracesCallback callback
      ) : callback_(std::move(callback)) {
  }

  PageHandler_DeleteAllTraces_ForwardToCallback(const PageHandler_DeleteAllTraces_ForwardToCallback&) = delete;
  PageHandler_DeleteAllTraces_ForwardToCallback& operator=(const PageHandler_DeleteAllTraces_ForwardToCallback&) = delete;

  bool Accept(mojo::Message* message) override;
 private:
  PageHandler::DeleteAllTracesCallback callback_;
};

class PageHandler_UserUploadSingleTrace_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  PageHandler_UserUploadSingleTrace_ForwardToCallback(
      PageHandler::UserUploadSingleTraceCallback callback
      ) : callback_(std::move(callback)) {
  }

  PageHandler_UserUploadSingleTrace_ForwardToCallback(const PageHandler_UserUploadSingleTrace_ForwardToCallback&) = delete;
  PageHandler_UserUploadSingleTrace_ForwardToCallback& operator=(const PageHandler_UserUploadSingleTrace_ForwardToCallback&) = delete;

  bool Accept(mojo::Message* message) override;
 private:
  PageHandler::UserUploadSingleTraceCallback callback_;
};

class PageHandler_DownloadTrace_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  PageHandler_DownloadTrace_ForwardToCallback(
      PageHandler::DownloadTraceCallback callback
      ) : callback_(std::move(callback)) {
  }

  PageHandler_DownloadTrace_ForwardToCallback(const PageHandler_DownloadTrace_ForwardToCallback&) = delete;
  PageHandler_DownloadTrace_ForwardToCallback& operator=(const PageHandler_DownloadTrace_ForwardToCallback&) = delete;

  bool Accept(mojo::Message* message) override;
 private:
  PageHandler::DownloadTraceCallback callback_;
};

PageHandlerProxy::PageHandlerProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void PageHandlerProxy::GetAllTraceReports(
    GetAllTraceReportsCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "Send trace_report::mojom::PageHandler::GetAllTraceReports");
#endif

  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  const bool is_urgent = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((is_urgent) ? mojo::Message::kFlagIsUrgent : 0);
  
  mojo::Message message(
      internal::kPageHandler_GetAllTraceReports_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::trace_report::mojom::internal::PageHandler_GetAllTraceReports_Params_Data> params(
          message);
  params.Allocate();

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandler::Name_);
  message.set_method_name("GetAllTraceReports");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new PageHandler_GetAllTraceReports_ForwardToCallback(
          std::move(callback)));
  ::mojo::internal::SendMojoMessage(*receiver_, message, std::move(responder));
}

void PageHandlerProxy::DeleteSingleTrace(
    const ::base::Token& in_uuid, DeleteSingleTraceCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send trace_report::mojom::PageHandler::DeleteSingleTrace", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("uuid"), in_uuid,
                        "<value of type const ::base::Token&>");
   });
#endif

  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  const bool is_urgent = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((is_urgent) ? mojo::Message::kFlagIsUrgent : 0);
  
  mojo::Message message(
      internal::kPageHandler_DeleteSingleTrace_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::trace_report::mojom::internal::PageHandler_DeleteSingleTrace_Params_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<
      typename decltype(params->uuid)::BaseType> uuid_fragment(
          params.message());
  mojo::internal::Serialize<::mojo_base::mojom::TokenDataView>(
      in_uuid, uuid_fragment);
  params->uuid.Set(
      uuid_fragment.is_null() ? nullptr : uuid_fragment.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->uuid.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null uuid in PageHandler.DeleteSingleTrace request");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandler::Name_);
  message.set_method_name("DeleteSingleTrace");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new PageHandler_DeleteSingleTrace_ForwardToCallback(
          std::move(callback)));
  ::mojo::internal::SendMojoMessage(*receiver_, message, std::move(responder));
}

void PageHandlerProxy::DeleteAllTraces(
    DeleteAllTracesCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "Send trace_report::mojom::PageHandler::DeleteAllTraces");
#endif

  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  const bool is_urgent = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((is_urgent) ? mojo::Message::kFlagIsUrgent : 0);
  
  mojo::Message message(
      internal::kPageHandler_DeleteAllTraces_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::trace_report::mojom::internal::PageHandler_DeleteAllTraces_Params_Data> params(
          message);
  params.Allocate();

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandler::Name_);
  message.set_method_name("DeleteAllTraces");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new PageHandler_DeleteAllTraces_ForwardToCallback(
          std::move(callback)));
  ::mojo::internal::SendMojoMessage(*receiver_, message, std::move(responder));
}

void PageHandlerProxy::UserUploadSingleTrace(
    const ::base::Token& in_uuid, UserUploadSingleTraceCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send trace_report::mojom::PageHandler::UserUploadSingleTrace", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("uuid"), in_uuid,
                        "<value of type const ::base::Token&>");
   });
#endif

  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  const bool is_urgent = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((is_urgent) ? mojo::Message::kFlagIsUrgent : 0);
  
  mojo::Message message(
      internal::kPageHandler_UserUploadSingleTrace_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::trace_report::mojom::internal::PageHandler_UserUploadSingleTrace_Params_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<
      typename decltype(params->uuid)::BaseType> uuid_fragment(
          params.message());
  mojo::internal::Serialize<::mojo_base::mojom::TokenDataView>(
      in_uuid, uuid_fragment);
  params->uuid.Set(
      uuid_fragment.is_null() ? nullptr : uuid_fragment.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->uuid.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null uuid in PageHandler.UserUploadSingleTrace request");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandler::Name_);
  message.set_method_name("UserUploadSingleTrace");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new PageHandler_UserUploadSingleTrace_ForwardToCallback(
          std::move(callback)));
  ::mojo::internal::SendMojoMessage(*receiver_, message, std::move(responder));
}

void PageHandlerProxy::DownloadTrace(
    const ::base::Token& in_uuid, DownloadTraceCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send trace_report::mojom::PageHandler::DownloadTrace", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("uuid"), in_uuid,
                        "<value of type const ::base::Token&>");
   });
#endif

  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  const bool is_urgent = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((is_urgent) ? mojo::Message::kFlagIsUrgent : 0);
  
  mojo::Message message(
      internal::kPageHandler_DownloadTrace_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::trace_report::mojom::internal::PageHandler_DownloadTrace_Params_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<
      typename decltype(params->uuid)::BaseType> uuid_fragment(
          params.message());
  mojo::internal::Serialize<::mojo_base::mojom::TokenDataView>(
      in_uuid, uuid_fragment);
  params->uuid.Set(
      uuid_fragment.is_null() ? nullptr : uuid_fragment.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->uuid.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null uuid in PageHandler.DownloadTrace request");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandler::Name_);
  message.set_method_name("DownloadTrace");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new PageHandler_DownloadTrace_ForwardToCallback(
          std::move(callback)));
  ::mojo::internal::SendMojoMessage(*receiver_, message, std::move(responder));
}
class PageHandler_GetAllTraceReports_ProxyToResponder : public ::mojo::internal::ProxyToResponder {
 public:
  static PageHandler::GetAllTraceReportsCallback CreateCallback(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<PageHandler_GetAllTraceReports_ProxyToResponder> proxy(
        new PageHandler_GetAllTraceReports_ProxyToResponder(
            message, std::move(responder)));
    return base::BindOnce(&PageHandler_GetAllTraceReports_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~PageHandler_GetAllTraceReports_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      // Instantiate a ScopedFizzleBlockShutdownTasks to allow this request to
      // fizzle if this happens after shutdown and the endpoint is bound to a
      // BLOCK_SHUTDOWN sequence.
      base::ThreadPoolInstance::ScopedFizzleBlockShutdownTasks fizzler;
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
  }

 private:
  PageHandler_GetAllTraceReports_ProxyToResponder(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : ::mojo::internal::ProxyToResponder(message, std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "PageHandler::GetAllTraceReportsCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      std::vector<ClientTraceReportPtr> in_reports);
};

bool PageHandler_GetAllTraceReports_ForwardToCallback::Accept(
    mojo::Message* message) {

  DCHECK(message->is_serialized());
  internal::PageHandler_GetAllTraceReports_ResponseParams_Data* params =
      reinterpret_cast<
          internal::PageHandler_GetAllTraceReports_ResponseParams_Data*>(
              message->mutable_payload());
  
  
  // Validation for PageHandler.0
  bool success = true;
  std::vector<ClientTraceReportPtr> p_reports{};
  PageHandler_GetAllTraceReports_ResponseParamsDataView input_data_view(params, message);
  
  if (success && !input_data_view.ReadReports(&p_reports))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        PageHandler::Name_, 0, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_reports));
  return true;
}

void PageHandler_GetAllTraceReports_ProxyToResponder::Run(
    std::vector<ClientTraceReportPtr> in_reports) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send reply trace_report::mojom::PageHandler::GetAllTraceReports", "async_response_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("reports"), in_reports,
                        "<value of type std::vector<ClientTraceReportPtr>>");
   });
#endif
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0) |
      ((true) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((false) ? mojo::Message::kFlagIsUrgent : 0);
  
  mojo::Message message(
      internal::kPageHandler_GetAllTraceReports_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::trace_report::mojom::internal::PageHandler_GetAllTraceReports_ResponseParams_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<
      typename decltype(params->reports)::BaseType>
      reports_fragment(params.message());
  constexpr const mojo::internal::ContainerValidateParams& reports_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  mojo::internal::Serialize<mojo::ArrayDataView<::trace_report::mojom::ClientTraceReportDataView>>(
      in_reports, reports_fragment, &reports_validate_params);
  params->reports.Set(
      reports_fragment.is_null() ? nullptr : reports_fragment.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->reports.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null reports in ");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandler::Name_);
  message.set_method_name("GetAllTraceReports");
#endif

  message.set_request_id(request_id_);
  message.set_trace_nonce(trace_nonce_);
  ::mojo::internal::SendMojoMessage(*responder_, message);
  // SendMojoMessage() fails silently if the responder connection is closed,
  // or if the message is malformed.
  //
  // TODO(darin): If Accept() returns false due to a malformed message, that
  // may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class PageHandler_DeleteSingleTrace_ProxyToResponder : public ::mojo::internal::ProxyToResponder {
 public:
  static PageHandler::DeleteSingleTraceCallback CreateCallback(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<PageHandler_DeleteSingleTrace_ProxyToResponder> proxy(
        new PageHandler_DeleteSingleTrace_ProxyToResponder(
            message, std::move(responder)));
    return base::BindOnce(&PageHandler_DeleteSingleTrace_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~PageHandler_DeleteSingleTrace_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      // Instantiate a ScopedFizzleBlockShutdownTasks to allow this request to
      // fizzle if this happens after shutdown and the endpoint is bound to a
      // BLOCK_SHUTDOWN sequence.
      base::ThreadPoolInstance::ScopedFizzleBlockShutdownTasks fizzler;
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
  }

 private:
  PageHandler_DeleteSingleTrace_ProxyToResponder(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : ::mojo::internal::ProxyToResponder(message, std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "PageHandler::DeleteSingleTraceCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      bool in_success);
};

bool PageHandler_DeleteSingleTrace_ForwardToCallback::Accept(
    mojo::Message* message) {

  DCHECK(message->is_serialized());
  internal::PageHandler_DeleteSingleTrace_ResponseParams_Data* params =
      reinterpret_cast<
          internal::PageHandler_DeleteSingleTrace_ResponseParams_Data*>(
              message->mutable_payload());
  
  
  // Validation for PageHandler.1
  bool success = true;
  bool p_success{};
  PageHandler_DeleteSingleTrace_ResponseParamsDataView input_data_view(params, message);
  
  if (success)
    p_success = input_data_view.success();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        PageHandler::Name_, 1, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_success));
  return true;
}

void PageHandler_DeleteSingleTrace_ProxyToResponder::Run(
    bool in_success) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send reply trace_report::mojom::PageHandler::DeleteSingleTrace", "async_response_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("success"), in_success,
                        "<value of type bool>");
   });
#endif
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0) |
      ((true) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((false) ? mojo::Message::kFlagIsUrgent : 0);
  
  mojo::Message message(
      internal::kPageHandler_DeleteSingleTrace_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::trace_report::mojom::internal::PageHandler_DeleteSingleTrace_ResponseParams_Data> params(
          message);
  params.Allocate();
  params->success = in_success;

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandler::Name_);
  message.set_method_name("DeleteSingleTrace");
#endif

  message.set_request_id(request_id_);
  message.set_trace_nonce(trace_nonce_);
  ::mojo::internal::SendMojoMessage(*responder_, message);
  // SendMojoMessage() fails silently if the responder connection is closed,
  // or if the message is malformed.
  //
  // TODO(darin): If Accept() returns false due to a malformed message, that
  // may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class PageHandler_DeleteAllTraces_ProxyToResponder : public ::mojo::internal::ProxyToResponder {
 public:
  static PageHandler::DeleteAllTracesCallback CreateCallback(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<PageHandler_DeleteAllTraces_ProxyToResponder> proxy(
        new PageHandler_DeleteAllTraces_ProxyToResponder(
            message, std::move(responder)));
    return base::BindOnce(&PageHandler_DeleteAllTraces_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~PageHandler_DeleteAllTraces_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      // Instantiate a ScopedFizzleBlockShutdownTasks to allow this request to
      // fizzle if this happens after shutdown and the endpoint is bound to a
      // BLOCK_SHUTDOWN sequence.
      base::ThreadPoolInstance::ScopedFizzleBlockShutdownTasks fizzler;
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
  }

 private:
  PageHandler_DeleteAllTraces_ProxyToResponder(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : ::mojo::internal::ProxyToResponder(message, std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "PageHandler::DeleteAllTracesCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      bool in_success);
};

bool PageHandler_DeleteAllTraces_ForwardToCallback::Accept(
    mojo::Message* message) {

  DCHECK(message->is_serialized());
  internal::PageHandler_DeleteAllTraces_ResponseParams_Data* params =
      reinterpret_cast<
          internal::PageHandler_DeleteAllTraces_ResponseParams_Data*>(
              message->mutable_payload());
  
  
  // Validation for PageHandler.2
  bool success = true;
  bool p_success{};
  PageHandler_DeleteAllTraces_ResponseParamsDataView input_data_view(params, message);
  
  if (success)
    p_success = input_data_view.success();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        PageHandler::Name_, 2, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_success));
  return true;
}

void PageHandler_DeleteAllTraces_ProxyToResponder::Run(
    bool in_success) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send reply trace_report::mojom::PageHandler::DeleteAllTraces", "async_response_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("success"), in_success,
                        "<value of type bool>");
   });
#endif
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0) |
      ((true) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((false) ? mojo::Message::kFlagIsUrgent : 0);
  
  mojo::Message message(
      internal::kPageHandler_DeleteAllTraces_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::trace_report::mojom::internal::PageHandler_DeleteAllTraces_ResponseParams_Data> params(
          message);
  params.Allocate();
  params->success = in_success;

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandler::Name_);
  message.set_method_name("DeleteAllTraces");
#endif

  message.set_request_id(request_id_);
  message.set_trace_nonce(trace_nonce_);
  ::mojo::internal::SendMojoMessage(*responder_, message);
  // SendMojoMessage() fails silently if the responder connection is closed,
  // or if the message is malformed.
  //
  // TODO(darin): If Accept() returns false due to a malformed message, that
  // may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class PageHandler_UserUploadSingleTrace_ProxyToResponder : public ::mojo::internal::ProxyToResponder {
 public:
  static PageHandler::UserUploadSingleTraceCallback CreateCallback(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<PageHandler_UserUploadSingleTrace_ProxyToResponder> proxy(
        new PageHandler_UserUploadSingleTrace_ProxyToResponder(
            message, std::move(responder)));
    return base::BindOnce(&PageHandler_UserUploadSingleTrace_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~PageHandler_UserUploadSingleTrace_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      // Instantiate a ScopedFizzleBlockShutdownTasks to allow this request to
      // fizzle if this happens after shutdown and the endpoint is bound to a
      // BLOCK_SHUTDOWN sequence.
      base::ThreadPoolInstance::ScopedFizzleBlockShutdownTasks fizzler;
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
  }

 private:
  PageHandler_UserUploadSingleTrace_ProxyToResponder(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : ::mojo::internal::ProxyToResponder(message, std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "PageHandler::UserUploadSingleTraceCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      bool in_success);
};

bool PageHandler_UserUploadSingleTrace_ForwardToCallback::Accept(
    mojo::Message* message) {

  DCHECK(message->is_serialized());
  internal::PageHandler_UserUploadSingleTrace_ResponseParams_Data* params =
      reinterpret_cast<
          internal::PageHandler_UserUploadSingleTrace_ResponseParams_Data*>(
              message->mutable_payload());
  
  
  // Validation for PageHandler.3
  bool success = true;
  bool p_success{};
  PageHandler_UserUploadSingleTrace_ResponseParamsDataView input_data_view(params, message);
  
  if (success)
    p_success = input_data_view.success();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        PageHandler::Name_, 3, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_success));
  return true;
}

void PageHandler_UserUploadSingleTrace_ProxyToResponder::Run(
    bool in_success) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send reply trace_report::mojom::PageHandler::UserUploadSingleTrace", "async_response_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("success"), in_success,
                        "<value of type bool>");
   });
#endif
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0) |
      ((true) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((false) ? mojo::Message::kFlagIsUrgent : 0);
  
  mojo::Message message(
      internal::kPageHandler_UserUploadSingleTrace_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::trace_report::mojom::internal::PageHandler_UserUploadSingleTrace_ResponseParams_Data> params(
          message);
  params.Allocate();
  params->success = in_success;

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandler::Name_);
  message.set_method_name("UserUploadSingleTrace");
#endif

  message.set_request_id(request_id_);
  message.set_trace_nonce(trace_nonce_);
  ::mojo::internal::SendMojoMessage(*responder_, message);
  // SendMojoMessage() fails silently if the responder connection is closed,
  // or if the message is malformed.
  //
  // TODO(darin): If Accept() returns false due to a malformed message, that
  // may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class PageHandler_DownloadTrace_ProxyToResponder : public ::mojo::internal::ProxyToResponder {
 public:
  static PageHandler::DownloadTraceCallback CreateCallback(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<PageHandler_DownloadTrace_ProxyToResponder> proxy(
        new PageHandler_DownloadTrace_ProxyToResponder(
            message, std::move(responder)));
    return base::BindOnce(&PageHandler_DownloadTrace_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~PageHandler_DownloadTrace_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      // Instantiate a ScopedFizzleBlockShutdownTasks to allow this request to
      // fizzle if this happens after shutdown and the endpoint is bound to a
      // BLOCK_SHUTDOWN sequence.
      base::ThreadPoolInstance::ScopedFizzleBlockShutdownTasks fizzler;
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
  }

 private:
  PageHandler_DownloadTrace_ProxyToResponder(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : ::mojo::internal::ProxyToResponder(message, std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "PageHandler::DownloadTraceCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      std::optional<::mojo_base::BigBuffer> in_trace);
};

bool PageHandler_DownloadTrace_ForwardToCallback::Accept(
    mojo::Message* message) {

  DCHECK(message->is_serialized());
  internal::PageHandler_DownloadTrace_ResponseParams_Data* params =
      reinterpret_cast<
          internal::PageHandler_DownloadTrace_ResponseParams_Data*>(
              message->mutable_payload());
  
  
  // Validation for PageHandler.4
  bool success = true;
  std::optional<::mojo_base::BigBuffer> p_trace{};
  PageHandler_DownloadTrace_ResponseParamsDataView input_data_view(params, message);
  
  if (success && !input_data_view.ReadTrace(&p_trace))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        PageHandler::Name_, 4, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_trace));
  return true;
}

void PageHandler_DownloadTrace_ProxyToResponder::Run(
    std::optional<::mojo_base::BigBuffer> in_trace) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send reply trace_report::mojom::PageHandler::DownloadTrace", "async_response_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("trace"), in_trace,
                        "<value of type std::optional<::mojo_base::BigBuffer>>");
   });
#endif
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0) |
      ((true) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((false) ? mojo::Message::kFlagIsUrgent : 0);
  
  mojo::Message message(
      internal::kPageHandler_DownloadTrace_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::trace_report::mojom::internal::PageHandler_DownloadTrace_ResponseParams_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<decltype(params->trace)>
      trace_fragment(params.message());
  trace_fragment.Claim(&params->trace);
  mojo::internal::Serialize<::mojo_base::mojom::BigBufferDataView>(
      in_trace, trace_fragment, true);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandler::Name_);
  message.set_method_name("DownloadTrace");
#endif

  message.set_request_id(request_id_);
  message.set_trace_nonce(trace_nonce_);
  ::mojo::internal::SendMojoMessage(*responder_, message);
  // SendMojoMessage() fails silently if the responder connection is closed,
  // or if the message is malformed.
  //
  // TODO(darin): If Accept() returns false due to a malformed message, that
  // may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool PageHandlerStubDispatch::Accept(
    PageHandler* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kPageHandler_GetAllTraceReports_Name: {
      break;
    }
    case internal::kPageHandler_DeleteSingleTrace_Name: {
      break;
    }
    case internal::kPageHandler_DeleteAllTraces_Name: {
      break;
    }
    case internal::kPageHandler_UserUploadSingleTrace_Name: {
      break;
    }
    case internal::kPageHandler_DownloadTrace_Name: {
      break;
    }
  }
  return false;
}

// static
bool PageHandlerStubDispatch::AcceptWithResponder(
    PageHandler* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  [[maybe_unused]] const bool message_is_sync =
      message->has_flag(mojo::Message::kFlagIsSync);
  [[maybe_unused]] const uint64_t request_id = message->request_id();
  switch (message->header()->name) {
    case internal::kPageHandler_GetAllTraceReports_Name: {

      internal::PageHandler_GetAllTraceReports_Params_Data* params =
          reinterpret_cast<
              internal::PageHandler_GetAllTraceReports_Params_Data*>(
                  message->mutable_payload());
      
      
      // Validation for PageHandler.0
      bool success = true;
      PageHandler_GetAllTraceReports_ParamsDataView input_data_view(params, message);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PageHandler::Name_, 0, false);
        return false;
      }
      PageHandler::GetAllTraceReportsCallback callback =
          PageHandler_GetAllTraceReports_ProxyToResponder::CreateCallback(
              *message, std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GetAllTraceReports(std::move(callback));
      return true;
    }
    case internal::kPageHandler_DeleteSingleTrace_Name: {

      internal::PageHandler_DeleteSingleTrace_Params_Data* params =
          reinterpret_cast<
              internal::PageHandler_DeleteSingleTrace_Params_Data*>(
                  message->mutable_payload());
      
      
      // Validation for PageHandler.1
      bool success = true;
      ::base::Token p_uuid{};
      PageHandler_DeleteSingleTrace_ParamsDataView input_data_view(params, message);
      
      if (success && !input_data_view.ReadUuid(&p_uuid))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PageHandler::Name_, 1, false);
        return false;
      }
      PageHandler::DeleteSingleTraceCallback callback =
          PageHandler_DeleteSingleTrace_ProxyToResponder::CreateCallback(
              *message, std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->DeleteSingleTrace(        
        std::move(p_uuid), std::move(callback));
      return true;
    }
    case internal::kPageHandler_DeleteAllTraces_Name: {

      internal::PageHandler_DeleteAllTraces_Params_Data* params =
          reinterpret_cast<
              internal::PageHandler_DeleteAllTraces_Params_Data*>(
                  message->mutable_payload());
      
      
      // Validation for PageHandler.2
      bool success = true;
      PageHandler_DeleteAllTraces_ParamsDataView input_data_view(params, message);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PageHandler::Name_, 2, false);
        return false;
      }
      PageHandler::DeleteAllTracesCallback callback =
          PageHandler_DeleteAllTraces_ProxyToResponder::CreateCallback(
              *message, std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->DeleteAllTraces(std::move(callback));
      return true;
    }
    case internal::kPageHandler_UserUploadSingleTrace_Name: {

      internal::PageHandler_UserUploadSingleTrace_Params_Data* params =
          reinterpret_cast<
              internal::PageHandler_UserUploadSingleTrace_Params_Data*>(
                  message->mutable_payload());
      
      
      // Validation for PageHandler.3
      bool success = true;
      ::base::Token p_uuid{};
      PageHandler_UserUploadSingleTrace_ParamsDataView input_data_view(params, message);
      
      if (success && !input_data_view.ReadUuid(&p_uuid))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PageHandler::Name_, 3, false);
        return false;
      }
      PageHandler::UserUploadSingleTraceCallback callback =
          PageHandler_UserUploadSingleTrace_ProxyToResponder::CreateCallback(
              *message, std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->UserUploadSingleTrace(        
        std::move(p_uuid), std::move(callback));
      return true;
    }
    case internal::kPageHandler_DownloadTrace_Name: {

      internal::PageHandler_DownloadTrace_Params_Data* params =
          reinterpret_cast<
              internal::PageHandler_DownloadTrace_Params_Data*>(
                  message->mutable_payload());
      
      
      // Validation for PageHandler.4
      bool success = true;
      ::base::Token p_uuid{};
      PageHandler_DownloadTrace_ParamsDataView input_data_view(params, message);
      
      if (success && !input_data_view.ReadUuid(&p_uuid))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PageHandler::Name_, 4, false);
        return false;
      }
      PageHandler::DownloadTraceCallback callback =
          PageHandler_DownloadTrace_ProxyToResponder::CreateCallback(
              *message, std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->DownloadTrace(        
        std::move(p_uuid), std::move(callback));
      return true;
    }
  }
  return false;
}
namespace {
}  // namespace
static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kPageHandlerValidationInfo[] = {
    {internal::kPageHandler_GetAllTraceReports_Name,
     { &internal::PageHandler_GetAllTraceReports_Params_Data::Validate,
      &internal::PageHandler_GetAllTraceReports_ResponseParams_Data::Validate}},
    {internal::kPageHandler_DeleteSingleTrace_Name,
     { &internal::PageHandler_DeleteSingleTrace_Params_Data::Validate,
      &internal::PageHandler_DeleteSingleTrace_ResponseParams_Data::Validate}},
    {internal::kPageHandler_DeleteAllTraces_Name,
     { &internal::PageHandler_DeleteAllTraces_Params_Data::Validate,
      &internal::PageHandler_DeleteAllTraces_ResponseParams_Data::Validate}},
    {internal::kPageHandler_UserUploadSingleTrace_Name,
     { &internal::PageHandler_UserUploadSingleTrace_Params_Data::Validate,
      &internal::PageHandler_UserUploadSingleTrace_ResponseParams_Data::Validate}},
    {internal::kPageHandler_DownloadTrace_Name,
     { &internal::PageHandler_DownloadTrace_Params_Data::Validate,
      &internal::PageHandler_DownloadTrace_ResponseParams_Data::Validate}},
};

bool PageHandlerRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::trace_report::mojom::PageHandler::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kPageHandlerValidationInfo);
}

bool PageHandlerResponseValidator::Accept(mojo::Message* message) {
  const char* name = ::trace_report::mojom::PageHandler::Name_;
  return mojo::internal::ValidateResponseGeneric(message, name, kPageHandlerValidationInfo);

}
const char Page::Name_[] = "trace_report.mojom.Page";

Page::IPCStableHashFunction Page::MessageToMethodInfo_(mojo::Message& message) {
#if !BUILDFLAG(IS_FUCHSIA)
#endif  // !BUILDFLAG(IS_FUCHSIA)
  return nullptr;
}


const char* Page::MessageToMethodName_(mojo::Message& message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  return "Receive unknown mojo message";
#else
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (is_response) {
    return "Receive mojo reply";
  } else {
    return "Receive mojo message";
  }
#endif // BUILDFLAG(MOJO_TRACE_ENABLED)
}

#if !BUILDFLAG(IS_FUCHSIA)
# endif // !BUILDFLAG(IS_FUCHSIA)

PageProxy::PageProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

// static
bool PageStubDispatch::Accept(
    Page* impl,
    mojo::Message* message) {
  return false;
}

// static
bool PageStubDispatch::AcceptWithResponder(
    Page* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  return false;
}
namespace {
}  // namespace

bool PageRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::trace_report::mojom::Page::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, {});
}



}  // trace_report::mojom


namespace mojo {


// static
bool StructTraits<::trace_report::mojom::ClientTraceReport::DataView, ::trace_report::mojom::ClientTraceReportPtr>::Read(
    ::trace_report::mojom::ClientTraceReport::DataView input,
    ::trace_report::mojom::ClientTraceReportPtr* output) {
  bool success = true;
  ::trace_report::mojom::ClientTraceReportPtr result(::trace_report::mojom::ClientTraceReport::New());
  
      if (success && !input.ReadUuid(&result->uuid))
        success = false;
      if (success && !input.ReadCreationTime(&result->creation_time))
        success = false;
      if (success && !input.ReadScenarioName(&result->scenario_name))
        success = false;
      if (success && !input.ReadUploadRuleName(&result->upload_rule_name))
        success = false;
      if (success)
        result->total_size = input.total_size();
      if (success && !input.ReadUploadState(&result->upload_state))
        success = false;
      if (success && !input.ReadUploadTime(&result->upload_time))
        success = false;
      if (success && !input.ReadSkipReason(&result->skip_reason))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo


// Symbols declared in the -test-utils.h header are defined here instead of a
// separate .cc file to save compile time.


namespace trace_report::mojom {


void TraceReportHandlerFactoryInterceptorForTesting::CreatePageHandler(::mojo::PendingRemote<Page> page, ::mojo::PendingReceiver<PageHandler> handler) {
  GetForwardingInterface()->CreatePageHandler(std::move(page), std::move(handler));
}
TraceReportHandlerFactoryAsyncWaiter::TraceReportHandlerFactoryAsyncWaiter(
    TraceReportHandlerFactory* proxy) : proxy_(proxy) {}

TraceReportHandlerFactoryAsyncWaiter::~TraceReportHandlerFactoryAsyncWaiter() = default;




void PageHandlerInterceptorForTesting::GetAllTraceReports(GetAllTraceReportsCallback callback) {
  GetForwardingInterface()->GetAllTraceReports(std::move(callback));
}
void PageHandlerInterceptorForTesting::DeleteSingleTrace(const ::base::Token& uuid, DeleteSingleTraceCallback callback) {
  GetForwardingInterface()->DeleteSingleTrace(std::move(uuid), std::move(callback));
}
void PageHandlerInterceptorForTesting::DeleteAllTraces(DeleteAllTracesCallback callback) {
  GetForwardingInterface()->DeleteAllTraces(std::move(callback));
}
void PageHandlerInterceptorForTesting::UserUploadSingleTrace(const ::base::Token& uuid, UserUploadSingleTraceCallback callback) {
  GetForwardingInterface()->UserUploadSingleTrace(std::move(uuid), std::move(callback));
}
void PageHandlerInterceptorForTesting::DownloadTrace(const ::base::Token& uuid, DownloadTraceCallback callback) {
  GetForwardingInterface()->DownloadTrace(std::move(uuid), std::move(callback));
}
PageHandlerAsyncWaiter::PageHandlerAsyncWaiter(
    PageHandler* proxy) : proxy_(proxy) {}

PageHandlerAsyncWaiter::~PageHandlerAsyncWaiter() = default;

void PageHandlerAsyncWaiter::GetAllTraceReports(
    std::vector<ClientTraceReportPtr>* out_reports) {
  base::RunLoop loop;
  proxy_->GetAllTraceReports(
      base::BindOnce(
          [](base::RunLoop* loop,
             std::vector<ClientTraceReportPtr>* out_reports
,
             std::vector<ClientTraceReportPtr> reports) {*out_reports = std::move(reports);
            loop->Quit();
          },
          &loop,
          out_reports));
  loop.Run();
}

std::vector<ClientTraceReportPtr> PageHandlerAsyncWaiter::GetAllTraceReports(
    ) {
  std::vector<ClientTraceReportPtr> async_wait_result;
  GetAllTraceReports(&async_wait_result);
  return async_wait_result;
}

void PageHandlerAsyncWaiter::DeleteSingleTrace(
    const ::base::Token& uuid, bool* out_success) {
  base::RunLoop loop;
  proxy_->DeleteSingleTrace(std::move(uuid),
      base::BindOnce(
          [](base::RunLoop* loop,
             bool* out_success
,
             bool success) {*out_success = std::move(success);
            loop->Quit();
          },
          &loop,
          out_success));
  loop.Run();
}

bool PageHandlerAsyncWaiter::DeleteSingleTrace(
    const ::base::Token& uuid) {
  bool async_wait_result;
  DeleteSingleTrace(std::move(uuid),&async_wait_result);
  return async_wait_result;
}

void PageHandlerAsyncWaiter::DeleteAllTraces(
    bool* out_success) {
  base::RunLoop loop;
  proxy_->DeleteAllTraces(
      base::BindOnce(
          [](base::RunLoop* loop,
             bool* out_success
,
             bool success) {*out_success = std::move(success);
            loop->Quit();
          },
          &loop,
          out_success));
  loop.Run();
}

bool PageHandlerAsyncWaiter::DeleteAllTraces(
    ) {
  bool async_wait_result;
  DeleteAllTraces(&async_wait_result);
  return async_wait_result;
}

void PageHandlerAsyncWaiter::UserUploadSingleTrace(
    const ::base::Token& uuid, bool* out_success) {
  base::RunLoop loop;
  proxy_->UserUploadSingleTrace(std::move(uuid),
      base::BindOnce(
          [](base::RunLoop* loop,
             bool* out_success
,
             bool success) {*out_success = std::move(success);
            loop->Quit();
          },
          &loop,
          out_success));
  loop.Run();
}

bool PageHandlerAsyncWaiter::UserUploadSingleTrace(
    const ::base::Token& uuid) {
  bool async_wait_result;
  UserUploadSingleTrace(std::move(uuid),&async_wait_result);
  return async_wait_result;
}

void PageHandlerAsyncWaiter::DownloadTrace(
    const ::base::Token& uuid, std::optional<::mojo_base::BigBuffer>* out_trace) {
  base::RunLoop loop;
  proxy_->DownloadTrace(std::move(uuid),
      base::BindOnce(
          [](base::RunLoop* loop,
             std::optional<::mojo_base::BigBuffer>* out_trace
,
             std::optional<::mojo_base::BigBuffer> trace) {*out_trace = std::move(trace);
            loop->Quit();
          },
          &loop,
          out_trace));
  loop.Run();
}

std::optional<::mojo_base::BigBuffer> PageHandlerAsyncWaiter::DownloadTrace(
    const ::base::Token& uuid) {
  std::optional<::mojo_base::BigBuffer> async_wait_result;
  DownloadTrace(std::move(uuid),&async_wait_result);
  return async_wait_result;
}




PageAsyncWaiter::PageAsyncWaiter(
    Page* proxy) : proxy_(proxy) {}

PageAsyncWaiter::~PageAsyncWaiter() = default;






}  // trace_report::mojom


#if defined(__clang__)
#pragma clang diagnostic pop
#endif