// This is generated file. Do not modify directly.

#include "electron/electron_gtk_stubs.h"

#include <dlfcn.h>   // For dlsym, dlopen, RTLD_LAZY.

#include <cstdarg>

#include "base/compiler_specific.h"
#include "ui/gtk/log_noop.h"

#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gtk/gtk.h>

namespace  {

void LogDlerror(const char* symbol) {
  LogNoop() << "Couldn't load " << symbol << ", dlerror() says:\n" << dlerror();
}

}  // namespace 

extern "C" {

// Static pointers that will hold the location of the real function
// implementations after the module has been loaded.
static GdkPixbuf* (*gdk_pixbuf_new_ptr)(GdkColorspace colorspace, gboolean has_alpha, int bits_per_sample, int width, int height) = nullptr;
static GdkPixbuf* (*gdk_pixbuf_scale_simple_ptr)(const GdkPixbuf* src, int dest_width, int dest_height, GdkInterpType interp_type) = nullptr;
static guchar* (*gdk_pixbuf_get_pixels_ptr)(const GdkPixbuf* pixbuf) = nullptr;

// Stubs that dispatch to the real implementations.
extern GdkPixbuf* gdk_pixbuf_new(GdkColorspace colorspace, gboolean has_alpha, int bits_per_sample, int width, int height) __attribute__((weak));
DISABLE_CFI_ICALL
GdkPixbuf*  gdk_pixbuf_new(GdkColorspace colorspace, gboolean has_alpha, int bits_per_sample, int width, int height) {
  return gdk_pixbuf_new_ptr(colorspace, has_alpha, bits_per_sample, width, height);
}
extern GdkPixbuf* gdk_pixbuf_scale_simple(const GdkPixbuf* src, int dest_width, int dest_height, GdkInterpType interp_type) __attribute__((weak));
DISABLE_CFI_ICALL
GdkPixbuf*  gdk_pixbuf_scale_simple(const GdkPixbuf* src, int dest_width, int dest_height, GdkInterpType interp_type) {
  return gdk_pixbuf_scale_simple_ptr(src, dest_width, dest_height, interp_type);
}
extern guchar* gdk_pixbuf_get_pixels(const GdkPixbuf* pixbuf) __attribute__((weak));
DISABLE_CFI_ICALL
guchar*  gdk_pixbuf_get_pixels(const GdkPixbuf* pixbuf) {
  return gdk_pixbuf_get_pixels_ptr(pixbuf);
}

}  // extern "C"


namespace electron {

// Returns true if all stubs have been properly initialized.
bool IsElectron_gdk_pixbufInitialized() {
  return gdk_pixbuf_new_ptr &&
         gdk_pixbuf_scale_simple_ptr &&
         gdk_pixbuf_get_pixels_ptr;
}

// Initializes the module stubs.
void InitializeElectron_gdk_pixbuf(void* module) {
  const char gdk_pixbuf_new_name[] = "gdk_pixbuf_new";
  gdk_pixbuf_new_ptr =
    reinterpret_cast<GdkPixbuf* (*)(GdkColorspace colorspace, gboolean has_alpha, int bits_per_sample, int width, int height)>(
      dlsym(module, gdk_pixbuf_new_name));
  if (!gdk_pixbuf_new_ptr)
    LogDlerror(gdk_pixbuf_new_name);
  const char gdk_pixbuf_scale_simple_name[] = "gdk_pixbuf_scale_simple";
  gdk_pixbuf_scale_simple_ptr =
    reinterpret_cast<GdkPixbuf* (*)(const GdkPixbuf* src, int dest_width, int dest_height, GdkInterpType interp_type)>(
      dlsym(module, gdk_pixbuf_scale_simple_name));
  if (!gdk_pixbuf_scale_simple_ptr)
    LogDlerror(gdk_pixbuf_scale_simple_name);
  const char gdk_pixbuf_get_pixels_name[] = "gdk_pixbuf_get_pixels";
  gdk_pixbuf_get_pixels_ptr =
    reinterpret_cast<guchar* (*)(const GdkPixbuf* pixbuf)>(
      dlsym(module, gdk_pixbuf_get_pixels_name));
  if (!gdk_pixbuf_get_pixels_ptr)
    LogDlerror(gdk_pixbuf_get_pixels_name);
}

// Uninitialize the module stubs.  Reset pointers to nullptr.
void UninitializeElectron_gdk_pixbuf() {
  gdk_pixbuf_new_ptr = nullptr;
  gdk_pixbuf_scale_simple_ptr = nullptr;
  gdk_pixbuf_get_pixels_ptr = nullptr;
}

}  // namespace electron

namespace electron {
typedef std::map<StubModules, void*> StubHandleMap;
static void CloseLibraries(StubHandleMap* stub_handles) {
  for (StubHandleMap::const_iterator it = stub_handles->begin();
       it != stub_handles->end();
       ++it) {
    dlclose(it->second);
  }

  stub_handles->clear();
}
bool InitializeStubs(const StubPathMap& path_map) {
  StubHandleMap opened_libraries;
  for (int i = 0; i < kNumStubModules; ++i) {
    StubModules cur_module = static_cast<StubModules>(i);
    // If a module is missing, we fail.
    StubPathMap::const_iterator it = path_map.find(cur_module);
    if (it == path_map.end()) {
      CloseLibraries(&opened_libraries);
      return false;
    }

    // Otherwise, attempt to dlopen the library.
    const std::vector<std::string>& paths = it->second;
    bool module_opened = false;
    for (std::vector<std::string>::const_iterator dso_path = paths.begin();
         !module_opened && dso_path != paths.end();
         ++dso_path) {
      void* handle = dlopen(dso_path->c_str(), RTLD_LAZY);
      if (handle) {
        module_opened = true;
        opened_libraries[cur_module] = handle;
      } else {
        LogNoop() << "dlopen(" << dso_path->c_str() << ") failed.";
        if (char *errstr = dlerror()) {
          LogNoop() << "dlerror() says:\n" << errstr;
        } else {
          LogNoop() << "dlerror() is nullptr";
        }

      }
    }

    if (!module_opened) {
      CloseLibraries(&opened_libraries);
      return false;
    }
  }

  // Initialize each module if we have not already failed.
  InitializeElectron_gdk_pixbuf(opened_libraries[kModuleElectron_gdk_pixbuf]);

  // Check that each module is initialized correctly.
  // Close all previously opened libraries on failure.
  if (!IsElectron_gdk_pixbufInitialized()) {
    UninitializeElectron_gdk_pixbuf();
    CloseLibraries(&opened_libraries);
    return false;
  }

  return true;
}

}  // namespace electron
