// electron/shell/common/api/api.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef ELECTRON_SHELL_COMMON_API_API_MOJOM_SHARED_H_
#define ELECTRON_SHELL_COMMON_API_API_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "electron/shell/common/api/api.mojom-shared-internal.h"
#include "mojo/public/mojom/base/string16.mojom-shared.h"
#include "ui/gfx/geometry/mojom/geometry.mojom-shared.h"
#include "third_party/blink/public/mojom/messaging/cloneable_message.mojom-shared.h"
#include "third_party/blink/public/mojom/messaging/transferable_message.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"






namespace electron::mojom {
class DraggableRegionDataView;



}  // electron::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::electron::mojom::DraggableRegionDataView> {
  using Data = ::electron::mojom::internal::DraggableRegion_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace electron::mojom {
// Interface base classes. They are used for type safety check.
class ElectronRendererInterfaceBase {};

using ElectronRendererPtrDataView =
    mojo::InterfacePtrDataView<ElectronRendererInterfaceBase>;
using ElectronRendererRequestDataView =
    mojo::InterfaceRequestDataView<ElectronRendererInterfaceBase>;
using ElectronRendererAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<ElectronRendererInterfaceBase>;
using ElectronRendererAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<ElectronRendererInterfaceBase>;
class ElectronAutofillAgentInterfaceBase {};

using ElectronAutofillAgentPtrDataView =
    mojo::InterfacePtrDataView<ElectronAutofillAgentInterfaceBase>;
using ElectronAutofillAgentRequestDataView =
    mojo::InterfaceRequestDataView<ElectronAutofillAgentInterfaceBase>;
using ElectronAutofillAgentAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<ElectronAutofillAgentInterfaceBase>;
using ElectronAutofillAgentAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<ElectronAutofillAgentInterfaceBase>;
class ElectronAutofillDriverInterfaceBase {};

using ElectronAutofillDriverPtrDataView =
    mojo::InterfacePtrDataView<ElectronAutofillDriverInterfaceBase>;
using ElectronAutofillDriverRequestDataView =
    mojo::InterfaceRequestDataView<ElectronAutofillDriverInterfaceBase>;
using ElectronAutofillDriverAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<ElectronAutofillDriverInterfaceBase>;
using ElectronAutofillDriverAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<ElectronAutofillDriverInterfaceBase>;
class ElectronWebContentsUtilityInterfaceBase {};

using ElectronWebContentsUtilityPtrDataView =
    mojo::InterfacePtrDataView<ElectronWebContentsUtilityInterfaceBase>;
using ElectronWebContentsUtilityRequestDataView =
    mojo::InterfaceRequestDataView<ElectronWebContentsUtilityInterfaceBase>;
using ElectronWebContentsUtilityAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<ElectronWebContentsUtilityInterfaceBase>;
using ElectronWebContentsUtilityAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<ElectronWebContentsUtilityInterfaceBase>;
class ElectronApiIPCInterfaceBase {};

using ElectronApiIPCPtrDataView =
    mojo::InterfacePtrDataView<ElectronApiIPCInterfaceBase>;
using ElectronApiIPCRequestDataView =
    mojo::InterfaceRequestDataView<ElectronApiIPCInterfaceBase>;
using ElectronApiIPCAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<ElectronApiIPCInterfaceBase>;
using ElectronApiIPCAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<ElectronApiIPCInterfaceBase>;


class DraggableRegionDataView {
 public:
  DraggableRegionDataView() = default;

  DraggableRegionDataView(
      internal::DraggableRegion_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  bool draggable() const {
    return data_->draggable;
  }
  inline void GetBoundsDataView(
      ::gfx::mojom::RectDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadBounds(UserType* output) {
    
    auto* pointer = data_->bounds.Get();
    return mojo::internal::Deserialize<::gfx::mojom::RectDataView>(
        pointer, output, message_);
  }
 private:
  internal::DraggableRegion_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


}  // electron::mojom

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::electron::mojom::DraggableRegionDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::electron::mojom::DraggableRegionDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::electron::mojom::internal::DraggableRegion_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    fragment->draggable = Traits::draggable(input);
    decltype(Traits::bounds(input)) in_bounds = Traits::bounds(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->bounds)::BaseType> bounds_fragment(
            fragment.message());
    mojo::internal::Serialize<::gfx::mojom::RectDataView>(
        in_bounds, bounds_fragment);
    fragment->bounds.Set(
        bounds_fragment.is_null() ? nullptr : bounds_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->bounds.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null bounds in DraggableRegion struct");
  }

  static bool Deserialize(::electron::mojom::internal::DraggableRegion_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::electron::mojom::DraggableRegionDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace electron::mojom {

inline void DraggableRegionDataView::GetBoundsDataView(
    ::gfx::mojom::RectDataView* output) {
  auto pointer = data_->bounds.Get();
  *output = ::gfx::mojom::RectDataView(pointer, message_);
}



}  // electron::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // ELECTRON_SHELL_COMMON_API_API_MOJOM_SHARED_H_