// electron/shell/services/node/public/mojom/node_service.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef ELECTRON_SHELL_SERVICES_NODE_PUBLIC_MOJOM_NODE_SERVICE_MOJOM_H_
#define ELECTRON_SHELL_SERVICES_NODE_PUBLIC_MOJOM_NODE_SERVICE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include <optional>
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "electron/shell/services/node/public/mojom/node_service.mojom-features.h"
#include "electron/shell/services/node/public/mojom/node_service.mojom-shared.h"
#include "electron/shell/services/node/public/mojom/node_service.mojom-forward.h"
#include "mojo/public/mojom/base/file_path.mojom.h"
#include "sandbox/policy/mojom/sandbox.mojom-forward.h"
#include "services/network/public/mojom/host_resolver.mojom-forward.h"
#include "services/network/public/mojom/url_loader_factory.mojom-forward.h"
#include "third_party/blink/public/mojom/messaging/message_port_descriptor.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"






namespace node::mojom {

class NodeServiceProxy;

template <typename ImplRefTraits>
class NodeServiceStub;

class NodeServiceRequestValidator;


class NodeService
    : public NodeServiceInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr auto kServiceSandbox = sandbox::mojom::Sandbox::kNoSandbox;
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = NodeServiceInterfaceBase;
  using Proxy_ = NodeServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = NodeServiceStub<ImplRefTraits>;

  using RequestValidator_ = NodeServiceRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kInitializeMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct Initialize_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~NodeService() = default;

  
  virtual void Initialize(NodeServiceParamsPtr params) = 0;
};



class  NodeServiceProxy
    : public NodeService {
 public:
  using InterfaceType = NodeService;

  explicit NodeServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Initialize(NodeServiceParamsPtr params) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  NodeServiceStubDispatch {
 public:
  static bool Accept(NodeService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      NodeService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<NodeService>>
class NodeServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  NodeServiceStub() = default;
  ~NodeServiceStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return NodeServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return NodeServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  NodeServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};








class  NodeServiceParams {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<NodeServiceParams, T>::value>;
  using DataView = NodeServiceParamsDataView;
  using Data_ = internal::NodeServiceParams_Data;

  template <typename... Args>
  static NodeServiceParamsPtr New(Args&&... args) {
    return NodeServiceParamsPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static NodeServiceParamsPtr From(const U& u) {
    return mojo::TypeConverter<NodeServiceParamsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, NodeServiceParams>::Convert(*this);
  }


  NodeServiceParams();

  NodeServiceParams(
      const ::base::FilePath& script,
      std::vector<std::string> args,
      std::vector<std::string> exec_args,
      ::blink::MessagePortDescriptor port,
      ::mojo::PendingRemote<::network::mojom::URLLoaderFactory> url_loader_factory,
      ::mojo::PendingRemote<::network::mojom::HostResolver> host_resolver);

NodeServiceParams(const NodeServiceParams&) = delete;
NodeServiceParams& operator=(const NodeServiceParams&) = delete;

  ~NodeServiceParams();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = NodeServiceParamsPtr>
  NodeServiceParamsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, NodeServiceParams::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, NodeServiceParams::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, NodeServiceParams::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        NodeServiceParams::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::NodeServiceParams_UnserializedMessageContext<
            UserType, NodeServiceParams::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<NodeServiceParams::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return NodeServiceParams::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::NodeServiceParams_UnserializedMessageContext<
            UserType, NodeServiceParams::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<NodeServiceParams::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::base::FilePath script;
  
  std::vector<std::string> args;
  
  std::vector<std::string> exec_args;
  
  ::blink::MessagePortDescriptor port;
  
  ::mojo::PendingRemote<::network::mojom::URLLoaderFactory> url_loader_factory;
  
  ::mojo::PendingRemote<::network::mojom::HostResolver> host_resolver;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, NodeServiceParams::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, NodeServiceParams::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, NodeServiceParams::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, NodeServiceParams::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
NodeServiceParamsPtr NodeServiceParams::Clone() const {
  return New(
      mojo::Clone(script),
      mojo::Clone(args),
      mojo::Clone(exec_args),
      mojo::Clone(port),
      mojo::Clone(url_loader_factory),
      mojo::Clone(host_resolver)
  );
}

template <typename T, NodeServiceParams::EnableIfSame<T>*>
bool NodeServiceParams::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->script, other_struct.script))
    return false;
  if (!mojo::Equals(this->args, other_struct.args))
    return false;
  if (!mojo::Equals(this->exec_args, other_struct.exec_args))
    return false;
  if (!mojo::Equals(this->port, other_struct.port))
    return false;
  if (!mojo::Equals(this->url_loader_factory, other_struct.url_loader_factory))
    return false;
  if (!mojo::Equals(this->host_resolver, other_struct.host_resolver))
    return false;
  return true;
}

template <typename T, NodeServiceParams::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.script < rhs.script)
    return true;
  if (rhs.script < lhs.script)
    return false;
  if (lhs.args < rhs.args)
    return true;
  if (rhs.args < lhs.args)
    return false;
  if (lhs.exec_args < rhs.exec_args)
    return true;
  if (rhs.exec_args < lhs.exec_args)
    return false;
  if (lhs.port < rhs.port)
    return true;
  if (rhs.port < lhs.port)
    return false;
  if (lhs.url_loader_factory < rhs.url_loader_factory)
    return true;
  if (rhs.url_loader_factory < lhs.url_loader_factory)
    return false;
  if (lhs.host_resolver < rhs.host_resolver)
    return true;
  if (rhs.host_resolver < lhs.host_resolver)
    return false;
  return false;
}


}  // node::mojom

namespace mojo {


template <>
struct  StructTraits<::node::mojom::NodeServiceParams::DataView,
                                         ::node::mojom::NodeServiceParamsPtr> {
  static bool IsNull(const ::node::mojom::NodeServiceParamsPtr& input) { return !input; }
  static void SetToNull(::node::mojom::NodeServiceParamsPtr* output) { output->reset(); }

  static const decltype(::node::mojom::NodeServiceParams::script)& script(
      const ::node::mojom::NodeServiceParamsPtr& input) {
    return input->script;
  }

  static const decltype(::node::mojom::NodeServiceParams::args)& args(
      const ::node::mojom::NodeServiceParamsPtr& input) {
    return input->args;
  }

  static const decltype(::node::mojom::NodeServiceParams::exec_args)& exec_args(
      const ::node::mojom::NodeServiceParamsPtr& input) {
    return input->exec_args;
  }

  static  decltype(::node::mojom::NodeServiceParams::port)& port(
       ::node::mojom::NodeServiceParamsPtr& input) {
    return input->port;
  }

  static  decltype(::node::mojom::NodeServiceParams::url_loader_factory)& url_loader_factory(
       ::node::mojom::NodeServiceParamsPtr& input) {
    return input->url_loader_factory;
  }

  static  decltype(::node::mojom::NodeServiceParams::host_resolver)& host_resolver(
       ::node::mojom::NodeServiceParamsPtr& input) {
    return input->host_resolver;
  }

  static bool Read(::node::mojom::NodeServiceParams::DataView input, ::node::mojom::NodeServiceParamsPtr* output);
};

}  // namespace mojo

#endif  // ELECTRON_SHELL_SERVICES_NODE_PUBLIC_MOJOM_NODE_SERVICE_MOJOM_H_