// media/midi/midi_service.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef MEDIA_MIDI_MIDI_SERVICE_MOJOM_SHARED_H_
#define MEDIA_MIDI_MIDI_SERVICE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "media/midi/midi_service.mojom-shared-internal.h"
#include "mojo/public/mojom/base/time.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"






namespace midi::mojom {
class PortInfoDataView;



}  // midi::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::midi::mojom::PortInfoDataView> {
  using Data = ::midi::mojom::internal::PortInfo_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace midi::mojom {


enum class Result : int32_t {
  
  NOT_INITIALIZED = 0,
  
  OK = 1,
  
  NOT_SUPPORTED = 2,
  
  INITIALIZATION_ERROR = 3,
  kMinValue = 0,
  kMaxValue = 3,
};

 std::ostream& operator<<(std::ostream& os, Result value);
inline bool IsKnownEnumValue(Result value) {
  return internal::Result_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class PortState : int32_t {
  
  DISCONNECTED = 0,
  
  CONNECTED = 1,
  
  OPENED = 2,
  kMinValue = 0,
  kMaxValue = 2,
};

 std::ostream& operator<<(std::ostream& os, PortState value);
inline bool IsKnownEnumValue(PortState value) {
  return internal::PortState_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class MidiSessionClientInterfaceBase {};

using MidiSessionClientPtrDataView =
    mojo::InterfacePtrDataView<MidiSessionClientInterfaceBase>;
using MidiSessionClientRequestDataView =
    mojo::InterfaceRequestDataView<MidiSessionClientInterfaceBase>;
using MidiSessionClientAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<MidiSessionClientInterfaceBase>;
using MidiSessionClientAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<MidiSessionClientInterfaceBase>;
class MidiSessionProviderInterfaceBase {};

using MidiSessionProviderPtrDataView =
    mojo::InterfacePtrDataView<MidiSessionProviderInterfaceBase>;
using MidiSessionProviderRequestDataView =
    mojo::InterfaceRequestDataView<MidiSessionProviderInterfaceBase>;
using MidiSessionProviderAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<MidiSessionProviderInterfaceBase>;
using MidiSessionProviderAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<MidiSessionProviderInterfaceBase>;
class MidiSessionInterfaceBase {};

using MidiSessionPtrDataView =
    mojo::InterfacePtrDataView<MidiSessionInterfaceBase>;
using MidiSessionRequestDataView =
    mojo::InterfaceRequestDataView<MidiSessionInterfaceBase>;
using MidiSessionAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<MidiSessionInterfaceBase>;
using MidiSessionAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<MidiSessionInterfaceBase>;


class PortInfoDataView {
 public:
  PortInfoDataView() = default;

  PortInfoDataView(
      internal::PortInfo_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadId(UserType* output) {
    
    auto* pointer = data_->id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetManufacturerDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadManufacturer(UserType* output) {
    
    auto* pointer = data_->manufacturer.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetNameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadName(UserType* output) {
    
    auto* pointer = data_->name.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetVersionDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadVersion(UserType* output) {
    
    auto* pointer = data_->version.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  template <typename UserType>
  [[nodiscard]] bool ReadState(UserType* output) const {
    auto data_value = data_->state;
    return mojo::internal::Deserialize<::midi::mojom::PortState>(
        data_value, output);
  }
  PortState state() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::midi::mojom::PortState>(data_->state));
  }
 private:
  internal::PortInfo_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


}  // midi::mojom

namespace std {

template <>
struct hash<::midi::mojom::Result>
    : public mojo::internal::EnumHashImpl<::midi::mojom::Result> {};

template <>
struct hash<::midi::mojom::PortState>
    : public mojo::internal::EnumHashImpl<::midi::mojom::PortState> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::midi::mojom::Result, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::midi::mojom::Result, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::midi::mojom::Result>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::midi::mojom::PortState, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::midi::mojom::PortState, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::midi::mojom::PortState>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::midi::mojom::PortInfoDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::midi::mojom::PortInfoDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::midi::mojom::internal::PortInfo_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::id(input)) in_id = Traits::id(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->id)::BaseType> id_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_id, id_fragment);
    fragment->id.Set(
        id_fragment.is_null() ? nullptr : id_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->id.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null id in PortInfo struct");
    decltype(Traits::manufacturer(input)) in_manufacturer = Traits::manufacturer(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->manufacturer)::BaseType> manufacturer_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_manufacturer, manufacturer_fragment);
    fragment->manufacturer.Set(
        manufacturer_fragment.is_null() ? nullptr : manufacturer_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->manufacturer.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null manufacturer in PortInfo struct");
    decltype(Traits::name(input)) in_name = Traits::name(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->name)::BaseType> name_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_name, name_fragment);
    fragment->name.Set(
        name_fragment.is_null() ? nullptr : name_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->name.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null name in PortInfo struct");
    decltype(Traits::version(input)) in_version = Traits::version(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->version)::BaseType> version_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_version, version_fragment);
    fragment->version.Set(
        version_fragment.is_null() ? nullptr : version_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->version.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null version in PortInfo struct");
    mojo::internal::Serialize<::midi::mojom::PortState>(
        Traits::state(input), &fragment->state);
  }

  static bool Deserialize(::midi::mojom::internal::PortInfo_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::midi::mojom::PortInfoDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace midi::mojom {

inline void PortInfoDataView::GetIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->id.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void PortInfoDataView::GetManufacturerDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->manufacturer.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void PortInfoDataView::GetNameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->name.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void PortInfoDataView::GetVersionDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->version.Get();
  *output = mojo::StringDataView(pointer, message_);
}



}  // midi::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct  TraceFormatTraits<::midi::mojom::Result> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::midi::mojom::Result value);
};

} // namespace perfetto

namespace perfetto {

template <>
struct  TraceFormatTraits<::midi::mojom::PortState> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::midi::mojom::PortState value);
};

} // namespace perfetto

#endif  // MEDIA_MIDI_MIDI_SERVICE_MOJOM_SHARED_H_