// services/network/public/mojom/attribution.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "services/network/public/mojom/attribution.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/debug/alias.h"
#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/thread_pool/thread_pool_instance.h"
#include "base/trace_event/trace_event.h"
#include "base/trace_event/typed_macros.h"
#include "mojo/public/cpp/bindings/lib/default_construct_tag_internal.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/send_message_helper.h"
#include "mojo/public/cpp/bindings/lib/proxy_to_responder.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#include "mojo/public/cpp/bindings/urgent_message_scope.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "services/network/public/mojom/attribution.mojom-params-data.h"
#include "services/network/public/mojom/attribution.mojom-shared-message-ids.h"

#include "services/network/public/mojom/attribution.mojom-import-headers.h"
#include "services/network/public/mojom/attribution.mojom-test-utils.h"


namespace network::mojom {
TriggerVerification::TriggerVerification()
    : token(),
      aggregatable_report_id() {}

TriggerVerification::TriggerVerification(
    const std::string& token_in,
    const std::string& aggregatable_report_id_in)
    : token(std::move(token_in)),
      aggregatable_report_id(std::move(aggregatable_report_id_in)) {}

TriggerVerification::~TriggerVerification() = default;

void TriggerVerification::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "token"), this->token,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::string&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "aggregatable_report_id"), this->aggregatable_report_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::string&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool TriggerVerification::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
AttributionReportingRuntimeFeatures::AttributionReportingRuntimeFeatures()
    : cross_app_web_enabled() {}

AttributionReportingRuntimeFeatures::AttributionReportingRuntimeFeatures(
    bool cross_app_web_enabled_in)
    : cross_app_web_enabled(std::move(cross_app_web_enabled_in)) {}

AttributionReportingRuntimeFeatures::~AttributionReportingRuntimeFeatures() = default;

void AttributionReportingRuntimeFeatures::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "cross_app_web_enabled"), this->cross_app_web_enabled,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type bool>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool AttributionReportingRuntimeFeatures::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}


}  // network::mojom


namespace mojo {


// static
bool StructTraits<::network::mojom::TriggerVerification::DataView, ::network::mojom::TriggerVerificationPtr>::Read(
    ::network::mojom::TriggerVerification::DataView input,
    ::network::mojom::TriggerVerificationPtr* output) {
  bool success = true;
  ::network::mojom::TriggerVerificationPtr result(::network::mojom::TriggerVerification::New());
  
      if (success && !input.ReadToken(&result->token))
        success = false;
      if (success && !input.ReadAggregatableReportId(&result->aggregatable_report_id))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::network::mojom::AttributionReportingRuntimeFeatures::DataView, ::network::mojom::AttributionReportingRuntimeFeaturesPtr>::Read(
    ::network::mojom::AttributionReportingRuntimeFeatures::DataView input,
    ::network::mojom::AttributionReportingRuntimeFeaturesPtr* output) {
  bool success = true;
  ::network::mojom::AttributionReportingRuntimeFeaturesPtr result(::network::mojom::AttributionReportingRuntimeFeatures::New());
  
      if (success)
        result->cross_app_web_enabled = input.cross_app_web_enabled();
  *output = std::move(result);
  return success;
}

}  // namespace mojo


// Symbols declared in the -test-utils.h header are defined here instead of a
// separate .cc file to save compile time.


namespace network::mojom {




}  // network::mojom


#if defined(__clang__)
#pragma clang diagnostic pop
#endif