// services/network/public/mojom/attribution.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_ATTRIBUTION_MOJOM_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_ATTRIBUTION_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include <optional>
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/network/public/mojom/attribution.mojom-features.h"
#include "services/network/public/mojom/attribution.mojom-shared.h"
#include "services/network/public/mojom/attribution.mojom-forward.h"
#include <string>
#include <vector>




#include "services/network/public/cpp/attribution_mojom_traits.h"




namespace network::mojom {





class  TriggerVerification {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<TriggerVerification, T>::value>;
  using DataView = TriggerVerificationDataView;
  using Data_ = internal::TriggerVerification_Data;

  template <typename... Args>
  static TriggerVerificationPtr New(Args&&... args) {
    return TriggerVerificationPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static TriggerVerificationPtr From(const U& u) {
    return mojo::TypeConverter<TriggerVerificationPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, TriggerVerification>::Convert(*this);
  }


  TriggerVerification();

  TriggerVerification(
      const std::string& token,
      const std::string& aggregatable_report_id);


  ~TriggerVerification();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = TriggerVerificationPtr>
  TriggerVerificationPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, TriggerVerification::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, TriggerVerification::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, TriggerVerification::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        TriggerVerification::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        TriggerVerification::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::TriggerVerification_UnserializedMessageContext<
            UserType, TriggerVerification::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<TriggerVerification::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return TriggerVerification::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::TriggerVerification_UnserializedMessageContext<
            UserType, TriggerVerification::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<TriggerVerification::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string token;
  
  std::string aggregatable_report_id;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, TriggerVerification::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, TriggerVerification::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, TriggerVerification::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, TriggerVerification::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  AttributionReportingRuntimeFeatures {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AttributionReportingRuntimeFeatures, T>::value>;
  using DataView = AttributionReportingRuntimeFeaturesDataView;
  using Data_ = internal::AttributionReportingRuntimeFeatures_Data;

  template <typename... Args>
  static AttributionReportingRuntimeFeaturesPtr New(Args&&... args) {
    return AttributionReportingRuntimeFeaturesPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AttributionReportingRuntimeFeaturesPtr From(const U& u) {
    return mojo::TypeConverter<AttributionReportingRuntimeFeaturesPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AttributionReportingRuntimeFeatures>::Convert(*this);
  }


  AttributionReportingRuntimeFeatures();

  explicit AttributionReportingRuntimeFeatures(
      bool cross_app_web_enabled);


  ~AttributionReportingRuntimeFeatures();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AttributionReportingRuntimeFeaturesPtr>
  AttributionReportingRuntimeFeaturesPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AttributionReportingRuntimeFeatures::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AttributionReportingRuntimeFeatures::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, AttributionReportingRuntimeFeatures::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AttributionReportingRuntimeFeatures::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AttributionReportingRuntimeFeatures::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AttributionReportingRuntimeFeatures_UnserializedMessageContext<
            UserType, AttributionReportingRuntimeFeatures::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AttributionReportingRuntimeFeatures::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return AttributionReportingRuntimeFeatures::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AttributionReportingRuntimeFeatures_UnserializedMessageContext<
            UserType, AttributionReportingRuntimeFeatures::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AttributionReportingRuntimeFeatures::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  bool cross_app_web_enabled;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AttributionReportingRuntimeFeatures::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AttributionReportingRuntimeFeatures::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AttributionReportingRuntimeFeatures::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AttributionReportingRuntimeFeatures::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





template <typename StructPtrType>
TriggerVerificationPtr TriggerVerification::Clone() const {
  return New(
      mojo::Clone(token),
      mojo::Clone(aggregatable_report_id)
  );
}

template <typename T, TriggerVerification::EnableIfSame<T>*>
bool TriggerVerification::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->token, other_struct.token))
    return false;
  if (!mojo::Equals(this->aggregatable_report_id, other_struct.aggregatable_report_id))
    return false;
  return true;
}

template <typename T, TriggerVerification::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.token < rhs.token)
    return true;
  if (rhs.token < lhs.token)
    return false;
  if (lhs.aggregatable_report_id < rhs.aggregatable_report_id)
    return true;
  if (rhs.aggregatable_report_id < lhs.aggregatable_report_id)
    return false;
  return false;
}
template <typename StructPtrType>
AttributionReportingRuntimeFeaturesPtr AttributionReportingRuntimeFeatures::Clone() const {
  return New(
      mojo::Clone(cross_app_web_enabled)
  );
}

template <typename T, AttributionReportingRuntimeFeatures::EnableIfSame<T>*>
bool AttributionReportingRuntimeFeatures::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->cross_app_web_enabled, other_struct.cross_app_web_enabled))
    return false;
  return true;
}

template <typename T, AttributionReportingRuntimeFeatures::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.cross_app_web_enabled < rhs.cross_app_web_enabled)
    return true;
  if (rhs.cross_app_web_enabled < lhs.cross_app_web_enabled)
    return false;
  return false;
}


}  // network::mojom

namespace mojo {


template <>
struct  StructTraits<::network::mojom::TriggerVerification::DataView,
                                         ::network::mojom::TriggerVerificationPtr> {
  static bool IsNull(const ::network::mojom::TriggerVerificationPtr& input) { return !input; }
  static void SetToNull(::network::mojom::TriggerVerificationPtr* output) { output->reset(); }

  static const decltype(::network::mojom::TriggerVerification::token)& token(
      const ::network::mojom::TriggerVerificationPtr& input) {
    return input->token;
  }

  static const decltype(::network::mojom::TriggerVerification::aggregatable_report_id)& aggregatable_report_id(
      const ::network::mojom::TriggerVerificationPtr& input) {
    return input->aggregatable_report_id;
  }

  static bool Read(::network::mojom::TriggerVerification::DataView input, ::network::mojom::TriggerVerificationPtr* output);
};


template <>
struct  StructTraits<::network::mojom::AttributionReportingRuntimeFeatures::DataView,
                                         ::network::mojom::AttributionReportingRuntimeFeaturesPtr> {
  static bool IsNull(const ::network::mojom::AttributionReportingRuntimeFeaturesPtr& input) { return !input; }
  static void SetToNull(::network::mojom::AttributionReportingRuntimeFeaturesPtr* output) { output->reset(); }

  static decltype(::network::mojom::AttributionReportingRuntimeFeatures::cross_app_web_enabled) cross_app_web_enabled(
      const ::network::mojom::AttributionReportingRuntimeFeaturesPtr& input) {
    return input->cross_app_web_enabled;
  }

  static bool Read(::network::mojom::AttributionReportingRuntimeFeatures::DataView input, ::network::mojom::AttributionReportingRuntimeFeaturesPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_ATTRIBUTION_MOJOM_H_