// services/network/public/mojom/shared_dictionary_access_observer.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_SHARED_DICTIONARY_ACCESS_OBSERVER_MOJOM_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_SHARED_DICTIONARY_ACCESS_OBSERVER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include <optional>
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/network/public/mojom/shared_dictionary_access_observer.mojom-features.h"
#include "services/network/public/mojom/shared_dictionary_access_observer.mojom-shared.h"
#include "services/network/public/mojom/shared_dictionary_access_observer.mojom-forward.h"
#include "services/network/public/mojom/shared_dictionary_isolation_key.mojom.h"
#include "url/mojom/origin.mojom-forward.h"
#include "url/mojom/url.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"






namespace network::mojom {

class SharedDictionaryAccessObserverProxy;

template <typename ImplRefTraits>
class SharedDictionaryAccessObserverStub;

class SharedDictionaryAccessObserverRequestValidator;


class SharedDictionaryAccessObserver
    : public SharedDictionaryAccessObserverInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = SharedDictionaryAccessObserverInterfaceBase;
  using Proxy_ = SharedDictionaryAccessObserverProxy;

  template <typename ImplRefTraits>
  using Stub_ = SharedDictionaryAccessObserverStub<ImplRefTraits>;

  using RequestValidator_ = SharedDictionaryAccessObserverRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnSharedDictionaryAccessedMinVersion = 0,
    kCloneMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct OnSharedDictionaryAccessed_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct Clone_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~SharedDictionaryAccessObserver() = default;

  
  virtual void OnSharedDictionaryAccessed(SharedDictionaryAccessDetailsPtr details) = 0;

  
  virtual void Clone(::mojo::PendingReceiver<SharedDictionaryAccessObserver> observer) = 0;
};



class  SharedDictionaryAccessObserverProxy
    : public SharedDictionaryAccessObserver {
 public:
  using InterfaceType = SharedDictionaryAccessObserver;

  explicit SharedDictionaryAccessObserverProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void OnSharedDictionaryAccessed(SharedDictionaryAccessDetailsPtr details) final;
  
  void Clone(::mojo::PendingReceiver<SharedDictionaryAccessObserver> observer) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  SharedDictionaryAccessObserverStubDispatch {
 public:
  static bool Accept(SharedDictionaryAccessObserver* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      SharedDictionaryAccessObserver* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<SharedDictionaryAccessObserver>>
class SharedDictionaryAccessObserverStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  SharedDictionaryAccessObserverStub() = default;
  ~SharedDictionaryAccessObserverStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SharedDictionaryAccessObserverStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SharedDictionaryAccessObserverStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  SharedDictionaryAccessObserverRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};








class  SharedDictionaryAccessDetails {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<SharedDictionaryAccessDetails, T>::value>;
  using DataView = SharedDictionaryAccessDetailsDataView;
  using Data_ = internal::SharedDictionaryAccessDetails_Data;
  using Type = SharedDictionaryAccessDetails_Type;

  template <typename... Args>
  static SharedDictionaryAccessDetailsPtr New(Args&&... args) {
    return SharedDictionaryAccessDetailsPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static SharedDictionaryAccessDetailsPtr From(const U& u) {
    return mojo::TypeConverter<SharedDictionaryAccessDetailsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, SharedDictionaryAccessDetails>::Convert(*this);
  }


  SharedDictionaryAccessDetails();

  SharedDictionaryAccessDetails(
      SharedDictionaryAccessDetails::Type type,
      const ::GURL& url,
      const ::net::SharedDictionaryIsolationKey& isolation_key,
      bool is_blocked);


  ~SharedDictionaryAccessDetails();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = SharedDictionaryAccessDetailsPtr>
  SharedDictionaryAccessDetailsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, SharedDictionaryAccessDetails::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, SharedDictionaryAccessDetails::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, SharedDictionaryAccessDetails::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        SharedDictionaryAccessDetails::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        SharedDictionaryAccessDetails::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::SharedDictionaryAccessDetails_UnserializedMessageContext<
            UserType, SharedDictionaryAccessDetails::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<SharedDictionaryAccessDetails::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return SharedDictionaryAccessDetails::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::SharedDictionaryAccessDetails_UnserializedMessageContext<
            UserType, SharedDictionaryAccessDetails::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<SharedDictionaryAccessDetails::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  SharedDictionaryAccessDetails::Type type;
  
  ::GURL url;
  
  ::net::SharedDictionaryIsolationKey isolation_key;
  
  bool is_blocked;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, SharedDictionaryAccessDetails::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, SharedDictionaryAccessDetails::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, SharedDictionaryAccessDetails::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, SharedDictionaryAccessDetails::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
SharedDictionaryAccessDetailsPtr SharedDictionaryAccessDetails::Clone() const {
  return New(
      mojo::Clone(type),
      mojo::Clone(url),
      mojo::Clone(isolation_key),
      mojo::Clone(is_blocked)
  );
}

template <typename T, SharedDictionaryAccessDetails::EnableIfSame<T>*>
bool SharedDictionaryAccessDetails::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->type, other_struct.type))
    return false;
  if (!mojo::Equals(this->url, other_struct.url))
    return false;
  if (!mojo::Equals(this->isolation_key, other_struct.isolation_key))
    return false;
  if (!mojo::Equals(this->is_blocked, other_struct.is_blocked))
    return false;
  return true;
}

template <typename T, SharedDictionaryAccessDetails::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.type < rhs.type)
    return true;
  if (rhs.type < lhs.type)
    return false;
  if (lhs.url < rhs.url)
    return true;
  if (rhs.url < lhs.url)
    return false;
  if (lhs.isolation_key < rhs.isolation_key)
    return true;
  if (rhs.isolation_key < lhs.isolation_key)
    return false;
  if (lhs.is_blocked < rhs.is_blocked)
    return true;
  if (rhs.is_blocked < lhs.is_blocked)
    return false;
  return false;
}


}  // network::mojom

namespace mojo {


template <>
struct  StructTraits<::network::mojom::SharedDictionaryAccessDetails::DataView,
                                         ::network::mojom::SharedDictionaryAccessDetailsPtr> {
  static bool IsNull(const ::network::mojom::SharedDictionaryAccessDetailsPtr& input) { return !input; }
  static void SetToNull(::network::mojom::SharedDictionaryAccessDetailsPtr* output) { output->reset(); }

  static decltype(::network::mojom::SharedDictionaryAccessDetails::type) type(
      const ::network::mojom::SharedDictionaryAccessDetailsPtr& input) {
    return input->type;
  }

  static const decltype(::network::mojom::SharedDictionaryAccessDetails::url)& url(
      const ::network::mojom::SharedDictionaryAccessDetailsPtr& input) {
    return input->url;
  }

  static const decltype(::network::mojom::SharedDictionaryAccessDetails::isolation_key)& isolation_key(
      const ::network::mojom::SharedDictionaryAccessDetailsPtr& input) {
    return input->isolation_key;
  }

  static decltype(::network::mojom::SharedDictionaryAccessDetails::is_blocked) is_blocked(
      const ::network::mojom::SharedDictionaryAccessDetailsPtr& input) {
    return input->is_blocked;
  }

  static bool Read(::network::mojom::SharedDictionaryAccessDetails::DataView input, ::network::mojom::SharedDictionaryAccessDetailsPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_SHARED_DICTIONARY_ACCESS_OBSERVER_MOJOM_H_