// services/webnn/public/mojom/webnn_context_provider.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_CONTEXT_PROVIDER_MOJOM_BLINK_H_
#define SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_CONTEXT_PROVIDER_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include <optional>
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/webnn/public/mojom/webnn_context_provider.mojom-features.h"
#include "services/webnn/public/mojom/webnn_context_provider.mojom-shared.h"
#include "services/webnn/public/mojom/webnn_context_provider.mojom-blink-forward.h"
#include "components/ml/webnn/features.mojom-blink-forward.h"
#include "services/webnn/public/mojom/webnn_error.mojom-blink.h"
#include "services/webnn/public/mojom/webnn_graph.mojom-blink-forward.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"






namespace webnn::mojom::blink {

class WebNNContextProxy;

template <typename ImplRefTraits>
class WebNNContextStub;

class WebNNContextRequestValidator;
class WebNNContextResponseValidator;


class WebNNContext
    : public WebNNContextInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static bool RuntimeFeature_IsEnabled_(bool expected);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static inline constexpr uint32_t kSyncMethodOrdinals[] = {
    922028900
  };
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = WebNNContextInterfaceBase;
  using Proxy_ = WebNNContextProxy;

  template <typename ImplRefTraits>
  using Stub_ = WebNNContextStub<ImplRefTraits>;

  using RequestValidator_ = WebNNContextRequestValidator;
  using ResponseValidator_ = WebNNContextResponseValidator;
  enum MethodMinVersions : uint32_t {
    kCreateGraphMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct CreateGraph_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~WebNNContext() = default;

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  
  virtual bool CreateGraph(::webnn::mojom::blink::GraphInfoPtr graph_info, CreateGraphResultPtr* out_result);

  using CreateGraphCallback = base::OnceCallback<void(CreateGraphResultPtr)>;
  
  virtual void CreateGraph(::webnn::mojom::blink::GraphInfoPtr graph_info, CreateGraphCallback callback) = 0;
};

class WebNNContextProviderProxy;

template <typename ImplRefTraits>
class WebNNContextProviderStub;

class WebNNContextProviderRequestValidator;
class WebNNContextProviderResponseValidator;


class WebNNContextProvider
    : public WebNNContextProviderInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static bool RuntimeFeature_IsEnabled_(bool expected);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static inline constexpr uint32_t kSyncMethodOrdinals[] = {
    1905451944
  };
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = WebNNContextProviderInterfaceBase;
  using Proxy_ = WebNNContextProviderProxy;

  template <typename ImplRefTraits>
  using Stub_ = WebNNContextProviderStub<ImplRefTraits>;

  using RequestValidator_ = WebNNContextProviderRequestValidator;
  using ResponseValidator_ = WebNNContextProviderResponseValidator;
  enum MethodMinVersions : uint32_t {
    kCreateWebNNContextMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct CreateWebNNContext_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~WebNNContextProvider() = default;

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  
  virtual bool CreateWebNNContext(CreateContextOptionsPtr options, CreateContextResultPtr* out_result);

  using CreateWebNNContextCallback = base::OnceCallback<void(CreateContextResultPtr)>;
  
  virtual void CreateWebNNContext(CreateContextOptionsPtr options, CreateWebNNContextCallback callback) = 0;
};



class  WebNNContextProxy
    : public WebNNContext {
 public:
  using InterfaceType = WebNNContext;

  explicit WebNNContextProxy(mojo::MessageReceiverWithResponder* receiver);
  
  bool CreateGraph(::webnn::mojom::blink::GraphInfoPtr graph_info, CreateGraphResultPtr* out_result) final;
  
  void CreateGraph(::webnn::mojom::blink::GraphInfoPtr graph_info, CreateGraphCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  WebNNContextProviderProxy
    : public WebNNContextProvider {
 public:
  using InterfaceType = WebNNContextProvider;

  explicit WebNNContextProviderProxy(mojo::MessageReceiverWithResponder* receiver);
  
  bool CreateWebNNContext(CreateContextOptionsPtr options, CreateContextResultPtr* out_result) final;
  
  void CreateWebNNContext(CreateContextOptionsPtr options, CreateWebNNContextCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  WebNNContextStubDispatch {
 public:
  static bool Accept(WebNNContext* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      WebNNContext* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<WebNNContext>>
class WebNNContextStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  WebNNContextStub() = default;
  ~WebNNContextStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebNNContextStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebNNContextStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  WebNNContextProviderStubDispatch {
 public:
  static bool Accept(WebNNContextProvider* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      WebNNContextProvider* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<WebNNContextProvider>>
class WebNNContextProviderStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  WebNNContextProviderStub() = default;
  ~WebNNContextProviderStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebNNContextProviderStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebNNContextProviderStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  WebNNContextRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  WebNNContextProviderRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  WebNNContextResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  WebNNContextProviderResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class  CreateContextOptions {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<CreateContextOptions, T>::value>;
  using DataView = CreateContextOptionsDataView;
  using Data_ = internal::CreateContextOptions_Data;

  template <typename... Args>
  static CreateContextOptionsPtr New(Args&&... args) {
    return CreateContextOptionsPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static CreateContextOptionsPtr From(const U& u) {
    return mojo::TypeConverter<CreateContextOptionsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, CreateContextOptions>::Convert(*this);
  }


  CreateContextOptions();

  explicit CreateContextOptions(
      PowerPreference power_preference);


  ~CreateContextOptions();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = CreateContextOptionsPtr>
  CreateContextOptionsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, CreateContextOptions::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, CreateContextOptions::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, CreateContextOptions::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        CreateContextOptions::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        CreateContextOptions::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::CreateContextOptions_UnserializedMessageContext<
            UserType, CreateContextOptions::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<CreateContextOptions::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return CreateContextOptions::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::CreateContextOptions_UnserializedMessageContext<
            UserType, CreateContextOptions::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<CreateContextOptions::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  PowerPreference power_preference;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, CreateContextOptions::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, CreateContextOptions::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, CreateContextOptions::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, CreateContextOptions::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  CreateGraphResult {
 public:
  using DataView = CreateGraphResultDataView;
  using Data_ = internal::CreateGraphResult_Data;
  using Tag = Data_::CreateGraphResult_Tag;

  template <typename... Args>
  static CreateGraphResultPtr New(Args&&... args) {
    static_assert(
        sizeof...(args) < 0,
        "Do not use Union::New(); to create a union of a given subtype, use "
        "New<SubType>(), not New() followed by set_<sub_type>(). To represent "
        "an empty union, mark the field or parameter as nullable in the mojom "
        "definition.");
    return nullptr;
  }
  // Construct an instance holding |graph_remote|.
  static CreateGraphResultPtr
  NewGraphRemote(
      ::mojo::PendingRemote<::webnn::mojom::blink::WebNNGraph> value) {
    auto result = CreateGraphResultPtr(absl::in_place);
    result->set_graph_remote(std::move(value));
    return result;
  }
  // Construct an instance holding |error|.
  static CreateGraphResultPtr
  NewError(
      ::webnn::mojom::blink::ErrorPtr value) {
    auto result = CreateGraphResultPtr(absl::in_place);
    result->set_error(std::move(value));
    return result;
  }

  template <typename U>
  static CreateGraphResultPtr From(const U& u) {
    return mojo::TypeConverter<CreateGraphResultPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, CreateGraphResult>::Convert(*this);
  }

  CreateGraphResult();
  ~CreateGraphResult();
  // Delete the copy constructor and copy assignment operators because `data_`
  // contains raw pointers that must not be copied.
  CreateGraphResult(const CreateGraphResult& other) = delete;
  CreateGraphResult& operator=(const CreateGraphResult& other) = delete;

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = CreateGraphResultPtr>
  CreateGraphResultPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, CreateGraphResult>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename T,
            typename std::enable_if<std::is_same<
                T, CreateGraphResult>::value>::type* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  Tag which() const {
    return tag_;
  }


  
  bool is_graph_remote() const { return tag_ == Tag::kGraphRemote; }

  
  ::mojo::PendingRemote<::webnn::mojom::blink::WebNNGraph>& get_graph_remote() const {
    CHECK(tag_ == Tag::kGraphRemote);
    return *(data_.graph_remote);
  }

  
  void set_graph_remote(
      ::mojo::PendingRemote<::webnn::mojom::blink::WebNNGraph> graph_remote);
  
  bool is_error() const { return tag_ == Tag::kError; }

  
  ::webnn::mojom::blink::ErrorPtr& get_error() const {
    CHECK(tag_ == Tag::kError);
    return *(data_.error);
  }

  
  void set_error(
      ::webnn::mojom::blink::ErrorPtr error);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        CreateGraphResult::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<CreateGraphResult::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

 private:
  union Union_ {
    Union_() = default;
    ~Union_() = default;
    ::mojo::PendingRemote<::webnn::mojom::blink::WebNNGraph>* graph_remote;
    ::webnn::mojom::blink::ErrorPtr* error;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};



class  CreateContextResult {
 public:
  using DataView = CreateContextResultDataView;
  using Data_ = internal::CreateContextResult_Data;
  using Tag = Data_::CreateContextResult_Tag;

  template <typename... Args>
  static CreateContextResultPtr New(Args&&... args) {
    static_assert(
        sizeof...(args) < 0,
        "Do not use Union::New(); to create a union of a given subtype, use "
        "New<SubType>(), not New() followed by set_<sub_type>(). To represent "
        "an empty union, mark the field or parameter as nullable in the mojom "
        "definition.");
    return nullptr;
  }
  // Construct an instance holding |context_remote|.
  static CreateContextResultPtr
  NewContextRemote(
      ::mojo::PendingRemote<WebNNContext> value) {
    auto result = CreateContextResultPtr(absl::in_place);
    result->set_context_remote(std::move(value));
    return result;
  }
  // Construct an instance holding |error|.
  static CreateContextResultPtr
  NewError(
      ::webnn::mojom::blink::ErrorPtr value) {
    auto result = CreateContextResultPtr(absl::in_place);
    result->set_error(std::move(value));
    return result;
  }

  template <typename U>
  static CreateContextResultPtr From(const U& u) {
    return mojo::TypeConverter<CreateContextResultPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, CreateContextResult>::Convert(*this);
  }

  CreateContextResult();
  ~CreateContextResult();
  // Delete the copy constructor and copy assignment operators because `data_`
  // contains raw pointers that must not be copied.
  CreateContextResult(const CreateContextResult& other) = delete;
  CreateContextResult& operator=(const CreateContextResult& other) = delete;

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = CreateContextResultPtr>
  CreateContextResultPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, CreateContextResult>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename T,
            typename std::enable_if<std::is_same<
                T, CreateContextResult>::value>::type* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  Tag which() const {
    return tag_;
  }


  
  bool is_context_remote() const { return tag_ == Tag::kContextRemote; }

  
  ::mojo::PendingRemote<WebNNContext>& get_context_remote() const {
    CHECK(tag_ == Tag::kContextRemote);
    return *(data_.context_remote);
  }

  
  void set_context_remote(
      ::mojo::PendingRemote<WebNNContext> context_remote);
  
  bool is_error() const { return tag_ == Tag::kError; }

  
  ::webnn::mojom::blink::ErrorPtr& get_error() const {
    CHECK(tag_ == Tag::kError);
    return *(data_.error);
  }

  
  void set_error(
      ::webnn::mojom::blink::ErrorPtr error);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        CreateContextResult::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<CreateContextResult::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

 private:
  union Union_ {
    Union_() = default;
    ~Union_() = default;
    ::mojo::PendingRemote<WebNNContext>* context_remote;
    ::webnn::mojom::blink::ErrorPtr* error;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};


template <typename UnionPtrType>
CreateGraphResultPtr CreateGraphResult::Clone() const {
  switch (tag_) {
    case Tag::kGraphRemote:
      return NewGraphRemote(
          mojo::Clone(*data_.graph_remote));
    case Tag::kError:
      return NewError(
          mojo::Clone(*data_.error));
  }
  return nullptr;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, CreateGraphResult>::value>::type*>
bool CreateGraphResult::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::kGraphRemote:
      return mojo::Equals(*(data_.graph_remote), *(other.data_.graph_remote));
    case Tag::kError:
      return mojo::Equals(*(data_.error), *(other.data_.error));
  }

  return false;
}
template <typename UnionPtrType>
CreateContextResultPtr CreateContextResult::Clone() const {
  switch (tag_) {
    case Tag::kContextRemote:
      return NewContextRemote(
          mojo::Clone(*data_.context_remote));
    case Tag::kError:
      return NewError(
          mojo::Clone(*data_.error));
  }
  return nullptr;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, CreateContextResult>::value>::type*>
bool CreateContextResult::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::kContextRemote:
      return mojo::Equals(*(data_.context_remote), *(other.data_.context_remote));
    case Tag::kError:
      return mojo::Equals(*(data_.error), *(other.data_.error));
  }

  return false;
}
template <typename StructPtrType>
CreateContextOptionsPtr CreateContextOptions::Clone() const {
  return New(
      mojo::Clone(power_preference)
  );
}

template <typename T, CreateContextOptions::EnableIfSame<T>*>
bool CreateContextOptions::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->power_preference, other_struct.power_preference))
    return false;
  return true;
}

template <typename T, CreateContextOptions::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.power_preference < rhs.power_preference)
    return true;
  if (rhs.power_preference < lhs.power_preference)
    return false;
  return false;
}


}  // webnn::mojom::blink

namespace mojo {


template <>
struct  StructTraits<::webnn::mojom::blink::CreateContextOptions::DataView,
                                         ::webnn::mojom::blink::CreateContextOptionsPtr> {
  static bool IsNull(const ::webnn::mojom::blink::CreateContextOptionsPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::CreateContextOptionsPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::CreateContextOptions::power_preference) power_preference(
      const ::webnn::mojom::blink::CreateContextOptionsPtr& input) {
    return input->power_preference;
  }

  static bool Read(::webnn::mojom::blink::CreateContextOptions::DataView input, ::webnn::mojom::blink::CreateContextOptionsPtr* output);
};


template <>
struct  UnionTraits<::webnn::mojom::blink::CreateGraphResult::DataView,
                                        ::webnn::mojom::blink::CreateGraphResultPtr> {
  static bool IsNull(const ::webnn::mojom::blink::CreateGraphResultPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::CreateGraphResultPtr* output) { output->reset(); }

  static ::webnn::mojom::blink::CreateGraphResult::Tag GetTag(const ::webnn::mojom::blink::CreateGraphResultPtr& input) {
    return input->which();
  }

  static  ::mojo::PendingRemote<::webnn::mojom::blink::WebNNGraph>& graph_remote( ::webnn::mojom::blink::CreateGraphResultPtr& input) {
    return input->get_graph_remote();
  }

  static const ::webnn::mojom::blink::ErrorPtr& error(const ::webnn::mojom::blink::CreateGraphResultPtr& input) {
    return input->get_error();
  }

  static bool Read(::webnn::mojom::blink::CreateGraphResult::DataView input, ::webnn::mojom::blink::CreateGraphResultPtr* output);
};


template <>
struct  UnionTraits<::webnn::mojom::blink::CreateContextResult::DataView,
                                        ::webnn::mojom::blink::CreateContextResultPtr> {
  static bool IsNull(const ::webnn::mojom::blink::CreateContextResultPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::CreateContextResultPtr* output) { output->reset(); }

  static ::webnn::mojom::blink::CreateContextResult::Tag GetTag(const ::webnn::mojom::blink::CreateContextResultPtr& input) {
    return input->which();
  }

  static  ::mojo::PendingRemote<::webnn::mojom::blink::WebNNContext>& context_remote( ::webnn::mojom::blink::CreateContextResultPtr& input) {
    return input->get_context_remote();
  }

  static const ::webnn::mojom::blink::ErrorPtr& error(const ::webnn::mojom::blink::CreateContextResultPtr& input) {
    return input->get_error();
  }

  static bool Read(::webnn::mojom::blink::CreateContextResult::DataView input, ::webnn::mojom::blink::CreateContextResultPtr* output);
};
namespace internal {
template <>
inline bool GetRuntimeFeature_IsEnabled<::webnn::mojom::blink::WebNNContext>() {
  return ::webnn::mojom::blink::WebNNContext::RuntimeFeature_IsEnabled_(false);
}
template <>
inline bool GetRuntimeFeature_ExpectEnabled<::webnn::mojom::blink::WebNNContext>() {
  return ::webnn::mojom::blink::WebNNContext::RuntimeFeature_IsEnabled_(true);
}template <>
inline constexpr bool kIsRuntimeFeatureGuarded<::webnn::mojom::blink::WebNNContext> = true;
template <>
inline bool GetRuntimeFeature_IsEnabled<::webnn::mojom::blink::WebNNContextProvider>() {
  return ::webnn::mojom::blink::WebNNContextProvider::RuntimeFeature_IsEnabled_(false);
}
template <>
inline bool GetRuntimeFeature_ExpectEnabled<::webnn::mojom::blink::WebNNContextProvider>() {
  return ::webnn::mojom::blink::WebNNContextProvider::RuntimeFeature_IsEnabled_(true);
}template <>
inline constexpr bool kIsRuntimeFeatureGuarded<::webnn::mojom::blink::WebNNContextProvider> = true;
}  // namespace internal

}  // namespace mojo

#endif  // SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_CONTEXT_PROVIDER_MOJOM_BLINK_H_