// third_party/blink/public/mojom/file_system_access/file_system_access_directory_handle.mojom-blink-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FILE_SYSTEM_ACCESS_FILE_SYSTEM_ACCESS_DIRECTORY_HANDLE_MOJOM_BLINK_TEST_UTILS_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FILE_SYSTEM_ACCESS_FILE_SYSTEM_ACCESS_DIRECTORY_HANDLE_MOJOM_BLINK_TEST_UTILS_H_

#include "third_party/blink/public/mojom/file_system_access/file_system_access_directory_handle.mojom-blink.h"
#include "third_party/blink/renderer/platform/platform_export.h"


namespace blink::mojom::blink {


class PLATFORM_EXPORT FileSystemAccessDirectoryEntriesListenerInterceptorForTesting : public FileSystemAccessDirectoryEntriesListener {
  virtual FileSystemAccessDirectoryEntriesListener* GetForwardingInterface() = 0;
  void DidReadDirectory(::blink::mojom::blink::FileSystemAccessErrorPtr result, WTF::Vector<FileSystemAccessEntryPtr> entries, bool has_more_entries) override;
};
class PLATFORM_EXPORT FileSystemAccessDirectoryEntriesListenerAsyncWaiter {
 public:
  explicit FileSystemAccessDirectoryEntriesListenerAsyncWaiter(FileSystemAccessDirectoryEntriesListener* proxy);

  FileSystemAccessDirectoryEntriesListenerAsyncWaiter(const FileSystemAccessDirectoryEntriesListenerAsyncWaiter&) = delete;
  FileSystemAccessDirectoryEntriesListenerAsyncWaiter& operator=(const FileSystemAccessDirectoryEntriesListenerAsyncWaiter&) = delete;

  ~FileSystemAccessDirectoryEntriesListenerAsyncWaiter();

 private:
  FileSystemAccessDirectoryEntriesListener* const proxy_;
};


class PLATFORM_EXPORT FileSystemAccessDirectoryHandleInterceptorForTesting : public FileSystemAccessDirectoryHandle {
  virtual FileSystemAccessDirectoryHandle* GetForwardingInterface() = 0;
  void GetPermissionStatus(bool writable, GetPermissionStatusCallback callback) override;
  void RequestPermission(bool writable, RequestPermissionCallback callback) override;
  void GetFile(const WTF::String& basename, bool create, GetFileCallback callback) override;
  void GetDirectory(const WTF::String& basename, bool create, GetDirectoryCallback callback) override;
  void GetEntries(::mojo::PendingRemote<FileSystemAccessDirectoryEntriesListener> listener) override;
  void Rename(const WTF::String& new_entry_name, RenameCallback callback) override;
  void Move(::mojo::PendingRemote<::blink::mojom::blink::FileSystemAccessTransferToken> destination_directory, const WTF::String& new_entry_name, MoveCallback callback) override;
  void Remove(bool recurse, RemoveCallback callback) override;
  void RemoveEntry(const WTF::String& basename, bool recurse, RemoveEntryCallback callback) override;
  void Resolve(::mojo::PendingRemote<::blink::mojom::blink::FileSystemAccessTransferToken> possible_child, ResolveCallback callback) override;
  void Transfer(::mojo::PendingReceiver<::blink::mojom::blink::FileSystemAccessTransferToken> token) override;
  void GetUniqueId(GetUniqueIdCallback callback) override;
  void GetCloudIdentifiers(GetCloudIdentifiersCallback callback) override;
};
class PLATFORM_EXPORT FileSystemAccessDirectoryHandleAsyncWaiter {
 public:
  explicit FileSystemAccessDirectoryHandleAsyncWaiter(FileSystemAccessDirectoryHandle* proxy);

  FileSystemAccessDirectoryHandleAsyncWaiter(const FileSystemAccessDirectoryHandleAsyncWaiter&) = delete;
  FileSystemAccessDirectoryHandleAsyncWaiter& operator=(const FileSystemAccessDirectoryHandleAsyncWaiter&) = delete;

  ~FileSystemAccessDirectoryHandleAsyncWaiter();
  void GetPermissionStatus(
      bool writable, ::blink::mojom::blink::PermissionStatus* out_status);
  ::blink::mojom::blink::PermissionStatus GetPermissionStatus(bool writable);
  void RequestPermission(
      bool writable, ::blink::mojom::blink::FileSystemAccessErrorPtr* out_result, ::blink::mojom::blink::PermissionStatus* out_status);
  
  void GetFile(
      const WTF::String& basename, bool create, ::blink::mojom::blink::FileSystemAccessErrorPtr* out_result, ::mojo::PendingRemote<::blink::mojom::blink::FileSystemAccessFileHandle>* out_file);
  
  void GetDirectory(
      const WTF::String& basename, bool create, ::blink::mojom::blink::FileSystemAccessErrorPtr* out_result, ::mojo::PendingRemote<FileSystemAccessDirectoryHandle>* out_directory);
  
  void Rename(
      const WTF::String& new_entry_name, ::blink::mojom::blink::FileSystemAccessErrorPtr* out_result);
  ::blink::mojom::blink::FileSystemAccessErrorPtr Rename(const WTF::String& new_entry_name);
  void Move(
      ::mojo::PendingRemote<::blink::mojom::blink::FileSystemAccessTransferToken> destination_directory, const WTF::String& new_entry_name, ::blink::mojom::blink::FileSystemAccessErrorPtr* out_result);
  ::blink::mojom::blink::FileSystemAccessErrorPtr Move(::mojo::PendingRemote<::blink::mojom::blink::FileSystemAccessTransferToken> destination_directory, const WTF::String& new_entry_name);
  void Remove(
      bool recurse, ::blink::mojom::blink::FileSystemAccessErrorPtr* out_result);
  ::blink::mojom::blink::FileSystemAccessErrorPtr Remove(bool recurse);
  void RemoveEntry(
      const WTF::String& basename, bool recurse, ::blink::mojom::blink::FileSystemAccessErrorPtr* out_result);
  ::blink::mojom::blink::FileSystemAccessErrorPtr RemoveEntry(const WTF::String& basename, bool recurse);
  void Resolve(
      ::mojo::PendingRemote<::blink::mojom::blink::FileSystemAccessTransferToken> possible_child, ::blink::mojom::blink::FileSystemAccessErrorPtr* out_result, std::optional<WTF::Vector<WTF::String>>* out_path);
  
  void GetUniqueId(
      ::blink::mojom::blink::FileSystemAccessErrorPtr* out_result, WTF::String* out_id);
  
  void GetCloudIdentifiers(
      ::blink::mojom::blink::FileSystemAccessErrorPtr* out_result, WTF::Vector<::blink::mojom::blink::FileSystemAccessCloudIdentifierPtr>* out_cloud_identifiers);
  

 private:
  FileSystemAccessDirectoryHandle* const proxy_;
};




}  // blink::mojom::blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_FILE_SYSTEM_ACCESS_FILE_SYSTEM_ACCESS_DIRECTORY_HANDLE_MOJOM_BLINK_TEST_UTILS_H_