// third_party/blink/public/mojom/frame/pending_beacon.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_PENDING_BEACON_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_PENDING_BEACON_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include <optional>
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/frame/pending_beacon.mojom-features.h"
#include "third_party/blink/public/mojom/frame/pending_beacon.mojom-shared.h"
#include "third_party/blink/public/mojom/frame/pending_beacon.mojom-forward.h"
#include "services/network/public/mojom/url_request.mojom.h"
#include "url/mojom/url.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink::mojom {

class PendingBeaconHostProxy;

template <typename ImplRefTraits>
class PendingBeaconHostStub;

class PendingBeaconHostRequestValidator;


class BLINK_COMMON_EXPORT PendingBeaconHost
    : public PendingBeaconHostInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = PendingBeaconHostInterfaceBase;
  using Proxy_ = PendingBeaconHostProxy;

  template <typename ImplRefTraits>
  using Stub_ = PendingBeaconHostStub<ImplRefTraits>;

  using RequestValidator_ = PendingBeaconHostRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kCreateBeaconMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct CreateBeacon_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~PendingBeaconHost() = default;

  
  virtual void CreateBeacon(::mojo::PendingReceiver<PendingBeacon> receiver, const ::GURL& url, BeaconMethod method) = 0;
};

class PendingBeaconProxy;

template <typename ImplRefTraits>
class PendingBeaconStub;

class PendingBeaconRequestValidator;


class BLINK_COMMON_EXPORT PendingBeacon
    : public PendingBeaconInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = PendingBeaconInterfaceBase;
  using Proxy_ = PendingBeaconProxy;

  template <typename ImplRefTraits>
  using Stub_ = PendingBeaconStub<ImplRefTraits>;

  using RequestValidator_ = PendingBeaconRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kDeactivateMinVersion = 0,
    kSetRequestDataMinVersion = 0,
    kSetRequestURLMinVersion = 0,
    kSendNowMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct Deactivate_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct SetRequestData_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct SetRequestURL_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct SendNow_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~PendingBeacon() = default;

  
  virtual void Deactivate() = 0;

  
  virtual void SetRequestData(::scoped_refptr<::network::ResourceRequestBody> request_body, const std::string& content_type) = 0;

  
  virtual void SetRequestURL(const ::GURL& url) = 0;

  
  virtual void SendNow() = 0;
};



class BLINK_COMMON_EXPORT PendingBeaconHostProxy
    : public PendingBeaconHost {
 public:
  using InterfaceType = PendingBeaconHost;

  explicit PendingBeaconHostProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void CreateBeacon(::mojo::PendingReceiver<PendingBeacon> receiver, const ::GURL& url, BeaconMethod method) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class BLINK_COMMON_EXPORT PendingBeaconProxy
    : public PendingBeacon {
 public:
  using InterfaceType = PendingBeacon;

  explicit PendingBeaconProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Deactivate() final;
  
  void SetRequestData(::scoped_refptr<::network::ResourceRequestBody> request_body, const std::string& content_type) final;
  
  void SetRequestURL(const ::GURL& url) final;
  
  void SendNow() final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT PendingBeaconHostStubDispatch {
 public:
  static bool Accept(PendingBeaconHost* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      PendingBeaconHost* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<PendingBeaconHost>>
class PendingBeaconHostStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  PendingBeaconHostStub() = default;
  ~PendingBeaconHostStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PendingBeaconHostStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PendingBeaconHostStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT PendingBeaconStubDispatch {
 public:
  static bool Accept(PendingBeacon* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      PendingBeacon* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<PendingBeacon>>
class PendingBeaconStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  PendingBeaconStub() = default;
  ~PendingBeaconStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PendingBeaconStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PendingBeaconStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT PendingBeaconHostRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT PendingBeaconRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // blink::mojom

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_PENDING_BEACON_MOJOM_H_