// third_party/blink/public/mojom/model_execution/model_manager.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_MODEL_EXECUTION_MODEL_MANAGER_MOJOM_BLINK_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_MODEL_EXECUTION_MODEL_MANAGER_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include <optional>
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/model_execution/model_manager.mojom-features.h"
#include "third_party/blink/public/mojom/model_execution/model_manager.mojom-shared.h"
#include "third_party/blink/public/mojom/model_execution/model_manager.mojom-blink-forward.h"
#include "third_party/blink/public/mojom/model_execution/model_session.mojom-blink-forward.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/renderer/platform/platform_export.h"




namespace blink::mojom::blink {

class ModelManagerProxy;

template <typename ImplRefTraits>
class ModelManagerStub;

class ModelManagerRequestValidator;
class ModelManagerResponseValidator;


class PLATFORM_EXPORT ModelManager
    : public ModelManagerInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = ModelManagerInterfaceBase;
  using Proxy_ = ModelManagerProxy;

  template <typename ImplRefTraits>
  using Stub_ = ModelManagerStub<ImplRefTraits>;

  using RequestValidator_ = ModelManagerRequestValidator;
  using ResponseValidator_ = ModelManagerResponseValidator;
  enum MethodMinVersions : uint32_t {
    kCanCreateGenericSessionMinVersion = 0,
    kCreateGenericSessionMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct CanCreateGenericSession_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct CreateGenericSession_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~ModelManager() = default;


  using CanCreateGenericSessionCallback = base::OnceCallback<void(bool)>;
  
  virtual void CanCreateGenericSession(CanCreateGenericSessionCallback callback) = 0;


  using CreateGenericSessionCallback = base::OnceCallback<void(bool)>;
  
  virtual void CreateGenericSession(::mojo::PendingReceiver<::blink::mojom::blink::ModelGenericSession> session, CreateGenericSessionCallback callback) = 0;
};



class PLATFORM_EXPORT ModelManagerProxy
    : public ModelManager {
 public:
  using InterfaceType = ModelManager;

  explicit ModelManagerProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void CanCreateGenericSession(CanCreateGenericSessionCallback callback) final;
  
  void CreateGenericSession(::mojo::PendingReceiver<::blink::mojom::blink::ModelGenericSession> session, CreateGenericSessionCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class PLATFORM_EXPORT ModelManagerStubDispatch {
 public:
  static bool Accept(ModelManager* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ModelManager* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ModelManager>>
class ModelManagerStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ModelManagerStub() = default;
  ~ModelManagerStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ModelManagerStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ModelManagerStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class PLATFORM_EXPORT ModelManagerRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class PLATFORM_EXPORT ModelManagerResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // blink::mojom::blink

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_MODEL_EXECUTION_MODEL_MANAGER_MOJOM_BLINK_H_