// third_party/blink/public/mojom/model_execution/model_session.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_MODEL_EXECUTION_MODEL_SESSION_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_MODEL_EXECUTION_MODEL_SESSION_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include <optional>
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/model_execution/model_session.mojom-features.h"
#include "third_party/blink/public/mojom/model_execution/model_session.mojom-shared.h"
#include "third_party/blink/public/mojom/model_execution/model_session.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink::mojom {

class ModelStreamingResponderProxy;

template <typename ImplRefTraits>
class ModelStreamingResponderStub;

class ModelStreamingResponderRequestValidator;


class BLINK_COMMON_EXPORT ModelStreamingResponder
    : public ModelStreamingResponderInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = ModelStreamingResponderInterfaceBase;
  using Proxy_ = ModelStreamingResponderProxy;

  template <typename ImplRefTraits>
  using Stub_ = ModelStreamingResponderStub<ImplRefTraits>;

  using RequestValidator_ = ModelStreamingResponderRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnResponseMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct OnResponse_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~ModelStreamingResponder() = default;

  
  virtual void OnResponse(ModelStreamingResponseStatus status, const std::optional<std::string>& text) = 0;
};

class ModelGenericSessionProxy;

template <typename ImplRefTraits>
class ModelGenericSessionStub;

class ModelGenericSessionRequestValidator;


class BLINK_COMMON_EXPORT ModelGenericSession
    : public ModelGenericSessionInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = ModelGenericSessionInterfaceBase;
  using Proxy_ = ModelGenericSessionProxy;

  template <typename ImplRefTraits>
  using Stub_ = ModelGenericSessionStub<ImplRefTraits>;

  using RequestValidator_ = ModelGenericSessionRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kExecuteMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct Execute_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~ModelGenericSession() = default;

  
  virtual void Execute(const std::string& input, ::mojo::PendingRemote<ModelStreamingResponder> responder) = 0;
};



class BLINK_COMMON_EXPORT ModelStreamingResponderProxy
    : public ModelStreamingResponder {
 public:
  using InterfaceType = ModelStreamingResponder;

  explicit ModelStreamingResponderProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void OnResponse(ModelStreamingResponseStatus status, const std::optional<std::string>& text) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class BLINK_COMMON_EXPORT ModelGenericSessionProxy
    : public ModelGenericSession {
 public:
  using InterfaceType = ModelGenericSession;

  explicit ModelGenericSessionProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Execute(const std::string& input, ::mojo::PendingRemote<ModelStreamingResponder> responder) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT ModelStreamingResponderStubDispatch {
 public:
  static bool Accept(ModelStreamingResponder* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ModelStreamingResponder* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ModelStreamingResponder>>
class ModelStreamingResponderStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ModelStreamingResponderStub() = default;
  ~ModelStreamingResponderStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ModelStreamingResponderStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ModelStreamingResponderStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT ModelGenericSessionStubDispatch {
 public:
  static bool Accept(ModelGenericSession* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ModelGenericSession* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ModelGenericSession>>
class ModelGenericSessionStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ModelGenericSessionStub() = default;
  ~ModelGenericSessionStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ModelGenericSessionStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ModelGenericSessionStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT ModelStreamingResponderRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT ModelGenericSessionRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // blink::mojom

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_MODEL_EXECUTION_MODEL_SESSION_MOJOM_H_