// third_party/blink/public/mojom/navigation/renderer_content_settings.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_NAVIGATION_RENDERER_CONTENT_SETTINGS_MOJOM_BLINK_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_NAVIGATION_RENDERER_CONTENT_SETTINGS_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include <optional>
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/navigation/renderer_content_settings.mojom-features.h"
#include "third_party/blink/public/mojom/navigation/renderer_content_settings.mojom-shared.h"
#include "third_party/blink/public/mojom/navigation/renderer_content_settings.mojom-blink-forward.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"




#include "third_party/blink/renderer/platform/platform_export.h"




namespace blink::mojom::blink {





class PLATFORM_EXPORT RendererContentSettings {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<RendererContentSettings, T>::value>;
  using DataView = RendererContentSettingsDataView;
  using Data_ = internal::RendererContentSettings_Data;

  template <typename... Args>
  static RendererContentSettingsPtr New(Args&&... args) {
    return RendererContentSettingsPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static RendererContentSettingsPtr From(const U& u) {
    return mojo::TypeConverter<RendererContentSettingsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, RendererContentSettings>::Convert(*this);
  }


  RendererContentSettings();

  RendererContentSettings(
      bool allow_script,
      bool allow_image,
      bool allow_popup,
      bool allow_mixed_content);


  ~RendererContentSettings();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = RendererContentSettingsPtr>
  RendererContentSettingsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, RendererContentSettings::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, RendererContentSettings::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, RendererContentSettings::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        RendererContentSettings::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        RendererContentSettings::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::RendererContentSettings_UnserializedMessageContext<
            UserType, RendererContentSettings::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<RendererContentSettings::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return RendererContentSettings::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::RendererContentSettings_UnserializedMessageContext<
            UserType, RendererContentSettings::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<RendererContentSettings::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  bool allow_script;
  
  bool allow_image;
  
  bool allow_popup;
  
  bool allow_mixed_content;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, RendererContentSettings::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, RendererContentSettings::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, RendererContentSettings::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, RendererContentSettings::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}




template <typename StructPtrType>
RendererContentSettingsPtr RendererContentSettings::Clone() const {
  return New(
      mojo::Clone(allow_script),
      mojo::Clone(allow_image),
      mojo::Clone(allow_popup),
      mojo::Clone(allow_mixed_content)
  );
}

template <typename T, RendererContentSettings::EnableIfSame<T>*>
bool RendererContentSettings::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->allow_script, other_struct.allow_script))
    return false;
  if (!mojo::Equals(this->allow_image, other_struct.allow_image))
    return false;
  if (!mojo::Equals(this->allow_popup, other_struct.allow_popup))
    return false;
  if (!mojo::Equals(this->allow_mixed_content, other_struct.allow_mixed_content))
    return false;
  return true;
}

template <typename T, RendererContentSettings::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.allow_script < rhs.allow_script)
    return true;
  if (rhs.allow_script < lhs.allow_script)
    return false;
  if (lhs.allow_image < rhs.allow_image)
    return true;
  if (rhs.allow_image < lhs.allow_image)
    return false;
  if (lhs.allow_popup < rhs.allow_popup)
    return true;
  if (rhs.allow_popup < lhs.allow_popup)
    return false;
  if (lhs.allow_mixed_content < rhs.allow_mixed_content)
    return true;
  if (rhs.allow_mixed_content < lhs.allow_mixed_content)
    return false;
  return false;
}


}  // blink::mojom::blink

namespace mojo {


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::RendererContentSettings::DataView,
                                         ::blink::mojom::blink::RendererContentSettingsPtr> {
  static bool IsNull(const ::blink::mojom::blink::RendererContentSettingsPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::RendererContentSettingsPtr* output) { output->reset(); }

  static decltype(::blink::mojom::blink::RendererContentSettings::allow_script) allow_script(
      const ::blink::mojom::blink::RendererContentSettingsPtr& input) {
    return input->allow_script;
  }

  static decltype(::blink::mojom::blink::RendererContentSettings::allow_image) allow_image(
      const ::blink::mojom::blink::RendererContentSettingsPtr& input) {
    return input->allow_image;
  }

  static decltype(::blink::mojom::blink::RendererContentSettings::allow_popup) allow_popup(
      const ::blink::mojom::blink::RendererContentSettingsPtr& input) {
    return input->allow_popup;
  }

  static decltype(::blink::mojom::blink::RendererContentSettings::allow_mixed_content) allow_mixed_content(
      const ::blink::mojom::blink::RendererContentSettingsPtr& input) {
    return input->allow_mixed_content;
  }

  static bool Read(::blink::mojom::blink::RendererContentSettings::DataView input, ::blink::mojom::blink::RendererContentSettingsPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_NAVIGATION_RENDERER_CONTENT_SETTINGS_MOJOM_BLINK_H_