// third_party/blink/public/mojom/printing/web_printing.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_PRINTING_WEB_PRINTING_MOJOM_BLINK_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_PRINTING_WEB_PRINTING_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include <optional>
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/printing/web_printing.mojom-features.h"
#include "third_party/blink/public/mojom/printing/web_printing.mojom-shared.h"
#include "third_party/blink/public/mojom/printing/web_printing.mojom-blink-forward.h"
#include "third_party/blink/public/mojom/blob/blob.mojom-blink-forward.h"
#include "ui/gfx/geometry/mojom/geometry.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/renderer/platform/platform_export.h"




namespace blink::mojom::blink {

class WebPrintJobStateObserverProxy;

template <typename ImplRefTraits>
class WebPrintJobStateObserverStub;

class WebPrintJobStateObserverRequestValidator;


class PLATFORM_EXPORT WebPrintJobStateObserver
    : public WebPrintJobStateObserverInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = WebPrintJobStateObserverInterfaceBase;
  using Proxy_ = WebPrintJobStateObserverProxy;

  template <typename ImplRefTraits>
  using Stub_ = WebPrintJobStateObserverStub<ImplRefTraits>;

  using RequestValidator_ = WebPrintJobStateObserverRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnWebPrintJobUpdateMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct OnWebPrintJobUpdate_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~WebPrintJobStateObserver() = default;

  
  virtual void OnWebPrintJobUpdate(WebPrintJobUpdatePtr update) = 0;
};

class WebPrinterProxy;

template <typename ImplRefTraits>
class WebPrinterStub;

class WebPrinterRequestValidator;
class WebPrinterResponseValidator;


class PLATFORM_EXPORT WebPrinter
    : public WebPrinterInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = WebPrinterInterfaceBase;
  using Proxy_ = WebPrinterProxy;

  template <typename ImplRefTraits>
  using Stub_ = WebPrinterStub<ImplRefTraits>;

  using RequestValidator_ = WebPrinterRequestValidator;
  using ResponseValidator_ = WebPrinterResponseValidator;
  enum MethodMinVersions : uint32_t {
    kFetchAttributesMinVersion = 0,
    kPrintMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct FetchAttributes_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct Print_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~WebPrinter() = default;


  using FetchAttributesCallback = base::OnceCallback<void(WebPrinterAttributesPtr)>;
  
  virtual void FetchAttributes(FetchAttributesCallback callback) = 0;


  using PrintCallback = base::OnceCallback<void(WebPrintResultPtr)>;
  
  virtual void Print(::mojo::PendingRemote<::blink::mojom::blink::Blob> document, WebPrintJobTemplateAttributesPtr attributes, PrintCallback callback) = 0;
};

class WebPrintingServiceProxy;

template <typename ImplRefTraits>
class WebPrintingServiceStub;

class WebPrintingServiceRequestValidator;
class WebPrintingServiceResponseValidator;


class PLATFORM_EXPORT WebPrintingService
    : public WebPrintingServiceInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = WebPrintingServiceInterfaceBase;
  using Proxy_ = WebPrintingServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = WebPrintingServiceStub<ImplRefTraits>;

  using RequestValidator_ = WebPrintingServiceRequestValidator;
  using ResponseValidator_ = WebPrintingServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGetPrintersMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct GetPrinters_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~WebPrintingService() = default;


  using GetPrintersCallback = base::OnceCallback<void(WTF::Vector<WebPrinterInfoPtr>)>;
  
  virtual void GetPrinters(GetPrintersCallback callback) = 0;
};



class PLATFORM_EXPORT WebPrintJobStateObserverProxy
    : public WebPrintJobStateObserver {
 public:
  using InterfaceType = WebPrintJobStateObserver;

  explicit WebPrintJobStateObserverProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void OnWebPrintJobUpdate(WebPrintJobUpdatePtr update) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class PLATFORM_EXPORT WebPrinterProxy
    : public WebPrinter {
 public:
  using InterfaceType = WebPrinter;

  explicit WebPrinterProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void FetchAttributes(FetchAttributesCallback callback) final;
  
  void Print(::mojo::PendingRemote<::blink::mojom::blink::Blob> document, WebPrintJobTemplateAttributesPtr attributes, PrintCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class PLATFORM_EXPORT WebPrintingServiceProxy
    : public WebPrintingService {
 public:
  using InterfaceType = WebPrintingService;

  explicit WebPrintingServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void GetPrinters(GetPrintersCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class PLATFORM_EXPORT WebPrintJobStateObserverStubDispatch {
 public:
  static bool Accept(WebPrintJobStateObserver* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      WebPrintJobStateObserver* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<WebPrintJobStateObserver>>
class WebPrintJobStateObserverStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  WebPrintJobStateObserverStub() = default;
  ~WebPrintJobStateObserverStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebPrintJobStateObserverStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebPrintJobStateObserverStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class PLATFORM_EXPORT WebPrinterStubDispatch {
 public:
  static bool Accept(WebPrinter* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      WebPrinter* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<WebPrinter>>
class WebPrinterStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  WebPrinterStub() = default;
  ~WebPrinterStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebPrinterStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebPrinterStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class PLATFORM_EXPORT WebPrintingServiceStubDispatch {
 public:
  static bool Accept(WebPrintingService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      WebPrintingService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<WebPrintingService>>
class WebPrintingServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  WebPrintingServiceStub() = default;
  ~WebPrintingServiceStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebPrintingServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebPrintingServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class PLATFORM_EXPORT WebPrintJobStateObserverRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class PLATFORM_EXPORT WebPrinterRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class PLATFORM_EXPORT WebPrintingServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class PLATFORM_EXPORT WebPrinterResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class PLATFORM_EXPORT WebPrintingServiceResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};






class PLATFORM_EXPORT WebPrintingRange {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<WebPrintingRange, T>::value>;
  using DataView = WebPrintingRangeDataView;
  using Data_ = internal::WebPrintingRange_Data;

  template <typename... Args>
  static WebPrintingRangePtr New(Args&&... args) {
    return WebPrintingRangePtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static WebPrintingRangePtr From(const U& u) {
    return mojo::TypeConverter<WebPrintingRangePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, WebPrintingRange>::Convert(*this);
  }


  WebPrintingRange();

  WebPrintingRange(
      uint32_t from,
      uint32_t to);


  ~WebPrintingRange();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = WebPrintingRangePtr>
  WebPrintingRangePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, WebPrintingRange::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, WebPrintingRange::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, WebPrintingRange::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        WebPrintingRange::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        WebPrintingRange::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::WebPrintingRange_UnserializedMessageContext<
            UserType, WebPrintingRange::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<WebPrintingRange::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return WebPrintingRange::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::WebPrintingRange_UnserializedMessageContext<
            UserType, WebPrintingRange::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<WebPrintingRange::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint32_t from;
  
  uint32_t to;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, WebPrintingRange::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, WebPrintingRange::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, WebPrintingRange::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, WebPrintingRange::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}







class PLATFORM_EXPORT WebPrintJobUpdate {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<WebPrintJobUpdate, T>::value>;
  using DataView = WebPrintJobUpdateDataView;
  using Data_ = internal::WebPrintJobUpdate_Data;

  template <typename... Args>
  static WebPrintJobUpdatePtr New(Args&&... args) {
    return WebPrintJobUpdatePtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static WebPrintJobUpdatePtr From(const U& u) {
    return mojo::TypeConverter<WebPrintJobUpdatePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, WebPrintJobUpdate>::Convert(*this);
  }


  WebPrintJobUpdate();

  WebPrintJobUpdate(
      WebPrintJobState state,
      uint32_t pages_printed);


  ~WebPrintJobUpdate();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = WebPrintJobUpdatePtr>
  WebPrintJobUpdatePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, WebPrintJobUpdate::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, WebPrintJobUpdate::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, WebPrintJobUpdate::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        WebPrintJobUpdate::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        WebPrintJobUpdate::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::WebPrintJobUpdate_UnserializedMessageContext<
            UserType, WebPrintJobUpdate::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<WebPrintJobUpdate::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return WebPrintJobUpdate::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::WebPrintJobUpdate_UnserializedMessageContext<
            UserType, WebPrintJobUpdate::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<WebPrintJobUpdate::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  WebPrintJobState state;
  
  uint32_t pages_printed;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, WebPrintJobUpdate::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, WebPrintJobUpdate::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, WebPrintJobUpdate::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, WebPrintJobUpdate::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class PLATFORM_EXPORT WebPrintResult {
 public:
  using DataView = WebPrintResultDataView;
  using Data_ = internal::WebPrintResult_Data;
  using Tag = Data_::WebPrintResult_Tag;

  template <typename... Args>
  static WebPrintResultPtr New(Args&&... args) {
    static_assert(
        sizeof...(args) < 0,
        "Do not use Union::New(); to create a union of a given subtype, use "
        "New<SubType>(), not New() followed by set_<sub_type>(). To represent "
        "an empty union, mark the field or parameter as nullable in the mojom "
        "definition.");
    return nullptr;
  }
  // Construct an instance holding |print_job_info|.
  static WebPrintResultPtr
  NewPrintJobInfo(
      WebPrintJobInfoPtr value) {
    auto result = WebPrintResultPtr(absl::in_place);
    result->set_print_job_info(std::move(value));
    return result;
  }
  // Construct an instance holding |error|.
  static WebPrintResultPtr
  NewError(
      WebPrintError value) {
    auto result = WebPrintResultPtr(absl::in_place);
    result->set_error(std::move(value));
    return result;
  }

  template <typename U>
  static WebPrintResultPtr From(const U& u) {
    return mojo::TypeConverter<WebPrintResultPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, WebPrintResult>::Convert(*this);
  }

  WebPrintResult();
  ~WebPrintResult();
  // Delete the copy constructor and copy assignment operators because `data_`
  // contains raw pointers that must not be copied.
  WebPrintResult(const WebPrintResult& other) = delete;
  WebPrintResult& operator=(const WebPrintResult& other) = delete;

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = WebPrintResultPtr>
  WebPrintResultPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, WebPrintResult>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename T,
            typename std::enable_if<std::is_same<
                T, WebPrintResult>::value>::type* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  Tag which() const {
    return tag_;
  }


  
  bool is_print_job_info() const { return tag_ == Tag::kPrintJobInfo; }

  
  WebPrintJobInfoPtr& get_print_job_info() const {
    CHECK(tag_ == Tag::kPrintJobInfo);
    return *(data_.print_job_info);
  }

  
  void set_print_job_info(
      WebPrintJobInfoPtr print_job_info);
  
  bool is_error() const { return tag_ == Tag::kError; }

  
  WebPrintError get_error() const {
    CHECK(tag_ == Tag::kError);
    return data_.error;
  }

  
  void set_error(
      WebPrintError error);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        WebPrintResult::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<WebPrintResult::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

 private:
  union Union_ {
    Union_() = default;
    ~Union_() = default;
    WebPrintJobInfoPtr* print_job_info;
    WebPrintError error;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};





class PLATFORM_EXPORT WebPrinterInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<WebPrinterInfo, T>::value>;
  using DataView = WebPrinterInfoDataView;
  using Data_ = internal::WebPrinterInfo_Data;

  template <typename... Args>
  static WebPrinterInfoPtr New(Args&&... args) {
    return WebPrinterInfoPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static WebPrinterInfoPtr From(const U& u) {
    return mojo::TypeConverter<WebPrinterInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, WebPrinterInfo>::Convert(*this);
  }


  WebPrinterInfo();

  WebPrinterInfo(
      const WTF::String& printer_name,
      ::mojo::PendingRemote<WebPrinter> printer_remote);

WebPrinterInfo(const WebPrinterInfo&) = delete;
WebPrinterInfo& operator=(const WebPrinterInfo&) = delete;

  ~WebPrinterInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = WebPrinterInfoPtr>
  WebPrinterInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, WebPrinterInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, WebPrinterInfo::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, WebPrinterInfo::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        WebPrinterInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::WebPrinterInfo_UnserializedMessageContext<
            UserType, WebPrinterInfo::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<WebPrinterInfo::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return WebPrinterInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::WebPrinterInfo_UnserializedMessageContext<
            UserType, WebPrinterInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<WebPrinterInfo::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  WTF::String printer_name;
  
  ::mojo::PendingRemote<WebPrinter> printer_remote;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, WebPrinterInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, WebPrinterInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, WebPrinterInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, WebPrinterInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class PLATFORM_EXPORT WebPrinterAttributes {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<WebPrinterAttributes, T>::value>;
  using DataView = WebPrinterAttributesDataView;
  using Data_ = internal::WebPrinterAttributes_Data;

  template <typename... Args>
  static WebPrinterAttributesPtr New(Args&&... args) {
    return WebPrinterAttributesPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static WebPrinterAttributesPtr From(const U& u) {
    return mojo::TypeConverter<WebPrinterAttributesPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, WebPrinterAttributes>::Convert(*this);
  }


  WebPrinterAttributes();

  WebPrinterAttributes(
      uint32_t copies_default,
      WebPrintingRangePtr copies_supported,
      WebPrintingMultipleDocumentHandling multiple_document_handling_default,
      WTF::Vector<WebPrintingMultipleDocumentHandling> multiple_document_handling_supported,
      const ::gfx::Size& printer_resolution_default,
      WTF::Vector<::gfx::Size> printer_resolution_supported,
      WebPrintColorMode print_color_mode_default,
      WTF::Vector<WebPrintColorMode> print_color_mode_supported,
      WebPrinterState printer_state,
      const WTF::String& printer_state_message,
      WTF::Vector<WebPrinterStateReason> printer_state_reasons,
      std::optional<WebPrintingSides> sides_default,
      WTF::Vector<WebPrintingSides> sides_supported);

WebPrinterAttributes(const WebPrinterAttributes&) = delete;
WebPrinterAttributes& operator=(const WebPrinterAttributes&) = delete;

  ~WebPrinterAttributes();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = WebPrinterAttributesPtr>
  WebPrinterAttributesPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, WebPrinterAttributes::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, WebPrinterAttributes::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, WebPrinterAttributes::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        WebPrinterAttributes::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        WebPrinterAttributes::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::WebPrinterAttributes_UnserializedMessageContext<
            UserType, WebPrinterAttributes::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<WebPrinterAttributes::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return WebPrinterAttributes::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::WebPrinterAttributes_UnserializedMessageContext<
            UserType, WebPrinterAttributes::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<WebPrinterAttributes::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint32_t copies_default;
  
  WebPrintingRangePtr copies_supported;
  
  WebPrintingMultipleDocumentHandling multiple_document_handling_default;
  
  WTF::Vector<WebPrintingMultipleDocumentHandling> multiple_document_handling_supported;
  
  ::gfx::Size printer_resolution_default;
  
  WTF::Vector<::gfx::Size> printer_resolution_supported;
  
  WebPrintColorMode print_color_mode_default;
  
  WTF::Vector<WebPrintColorMode> print_color_mode_supported;
  
  WebPrinterState printer_state;
  
  WTF::String printer_state_message;
  
  WTF::Vector<WebPrinterStateReason> printer_state_reasons;
  
  std::optional<WebPrintingSides> sides_default;
  
  WTF::Vector<WebPrintingSides> sides_supported;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, WebPrinterAttributes::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, WebPrinterAttributes::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, WebPrinterAttributes::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, WebPrinterAttributes::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class PLATFORM_EXPORT WebPrintJobTemplateAttributes {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<WebPrintJobTemplateAttributes, T>::value>;
  using DataView = WebPrintJobTemplateAttributesDataView;
  using Data_ = internal::WebPrintJobTemplateAttributes_Data;

  template <typename... Args>
  static WebPrintJobTemplateAttributesPtr New(Args&&... args) {
    return WebPrintJobTemplateAttributesPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static WebPrintJobTemplateAttributesPtr From(const U& u) {
    return mojo::TypeConverter<WebPrintJobTemplateAttributesPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, WebPrintJobTemplateAttributes>::Convert(*this);
  }


  WebPrintJobTemplateAttributes();

  WebPrintJobTemplateAttributes(
      const WTF::String& job_name,
      uint32_t copies,
      std::optional<WebPrintingMultipleDocumentHandling> multiple_document_handling,
      const std::optional<::gfx::Size>& printer_resolution,
      std::optional<WebPrintColorMode> print_color_mode,
      std::optional<WebPrintingSides> sides);


  ~WebPrintJobTemplateAttributes();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = WebPrintJobTemplateAttributesPtr>
  WebPrintJobTemplateAttributesPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, WebPrintJobTemplateAttributes::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, WebPrintJobTemplateAttributes::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, WebPrintJobTemplateAttributes::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        WebPrintJobTemplateAttributes::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        WebPrintJobTemplateAttributes::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::WebPrintJobTemplateAttributes_UnserializedMessageContext<
            UserType, WebPrintJobTemplateAttributes::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<WebPrintJobTemplateAttributes::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return WebPrintJobTemplateAttributes::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::WebPrintJobTemplateAttributes_UnserializedMessageContext<
            UserType, WebPrintJobTemplateAttributes::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<WebPrintJobTemplateAttributes::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  WTF::String job_name;
  
  uint32_t copies;
  
  std::optional<WebPrintingMultipleDocumentHandling> multiple_document_handling;
  
  std::optional<::gfx::Size> printer_resolution;
  
  std::optional<WebPrintColorMode> print_color_mode;
  
  std::optional<WebPrintingSides> sides;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, WebPrintJobTemplateAttributes::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, WebPrintJobTemplateAttributes::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, WebPrintJobTemplateAttributes::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, WebPrintJobTemplateAttributes::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class PLATFORM_EXPORT WebPrintJobInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<WebPrintJobInfo, T>::value>;
  using DataView = WebPrintJobInfoDataView;
  using Data_ = internal::WebPrintJobInfo_Data;

  template <typename... Args>
  static WebPrintJobInfoPtr New(Args&&... args) {
    return WebPrintJobInfoPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static WebPrintJobInfoPtr From(const U& u) {
    return mojo::TypeConverter<WebPrintJobInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, WebPrintJobInfo>::Convert(*this);
  }


  WebPrintJobInfo();

  WebPrintJobInfo(
      const WTF::String& job_name,
      uint32_t job_pages,
      ::mojo::PendingReceiver<WebPrintJobStateObserver> observer);

WebPrintJobInfo(const WebPrintJobInfo&) = delete;
WebPrintJobInfo& operator=(const WebPrintJobInfo&) = delete;

  ~WebPrintJobInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = WebPrintJobInfoPtr>
  WebPrintJobInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, WebPrintJobInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, WebPrintJobInfo::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, WebPrintJobInfo::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        WebPrintJobInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::WebPrintJobInfo_UnserializedMessageContext<
            UserType, WebPrintJobInfo::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<WebPrintJobInfo::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return WebPrintJobInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::WebPrintJobInfo_UnserializedMessageContext<
            UserType, WebPrintJobInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<WebPrintJobInfo::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  WTF::String job_name;
  
  uint32_t job_pages;
  
  ::mojo::PendingReceiver<WebPrintJobStateObserver> observer;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, WebPrintJobInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, WebPrintJobInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, WebPrintJobInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, WebPrintJobInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename UnionPtrType>
WebPrintResultPtr WebPrintResult::Clone() const {
  switch (tag_) {
    case Tag::kPrintJobInfo:
      return NewPrintJobInfo(
          mojo::Clone(*data_.print_job_info));
    case Tag::kError:
      return NewError(
          mojo::Clone(data_.error));
  }
  return nullptr;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, WebPrintResult>::value>::type*>
bool WebPrintResult::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::kPrintJobInfo:
      return mojo::Equals(*(data_.print_job_info), *(other.data_.print_job_info));
    case Tag::kError:
      return mojo::Equals(data_.error, other.data_.error);
  }

  return false;
}
template <typename StructPtrType>
WebPrinterInfoPtr WebPrinterInfo::Clone() const {
  return New(
      mojo::Clone(printer_name),
      mojo::Clone(printer_remote)
  );
}

template <typename T, WebPrinterInfo::EnableIfSame<T>*>
bool WebPrinterInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->printer_name, other_struct.printer_name))
    return false;
  if (!mojo::Equals(this->printer_remote, other_struct.printer_remote))
    return false;
  return true;
}

template <typename T, WebPrinterInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.printer_name < rhs.printer_name)
    return true;
  if (rhs.printer_name < lhs.printer_name)
    return false;
  if (lhs.printer_remote < rhs.printer_remote)
    return true;
  if (rhs.printer_remote < lhs.printer_remote)
    return false;
  return false;
}
template <typename StructPtrType>
WebPrintingRangePtr WebPrintingRange::Clone() const {
  return New(
      mojo::Clone(from),
      mojo::Clone(to)
  );
}

template <typename T, WebPrintingRange::EnableIfSame<T>*>
bool WebPrintingRange::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->from, other_struct.from))
    return false;
  if (!mojo::Equals(this->to, other_struct.to))
    return false;
  return true;
}

template <typename T, WebPrintingRange::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.from < rhs.from)
    return true;
  if (rhs.from < lhs.from)
    return false;
  if (lhs.to < rhs.to)
    return true;
  if (rhs.to < lhs.to)
    return false;
  return false;
}
template <typename StructPtrType>
WebPrinterAttributesPtr WebPrinterAttributes::Clone() const {
  return New(
      mojo::Clone(copies_default),
      mojo::Clone(copies_supported),
      mojo::Clone(multiple_document_handling_default),
      mojo::Clone(multiple_document_handling_supported),
      mojo::Clone(printer_resolution_default),
      mojo::Clone(printer_resolution_supported),
      mojo::Clone(print_color_mode_default),
      mojo::Clone(print_color_mode_supported),
      mojo::Clone(printer_state),
      mojo::Clone(printer_state_message),
      mojo::Clone(printer_state_reasons),
      mojo::Clone(sides_default),
      mojo::Clone(sides_supported)
  );
}

template <typename T, WebPrinterAttributes::EnableIfSame<T>*>
bool WebPrinterAttributes::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->copies_default, other_struct.copies_default))
    return false;
  if (!mojo::Equals(this->copies_supported, other_struct.copies_supported))
    return false;
  if (!mojo::Equals(this->multiple_document_handling_default, other_struct.multiple_document_handling_default))
    return false;
  if (!mojo::Equals(this->multiple_document_handling_supported, other_struct.multiple_document_handling_supported))
    return false;
  if (!mojo::Equals(this->printer_resolution_default, other_struct.printer_resolution_default))
    return false;
  if (!mojo::Equals(this->printer_resolution_supported, other_struct.printer_resolution_supported))
    return false;
  if (!mojo::Equals(this->print_color_mode_default, other_struct.print_color_mode_default))
    return false;
  if (!mojo::Equals(this->print_color_mode_supported, other_struct.print_color_mode_supported))
    return false;
  if (!mojo::Equals(this->printer_state, other_struct.printer_state))
    return false;
  if (!mojo::Equals(this->printer_state_message, other_struct.printer_state_message))
    return false;
  if (!mojo::Equals(this->printer_state_reasons, other_struct.printer_state_reasons))
    return false;
  if (!mojo::Equals(this->sides_default, other_struct.sides_default))
    return false;
  if (!mojo::Equals(this->sides_supported, other_struct.sides_supported))
    return false;
  return true;
}

template <typename T, WebPrinterAttributes::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.copies_default < rhs.copies_default)
    return true;
  if (rhs.copies_default < lhs.copies_default)
    return false;
  if (lhs.copies_supported < rhs.copies_supported)
    return true;
  if (rhs.copies_supported < lhs.copies_supported)
    return false;
  if (lhs.multiple_document_handling_default < rhs.multiple_document_handling_default)
    return true;
  if (rhs.multiple_document_handling_default < lhs.multiple_document_handling_default)
    return false;
  if (lhs.multiple_document_handling_supported < rhs.multiple_document_handling_supported)
    return true;
  if (rhs.multiple_document_handling_supported < lhs.multiple_document_handling_supported)
    return false;
  if (lhs.printer_resolution_default < rhs.printer_resolution_default)
    return true;
  if (rhs.printer_resolution_default < lhs.printer_resolution_default)
    return false;
  if (lhs.printer_resolution_supported < rhs.printer_resolution_supported)
    return true;
  if (rhs.printer_resolution_supported < lhs.printer_resolution_supported)
    return false;
  if (lhs.print_color_mode_default < rhs.print_color_mode_default)
    return true;
  if (rhs.print_color_mode_default < lhs.print_color_mode_default)
    return false;
  if (lhs.print_color_mode_supported < rhs.print_color_mode_supported)
    return true;
  if (rhs.print_color_mode_supported < lhs.print_color_mode_supported)
    return false;
  if (lhs.printer_state < rhs.printer_state)
    return true;
  if (rhs.printer_state < lhs.printer_state)
    return false;
  if (lhs.printer_state_message < rhs.printer_state_message)
    return true;
  if (rhs.printer_state_message < lhs.printer_state_message)
    return false;
  if (lhs.printer_state_reasons < rhs.printer_state_reasons)
    return true;
  if (rhs.printer_state_reasons < lhs.printer_state_reasons)
    return false;
  if (lhs.sides_default < rhs.sides_default)
    return true;
  if (rhs.sides_default < lhs.sides_default)
    return false;
  if (lhs.sides_supported < rhs.sides_supported)
    return true;
  if (rhs.sides_supported < lhs.sides_supported)
    return false;
  return false;
}
template <typename StructPtrType>
WebPrintJobTemplateAttributesPtr WebPrintJobTemplateAttributes::Clone() const {
  return New(
      mojo::Clone(job_name),
      mojo::Clone(copies),
      mojo::Clone(multiple_document_handling),
      mojo::Clone(printer_resolution),
      mojo::Clone(print_color_mode),
      mojo::Clone(sides)
  );
}

template <typename T, WebPrintJobTemplateAttributes::EnableIfSame<T>*>
bool WebPrintJobTemplateAttributes::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->job_name, other_struct.job_name))
    return false;
  if (!mojo::Equals(this->copies, other_struct.copies))
    return false;
  if (!mojo::Equals(this->multiple_document_handling, other_struct.multiple_document_handling))
    return false;
  if (!mojo::Equals(this->printer_resolution, other_struct.printer_resolution))
    return false;
  if (!mojo::Equals(this->print_color_mode, other_struct.print_color_mode))
    return false;
  if (!mojo::Equals(this->sides, other_struct.sides))
    return false;
  return true;
}

template <typename T, WebPrintJobTemplateAttributes::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.job_name < rhs.job_name)
    return true;
  if (rhs.job_name < lhs.job_name)
    return false;
  if (lhs.copies < rhs.copies)
    return true;
  if (rhs.copies < lhs.copies)
    return false;
  if (lhs.multiple_document_handling < rhs.multiple_document_handling)
    return true;
  if (rhs.multiple_document_handling < lhs.multiple_document_handling)
    return false;
  if (lhs.printer_resolution < rhs.printer_resolution)
    return true;
  if (rhs.printer_resolution < lhs.printer_resolution)
    return false;
  if (lhs.print_color_mode < rhs.print_color_mode)
    return true;
  if (rhs.print_color_mode < lhs.print_color_mode)
    return false;
  if (lhs.sides < rhs.sides)
    return true;
  if (rhs.sides < lhs.sides)
    return false;
  return false;
}
template <typename StructPtrType>
WebPrintJobUpdatePtr WebPrintJobUpdate::Clone() const {
  return New(
      mojo::Clone(state),
      mojo::Clone(pages_printed)
  );
}

template <typename T, WebPrintJobUpdate::EnableIfSame<T>*>
bool WebPrintJobUpdate::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->state, other_struct.state))
    return false;
  if (!mojo::Equals(this->pages_printed, other_struct.pages_printed))
    return false;
  return true;
}

template <typename T, WebPrintJobUpdate::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.state < rhs.state)
    return true;
  if (rhs.state < lhs.state)
    return false;
  if (lhs.pages_printed < rhs.pages_printed)
    return true;
  if (rhs.pages_printed < lhs.pages_printed)
    return false;
  return false;
}
template <typename StructPtrType>
WebPrintJobInfoPtr WebPrintJobInfo::Clone() const {
  return New(
      mojo::Clone(job_name),
      mojo::Clone(job_pages),
      mojo::Clone(observer)
  );
}

template <typename T, WebPrintJobInfo::EnableIfSame<T>*>
bool WebPrintJobInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->job_name, other_struct.job_name))
    return false;
  if (!mojo::Equals(this->job_pages, other_struct.job_pages))
    return false;
  if (!mojo::Equals(this->observer, other_struct.observer))
    return false;
  return true;
}

template <typename T, WebPrintJobInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.job_name < rhs.job_name)
    return true;
  if (rhs.job_name < lhs.job_name)
    return false;
  if (lhs.job_pages < rhs.job_pages)
    return true;
  if (rhs.job_pages < lhs.job_pages)
    return false;
  if (lhs.observer < rhs.observer)
    return true;
  if (rhs.observer < lhs.observer)
    return false;
  return false;
}


}  // blink::mojom::blink

namespace mojo {


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::WebPrinterInfo::DataView,
                                         ::blink::mojom::blink::WebPrinterInfoPtr> {
  static bool IsNull(const ::blink::mojom::blink::WebPrinterInfoPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::WebPrinterInfoPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::blink::WebPrinterInfo::printer_name)& printer_name(
      const ::blink::mojom::blink::WebPrinterInfoPtr& input) {
    return input->printer_name;
  }

  static  decltype(::blink::mojom::blink::WebPrinterInfo::printer_remote)& printer_remote(
       ::blink::mojom::blink::WebPrinterInfoPtr& input) {
    return input->printer_remote;
  }

  static bool Read(::blink::mojom::blink::WebPrinterInfo::DataView input, ::blink::mojom::blink::WebPrinterInfoPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::WebPrintingRange::DataView,
                                         ::blink::mojom::blink::WebPrintingRangePtr> {
  static bool IsNull(const ::blink::mojom::blink::WebPrintingRangePtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::WebPrintingRangePtr* output) { output->reset(); }

  static decltype(::blink::mojom::blink::WebPrintingRange::from) from(
      const ::blink::mojom::blink::WebPrintingRangePtr& input) {
    return input->from;
  }

  static decltype(::blink::mojom::blink::WebPrintingRange::to) to(
      const ::blink::mojom::blink::WebPrintingRangePtr& input) {
    return input->to;
  }

  static bool Read(::blink::mojom::blink::WebPrintingRange::DataView input, ::blink::mojom::blink::WebPrintingRangePtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::WebPrinterAttributes::DataView,
                                         ::blink::mojom::blink::WebPrinterAttributesPtr> {
  static bool IsNull(const ::blink::mojom::blink::WebPrinterAttributesPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::WebPrinterAttributesPtr* output) { output->reset(); }

  static decltype(::blink::mojom::blink::WebPrinterAttributes::copies_default) copies_default(
      const ::blink::mojom::blink::WebPrinterAttributesPtr& input) {
    return input->copies_default;
  }

  static const decltype(::blink::mojom::blink::WebPrinterAttributes::copies_supported)& copies_supported(
      const ::blink::mojom::blink::WebPrinterAttributesPtr& input) {
    return input->copies_supported;
  }

  static decltype(::blink::mojom::blink::WebPrinterAttributes::multiple_document_handling_default) multiple_document_handling_default(
      const ::blink::mojom::blink::WebPrinterAttributesPtr& input) {
    return input->multiple_document_handling_default;
  }

  static const decltype(::blink::mojom::blink::WebPrinterAttributes::multiple_document_handling_supported)& multiple_document_handling_supported(
      const ::blink::mojom::blink::WebPrinterAttributesPtr& input) {
    return input->multiple_document_handling_supported;
  }

  static const decltype(::blink::mojom::blink::WebPrinterAttributes::printer_resolution_default)& printer_resolution_default(
      const ::blink::mojom::blink::WebPrinterAttributesPtr& input) {
    return input->printer_resolution_default;
  }

  static const decltype(::blink::mojom::blink::WebPrinterAttributes::printer_resolution_supported)& printer_resolution_supported(
      const ::blink::mojom::blink::WebPrinterAttributesPtr& input) {
    return input->printer_resolution_supported;
  }

  static decltype(::blink::mojom::blink::WebPrinterAttributes::print_color_mode_default) print_color_mode_default(
      const ::blink::mojom::blink::WebPrinterAttributesPtr& input) {
    return input->print_color_mode_default;
  }

  static const decltype(::blink::mojom::blink::WebPrinterAttributes::print_color_mode_supported)& print_color_mode_supported(
      const ::blink::mojom::blink::WebPrinterAttributesPtr& input) {
    return input->print_color_mode_supported;
  }

  static decltype(::blink::mojom::blink::WebPrinterAttributes::printer_state) printer_state(
      const ::blink::mojom::blink::WebPrinterAttributesPtr& input) {
    return input->printer_state;
  }

  static const decltype(::blink::mojom::blink::WebPrinterAttributes::printer_state_message)& printer_state_message(
      const ::blink::mojom::blink::WebPrinterAttributesPtr& input) {
    return input->printer_state_message;
  }

  static const decltype(::blink::mojom::blink::WebPrinterAttributes::printer_state_reasons)& printer_state_reasons(
      const ::blink::mojom::blink::WebPrinterAttributesPtr& input) {
    return input->printer_state_reasons;
  }

  static decltype(::blink::mojom::blink::WebPrinterAttributes::sides_default) sides_default(
      const ::blink::mojom::blink::WebPrinterAttributesPtr& input) {
    return input->sides_default;
  }

  static const decltype(::blink::mojom::blink::WebPrinterAttributes::sides_supported)& sides_supported(
      const ::blink::mojom::blink::WebPrinterAttributesPtr& input) {
    return input->sides_supported;
  }

  static bool Read(::blink::mojom::blink::WebPrinterAttributes::DataView input, ::blink::mojom::blink::WebPrinterAttributesPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::WebPrintJobTemplateAttributes::DataView,
                                         ::blink::mojom::blink::WebPrintJobTemplateAttributesPtr> {
  static bool IsNull(const ::blink::mojom::blink::WebPrintJobTemplateAttributesPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::WebPrintJobTemplateAttributesPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::blink::WebPrintJobTemplateAttributes::job_name)& job_name(
      const ::blink::mojom::blink::WebPrintJobTemplateAttributesPtr& input) {
    return input->job_name;
  }

  static decltype(::blink::mojom::blink::WebPrintJobTemplateAttributes::copies) copies(
      const ::blink::mojom::blink::WebPrintJobTemplateAttributesPtr& input) {
    return input->copies;
  }

  static decltype(::blink::mojom::blink::WebPrintJobTemplateAttributes::multiple_document_handling) multiple_document_handling(
      const ::blink::mojom::blink::WebPrintJobTemplateAttributesPtr& input) {
    return input->multiple_document_handling;
  }

  static const decltype(::blink::mojom::blink::WebPrintJobTemplateAttributes::printer_resolution)& printer_resolution(
      const ::blink::mojom::blink::WebPrintJobTemplateAttributesPtr& input) {
    return input->printer_resolution;
  }

  static decltype(::blink::mojom::blink::WebPrintJobTemplateAttributes::print_color_mode) print_color_mode(
      const ::blink::mojom::blink::WebPrintJobTemplateAttributesPtr& input) {
    return input->print_color_mode;
  }

  static decltype(::blink::mojom::blink::WebPrintJobTemplateAttributes::sides) sides(
      const ::blink::mojom::blink::WebPrintJobTemplateAttributesPtr& input) {
    return input->sides;
  }

  static bool Read(::blink::mojom::blink::WebPrintJobTemplateAttributes::DataView input, ::blink::mojom::blink::WebPrintJobTemplateAttributesPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::WebPrintJobUpdate::DataView,
                                         ::blink::mojom::blink::WebPrintJobUpdatePtr> {
  static bool IsNull(const ::blink::mojom::blink::WebPrintJobUpdatePtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::WebPrintJobUpdatePtr* output) { output->reset(); }

  static decltype(::blink::mojom::blink::WebPrintJobUpdate::state) state(
      const ::blink::mojom::blink::WebPrintJobUpdatePtr& input) {
    return input->state;
  }

  static decltype(::blink::mojom::blink::WebPrintJobUpdate::pages_printed) pages_printed(
      const ::blink::mojom::blink::WebPrintJobUpdatePtr& input) {
    return input->pages_printed;
  }

  static bool Read(::blink::mojom::blink::WebPrintJobUpdate::DataView input, ::blink::mojom::blink::WebPrintJobUpdatePtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::WebPrintJobInfo::DataView,
                                         ::blink::mojom::blink::WebPrintJobInfoPtr> {
  static bool IsNull(const ::blink::mojom::blink::WebPrintJobInfoPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::WebPrintJobInfoPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::blink::WebPrintJobInfo::job_name)& job_name(
      const ::blink::mojom::blink::WebPrintJobInfoPtr& input) {
    return input->job_name;
  }

  static decltype(::blink::mojom::blink::WebPrintJobInfo::job_pages) job_pages(
      const ::blink::mojom::blink::WebPrintJobInfoPtr& input) {
    return input->job_pages;
  }

  static  decltype(::blink::mojom::blink::WebPrintJobInfo::observer)& observer(
       ::blink::mojom::blink::WebPrintJobInfoPtr& input) {
    return input->observer;
  }

  static bool Read(::blink::mojom::blink::WebPrintJobInfo::DataView input, ::blink::mojom::blink::WebPrintJobInfoPtr* output);
};


template <>
struct PLATFORM_EXPORT UnionTraits<::blink::mojom::blink::WebPrintResult::DataView,
                                        ::blink::mojom::blink::WebPrintResultPtr> {
  static bool IsNull(const ::blink::mojom::blink::WebPrintResultPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::WebPrintResultPtr* output) { output->reset(); }

  static ::blink::mojom::blink::WebPrintResult::Tag GetTag(const ::blink::mojom::blink::WebPrintResultPtr& input) {
    return input->which();
  }

  static  ::blink::mojom::blink::WebPrintJobInfoPtr& print_job_info( ::blink::mojom::blink::WebPrintResultPtr& input) {
    return input->get_print_job_info();
  }

  static  ::blink::mojom::blink::WebPrintError error(const ::blink::mojom::blink::WebPrintResultPtr& input) {
    return input->get_error();
  }

  static bool Read(::blink::mojom::blink::WebPrintResult::DataView input, ::blink::mojom::blink::WebPrintResultPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_PRINTING_WEB_PRINTING_MOJOM_BLINK_H_