// third_party/blink/public/mojom/service_worker/service_worker_client.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "third_party/blink/public/mojom/service_worker/service_worker_client.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/debug/alias.h"
#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/thread_pool/thread_pool_instance.h"
#include "base/trace_event/trace_event.h"
#include "base/trace_event/typed_macros.h"
#include "mojo/public/cpp/bindings/lib/default_construct_tag_internal.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/send_message_helper.h"
#include "mojo/public/cpp/bindings/lib/proxy_to_responder.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#include "mojo/public/cpp/bindings/urgent_message_scope.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "third_party/blink/public/mojom/service_worker/service_worker_client.mojom-params-data.h"
#include "third_party/blink/public/mojom/service_worker/service_worker_client.mojom-shared-message-ids.h"

#include "third_party/blink/public/mojom/service_worker/service_worker_client.mojom-import-headers.h"
#include "third_party/blink/public/mojom/service_worker/service_worker_client.mojom-test-utils.h"


namespace blink::mojom {
ServiceWorkerClientQueryOptions::ServiceWorkerClientQueryOptions()
    : include_uncontrolled(false),
      client_type(ServiceWorkerClientType::kWindow) {}

ServiceWorkerClientQueryOptions::ServiceWorkerClientQueryOptions(
    bool include_uncontrolled_in,
    ServiceWorkerClientType client_type_in)
    : include_uncontrolled(std::move(include_uncontrolled_in)),
      client_type(std::move(client_type_in)) {}

ServiceWorkerClientQueryOptions::~ServiceWorkerClientQueryOptions() = default;
size_t ServiceWorkerClientQueryOptions::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->include_uncontrolled);
  seed = mojo::internal::Hash(seed, this->client_type);
  return seed;
}

void ServiceWorkerClientQueryOptions::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "include_uncontrolled"), this->include_uncontrolled,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type bool>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "client_type"), this->client_type,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ServiceWorkerClientType>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool ServiceWorkerClientQueryOptions::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
ServiceWorkerClientInfo::ServiceWorkerClientInfo()
    : url(),
      frame_type(::blink::mojom::RequestContextFrameType::kNone),
      client_uuid(),
      client_type(),
      page_hidden(true),
      is_focused(false),
      lifecycle_state(ServiceWorkerClientLifecycleState::kActive),
      last_focus_time(),
      creation_time() {}

ServiceWorkerClientInfo::ServiceWorkerClientInfo(
    const ::GURL& url_in,
    ::blink::mojom::RequestContextFrameType frame_type_in,
    const std::string& client_uuid_in,
    ServiceWorkerClientType client_type_in,
    bool page_hidden_in,
    bool is_focused_in,
    ServiceWorkerClientLifecycleState lifecycle_state_in,
    ::base::TimeTicks last_focus_time_in,
    ::base::TimeTicks creation_time_in)
    : url(std::move(url_in)),
      frame_type(std::move(frame_type_in)),
      client_uuid(std::move(client_uuid_in)),
      client_type(std::move(client_type_in)),
      page_hidden(std::move(page_hidden_in)),
      is_focused(std::move(is_focused_in)),
      lifecycle_state(std::move(lifecycle_state_in)),
      last_focus_time(std::move(last_focus_time_in)),
      creation_time(std::move(creation_time_in)) {}

ServiceWorkerClientInfo::~ServiceWorkerClientInfo() = default;

void ServiceWorkerClientInfo::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "url"), this->url,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const ::GURL&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "frame_type"), this->frame_type,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::blink::mojom::RequestContextFrameType>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "client_uuid"), this->client_uuid,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::string&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "client_type"), this->client_type,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ServiceWorkerClientType>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "page_hidden"), this->page_hidden,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type bool>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "is_focused"), this->is_focused,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type bool>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "lifecycle_state"), this->lifecycle_state,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ServiceWorkerClientLifecycleState>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "last_focus_time"), this->last_focus_time,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::base::TimeTicks>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "creation_time"), this->creation_time,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::base::TimeTicks>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool ServiceWorkerClientInfo::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}


}  // blink::mojom


namespace mojo {


// static
bool StructTraits<::blink::mojom::ServiceWorkerClientQueryOptions::DataView, ::blink::mojom::ServiceWorkerClientQueryOptionsPtr>::Read(
    ::blink::mojom::ServiceWorkerClientQueryOptions::DataView input,
    ::blink::mojom::ServiceWorkerClientQueryOptionsPtr* output) {
  bool success = true;
  ::blink::mojom::ServiceWorkerClientQueryOptionsPtr result(::blink::mojom::ServiceWorkerClientQueryOptions::New());
  
      if (success)
        result->include_uncontrolled = input.include_uncontrolled();
      if (success && !input.ReadClientType(&result->client_type))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::blink::mojom::ServiceWorkerClientInfo::DataView, ::blink::mojom::ServiceWorkerClientInfoPtr>::Read(
    ::blink::mojom::ServiceWorkerClientInfo::DataView input,
    ::blink::mojom::ServiceWorkerClientInfoPtr* output) {
  bool success = true;
  ::blink::mojom::ServiceWorkerClientInfoPtr result(::blink::mojom::ServiceWorkerClientInfo::New());
  
      if (success && !input.ReadUrl(&result->url))
        success = false;
      if (success && !input.ReadFrameType(&result->frame_type))
        success = false;
      if (success && !input.ReadClientUuid(&result->client_uuid))
        success = false;
      if (success && !input.ReadClientType(&result->client_type))
        success = false;
      if (success)
        result->page_hidden = input.page_hidden();
      if (success)
        result->is_focused = input.is_focused();
      if (success && !input.ReadLifecycleState(&result->lifecycle_state))
        success = false;
      if (success && !input.ReadLastFocusTime(&result->last_focus_time))
        success = false;
      if (success && !input.ReadCreationTime(&result->creation_time))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo


// Symbols declared in the -test-utils.h header are defined here instead of a
// separate .cc file to save compile time.


namespace blink::mojom {




}  // blink::mojom


#if defined(__clang__)
#pragma clang diagnostic pop
#endif