// third_party/blink/public/mojom/speech/speech_recognition_error.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_SPEECH_SPEECH_RECOGNITION_ERROR_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_SPEECH_SPEECH_RECOGNITION_ERROR_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/speech/speech_recognition_error.mojom-shared-internal.h"
#include "third_party/blink/public/mojom/speech/speech_recognition_error_code.mojom-shared.h"



#include "base/component_export.h"




namespace blink::mojom {
class SpeechRecognitionErrorDataView;



}  // blink::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::SpeechRecognitionErrorDataView> {
  using Data = ::blink::mojom::internal::SpeechRecognitionError_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace blink::mojom {


enum class SpeechAudioErrorDetails : int32_t {
  
  kNone = 0,
  
  kNoMic = 1,
  kMinValue = 0,
  kMaxValue = 1,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, SpeechAudioErrorDetails value);
inline bool IsKnownEnumValue(SpeechAudioErrorDetails value) {
  return internal::SpeechAudioErrorDetails_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


class SpeechRecognitionErrorDataView {
 public:
  SpeechRecognitionErrorDataView() = default;

  SpeechRecognitionErrorDataView(
      internal::SpeechRecognitionError_Data* data,
      mojo::Message* message)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  [[nodiscard]] bool ReadCode(UserType* output) const {
    auto data_value = data_->code;
    return mojo::internal::Deserialize<::blink::mojom::SpeechRecognitionErrorCode>(
        data_value, output);
  }
  ::blink::mojom::SpeechRecognitionErrorCode code() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::blink::mojom::SpeechRecognitionErrorCode>(data_->code));
  }
  template <typename UserType>
  [[nodiscard]] bool ReadDetails(UserType* output) const {
    auto data_value = data_->details;
    return mojo::internal::Deserialize<::blink::mojom::SpeechAudioErrorDetails>(
        data_value, output);
  }
  SpeechAudioErrorDetails details() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::blink::mojom::SpeechAudioErrorDetails>(data_->details));
  }
 private:
  internal::SpeechRecognitionError_Data* data_ = nullptr;
};


}  // blink::mojom

namespace std {

template <>
struct hash<::blink::mojom::SpeechAudioErrorDetails>
    : public mojo::internal::EnumHashImpl<::blink::mojom::SpeechAudioErrorDetails> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::SpeechAudioErrorDetails, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::SpeechAudioErrorDetails, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::SpeechAudioErrorDetails>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::SpeechRecognitionErrorDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::SpeechRecognitionErrorDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::SpeechRecognitionError_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    mojo::internal::Serialize<::blink::mojom::SpeechRecognitionErrorCode>(
        Traits::code(input), &fragment->code);
    mojo::internal::Serialize<::blink::mojom::SpeechAudioErrorDetails>(
        Traits::details(input), &fragment->details);
  }

  static bool Deserialize(::blink::mojom::internal::SpeechRecognitionError_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::SpeechRecognitionErrorDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink::mojom {




}  // blink::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::SpeechAudioErrorDetails> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::SpeechAudioErrorDetails value);
};

} // namespace perfetto

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_SPEECH_SPEECH_RECOGNITION_ERROR_MOJOM_SHARED_H_