// third_party/blink/public/mojom/webid/federated_auth_request.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBID_FEDERATED_AUTH_REQUEST_MOJOM_BLINK_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBID_FEDERATED_AUTH_REQUEST_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include <optional>
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/webid/federated_auth_request.mojom-features.h"
#include "third_party/blink/public/mojom/webid/federated_auth_request.mojom-shared.h"
#include "third_party/blink/public/mojom/webid/federated_auth_request.mojom-blink-forward.h"
#include "third_party/blink/public/mojom/credentialmanagement/credential_manager.mojom-blink-forward.h"
#include "url/mojom/url.mojom-blink.h"
#include "url/mojom/origin.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/renderer/platform/platform_export.h"




namespace blink::mojom::blink {

class FederatedAuthRequestProxy;

template <typename ImplRefTraits>
class FederatedAuthRequestStub;

class FederatedAuthRequestRequestValidator;
class FederatedAuthRequestResponseValidator;


class PLATFORM_EXPORT FederatedAuthRequest
    : public FederatedAuthRequestInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = FederatedAuthRequestInterfaceBase;
  using Proxy_ = FederatedAuthRequestProxy;

  template <typename ImplRefTraits>
  using Stub_ = FederatedAuthRequestStub<ImplRefTraits>;

  using RequestValidator_ = FederatedAuthRequestRequestValidator;
  using ResponseValidator_ = FederatedAuthRequestResponseValidator;
  enum MethodMinVersions : uint32_t {
    kRequestTokenMinVersion = 0,
    kRequestUserInfoMinVersion = 0,
    kCancelTokenRequestMinVersion = 0,
    kResolveTokenRequestMinVersion = 0,
    kSetIdpSigninStatusMinVersion = 0,
    kRegisterIdPMinVersion = 0,
    kUnregisterIdPMinVersion = 0,
    kCloseModalDialogViewMinVersion = 0,
    kPreventSilentAccessMinVersion = 0,
    kDisconnectMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct RequestToken_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct RequestUserInfo_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct CancelTokenRequest_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct ResolveTokenRequest_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct SetIdpSigninStatus_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct RegisterIdP_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct UnregisterIdP_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct CloseModalDialogView_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct PreventSilentAccess_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct Disconnect_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~FederatedAuthRequest() = default;


  using RequestTokenCallback = base::OnceCallback<void(RequestTokenStatus, const std::optional<::blink::KURL>&, const WTF::String&, TokenErrorPtr, bool)>;
  
  virtual void RequestToken(WTF::Vector<IdentityProviderGetParametersPtr> idp_get_params, ::blink::mojom::blink::CredentialMediationRequirement requirement, RequestTokenCallback callback) = 0;


  using RequestUserInfoCallback = base::OnceCallback<void(RequestUserInfoStatus, std::optional<WTF::Vector<IdentityUserInfoPtr>>)>;
  
  virtual void RequestUserInfo(IdentityProviderConfigPtr provider, RequestUserInfoCallback callback) = 0;

  
  virtual void CancelTokenRequest() = 0;


  using ResolveTokenRequestCallback = base::OnceCallback<void(bool)>;
  
  virtual void ResolveTokenRequest(const WTF::String& token, ResolveTokenRequestCallback callback) = 0;

  
  virtual void SetIdpSigninStatus(const ::scoped_refptr<const ::blink::SecurityOrigin>& origin, IdpSigninStatus status) = 0;


  using RegisterIdPCallback = base::OnceCallback<void(bool)>;
  
  virtual void RegisterIdP(const ::blink::KURL& url, RegisterIdPCallback callback) = 0;


  using UnregisterIdPCallback = base::OnceCallback<void(bool)>;
  
  virtual void UnregisterIdP(const ::blink::KURL& url, UnregisterIdPCallback callback) = 0;

  
  virtual void CloseModalDialogView() = 0;


  using PreventSilentAccessCallback = base::OnceCallback<void()>;
  
  virtual void PreventSilentAccess(PreventSilentAccessCallback callback) = 0;


  using DisconnectCallback = base::OnceCallback<void(DisconnectStatus)>;
  
  virtual void Disconnect(IdentityCredentialDisconnectOptionsPtr options, DisconnectCallback callback) = 0;
};



class PLATFORM_EXPORT FederatedAuthRequestProxy
    : public FederatedAuthRequest {
 public:
  using InterfaceType = FederatedAuthRequest;

  explicit FederatedAuthRequestProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void RequestToken(WTF::Vector<IdentityProviderGetParametersPtr> idp_get_params, ::blink::mojom::blink::CredentialMediationRequirement requirement, RequestTokenCallback callback) final;
  
  void RequestUserInfo(IdentityProviderConfigPtr provider, RequestUserInfoCallback callback) final;
  
  void CancelTokenRequest() final;
  
  void ResolveTokenRequest(const WTF::String& token, ResolveTokenRequestCallback callback) final;
  
  void SetIdpSigninStatus(const ::scoped_refptr<const ::blink::SecurityOrigin>& origin, IdpSigninStatus status) final;
  
  void RegisterIdP(const ::blink::KURL& url, RegisterIdPCallback callback) final;
  
  void UnregisterIdP(const ::blink::KURL& url, UnregisterIdPCallback callback) final;
  
  void CloseModalDialogView() final;
  
  void PreventSilentAccess(PreventSilentAccessCallback callback) final;
  
  void Disconnect(IdentityCredentialDisconnectOptionsPtr options, DisconnectCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class PLATFORM_EXPORT FederatedAuthRequestStubDispatch {
 public:
  static bool Accept(FederatedAuthRequest* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      FederatedAuthRequest* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<FederatedAuthRequest>>
class FederatedAuthRequestStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  FederatedAuthRequestStub() = default;
  ~FederatedAuthRequestStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return FederatedAuthRequestStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return FederatedAuthRequestStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class PLATFORM_EXPORT FederatedAuthRequestRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class PLATFORM_EXPORT FederatedAuthRequestResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};







class PLATFORM_EXPORT DigitalCredentialFieldRequirement {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<DigitalCredentialFieldRequirement, T>::value>;
  using DataView = DigitalCredentialFieldRequirementDataView;
  using Data_ = internal::DigitalCredentialFieldRequirement_Data;

  template <typename... Args>
  static DigitalCredentialFieldRequirementPtr New(Args&&... args) {
    return DigitalCredentialFieldRequirementPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static DigitalCredentialFieldRequirementPtr From(const U& u) {
    return mojo::TypeConverter<DigitalCredentialFieldRequirementPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, DigitalCredentialFieldRequirement>::Convert(*this);
  }


  DigitalCredentialFieldRequirement();

  DigitalCredentialFieldRequirement(
      const WTF::String& name,
      const WTF::String& equals);


  ~DigitalCredentialFieldRequirement();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = DigitalCredentialFieldRequirementPtr>
  DigitalCredentialFieldRequirementPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, DigitalCredentialFieldRequirement::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, DigitalCredentialFieldRequirement::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, DigitalCredentialFieldRequirement::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        DigitalCredentialFieldRequirement::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        DigitalCredentialFieldRequirement::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::DigitalCredentialFieldRequirement_UnserializedMessageContext<
            UserType, DigitalCredentialFieldRequirement::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<DigitalCredentialFieldRequirement::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return DigitalCredentialFieldRequirement::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::DigitalCredentialFieldRequirement_UnserializedMessageContext<
            UserType, DigitalCredentialFieldRequirement::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<DigitalCredentialFieldRequirement::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  WTF::String name;
  
  WTF::String equals;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, DigitalCredentialFieldRequirement::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, DigitalCredentialFieldRequirement::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, DigitalCredentialFieldRequirement::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, DigitalCredentialFieldRequirement::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}








class PLATFORM_EXPORT IdentityUserInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<IdentityUserInfo, T>::value>;
  using DataView = IdentityUserInfoDataView;
  using Data_ = internal::IdentityUserInfo_Data;

  template <typename... Args>
  static IdentityUserInfoPtr New(Args&&... args) {
    return IdentityUserInfoPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static IdentityUserInfoPtr From(const U& u) {
    return mojo::TypeConverter<IdentityUserInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, IdentityUserInfo>::Convert(*this);
  }


  IdentityUserInfo();

  IdentityUserInfo(
      const WTF::String& email,
      const WTF::String& given_name,
      const WTF::String& name,
      const WTF::String& picture);


  ~IdentityUserInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = IdentityUserInfoPtr>
  IdentityUserInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, IdentityUserInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, IdentityUserInfo::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, IdentityUserInfo::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        IdentityUserInfo::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        IdentityUserInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::IdentityUserInfo_UnserializedMessageContext<
            UserType, IdentityUserInfo::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<IdentityUserInfo::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return IdentityUserInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::IdentityUserInfo_UnserializedMessageContext<
            UserType, IdentityUserInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<IdentityUserInfo::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  WTF::String email;
  
  WTF::String given_name;
  
  WTF::String name;
  
  WTF::String picture;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, IdentityUserInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, IdentityUserInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, IdentityUserInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, IdentityUserInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class PLATFORM_EXPORT TokenError {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<TokenError, T>::value>;
  using DataView = TokenErrorDataView;
  using Data_ = internal::TokenError_Data;

  template <typename... Args>
  static TokenErrorPtr New(Args&&... args) {
    return TokenErrorPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static TokenErrorPtr From(const U& u) {
    return mojo::TypeConverter<TokenErrorPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, TokenError>::Convert(*this);
  }


  TokenError();

  TokenError(
      const WTF::String& code,
      const WTF::String& url);


  ~TokenError();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = TokenErrorPtr>
  TokenErrorPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, TokenError::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, TokenError::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, TokenError::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        TokenError::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        TokenError::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::TokenError_UnserializedMessageContext<
            UserType, TokenError::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<TokenError::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return TokenError::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::TokenError_UnserializedMessageContext<
            UserType, TokenError::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<TokenError::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  WTF::String code;
  
  WTF::String url;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, TokenError::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, TokenError::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, TokenError::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, TokenError::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class PLATFORM_EXPORT IdentityProvider {
 public:
  using DataView = IdentityProviderDataView;
  using Data_ = internal::IdentityProvider_Data;
  using Tag = Data_::IdentityProvider_Tag;

  template <typename... Args>
  static IdentityProviderPtr New(Args&&... args) {
    static_assert(
        sizeof...(args) < 0,
        "Do not use Union::New(); to create a union of a given subtype, use "
        "New<SubType>(), not New() followed by set_<sub_type>(). To represent "
        "an empty union, mark the field or parameter as nullable in the mojom "
        "definition.");
    return nullptr;
  }
  // Construct an instance holding |federated|.
  static IdentityProviderPtr
  NewFederated(
      IdentityProviderRequestOptionsPtr value) {
    auto result = IdentityProviderPtr(absl::in_place);
    result->set_federated(std::move(value));
    return result;
  }
  // Construct an instance holding |holder|.
  static IdentityProviderPtr
  NewHolder(
      DigitalCredentialProviderPtr value) {
    auto result = IdentityProviderPtr(absl::in_place);
    result->set_holder(std::move(value));
    return result;
  }

  template <typename U>
  static IdentityProviderPtr From(const U& u) {
    return mojo::TypeConverter<IdentityProviderPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, IdentityProvider>::Convert(*this);
  }

  IdentityProvider();
  ~IdentityProvider();
  // Delete the copy constructor and copy assignment operators because `data_`
  // contains raw pointers that must not be copied.
  IdentityProvider(const IdentityProvider& other) = delete;
  IdentityProvider& operator=(const IdentityProvider& other) = delete;

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = IdentityProviderPtr>
  IdentityProviderPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, IdentityProvider>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename T,
            typename std::enable_if<std::is_same<
                T, IdentityProvider>::value>::type* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  Tag which() const {
    return tag_;
  }


  
  bool is_federated() const { return tag_ == Tag::kFederated; }

  
  IdentityProviderRequestOptionsPtr& get_federated() const {
    CHECK(tag_ == Tag::kFederated);
    return *(data_.federated);
  }

  
  void set_federated(
      IdentityProviderRequestOptionsPtr federated);
  
  bool is_holder() const { return tag_ == Tag::kHolder; }

  
  DigitalCredentialProviderPtr& get_holder() const {
    CHECK(tag_ == Tag::kHolder);
    return *(data_.holder);
  }

  
  void set_holder(
      DigitalCredentialProviderPtr holder);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        IdentityProvider::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<IdentityProvider::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

 private:
  union Union_ {
    Union_() = default;
    ~Union_() = default;
    IdentityProviderRequestOptionsPtr* federated;
    DigitalCredentialProviderPtr* holder;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};





class PLATFORM_EXPORT DigitalCredentialProvider {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<DigitalCredentialProvider, T>::value>;
  using DataView = DigitalCredentialProviderDataView;
  using Data_ = internal::DigitalCredentialProvider_Data;

  template <typename... Args>
  static DigitalCredentialProviderPtr New(Args&&... args) {
    return DigitalCredentialProviderPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static DigitalCredentialProviderPtr From(const U& u) {
    return mojo::TypeConverter<DigitalCredentialProviderPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, DigitalCredentialProvider>::Convert(*this);
  }


  DigitalCredentialProvider();

  DigitalCredentialProvider(
      const std::optional<WTF::HashMap<WTF::String, WTF::String>>& params,
      DigitalCredentialSelectorPtr selector,
      const WTF::String& protocol,
      const WTF::String& request,
      const WTF::String& publicKey);

DigitalCredentialProvider(const DigitalCredentialProvider&) = delete;
DigitalCredentialProvider& operator=(const DigitalCredentialProvider&) = delete;

  ~DigitalCredentialProvider();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = DigitalCredentialProviderPtr>
  DigitalCredentialProviderPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, DigitalCredentialProvider::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, DigitalCredentialProvider::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, DigitalCredentialProvider::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        DigitalCredentialProvider::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        DigitalCredentialProvider::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::DigitalCredentialProvider_UnserializedMessageContext<
            UserType, DigitalCredentialProvider::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<DigitalCredentialProvider::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return DigitalCredentialProvider::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::DigitalCredentialProvider_UnserializedMessageContext<
            UserType, DigitalCredentialProvider::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<DigitalCredentialProvider::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::optional<WTF::HashMap<WTF::String, WTF::String>> params;
  
  DigitalCredentialSelectorPtr selector;
  
  WTF::String protocol;
  
  WTF::String request;
  
  WTF::String publicKey;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, DigitalCredentialProvider::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, DigitalCredentialProvider::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, DigitalCredentialProvider::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, DigitalCredentialProvider::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class PLATFORM_EXPORT DigitalCredentialSelector {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<DigitalCredentialSelector, T>::value>;
  using DataView = DigitalCredentialSelectorDataView;
  using Data_ = internal::DigitalCredentialSelector_Data;

  template <typename... Args>
  static DigitalCredentialSelectorPtr New(Args&&... args) {
    return DigitalCredentialSelectorPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static DigitalCredentialSelectorPtr From(const U& u) {
    return mojo::TypeConverter<DigitalCredentialSelectorPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, DigitalCredentialSelector>::Convert(*this);
  }


  DigitalCredentialSelector();

  DigitalCredentialSelector(
      WTF::Vector<WTF::String> format,
      const WTF::String& doctype,
      WTF::Vector<DigitalCredentialFieldRequirementPtr> fields);

DigitalCredentialSelector(const DigitalCredentialSelector&) = delete;
DigitalCredentialSelector& operator=(const DigitalCredentialSelector&) = delete;

  ~DigitalCredentialSelector();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = DigitalCredentialSelectorPtr>
  DigitalCredentialSelectorPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, DigitalCredentialSelector::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, DigitalCredentialSelector::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, DigitalCredentialSelector::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        DigitalCredentialSelector::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        DigitalCredentialSelector::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::DigitalCredentialSelector_UnserializedMessageContext<
            UserType, DigitalCredentialSelector::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<DigitalCredentialSelector::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return DigitalCredentialSelector::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::DigitalCredentialSelector_UnserializedMessageContext<
            UserType, DigitalCredentialSelector::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<DigitalCredentialSelector::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  WTF::Vector<WTF::String> format;
  
  WTF::String doctype;
  
  WTF::Vector<DigitalCredentialFieldRequirementPtr> fields;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, DigitalCredentialSelector::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, DigitalCredentialSelector::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, DigitalCredentialSelector::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, DigitalCredentialSelector::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class PLATFORM_EXPORT IdentityProviderConfig {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<IdentityProviderConfig, T>::value>;
  using DataView = IdentityProviderConfigDataView;
  using Data_ = internal::IdentityProviderConfig_Data;

  template <typename... Args>
  static IdentityProviderConfigPtr New(Args&&... args) {
    return IdentityProviderConfigPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static IdentityProviderConfigPtr From(const U& u) {
    return mojo::TypeConverter<IdentityProviderConfigPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, IdentityProviderConfig>::Convert(*this);
  }


  IdentityProviderConfig();

  IdentityProviderConfig(
      const ::blink::KURL& config_url,
      bool use_registered_config_urls,
      const WTF::String& client_id);


  ~IdentityProviderConfig();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = IdentityProviderConfigPtr>
  IdentityProviderConfigPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, IdentityProviderConfig::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, IdentityProviderConfig::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, IdentityProviderConfig::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        IdentityProviderConfig::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        IdentityProviderConfig::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::IdentityProviderConfig_UnserializedMessageContext<
            UserType, IdentityProviderConfig::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<IdentityProviderConfig::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return IdentityProviderConfig::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::IdentityProviderConfig_UnserializedMessageContext<
            UserType, IdentityProviderConfig::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<IdentityProviderConfig::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::blink::KURL config_url;
  
  bool use_registered_config_urls;
  
  WTF::String client_id;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, IdentityProviderConfig::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, IdentityProviderConfig::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, IdentityProviderConfig::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, IdentityProviderConfig::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class PLATFORM_EXPORT IdentityProviderRequestOptions {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<IdentityProviderRequestOptions, T>::value>;
  using DataView = IdentityProviderRequestOptionsDataView;
  using Data_ = internal::IdentityProviderRequestOptions_Data;

  template <typename... Args>
  static IdentityProviderRequestOptionsPtr New(Args&&... args) {
    return IdentityProviderRequestOptionsPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static IdentityProviderRequestOptionsPtr From(const U& u) {
    return mojo::TypeConverter<IdentityProviderRequestOptionsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, IdentityProviderRequestOptions>::Convert(*this);
  }


  IdentityProviderRequestOptions();

  IdentityProviderRequestOptions(
      IdentityProviderConfigPtr config,
      const WTF::String& nonce,
      const WTF::String& login_hint,
      const WTF::String& domain_hint,
      WTF::Vector<WTF::String> scope,
      WTF::Vector<WTF::String> responseType,
      const WTF::HashMap<WTF::String, WTF::String>& params);

IdentityProviderRequestOptions(const IdentityProviderRequestOptions&) = delete;
IdentityProviderRequestOptions& operator=(const IdentityProviderRequestOptions&) = delete;

  ~IdentityProviderRequestOptions();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = IdentityProviderRequestOptionsPtr>
  IdentityProviderRequestOptionsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, IdentityProviderRequestOptions::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, IdentityProviderRequestOptions::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, IdentityProviderRequestOptions::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        IdentityProviderRequestOptions::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        IdentityProviderRequestOptions::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::IdentityProviderRequestOptions_UnserializedMessageContext<
            UserType, IdentityProviderRequestOptions::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<IdentityProviderRequestOptions::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return IdentityProviderRequestOptions::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::IdentityProviderRequestOptions_UnserializedMessageContext<
            UserType, IdentityProviderRequestOptions::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<IdentityProviderRequestOptions::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  IdentityProviderConfigPtr config;
  
  WTF::String nonce;
  
  WTF::String login_hint;
  
  WTF::String domain_hint;
  
  WTF::Vector<WTF::String> scope;
  
  WTF::Vector<WTF::String> responseType;
  
  WTF::HashMap<WTF::String, WTF::String> params;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, IdentityProviderRequestOptions::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, IdentityProviderRequestOptions::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, IdentityProviderRequestOptions::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, IdentityProviderRequestOptions::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class PLATFORM_EXPORT IdentityCredentialDisconnectOptions {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<IdentityCredentialDisconnectOptions, T>::value>;
  using DataView = IdentityCredentialDisconnectOptionsDataView;
  using Data_ = internal::IdentityCredentialDisconnectOptions_Data;

  template <typename... Args>
  static IdentityCredentialDisconnectOptionsPtr New(Args&&... args) {
    return IdentityCredentialDisconnectOptionsPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static IdentityCredentialDisconnectOptionsPtr From(const U& u) {
    return mojo::TypeConverter<IdentityCredentialDisconnectOptionsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, IdentityCredentialDisconnectOptions>::Convert(*this);
  }


  IdentityCredentialDisconnectOptions();

  IdentityCredentialDisconnectOptions(
      IdentityProviderConfigPtr config,
      const WTF::String& account_hint);

IdentityCredentialDisconnectOptions(const IdentityCredentialDisconnectOptions&) = delete;
IdentityCredentialDisconnectOptions& operator=(const IdentityCredentialDisconnectOptions&) = delete;

  ~IdentityCredentialDisconnectOptions();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = IdentityCredentialDisconnectOptionsPtr>
  IdentityCredentialDisconnectOptionsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, IdentityCredentialDisconnectOptions::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, IdentityCredentialDisconnectOptions::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, IdentityCredentialDisconnectOptions::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        IdentityCredentialDisconnectOptions::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        IdentityCredentialDisconnectOptions::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::IdentityCredentialDisconnectOptions_UnserializedMessageContext<
            UserType, IdentityCredentialDisconnectOptions::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<IdentityCredentialDisconnectOptions::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return IdentityCredentialDisconnectOptions::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::IdentityCredentialDisconnectOptions_UnserializedMessageContext<
            UserType, IdentityCredentialDisconnectOptions::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<IdentityCredentialDisconnectOptions::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  IdentityProviderConfigPtr config;
  
  WTF::String account_hint;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, IdentityCredentialDisconnectOptions::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, IdentityCredentialDisconnectOptions::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, IdentityCredentialDisconnectOptions::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, IdentityCredentialDisconnectOptions::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class PLATFORM_EXPORT IdentityProviderGetParameters {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<IdentityProviderGetParameters, T>::value>;
  using DataView = IdentityProviderGetParametersDataView;
  using Data_ = internal::IdentityProviderGetParameters_Data;

  template <typename... Args>
  static IdentityProviderGetParametersPtr New(Args&&... args) {
    return IdentityProviderGetParametersPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static IdentityProviderGetParametersPtr From(const U& u) {
    return mojo::TypeConverter<IdentityProviderGetParametersPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, IdentityProviderGetParameters>::Convert(*this);
  }


  IdentityProviderGetParameters();

  IdentityProviderGetParameters(
      WTF::Vector<IdentityProviderPtr> providers,
      RpContext context,
      RpMode mode);

IdentityProviderGetParameters(const IdentityProviderGetParameters&) = delete;
IdentityProviderGetParameters& operator=(const IdentityProviderGetParameters&) = delete;

  ~IdentityProviderGetParameters();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = IdentityProviderGetParametersPtr>
  IdentityProviderGetParametersPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, IdentityProviderGetParameters::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, IdentityProviderGetParameters::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, IdentityProviderGetParameters::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        IdentityProviderGetParameters::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        IdentityProviderGetParameters::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::IdentityProviderGetParameters_UnserializedMessageContext<
            UserType, IdentityProviderGetParameters::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<IdentityProviderGetParameters::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return IdentityProviderGetParameters::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::IdentityProviderGetParameters_UnserializedMessageContext<
            UserType, IdentityProviderGetParameters::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<IdentityProviderGetParameters::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  WTF::Vector<IdentityProviderPtr> providers;
  
  RpContext context;
  
  RpMode mode;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, IdentityProviderGetParameters::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, IdentityProviderGetParameters::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, IdentityProviderGetParameters::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, IdentityProviderGetParameters::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}


template <typename UnionPtrType>
IdentityProviderPtr IdentityProvider::Clone() const {
  switch (tag_) {
    case Tag::kFederated:
      return NewFederated(
          mojo::Clone(*data_.federated));
    case Tag::kHolder:
      return NewHolder(
          mojo::Clone(*data_.holder));
  }
  return nullptr;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, IdentityProvider>::value>::type*>
bool IdentityProvider::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::kFederated:
      return mojo::Equals(*(data_.federated), *(other.data_.federated));
    case Tag::kHolder:
      return mojo::Equals(*(data_.holder), *(other.data_.holder));
  }

  return false;
}
template <typename StructPtrType>
DigitalCredentialProviderPtr DigitalCredentialProvider::Clone() const {
  return New(
      mojo::Clone(params),
      mojo::Clone(selector),
      mojo::Clone(protocol),
      mojo::Clone(request),
      mojo::Clone(publicKey)
  );
}

template <typename T, DigitalCredentialProvider::EnableIfSame<T>*>
bool DigitalCredentialProvider::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->params, other_struct.params))
    return false;
  if (!mojo::Equals(this->selector, other_struct.selector))
    return false;
  if (!mojo::Equals(this->protocol, other_struct.protocol))
    return false;
  if (!mojo::Equals(this->request, other_struct.request))
    return false;
  if (!mojo::Equals(this->publicKey, other_struct.publicKey))
    return false;
  return true;
}

template <typename T, DigitalCredentialProvider::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.params < rhs.params)
    return true;
  if (rhs.params < lhs.params)
    return false;
  if (lhs.selector < rhs.selector)
    return true;
  if (rhs.selector < lhs.selector)
    return false;
  if (lhs.protocol < rhs.protocol)
    return true;
  if (rhs.protocol < lhs.protocol)
    return false;
  if (lhs.request < rhs.request)
    return true;
  if (rhs.request < lhs.request)
    return false;
  if (lhs.publicKey < rhs.publicKey)
    return true;
  if (rhs.publicKey < lhs.publicKey)
    return false;
  return false;
}
template <typename StructPtrType>
DigitalCredentialSelectorPtr DigitalCredentialSelector::Clone() const {
  return New(
      mojo::Clone(format),
      mojo::Clone(doctype),
      mojo::Clone(fields)
  );
}

template <typename T, DigitalCredentialSelector::EnableIfSame<T>*>
bool DigitalCredentialSelector::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->format, other_struct.format))
    return false;
  if (!mojo::Equals(this->doctype, other_struct.doctype))
    return false;
  if (!mojo::Equals(this->fields, other_struct.fields))
    return false;
  return true;
}

template <typename T, DigitalCredentialSelector::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.format < rhs.format)
    return true;
  if (rhs.format < lhs.format)
    return false;
  if (lhs.doctype < rhs.doctype)
    return true;
  if (rhs.doctype < lhs.doctype)
    return false;
  if (lhs.fields < rhs.fields)
    return true;
  if (rhs.fields < lhs.fields)
    return false;
  return false;
}
template <typename StructPtrType>
DigitalCredentialFieldRequirementPtr DigitalCredentialFieldRequirement::Clone() const {
  return New(
      mojo::Clone(name),
      mojo::Clone(equals)
  );
}

template <typename T, DigitalCredentialFieldRequirement::EnableIfSame<T>*>
bool DigitalCredentialFieldRequirement::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->name, other_struct.name))
    return false;
  if (!mojo::Equals(this->equals, other_struct.equals))
    return false;
  return true;
}

template <typename T, DigitalCredentialFieldRequirement::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.name < rhs.name)
    return true;
  if (rhs.name < lhs.name)
    return false;
  if (lhs.equals < rhs.equals)
    return true;
  if (rhs.equals < lhs.equals)
    return false;
  return false;
}
template <typename StructPtrType>
IdentityProviderConfigPtr IdentityProviderConfig::Clone() const {
  return New(
      mojo::Clone(config_url),
      mojo::Clone(use_registered_config_urls),
      mojo::Clone(client_id)
  );
}

template <typename T, IdentityProviderConfig::EnableIfSame<T>*>
bool IdentityProviderConfig::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->config_url, other_struct.config_url))
    return false;
  if (!mojo::Equals(this->use_registered_config_urls, other_struct.use_registered_config_urls))
    return false;
  if (!mojo::Equals(this->client_id, other_struct.client_id))
    return false;
  return true;
}

template <typename T, IdentityProviderConfig::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.config_url < rhs.config_url)
    return true;
  if (rhs.config_url < lhs.config_url)
    return false;
  if (lhs.use_registered_config_urls < rhs.use_registered_config_urls)
    return true;
  if (rhs.use_registered_config_urls < lhs.use_registered_config_urls)
    return false;
  if (lhs.client_id < rhs.client_id)
    return true;
  if (rhs.client_id < lhs.client_id)
    return false;
  return false;
}
template <typename StructPtrType>
IdentityProviderRequestOptionsPtr IdentityProviderRequestOptions::Clone() const {
  return New(
      mojo::Clone(config),
      mojo::Clone(nonce),
      mojo::Clone(login_hint),
      mojo::Clone(domain_hint),
      mojo::Clone(scope),
      mojo::Clone(responseType),
      mojo::Clone(params)
  );
}

template <typename T, IdentityProviderRequestOptions::EnableIfSame<T>*>
bool IdentityProviderRequestOptions::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->config, other_struct.config))
    return false;
  if (!mojo::Equals(this->nonce, other_struct.nonce))
    return false;
  if (!mojo::Equals(this->login_hint, other_struct.login_hint))
    return false;
  if (!mojo::Equals(this->domain_hint, other_struct.domain_hint))
    return false;
  if (!mojo::Equals(this->scope, other_struct.scope))
    return false;
  if (!mojo::Equals(this->responseType, other_struct.responseType))
    return false;
  if (!mojo::Equals(this->params, other_struct.params))
    return false;
  return true;
}

template <typename T, IdentityProviderRequestOptions::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.config < rhs.config)
    return true;
  if (rhs.config < lhs.config)
    return false;
  if (lhs.nonce < rhs.nonce)
    return true;
  if (rhs.nonce < lhs.nonce)
    return false;
  if (lhs.login_hint < rhs.login_hint)
    return true;
  if (rhs.login_hint < lhs.login_hint)
    return false;
  if (lhs.domain_hint < rhs.domain_hint)
    return true;
  if (rhs.domain_hint < lhs.domain_hint)
    return false;
  if (lhs.scope < rhs.scope)
    return true;
  if (rhs.scope < lhs.scope)
    return false;
  if (lhs.responseType < rhs.responseType)
    return true;
  if (rhs.responseType < lhs.responseType)
    return false;
  if (lhs.params < rhs.params)
    return true;
  if (rhs.params < lhs.params)
    return false;
  return false;
}
template <typename StructPtrType>
IdentityCredentialDisconnectOptionsPtr IdentityCredentialDisconnectOptions::Clone() const {
  return New(
      mojo::Clone(config),
      mojo::Clone(account_hint)
  );
}

template <typename T, IdentityCredentialDisconnectOptions::EnableIfSame<T>*>
bool IdentityCredentialDisconnectOptions::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->config, other_struct.config))
    return false;
  if (!mojo::Equals(this->account_hint, other_struct.account_hint))
    return false;
  return true;
}

template <typename T, IdentityCredentialDisconnectOptions::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.config < rhs.config)
    return true;
  if (rhs.config < lhs.config)
    return false;
  if (lhs.account_hint < rhs.account_hint)
    return true;
  if (rhs.account_hint < lhs.account_hint)
    return false;
  return false;
}
template <typename StructPtrType>
IdentityUserInfoPtr IdentityUserInfo::Clone() const {
  return New(
      mojo::Clone(email),
      mojo::Clone(given_name),
      mojo::Clone(name),
      mojo::Clone(picture)
  );
}

template <typename T, IdentityUserInfo::EnableIfSame<T>*>
bool IdentityUserInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->email, other_struct.email))
    return false;
  if (!mojo::Equals(this->given_name, other_struct.given_name))
    return false;
  if (!mojo::Equals(this->name, other_struct.name))
    return false;
  if (!mojo::Equals(this->picture, other_struct.picture))
    return false;
  return true;
}

template <typename T, IdentityUserInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.email < rhs.email)
    return true;
  if (rhs.email < lhs.email)
    return false;
  if (lhs.given_name < rhs.given_name)
    return true;
  if (rhs.given_name < lhs.given_name)
    return false;
  if (lhs.name < rhs.name)
    return true;
  if (rhs.name < lhs.name)
    return false;
  if (lhs.picture < rhs.picture)
    return true;
  if (rhs.picture < lhs.picture)
    return false;
  return false;
}
template <typename StructPtrType>
IdentityProviderGetParametersPtr IdentityProviderGetParameters::Clone() const {
  return New(
      mojo::Clone(providers),
      mojo::Clone(context),
      mojo::Clone(mode)
  );
}

template <typename T, IdentityProviderGetParameters::EnableIfSame<T>*>
bool IdentityProviderGetParameters::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->providers, other_struct.providers))
    return false;
  if (!mojo::Equals(this->context, other_struct.context))
    return false;
  if (!mojo::Equals(this->mode, other_struct.mode))
    return false;
  return true;
}

template <typename T, IdentityProviderGetParameters::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.providers < rhs.providers)
    return true;
  if (rhs.providers < lhs.providers)
    return false;
  if (lhs.context < rhs.context)
    return true;
  if (rhs.context < lhs.context)
    return false;
  if (lhs.mode < rhs.mode)
    return true;
  if (rhs.mode < lhs.mode)
    return false;
  return false;
}
template <typename StructPtrType>
TokenErrorPtr TokenError::Clone() const {
  return New(
      mojo::Clone(code),
      mojo::Clone(url)
  );
}

template <typename T, TokenError::EnableIfSame<T>*>
bool TokenError::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->code, other_struct.code))
    return false;
  if (!mojo::Equals(this->url, other_struct.url))
    return false;
  return true;
}

template <typename T, TokenError::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.code < rhs.code)
    return true;
  if (rhs.code < lhs.code)
    return false;
  if (lhs.url < rhs.url)
    return true;
  if (rhs.url < lhs.url)
    return false;
  return false;
}


}  // blink::mojom::blink

namespace mojo {


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::DigitalCredentialProvider::DataView,
                                         ::blink::mojom::blink::DigitalCredentialProviderPtr> {
  static bool IsNull(const ::blink::mojom::blink::DigitalCredentialProviderPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::DigitalCredentialProviderPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::blink::DigitalCredentialProvider::params)& params(
      const ::blink::mojom::blink::DigitalCredentialProviderPtr& input) {
    return input->params;
  }

  static const decltype(::blink::mojom::blink::DigitalCredentialProvider::selector)& selector(
      const ::blink::mojom::blink::DigitalCredentialProviderPtr& input) {
    return input->selector;
  }

  static const decltype(::blink::mojom::blink::DigitalCredentialProvider::protocol)& protocol(
      const ::blink::mojom::blink::DigitalCredentialProviderPtr& input) {
    return input->protocol;
  }

  static const decltype(::blink::mojom::blink::DigitalCredentialProvider::request)& request(
      const ::blink::mojom::blink::DigitalCredentialProviderPtr& input) {
    return input->request;
  }

  static const decltype(::blink::mojom::blink::DigitalCredentialProvider::publicKey)& publicKey(
      const ::blink::mojom::blink::DigitalCredentialProviderPtr& input) {
    return input->publicKey;
  }

  static bool Read(::blink::mojom::blink::DigitalCredentialProvider::DataView input, ::blink::mojom::blink::DigitalCredentialProviderPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::DigitalCredentialSelector::DataView,
                                         ::blink::mojom::blink::DigitalCredentialSelectorPtr> {
  static bool IsNull(const ::blink::mojom::blink::DigitalCredentialSelectorPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::DigitalCredentialSelectorPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::blink::DigitalCredentialSelector::format)& format(
      const ::blink::mojom::blink::DigitalCredentialSelectorPtr& input) {
    return input->format;
  }

  static const decltype(::blink::mojom::blink::DigitalCredentialSelector::doctype)& doctype(
      const ::blink::mojom::blink::DigitalCredentialSelectorPtr& input) {
    return input->doctype;
  }

  static const decltype(::blink::mojom::blink::DigitalCredentialSelector::fields)& fields(
      const ::blink::mojom::blink::DigitalCredentialSelectorPtr& input) {
    return input->fields;
  }

  static bool Read(::blink::mojom::blink::DigitalCredentialSelector::DataView input, ::blink::mojom::blink::DigitalCredentialSelectorPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::DigitalCredentialFieldRequirement::DataView,
                                         ::blink::mojom::blink::DigitalCredentialFieldRequirementPtr> {
  static bool IsNull(const ::blink::mojom::blink::DigitalCredentialFieldRequirementPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::DigitalCredentialFieldRequirementPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::blink::DigitalCredentialFieldRequirement::name)& name(
      const ::blink::mojom::blink::DigitalCredentialFieldRequirementPtr& input) {
    return input->name;
  }

  static const decltype(::blink::mojom::blink::DigitalCredentialFieldRequirement::equals)& equals(
      const ::blink::mojom::blink::DigitalCredentialFieldRequirementPtr& input) {
    return input->equals;
  }

  static bool Read(::blink::mojom::blink::DigitalCredentialFieldRequirement::DataView input, ::blink::mojom::blink::DigitalCredentialFieldRequirementPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::IdentityProviderConfig::DataView,
                                         ::blink::mojom::blink::IdentityProviderConfigPtr> {
  static bool IsNull(const ::blink::mojom::blink::IdentityProviderConfigPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::IdentityProviderConfigPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::blink::IdentityProviderConfig::config_url)& config_url(
      const ::blink::mojom::blink::IdentityProviderConfigPtr& input) {
    return input->config_url;
  }

  static decltype(::blink::mojom::blink::IdentityProviderConfig::use_registered_config_urls) use_registered_config_urls(
      const ::blink::mojom::blink::IdentityProviderConfigPtr& input) {
    return input->use_registered_config_urls;
  }

  static const decltype(::blink::mojom::blink::IdentityProviderConfig::client_id)& client_id(
      const ::blink::mojom::blink::IdentityProviderConfigPtr& input) {
    return input->client_id;
  }

  static bool Read(::blink::mojom::blink::IdentityProviderConfig::DataView input, ::blink::mojom::blink::IdentityProviderConfigPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::IdentityProviderRequestOptions::DataView,
                                         ::blink::mojom::blink::IdentityProviderRequestOptionsPtr> {
  static bool IsNull(const ::blink::mojom::blink::IdentityProviderRequestOptionsPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::IdentityProviderRequestOptionsPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::blink::IdentityProviderRequestOptions::config)& config(
      const ::blink::mojom::blink::IdentityProviderRequestOptionsPtr& input) {
    return input->config;
  }

  static const decltype(::blink::mojom::blink::IdentityProviderRequestOptions::nonce)& nonce(
      const ::blink::mojom::blink::IdentityProviderRequestOptionsPtr& input) {
    return input->nonce;
  }

  static const decltype(::blink::mojom::blink::IdentityProviderRequestOptions::login_hint)& login_hint(
      const ::blink::mojom::blink::IdentityProviderRequestOptionsPtr& input) {
    return input->login_hint;
  }

  static const decltype(::blink::mojom::blink::IdentityProviderRequestOptions::domain_hint)& domain_hint(
      const ::blink::mojom::blink::IdentityProviderRequestOptionsPtr& input) {
    return input->domain_hint;
  }

  static const decltype(::blink::mojom::blink::IdentityProviderRequestOptions::scope)& scope(
      const ::blink::mojom::blink::IdentityProviderRequestOptionsPtr& input) {
    return input->scope;
  }

  static const decltype(::blink::mojom::blink::IdentityProviderRequestOptions::responseType)& responseType(
      const ::blink::mojom::blink::IdentityProviderRequestOptionsPtr& input) {
    return input->responseType;
  }

  static const decltype(::blink::mojom::blink::IdentityProviderRequestOptions::params)& params(
      const ::blink::mojom::blink::IdentityProviderRequestOptionsPtr& input) {
    return input->params;
  }

  static bool Read(::blink::mojom::blink::IdentityProviderRequestOptions::DataView input, ::blink::mojom::blink::IdentityProviderRequestOptionsPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::IdentityCredentialDisconnectOptions::DataView,
                                         ::blink::mojom::blink::IdentityCredentialDisconnectOptionsPtr> {
  static bool IsNull(const ::blink::mojom::blink::IdentityCredentialDisconnectOptionsPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::IdentityCredentialDisconnectOptionsPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::blink::IdentityCredentialDisconnectOptions::config)& config(
      const ::blink::mojom::blink::IdentityCredentialDisconnectOptionsPtr& input) {
    return input->config;
  }

  static const decltype(::blink::mojom::blink::IdentityCredentialDisconnectOptions::account_hint)& account_hint(
      const ::blink::mojom::blink::IdentityCredentialDisconnectOptionsPtr& input) {
    return input->account_hint;
  }

  static bool Read(::blink::mojom::blink::IdentityCredentialDisconnectOptions::DataView input, ::blink::mojom::blink::IdentityCredentialDisconnectOptionsPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::IdentityUserInfo::DataView,
                                         ::blink::mojom::blink::IdentityUserInfoPtr> {
  static bool IsNull(const ::blink::mojom::blink::IdentityUserInfoPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::IdentityUserInfoPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::blink::IdentityUserInfo::email)& email(
      const ::blink::mojom::blink::IdentityUserInfoPtr& input) {
    return input->email;
  }

  static const decltype(::blink::mojom::blink::IdentityUserInfo::given_name)& given_name(
      const ::blink::mojom::blink::IdentityUserInfoPtr& input) {
    return input->given_name;
  }

  static const decltype(::blink::mojom::blink::IdentityUserInfo::name)& name(
      const ::blink::mojom::blink::IdentityUserInfoPtr& input) {
    return input->name;
  }

  static const decltype(::blink::mojom::blink::IdentityUserInfo::picture)& picture(
      const ::blink::mojom::blink::IdentityUserInfoPtr& input) {
    return input->picture;
  }

  static bool Read(::blink::mojom::blink::IdentityUserInfo::DataView input, ::blink::mojom::blink::IdentityUserInfoPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::IdentityProviderGetParameters::DataView,
                                         ::blink::mojom::blink::IdentityProviderGetParametersPtr> {
  static bool IsNull(const ::blink::mojom::blink::IdentityProviderGetParametersPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::IdentityProviderGetParametersPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::blink::IdentityProviderGetParameters::providers)& providers(
      const ::blink::mojom::blink::IdentityProviderGetParametersPtr& input) {
    return input->providers;
  }

  static decltype(::blink::mojom::blink::IdentityProviderGetParameters::context) context(
      const ::blink::mojom::blink::IdentityProviderGetParametersPtr& input) {
    return input->context;
  }

  static decltype(::blink::mojom::blink::IdentityProviderGetParameters::mode) mode(
      const ::blink::mojom::blink::IdentityProviderGetParametersPtr& input) {
    return input->mode;
  }

  static bool Read(::blink::mojom::blink::IdentityProviderGetParameters::DataView input, ::blink::mojom::blink::IdentityProviderGetParametersPtr* output);
};


template <>
struct PLATFORM_EXPORT StructTraits<::blink::mojom::blink::TokenError::DataView,
                                         ::blink::mojom::blink::TokenErrorPtr> {
  static bool IsNull(const ::blink::mojom::blink::TokenErrorPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::TokenErrorPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::blink::TokenError::code)& code(
      const ::blink::mojom::blink::TokenErrorPtr& input) {
    return input->code;
  }

  static const decltype(::blink::mojom::blink::TokenError::url)& url(
      const ::blink::mojom::blink::TokenErrorPtr& input) {
    return input->url;
  }

  static bool Read(::blink::mojom::blink::TokenError::DataView input, ::blink::mojom::blink::TokenErrorPtr* output);
};


template <>
struct PLATFORM_EXPORT UnionTraits<::blink::mojom::blink::IdentityProvider::DataView,
                                        ::blink::mojom::blink::IdentityProviderPtr> {
  static bool IsNull(const ::blink::mojom::blink::IdentityProviderPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::IdentityProviderPtr* output) { output->reset(); }

  static ::blink::mojom::blink::IdentityProvider::Tag GetTag(const ::blink::mojom::blink::IdentityProviderPtr& input) {
    return input->which();
  }

  static const ::blink::mojom::blink::IdentityProviderRequestOptionsPtr& federated(const ::blink::mojom::blink::IdentityProviderPtr& input) {
    return input->get_federated();
  }

  static const ::blink::mojom::blink::DigitalCredentialProviderPtr& holder(const ::blink::mojom::blink::IdentityProviderPtr& input) {
    return input->get_holder();
  }

  static bool Read(::blink::mojom::blink::IdentityProvider::DataView input, ::blink::mojom::blink::IdentityProviderPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBID_FEDERATED_AUTH_REQUEST_MOJOM_BLINK_H_