// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_custom_layout_constraints_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



CustomLayoutConstraintsOptions* CustomLayoutConstraintsOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  CustomLayoutConstraintsOptions* dictionary = MakeGarbageCollected<CustomLayoutConstraintsOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "CustomLayoutConstraintsOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 CustomLayoutConstraintsOptions::CustomLayoutConstraintsOptions() {
  
}

 CustomLayoutConstraintsOptions::CustomLayoutConstraintsOptions(v8::Isolate* isolate) {
  
}




















































void CustomLayoutConstraintsOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<double>::Trace(visitor, member_available_block_size_);
TraceIfNeeded<double>::Trace(visitor, member_available_inline_size_);
TraceIfNeeded<ScriptValue>::Trace(visitor, member_data_);
TraceIfNeeded<double>::Trace(visitor, member_fixed_block_size_);
TraceIfNeeded<double>::Trace(visitor, member_fixed_inline_size_);
TraceIfNeeded<double>::Trace(visitor, member_percentage_block_size_);
TraceIfNeeded<double>::Trace(visitor, member_percentage_inline_size_);
bindings::DictionaryBase::Trace(visitor);
}

bool CustomLayoutConstraintsOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAvailableBlockSize()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_available_block_size_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasAvailableInlineSize()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_available_inline_size_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasData()) {
  v8_value = ToV8Traits<IDLAny>::ToV8(script_state, member_data_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasFixedBlockSize()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_fixed_block_size_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasFixedInlineSize()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_fixed_inline_size_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasPercentageBlockSize()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_percentage_block_size_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
if (hasPercentageInlineSize()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_percentage_inline_size_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[6].Get(isolate), v8_value).ToChecked();
}
return true;
}

void CustomLayoutConstraintsOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "CustomLayoutConstraintsOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("availableBlockSize");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_available_block_size_, member_available_block_size_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("availableInlineSize");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_available_inline_size_, member_available_inline_size_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("data");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLAny, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_data_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("fixedBlockSize");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_fixed_block_size_, member_fixed_block_size_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("fixedInlineSize");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_fixed_inline_size_, member_fixed_inline_size_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("percentageBlockSize");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_percentage_block_size_, member_percentage_block_size_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("percentageInlineSize");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_percentage_inline_size_, member_percentage_inline_size_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> CustomLayoutConstraintsOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"availableBlockSize",
"availableInlineSize",
"data",
"fixedBlockSize",
"fixedInlineSize",
"percentageBlockSize",
"percentageInlineSize",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
