// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_DEFERRED_REQUEST_INIT_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_DEFERRED_REQUEST_INIT_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_request_init.h"
#include "third_party/blink/renderer/core/core_export.h"

namespace blink {

class ExceptionState;

class CORE_EXPORT DeferredRequestInit : public RequestInit {
  
  public:
static DeferredRequestInit* Create() {
  return MakeGarbageCollected<DeferredRequestInit>();
}
static DeferredRequestInit* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<DeferredRequestInit>(isolate);
}
static DeferredRequestInit* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  DeferredRequestInit();
explicit  DeferredRequestInit(v8::Isolate* isolate);

bool hasActivateAfter() const {
  return has_activate_after_;
}
double activateAfter() const {
  DCHECK(hasActivateAfter());
return member_activate_after_;
}
double getActivateAfterOr(double fallback_value) const {
  if (!hasActivateAfter()) {
  return fallback_value;
}
return member_activate_after_;
}
void setActivateAfter(double value) {
  member_activate_after_ = value;
has_activate_after_ = true;
}




void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_activate_after_ = false;

double member_activate_after_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_DEFERRED_REQUEST_INIT_H_
