// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_intersection_observer_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_union_document_element.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_union_double_doublesequence.h"
#include "third_party/blink/renderer/core/dom/document.h"
#include "third_party/blink/renderer/core/dom/element.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



IntersectionObserverInit* IntersectionObserverInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  IntersectionObserverInit* dictionary = MakeGarbageCollected<IntersectionObserverInit>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "IntersectionObserverInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 IntersectionObserverInit::IntersectionObserverInit() : member_root_(nullptr), member_threshold_(MakeGarbageCollected<V8UnionDoubleOrDoubleSequence>(0)) {
  
}

 IntersectionObserverInit::IntersectionObserverInit(v8::Isolate* isolate) : member_root_(nullptr), member_threshold_(MakeGarbageCollected<V8UnionDoubleOrDoubleSequence>(0)) {
  
}













void IntersectionObserverInit::setRootMargin(const String& value) {
  member_root_margin_ = value;
}

void IntersectionObserverInit::setRootMargin(String&& value) {
  member_root_margin_ = std::move(value);
}




void IntersectionObserverInit::setScrollMargin(const String& value) {
  member_scroll_margin_ = value;
}

void IntersectionObserverInit::setScrollMargin(String&& value) {
  member_scroll_margin_ = std::move(value);
}














void IntersectionObserverInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<double>::Trace(visitor, member_delay_);
TraceIfNeeded<Member<V8UnionDocumentOrElement>>::Trace(visitor, member_root_);
TraceIfNeeded<String>::Trace(visitor, member_root_margin_);
TraceIfNeeded<String>::Trace(visitor, member_scroll_margin_);
TraceIfNeeded<Member<V8UnionDoubleOrDoubleSequence>>::Trace(visitor, member_threshold_);
TraceIfNeeded<bool>::Trace(visitor, member_track_visibility_);
bindings::DictionaryBase::Trace(visitor);
}

bool IntersectionObserverInit::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasDelay()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_delay_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasRoot()) {
  v8_value = ToV8Traits<IDLNullable<V8UnionDocumentOrElement>>::ToV8(script_state, member_root_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasRootMargin()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_root_margin_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasScrollMargin()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_scroll_margin_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasThreshold()) {
  v8_value = ToV8Traits<V8UnionDoubleOrDoubleSequence>::ToV8(script_state, member_threshold_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasTrackVisibility()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_track_visibility_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
return true;
}

void IntersectionObserverInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "IntersectionObserverInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("delay");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_delay_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("root");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<V8UnionDocumentOrElement>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_root_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("rootMargin");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_root_margin_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("scrollMargin");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_scroll_margin_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("threshold");
if (!bindings::GetDictionaryMemberFromV8Object<V8UnionDoubleOrDoubleSequence, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_threshold_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("trackVisibility");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), fallback_presence_var, member_track_visibility_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> IntersectionObserverInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"delay",
"root",
"rootMargin",
"scrollMargin",
"threshold",
"trackVisibility",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
