// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_MEMORY_MEASUREMENT_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_MEMORY_MEASUREMENT_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/core/core_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class ExceptionState;
class MemoryBreakdownEntry;

class CORE_EXPORT MemoryMeasurement : public bindings::DictionaryBase {
  
  public:
static MemoryMeasurement* Create() {
  return MakeGarbageCollected<MemoryMeasurement>();
}
static MemoryMeasurement* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<MemoryMeasurement>(isolate);
}
static MemoryMeasurement* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  MemoryMeasurement();
explicit  MemoryMeasurement(v8::Isolate* isolate);

bool hasBreakdown() const {
  return true;
}
const HeapVector<Member<MemoryBreakdownEntry>>& breakdown() const {
  return member_breakdown_;
}
void setBreakdown(const HeapVector<Member<MemoryBreakdownEntry>>& value);
void setBreakdown(HeapVector<Member<MemoryBreakdownEntry>>&& value);

bool hasBytes() const {
  return true;
}
uint64_t bytes() const {
  return member_bytes_;
}
void setBytes(uint64_t value) {
  member_bytes_ = value;
}




void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);



HeapVector<Member<MemoryBreakdownEntry>> member_breakdown_;
uint64_t member_bytes_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_MEMORY_MEASUREMENT_H_
