// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_mojo_read_message_result.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/core/mojo/mojo_handle.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



MojoReadMessageResult* MojoReadMessageResult::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  MojoReadMessageResult* dictionary = MakeGarbageCollected<MojoReadMessageResult>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "MojoReadMessageResult";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 MojoReadMessageResult::MojoReadMessageResult() {
  
}

 MojoReadMessageResult::MojoReadMessageResult(v8::Isolate* isolate) {
  
}










HeapVector<Member<MojoHandle>> MojoReadMessageResult::getHandlesOr(const HeapVector<Member<MojoHandle>>& fallback_value) const {
  if (!hasHandles()) {
  return fallback_value;
}
return member_handles_;
}

HeapVector<Member<MojoHandle>> MojoReadMessageResult::getHandlesOr(HeapVector<Member<MojoHandle>>&& fallback_value) const {
  if (!hasHandles()) {
  return std::move(fallback_value);
}
return member_handles_;
}

void MojoReadMessageResult::setHandles(const HeapVector<Member<MojoHandle>>& value) {
  member_handles_ = value;
has_handles_ = true;
}

void MojoReadMessageResult::setHandles(HeapVector<Member<MojoHandle>>&& value) {
  member_handles_ = std::move(value);
has_handles_ = true;
}









void MojoReadMessageResult::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<DOMArrayBuffer>>::Trace(visitor, member_buffer_);
TraceIfNeeded<HeapVector<Member<MojoHandle>>>::Trace(visitor, member_handles_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_result_);
bindings::DictionaryBase::Trace(visitor);
}

bool MojoReadMessageResult::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasBuffer()) {
  v8_value = ToV8Traits<DOMArrayBuffer>::ToV8(script_state, member_buffer_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasHandles()) {
  v8_value = ToV8Traits<IDLSequence<MojoHandle>>::ToV8(script_state, member_handles_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasResult()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_result_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
return true;
}

void MojoReadMessageResult::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "MojoReadMessageResult";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("buffer");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<DOMArrayBuffer, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_buffer_, member_buffer_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("handles");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<MojoHandle>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_handles_, member_handles_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("result");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_result_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> MojoReadMessageResult::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"buffer",
"handles",
"result",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
