// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_navigator_ua_brand_version.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



NavigatorUABrandVersion* NavigatorUABrandVersion::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  NavigatorUABrandVersion* dictionary = MakeGarbageCollected<NavigatorUABrandVersion>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "NavigatorUABrandVersion";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 NavigatorUABrandVersion::NavigatorUABrandVersion() {
  
}

 NavigatorUABrandVersion::NavigatorUABrandVersion(v8::Isolate* isolate) {
  
}



String NavigatorUABrandVersion::getBrandOr(const String& fallback_value) const {
  if (!hasBrand()) {
  return fallback_value;
}
return member_brand_;
}

String NavigatorUABrandVersion::getBrandOr(String&& fallback_value) const {
  if (!hasBrand()) {
  return std::move(fallback_value);
}
return member_brand_;
}

void NavigatorUABrandVersion::setBrand(const String& value) {
  member_brand_ = value;
has_brand_ = true;
}

void NavigatorUABrandVersion::setBrand(String&& value) {
  member_brand_ = std::move(value);
has_brand_ = true;
}




String NavigatorUABrandVersion::getVersionOr(const String& fallback_value) const {
  if (!hasVersion()) {
  return fallback_value;
}
return member_version_;
}

String NavigatorUABrandVersion::getVersionOr(String&& fallback_value) const {
  if (!hasVersion()) {
  return std::move(fallback_value);
}
return member_version_;
}

void NavigatorUABrandVersion::setVersion(const String& value) {
  member_version_ = value;
has_version_ = true;
}

void NavigatorUABrandVersion::setVersion(String&& value) {
  member_version_ = std::move(value);
has_version_ = true;
}




void NavigatorUABrandVersion::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_brand_);
TraceIfNeeded<String>::Trace(visitor, member_version_);
bindings::DictionaryBase::Trace(visitor);
}

bool NavigatorUABrandVersion::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasBrand()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_brand_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasVersion()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_version_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
return true;
}

void NavigatorUABrandVersion::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "NavigatorUABrandVersion";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("brand");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_brand_, member_brand_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("version");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_version_, member_version_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> NavigatorUABrandVersion::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"brand",
"version",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
