// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_PROPERTY_DEFINITION_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_PROPERTY_DEFINITION_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/core/core_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;

class CORE_EXPORT PropertyDefinition : public bindings::DictionaryBase {
  
  public:
static PropertyDefinition* Create() {
  return MakeGarbageCollected<PropertyDefinition>();
}
static PropertyDefinition* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<PropertyDefinition>(isolate);
}
static PropertyDefinition* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  PropertyDefinition();
explicit  PropertyDefinition(v8::Isolate* isolate);

bool hasInherits() const {
  return true;
}
bool inherits() const {
  return member_inherits_;
}
void setInherits(bool value) {
  member_inherits_ = value;
}

bool hasInitialValue() const {
  return has_initial_value_;
}
const String& initialValue() const {
  DCHECK(hasInitialValue());
return member_initial_value_;
}
String getInitialValueOr(const String& fallback_value) const;
String getInitialValueOr(String&& fallback_value) const;
void setInitialValue(const String& value);
void setInitialValue(String&& value);

bool hasName() const {
  return true;
}
const String& name() const {
  return member_name_;
}
void setName(const String& value);
void setName(String&& value);

bool hasSyntax() const {
  return true;
}
const String& syntax() const {
  return member_syntax_;
}
void setSyntax(const String& value);
void setSyntax(String&& value);




void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_initial_value_ = false;

bool member_inherits_;
String member_initial_value_;
String member_name_;
String member_syntax_{"*"};


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_PROPERTY_DEFINITION_H_
