// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_text_format_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



TextFormatInit* TextFormatInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  TextFormatInit* dictionary = MakeGarbageCollected<TextFormatInit>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "TextFormatInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 TextFormatInit::TextFormatInit() {
  
}

 TextFormatInit::TextFormatInit(v8::Isolate* isolate) {
  
}

















String TextFormatInit::getUnderlineStyleOr(const String& fallback_value) const {
  if (!hasUnderlineStyle()) {
  return fallback_value;
}
return member_underline_style_;
}

String TextFormatInit::getUnderlineStyleOr(String&& fallback_value) const {
  if (!hasUnderlineStyle()) {
  return std::move(fallback_value);
}
return member_underline_style_;
}

void TextFormatInit::setUnderlineStyle(const String& value) {
  member_underline_style_ = value;
has_underline_style_ = true;
}

void TextFormatInit::setUnderlineStyle(String&& value) {
  member_underline_style_ = std::move(value);
has_underline_style_ = true;
}




String TextFormatInit::getUnderlineThicknessOr(const String& fallback_value) const {
  if (!hasUnderlineThickness()) {
  return fallback_value;
}
return member_underline_thickness_;
}

String TextFormatInit::getUnderlineThicknessOr(String&& fallback_value) const {
  if (!hasUnderlineThickness()) {
  return std::move(fallback_value);
}
return member_underline_thickness_;
}

void TextFormatInit::setUnderlineThickness(const String& value) {
  member_underline_thickness_ = value;
has_underline_thickness_ = true;
}

void TextFormatInit::setUnderlineThickness(String&& value) {
  member_underline_thickness_ = std::move(value);
has_underline_thickness_ = true;
}




void TextFormatInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<uint32_t>::Trace(visitor, member_range_end_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_range_start_);
TraceIfNeeded<String>::Trace(visitor, member_underline_style_);
TraceIfNeeded<String>::Trace(visitor, member_underline_thickness_);
bindings::DictionaryBase::Trace(visitor);
}

bool TextFormatInit::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasRangeEnd()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_range_end_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasRangeStart()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_range_start_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasUnderlineStyle()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_underline_style_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasUnderlineThickness()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_underline_thickness_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
return true;
}

void TextFormatInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "TextFormatInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("rangeEnd");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_range_end_, member_range_end_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("rangeStart");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_range_start_, member_range_start_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("underlineStyle");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_underline_style_, member_underline_style_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("underlineThickness");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_underline_thickness_, member_underline_thickness_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> TextFormatInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"rangeEnd",
"rangeStart",
"underlineStyle",
"underlineThickness",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
