// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_union_double_doublesequence.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"

namespace blink {



V8UnionDoubleOrDoubleSequence* V8UnionDoubleOrDoubleSequence::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  if (v8_value->IsArray()) {
  auto&& blink_value = NativeValueTraits<IDLSequence<IDLDouble>>::NativeValue(isolate, v8_value, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return MakeGarbageCollected<V8UnionDoubleOrDoubleSequence>(std::move(blink_value));
}
if (v8_value->IsObject()) {
  ScriptIterator script_iterator = ScriptIterator::FromIterable(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
if (!script_iterator.IsNull()) {
  auto&& blink_value = bindings::CreateIDLSequenceFromIterator<IDLDouble>(isolate, std::move(script_iterator), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return MakeGarbageCollected<V8UnionDoubleOrDoubleSequence>(std::move(blink_value));
}
}
if (v8_value->IsNumber()) {
  auto&& blink_value = NativeValueTraits<IDLDouble>::NativeValue(isolate, v8_value, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return MakeGarbageCollected<V8UnionDoubleOrDoubleSequence>(blink_value);
}
{
  auto&& blink_value = NativeValueTraits<IDLDouble>::NativeValue(isolate, v8_value, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return MakeGarbageCollected<V8UnionDoubleOrDoubleSequence>(blink_value);
}
}

 V8UnionDoubleOrDoubleSequence::V8UnionDoubleOrDoubleSequence(const Vector<double>& value) : content_type_(ContentType::kDoubleSequence), member_double_sequence_(value) {
  
}

 V8UnionDoubleOrDoubleSequence::V8UnionDoubleOrDoubleSequence(Vector<double>&& value) : content_type_(ContentType::kDoubleSequence), member_double_sequence_(std::move(value)) {
  
}







void V8UnionDoubleOrDoubleSequence::Set(const Vector<double>& value) {
  Clear();
member_double_sequence_ = value;
content_type_ = ContentType::kDoubleSequence;
}

void V8UnionDoubleOrDoubleSequence::Set(Vector<double>&& value) {
  Clear();
member_double_sequence_ = std::move(value);
content_type_ = ContentType::kDoubleSequence;
}


v8::Local<v8::Value> V8UnionDoubleOrDoubleSequence::ToV8(ScriptState* script_state) const {
  switch (content_type_) {
  case ContentType::kDouble: {
    return ToV8Traits<IDLDouble>::ToV8(script_state, member_double_);
  }
  case ContentType::kDoubleSequence: {
    return ToV8Traits<IDLSequence<IDLDouble>>::ToV8(script_state, member_double_sequence_);
  }
}

NOTREACHED();
return v8::Local<v8::Value>();
}

void V8UnionDoubleOrDoubleSequence::Trace(Visitor* visitor) const {
  TraceIfNeeded<double>::Trace(visitor, member_double_);
TraceIfNeeded<Vector<double>>::Trace(visitor, member_double_sequence_);
bindings::UnionBase::Trace(visitor);
}

void V8UnionDoubleOrDoubleSequence::Clear() {
  member_double_ = 0;
member_double_sequence_.clear();
}



}  // namespace blink
