// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_INT_32_ARRAYALLOWSHARED_LONGSEQUENCE_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_INT_32_ARRAYALLOWSHARED_LONGSEQUENCE_H_

#include "base/check_op.h"
#include "third_party/blink/renderer/core/core_export.h"
#include "third_party/blink/renderer/core/typed_arrays/array_buffer_view_helpers.h"
#include "third_party/blink/renderer/core/typed_arrays/dom_typed_array.h"
#include "third_party/blink/renderer/platform/bindings/union_base.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class ExceptionState;

class CORE_EXPORT V8UnionInt32ArrayAllowSharedOrLongSequence final : public bindings::UnionBase {
  
  public:
// The type of the content value of this IDL union.
enum class ContentType {
kInt32ArrayAllowShared, kLongSequence
};

static V8UnionInt32ArrayAllowSharedOrLongSequence* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  V8UnionInt32ArrayAllowSharedOrLongSequence(MaybeShared<DOMInt32Array> value) : content_type_(ContentType::kInt32ArrayAllowShared), member_int32_array_allow_shared_(value) {
  DCHECK(value);
}
explicit  V8UnionInt32ArrayAllowSharedOrLongSequence(const Vector<int32_t>& value);
explicit  V8UnionInt32ArrayAllowSharedOrLongSequence(Vector<int32_t>&& value);

// Returns the type of the content value.
ContentType GetContentType() const {
  return content_type_;
}

bool IsInt32ArrayAllowShared() const {
  return content_type_ == ContentType::kInt32ArrayAllowShared;
}
MaybeShared<DOMInt32Array> GetAsInt32ArrayAllowShared() const {
  DCHECK_EQ(content_type_, ContentType::kInt32ArrayAllowShared);
return member_int32_array_allow_shared_;
}
void Set(MaybeShared<DOMInt32Array> value) {
  DCHECK(value);
Clear();
member_int32_array_allow_shared_ = value;
content_type_ = ContentType::kInt32ArrayAllowShared;
}

bool IsLongSequence() const {
  return content_type_ == ContentType::kLongSequence;
}
const Vector<int32_t>& GetAsLongSequence() const {
  DCHECK_EQ(content_type_, ContentType::kLongSequence);
return member_long_sequence_;
}
void Set(const Vector<int32_t>& value);
void Set(Vector<int32_t>&& value);


v8::Local<v8::Value> ToV8(ScriptState* script_state) const override;

void Trace(Visitor* visitor) const override;


  
  private:
void Clear();

static constexpr const char* UnionNameInIDL() {
  return "([AllowShared] Int32Array or sequence<long>)";
}

ContentType content_type_;

MaybeShared<DOMInt32Array> member_int32_array_allow_shared_;
Vector<int32_t> member_long_sequence_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_INT_32_ARRAYALLOWSHARED_LONGSEQUENCE_H_
