// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_union_range_selection.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_range.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_selection.h"
#include "third_party/blink/renderer/core/dom/range.h"
#include "third_party/blink/renderer/core/editing/dom_selection.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"

namespace blink {



V8UnionRangeOrSelection* V8UnionRangeOrSelection::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  if (V8Range::HasInstance(isolate, v8_value)) {
  auto&& blink_value = V8Range::ToWrappableUnsafe(v8_value.As<v8::Object>());
return MakeGarbageCollected<V8UnionRangeOrSelection>(blink_value);
}
if (V8Selection::HasInstance(isolate, v8_value)) {
  auto&& blink_value = V8Selection::ToWrappableUnsafe(v8_value.As<v8::Object>());
return MakeGarbageCollected<V8UnionRangeOrSelection>(blink_value);
}
ThrowTypeErrorNotOfType(exception_state, UnionNameInIDL());
return nullptr;
}










v8::Local<v8::Value> V8UnionRangeOrSelection::ToV8(ScriptState* script_state) const {
  switch (content_type_) {
  case ContentType::kRange: {
    return ToV8Traits<Range>::ToV8(script_state, member_range_.Get());
  }
  case ContentType::kSelection: {
    return ToV8Traits<DOMSelection>::ToV8(script_state, member_selection_.Get());
  }
}

NOTREACHED();
return v8::Local<v8::Value>();
}

void V8UnionRangeOrSelection::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<Range>>::Trace(visitor, member_range_);
TraceIfNeeded<Member<DOMSelection>>::Trace(visitor, member_selection_);
bindings::UnionBase::Trace(visitor);
}

void V8UnionRangeOrSelection::Clear() {
  member_range_.Clear();
member_selection_.Clear();
}



}  // namespace blink
