// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_STRING_TRUSTEDSCRIPTURL_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_STRING_TRUSTEDSCRIPTURL_H_

#include "base/check_op.h"
#include "third_party/blink/renderer/core/core_export.h"
#include "third_party/blink/renderer/platform/bindings/union_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;
class TrustedScriptURL;

class CORE_EXPORT V8UnionStringOrTrustedScriptURL final : public bindings::UnionBase {
  
  public:
// The type of the content value of this IDL union.
enum class ContentType {
kString, kTrustedScriptURL
};

static V8UnionStringOrTrustedScriptURL* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  V8UnionStringOrTrustedScriptURL(const String& value);
explicit  V8UnionStringOrTrustedScriptURL(String&& value);
explicit  V8UnionStringOrTrustedScriptURL(TrustedScriptURL* value) : content_type_(ContentType::kTrustedScriptURL), member_trusted_script_url_(value) {
  DCHECK(value);
}

// Returns the type of the content value.
ContentType GetContentType() const {
  return content_type_;
}

bool IsString() const {
  return content_type_ == ContentType::kString;
}
const String& GetAsString() const {
  DCHECK_EQ(content_type_, ContentType::kString);
return member_string_;
}
void Set(const String& value);
void Set(String&& value);

bool IsTrustedScriptURL() const {
  return content_type_ == ContentType::kTrustedScriptURL;
}
TrustedScriptURL* GetAsTrustedScriptURL() const {
  DCHECK_EQ(content_type_, ContentType::kTrustedScriptURL);
return member_trusted_script_url_.Get();
}
void Set(TrustedScriptURL* value) {
  DCHECK(value);
Clear();
member_trusted_script_url_ = value;
content_type_ = ContentType::kTrustedScriptURL;
}


v8::Local<v8::Value> ToV8(ScriptState* script_state) const override;

void Trace(Visitor* visitor) const override;


  
  private:
void Clear();

static constexpr const char* UnionNameInIDL() {
  return "(DOMString or TrustedScriptURL)";
}

ContentType content_type_;

String member_string_;
Member<TrustedScriptURL> member_trusted_script_url_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_STRING_TRUSTEDSCRIPTURL_H_
