// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_STRINGLEGACYNULLTOEMPTYSTRING_TRUSTEDSCRIPT_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_STRINGLEGACYNULLTOEMPTYSTRING_TRUSTEDSCRIPT_H_

#include "base/check_op.h"
#include "third_party/blink/renderer/core/core_export.h"
#include "third_party/blink/renderer/platform/bindings/union_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;
class TrustedScript;

class CORE_EXPORT V8UnionStringLegacyNullToEmptyStringOrTrustedScript final : public bindings::UnionBase {
  
  public:
// The type of the content value of this IDL union.
enum class ContentType {
kStringLegacyNullToEmptyString, kTrustedScript
};

static V8UnionStringLegacyNullToEmptyStringOrTrustedScript* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  V8UnionStringLegacyNullToEmptyStringOrTrustedScript(const String& value);
explicit  V8UnionStringLegacyNullToEmptyStringOrTrustedScript(String&& value);
explicit  V8UnionStringLegacyNullToEmptyStringOrTrustedScript(TrustedScript* value) : content_type_(ContentType::kTrustedScript), member_trusted_script_(value) {
  DCHECK(value);
}

// Returns the type of the content value.
ContentType GetContentType() const {
  return content_type_;
}

bool IsStringLegacyNullToEmptyString() const {
  return content_type_ == ContentType::kStringLegacyNullToEmptyString;
}
const String& GetAsStringLegacyNullToEmptyString() const {
  DCHECK_EQ(content_type_, ContentType::kStringLegacyNullToEmptyString);
return member_string_legacy_null_to_empty_string_;
}
void Set(const String& value);
void Set(String&& value);

bool IsTrustedScript() const {
  return content_type_ == ContentType::kTrustedScript;
}
TrustedScript* GetAsTrustedScript() const {
  DCHECK_EQ(content_type_, ContentType::kTrustedScript);
return member_trusted_script_.Get();
}
void Set(TrustedScript* value) {
  DCHECK(value);
Clear();
member_trusted_script_ = value;
content_type_ = ContentType::kTrustedScript;
}


v8::Local<v8::Value> ToV8(ScriptState* script_state) const override;

void Trace(Visitor* visitor) const override;


  
  private:
void Clear();

static constexpr const char* UnionNameInIDL() {
  return "(TrustedScript or [LegacyNullToEmptyString] DOMString)";
}

ContentType content_type_;

String member_string_legacy_null_to_empty_string_;
Member<TrustedScript> member_trusted_script_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_UNION_STRINGLEGACYNULLTOEMPTYSTRING_TRUSTEDSCRIPT_H_
