// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_url_pattern_component_result.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



URLPatternComponentResult* URLPatternComponentResult::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  URLPatternComponentResult* dictionary = MakeGarbageCollected<URLPatternComponentResult>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "URLPatternComponentResult";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 URLPatternComponentResult::URLPatternComponentResult() {
  
}

 URLPatternComponentResult::URLPatternComponentResult(v8::Isolate* isolate) {
  
}



HeapVector<std::pair<String, ScriptValue>> URLPatternComponentResult::getGroupsOr(const HeapVector<std::pair<String, ScriptValue>>& fallback_value) const {
  if (!hasGroups()) {
  return fallback_value;
}
return member_groups_;
}

HeapVector<std::pair<String, ScriptValue>> URLPatternComponentResult::getGroupsOr(HeapVector<std::pair<String, ScriptValue>>&& fallback_value) const {
  if (!hasGroups()) {
  return std::move(fallback_value);
}
return member_groups_;
}

void URLPatternComponentResult::setGroups(const HeapVector<std::pair<String, ScriptValue>>& value) {
  member_groups_ = value;
has_groups_ = true;
}

void URLPatternComponentResult::setGroups(HeapVector<std::pair<String, ScriptValue>>&& value) {
  member_groups_ = std::move(value);
has_groups_ = true;
}




String URLPatternComponentResult::getInputOr(const String& fallback_value) const {
  if (!hasInput()) {
  return fallback_value;
}
return member_input_;
}

String URLPatternComponentResult::getInputOr(String&& fallback_value) const {
  if (!hasInput()) {
  return std::move(fallback_value);
}
return member_input_;
}

void URLPatternComponentResult::setInput(const String& value) {
  member_input_ = value;
has_input_ = true;
}

void URLPatternComponentResult::setInput(String&& value) {
  member_input_ = std::move(value);
has_input_ = true;
}




void URLPatternComponentResult::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<std::pair<String, ScriptValue>>>::Trace(visitor, member_groups_);
TraceIfNeeded<String>::Trace(visitor, member_input_);
bindings::DictionaryBase::Trace(visitor);
}

bool URLPatternComponentResult::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasGroups()) {
  v8_value = ToV8Traits<IDLRecord<IDLUSVString, IDLAny>>::ToV8(script_state, member_groups_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasInput()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_input_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
return true;
}

void URLPatternComponentResult::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "URLPatternComponentResult";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("groups");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLRecord<IDLUSVString, IDLAny>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_groups_, member_groups_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("input");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_input_, member_input_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> URLPatternComponentResult::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"groups",
"input",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
