// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_view_timeline_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_union_cssnumericvalue_string.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_union_cssnumericvalueorstringsequence_string.h"
#include "third_party/blink/renderer/core/css/cssom/css_numeric_value.h"
#include "third_party/blink/renderer/core/dom/element.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



ViewTimelineOptions* ViewTimelineOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  ViewTimelineOptions* dictionary = MakeGarbageCollected<ViewTimelineOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "ViewTimelineOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 ViewTimelineOptions::ViewTimelineOptions() : member_inset_(MakeGarbageCollected<V8UnionCSSNumericValueOrStringSequenceOrString>(HeapVector<Member<V8UnionCSSNumericValueOrString>>())) {
  
}

 ViewTimelineOptions::ViewTimelineOptions(v8::Isolate* isolate) : member_inset_(MakeGarbageCollected<V8UnionCSSNumericValueOrStringSequenceOrString>(HeapVector<Member<V8UnionCSSNumericValueOrString>>())) {
  
}




















void ViewTimelineOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<V8ScrollAxis>::Trace(visitor, member_axis_);
TraceIfNeeded<Member<V8UnionCSSNumericValueOrStringSequenceOrString>>::Trace(visitor, member_inset_);
TraceIfNeeded<Member<Element>>::Trace(visitor, member_subject_);
bindings::DictionaryBase::Trace(visitor);
}

bool ViewTimelineOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAxis()) {
  v8_value = ToV8Traits<V8ScrollAxis>::ToV8(script_state, member_axis_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasInset()) {
  v8_value = ToV8Traits<V8UnionCSSNumericValueOrStringSequenceOrString>::ToV8(script_state, member_inset_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasSubject()) {
  v8_value = ToV8Traits<Element>::ToV8(script_state, member_subject_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
return true;
}

void ViewTimelineOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "ViewTimelineOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("axis");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<V8ScrollAxis, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_axis_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("inset");
if (!bindings::GetDictionaryMemberFromV8Object<V8UnionCSSNumericValueOrStringSequenceOrString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_inset_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("subject");
if (!bindings::GetDictionaryMemberFromV8Object<Element, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_subject_, member_subject_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> ViewTimelineOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"axis",
"inset",
"subject",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
