// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_window_post_message_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



WindowPostMessageOptions* WindowPostMessageOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  WindowPostMessageOptions* dictionary = MakeGarbageCollected<WindowPostMessageOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "WindowPostMessageOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 WindowPostMessageOptions::WindowPostMessageOptions() {
  
}

 WindowPostMessageOptions::WindowPostMessageOptions(v8::Isolate* isolate) : PostMessageOptions(isolate) {
  
}



String WindowPostMessageOptions::getDelegateOr(const String& fallback_value) const {
  if (!hasDelegate()) {
  return fallback_value;
}
return member_delegate_;
}

String WindowPostMessageOptions::getDelegateOr(String&& fallback_value) const {
  if (!hasDelegate()) {
  return std::move(fallback_value);
}
return member_delegate_;
}

void WindowPostMessageOptions::setDelegate(const String& value) {
  member_delegate_ = value;
has_delegate_ = true;
}

void WindowPostMessageOptions::setDelegate(String&& value) {
  member_delegate_ = std::move(value);
has_delegate_ = true;
}




void WindowPostMessageOptions::setTargetOrigin(const String& value) {
  member_target_origin_ = value;
}

void WindowPostMessageOptions::setTargetOrigin(String&& value) {
  member_target_origin_ = std::move(value);
}




void WindowPostMessageOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_delegate_);
TraceIfNeeded<String>::Trace(visitor, member_target_origin_);
PostMessageOptions::Trace(visitor);
}

bool WindowPostMessageOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!PostMessageOptions::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasDelegate()) {
  v8_value = ToV8Traits<IDLNullable<IDLString>>::ToV8(script_state, member_delegate_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasTargetOrigin()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_target_origin_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
return true;
}

void WindowPostMessageOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  PostMessageOptions::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "WindowPostMessageOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("delegate");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_delegate_, member_delegate_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("targetOrigin");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_target_origin_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> WindowPostMessageOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"delegate",
"targetOrigin",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
