// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_android_pay_method_data.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



AndroidPayMethodData* AndroidPayMethodData::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  AndroidPayMethodData* dictionary = MakeGarbageCollected<AndroidPayMethodData>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "AndroidPayMethodData";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 AndroidPayMethodData::AndroidPayMethodData() {
  
}

 AndroidPayMethodData::AndroidPayMethodData(v8::Isolate* isolate) {
  
}










String AndroidPayMethodData::getEnvironmentOr(const String& fallback_value) const {
  if (!hasEnvironment()) {
  return fallback_value;
}
return member_environment_;
}

String AndroidPayMethodData::getEnvironmentOr(String&& fallback_value) const {
  if (!hasEnvironment()) {
  return std::move(fallback_value);
}
return member_environment_;
}

void AndroidPayMethodData::setEnvironment(const String& value) {
  member_environment_ = value;
has_environment_ = true;
}

void AndroidPayMethodData::setEnvironment(String&& value) {
  member_environment_ = std::move(value);
has_environment_ = true;
}




String AndroidPayMethodData::getMinGooglePlayServicesVersionOr(const String& fallback_value) const {
  if (!hasMinGooglePlayServicesVersion()) {
  return fallback_value;
}
return member_min_google_play_services_version_;
}

String AndroidPayMethodData::getMinGooglePlayServicesVersionOr(String&& fallback_value) const {
  if (!hasMinGooglePlayServicesVersion()) {
  return std::move(fallback_value);
}
return member_min_google_play_services_version_;
}

void AndroidPayMethodData::setMinGooglePlayServicesVersion(const String& value) {
  member_min_google_play_services_version_ = value;
has_min_google_play_services_version_ = true;
}

void AndroidPayMethodData::setMinGooglePlayServicesVersion(String&& value) {
  member_min_google_play_services_version_ = std::move(value);
has_min_google_play_services_version_ = true;
}




void AndroidPayMethodData::Trace(Visitor* visitor) const {
  TraceIfNeeded<int32_t>::Trace(visitor, member_api_version_);
TraceIfNeeded<String>::Trace(visitor, member_environment_);
TraceIfNeeded<String>::Trace(visitor, member_min_google_play_services_version_);
bindings::DictionaryBase::Trace(visitor);
}

bool AndroidPayMethodData::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasApiVersion()) {
  v8_value = ToV8Traits<IDLLong>::ToV8(script_state, member_api_version_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasEnvironment()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_environment_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasMinGooglePlayServicesVersion()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_min_google_play_services_version_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
return true;
}

void AndroidPayMethodData::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "AndroidPayMethodData";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("apiVersion");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_api_version_, member_api_version_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("environment");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_environment_, member_environment_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("minGooglePlayServicesVersion");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_min_google_play_services_version_, member_min_google_play_services_version_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> AndroidPayMethodData::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"apiVersion",
"environment",
"minGooglePlayServicesVersion",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
