// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_auction_ad.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



AuctionAd* AuctionAd::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  AuctionAd* dictionary = MakeGarbageCollected<AuctionAd>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "AuctionAd";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 AuctionAd::AuctionAd() {
  
}

 AuctionAd::AuctionAd(v8::Isolate* isolate) {
  
}



String AuctionAd::getAdRenderIdOr(const String& fallback_value) const {
  if (!hasAdRenderId()) {
  return fallback_value;
}
return member_ad_render_id_;
}

String AuctionAd::getAdRenderIdOr(String&& fallback_value) const {
  if (!hasAdRenderId()) {
  return std::move(fallback_value);
}
return member_ad_render_id_;
}

void AuctionAd::setAdRenderId(const String& value) {
  member_ad_render_id_ = value;
has_ad_render_id_ = true;
}

void AuctionAd::setAdRenderId(String&& value) {
  member_ad_render_id_ = std::move(value);
has_ad_render_id_ = true;
}




Vector<String> AuctionAd::getAllowedReportingOriginsOr(const Vector<String>& fallback_value) const {
  if (!hasAllowedReportingOrigins()) {
  return fallback_value;
}
return member_allowed_reporting_origins_;
}

Vector<String> AuctionAd::getAllowedReportingOriginsOr(Vector<String>&& fallback_value) const {
  if (!hasAllowedReportingOrigins()) {
  return std::move(fallback_value);
}
return member_allowed_reporting_origins_;
}

void AuctionAd::setAllowedReportingOrigins(const Vector<String>& value) {
  member_allowed_reporting_origins_ = value;
has_allowed_reporting_origins_ = true;
}

void AuctionAd::setAllowedReportingOrigins(Vector<String>&& value) {
  member_allowed_reporting_origins_ = std::move(value);
has_allowed_reporting_origins_ = true;
}




String AuctionAd::getBuyerAndSellerReportingIdOr(const String& fallback_value) const {
  if (!hasBuyerAndSellerReportingId()) {
  return fallback_value;
}
return member_buyer_and_seller_reporting_id_;
}

String AuctionAd::getBuyerAndSellerReportingIdOr(String&& fallback_value) const {
  if (!hasBuyerAndSellerReportingId()) {
  return std::move(fallback_value);
}
return member_buyer_and_seller_reporting_id_;
}

void AuctionAd::setBuyerAndSellerReportingId(const String& value) {
  member_buyer_and_seller_reporting_id_ = value;
has_buyer_and_seller_reporting_id_ = true;
}

void AuctionAd::setBuyerAndSellerReportingId(String&& value) {
  member_buyer_and_seller_reporting_id_ = std::move(value);
has_buyer_and_seller_reporting_id_ = true;
}




String AuctionAd::getBuyerReportingIdOr(const String& fallback_value) const {
  if (!hasBuyerReportingId()) {
  return fallback_value;
}
return member_buyer_reporting_id_;
}

String AuctionAd::getBuyerReportingIdOr(String&& fallback_value) const {
  if (!hasBuyerReportingId()) {
  return std::move(fallback_value);
}
return member_buyer_reporting_id_;
}

void AuctionAd::setBuyerReportingId(const String& value) {
  member_buyer_reporting_id_ = value;
has_buyer_reporting_id_ = true;
}

void AuctionAd::setBuyerReportingId(String&& value) {
  member_buyer_reporting_id_ = std::move(value);
has_buyer_reporting_id_ = true;
}











String AuctionAd::getRenderURLOr(const String& fallback_value) const {
  if (!hasRenderURL()) {
  return fallback_value;
}
return member_render_url_;
}

String AuctionAd::getRenderURLOr(String&& fallback_value) const {
  if (!hasRenderURL()) {
  return std::move(fallback_value);
}
return member_render_url_;
}

void AuctionAd::setRenderURL(const String& value) {
  member_render_url_ = value;
has_render_url_ = true;
}

void AuctionAd::setRenderURL(String&& value) {
  member_render_url_ = std::move(value);
has_render_url_ = true;
}




String AuctionAd::getRenderUrlDeprecatedOr(const String& fallback_value) const {
  if (!hasRenderUrlDeprecated()) {
  return fallback_value;
}
return member_render_url_deprecated_;
}

String AuctionAd::getRenderUrlDeprecatedOr(String&& fallback_value) const {
  if (!hasRenderUrlDeprecated()) {
  return std::move(fallback_value);
}
return member_render_url_deprecated_;
}

void AuctionAd::setRenderUrlDeprecated(const String& value) {
  member_render_url_deprecated_ = value;
has_render_url_deprecated_ = true;
}

void AuctionAd::setRenderUrlDeprecated(String&& value) {
  member_render_url_deprecated_ = std::move(value);
has_render_url_deprecated_ = true;
}




String AuctionAd::getSizeGroupOr(const String& fallback_value) const {
  if (!hasSizeGroup()) {
  return fallback_value;
}
return member_size_group_;
}

String AuctionAd::getSizeGroupOr(String&& fallback_value) const {
  if (!hasSizeGroup()) {
  return std::move(fallback_value);
}
return member_size_group_;
}

void AuctionAd::setSizeGroup(const String& value) {
  member_size_group_ = value;
has_size_group_ = true;
}

void AuctionAd::setSizeGroup(String&& value) {
  member_size_group_ = std::move(value);
has_size_group_ = true;
}




void AuctionAd::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_ad_render_id_);
TraceIfNeeded<Vector<String>>::Trace(visitor, member_allowed_reporting_origins_);
TraceIfNeeded<String>::Trace(visitor, member_buyer_and_seller_reporting_id_);
TraceIfNeeded<String>::Trace(visitor, member_buyer_reporting_id_);
TraceIfNeeded<ScriptValue>::Trace(visitor, member_metadata_);
TraceIfNeeded<String>::Trace(visitor, member_render_url_);
TraceIfNeeded<String>::Trace(visitor, member_render_url_deprecated_);
TraceIfNeeded<String>::Trace(visitor, member_size_group_);
bindings::DictionaryBase::Trace(visitor);
}

bool AuctionAd::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAdRenderId()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_ad_render_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasAllowedReportingOrigins()) {
  v8_value = ToV8Traits<IDLSequence<IDLUSVString>>::ToV8(script_state, member_allowed_reporting_origins_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasBuyerAndSellerReportingId()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_buyer_and_seller_reporting_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasBuyerReportingId()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_buyer_reporting_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasMetadata()) {
  v8_value = ToV8Traits<IDLAny>::ToV8(script_state, member_metadata_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasRenderURL()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_render_url_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
if (hasRenderUrlDeprecated()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_render_url_deprecated_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[6].Get(isolate), v8_value).ToChecked();
}
if (hasSizeGroup()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_size_group_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[7].Get(isolate), v8_value).ToChecked();
}
return true;
}

void AuctionAd::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "AuctionAd";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("adRenderId");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_ad_render_id_, member_ad_render_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("allowedReportingOrigins");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUSVString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_allowed_reporting_origins_, member_allowed_reporting_origins_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("buyerAndSellerReportingId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_buyer_and_seller_reporting_id_, member_buyer_and_seller_reporting_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("buyerReportingId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_buyer_reporting_id_, member_buyer_reporting_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("metadata");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLAny, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_metadata_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("renderURL");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_render_url_, member_render_url_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("renderUrl");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_render_url_deprecated_, member_render_url_deprecated_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sizeGroup");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), has_size_group_, member_size_group_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> AuctionAd::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"adRenderId",
"allowedReportingOrigins",
"buyerAndSellerReportingId",
"buyerReportingId",
"metadata",
"renderURL",
"renderUrl",
"sizeGroup",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
