// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_audio_context_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_audio_sink_options.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_union_audiocontextlatencycategory_double.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_union_audiosinkoptions_string.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



AudioContextOptions* AudioContextOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  AudioContextOptions* dictionary = MakeGarbageCollected<AudioContextOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "AudioContextOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 AudioContextOptions::AudioContextOptions() : member_latency_hint_(MakeGarbageCollected<V8UnionAudioContextLatencyCategoryOrDouble>(V8AudioContextLatencyCategory(V8AudioContextLatencyCategory::Enum::kInteractive))) {
  
}

 AudioContextOptions::AudioContextOptions(v8::Isolate* isolate) : member_latency_hint_(MakeGarbageCollected<V8UnionAudioContextLatencyCategoryOrDouble>(V8AudioContextLatencyCategory(V8AudioContextLatencyCategory::Enum::kInteractive))) {
  
}






















void AudioContextOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<V8UnionAudioContextLatencyCategoryOrDouble>>::Trace(visitor, member_latency_hint_);
TraceIfNeeded<float>::Trace(visitor, member_sample_rate_);
TraceIfNeeded<Member<V8UnionAudioSinkOptionsOrString>>::Trace(visitor, member_sink_id_);
bindings::DictionaryBase::Trace(visitor);
}

bool AudioContextOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasLatencyHint()) {
  v8_value = ToV8Traits<V8UnionAudioContextLatencyCategoryOrDouble>::ToV8(script_state, member_latency_hint_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasSampleRate()) {
  v8_value = ToV8Traits<IDLFloat>::ToV8(script_state, member_sample_rate_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasSinkId()) {
  v8_value = ToV8Traits<V8UnionAudioSinkOptionsOrString>::ToV8(script_state, member_sink_id_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
return true;
}

void AudioContextOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "AudioContextOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("latencyHint");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<V8UnionAudioContextLatencyCategoryOrDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_latency_hint_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sampleRate");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_sample_rate_, member_sample_rate_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sinkId");
if (!bindings::GetDictionaryMemberFromV8Object<V8UnionAudioSinkOptionsOrString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_sink_id_, member_sink_id_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> AudioContextOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"latencyHint",
"sampleRate",
"sinkId",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
