// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_audio_worklet_node_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



AudioWorkletNodeOptions* AudioWorkletNodeOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  AudioWorkletNodeOptions* dictionary = MakeGarbageCollected<AudioWorkletNodeOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "AudioWorkletNodeOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 AudioWorkletNodeOptions::AudioWorkletNodeOptions() {
  
}

 AudioWorkletNodeOptions::AudioWorkletNodeOptions(v8::Isolate* isolate) : AudioNodeOptions(isolate) {
  
}













Vector<uint32_t> AudioWorkletNodeOptions::getOutputChannelCountOr(const Vector<uint32_t>& fallback_value) const {
  if (!hasOutputChannelCount()) {
  return fallback_value;
}
return member_output_channel_count_;
}

Vector<uint32_t> AudioWorkletNodeOptions::getOutputChannelCountOr(Vector<uint32_t>&& fallback_value) const {
  if (!hasOutputChannelCount()) {
  return std::move(fallback_value);
}
return member_output_channel_count_;
}

void AudioWorkletNodeOptions::setOutputChannelCount(const Vector<uint32_t>& value) {
  member_output_channel_count_ = value;
has_output_channel_count_ = true;
}

void AudioWorkletNodeOptions::setOutputChannelCount(Vector<uint32_t>&& value) {
  member_output_channel_count_ = std::move(value);
has_output_channel_count_ = true;
}




Vector<std::pair<String, double>> AudioWorkletNodeOptions::getParameterDataOr(const Vector<std::pair<String, double>>& fallback_value) const {
  if (!hasParameterData()) {
  return fallback_value;
}
return member_parameter_data_;
}

Vector<std::pair<String, double>> AudioWorkletNodeOptions::getParameterDataOr(Vector<std::pair<String, double>>&& fallback_value) const {
  if (!hasParameterData()) {
  return std::move(fallback_value);
}
return member_parameter_data_;
}

void AudioWorkletNodeOptions::setParameterData(const Vector<std::pair<String, double>>& value) {
  member_parameter_data_ = value;
has_parameter_data_ = true;
}

void AudioWorkletNodeOptions::setParameterData(Vector<std::pair<String, double>>&& value) {
  member_parameter_data_ = std::move(value);
has_parameter_data_ = true;
}











void AudioWorkletNodeOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<uint32_t>::Trace(visitor, member_number_of_inputs_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_number_of_outputs_);
TraceIfNeeded<Vector<uint32_t>>::Trace(visitor, member_output_channel_count_);
TraceIfNeeded<Vector<std::pair<String, double>>>::Trace(visitor, member_parameter_data_);
TraceIfNeeded<ScriptValue>::Trace(visitor, member_processor_options_);
AudioNodeOptions::Trace(visitor);
}

bool AudioWorkletNodeOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!AudioNodeOptions::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasNumberOfInputs()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_number_of_inputs_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasNumberOfOutputs()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_number_of_outputs_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasOutputChannelCount()) {
  v8_value = ToV8Traits<IDLSequence<IDLUnsignedLong>>::ToV8(script_state, member_output_channel_count_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasParameterData()) {
  v8_value = ToV8Traits<IDLRecord<IDLString, IDLDouble>>::ToV8(script_state, member_parameter_data_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasProcessorOptions()) {
  v8_value = ToV8Traits<IDLObject>::ToV8(script_state, member_processor_options_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
return true;
}

void AudioWorkletNodeOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  AudioNodeOptions::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "AudioWorkletNodeOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("numberOfInputs");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_number_of_inputs_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("numberOfOutputs");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_number_of_outputs_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("outputChannelCount");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUnsignedLong>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_output_channel_count_, member_output_channel_count_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("parameterData");
if (!bindings::GetDictionaryMemberFromV8Object<IDLRecord<IDLString, IDLDouble>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_parameter_data_, member_parameter_data_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("processorOptions");
if (!bindings::GetDictionaryMemberFromV8Object<IDLObject, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_processor_options_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> AudioWorkletNodeOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"numberOfInputs",
"numberOfOutputs",
"outputChannelCount",
"parameterData",
"processorOptions",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
