// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_AUTHENTICATION_EXTENSIONS_PRF_INPUTS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_AUTHENTICATION_EXTENSIONS_PRF_INPUTS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class AuthenticationExtensionsPRFValues;
class ExceptionState;

class MODULES_EXPORT AuthenticationExtensionsPRFInputs : public bindings::DictionaryBase {
  
  public:
static AuthenticationExtensionsPRFInputs* Create() {
  return MakeGarbageCollected<AuthenticationExtensionsPRFInputs>();
}
static AuthenticationExtensionsPRFInputs* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<AuthenticationExtensionsPRFInputs>(isolate);
}
static AuthenticationExtensionsPRFInputs* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  AuthenticationExtensionsPRFInputs();
explicit  AuthenticationExtensionsPRFInputs(v8::Isolate* isolate);

bool hasEval() const {
  return has_eval_;
}
AuthenticationExtensionsPRFValues* eval() const {
  DCHECK(hasEval());
return member_eval_.Get();
}
AuthenticationExtensionsPRFValues* getEvalOr(AuthenticationExtensionsPRFValues* fallback_value) const {
  if (!hasEval()) {
  return fallback_value;
}
return member_eval_.Get();
}
void setEval(AuthenticationExtensionsPRFValues* value) {
  member_eval_ = value;
has_eval_ = true;
DCHECK(member_eval_);
}

bool hasEvalByCredential() const {
  return has_eval_by_credential_;
}
const HeapVector<std::pair<String, Member<AuthenticationExtensionsPRFValues>>>& evalByCredential() const {
  DCHECK(hasEvalByCredential());
return member_eval_by_credential_;
}
HeapVector<std::pair<String, Member<AuthenticationExtensionsPRFValues>>> getEvalByCredentialOr(const HeapVector<std::pair<String, Member<AuthenticationExtensionsPRFValues>>>& fallback_value) const;
HeapVector<std::pair<String, Member<AuthenticationExtensionsPRFValues>>> getEvalByCredentialOr(HeapVector<std::pair<String, Member<AuthenticationExtensionsPRFValues>>>&& fallback_value) const;
void setEvalByCredential(const HeapVector<std::pair<String, Member<AuthenticationExtensionsPRFValues>>>& value);
void setEvalByCredential(HeapVector<std::pair<String, Member<AuthenticationExtensionsPRFValues>>>&& value);




void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_eval_ = false;
bool has_eval_by_credential_ = false;

Member<AuthenticationExtensionsPRFValues> member_eval_;
HeapVector<std::pair<String, Member<AuthenticationExtensionsPRFValues>>> member_eval_by_credential_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_AUTHENTICATION_EXTENSIONS_PRF_INPUTS_H_
