// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_authentication_response_js_on.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_authentication_extensions_client_outputs_js_on.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_authenticator_assertion_response_js_on.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



AuthenticationResponseJSON* AuthenticationResponseJSON::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  AuthenticationResponseJSON* dictionary = MakeGarbageCollected<AuthenticationResponseJSON>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "AuthenticationResponseJSON";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 AuthenticationResponseJSON::AuthenticationResponseJSON() {
  
}

 AuthenticationResponseJSON::AuthenticationResponseJSON(v8::Isolate* isolate) {
  
}



String AuthenticationResponseJSON::getAuthenticatorAttachmentOr(const String& fallback_value) const {
  if (!hasAuthenticatorAttachment()) {
  return fallback_value;
}
return member_authenticator_attachment_;
}

String AuthenticationResponseJSON::getAuthenticatorAttachmentOr(String&& fallback_value) const {
  if (!hasAuthenticatorAttachment()) {
  return std::move(fallback_value);
}
return member_authenticator_attachment_;
}

void AuthenticationResponseJSON::setAuthenticatorAttachment(const String& value) {
  member_authenticator_attachment_ = value;
has_authenticator_attachment_ = true;
}

void AuthenticationResponseJSON::setAuthenticatorAttachment(String&& value) {
  member_authenticator_attachment_ = std::move(value);
has_authenticator_attachment_ = true;
}











String AuthenticationResponseJSON::getIdOr(const String& fallback_value) const {
  if (!hasId()) {
  return fallback_value;
}
return member_id_;
}

String AuthenticationResponseJSON::getIdOr(String&& fallback_value) const {
  if (!hasId()) {
  return std::move(fallback_value);
}
return member_id_;
}

void AuthenticationResponseJSON::setId(const String& value) {
  member_id_ = value;
has_id_ = true;
}

void AuthenticationResponseJSON::setId(String&& value) {
  member_id_ = std::move(value);
has_id_ = true;
}




String AuthenticationResponseJSON::getRawIdOr(const String& fallback_value) const {
  if (!hasRawId()) {
  return fallback_value;
}
return member_raw_id_;
}

String AuthenticationResponseJSON::getRawIdOr(String&& fallback_value) const {
  if (!hasRawId()) {
  return std::move(fallback_value);
}
return member_raw_id_;
}

void AuthenticationResponseJSON::setRawId(const String& value) {
  member_raw_id_ = value;
has_raw_id_ = true;
}

void AuthenticationResponseJSON::setRawId(String&& value) {
  member_raw_id_ = std::move(value);
has_raw_id_ = true;
}











String AuthenticationResponseJSON::getTypeOr(const String& fallback_value) const {
  if (!hasType()) {
  return fallback_value;
}
return member_type_;
}

String AuthenticationResponseJSON::getTypeOr(String&& fallback_value) const {
  if (!hasType()) {
  return std::move(fallback_value);
}
return member_type_;
}

void AuthenticationResponseJSON::setType(const String& value) {
  member_type_ = value;
has_type_ = true;
}

void AuthenticationResponseJSON::setType(String&& value) {
  member_type_ = std::move(value);
has_type_ = true;
}




void AuthenticationResponseJSON::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_authenticator_attachment_);
TraceIfNeeded<Member<AuthenticationExtensionsClientOutputsJSON>>::Trace(visitor, member_client_extension_results_);
TraceIfNeeded<String>::Trace(visitor, member_id_);
TraceIfNeeded<String>::Trace(visitor, member_raw_id_);
TraceIfNeeded<Member<AuthenticatorAssertionResponseJSON>>::Trace(visitor, member_response_);
TraceIfNeeded<String>::Trace(visitor, member_type_);
bindings::DictionaryBase::Trace(visitor);
}

bool AuthenticationResponseJSON::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAuthenticatorAttachment()) {
  v8_value = ToV8Traits<IDLNullable<IDLString>>::ToV8(script_state, member_authenticator_attachment_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasClientExtensionResults()) {
  v8_value = ToV8Traits<AuthenticationExtensionsClientOutputsJSON>::ToV8(script_state, member_client_extension_results_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasId()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasRawId()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_raw_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasResponse()) {
  v8_value = ToV8Traits<AuthenticatorAssertionResponseJSON>::ToV8(script_state, member_response_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasType()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_type_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
return true;
}

void AuthenticationResponseJSON::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "AuthenticationResponseJSON";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("authenticatorAttachment");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_authenticator_attachment_, member_authenticator_attachment_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("clientExtensionResults");
if (!bindings::GetDictionaryMemberFromV8Object<AuthenticationExtensionsClientOutputsJSON, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_client_extension_results_, member_client_extension_results_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("id");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_id_, member_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("rawId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_raw_id_, member_raw_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("response");
if (!bindings::GetDictionaryMemberFromV8Object<AuthenticatorAssertionResponseJSON, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_response_, member_response_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("type");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_type_, member_type_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> AuthenticationResponseJSON::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"authenticatorAttachment",
"clientExtensionResults",
"id",
"rawId",
"response",
"type",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
