// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_authenticator_assertion_response_js_on.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



AuthenticatorAssertionResponseJSON* AuthenticatorAssertionResponseJSON::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  AuthenticatorAssertionResponseJSON* dictionary = MakeGarbageCollected<AuthenticatorAssertionResponseJSON>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "AuthenticatorAssertionResponseJSON";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 AuthenticatorAssertionResponseJSON::AuthenticatorAssertionResponseJSON() {
  
}

 AuthenticatorAssertionResponseJSON::AuthenticatorAssertionResponseJSON(v8::Isolate* isolate) {
  
}



String AuthenticatorAssertionResponseJSON::getAuthenticatorDataOr(const String& fallback_value) const {
  if (!hasAuthenticatorData()) {
  return fallback_value;
}
return member_authenticator_data_;
}

String AuthenticatorAssertionResponseJSON::getAuthenticatorDataOr(String&& fallback_value) const {
  if (!hasAuthenticatorData()) {
  return std::move(fallback_value);
}
return member_authenticator_data_;
}

void AuthenticatorAssertionResponseJSON::setAuthenticatorData(const String& value) {
  member_authenticator_data_ = value;
has_authenticator_data_ = true;
}

void AuthenticatorAssertionResponseJSON::setAuthenticatorData(String&& value) {
  member_authenticator_data_ = std::move(value);
has_authenticator_data_ = true;
}




String AuthenticatorAssertionResponseJSON::getClientDataJSONOr(const String& fallback_value) const {
  if (!hasClientDataJSON()) {
  return fallback_value;
}
return member_client_data_js_on_;
}

String AuthenticatorAssertionResponseJSON::getClientDataJSONOr(String&& fallback_value) const {
  if (!hasClientDataJSON()) {
  return std::move(fallback_value);
}
return member_client_data_js_on_;
}

void AuthenticatorAssertionResponseJSON::setClientDataJSON(const String& value) {
  member_client_data_js_on_ = value;
has_client_data_js_on_ = true;
}

void AuthenticatorAssertionResponseJSON::setClientDataJSON(String&& value) {
  member_client_data_js_on_ = std::move(value);
has_client_data_js_on_ = true;
}




String AuthenticatorAssertionResponseJSON::getSignatureOr(const String& fallback_value) const {
  if (!hasSignature()) {
  return fallback_value;
}
return member_signature_;
}

String AuthenticatorAssertionResponseJSON::getSignatureOr(String&& fallback_value) const {
  if (!hasSignature()) {
  return std::move(fallback_value);
}
return member_signature_;
}

void AuthenticatorAssertionResponseJSON::setSignature(const String& value) {
  member_signature_ = value;
has_signature_ = true;
}

void AuthenticatorAssertionResponseJSON::setSignature(String&& value) {
  member_signature_ = std::move(value);
has_signature_ = true;
}




String AuthenticatorAssertionResponseJSON::getUserHandleOr(const String& fallback_value) const {
  if (!hasUserHandle()) {
  return fallback_value;
}
return member_user_handle_;
}

String AuthenticatorAssertionResponseJSON::getUserHandleOr(String&& fallback_value) const {
  if (!hasUserHandle()) {
  return std::move(fallback_value);
}
return member_user_handle_;
}

void AuthenticatorAssertionResponseJSON::setUserHandle(const String& value) {
  member_user_handle_ = value;
has_user_handle_ = true;
}

void AuthenticatorAssertionResponseJSON::setUserHandle(String&& value) {
  member_user_handle_ = std::move(value);
has_user_handle_ = true;
}




void AuthenticatorAssertionResponseJSON::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_authenticator_data_);
TraceIfNeeded<String>::Trace(visitor, member_client_data_js_on_);
TraceIfNeeded<String>::Trace(visitor, member_signature_);
TraceIfNeeded<String>::Trace(visitor, member_user_handle_);
bindings::DictionaryBase::Trace(visitor);
}

bool AuthenticatorAssertionResponseJSON::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAuthenticatorData()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_authenticator_data_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasClientDataJSON()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_client_data_js_on_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasSignature()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_signature_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasUserHandle()) {
  v8_value = ToV8Traits<IDLNullable<IDLString>>::ToV8(script_state, member_user_handle_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
return true;
}

void AuthenticatorAssertionResponseJSON::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "AuthenticatorAssertionResponseJSON";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("authenticatorData");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_authenticator_data_, member_authenticator_data_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("clientDataJSON");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_client_data_js_on_, member_client_data_js_on_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("signature");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_signature_, member_signature_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("userHandle");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_user_handle_, member_user_handle_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> AuthenticatorAssertionResponseJSON::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"authenticatorData",
"clientDataJSON",
"signature",
"userHandle",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
