// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_authenticator_selection_criteria.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



AuthenticatorSelectionCriteria* AuthenticatorSelectionCriteria::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  AuthenticatorSelectionCriteria* dictionary = MakeGarbageCollected<AuthenticatorSelectionCriteria>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "AuthenticatorSelectionCriteria";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 AuthenticatorSelectionCriteria::AuthenticatorSelectionCriteria() {
  
}

 AuthenticatorSelectionCriteria::AuthenticatorSelectionCriteria(v8::Isolate* isolate) {
  
}



String AuthenticatorSelectionCriteria::getAuthenticatorAttachmentOr(const String& fallback_value) const {
  if (!hasAuthenticatorAttachment()) {
  return fallback_value;
}
return member_authenticator_attachment_;
}

String AuthenticatorSelectionCriteria::getAuthenticatorAttachmentOr(String&& fallback_value) const {
  if (!hasAuthenticatorAttachment()) {
  return std::move(fallback_value);
}
return member_authenticator_attachment_;
}

void AuthenticatorSelectionCriteria::setAuthenticatorAttachment(const String& value) {
  member_authenticator_attachment_ = value;
has_authenticator_attachment_ = true;
}

void AuthenticatorSelectionCriteria::setAuthenticatorAttachment(String&& value) {
  member_authenticator_attachment_ = std::move(value);
has_authenticator_attachment_ = true;
}









String AuthenticatorSelectionCriteria::getResidentKeyOr(const String& fallback_value) const {
  if (!hasResidentKey()) {
  return fallback_value;
}
return member_resident_key_;
}

String AuthenticatorSelectionCriteria::getResidentKeyOr(String&& fallback_value) const {
  if (!hasResidentKey()) {
  return std::move(fallback_value);
}
return member_resident_key_;
}

void AuthenticatorSelectionCriteria::setResidentKey(const String& value) {
  member_resident_key_ = value;
has_resident_key_ = true;
}

void AuthenticatorSelectionCriteria::setResidentKey(String&& value) {
  member_resident_key_ = std::move(value);
has_resident_key_ = true;
}




String AuthenticatorSelectionCriteria::getUserVerificationOr(const String& fallback_value) const {
  if (!hasUserVerification()) {
  return fallback_value;
}
return member_user_verification_;
}

String AuthenticatorSelectionCriteria::getUserVerificationOr(String&& fallback_value) const {
  if (!hasUserVerification()) {
  return std::move(fallback_value);
}
return member_user_verification_;
}

void AuthenticatorSelectionCriteria::setUserVerification(const String& value) {
  member_user_verification_ = value;
has_user_verification_ = true;
}

void AuthenticatorSelectionCriteria::setUserVerification(String&& value) {
  member_user_verification_ = std::move(value);
has_user_verification_ = true;
}




void AuthenticatorSelectionCriteria::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_authenticator_attachment_);
TraceIfNeeded<bool>::Trace(visitor, member_require_resident_key_);
TraceIfNeeded<String>::Trace(visitor, member_resident_key_);
TraceIfNeeded<String>::Trace(visitor, member_user_verification_);
bindings::DictionaryBase::Trace(visitor);
}

bool AuthenticatorSelectionCriteria::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAuthenticatorAttachment()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_authenticator_attachment_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasRequireResidentKey()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_require_resident_key_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasResidentKey()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_resident_key_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasUserVerification()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_user_verification_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
return true;
}

void AuthenticatorSelectionCriteria::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "AuthenticatorSelectionCriteria";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("authenticatorAttachment");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_authenticator_attachment_, member_authenticator_attachment_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("requireResidentKey");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_require_resident_key_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("residentKey");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_resident_key_, member_resident_key_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("userVerification");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_user_verification_, member_user_verification_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> AuthenticatorSelectionCriteria::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"authenticatorAttachment",
"requireResidentKey",
"residentKey",
"userVerification",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
