// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_bluetooth_le_scan_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_bluetooth_le_scan_filter_init.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



BluetoothLEScanOptions* BluetoothLEScanOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  BluetoothLEScanOptions* dictionary = MakeGarbageCollected<BluetoothLEScanOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "BluetoothLEScanOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 BluetoothLEScanOptions::BluetoothLEScanOptions() {
  
}

 BluetoothLEScanOptions::BluetoothLEScanOptions(v8::Isolate* isolate) {
  
}








HeapVector<Member<BluetoothLEScanFilterInit>> BluetoothLEScanOptions::getFiltersOr(const HeapVector<Member<BluetoothLEScanFilterInit>>& fallback_value) const {
  if (!hasFilters()) {
  return fallback_value;
}
return member_filters_;
}

HeapVector<Member<BluetoothLEScanFilterInit>> BluetoothLEScanOptions::getFiltersOr(HeapVector<Member<BluetoothLEScanFilterInit>>&& fallback_value) const {
  if (!hasFilters()) {
  return std::move(fallback_value);
}
return member_filters_;
}

void BluetoothLEScanOptions::setFilters(const HeapVector<Member<BluetoothLEScanFilterInit>>& value) {
  member_filters_ = value;
has_filters_ = true;
}

void BluetoothLEScanOptions::setFilters(HeapVector<Member<BluetoothLEScanFilterInit>>&& value) {
  member_filters_ = std::move(value);
has_filters_ = true;
}









void BluetoothLEScanOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<bool>::Trace(visitor, member_accept_all_advertisements_);
TraceIfNeeded<HeapVector<Member<BluetoothLEScanFilterInit>>>::Trace(visitor, member_filters_);
TraceIfNeeded<bool>::Trace(visitor, member_keep_repeated_devices_);
bindings::DictionaryBase::Trace(visitor);
}

bool BluetoothLEScanOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAcceptAllAdvertisements()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_accept_all_advertisements_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasFilters()) {
  v8_value = ToV8Traits<IDLSequence<BluetoothLEScanFilterInit>>::ToV8(script_state, member_filters_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasKeepRepeatedDevices()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_keep_repeated_devices_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
return true;
}

void BluetoothLEScanOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "BluetoothLEScanOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("acceptAllAdvertisements");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_accept_all_advertisements_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("filters");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<BluetoothLEScanFilterInit>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_filters_, member_filters_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("keepRepeatedDevices");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_keep_repeated_devices_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> BluetoothLEScanOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"acceptAllAdvertisements",
"filters",
"keepRepeatedDevices",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
