// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_chapter_information.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_media_image.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



ChapterInformation* ChapterInformation::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  ChapterInformation* dictionary = MakeGarbageCollected<ChapterInformation>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "ChapterInformation";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 ChapterInformation::ChapterInformation() {
  
}

 ChapterInformation::ChapterInformation(v8::Isolate* isolate) {
  
}



HeapVector<Member<MediaImage>> ChapterInformation::getArtworkOr(const HeapVector<Member<MediaImage>>& fallback_value) const {
  if (!hasArtwork()) {
  return fallback_value;
}
return member_artwork_;
}

HeapVector<Member<MediaImage>> ChapterInformation::getArtworkOr(HeapVector<Member<MediaImage>>&& fallback_value) const {
  if (!hasArtwork()) {
  return std::move(fallback_value);
}
return member_artwork_;
}

void ChapterInformation::setArtwork(const HeapVector<Member<MediaImage>>& value) {
  member_artwork_ = value;
has_artwork_ = true;
}

void ChapterInformation::setArtwork(HeapVector<Member<MediaImage>>&& value) {
  member_artwork_ = std::move(value);
has_artwork_ = true;
}









void ChapterInformation::setTitle(const String& value) {
  member_title_ = value;
}

void ChapterInformation::setTitle(String&& value) {
  member_title_ = std::move(value);
}




void ChapterInformation::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<Member<MediaImage>>>::Trace(visitor, member_artwork_);
TraceIfNeeded<double>::Trace(visitor, member_start_time_);
TraceIfNeeded<String>::Trace(visitor, member_title_);
bindings::DictionaryBase::Trace(visitor);
}

bool ChapterInformation::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasArtwork()) {
  v8_value = ToV8Traits<IDLSequence<MediaImage>>::ToV8(script_state, member_artwork_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasStartTime()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_start_time_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasTitle()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_title_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
return true;
}

void ChapterInformation::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "ChapterInformation";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("artwork");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<MediaImage>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_artwork_, member_artwork_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("startTime");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_start_time_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("title");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_title_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> ChapterInformation::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"artwork",
"startTime",
"title",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
