// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_contact_info.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/core/fileapi/blob.h"
#include "third_party/blink/renderer/modules/contacts_picker/contact_address.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



ContactInfo* ContactInfo::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  ContactInfo* dictionary = MakeGarbageCollected<ContactInfo>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "ContactInfo";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 ContactInfo::ContactInfo() {
  
}

 ContactInfo::ContactInfo(v8::Isolate* isolate) {
  
}



HeapVector<Member<ContactAddress>> ContactInfo::getAddressOr(const HeapVector<Member<ContactAddress>>& fallback_value) const {
  if (!hasAddress()) {
  return fallback_value;
}
return member_address_;
}

HeapVector<Member<ContactAddress>> ContactInfo::getAddressOr(HeapVector<Member<ContactAddress>>&& fallback_value) const {
  if (!hasAddress()) {
  return std::move(fallback_value);
}
return member_address_;
}

void ContactInfo::setAddress(const HeapVector<Member<ContactAddress>>& value) {
  member_address_ = value;
has_address_ = true;
}

void ContactInfo::setAddress(HeapVector<Member<ContactAddress>>&& value) {
  member_address_ = std::move(value);
has_address_ = true;
}




Vector<String> ContactInfo::getEmailOr(const Vector<String>& fallback_value) const {
  if (!hasEmail()) {
  return fallback_value;
}
return member_email_;
}

Vector<String> ContactInfo::getEmailOr(Vector<String>&& fallback_value) const {
  if (!hasEmail()) {
  return std::move(fallback_value);
}
return member_email_;
}

void ContactInfo::setEmail(const Vector<String>& value) {
  member_email_ = value;
has_email_ = true;
}

void ContactInfo::setEmail(Vector<String>&& value) {
  member_email_ = std::move(value);
has_email_ = true;
}




HeapVector<Member<Blob>> ContactInfo::getIconOr(const HeapVector<Member<Blob>>& fallback_value) const {
  if (!hasIcon()) {
  return fallback_value;
}
return member_icon_;
}

HeapVector<Member<Blob>> ContactInfo::getIconOr(HeapVector<Member<Blob>>&& fallback_value) const {
  if (!hasIcon()) {
  return std::move(fallback_value);
}
return member_icon_;
}

void ContactInfo::setIcon(const HeapVector<Member<Blob>>& value) {
  member_icon_ = value;
has_icon_ = true;
}

void ContactInfo::setIcon(HeapVector<Member<Blob>>&& value) {
  member_icon_ = std::move(value);
has_icon_ = true;
}




Vector<String> ContactInfo::getNameOr(const Vector<String>& fallback_value) const {
  if (!hasName()) {
  return fallback_value;
}
return member_name_;
}

Vector<String> ContactInfo::getNameOr(Vector<String>&& fallback_value) const {
  if (!hasName()) {
  return std::move(fallback_value);
}
return member_name_;
}

void ContactInfo::setName(const Vector<String>& value) {
  member_name_ = value;
has_name_ = true;
}

void ContactInfo::setName(Vector<String>&& value) {
  member_name_ = std::move(value);
has_name_ = true;
}




Vector<String> ContactInfo::getTelOr(const Vector<String>& fallback_value) const {
  if (!hasTel()) {
  return fallback_value;
}
return member_tel_;
}

Vector<String> ContactInfo::getTelOr(Vector<String>&& fallback_value) const {
  if (!hasTel()) {
  return std::move(fallback_value);
}
return member_tel_;
}

void ContactInfo::setTel(const Vector<String>& value) {
  member_tel_ = value;
has_tel_ = true;
}

void ContactInfo::setTel(Vector<String>&& value) {
  member_tel_ = std::move(value);
has_tel_ = true;
}




void ContactInfo::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<Member<ContactAddress>>>::Trace(visitor, member_address_);
TraceIfNeeded<Vector<String>>::Trace(visitor, member_email_);
TraceIfNeeded<HeapVector<Member<Blob>>>::Trace(visitor, member_icon_);
TraceIfNeeded<Vector<String>>::Trace(visitor, member_name_);
TraceIfNeeded<Vector<String>>::Trace(visitor, member_tel_);
bindings::DictionaryBase::Trace(visitor);
}

bool ContactInfo::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAddress()) {
  v8_value = ToV8Traits<IDLSequence<ContactAddress>>::ToV8(script_state, member_address_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasEmail()) {
  v8_value = ToV8Traits<IDLSequence<IDLUSVString>>::ToV8(script_state, member_email_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasIcon()) {
  v8_value = ToV8Traits<IDLSequence<Blob>>::ToV8(script_state, member_icon_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasName()) {
  v8_value = ToV8Traits<IDLSequence<IDLUSVString>>::ToV8(script_state, member_name_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasTel()) {
  v8_value = ToV8Traits<IDLSequence<IDLUSVString>>::ToV8(script_state, member_tel_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
return true;
}

void ContactInfo::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "ContactInfo";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("address");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<ContactAddress>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_address_, member_address_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("email");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUSVString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_email_, member_email_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("icon");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<Blob>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_icon_, member_icon_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("name");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUSVString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_name_, member_name_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("tel");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUSVString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_tel_, member_tel_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> ContactInfo::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"address",
"email",
"icon",
"name",
"tel",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
