// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_cookie_list_item.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/core/execution_context/execution_context.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



CookieListItem* CookieListItem::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  CookieListItem* dictionary = MakeGarbageCollected<CookieListItem>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "CookieListItem";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 CookieListItem::CookieListItem() {
  
}

 CookieListItem::CookieListItem(v8::Isolate* isolate) {
  
}



String CookieListItem::getDomainOr(const String& fallback_value) const {
  if (!hasDomain()) {
  return fallback_value;
}
return member_domain_;
}

String CookieListItem::getDomainOr(String&& fallback_value) const {
  if (!hasDomain()) {
  return std::move(fallback_value);
}
return member_domain_;
}

void CookieListItem::setDomain(const String& value) {
  member_domain_ = value;
has_domain_ = true;
}

void CookieListItem::setDomain(String&& value) {
  member_domain_ = std::move(value);
has_domain_ = true;
}











String CookieListItem::getNameOr(const String& fallback_value) const {
  if (!hasName()) {
  return fallback_value;
}
return member_name_;
}

String CookieListItem::getNameOr(String&& fallback_value) const {
  if (!hasName()) {
  return std::move(fallback_value);
}
return member_name_;
}

void CookieListItem::setName(const String& value) {
  member_name_ = value;
has_name_ = true;
}

void CookieListItem::setName(String&& value) {
  member_name_ = std::move(value);
has_name_ = true;
}











String CookieListItem::getPathOr(const String& fallback_value) const {
  if (!hasPath()) {
  return fallback_value;
}
return member_path_;
}

String CookieListItem::getPathOr(String&& fallback_value) const {
  if (!hasPath()) {
  return std::move(fallback_value);
}
return member_path_;
}

void CookieListItem::setPath(const String& value) {
  member_path_ = value;
has_path_ = true;
}

void CookieListItem::setPath(String&& value) {
  member_path_ = std::move(value);
has_path_ = true;
}


















String CookieListItem::getValueOr(const String& fallback_value) const {
  if (!hasValue()) {
  return fallback_value;
}
return member_value_;
}

String CookieListItem::getValueOr(String&& fallback_value) const {
  if (!hasValue()) {
  return std::move(fallback_value);
}
return member_value_;
}

void CookieListItem::setValue(const String& value) {
  member_value_ = value;
has_value_ = true;
}

void CookieListItem::setValue(String&& value) {
  member_value_ = std::move(value);
has_value_ = true;
}




void CookieListItem::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_domain_);
TraceIfNeeded<absl::optional<double>>::Trace(visitor, member_expires_);
TraceIfNeeded<String>::Trace(visitor, member_name_);
TraceIfNeeded<bool>::Trace(visitor, member_partitioned_);
TraceIfNeeded<String>::Trace(visitor, member_path_);
TraceIfNeeded<V8CookieSameSite>::Trace(visitor, member_same_site_);
TraceIfNeeded<bool>::Trace(visitor, member_secure_);
TraceIfNeeded<String>::Trace(visitor, member_value_);
bindings::DictionaryBase::Trace(visitor);
}

bool CookieListItem::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasDomain()) {
  v8_value = ToV8Traits<IDLNullable<IDLUSVString>>::ToV8(script_state, member_domain_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasExpires()) {
  v8_value = ToV8Traits<IDLNullable<IDLDouble>>::ToV8(script_state, member_expires_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasName()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_name_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
ExecutionContext* execution_context = ExecutionContext::From(current_context);
if (RuntimeEnabledFeatures::PartitionedCookiesEnabled(execution_context)) {
  if (hasPartitioned()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_partitioned_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
}
if (hasPath()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_path_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasSameSite()) {
  v8_value = ToV8Traits<V8CookieSameSite>::ToV8(script_state, member_same_site_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
if (hasSecure()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_secure_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[6].Get(isolate), v8_value).ToChecked();
}
if (hasValue()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_value_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[7].Get(isolate), v8_value).ToChecked();
}
return true;
}

void CookieListItem::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "CookieListItem";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("domain");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLUSVString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_domain_, member_domain_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("expires");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLDouble>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_expires_, member_expires_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("name");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_name_, member_name_, try_block, exception_state)) {
  return;
}
ExecutionContext* execution_context = ExecutionContext::From(current_context);
if (RuntimeEnabledFeatures::PartitionedCookiesEnabled(execution_context)) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("partitioned");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_partitioned_, member_partitioned_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("path");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_path_, member_path_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sameSite");
if (!bindings::GetDictionaryMemberFromV8Object<V8CookieSameSite, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_same_site_, member_same_site_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("secure");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_secure_, member_secure_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("value");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), has_value_, member_value_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> CookieListItem::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"domain",
"expires",
"name",
"partitioned",
"path",
"sameSite",
"secure",
"value",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
