// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_credential_request_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_federated_credential_request_options.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_identity_credential_request_options.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_otp_credential_request_options.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_public_key_credential_request_options.h"
#include "third_party/blink/renderer/core/dom/abort_signal.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



CredentialRequestOptions* CredentialRequestOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  CredentialRequestOptions* dictionary = MakeGarbageCollected<CredentialRequestOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "CredentialRequestOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 CredentialRequestOptions::CredentialRequestOptions() {
  
}

 CredentialRequestOptions::CredentialRequestOptions(v8::Isolate* isolate) {
  
}
















































void CredentialRequestOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<FederatedCredentialRequestOptions>>::Trace(visitor, member_federated_);
TraceIfNeeded<Member<IdentityCredentialRequestOptions>>::Trace(visitor, member_identity_);
TraceIfNeeded<V8CredentialMediationRequirement>::Trace(visitor, member_mediation_);
TraceIfNeeded<Member<OTPCredentialRequestOptions>>::Trace(visitor, member_otp_);
TraceIfNeeded<bool>::Trace(visitor, member_password_);
TraceIfNeeded<Member<PublicKeyCredentialRequestOptions>>::Trace(visitor, member_public_key_);
TraceIfNeeded<Member<AbortSignal>>::Trace(visitor, member_signal_);
bindings::DictionaryBase::Trace(visitor);
}

bool CredentialRequestOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasFederated()) {
  v8_value = ToV8Traits<FederatedCredentialRequestOptions>::ToV8(script_state, member_federated_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasIdentity()) {
  v8_value = ToV8Traits<IdentityCredentialRequestOptions>::ToV8(script_state, member_identity_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasMediation()) {
  v8_value = ToV8Traits<V8CredentialMediationRequirement>::ToV8(script_state, member_mediation_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (RuntimeEnabledFeatures::WebOTPEnabled()) {
  if (hasOtp()) {
  v8_value = ToV8Traits<OTPCredentialRequestOptions>::ToV8(script_state, member_otp_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
}
if (hasPassword()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_password_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasPublicKey()) {
  v8_value = ToV8Traits<PublicKeyCredentialRequestOptions>::ToV8(script_state, member_public_key_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
if (hasSignal()) {
  v8_value = ToV8Traits<AbortSignal>::ToV8(script_state, member_signal_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[6].Get(isolate), v8_value).ToChecked();
}
return true;
}

void CredentialRequestOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "CredentialRequestOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("federated");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<FederatedCredentialRequestOptions, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_federated_, member_federated_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("identity");
if (!bindings::GetDictionaryMemberFromV8Object<IdentityCredentialRequestOptions, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_identity_, member_identity_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("mediation");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<V8CredentialMediationRequirement, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_mediation_, try_block, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::WebOTPEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("otp");
if (!bindings::GetDictionaryMemberFromV8Object<OTPCredentialRequestOptions, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_otp_, member_otp_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("password");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_password_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("publicKey");
if (!bindings::GetDictionaryMemberFromV8Object<PublicKeyCredentialRequestOptions, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_public_key_, member_public_key_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("signal");
if (!bindings::GetDictionaryMemberFromV8Object<AbortSignal, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_signal_, member_signal_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> CredentialRequestOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"federated",
"identity",
"mediation",
"otp",
"password",
"publicKey",
"signal",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
