// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_detected_text.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_point_2d.h"
#include "third_party/blink/renderer/core/geometry/dom_rect_read_only.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



DetectedText* DetectedText::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  DetectedText* dictionary = MakeGarbageCollected<DetectedText>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "DetectedText";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 DetectedText::DetectedText() {
  
}

 DetectedText::DetectedText(v8::Isolate* isolate) {
  
}








void DetectedText::setCornerPoints(const HeapVector<Member<Point2D>>& value) {
  member_corner_points_ = value;
}

void DetectedText::setCornerPoints(HeapVector<Member<Point2D>>&& value) {
  member_corner_points_ = std::move(value);
}




void DetectedText::setRawValue(const String& value) {
  member_raw_value_ = value;
}

void DetectedText::setRawValue(String&& value) {
  member_raw_value_ = std::move(value);
}




void DetectedText::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<DOMRectReadOnly>>::Trace(visitor, member_bounding_box_);
TraceIfNeeded<HeapVector<Member<Point2D>>>::Trace(visitor, member_corner_points_);
TraceIfNeeded<String>::Trace(visitor, member_raw_value_);
bindings::DictionaryBase::Trace(visitor);
}

bool DetectedText::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasBoundingBox()) {
  v8_value = ToV8Traits<DOMRectReadOnly>::ToV8(script_state, member_bounding_box_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasCornerPoints()) {
  v8_value = ToV8Traits<IDLArray<Point2D>>::ToV8(script_state, member_corner_points_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasRawValue()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_raw_value_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
return true;
}

void DetectedText::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "DetectedText";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("boundingBox");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<DOMRectReadOnly, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_bounding_box_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("cornerPoints");
if (!bindings::GetDictionaryMemberFromV8Object<IDLArray<Point2D>, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_corner_points_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("rawValue");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_raw_value_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> DetectedText::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"boundingBox",
"cornerPoints",
"rawValue",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
