// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_DIGITAL_CREDENTIAL_PROVIDER_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_DIGITAL_CREDENTIAL_PROVIDER_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class DigitalCredentialSelector;
class ExceptionState;

class MODULES_EXPORT DigitalCredentialProvider : public bindings::DictionaryBase {
  
  public:
static DigitalCredentialProvider* Create() {
  return MakeGarbageCollected<DigitalCredentialProvider>();
}
static DigitalCredentialProvider* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<DigitalCredentialProvider>(isolate);
}
static DigitalCredentialProvider* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  DigitalCredentialProvider();
explicit  DigitalCredentialProvider(v8::Isolate* isolate);

bool hasParams() const {
  return has_params_;
}
const Vector<std::pair<String, String>>& params() const {
  DCHECK(hasParams());
return member_params_;
}
Vector<std::pair<String, String>> getParamsOr(const Vector<std::pair<String, String>>& fallback_value) const;
Vector<std::pair<String, String>> getParamsOr(Vector<std::pair<String, String>>&& fallback_value) const;
void setParams(const Vector<std::pair<String, String>>& value);
void setParams(Vector<std::pair<String, String>>&& value);

bool hasProtocol() const {
  return has_protocol_;
}
const String& protocol() const {
  DCHECK(hasProtocol());
return member_protocol_;
}
String getProtocolOr(const String& fallback_value) const;
String getProtocolOr(String&& fallback_value) const;
void setProtocol(const String& value);
void setProtocol(String&& value);

bool hasPublicKey() const {
  return has_public_key_;
}
const String& publicKey() const {
  DCHECK(hasPublicKey());
return member_public_key_;
}
String getPublicKeyOr(const String& fallback_value) const;
String getPublicKeyOr(String&& fallback_value) const;
void setPublicKey(const String& value);
void setPublicKey(String&& value);

bool hasRequest() const {
  return has_request_;
}
const String& request() const {
  DCHECK(hasRequest());
return member_request_;
}
String getRequestOr(const String& fallback_value) const;
String getRequestOr(String&& fallback_value) const;
void setRequest(const String& value);
void setRequest(String&& value);

bool hasSelector() const {
  return has_selector_;
}
DigitalCredentialSelector* selector() const {
  DCHECK(hasSelector());
return member_selector_.Get();
}
DigitalCredentialSelector* getSelectorOr(DigitalCredentialSelector* fallback_value) const {
  if (!hasSelector()) {
  return fallback_value;
}
return member_selector_.Get();
}
void setSelector(DigitalCredentialSelector* value) {
  member_selector_ = value;
has_selector_ = true;
DCHECK(member_selector_);
}




void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_params_ = false;
bool has_protocol_ = false;
bool has_public_key_ = false;
bool has_request_ = false;
bool has_selector_ = false;

Vector<std::pair<String, String>> member_params_;
String member_protocol_;
String member_public_key_;
String member_request_;
Member<DigitalCredentialSelector> member_selector_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_DIGITAL_CREDENTIAL_PROVIDER_H_
