// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_digital_credential_selector.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_digital_credential_field_requirement.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_digital_credential_storage_duration.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_union_digitalcredentialfieldrequirement_string.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



DigitalCredentialSelector* DigitalCredentialSelector::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  DigitalCredentialSelector* dictionary = MakeGarbageCollected<DigitalCredentialSelector>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "DigitalCredentialSelector";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 DigitalCredentialSelector::DigitalCredentialSelector() {
  
}

 DigitalCredentialSelector::DigitalCredentialSelector(v8::Isolate* isolate) {
  
}



String DigitalCredentialSelector::getDoctypeOr(const String& fallback_value) const {
  if (!hasDoctype()) {
  return fallback_value;
}
return member_doctype_;
}

String DigitalCredentialSelector::getDoctypeOr(String&& fallback_value) const {
  if (!hasDoctype()) {
  return std::move(fallback_value);
}
return member_doctype_;
}

void DigitalCredentialSelector::setDoctype(const String& value) {
  member_doctype_ = value;
has_doctype_ = true;
}

void DigitalCredentialSelector::setDoctype(String&& value) {
  member_doctype_ = std::move(value);
has_doctype_ = true;
}




HeapVector<Member<V8UnionDigitalCredentialFieldRequirementOrString>> DigitalCredentialSelector::getFieldsOr(const HeapVector<Member<V8UnionDigitalCredentialFieldRequirementOrString>>& fallback_value) const {
  if (!hasFields()) {
  return fallback_value;
}
return member_fields_;
}

HeapVector<Member<V8UnionDigitalCredentialFieldRequirementOrString>> DigitalCredentialSelector::getFieldsOr(HeapVector<Member<V8UnionDigitalCredentialFieldRequirementOrString>>&& fallback_value) const {
  if (!hasFields()) {
  return std::move(fallback_value);
}
return member_fields_;
}

void DigitalCredentialSelector::setFields(const HeapVector<Member<V8UnionDigitalCredentialFieldRequirementOrString>>& value) {
  member_fields_ = value;
has_fields_ = true;
}

void DigitalCredentialSelector::setFields(HeapVector<Member<V8UnionDigitalCredentialFieldRequirementOrString>>&& value) {
  member_fields_ = std::move(value);
has_fields_ = true;
}




Vector<String> DigitalCredentialSelector::getFormatOr(const Vector<String>& fallback_value) const {
  if (!hasFormat()) {
  return fallback_value;
}
return member_format_;
}

Vector<String> DigitalCredentialSelector::getFormatOr(Vector<String>&& fallback_value) const {
  if (!hasFormat()) {
  return std::move(fallback_value);
}
return member_format_;
}

void DigitalCredentialSelector::setFormat(const Vector<String>& value) {
  member_format_ = value;
has_format_ = true;
}

void DigitalCredentialSelector::setFormat(Vector<String>&& value) {
  member_format_ = std::move(value);
has_format_ = true;
}











void DigitalCredentialSelector::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_doctype_);
TraceIfNeeded<HeapVector<Member<V8UnionDigitalCredentialFieldRequirementOrString>>>::Trace(visitor, member_fields_);
TraceIfNeeded<Vector<String>>::Trace(visitor, member_format_);
TraceIfNeeded<Member<DigitalCredentialStorageDuration>>::Trace(visitor, member_retention_);
bindings::DictionaryBase::Trace(visitor);
}

bool DigitalCredentialSelector::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasDoctype()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_doctype_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasFields()) {
  v8_value = ToV8Traits<IDLSequence<V8UnionDigitalCredentialFieldRequirementOrString>>::ToV8(script_state, member_fields_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasFormat()) {
  v8_value = ToV8Traits<IDLSequence<IDLUSVString>>::ToV8(script_state, member_format_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasRetention()) {
  v8_value = ToV8Traits<DigitalCredentialStorageDuration>::ToV8(script_state, member_retention_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
return true;
}

void DigitalCredentialSelector::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "DigitalCredentialSelector";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("doctype");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_doctype_, member_doctype_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("fields");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<V8UnionDigitalCredentialFieldRequirementOrString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_fields_, member_fields_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("format");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUSVString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_format_, member_format_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("retention");
if (!bindings::GetDictionaryMemberFromV8Object<DigitalCredentialStorageDuration, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_retention_, member_retention_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> DigitalCredentialSelector::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"doctype",
"fields",
"format",
"retention",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
