// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_DIGITAL_CREDENTIAL_SELECTOR_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_DIGITAL_CREDENTIAL_SELECTOR_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class DigitalCredentialFieldRequirement;
class DigitalCredentialStorageDuration;
class ExceptionState;
class V8UnionDigitalCredentialFieldRequirementOrString;

class MODULES_EXPORT DigitalCredentialSelector : public bindings::DictionaryBase {
  
  public:
static DigitalCredentialSelector* Create() {
  return MakeGarbageCollected<DigitalCredentialSelector>();
}
static DigitalCredentialSelector* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<DigitalCredentialSelector>(isolate);
}
static DigitalCredentialSelector* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  DigitalCredentialSelector();
explicit  DigitalCredentialSelector(v8::Isolate* isolate);

bool hasDoctype() const {
  return has_doctype_;
}
const String& doctype() const {
  DCHECK(hasDoctype());
return member_doctype_;
}
String getDoctypeOr(const String& fallback_value) const;
String getDoctypeOr(String&& fallback_value) const;
void setDoctype(const String& value);
void setDoctype(String&& value);

bool hasFields() const {
  return has_fields_;
}
const HeapVector<Member<V8UnionDigitalCredentialFieldRequirementOrString>>& fields() const {
  DCHECK(hasFields());
return member_fields_;
}
HeapVector<Member<V8UnionDigitalCredentialFieldRequirementOrString>> getFieldsOr(const HeapVector<Member<V8UnionDigitalCredentialFieldRequirementOrString>>& fallback_value) const;
HeapVector<Member<V8UnionDigitalCredentialFieldRequirementOrString>> getFieldsOr(HeapVector<Member<V8UnionDigitalCredentialFieldRequirementOrString>>&& fallback_value) const;
void setFields(const HeapVector<Member<V8UnionDigitalCredentialFieldRequirementOrString>>& value);
void setFields(HeapVector<Member<V8UnionDigitalCredentialFieldRequirementOrString>>&& value);

bool hasFormat() const {
  return has_format_;
}
const Vector<String>& format() const {
  DCHECK(hasFormat());
return member_format_;
}
Vector<String> getFormatOr(const Vector<String>& fallback_value) const;
Vector<String> getFormatOr(Vector<String>&& fallback_value) const;
void setFormat(const Vector<String>& value);
void setFormat(Vector<String>&& value);

bool hasRetention() const {
  return has_retention_;
}
DigitalCredentialStorageDuration* retention() const {
  DCHECK(hasRetention());
return member_retention_.Get();
}
DigitalCredentialStorageDuration* getRetentionOr(DigitalCredentialStorageDuration* fallback_value) const {
  if (!hasRetention()) {
  return fallback_value;
}
return member_retention_.Get();
}
void setRetention(DigitalCredentialStorageDuration* value) {
  member_retention_ = value;
has_retention_ = true;
DCHECK(member_retention_);
}




void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_doctype_ = false;
bool has_fields_ = false;
bool has_format_ = false;
bool has_retention_ = false;

String member_doctype_;
HeapVector<Member<V8UnionDigitalCredentialFieldRequirementOrString>> member_fields_;
Vector<String> member_format_;
Member<DigitalCredentialStorageDuration> member_retention_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_DIGITAL_CREDENTIAL_SELECTOR_H_
