// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_DIGITAL_CREDENTIAL_STORAGE_DURATION_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_DIGITAL_CREDENTIAL_STORAGE_DURATION_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT DigitalCredentialStorageDuration : public bindings::DictionaryBase {
  
  public:
static DigitalCredentialStorageDuration* Create() {
  return MakeGarbageCollected<DigitalCredentialStorageDuration>();
}
static DigitalCredentialStorageDuration* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<DigitalCredentialStorageDuration>(isolate);
}
static DigitalCredentialStorageDuration* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  DigitalCredentialStorageDuration();
explicit  DigitalCredentialStorageDuration(v8::Isolate* isolate);

bool hasDays() const {
  return has_days_;
}
int32_t days() const {
  DCHECK(hasDays());
return member_days_;
}
int32_t getDaysOr(int32_t fallback_value) const {
  if (!hasDays()) {
  return fallback_value;
}
return member_days_;
}
void setDays(int32_t value) {
  member_days_ = value;
has_days_ = true;
}

bool hasForever() const {
  return has_forever_;
}
bool forever() const {
  DCHECK(hasForever());
return member_forever_;
}
bool getForeverOr(bool fallback_value) const {
  if (!hasForever()) {
  return fallback_value;
}
return member_forever_;
}
void setForever(bool value) {
  member_forever_ = value;
has_forever_ = true;
}




void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_days_ = false;
bool has_forever_ = false;

int32_t member_days_;
bool member_forever_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_DIGITAL_CREDENTIAL_STORAGE_DURATION_H_
