// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ENCODED_AUDIO_CHUNK_METADATA_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ENCODED_AUDIO_CHUNK_METADATA_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class AudioDecoderConfig;
class ExceptionState;

class MODULES_EXPORT EncodedAudioChunkMetadata : public bindings::DictionaryBase {
  
  public:
static EncodedAudioChunkMetadata* Create() {
  return MakeGarbageCollected<EncodedAudioChunkMetadata>();
}
static EncodedAudioChunkMetadata* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<EncodedAudioChunkMetadata>(isolate);
}
static EncodedAudioChunkMetadata* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  EncodedAudioChunkMetadata();
explicit  EncodedAudioChunkMetadata(v8::Isolate* isolate);

bool hasDecoderConfig() const {
  return has_decoder_config_;
}
AudioDecoderConfig* decoderConfig() const {
  DCHECK(hasDecoderConfig());
return member_decoder_config_.Get();
}
AudioDecoderConfig* getDecoderConfigOr(AudioDecoderConfig* fallback_value) const {
  if (!hasDecoderConfig()) {
  return fallback_value;
}
return member_decoder_config_.Get();
}
void setDecoderConfig(AudioDecoderConfig* value) {
  member_decoder_config_ = value;
has_decoder_config_ = true;
DCHECK(member_decoder_config_);
}




void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_decoder_config_ = false;

Member<AudioDecoderConfig> member_decoder_config_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ENCODED_AUDIO_CHUNK_METADATA_H_
