// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_encoded_video_chunk_metadata.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_svc_output_metadata.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_video_decoder_config.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



EncodedVideoChunkMetadata* EncodedVideoChunkMetadata::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  EncodedVideoChunkMetadata* dictionary = MakeGarbageCollected<EncodedVideoChunkMetadata>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "EncodedVideoChunkMetadata";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 EncodedVideoChunkMetadata::EncodedVideoChunkMetadata() {
  
}

 EncodedVideoChunkMetadata::EncodedVideoChunkMetadata(v8::Isolate* isolate) {
  
}

















void EncodedVideoChunkMetadata::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<VideoDecoderConfig>>::Trace(visitor, member_decoder_config_);
TraceIfNeeded<Member<SvcOutputMetadata>>::Trace(visitor, member_svc_);
bindings::DictionaryBase::Trace(visitor);
}

bool EncodedVideoChunkMetadata::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasDecoderConfig()) {
  v8_value = ToV8Traits<VideoDecoderConfig>::ToV8(script_state, member_decoder_config_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasSvc()) {
  v8_value = ToV8Traits<SvcOutputMetadata>::ToV8(script_state, member_svc_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
return true;
}

void EncodedVideoChunkMetadata::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "EncodedVideoChunkMetadata";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("decoderConfig");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<VideoDecoderConfig, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_decoder_config_, member_decoder_config_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("svc");
if (!bindings::GetDictionaryMemberFromV8Object<SvcOutputMetadata, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_svc_, member_svc_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> EncodedVideoChunkMetadata::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"decoderConfig",
"svc",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
