// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_formatted_text_run.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



FormattedTextRun* FormattedTextRun::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  FormattedTextRun* dictionary = MakeGarbageCollected<FormattedTextRun>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "FormattedTextRun";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 FormattedTextRun::FormattedTextRun() {
  
}

 FormattedTextRun::FormattedTextRun(v8::Isolate* isolate) {
  
}



String FormattedTextRun::getStyleOr(const String& fallback_value) const {
  if (!hasStyle()) {
  return fallback_value;
}
return member_style_;
}

String FormattedTextRun::getStyleOr(String&& fallback_value) const {
  if (!hasStyle()) {
  return std::move(fallback_value);
}
return member_style_;
}

void FormattedTextRun::setStyle(const String& value) {
  member_style_ = value;
has_style_ = true;
}

void FormattedTextRun::setStyle(String&& value) {
  member_style_ = std::move(value);
has_style_ = true;
}




String FormattedTextRun::getTextOr(const String& fallback_value) const {
  if (!hasText()) {
  return fallback_value;
}
return member_text_;
}

String FormattedTextRun::getTextOr(String&& fallback_value) const {
  if (!hasText()) {
  return std::move(fallback_value);
}
return member_text_;
}

void FormattedTextRun::setText(const String& value) {
  member_text_ = value;
has_text_ = true;
}

void FormattedTextRun::setText(String&& value) {
  member_text_ = std::move(value);
has_text_ = true;
}




void FormattedTextRun::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_style_);
TraceIfNeeded<String>::Trace(visitor, member_text_);
bindings::DictionaryBase::Trace(visitor);
}

bool FormattedTextRun::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasStyle()) {
  v8_value = ToV8Traits<IDLNullable<IDLString>>::ToV8(script_state, member_style_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasText()) {
  v8_value = ToV8Traits<IDLNullable<IDLString>>::ToV8(script_state, member_text_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
return true;
}

void FormattedTextRun::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "FormattedTextRun";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("style");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_style_, member_style_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("text");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_text_, member_text_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> FormattedTextRun::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"style",
"text",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
