// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_FORMATTED_TEXT_RUN_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_FORMATTED_TEXT_RUN_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT FormattedTextRun : public bindings::DictionaryBase {
  
  public:
static FormattedTextRun* Create() {
  return MakeGarbageCollected<FormattedTextRun>();
}
static FormattedTextRun* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<FormattedTextRun>(isolate);
}
static FormattedTextRun* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  FormattedTextRun();
explicit  FormattedTextRun(v8::Isolate* isolate);

bool hasStyle() const {
  return has_style_;
}
const String& style() const {
  DCHECK(hasStyle());
return member_style_;
}
String getStyleOr(const String& fallback_value) const;
String getStyleOr(String&& fallback_value) const;
void setStyle(const String& value);
void setStyle(String&& value);

bool hasText() const {
  return has_text_;
}
const String& text() const {
  DCHECK(hasText());
return member_text_;
}
String getTextOr(const String& fallback_value) const;
String getTextOr(String&& fallback_value) const;
void setText(const String& value);
void setText(String&& value);




void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_style_ = false;
bool has_text_ = false;

String member_style_;
String member_text_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_FORMATTED_TEXT_RUN_H_
