// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_bind_group_layout_entry.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_buffer_binding_layout.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_external_texture_binding_layout.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_sampler_binding_layout.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_storage_texture_binding_layout.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_texture_binding_layout.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



GPUBindGroupLayoutEntry* GPUBindGroupLayoutEntry::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  GPUBindGroupLayoutEntry* dictionary = MakeGarbageCollected<GPUBindGroupLayoutEntry>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "GPUBindGroupLayoutEntry";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 GPUBindGroupLayoutEntry::GPUBindGroupLayoutEntry() {
  
}

 GPUBindGroupLayoutEntry::GPUBindGroupLayoutEntry(v8::Isolate* isolate) {
  
}
















































void GPUBindGroupLayoutEntry::Trace(Visitor* visitor) const {
  TraceIfNeeded<uint32_t>::Trace(visitor, member_binding_);
TraceIfNeeded<Member<GPUBufferBindingLayout>>::Trace(visitor, member_buffer_);
TraceIfNeeded<Member<GPUExternalTextureBindingLayout>>::Trace(visitor, member_external_texture_);
TraceIfNeeded<Member<GPUSamplerBindingLayout>>::Trace(visitor, member_sampler_);
TraceIfNeeded<Member<GPUStorageTextureBindingLayout>>::Trace(visitor, member_storage_texture_);
TraceIfNeeded<Member<GPUTextureBindingLayout>>::Trace(visitor, member_texture_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_visibility_);
bindings::DictionaryBase::Trace(visitor);
}

bool GPUBindGroupLayoutEntry::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasBinding()) {
  v8_value = ToV8Traits<IDLUnsignedLongEnforceRange>::ToV8(script_state, member_binding_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasBuffer()) {
  v8_value = ToV8Traits<GPUBufferBindingLayout>::ToV8(script_state, member_buffer_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasExternalTexture()) {
  v8_value = ToV8Traits<GPUExternalTextureBindingLayout>::ToV8(script_state, member_external_texture_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasSampler()) {
  v8_value = ToV8Traits<GPUSamplerBindingLayout>::ToV8(script_state, member_sampler_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasStorageTexture()) {
  v8_value = ToV8Traits<GPUStorageTextureBindingLayout>::ToV8(script_state, member_storage_texture_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasTexture()) {
  v8_value = ToV8Traits<GPUTextureBindingLayout>::ToV8(script_state, member_texture_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
if (hasVisibility()) {
  v8_value = ToV8Traits<IDLUnsignedLongEnforceRange>::ToV8(script_state, member_visibility_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[6].Get(isolate), v8_value).ToChecked();
}
return true;
}

void GPUBindGroupLayoutEntry::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "GPUBindGroupLayoutEntry";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("binding");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongEnforceRange, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_binding_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("buffer");
constexpr bool is_optional = false;
if (!bindings::GetDictionaryMemberFromV8Object<GPUBufferBindingLayout, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_buffer_, member_buffer_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("externalTexture");
if (!bindings::GetDictionaryMemberFromV8Object<GPUExternalTextureBindingLayout, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_external_texture_, member_external_texture_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sampler");
if (!bindings::GetDictionaryMemberFromV8Object<GPUSamplerBindingLayout, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_sampler_, member_sampler_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("storageTexture");
if (!bindings::GetDictionaryMemberFromV8Object<GPUStorageTextureBindingLayout, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_storage_texture_, member_storage_texture_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("texture");
if (!bindings::GetDictionaryMemberFromV8Object<GPUTextureBindingLayout, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_texture_, member_texture_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("visibility");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongEnforceRange, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), fallback_presence_var, member_visibility_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> GPUBindGroupLayoutEntry::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"binding",
"buffer",
"externalTexture",
"sampler",
"storageTexture",
"texture",
"visibility",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
