// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_render_pass_depth_stencil_attachment.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/modules/webgpu/gpu_texture_view.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



GPURenderPassDepthStencilAttachment* GPURenderPassDepthStencilAttachment::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  GPURenderPassDepthStencilAttachment* dictionary = MakeGarbageCollected<GPURenderPassDepthStencilAttachment>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "GPURenderPassDepthStencilAttachment";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 GPURenderPassDepthStencilAttachment::GPURenderPassDepthStencilAttachment() {
  
}

 GPURenderPassDepthStencilAttachment::GPURenderPassDepthStencilAttachment(v8::Isolate* isolate) {
  
}


























































void GPURenderPassDepthStencilAttachment::Trace(Visitor* visitor) const {
  TraceIfNeeded<float>::Trace(visitor, member_depth_clear_value_);
TraceIfNeeded<V8GPULoadOp>::Trace(visitor, member_depth_load_op_);
TraceIfNeeded<bool>::Trace(visitor, member_depth_read_only_);
TraceIfNeeded<V8GPUStoreOp>::Trace(visitor, member_depth_store_op_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_stencil_clear_value_);
TraceIfNeeded<V8GPULoadOp>::Trace(visitor, member_stencil_load_op_);
TraceIfNeeded<bool>::Trace(visitor, member_stencil_read_only_);
TraceIfNeeded<V8GPUStoreOp>::Trace(visitor, member_stencil_store_op_);
TraceIfNeeded<Member<GPUTextureView>>::Trace(visitor, member_view_);
bindings::DictionaryBase::Trace(visitor);
}

bool GPURenderPassDepthStencilAttachment::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasDepthClearValue()) {
  v8_value = ToV8Traits<IDLFloat>::ToV8(script_state, member_depth_clear_value_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasDepthLoadOp()) {
  v8_value = ToV8Traits<V8GPULoadOp>::ToV8(script_state, member_depth_load_op_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasDepthReadOnly()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_depth_read_only_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasDepthStoreOp()) {
  v8_value = ToV8Traits<V8GPUStoreOp>::ToV8(script_state, member_depth_store_op_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasStencilClearValue()) {
  v8_value = ToV8Traits<IDLUnsignedLongEnforceRange>::ToV8(script_state, member_stencil_clear_value_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasStencilLoadOp()) {
  v8_value = ToV8Traits<V8GPULoadOp>::ToV8(script_state, member_stencil_load_op_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
if (hasStencilReadOnly()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_stencil_read_only_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[6].Get(isolate), v8_value).ToChecked();
}
if (hasStencilStoreOp()) {
  v8_value = ToV8Traits<V8GPUStoreOp>::ToV8(script_state, member_stencil_store_op_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[7].Get(isolate), v8_value).ToChecked();
}
if (hasView()) {
  v8_value = ToV8Traits<GPUTextureView>::ToV8(script_state, member_view_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[8].Get(isolate), v8_value).ToChecked();
}
return true;
}

void GPURenderPassDepthStencilAttachment::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "GPURenderPassDepthStencilAttachment";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("depthClearValue");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_depth_clear_value_, member_depth_clear_value_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("depthLoadOp");
if (!bindings::GetDictionaryMemberFromV8Object<V8GPULoadOp, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_depth_load_op_, member_depth_load_op_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("depthReadOnly");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_depth_read_only_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("depthStoreOp");
if (!bindings::GetDictionaryMemberFromV8Object<V8GPUStoreOp, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_depth_store_op_, member_depth_store_op_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("stencilClearValue");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongEnforceRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_stencil_clear_value_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("stencilLoadOp");
if (!bindings::GetDictionaryMemberFromV8Object<V8GPULoadOp, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_stencil_load_op_, member_stencil_load_op_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("stencilReadOnly");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), fallback_presence_var, member_stencil_read_only_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("stencilStoreOp");
if (!bindings::GetDictionaryMemberFromV8Object<V8GPUStoreOp, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), has_stencil_store_op_, member_stencil_store_op_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("view");
constexpr bool is_required = true;
if (!bindings::GetDictionaryMemberFromV8Object<GPUTextureView, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), fallback_presence_var, member_view_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> GPURenderPassDepthStencilAttachment::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"depthClearValue",
"depthLoadOp",
"depthReadOnly",
"depthStoreOp",
"stencilClearValue",
"stencilLoadOp",
"stencilReadOnly",
"stencilStoreOp",
"view",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
