// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_shader_module_descriptor.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_union_usvstring_uint32array.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_shader_module_compilation_hint.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



GPUShaderModuleDescriptor* GPUShaderModuleDescriptor::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  GPUShaderModuleDescriptor* dictionary = MakeGarbageCollected<GPUShaderModuleDescriptor>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "GPUShaderModuleDescriptor";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 GPUShaderModuleDescriptor::GPUShaderModuleDescriptor() {
  
}

 GPUShaderModuleDescriptor::GPUShaderModuleDescriptor(v8::Isolate* isolate) : GPUObjectDescriptorBase(isolate) {
  
}








HeapVector<std::pair<String, Member<GPUShaderModuleCompilationHint>>> GPUShaderModuleDescriptor::getHintsOr(const HeapVector<std::pair<String, Member<GPUShaderModuleCompilationHint>>>& fallback_value) const {
  if (!hasHints()) {
  return fallback_value;
}
return member_hints_;
}

HeapVector<std::pair<String, Member<GPUShaderModuleCompilationHint>>> GPUShaderModuleDescriptor::getHintsOr(HeapVector<std::pair<String, Member<GPUShaderModuleCompilationHint>>>&& fallback_value) const {
  if (!hasHints()) {
  return std::move(fallback_value);
}
return member_hints_;
}

void GPUShaderModuleDescriptor::setHints(const HeapVector<std::pair<String, Member<GPUShaderModuleCompilationHint>>>& value) {
  member_hints_ = value;
has_hints_ = true;
}

void GPUShaderModuleDescriptor::setHints(HeapVector<std::pair<String, Member<GPUShaderModuleCompilationHint>>>&& value) {
  member_hints_ = std::move(value);
has_hints_ = true;
}











void GPUShaderModuleDescriptor::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<V8UnionUSVStringOrUint32Array>>::Trace(visitor, member_code_);
TraceIfNeeded<HeapVector<std::pair<String, Member<GPUShaderModuleCompilationHint>>>>::Trace(visitor, member_hints_);
TraceIfNeeded<ScriptValue>::Trace(visitor, member_source_map_);
GPUObjectDescriptorBase::Trace(visitor);
}

bool GPUShaderModuleDescriptor::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!GPUObjectDescriptorBase::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasCode()) {
  v8_value = ToV8Traits<V8UnionUSVStringOrUint32Array>::ToV8(script_state, member_code_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasHints()) {
  v8_value = ToV8Traits<IDLRecord<IDLUSVString, GPUShaderModuleCompilationHint>>::ToV8(script_state, member_hints_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasSourceMap()) {
  v8_value = ToV8Traits<IDLObject>::ToV8(script_state, member_source_map_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
return true;
}

void GPUShaderModuleDescriptor::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  GPUObjectDescriptorBase::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "GPUShaderModuleDescriptor";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("code");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<V8UnionUSVStringOrUint32Array, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_code_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("hints");
constexpr bool is_optional = false;
if (!bindings::GetDictionaryMemberFromV8Object<IDLRecord<IDLUSVString, GPUShaderModuleCompilationHint>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_hints_, member_hints_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sourceMap");
if (!bindings::GetDictionaryMemberFromV8Object<IDLObject, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_source_map_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> GPUShaderModuleDescriptor::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"code",
"hints",
"sourceMap",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
