// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_handwriting_hints_query_result.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



HandwritingHintsQueryResult* HandwritingHintsQueryResult::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  HandwritingHintsQueryResult* dictionary = MakeGarbageCollected<HandwritingHintsQueryResult>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "HandwritingHintsQueryResult";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 HandwritingHintsQueryResult::HandwritingHintsQueryResult() {
  
}

 HandwritingHintsQueryResult::HandwritingHintsQueryResult(v8::Isolate* isolate) {
  
}










Vector<V8HandwritingInputType> HandwritingHintsQueryResult::getInputTypeOr(const Vector<V8HandwritingInputType>& fallback_value) const {
  if (!hasInputType()) {
  return fallback_value;
}
return member_input_type_;
}

Vector<V8HandwritingInputType> HandwritingHintsQueryResult::getInputTypeOr(Vector<V8HandwritingInputType>&& fallback_value) const {
  if (!hasInputType()) {
  return std::move(fallback_value);
}
return member_input_type_;
}

void HandwritingHintsQueryResult::setInputType(const Vector<V8HandwritingInputType>& value) {
  member_input_type_ = value;
has_input_type_ = true;
}

void HandwritingHintsQueryResult::setInputType(Vector<V8HandwritingInputType>&& value) {
  member_input_type_ = std::move(value);
has_input_type_ = true;
}




Vector<V8HandwritingRecognitionType> HandwritingHintsQueryResult::getRecognitionTypeOr(const Vector<V8HandwritingRecognitionType>& fallback_value) const {
  if (!hasRecognitionType()) {
  return fallback_value;
}
return member_recognition_type_;
}

Vector<V8HandwritingRecognitionType> HandwritingHintsQueryResult::getRecognitionTypeOr(Vector<V8HandwritingRecognitionType>&& fallback_value) const {
  if (!hasRecognitionType()) {
  return std::move(fallback_value);
}
return member_recognition_type_;
}

void HandwritingHintsQueryResult::setRecognitionType(const Vector<V8HandwritingRecognitionType>& value) {
  member_recognition_type_ = value;
has_recognition_type_ = true;
}

void HandwritingHintsQueryResult::setRecognitionType(Vector<V8HandwritingRecognitionType>&& value) {
  member_recognition_type_ = std::move(value);
has_recognition_type_ = true;
}











void HandwritingHintsQueryResult::Trace(Visitor* visitor) const {
  TraceIfNeeded<bool>::Trace(visitor, member_alternatives_);
TraceIfNeeded<Vector<V8HandwritingInputType>>::Trace(visitor, member_input_type_);
TraceIfNeeded<Vector<V8HandwritingRecognitionType>>::Trace(visitor, member_recognition_type_);
TraceIfNeeded<bool>::Trace(visitor, member_text_context_);
bindings::DictionaryBase::Trace(visitor);
}

bool HandwritingHintsQueryResult::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAlternatives()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_alternatives_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasInputType()) {
  v8_value = ToV8Traits<IDLSequence<V8HandwritingInputType>>::ToV8(script_state, member_input_type_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasRecognitionType()) {
  v8_value = ToV8Traits<IDLSequence<V8HandwritingRecognitionType>>::ToV8(script_state, member_recognition_type_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasTextContext()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_text_context_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
return true;
}

void HandwritingHintsQueryResult::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "HandwritingHintsQueryResult";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("alternatives");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_alternatives_, member_alternatives_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("inputType");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<V8HandwritingInputType>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_input_type_, member_input_type_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("recognitionType");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<V8HandwritingRecognitionType>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_recognition_type_, member_recognition_type_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("textContext");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_text_context_, member_text_context_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> HandwritingHintsQueryResult::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"alternatives",
"inputType",
"recognitionType",
"textContext",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
