// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_handwriting_prediction.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_handwriting_segment.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



HandwritingPrediction* HandwritingPrediction::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  HandwritingPrediction* dictionary = MakeGarbageCollected<HandwritingPrediction>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "HandwritingPrediction";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 HandwritingPrediction::HandwritingPrediction() {
  
}

 HandwritingPrediction::HandwritingPrediction(v8::Isolate* isolate) {
  
}



HeapVector<Member<HandwritingSegment>> HandwritingPrediction::getSegmentationResultOr(const HeapVector<Member<HandwritingSegment>>& fallback_value) const {
  if (!hasSegmentationResult()) {
  return fallback_value;
}
return member_segmentation_result_;
}

HeapVector<Member<HandwritingSegment>> HandwritingPrediction::getSegmentationResultOr(HeapVector<Member<HandwritingSegment>>&& fallback_value) const {
  if (!hasSegmentationResult()) {
  return std::move(fallback_value);
}
return member_segmentation_result_;
}

void HandwritingPrediction::setSegmentationResult(const HeapVector<Member<HandwritingSegment>>& value) {
  member_segmentation_result_ = value;
has_segmentation_result_ = true;
}

void HandwritingPrediction::setSegmentationResult(HeapVector<Member<HandwritingSegment>>&& value) {
  member_segmentation_result_ = std::move(value);
has_segmentation_result_ = true;
}




void HandwritingPrediction::setText(const String& value) {
  member_text_ = value;
}

void HandwritingPrediction::setText(String&& value) {
  member_text_ = std::move(value);
}




void HandwritingPrediction::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<Member<HandwritingSegment>>>::Trace(visitor, member_segmentation_result_);
TraceIfNeeded<String>::Trace(visitor, member_text_);
bindings::DictionaryBase::Trace(visitor);
}

bool HandwritingPrediction::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasSegmentationResult()) {
  v8_value = ToV8Traits<IDLSequence<HandwritingSegment>>::ToV8(script_state, member_segmentation_result_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasText()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_text_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
return true;
}

void HandwritingPrediction::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "HandwritingPrediction";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("segmentationResult");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<HandwritingSegment>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_segmentation_result_, member_segmentation_result_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("text");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_text_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> HandwritingPrediction::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"segmentationResult",
"text",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
