// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_handwriting_segment.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_handwriting_drawing_segment.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



HandwritingSegment* HandwritingSegment::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  HandwritingSegment* dictionary = MakeGarbageCollected<HandwritingSegment>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "HandwritingSegment";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 HandwritingSegment::HandwritingSegment() {
  
}

 HandwritingSegment::HandwritingSegment(v8::Isolate* isolate) {
  
}








void HandwritingSegment::setDrawingSegments(const HeapVector<Member<HandwritingDrawingSegment>>& value) {
  member_drawing_segments_ = value;
}

void HandwritingSegment::setDrawingSegments(HeapVector<Member<HandwritingDrawingSegment>>&& value) {
  member_drawing_segments_ = std::move(value);
}









void HandwritingSegment::setGrapheme(const String& value) {
  member_grapheme_ = value;
}

void HandwritingSegment::setGrapheme(String&& value) {
  member_grapheme_ = std::move(value);
}




void HandwritingSegment::Trace(Visitor* visitor) const {
  TraceIfNeeded<uint32_t>::Trace(visitor, member_begin_index_);
TraceIfNeeded<HeapVector<Member<HandwritingDrawingSegment>>>::Trace(visitor, member_drawing_segments_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_end_index_);
TraceIfNeeded<String>::Trace(visitor, member_grapheme_);
bindings::DictionaryBase::Trace(visitor);
}

bool HandwritingSegment::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasBeginIndex()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_begin_index_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasDrawingSegments()) {
  v8_value = ToV8Traits<IDLSequence<HandwritingDrawingSegment>>::ToV8(script_state, member_drawing_segments_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasEndIndex()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_end_index_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasGrapheme()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_grapheme_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
return true;
}

void HandwritingSegment::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "HandwritingSegment";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("beginIndex");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_begin_index_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("drawingSegments");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<HandwritingDrawingSegment>, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_drawing_segments_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("endIndex");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_end_index_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("grapheme");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_grapheme_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> HandwritingSegment::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"beginIndex",
"drawingSegments",
"endIndex",
"grapheme",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
