// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_hid_report_info.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_hid_report_item.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



HIDReportInfo* HIDReportInfo::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  HIDReportInfo* dictionary = MakeGarbageCollected<HIDReportInfo>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "HIDReportInfo";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 HIDReportInfo::HIDReportInfo() {
  
}

 HIDReportInfo::HIDReportInfo(v8::Isolate* isolate) {
  
}



HeapVector<Member<HIDReportItem>> HIDReportInfo::getItemsOr(const HeapVector<Member<HIDReportItem>>& fallback_value) const {
  if (!hasItems()) {
  return fallback_value;
}
return member_items_;
}

HeapVector<Member<HIDReportItem>> HIDReportInfo::getItemsOr(HeapVector<Member<HIDReportItem>>&& fallback_value) const {
  if (!hasItems()) {
  return std::move(fallback_value);
}
return member_items_;
}

void HIDReportInfo::setItems(const HeapVector<Member<HIDReportItem>>& value) {
  member_items_ = value;
has_items_ = true;
}

void HIDReportInfo::setItems(HeapVector<Member<HIDReportItem>>&& value) {
  member_items_ = std::move(value);
has_items_ = true;
}











void HIDReportInfo::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<Member<HIDReportItem>>>::Trace(visitor, member_items_);
TraceIfNeeded<uint8_t>::Trace(visitor, member_report_id_);
bindings::DictionaryBase::Trace(visitor);
}

bool HIDReportInfo::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasItems()) {
  v8_value = ToV8Traits<IDLSequence<HIDReportItem>>::ToV8(script_state, member_items_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasReportId()) {
  v8_value = ToV8Traits<IDLOctet>::ToV8(script_state, member_report_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
return true;
}

void HIDReportInfo::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "HIDReportInfo";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("items");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<HIDReportItem>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_items_, member_items_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("reportId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLOctet, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_report_id_, member_report_id_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> HIDReportInfo::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"items",
"reportId",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
