// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_identity_provider_config.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_digital_credential_provider.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



IdentityProviderConfig* IdentityProviderConfig::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  IdentityProviderConfig* dictionary = MakeGarbageCollected<IdentityProviderConfig>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "IdentityProviderConfig";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 IdentityProviderConfig::IdentityProviderConfig() {
  
}

 IdentityProviderConfig::IdentityProviderConfig(v8::Isolate* isolate) {
  
}



String IdentityProviderConfig::getClientIdOr(const String& fallback_value) const {
  if (!hasClientId()) {
  return fallback_value;
}
return member_client_id_;
}

String IdentityProviderConfig::getClientIdOr(String&& fallback_value) const {
  if (!hasClientId()) {
  return std::move(fallback_value);
}
return member_client_id_;
}

void IdentityProviderConfig::setClientId(const String& value) {
  member_client_id_ = value;
has_client_id_ = true;
}

void IdentityProviderConfig::setClientId(String&& value) {
  member_client_id_ = std::move(value);
has_client_id_ = true;
}




String IdentityProviderConfig::getConfigURLOr(const String& fallback_value) const {
  if (!hasConfigURL()) {
  return fallback_value;
}
return member_config_url_;
}

String IdentityProviderConfig::getConfigURLOr(String&& fallback_value) const {
  if (!hasConfigURL()) {
  return std::move(fallback_value);
}
return member_config_url_;
}

void IdentityProviderConfig::setConfigURL(const String& value) {
  member_config_url_ = value;
has_config_url_ = true;
}

void IdentityProviderConfig::setConfigURL(String&& value) {
  member_config_url_ = std::move(value);
has_config_url_ = true;
}











void IdentityProviderConfig::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_client_id_);
TraceIfNeeded<String>::Trace(visitor, member_config_url_);
TraceIfNeeded<Member<DigitalCredentialProvider>>::Trace(visitor, member_holder_);
bindings::DictionaryBase::Trace(visitor);
}

bool IdentityProviderConfig::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasClientId()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_client_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasConfigURL()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_config_url_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (RuntimeEnabledFeatures::WebIdentityDigitalCredentialsEnabled()) {
  if (hasHolder()) {
  v8_value = ToV8Traits<DigitalCredentialProvider>::ToV8(script_state, member_holder_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
}
return true;
}

void IdentityProviderConfig::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "IdentityProviderConfig";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("clientId");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_client_id_, member_client_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("configURL");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_config_url_, member_config_url_, try_block, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::WebIdentityDigitalCredentialsEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("holder");
if (!bindings::GetDictionaryMemberFromV8Object<DigitalCredentialProvider, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_holder_, member_holder_, try_block, exception_state)) {
  return;
}
}
}

const base::span<const v8::Eternal<v8::Name>> IdentityProviderConfig::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"clientId",
"configURL",
"holder",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
