// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_IDENTITY_PROVIDER_REQUEST_OPTIONS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_IDENTITY_PROVIDER_REQUEST_OPTIONS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_identity_provider_config.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT IdentityProviderRequestOptions : public IdentityProviderConfig {
  
  public:
static IdentityProviderRequestOptions* Create() {
  return MakeGarbageCollected<IdentityProviderRequestOptions>();
}
static IdentityProviderRequestOptions* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<IdentityProviderRequestOptions>(isolate);
}
static IdentityProviderRequestOptions* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  IdentityProviderRequestOptions();
explicit  IdentityProviderRequestOptions(v8::Isolate* isolate);

bool hasDomainHint() const {
  return has_domain_hint_;
}
const String& domainHint() const {
  DCHECK(hasDomainHint());
return member_domain_hint_;
}
String getDomainHintOr(const String& fallback_value) const;
String getDomainHintOr(String&& fallback_value) const;
void setDomainHint(const String& value);
void setDomainHint(String&& value);

bool hasLoginHint() const {
  return has_login_hint_;
}
const String& loginHint() const {
  DCHECK(hasLoginHint());
return member_login_hint_;
}
String getLoginHintOr(const String& fallback_value) const;
String getLoginHintOr(String&& fallback_value) const;
void setLoginHint(const String& value);
void setLoginHint(String&& value);

bool hasNonce() const {
  return has_nonce_;
}
const String& nonce() const {
  DCHECK(hasNonce());
return member_nonce_;
}
String getNonceOr(const String& fallback_value) const;
String getNonceOr(String&& fallback_value) const;
void setNonce(const String& value);
void setNonce(String&& value);

bool hasParams() const {
  return has_params_;
}
const Vector<std::pair<String, String>>& params() const {
  DCHECK(hasParams());
return member_params_;
}
Vector<std::pair<String, String>> getParamsOr(const Vector<std::pair<String, String>>& fallback_value) const;
Vector<std::pair<String, String>> getParamsOr(Vector<std::pair<String, String>>&& fallback_value) const;
void setParams(const Vector<std::pair<String, String>>& value);
void setParams(Vector<std::pair<String, String>>&& value);

bool hasResponseType() const {
  return has_response_type_;
}
const Vector<String>& responseType() const {
  DCHECK(hasResponseType());
return member_response_type_;
}
Vector<String> getResponseTypeOr(const Vector<String>& fallback_value) const;
Vector<String> getResponseTypeOr(Vector<String>&& fallback_value) const;
void setResponseType(const Vector<String>& value);
void setResponseType(Vector<String>&& value);

bool hasScope() const {
  return has_scope_;
}
const Vector<String>& scope() const {
  DCHECK(hasScope());
return member_scope_;
}
Vector<String> getScopeOr(const Vector<String>& fallback_value) const;
Vector<String> getScopeOr(Vector<String>&& fallback_value) const;
void setScope(const Vector<String>& value);
void setScope(Vector<String>&& value);




void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_domain_hint_ = false;
bool has_login_hint_ = false;
bool has_nonce_ = false;
bool has_params_ = false;
bool has_response_type_ = false;
bool has_scope_ = false;

String member_domain_hint_;
String member_login_hint_;
String member_nonce_;
Vector<std::pair<String, String>> member_params_;
Vector<String> member_response_type_;
Vector<String> member_scope_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_IDENTITY_PROVIDER_REQUEST_OPTIONS_H_
