// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_IDENTITY_STANDARD_CLAIMS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_IDENTITY_STANDARD_CLAIMS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class ExceptionState;
class IdentityClaimRequirement;

class MODULES_EXPORT IdentityStandardClaims : public bindings::DictionaryBase {
  
  public:
static IdentityStandardClaims* Create() {
  return MakeGarbageCollected<IdentityStandardClaims>();
}
static IdentityStandardClaims* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<IdentityStandardClaims>(isolate);
}
static IdentityStandardClaims* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  IdentityStandardClaims();
explicit  IdentityStandardClaims(v8::Isolate* isolate);

bool hasEmail() const {
  return has_email_;
}
IdentityClaimRequirement* email() const {
  DCHECK(hasEmail());
return member_email_.Get();
}
IdentityClaimRequirement* getEmailOr(IdentityClaimRequirement* fallback_value) const {
  if (!hasEmail()) {
  return fallback_value;
}
return member_email_.Get();
}
void setEmail(IdentityClaimRequirement* value) {
  member_email_ = value;
has_email_ = true;
DCHECK(member_email_);
}

bool hasGivenName() const {
  return has_given_name_;
}
IdentityClaimRequirement* givenName() const {
  DCHECK(hasGivenName());
return member_given_name_.Get();
}
IdentityClaimRequirement* getGivenNameOr(IdentityClaimRequirement* fallback_value) const {
  if (!hasGivenName()) {
  return fallback_value;
}
return member_given_name_.Get();
}
void setGivenName(IdentityClaimRequirement* value) {
  member_given_name_ = value;
has_given_name_ = true;
DCHECK(member_given_name_);
}

bool hasName() const {
  return has_name_;
}
IdentityClaimRequirement* name() const {
  DCHECK(hasName());
return member_name_.Get();
}
IdentityClaimRequirement* getNameOr(IdentityClaimRequirement* fallback_value) const {
  if (!hasName()) {
  return fallback_value;
}
return member_name_.Get();
}
void setName(IdentityClaimRequirement* value) {
  member_name_ = value;
has_name_ = true;
DCHECK(member_name_);
}

bool hasPicture() const {
  return has_picture_;
}
IdentityClaimRequirement* picture() const {
  DCHECK(hasPicture());
return member_picture_.Get();
}
IdentityClaimRequirement* getPictureOr(IdentityClaimRequirement* fallback_value) const {
  if (!hasPicture()) {
  return fallback_value;
}
return member_picture_.Get();
}
void setPicture(IdentityClaimRequirement* value) {
  member_picture_ = value;
has_picture_ = true;
DCHECK(member_picture_);
}




void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_email_ = false;
bool has_given_name_ = false;
bool has_name_ = false;
bool has_picture_ = false;

Member<IdentityClaimRequirement> member_email_;
Member<IdentityClaimRequirement> member_given_name_;
Member<IdentityClaimRequirement> member_name_;
Member<IdentityClaimRequirement> member_picture_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_IDENTITY_STANDARD_CLAIMS_H_
