// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_MEDIA_KEY_SYSTEM_MEDIA_CAPABILITY_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_MEDIA_KEY_SYSTEM_MEDIA_CAPABILITY_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT MediaKeySystemMediaCapability : public bindings::DictionaryBase {
  
  public:
static MediaKeySystemMediaCapability* Create() {
  return MakeGarbageCollected<MediaKeySystemMediaCapability>();
}
static MediaKeySystemMediaCapability* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<MediaKeySystemMediaCapability>(isolate);
}
static MediaKeySystemMediaCapability* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  MediaKeySystemMediaCapability();
explicit  MediaKeySystemMediaCapability(v8::Isolate* isolate);

bool hasContentType() const {
  return true;
}
const String& contentType() const {
  return member_content_type_;
}
void setContentType(const String& value);
void setContentType(String&& value);

bool hasEncryptionScheme() const {
  return true;
}
const String& encryptionScheme() const {
  return member_encryption_scheme_;
}
void setEncryptionScheme(const String& value);
void setEncryptionScheme(String&& value);

bool hasRobustness() const {
  return true;
}
const String& robustness() const {
  return member_robustness_;
}
void setRobustness(const String& value);
void setRobustness(String&& value);




void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);



String member_content_type_{""};
String member_encryption_scheme_;
String member_robustness_{""};


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_MEDIA_KEY_SYSTEM_MEDIA_CAPABILITY_H_
