// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_media_stream_track_generator_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/modules/mediastream/media_stream_track.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



MediaStreamTrackGeneratorInit* MediaStreamTrackGeneratorInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  MediaStreamTrackGeneratorInit* dictionary = MakeGarbageCollected<MediaStreamTrackGeneratorInit>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "MediaStreamTrackGeneratorInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 MediaStreamTrackGeneratorInit::MediaStreamTrackGeneratorInit() {
  
}

 MediaStreamTrackGeneratorInit::MediaStreamTrackGeneratorInit(v8::Isolate* isolate) {
  
}



void MediaStreamTrackGeneratorInit::setKind(const String& value) {
  member_kind_ = value;
}

void MediaStreamTrackGeneratorInit::setKind(String&& value) {
  member_kind_ = std::move(value);
}


















void MediaStreamTrackGeneratorInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_kind_);
TraceIfNeeded<uint16_t>::Trace(visitor, member_max_signal_buffer_size_);
TraceIfNeeded<Member<MediaStreamTrack>>::Trace(visitor, member_signal_target_);
bindings::DictionaryBase::Trace(visitor);
}

bool MediaStreamTrackGeneratorInit::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasKind()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_kind_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasMaxSignalBufferSize()) {
  v8_value = ToV8Traits<IDLUnsignedShortEnforceRange>::ToV8(script_state, member_max_signal_buffer_size_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasSignalTarget()) {
  v8_value = ToV8Traits<MediaStreamTrack>::ToV8(script_state, member_signal_target_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
return true;
}

void MediaStreamTrackGeneratorInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "MediaStreamTrackGeneratorInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("kind");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_kind_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("maxSignalBufferSize");
constexpr bool is_optional = false;
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedShortEnforceRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_max_signal_buffer_size_, member_max_signal_buffer_size_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("signalTarget");
if (!bindings::GetDictionaryMemberFromV8Object<MediaStreamTrack, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_signal_target_, member_signal_target_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> MediaStreamTrackGeneratorInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"kind",
"maxSignalBufferSize",
"signalTarget",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
