// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_media_track_constraints.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_media_track_constraint_set.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



MediaTrackConstraints* MediaTrackConstraints::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  MediaTrackConstraints* dictionary = MakeGarbageCollected<MediaTrackConstraints>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "MediaTrackConstraints";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 MediaTrackConstraints::MediaTrackConstraints() {
  
}

 MediaTrackConstraints::MediaTrackConstraints(v8::Isolate* isolate) : MediaTrackConstraintSet(isolate) {
  
}



HeapVector<Member<MediaTrackConstraintSet>> MediaTrackConstraints::getAdvancedOr(const HeapVector<Member<MediaTrackConstraintSet>>& fallback_value) const {
  if (!hasAdvanced()) {
  return fallback_value;
}
return member_advanced_;
}

HeapVector<Member<MediaTrackConstraintSet>> MediaTrackConstraints::getAdvancedOr(HeapVector<Member<MediaTrackConstraintSet>>&& fallback_value) const {
  if (!hasAdvanced()) {
  return std::move(fallback_value);
}
return member_advanced_;
}

void MediaTrackConstraints::setAdvanced(const HeapVector<Member<MediaTrackConstraintSet>>& value) {
  member_advanced_ = value;
has_advanced_ = true;
}

void MediaTrackConstraints::setAdvanced(HeapVector<Member<MediaTrackConstraintSet>>&& value) {
  member_advanced_ = std::move(value);
has_advanced_ = true;
}




void MediaTrackConstraints::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<Member<MediaTrackConstraintSet>>>::Trace(visitor, member_advanced_);
MediaTrackConstraintSet::Trace(visitor);
}

bool MediaTrackConstraints::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!MediaTrackConstraintSet::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

if (hasAdvanced()) {
  v8::Local<v8::Value> v8_value;
v8_value = ToV8Traits<IDLSequence<MediaTrackConstraintSet>>::ToV8(script_state, member_advanced_);
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
return true;
}

void MediaTrackConstraints::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  MediaTrackConstraintSet::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "MediaTrackConstraints";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("advanced");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<MediaTrackConstraintSet>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_advanced_, member_advanced_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> MediaTrackConstraints::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"advanced",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
