// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ML_ARG_MIN_MAX_OPTIONS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ML_ARG_MIN_MAX_OPTIONS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT MLArgMinMaxOptions : public bindings::DictionaryBase {
  
  public:
static MLArgMinMaxOptions* Create() {
  return MakeGarbageCollected<MLArgMinMaxOptions>();
}
static MLArgMinMaxOptions* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<MLArgMinMaxOptions>(isolate);
}
static MLArgMinMaxOptions* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  MLArgMinMaxOptions();
explicit  MLArgMinMaxOptions(v8::Isolate* isolate);

bool hasAxes() const {
  return has_axes_;
}
const Vector<uint32_t>& axes() const {
  DCHECK(hasAxes());
return member_axes_;
}
Vector<uint32_t> getAxesOr(const Vector<uint32_t>& fallback_value) const;
Vector<uint32_t> getAxesOr(Vector<uint32_t>&& fallback_value) const;
void setAxes(const Vector<uint32_t>& value);
void setAxes(Vector<uint32_t>&& value);

bool hasKeepDimensions() const {
  return true;
}
bool keepDimensions() const {
  return member_keep_dimensions_;
}
void setKeepDimensions(bool value) {
  member_keep_dimensions_ = value;
}

bool hasSelectLastIndex() const {
  return true;
}
bool selectLastIndex() const {
  return member_select_last_index_;
}
void setSelectLastIndex(bool value) {
  member_select_last_index_ = value;
}




void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_axes_ = false;

Vector<uint32_t> member_axes_;
bool member_keep_dimensions_{false};
bool member_select_last_index_{false};


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ML_ARG_MIN_MAX_OPTIONS_H_
