// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_ml_compute_result.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



MLComputeResult* MLComputeResult::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  MLComputeResult* dictionary = MakeGarbageCollected<MLComputeResult>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "MLComputeResult";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 MLComputeResult::MLComputeResult() {
  
}

 MLComputeResult::MLComputeResult(v8::Isolate* isolate) {
  
}



HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>> MLComputeResult::getInputsOr(const HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>>& fallback_value) const {
  if (!hasInputs()) {
  return fallback_value;
}
return member_inputs_;
}

HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>> MLComputeResult::getInputsOr(HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>>&& fallback_value) const {
  if (!hasInputs()) {
  return std::move(fallback_value);
}
return member_inputs_;
}

void MLComputeResult::setInputs(const HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>>& value) {
  member_inputs_ = value;
has_inputs_ = true;
}

void MLComputeResult::setInputs(HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>>&& value) {
  member_inputs_ = std::move(value);
has_inputs_ = true;
}




HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>> MLComputeResult::getOutputsOr(const HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>>& fallback_value) const {
  if (!hasOutputs()) {
  return fallback_value;
}
return member_outputs_;
}

HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>> MLComputeResult::getOutputsOr(HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>>&& fallback_value) const {
  if (!hasOutputs()) {
  return std::move(fallback_value);
}
return member_outputs_;
}

void MLComputeResult::setOutputs(const HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>>& value) {
  member_outputs_ = value;
has_outputs_ = true;
}

void MLComputeResult::setOutputs(HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>>&& value) {
  member_outputs_ = std::move(value);
has_outputs_ = true;
}




void MLComputeResult::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>>>::Trace(visitor, member_inputs_);
TraceIfNeeded<HeapVector<std::pair<String, NotShared<DOMArrayBufferView>>>>::Trace(visitor, member_outputs_);
bindings::DictionaryBase::Trace(visitor);
}

bool MLComputeResult::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasInputs()) {
  v8_value = ToV8Traits<IDLRecord<IDLString, NotShared<DOMArrayBufferView>>>::ToV8(script_state, member_inputs_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasOutputs()) {
  v8_value = ToV8Traits<IDLRecord<IDLString, NotShared<DOMArrayBufferView>>>::ToV8(script_state, member_outputs_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
return true;
}

void MLComputeResult::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "MLComputeResult";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("inputs");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLRecord<IDLString, NotShared<DOMArrayBufferView>>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_inputs_, member_inputs_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("outputs");
if (!bindings::GetDictionaryMemberFromV8Object<IDLRecord<IDLString, NotShared<DOMArrayBufferView>>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_outputs_, member_outputs_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> MLComputeResult::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"inputs",
"outputs",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
