// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_ml_operand_descriptor.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



MLOperandDescriptor* MLOperandDescriptor::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  MLOperandDescriptor* dictionary = MakeGarbageCollected<MLOperandDescriptor>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "MLOperandDescriptor";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 MLOperandDescriptor::MLOperandDescriptor() {
  
}

 MLOperandDescriptor::MLOperandDescriptor(v8::Isolate* isolate) {
  
}








Vector<uint32_t> MLOperandDescriptor::getDimensionsOr(const Vector<uint32_t>& fallback_value) const {
  if (!hasDimensions()) {
  return fallback_value;
}
return member_dimensions_;
}

Vector<uint32_t> MLOperandDescriptor::getDimensionsOr(Vector<uint32_t>&& fallback_value) const {
  if (!hasDimensions()) {
  return std::move(fallback_value);
}
return member_dimensions_;
}

void MLOperandDescriptor::setDimensions(const Vector<uint32_t>& value) {
  member_dimensions_ = value;
has_dimensions_ = true;
}

void MLOperandDescriptor::setDimensions(Vector<uint32_t>&& value) {
  member_dimensions_ = std::move(value);
has_dimensions_ = true;
}




void MLOperandDescriptor::Trace(Visitor* visitor) const {
  TraceIfNeeded<V8MLOperandDataType>::Trace(visitor, member_data_type_);
TraceIfNeeded<Vector<uint32_t>>::Trace(visitor, member_dimensions_);
bindings::DictionaryBase::Trace(visitor);
}

bool MLOperandDescriptor::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasDataType()) {
  v8_value = ToV8Traits<V8MLOperandDataType>::ToV8(script_state, member_data_type_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasDimensions()) {
  v8_value = ToV8Traits<IDLSequence<IDLUnsignedLongEnforceRange>>::ToV8(script_state, member_dimensions_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
return true;
}

void MLOperandDescriptor::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "MLOperandDescriptor";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("dataType");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<V8MLOperandDataType, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_data_type_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("dimensions");
constexpr bool is_optional = false;
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUnsignedLongEnforceRange>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_dimensions_, member_dimensions_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> MLOperandDescriptor::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"dataType",
"dimensions",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
