// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_ml_resample_2d_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



MLResample2dOptions* MLResample2dOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  MLResample2dOptions* dictionary = MakeGarbageCollected<MLResample2dOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "MLResample2dOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 MLResample2dOptions::MLResample2dOptions() {
  
}

 MLResample2dOptions::MLResample2dOptions(v8::Isolate* isolate) {
  
}



Vector<uint32_t> MLResample2dOptions::getAxesOr(const Vector<uint32_t>& fallback_value) const {
  if (!hasAxes()) {
  return fallback_value;
}
return member_axes_;
}

Vector<uint32_t> MLResample2dOptions::getAxesOr(Vector<uint32_t>&& fallback_value) const {
  if (!hasAxes()) {
  return std::move(fallback_value);
}
return member_axes_;
}

void MLResample2dOptions::setAxes(const Vector<uint32_t>& value) {
  member_axes_ = value;
has_axes_ = true;
}

void MLResample2dOptions::setAxes(Vector<uint32_t>&& value) {
  member_axes_ = std::move(value);
has_axes_ = true;
}









Vector<float> MLResample2dOptions::getScalesOr(const Vector<float>& fallback_value) const {
  if (!hasScales()) {
  return fallback_value;
}
return member_scales_;
}

Vector<float> MLResample2dOptions::getScalesOr(Vector<float>&& fallback_value) const {
  if (!hasScales()) {
  return std::move(fallback_value);
}
return member_scales_;
}

void MLResample2dOptions::setScales(const Vector<float>& value) {
  member_scales_ = value;
has_scales_ = true;
}

void MLResample2dOptions::setScales(Vector<float>&& value) {
  member_scales_ = std::move(value);
has_scales_ = true;
}




Vector<uint32_t> MLResample2dOptions::getSizesOr(const Vector<uint32_t>& fallback_value) const {
  if (!hasSizes()) {
  return fallback_value;
}
return member_sizes_;
}

Vector<uint32_t> MLResample2dOptions::getSizesOr(Vector<uint32_t>&& fallback_value) const {
  if (!hasSizes()) {
  return std::move(fallback_value);
}
return member_sizes_;
}

void MLResample2dOptions::setSizes(const Vector<uint32_t>& value) {
  member_sizes_ = value;
has_sizes_ = true;
}

void MLResample2dOptions::setSizes(Vector<uint32_t>&& value) {
  member_sizes_ = std::move(value);
has_sizes_ = true;
}




void MLResample2dOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<Vector<uint32_t>>::Trace(visitor, member_axes_);
TraceIfNeeded<V8MLInterpolationMode>::Trace(visitor, member_mode_);
TraceIfNeeded<Vector<float>>::Trace(visitor, member_scales_);
TraceIfNeeded<Vector<uint32_t>>::Trace(visitor, member_sizes_);
bindings::DictionaryBase::Trace(visitor);
}

bool MLResample2dOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAxes()) {
  v8_value = ToV8Traits<IDLSequence<IDLUnsignedLongEnforceRange>>::ToV8(script_state, member_axes_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasMode()) {
  v8_value = ToV8Traits<V8MLInterpolationMode>::ToV8(script_state, member_mode_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasScales()) {
  v8_value = ToV8Traits<IDLSequence<IDLFloat>>::ToV8(script_state, member_scales_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasSizes()) {
  v8_value = ToV8Traits<IDLSequence<IDLUnsignedLongEnforceRange>>::ToV8(script_state, member_sizes_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
return true;
}

void MLResample2dOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "MLResample2dOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("axes");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUnsignedLongEnforceRange>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_axes_, member_axes_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("mode");
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<V8MLInterpolationMode, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_mode_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("scales");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLFloat>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_scales_, member_scales_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sizes");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUnsignedLongEnforceRange>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_sizes_, member_sizes_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> MLResample2dOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"axes",
"mode",
"scales",
"sizes",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
