// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ML_TENSOR_INFO_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ML_TENSOR_INFO_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_ml_data_type.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT MLTensorInfo : public bindings::DictionaryBase {
  
  public:
static MLTensorInfo* Create() {
  return MakeGarbageCollected<MLTensorInfo>();
}
static MLTensorInfo* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<MLTensorInfo>(isolate);
}
static MLTensorInfo* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  MLTensorInfo();
explicit  MLTensorInfo(v8::Isolate* isolate);

bool hasDimensions() const {
  return true;
}
const Vector<uint32_t>& dimensions() const {
  return member_dimensions_;
}
void setDimensions(const Vector<uint32_t>& value);
void setDimensions(Vector<uint32_t>&& value);

bool hasName() const {
  return true;
}
const String& name() const {
  return member_name_;
}
void setName(const String& value);
void setName(String&& value);

bool hasType() const {
  return true;
}
V8MLDataType type() const {
  return member_type_;
}
void setType(V8MLDataType value) {
  member_type_ = value;
}
void setType(V8MLDataType::Enum value) {
  member_type_ = V8MLDataType(value);
}


// Obsolete accessor functions
void setType(const String& value) {
  member_type_ = V8MLDataType::Create(value).value();
}

void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);



Vector<uint32_t> member_dimensions_;
String member_name_;
V8MLDataType member_type_{static_cast<V8MLDataType::Enum>(0)};


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_ML_TENSOR_INFO_H_
