// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_MULTI_CACHE_QUERY_OPTIONS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_MULTI_CACHE_QUERY_OPTIONS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_cache_query_options.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT MultiCacheQueryOptions : public CacheQueryOptions {
  
  public:
static MultiCacheQueryOptions* Create() {
  return MakeGarbageCollected<MultiCacheQueryOptions>();
}
static MultiCacheQueryOptions* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<MultiCacheQueryOptions>(isolate);
}
static MultiCacheQueryOptions* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  MultiCacheQueryOptions();
explicit  MultiCacheQueryOptions(v8::Isolate* isolate);

bool hasCacheName() const {
  return has_cache_name_;
}
const String& cacheName() const {
  DCHECK(hasCacheName());
return member_cache_name_;
}
String getCacheNameOr(const String& fallback_value) const;
String getCacheNameOr(String&& fallback_value) const;
void setCacheName(const String& value);
void setCacheName(String&& value);




void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_cache_name_ = false;

String member_cache_name_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_MULTI_CACHE_QUERY_OPTIONS_H_
