// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_NAVIGATION_PRELOAD_STATE_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_NAVIGATION_PRELOAD_STATE_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT NavigationPreloadState : public bindings::DictionaryBase {
  
  public:
static NavigationPreloadState* Create() {
  return MakeGarbageCollected<NavigationPreloadState>();
}
static NavigationPreloadState* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<NavigationPreloadState>(isolate);
}
static NavigationPreloadState* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  NavigationPreloadState();
explicit  NavigationPreloadState(v8::Isolate* isolate);

bool hasEnabled() const {
  return true;
}
bool enabled() const {
  return member_enabled_;
}
void setEnabled(bool value) {
  member_enabled_ = value;
}

bool hasHeaderValue() const {
  return has_header_value_;
}
const String& headerValue() const {
  DCHECK(hasHeaderValue());
return member_header_value_;
}
String getHeaderValueOr(const String& fallback_value) const;
String getHeaderValueOr(String&& fallback_value) const;
void setHeaderValue(const String& value);
void setHeaderValue(String&& value);




void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_header_value_ = false;

bool member_enabled_{false};
String member_header_value_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_NAVIGATION_PRELOAD_STATE_H_
