// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_payment_credential_instrument.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



PaymentCredentialInstrument* PaymentCredentialInstrument::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  PaymentCredentialInstrument* dictionary = MakeGarbageCollected<PaymentCredentialInstrument>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "PaymentCredentialInstrument";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 PaymentCredentialInstrument::PaymentCredentialInstrument() {
  
}

 PaymentCredentialInstrument::PaymentCredentialInstrument(v8::Isolate* isolate) {
  
}



void PaymentCredentialInstrument::setDisplayName(const String& value) {
  member_display_name_ = value;
}

void PaymentCredentialInstrument::setDisplayName(String&& value) {
  member_display_name_ = std::move(value);
}




void PaymentCredentialInstrument::setIcon(const String& value) {
  member_icon_ = value;
}

void PaymentCredentialInstrument::setIcon(String&& value) {
  member_icon_ = std::move(value);
}









void PaymentCredentialInstrument::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_display_name_);
TraceIfNeeded<String>::Trace(visitor, member_icon_);
TraceIfNeeded<bool>::Trace(visitor, member_icon_must_be_shown_);
bindings::DictionaryBase::Trace(visitor);
}

bool PaymentCredentialInstrument::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasDisplayName()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_display_name_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasIcon()) {
  v8_value = ToV8Traits<IDLUSVString>::ToV8(script_state, member_icon_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasIconMustBeShown()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_icon_must_be_shown_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
return true;
}

void PaymentCredentialInstrument::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "PaymentCredentialInstrument";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("displayName");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_display_name_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("icon");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_icon_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("iconMustBeShown");
constexpr bool is_optional = false;
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_icon_must_be_shown_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> PaymentCredentialInstrument::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"displayName",
"icon",
"iconMustBeShown",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
