// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_photo_capabilities.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_media_settings_range.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



PhotoCapabilities* PhotoCapabilities::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  PhotoCapabilities* dictionary = MakeGarbageCollected<PhotoCapabilities>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "PhotoCapabilities";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 PhotoCapabilities::PhotoCapabilities() {
  
}

 PhotoCapabilities::PhotoCapabilities(v8::Isolate* isolate) {
  
}



Vector<V8FillLightMode> PhotoCapabilities::getFillLightModeOr(const Vector<V8FillLightMode>& fallback_value) const {
  if (!hasFillLightMode()) {
  return fallback_value;
}
return member_fill_light_mode_;
}

Vector<V8FillLightMode> PhotoCapabilities::getFillLightModeOr(Vector<V8FillLightMode>&& fallback_value) const {
  if (!hasFillLightMode()) {
  return std::move(fallback_value);
}
return member_fill_light_mode_;
}

void PhotoCapabilities::setFillLightMode(const Vector<V8FillLightMode>& value) {
  member_fill_light_mode_ = value;
has_fill_light_mode_ = true;
}

void PhotoCapabilities::setFillLightMode(Vector<V8FillLightMode>&& value) {
  member_fill_light_mode_ = std::move(value);
has_fill_light_mode_ = true;
}

























void PhotoCapabilities::Trace(Visitor* visitor) const {
  TraceIfNeeded<Vector<V8FillLightMode>>::Trace(visitor, member_fill_light_mode_);
TraceIfNeeded<Member<MediaSettingsRange>>::Trace(visitor, member_image_height_);
TraceIfNeeded<Member<MediaSettingsRange>>::Trace(visitor, member_image_width_);
TraceIfNeeded<V8RedEyeReduction>::Trace(visitor, member_red_eye_reduction_);
bindings::DictionaryBase::Trace(visitor);
}

bool PhotoCapabilities::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasFillLightMode()) {
  v8_value = ToV8Traits<IDLSequence<V8FillLightMode>>::ToV8(script_state, member_fill_light_mode_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasImageHeight()) {
  v8_value = ToV8Traits<MediaSettingsRange>::ToV8(script_state, member_image_height_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasImageWidth()) {
  v8_value = ToV8Traits<MediaSettingsRange>::ToV8(script_state, member_image_width_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasRedEyeReduction()) {
  v8_value = ToV8Traits<V8RedEyeReduction>::ToV8(script_state, member_red_eye_reduction_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
return true;
}

void PhotoCapabilities::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "PhotoCapabilities";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("fillLightMode");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<V8FillLightMode>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_fill_light_mode_, member_fill_light_mode_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("imageHeight");
if (!bindings::GetDictionaryMemberFromV8Object<MediaSettingsRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_image_height_, member_image_height_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("imageWidth");
if (!bindings::GetDictionaryMemberFromV8Object<MediaSettingsRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_image_width_, member_image_width_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("redEyeReduction");
if (!bindings::GetDictionaryMemberFromV8Object<V8RedEyeReduction, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_red_eye_reduction_, member_red_eye_reduction_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> PhotoCapabilities::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"fillLightMode",
"imageHeight",
"imageWidth",
"redEyeReduction",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
