// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_PRIVATE_ATTRIBUTION_OPTIONS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_PRIVATE_ATTRIBUTION_OPTIONS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_private_attribution_event.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT PrivateAttributionOptions : public bindings::DictionaryBase {
  
  public:
static PrivateAttributionOptions* Create() {
  return MakeGarbageCollected<PrivateAttributionOptions>();
}
static PrivateAttributionOptions* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<PrivateAttributionOptions>(isolate);
}
static PrivateAttributionOptions* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  PrivateAttributionOptions();
explicit  PrivateAttributionOptions(v8::Isolate* isolate);

bool hasEventType() const {
  return has_event_type_;
}
V8PrivateAttributionEvent eventType() const {
  DCHECK(hasEventType());
return member_event_type_;
}
V8PrivateAttributionEvent getEventTypeOr(V8PrivateAttributionEvent fallback_value) const {
  if (!hasEventType()) {
  return fallback_value;
}
return member_event_type_;
}
void setEventType(V8PrivateAttributionEvent value) {
  member_event_type_ = value;
has_event_type_ = true;
}
void setEventType(V8PrivateAttributionEvent::Enum value) {
  member_event_type_ = V8PrivateAttributionEvent(value);
has_event_type_ = true;
}

bool hasHelperNetworkId() const {
  return has_helper_network_id_;
}
uint32_t helperNetworkId() const {
  DCHECK(hasHelperNetworkId());
return member_helper_network_id_;
}
uint32_t getHelperNetworkIdOr(uint32_t fallback_value) const {
  if (!hasHelperNetworkId()) {
  return fallback_value;
}
return member_helper_network_id_;
}
void setHelperNetworkId(uint32_t value) {
  member_helper_network_id_ = value;
has_helper_network_id_ = true;
}


// Obsolete accessor functions
void setEventType(const String& value) {
  member_event_type_ = V8PrivateAttributionEvent::Create(value).value();
has_event_type_ = true;
}

void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_event_type_ = false;
bool has_helper_network_id_ = false;

V8PrivateAttributionEvent member_event_type_{static_cast<V8PrivateAttributionEvent::Enum>(0)};
uint32_t member_helper_network_id_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_PRIVATE_ATTRIBUTION_OPTIONS_H_
