// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_request_device_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_union_string_unsignedlong.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_bluetooth_le_scan_filter_init.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



RequestDeviceOptions* RequestDeviceOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RequestDeviceOptions* dictionary = MakeGarbageCollected<RequestDeviceOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RequestDeviceOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 RequestDeviceOptions::RequestDeviceOptions() {
  
}

 RequestDeviceOptions::RequestDeviceOptions(v8::Isolate* isolate) {
  
}








HeapVector<Member<BluetoothLEScanFilterInit>> RequestDeviceOptions::getExclusionFiltersOr(const HeapVector<Member<BluetoothLEScanFilterInit>>& fallback_value) const {
  if (!hasExclusionFilters()) {
  return fallback_value;
}
return member_exclusion_filters_;
}

HeapVector<Member<BluetoothLEScanFilterInit>> RequestDeviceOptions::getExclusionFiltersOr(HeapVector<Member<BluetoothLEScanFilterInit>>&& fallback_value) const {
  if (!hasExclusionFilters()) {
  return std::move(fallback_value);
}
return member_exclusion_filters_;
}

void RequestDeviceOptions::setExclusionFilters(const HeapVector<Member<BluetoothLEScanFilterInit>>& value) {
  member_exclusion_filters_ = value;
has_exclusion_filters_ = true;
}

void RequestDeviceOptions::setExclusionFilters(HeapVector<Member<BluetoothLEScanFilterInit>>&& value) {
  member_exclusion_filters_ = std::move(value);
has_exclusion_filters_ = true;
}




HeapVector<Member<BluetoothLEScanFilterInit>> RequestDeviceOptions::getFiltersOr(const HeapVector<Member<BluetoothLEScanFilterInit>>& fallback_value) const {
  if (!hasFilters()) {
  return fallback_value;
}
return member_filters_;
}

HeapVector<Member<BluetoothLEScanFilterInit>> RequestDeviceOptions::getFiltersOr(HeapVector<Member<BluetoothLEScanFilterInit>>&& fallback_value) const {
  if (!hasFilters()) {
  return std::move(fallback_value);
}
return member_filters_;
}

void RequestDeviceOptions::setFilters(const HeapVector<Member<BluetoothLEScanFilterInit>>& value) {
  member_filters_ = value;
has_filters_ = true;
}

void RequestDeviceOptions::setFilters(HeapVector<Member<BluetoothLEScanFilterInit>>&& value) {
  member_filters_ = std::move(value);
has_filters_ = true;
}




void RequestDeviceOptions::setOptionalManufacturerData(const Vector<uint16_t>& value) {
  member_optional_manufacturer_data_ = value;
}

void RequestDeviceOptions::setOptionalManufacturerData(Vector<uint16_t>&& value) {
  member_optional_manufacturer_data_ = std::move(value);
}




void RequestDeviceOptions::setOptionalServices(const HeapVector<Member<V8UnionStringOrUnsignedLong>>& value) {
  member_optional_services_ = value;
}

void RequestDeviceOptions::setOptionalServices(HeapVector<Member<V8UnionStringOrUnsignedLong>>&& value) {
  member_optional_services_ = std::move(value);
}




void RequestDeviceOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<bool>::Trace(visitor, member_accept_all_devices_);
TraceIfNeeded<HeapVector<Member<BluetoothLEScanFilterInit>>>::Trace(visitor, member_exclusion_filters_);
TraceIfNeeded<HeapVector<Member<BluetoothLEScanFilterInit>>>::Trace(visitor, member_filters_);
TraceIfNeeded<Vector<uint16_t>>::Trace(visitor, member_optional_manufacturer_data_);
TraceIfNeeded<HeapVector<Member<V8UnionStringOrUnsignedLong>>>::Trace(visitor, member_optional_services_);
bindings::DictionaryBase::Trace(visitor);
}

bool RequestDeviceOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAcceptAllDevices()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_accept_all_devices_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasExclusionFilters()) {
  v8_value = ToV8Traits<IDLSequence<BluetoothLEScanFilterInit>>::ToV8(script_state, member_exclusion_filters_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasFilters()) {
  v8_value = ToV8Traits<IDLSequence<BluetoothLEScanFilterInit>>::ToV8(script_state, member_filters_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (RuntimeEnabledFeatures::WebBluetoothWatchAdvertisementsEnabled()) {
  if (hasOptionalManufacturerData()) {
  v8_value = ToV8Traits<IDLSequence<IDLUnsignedShort>>::ToV8(script_state, member_optional_manufacturer_data_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
}
if (hasOptionalServices()) {
  v8_value = ToV8Traits<IDLSequence<V8UnionStringOrUnsignedLong>>::ToV8(script_state, member_optional_services_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
return true;
}

void RequestDeviceOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "RequestDeviceOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("acceptAllDevices");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_accept_all_devices_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("exclusionFilters");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<BluetoothLEScanFilterInit>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_exclusion_filters_, member_exclusion_filters_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("filters");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<BluetoothLEScanFilterInit>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_filters_, member_filters_, try_block, exception_state)) {
  return;
}
if (RuntimeEnabledFeatures::WebBluetoothWatchAdvertisementsEnabled()) {
  exception_context_scope.ChangePropertyNameAsOptimizationHack("optionalManufacturerData");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLUnsignedShort>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_optional_manufacturer_data_, try_block, exception_state)) {
  return;
}
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("optionalServices");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<V8UnionStringOrUnsignedLong>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_optional_services_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RequestDeviceOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"acceptAllDevices",
"exclusionFilters",
"filters",
"optionalManufacturerData",
"optionalServices",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
