// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_certificate_stats.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



RTCCertificateStats* RTCCertificateStats::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RTCCertificateStats* dictionary = MakeGarbageCollected<RTCCertificateStats>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RTCCertificateStats";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 RTCCertificateStats::RTCCertificateStats() {
  
}

 RTCCertificateStats::RTCCertificateStats(v8::Isolate* isolate) : RTCStats(isolate) {
  
}



void RTCCertificateStats::setBase64Certificate(const String& value) {
  member_base_64_certificate_ = value;
}

void RTCCertificateStats::setBase64Certificate(String&& value) {
  member_base_64_certificate_ = std::move(value);
}




void RTCCertificateStats::setFingerprint(const String& value) {
  member_fingerprint_ = value;
}

void RTCCertificateStats::setFingerprint(String&& value) {
  member_fingerprint_ = std::move(value);
}




void RTCCertificateStats::setFingerprintAlgorithm(const String& value) {
  member_fingerprint_algorithm_ = value;
}

void RTCCertificateStats::setFingerprintAlgorithm(String&& value) {
  member_fingerprint_algorithm_ = std::move(value);
}




String RTCCertificateStats::getIssuerCertificateIdOr(const String& fallback_value) const {
  if (!hasIssuerCertificateId()) {
  return fallback_value;
}
return member_issuer_certificate_id_;
}

String RTCCertificateStats::getIssuerCertificateIdOr(String&& fallback_value) const {
  if (!hasIssuerCertificateId()) {
  return std::move(fallback_value);
}
return member_issuer_certificate_id_;
}

void RTCCertificateStats::setIssuerCertificateId(const String& value) {
  member_issuer_certificate_id_ = value;
has_issuer_certificate_id_ = true;
}

void RTCCertificateStats::setIssuerCertificateId(String&& value) {
  member_issuer_certificate_id_ = std::move(value);
has_issuer_certificate_id_ = true;
}




void RTCCertificateStats::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_base_64_certificate_);
TraceIfNeeded<String>::Trace(visitor, member_fingerprint_);
TraceIfNeeded<String>::Trace(visitor, member_fingerprint_algorithm_);
TraceIfNeeded<String>::Trace(visitor, member_issuer_certificate_id_);
RTCStats::Trace(visitor);
}

bool RTCCertificateStats::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!RTCStats::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasBase64Certificate()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_base_64_certificate_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasFingerprint()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_fingerprint_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasFingerprintAlgorithm()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_fingerprint_algorithm_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasIssuerCertificateId()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_issuer_certificate_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
return true;
}

void RTCCertificateStats::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  RTCStats::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "RTCCertificateStats";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("base64Certificate");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_base_64_certificate_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("fingerprint");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_fingerprint_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("fingerprintAlgorithm");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_fingerprint_algorithm_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("issuerCertificateId");
constexpr bool is_optional = false;
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_issuer_certificate_id_, member_issuer_certificate_id_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RTCCertificateStats::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"base64Certificate",
"fingerprint",
"fingerprintAlgorithm",
"issuerCertificateId",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
