// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_ice_candidate_pair_stats.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



RTCIceCandidatePairStats* RTCIceCandidatePairStats::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RTCIceCandidatePairStats* dictionary = MakeGarbageCollected<RTCIceCandidatePairStats>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RTCIceCandidatePairStats";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 RTCIceCandidatePairStats::RTCIceCandidatePairStats() {
  
}

 RTCIceCandidatePairStats::RTCIceCandidatePairStats(v8::Isolate* isolate) : RTCStats(isolate) {
  
}


































































void RTCIceCandidatePairStats::setLocalCandidateId(const String& value) {
  member_local_candidate_id_ = value;
}

void RTCIceCandidatePairStats::setLocalCandidateId(String&& value) {
  member_local_candidate_id_ = std::move(value);
}







































void RTCIceCandidatePairStats::setRemoteCandidateId(const String& value) {
  member_remote_candidate_id_ = value;
}

void RTCIceCandidatePairStats::setRemoteCandidateId(String&& value) {
  member_remote_candidate_id_ = std::move(value);
}












































void RTCIceCandidatePairStats::setTransportId(const String& value) {
  member_transport_id_ = value;
}

void RTCIceCandidatePairStats::setTransportId(String&& value) {
  member_transport_id_ = std::move(value);
}











void RTCIceCandidatePairStats::Trace(Visitor* visitor) const {
  TraceIfNeeded<double>::Trace(visitor, member_available_incoming_bitrate_);
TraceIfNeeded<double>::Trace(visitor, member_available_outgoing_bitrate_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_bytes_discarded_on_send_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_bytes_received_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_bytes_sent_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_consent_requests_sent_);
TraceIfNeeded<double>::Trace(visitor, member_current_round_trip_time_);
TraceIfNeeded<double>::Trace(visitor, member_last_packet_received_timestamp_);
TraceIfNeeded<double>::Trace(visitor, member_last_packet_sent_timestamp_);
TraceIfNeeded<String>::Trace(visitor, member_local_candidate_id_);
TraceIfNeeded<bool>::Trace(visitor, member_nominated_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_packets_discarded_on_send_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_packets_received_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_packets_sent_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_priority_);
TraceIfNeeded<String>::Trace(visitor, member_remote_candidate_id_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_requests_received_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_requests_sent_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_responses_received_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_responses_sent_);
TraceIfNeeded<V8RTCStatsIceCandidatePairState>::Trace(visitor, member_state_);
TraceIfNeeded<double>::Trace(visitor, member_total_round_trip_time_);
TraceIfNeeded<String>::Trace(visitor, member_transport_id_);
TraceIfNeeded<bool>::Trace(visitor, member_writable_);
RTCStats::Trace(visitor);
}

bool RTCIceCandidatePairStats::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!RTCStats::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasAvailableIncomingBitrate()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_available_incoming_bitrate_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasAvailableOutgoingBitrate()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_available_outgoing_bitrate_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasBytesDiscardedOnSend()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_bytes_discarded_on_send_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasBytesReceived()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_bytes_received_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasBytesSent()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_bytes_sent_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasConsentRequestsSent()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_consent_requests_sent_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
if (hasCurrentRoundTripTime()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_current_round_trip_time_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[6].Get(isolate), v8_value).ToChecked();
}
if (hasLastPacketReceivedTimestamp()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_last_packet_received_timestamp_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[7].Get(isolate), v8_value).ToChecked();
}
if (hasLastPacketSentTimestamp()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_last_packet_sent_timestamp_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[8].Get(isolate), v8_value).ToChecked();
}
if (hasLocalCandidateId()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_local_candidate_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[9].Get(isolate), v8_value).ToChecked();
}
if (hasNominated()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_nominated_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[10].Get(isolate), v8_value).ToChecked();
}
if (hasPacketsDiscardedOnSend()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_packets_discarded_on_send_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[11].Get(isolate), v8_value).ToChecked();
}
if (hasPacketsReceived()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_packets_received_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[12].Get(isolate), v8_value).ToChecked();
}
if (hasPacketsSent()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_packets_sent_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[13].Get(isolate), v8_value).ToChecked();
}
if (hasPriority()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_priority_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[14].Get(isolate), v8_value).ToChecked();
}
if (hasRemoteCandidateId()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_remote_candidate_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[15].Get(isolate), v8_value).ToChecked();
}
if (hasRequestsReceived()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_requests_received_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[16].Get(isolate), v8_value).ToChecked();
}
if (hasRequestsSent()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_requests_sent_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[17].Get(isolate), v8_value).ToChecked();
}
if (hasResponsesReceived()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_responses_received_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[18].Get(isolate), v8_value).ToChecked();
}
if (hasResponsesSent()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_responses_sent_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[19].Get(isolate), v8_value).ToChecked();
}
if (hasState()) {
  v8_value = ToV8Traits<V8RTCStatsIceCandidatePairState>::ToV8(script_state, member_state_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[20].Get(isolate), v8_value).ToChecked();
}
if (hasTotalRoundTripTime()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_total_round_trip_time_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[21].Get(isolate), v8_value).ToChecked();
}
if (hasTransportId()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_transport_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[22].Get(isolate), v8_value).ToChecked();
}
if (hasWritable()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_writable_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[23].Get(isolate), v8_value).ToChecked();
}
return true;
}

void RTCIceCandidatePairStats::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  RTCStats::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "RTCIceCandidatePairStats";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("availableIncomingBitrate");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_available_incoming_bitrate_, member_available_incoming_bitrate_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("availableOutgoingBitrate");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_available_outgoing_bitrate_, member_available_outgoing_bitrate_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("bytesDiscardedOnSend");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_bytes_discarded_on_send_, member_bytes_discarded_on_send_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("bytesReceived");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_bytes_received_, member_bytes_received_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("bytesSent");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_bytes_sent_, member_bytes_sent_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("consentRequestsSent");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_consent_requests_sent_, member_consent_requests_sent_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("currentRoundTripTime");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_current_round_trip_time_, member_current_round_trip_time_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("lastPacketReceivedTimestamp");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), has_last_packet_received_timestamp_, member_last_packet_received_timestamp_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("lastPacketSentTimestamp");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), has_last_packet_sent_timestamp_, member_last_packet_sent_timestamp_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("localCandidateId");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[9].Get(isolate), fallback_presence_var, member_local_candidate_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("nominated");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[10].Get(isolate), has_nominated_, member_nominated_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("packetsDiscardedOnSend");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[11].Get(isolate), has_packets_discarded_on_send_, member_packets_discarded_on_send_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("packetsReceived");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[12].Get(isolate), has_packets_received_, member_packets_received_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("packetsSent");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[13].Get(isolate), has_packets_sent_, member_packets_sent_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("priority");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[14].Get(isolate), has_priority_, member_priority_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("remoteCandidateId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[15].Get(isolate), fallback_presence_var, member_remote_candidate_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("requestsReceived");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[16].Get(isolate), has_requests_received_, member_requests_received_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("requestsSent");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[17].Get(isolate), has_requests_sent_, member_requests_sent_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("responsesReceived");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[18].Get(isolate), has_responses_received_, member_responses_received_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("responsesSent");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[19].Get(isolate), has_responses_sent_, member_responses_sent_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("state");
if (!bindings::GetDictionaryMemberFromV8Object<V8RTCStatsIceCandidatePairState, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[20].Get(isolate), fallback_presence_var, member_state_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("totalRoundTripTime");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[21].Get(isolate), has_total_round_trip_time_, member_total_round_trip_time_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("transportId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[22].Get(isolate), fallback_presence_var, member_transport_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("writable");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[23].Get(isolate), has_writable_, member_writable_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RTCIceCandidatePairStats::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"availableIncomingBitrate",
"availableOutgoingBitrate",
"bytesDiscardedOnSend",
"bytesReceived",
"bytesSent",
"consentRequestsSent",
"currentRoundTripTime",
"lastPacketReceivedTimestamp",
"lastPacketSentTimestamp",
"localCandidateId",
"nominated",
"packetsDiscardedOnSend",
"packetsReceived",
"packetsSent",
"priority",
"remoteCandidateId",
"requestsReceived",
"requestsSent",
"responsesReceived",
"responsesSent",
"state",
"totalRoundTripTime",
"transportId",
"writable",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
