// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_outbound_rtp_stream_stats.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



RTCOutboundRtpStreamStats* RTCOutboundRtpStreamStats::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RTCOutboundRtpStreamStats* dictionary = MakeGarbageCollected<RTCOutboundRtpStreamStats>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RTCOutboundRtpStreamStats";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 RTCOutboundRtpStreamStats::RTCOutboundRtpStreamStats() {
  
}

 RTCOutboundRtpStreamStats::RTCOutboundRtpStreamStats(v8::Isolate* isolate) : RTCSentRtpStreamStats(isolate) {
  
}










String RTCOutboundRtpStreamStats::getContentTypeOr(const String& fallback_value) const {
  if (!hasContentType()) {
  return fallback_value;
}
return member_content_type_;
}

String RTCOutboundRtpStreamStats::getContentTypeOr(String&& fallback_value) const {
  if (!hasContentType()) {
  return std::move(fallback_value);
}
return member_content_type_;
}

void RTCOutboundRtpStreamStats::setContentType(const String& value) {
  member_content_type_ = value;
has_content_type_ = true;
}

void RTCOutboundRtpStreamStats::setContentType(String&& value) {
  member_content_type_ = std::move(value);
has_content_type_ = true;
}




String RTCOutboundRtpStreamStats::getEncoderImplementationOr(const String& fallback_value) const {
  if (!hasEncoderImplementation()) {
  return fallback_value;
}
return member_encoder_implementation_;
}

String RTCOutboundRtpStreamStats::getEncoderImplementationOr(String&& fallback_value) const {
  if (!hasEncoderImplementation()) {
  return std::move(fallback_value);
}
return member_encoder_implementation_;
}

void RTCOutboundRtpStreamStats::setEncoderImplementation(const String& value) {
  member_encoder_implementation_ = value;
has_encoder_implementation_ = true;
}

void RTCOutboundRtpStreamStats::setEncoderImplementation(String&& value) {
  member_encoder_implementation_ = std::move(value);
has_encoder_implementation_ = true;
}



































































String RTCOutboundRtpStreamStats::getMediaSourceIdOr(const String& fallback_value) const {
  if (!hasMediaSourceId()) {
  return fallback_value;
}
return member_media_source_id_;
}

String RTCOutboundRtpStreamStats::getMediaSourceIdOr(String&& fallback_value) const {
  if (!hasMediaSourceId()) {
  return std::move(fallback_value);
}
return member_media_source_id_;
}

void RTCOutboundRtpStreamStats::setMediaSourceId(const String& value) {
  member_media_source_id_ = value;
has_media_source_id_ = true;
}

void RTCOutboundRtpStreamStats::setMediaSourceId(String&& value) {
  member_media_source_id_ = std::move(value);
has_media_source_id_ = true;
}




String RTCOutboundRtpStreamStats::getMidOr(const String& fallback_value) const {
  if (!hasMid()) {
  return fallback_value;
}
return member_mid_;
}

String RTCOutboundRtpStreamStats::getMidOr(String&& fallback_value) const {
  if (!hasMid()) {
  return std::move(fallback_value);
}
return member_mid_;
}

void RTCOutboundRtpStreamStats::setMid(const String& value) {
  member_mid_ = value;
has_mid_ = true;
}

void RTCOutboundRtpStreamStats::setMid(String&& value) {
  member_mid_ = std::move(value);
has_mid_ = true;
}
































Vector<std::pair<String, double>> RTCOutboundRtpStreamStats::getQualityLimitationDurationsOr(const Vector<std::pair<String, double>>& fallback_value) const {
  if (!hasQualityLimitationDurations()) {
  return fallback_value;
}
return member_quality_limitation_durations_;
}

Vector<std::pair<String, double>> RTCOutboundRtpStreamStats::getQualityLimitationDurationsOr(Vector<std::pair<String, double>>&& fallback_value) const {
  if (!hasQualityLimitationDurations()) {
  return std::move(fallback_value);
}
return member_quality_limitation_durations_;
}

void RTCOutboundRtpStreamStats::setQualityLimitationDurations(const Vector<std::pair<String, double>>& value) {
  member_quality_limitation_durations_ = value;
has_quality_limitation_durations_ = true;
}

void RTCOutboundRtpStreamStats::setQualityLimitationDurations(Vector<std::pair<String, double>>&& value) {
  member_quality_limitation_durations_ = std::move(value);
has_quality_limitation_durations_ = true;
}


















String RTCOutboundRtpStreamStats::getRemoteIdOr(const String& fallback_value) const {
  if (!hasRemoteId()) {
  return fallback_value;
}
return member_remote_id_;
}

String RTCOutboundRtpStreamStats::getRemoteIdOr(String&& fallback_value) const {
  if (!hasRemoteId()) {
  return std::move(fallback_value);
}
return member_remote_id_;
}

void RTCOutboundRtpStreamStats::setRemoteId(const String& value) {
  member_remote_id_ = value;
has_remote_id_ = true;
}

void RTCOutboundRtpStreamStats::setRemoteId(String&& value) {
  member_remote_id_ = std::move(value);
has_remote_id_ = true;
}


















String RTCOutboundRtpStreamStats::getRidOr(const String& fallback_value) const {
  if (!hasRid()) {
  return fallback_value;
}
return member_rid_;
}

String RTCOutboundRtpStreamStats::getRidOr(String&& fallback_value) const {
  if (!hasRid()) {
  return std::move(fallback_value);
}
return member_rid_;
}

void RTCOutboundRtpStreamStats::setRid(const String& value) {
  member_rid_ = value;
has_rid_ = true;
}

void RTCOutboundRtpStreamStats::setRid(String&& value) {
  member_rid_ = std::move(value);
has_rid_ = true;
}











String RTCOutboundRtpStreamStats::getScalabilityModeOr(const String& fallback_value) const {
  if (!hasScalabilityMode()) {
  return fallback_value;
}
return member_scalability_mode_;
}

String RTCOutboundRtpStreamStats::getScalabilityModeOr(String&& fallback_value) const {
  if (!hasScalabilityMode()) {
  return std::move(fallback_value);
}
return member_scalability_mode_;
}

void RTCOutboundRtpStreamStats::setScalabilityMode(const String& value) {
  member_scalability_mode_ = value;
has_scalability_mode_ = true;
}

void RTCOutboundRtpStreamStats::setScalabilityMode(String&& value) {
  member_scalability_mode_ = std::move(value);
has_scalability_mode_ = true;
}
































void RTCOutboundRtpStreamStats::Trace(Visitor* visitor) const {
  TraceIfNeeded<bool>::Trace(visitor, member_active_);
TraceIfNeeded<String>::Trace(visitor, member_content_type_);
TraceIfNeeded<String>::Trace(visitor, member_encoder_implementation_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_fir_count_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_frame_height_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_frame_width_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_frames_encoded_);
TraceIfNeeded<double>::Trace(visitor, member_frames_per_second_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_frames_sent_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_header_bytes_sent_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_huge_frames_sent_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_key_frames_encoded_);
TraceIfNeeded<String>::Trace(visitor, member_media_source_id_);
TraceIfNeeded<String>::Trace(visitor, member_mid_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_nack_count_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_pli_count_);
TraceIfNeeded<bool>::Trace(visitor, member_power_efficient_encoder_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_qp_sum_);
TraceIfNeeded<Vector<std::pair<String, double>>>::Trace(visitor, member_quality_limitation_durations_);
TraceIfNeeded<V8RTCQualityLimitationReason>::Trace(visitor, member_quality_limitation_reason_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_quality_limitation_resolution_changes_);
TraceIfNeeded<String>::Trace(visitor, member_remote_id_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_retransmitted_bytes_sent_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_retransmitted_packets_sent_);
TraceIfNeeded<String>::Trace(visitor, member_rid_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_rtx_ssrc_);
TraceIfNeeded<String>::Trace(visitor, member_scalability_mode_);
TraceIfNeeded<double>::Trace(visitor, member_target_bitrate_);
TraceIfNeeded<double>::Trace(visitor, member_total_encode_time_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_total_encoded_bytes_target_);
TraceIfNeeded<double>::Trace(visitor, member_total_packet_send_delay_);
RTCSentRtpStreamStats::Trace(visitor);
}

bool RTCOutboundRtpStreamStats::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!RTCSentRtpStreamStats::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasActive()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_active_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasContentType()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_content_type_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasEncoderImplementation()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_encoder_implementation_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasFirCount()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_fir_count_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasFrameHeight()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_frame_height_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasFrameWidth()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_frame_width_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
if (hasFramesEncoded()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_frames_encoded_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[6].Get(isolate), v8_value).ToChecked();
}
if (hasFramesPerSecond()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_frames_per_second_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[7].Get(isolate), v8_value).ToChecked();
}
if (hasFramesSent()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_frames_sent_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[8].Get(isolate), v8_value).ToChecked();
}
if (hasHeaderBytesSent()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_header_bytes_sent_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[9].Get(isolate), v8_value).ToChecked();
}
if (hasHugeFramesSent()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_huge_frames_sent_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[10].Get(isolate), v8_value).ToChecked();
}
if (hasKeyFramesEncoded()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_key_frames_encoded_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[11].Get(isolate), v8_value).ToChecked();
}
if (hasMediaSourceId()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_media_source_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[12].Get(isolate), v8_value).ToChecked();
}
if (hasMid()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_mid_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[13].Get(isolate), v8_value).ToChecked();
}
if (hasNackCount()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_nack_count_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[14].Get(isolate), v8_value).ToChecked();
}
if (hasPliCount()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_pli_count_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[15].Get(isolate), v8_value).ToChecked();
}
if (hasPowerEfficientEncoder()) {
  v8_value = ToV8Traits<IDLBoolean>::ToV8(script_state, member_power_efficient_encoder_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[16].Get(isolate), v8_value).ToChecked();
}
if (hasQpSum()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_qp_sum_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[17].Get(isolate), v8_value).ToChecked();
}
if (hasQualityLimitationDurations()) {
  v8_value = ToV8Traits<IDLRecord<IDLString, IDLDouble>>::ToV8(script_state, member_quality_limitation_durations_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[18].Get(isolate), v8_value).ToChecked();
}
if (hasQualityLimitationReason()) {
  v8_value = ToV8Traits<V8RTCQualityLimitationReason>::ToV8(script_state, member_quality_limitation_reason_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[19].Get(isolate), v8_value).ToChecked();
}
if (hasQualityLimitationResolutionChanges()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_quality_limitation_resolution_changes_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[20].Get(isolate), v8_value).ToChecked();
}
if (hasRemoteId()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_remote_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[21].Get(isolate), v8_value).ToChecked();
}
if (hasRetransmittedBytesSent()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_retransmitted_bytes_sent_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[22].Get(isolate), v8_value).ToChecked();
}
if (hasRetransmittedPacketsSent()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_retransmitted_packets_sent_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[23].Get(isolate), v8_value).ToChecked();
}
if (hasRid()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_rid_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[24].Get(isolate), v8_value).ToChecked();
}
if (hasRtxSsrc()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_rtx_ssrc_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[25].Get(isolate), v8_value).ToChecked();
}
if (hasScalabilityMode()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_scalability_mode_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[26].Get(isolate), v8_value).ToChecked();
}
if (hasTargetBitrate()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_target_bitrate_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[27].Get(isolate), v8_value).ToChecked();
}
if (hasTotalEncodeTime()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_total_encode_time_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[28].Get(isolate), v8_value).ToChecked();
}
if (hasTotalEncodedBytesTarget()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_total_encoded_bytes_target_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[29].Get(isolate), v8_value).ToChecked();
}
if (hasTotalPacketSendDelay()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_total_packet_send_delay_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[30].Get(isolate), v8_value).ToChecked();
}
return true;
}

void RTCOutboundRtpStreamStats::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  RTCSentRtpStreamStats::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "RTCOutboundRtpStreamStats";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("active");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_active_, member_active_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("contentType");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_content_type_, member_content_type_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("encoderImplementation");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_encoder_implementation_, member_encoder_implementation_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("firCount");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_fir_count_, member_fir_count_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("frameHeight");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_frame_height_, member_frame_height_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("frameWidth");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_frame_width_, member_frame_width_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("framesEncoded");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[6].Get(isolate), has_frames_encoded_, member_frames_encoded_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("framesPerSecond");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[7].Get(isolate), has_frames_per_second_, member_frames_per_second_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("framesSent");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[8].Get(isolate), has_frames_sent_, member_frames_sent_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("headerBytesSent");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[9].Get(isolate), has_header_bytes_sent_, member_header_bytes_sent_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("hugeFramesSent");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[10].Get(isolate), has_huge_frames_sent_, member_huge_frames_sent_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("keyFramesEncoded");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[11].Get(isolate), has_key_frames_encoded_, member_key_frames_encoded_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("mediaSourceId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[12].Get(isolate), has_media_source_id_, member_media_source_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("mid");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[13].Get(isolate), has_mid_, member_mid_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("nackCount");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[14].Get(isolate), has_nack_count_, member_nack_count_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("pliCount");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[15].Get(isolate), has_pli_count_, member_pli_count_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("powerEfficientEncoder");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[16].Get(isolate), has_power_efficient_encoder_, member_power_efficient_encoder_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("qpSum");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[17].Get(isolate), has_qp_sum_, member_qp_sum_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("qualityLimitationDurations");
if (!bindings::GetDictionaryMemberFromV8Object<IDLRecord<IDLString, IDLDouble>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[18].Get(isolate), has_quality_limitation_durations_, member_quality_limitation_durations_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("qualityLimitationReason");
if (!bindings::GetDictionaryMemberFromV8Object<V8RTCQualityLimitationReason, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[19].Get(isolate), has_quality_limitation_reason_, member_quality_limitation_reason_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("qualityLimitationResolutionChanges");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[20].Get(isolate), has_quality_limitation_resolution_changes_, member_quality_limitation_resolution_changes_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("remoteId");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[21].Get(isolate), has_remote_id_, member_remote_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("retransmittedBytesSent");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[22].Get(isolate), has_retransmitted_bytes_sent_, member_retransmitted_bytes_sent_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("retransmittedPacketsSent");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[23].Get(isolate), has_retransmitted_packets_sent_, member_retransmitted_packets_sent_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("rid");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[24].Get(isolate), has_rid_, member_rid_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("rtxSsrc");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[25].Get(isolate), has_rtx_ssrc_, member_rtx_ssrc_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("scalabilityMode");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[26].Get(isolate), has_scalability_mode_, member_scalability_mode_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("targetBitrate");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[27].Get(isolate), has_target_bitrate_, member_target_bitrate_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("totalEncodeTime");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[28].Get(isolate), has_total_encode_time_, member_total_encode_time_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("totalEncodedBytesTarget");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[29].Get(isolate), has_total_encoded_bytes_target_, member_total_encoded_bytes_target_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("totalPacketSendDelay");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[30].Get(isolate), has_total_packet_send_delay_, member_total_packet_send_delay_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RTCOutboundRtpStreamStats::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"active",
"contentType",
"encoderImplementation",
"firCount",
"frameHeight",
"frameWidth",
"framesEncoded",
"framesPerSecond",
"framesSent",
"headerBytesSent",
"hugeFramesSent",
"keyFramesEncoded",
"mediaSourceId",
"mid",
"nackCount",
"pliCount",
"powerEfficientEncoder",
"qpSum",
"qualityLimitationDurations",
"qualityLimitationReason",
"qualityLimitationResolutionChanges",
"remoteId",
"retransmittedBytesSent",
"retransmittedPacketsSent",
"rid",
"rtxSsrc",
"scalabilityMode",
"targetBitrate",
"totalEncodeTime",
"totalEncodedBytesTarget",
"totalPacketSendDelay",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
