// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_remote_outbound_rtp_stream_stats.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



RTCRemoteOutboundRtpStreamStats* RTCRemoteOutboundRtpStreamStats::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RTCRemoteOutboundRtpStreamStats* dictionary = MakeGarbageCollected<RTCRemoteOutboundRtpStreamStats>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RTCRemoteOutboundRtpStreamStats";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 RTCRemoteOutboundRtpStreamStats::RTCRemoteOutboundRtpStreamStats() {
  
}

 RTCRemoteOutboundRtpStreamStats::RTCRemoteOutboundRtpStreamStats(v8::Isolate* isolate) : RTCSentRtpStreamStats(isolate) {
  
}



String RTCRemoteOutboundRtpStreamStats::getLocalIdOr(const String& fallback_value) const {
  if (!hasLocalId()) {
  return fallback_value;
}
return member_local_id_;
}

String RTCRemoteOutboundRtpStreamStats::getLocalIdOr(String&& fallback_value) const {
  if (!hasLocalId()) {
  return std::move(fallback_value);
}
return member_local_id_;
}

void RTCRemoteOutboundRtpStreamStats::setLocalId(const String& value) {
  member_local_id_ = value;
has_local_id_ = true;
}

void RTCRemoteOutboundRtpStreamStats::setLocalId(String&& value) {
  member_local_id_ = std::move(value);
has_local_id_ = true;
}







































void RTCRemoteOutboundRtpStreamStats::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_local_id_);
TraceIfNeeded<double>::Trace(visitor, member_remote_timestamp_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_reports_sent_);
TraceIfNeeded<double>::Trace(visitor, member_round_trip_time_);
TraceIfNeeded<uint64_t>::Trace(visitor, member_round_trip_time_measurements_);
TraceIfNeeded<double>::Trace(visitor, member_total_round_trip_time_);
RTCSentRtpStreamStats::Trace(visitor);
}

bool RTCRemoteOutboundRtpStreamStats::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!RTCSentRtpStreamStats::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasLocalId()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_local_id_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasRemoteTimestamp()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_remote_timestamp_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasReportsSent()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_reports_sent_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasRoundTripTime()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_round_trip_time_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasRoundTripTimeMeasurements()) {
  v8_value = ToV8Traits<IDLUnsignedLongLong>::ToV8(script_state, member_round_trip_time_measurements_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasTotalRoundTripTime()) {
  v8_value = ToV8Traits<IDLDouble>::ToV8(script_state, member_total_round_trip_time_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
return true;
}

void RTCRemoteOutboundRtpStreamStats::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  RTCSentRtpStreamStats::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "RTCRemoteOutboundRtpStreamStats";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("localId");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_local_id_, member_local_id_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("remoteTimestamp");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_remote_timestamp_, member_remote_timestamp_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("reportsSent");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_reports_sent_, member_reports_sent_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("roundTripTime");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_round_trip_time_, member_round_trip_time_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("roundTripTimeMeasurements");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLongLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_round_trip_time_measurements_, member_round_trip_time_measurements_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("totalRoundTripTime");
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_total_round_trip_time_, member_total_round_trip_time_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RTCRemoteOutboundRtpStreamStats::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"localId",
"remoteTimestamp",
"reportsSent",
"roundTripTime",
"roundTripTimeMeasurements",
"totalRoundTripTime",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
