// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_RTC_RTCP_PARAMETERS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_RTC_RTCP_PARAMETERS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT RTCRtcpParameters : public bindings::DictionaryBase {
  
  public:
static RTCRtcpParameters* Create() {
  return MakeGarbageCollected<RTCRtcpParameters>();
}
static RTCRtcpParameters* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<RTCRtcpParameters>(isolate);
}
static RTCRtcpParameters* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  RTCRtcpParameters();
explicit  RTCRtcpParameters(v8::Isolate* isolate);

bool hasCname() const {
  return has_cname_;
}
const String& cname() const {
  DCHECK(hasCname());
return member_cname_;
}
String getCnameOr(const String& fallback_value) const;
String getCnameOr(String&& fallback_value) const;
void setCname(const String& value);
void setCname(String&& value);

bool hasReducedSize() const {
  return has_reduced_size_;
}
bool reducedSize() const {
  DCHECK(hasReducedSize());
return member_reduced_size_;
}
bool getReducedSizeOr(bool fallback_value) const {
  if (!hasReducedSize()) {
  return fallback_value;
}
return member_reduced_size_;
}
void setReducedSize(bool value) {
  member_reduced_size_ = value;
has_reduced_size_ = true;
}




void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_cname_ = false;
bool has_reduced_size_ = false;

String member_cname_;
bool member_reduced_size_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_RTC_RTCP_PARAMETERS_H_
