// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_rtp_parameters.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_rtcp_parameters.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_rtp_codec_parameters.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_rtp_header_extension_parameters.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



RTCRtpParameters* RTCRtpParameters::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RTCRtpParameters* dictionary = MakeGarbageCollected<RTCRtpParameters>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RTCRtpParameters";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 RTCRtpParameters::RTCRtpParameters() {
  
}

 RTCRtpParameters::RTCRtpParameters(v8::Isolate* isolate) {
  
}



void RTCRtpParameters::setCodecs(const HeapVector<Member<RTCRtpCodecParameters>>& value) {
  member_codecs_ = value;
}

void RTCRtpParameters::setCodecs(HeapVector<Member<RTCRtpCodecParameters>>&& value) {
  member_codecs_ = std::move(value);
}




void RTCRtpParameters::setHeaderExtensions(const HeapVector<Member<RTCRtpHeaderExtensionParameters>>& value) {
  member_header_extensions_ = value;
}

void RTCRtpParameters::setHeaderExtensions(HeapVector<Member<RTCRtpHeaderExtensionParameters>>&& value) {
  member_header_extensions_ = std::move(value);
}









void RTCRtpParameters::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<Member<RTCRtpCodecParameters>>>::Trace(visitor, member_codecs_);
TraceIfNeeded<HeapVector<Member<RTCRtpHeaderExtensionParameters>>>::Trace(visitor, member_header_extensions_);
TraceIfNeeded<Member<RTCRtcpParameters>>::Trace(visitor, member_rtcp_);
bindings::DictionaryBase::Trace(visitor);
}

bool RTCRtpParameters::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasCodecs()) {
  v8_value = ToV8Traits<IDLSequence<RTCRtpCodecParameters>>::ToV8(script_state, member_codecs_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasHeaderExtensions()) {
  v8_value = ToV8Traits<IDLSequence<RTCRtpHeaderExtensionParameters>>::ToV8(script_state, member_header_extensions_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasRtcp()) {
  v8_value = ToV8Traits<RTCRtcpParameters>::ToV8(script_state, member_rtcp_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
return true;
}

void RTCRtpParameters::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "RTCRtpParameters";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("codecs");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<RTCRtpCodecParameters>, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_codecs_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("headerExtensions");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<RTCRtpHeaderExtensionParameters>, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_header_extensions_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("rtcp");
if (!bindings::GetDictionaryMemberFromV8Object<RTCRtcpParameters, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_rtcp_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RTCRtpParameters::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"codecs",
"headerExtensions",
"rtcp",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
