// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_rtp_receive_parameters.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_rtp_decoding_parameters.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



RTCRtpReceiveParameters* RTCRtpReceiveParameters::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RTCRtpReceiveParameters* dictionary = MakeGarbageCollected<RTCRtpReceiveParameters>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RTCRtpReceiveParameters";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 RTCRtpReceiveParameters::RTCRtpReceiveParameters() {
  
}

 RTCRtpReceiveParameters::RTCRtpReceiveParameters(v8::Isolate* isolate) : RTCRtpParameters(isolate) {
  
}



void RTCRtpReceiveParameters::setEncodings(const HeapVector<Member<RTCRtpDecodingParameters>>& value) {
  member_encodings_ = value;
}

void RTCRtpReceiveParameters::setEncodings(HeapVector<Member<RTCRtpDecodingParameters>>&& value) {
  member_encodings_ = std::move(value);
}




void RTCRtpReceiveParameters::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<Member<RTCRtpDecodingParameters>>>::Trace(visitor, member_encodings_);
RTCRtpParameters::Trace(visitor);
}

bool RTCRtpReceiveParameters::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  if (!RTCRtpParameters::FillV8ObjectWithMembers(script_state, v8_dictionary)) {
  return false;
}

if (hasEncodings()) {
  v8::Local<v8::Value> v8_value;
v8_value = ToV8Traits<IDLSequence<RTCRtpDecodingParameters>>::ToV8(script_state, member_encodings_);
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
return true;
}

void RTCRtpReceiveParameters::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  RTCRtpParameters::FillMembersFromV8Object(isolate, v8_dictionary, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return;
}

const char* const class_like_name = "RTCRtpReceiveParameters";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("encodings");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<RTCRtpDecodingParameters>, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_encodings_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RTCRtpReceiveParameters::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"encodings",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
