// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_RTC_SESSION_DESCRIPTION_INIT_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_RTC_SESSION_DESCRIPTION_INIT_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_sdp_type.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT RTCSessionDescriptionInit : public bindings::DictionaryBase {
  
  public:
static RTCSessionDescriptionInit* Create() {
  return MakeGarbageCollected<RTCSessionDescriptionInit>();
}
static RTCSessionDescriptionInit* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<RTCSessionDescriptionInit>(isolate);
}
static RTCSessionDescriptionInit* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  RTCSessionDescriptionInit();
explicit  RTCSessionDescriptionInit(v8::Isolate* isolate);

bool hasSdp() const {
  return true;
}
const String& sdp() const {
  return member_sdp_;
}
void setSdp(const String& value);
void setSdp(String&& value);

bool hasType() const {
  return has_type_;
}
V8RTCSdpType type() const {
  DCHECK(hasType());
return member_type_;
}
V8RTCSdpType getTypeOr(V8RTCSdpType fallback_value) const {
  if (!hasType()) {
  return fallback_value;
}
return member_type_;
}
void setType(V8RTCSdpType value) {
  member_type_ = value;
has_type_ = true;
}
void setType(V8RTCSdpType::Enum value) {
  member_type_ = V8RTCSdpType(value);
has_type_ = true;
}


// Obsolete accessor functions
void setType(const String& value) {
  member_type_ = V8RTCSdpType::Create(value).value();
has_type_ = true;
}

void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_type_ = false;

String member_sdp_{""};
V8RTCSdpType member_type_{static_cast<V8RTCSdpType::Enum>(0)};


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_RTC_SESSION_DESCRIPTION_INIT_H_
