// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_SMART_CARD_CONNECT_RESULT_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_SMART_CARD_CONNECT_RESULT_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_smart_card_protocol.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class ExceptionState;
class SmartCardConnection;

class MODULES_EXPORT SmartCardConnectResult : public bindings::DictionaryBase {
  
  public:
static SmartCardConnectResult* Create() {
  return MakeGarbageCollected<SmartCardConnectResult>();
}
static SmartCardConnectResult* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<SmartCardConnectResult>(isolate);
}
static SmartCardConnectResult* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  SmartCardConnectResult();
explicit  SmartCardConnectResult(v8::Isolate* isolate);

bool hasActiveProtocol() const {
  return has_active_protocol_;
}
V8SmartCardProtocol activeProtocol() const {
  DCHECK(hasActiveProtocol());
return member_active_protocol_;
}
V8SmartCardProtocol getActiveProtocolOr(V8SmartCardProtocol fallback_value) const {
  if (!hasActiveProtocol()) {
  return fallback_value;
}
return member_active_protocol_;
}
void setActiveProtocol(V8SmartCardProtocol value) {
  member_active_protocol_ = value;
has_active_protocol_ = true;
}
void setActiveProtocol(V8SmartCardProtocol::Enum value) {
  member_active_protocol_ = V8SmartCardProtocol(value);
has_active_protocol_ = true;
}

bool hasConnection() const {
  return true;
}
SmartCardConnection* connection() const {
  return member_connection_.Get();
}
void setConnection(SmartCardConnection* value) {
  member_connection_ = value;
DCHECK(member_connection_);
}


// Obsolete accessor functions
void setActiveProtocol(const String& value) {
  member_active_protocol_ = V8SmartCardProtocol::Create(value).value();
has_active_protocol_ = true;
}

void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_active_protocol_ = false;

V8SmartCardProtocol member_active_protocol_{static_cast<V8SmartCardProtocol::Enum>(0)};
Member<SmartCardConnection> member_connection_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_SMART_CARD_CONNECT_RESULT_H_
