// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_UNION_ABORTSIGNAL_SCHEDULERSIGNALINHERIT_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_UNION_ABORTSIGNAL_SCHEDULERSIGNALINHERIT_H_

#include "base/check_op.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_scheduler_signal_inherit.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/union_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class AbortSignal;
class ExceptionState;

class MODULES_EXPORT V8UnionAbortSignalOrSchedulerSignalInherit final : public bindings::UnionBase {
  
  public:
// The type of the content value of this IDL union.
enum class ContentType {
kAbortSignal, kSchedulerSignalInherit
};

static V8UnionAbortSignalOrSchedulerSignalInherit* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  V8UnionAbortSignalOrSchedulerSignalInherit(AbortSignal* value) : content_type_(ContentType::kAbortSignal), member_abort_signal_(value) {
  DCHECK(value);
}
explicit  V8UnionAbortSignalOrSchedulerSignalInherit(V8SchedulerSignalInherit value) : content_type_(ContentType::kSchedulerSignalInherit), member_scheduler_signal_inherit_(value) {
  
}

// Returns the type of the content value.
ContentType GetContentType() const {
  return content_type_;
}

bool IsAbortSignal() const {
  return content_type_ == ContentType::kAbortSignal;
}
AbortSignal* GetAsAbortSignal() const {
  DCHECK_EQ(content_type_, ContentType::kAbortSignal);
return member_abort_signal_.Get();
}
void Set(AbortSignal* value) {
  DCHECK(value);
Clear();
member_abort_signal_ = value;
content_type_ = ContentType::kAbortSignal;
}

bool IsSchedulerSignalInherit() const {
  return content_type_ == ContentType::kSchedulerSignalInherit;
}
V8SchedulerSignalInherit GetAsSchedulerSignalInherit() const {
  DCHECK_EQ(content_type_, ContentType::kSchedulerSignalInherit);
return member_scheduler_signal_inherit_;
}
void Set(V8SchedulerSignalInherit value) {
  Clear();
member_scheduler_signal_inherit_ = value;
content_type_ = ContentType::kSchedulerSignalInherit;
}


v8::Local<v8::Value> ToV8(ScriptState* script_state) const override;

void Trace(Visitor* visitor) const override;


  
  private:
void Clear();

static constexpr const char* UnionNameInIDL() {
  return "(AbortSignal or SchedulerSignalInherit)";
}

ContentType content_type_;

Member<AbortSignal> member_abort_signal_;
V8SchedulerSignalInherit member_scheduler_signal_inherit_{static_cast<V8SchedulerSignalInherit::Enum>(0)};


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_UNION_ABORTSIGNAL_SCHEDULERSIGNALINHERIT_H_
