// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_union_adproperties_adpropertiessequence.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_ad_properties.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"

namespace blink {



V8UnionAdPropertiesOrAdPropertiesSequence* V8UnionAdPropertiesOrAdPropertiesSequence::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  if (v8_value->IsNullOrUndefined()) {
  auto&& blink_value = AdProperties::Create(isolate);
return MakeGarbageCollected<V8UnionAdPropertiesOrAdPropertiesSequence>(blink_value);
}
if (v8_value->IsArray()) {
  auto&& blink_value = NativeValueTraits<IDLSequence<AdProperties>>::NativeValue(isolate, v8_value, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return MakeGarbageCollected<V8UnionAdPropertiesOrAdPropertiesSequence>(std::move(blink_value));
}
if (v8_value->IsObject()) {
  ScriptIterator script_iterator = ScriptIterator::FromIterable(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
if (!script_iterator.IsNull()) {
  auto&& blink_value = bindings::CreateIDLSequenceFromIterator<AdProperties>(isolate, std::move(script_iterator), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return MakeGarbageCollected<V8UnionAdPropertiesOrAdPropertiesSequence>(std::move(blink_value));
}
}
if (v8_value->IsObject()) {
  auto&& blink_value = NativeValueTraits<AdProperties>::NativeValue(isolate, v8_value, exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return MakeGarbageCollected<V8UnionAdPropertiesOrAdPropertiesSequence>(blink_value);
}
ThrowTypeErrorNotOfType(exception_state, UnionNameInIDL());
return nullptr;
}

 V8UnionAdPropertiesOrAdPropertiesSequence::V8UnionAdPropertiesOrAdPropertiesSequence(const HeapVector<Member<AdProperties>>& value) : content_type_(ContentType::kAdPropertiesSequence), member_ad_properties_sequence_(value) {
  
}

 V8UnionAdPropertiesOrAdPropertiesSequence::V8UnionAdPropertiesOrAdPropertiesSequence(HeapVector<Member<AdProperties>>&& value) : content_type_(ContentType::kAdPropertiesSequence), member_ad_properties_sequence_(std::move(value)) {
  
}







void V8UnionAdPropertiesOrAdPropertiesSequence::Set(const HeapVector<Member<AdProperties>>& value) {
  Clear();
member_ad_properties_sequence_ = value;
content_type_ = ContentType::kAdPropertiesSequence;
}

void V8UnionAdPropertiesOrAdPropertiesSequence::Set(HeapVector<Member<AdProperties>>&& value) {
  Clear();
member_ad_properties_sequence_ = std::move(value);
content_type_ = ContentType::kAdPropertiesSequence;
}


v8::Local<v8::Value> V8UnionAdPropertiesOrAdPropertiesSequence::ToV8(ScriptState* script_state) const {
  switch (content_type_) {
  case ContentType::kAdProperties: {
    return ToV8Traits<AdProperties>::ToV8(script_state, member_ad_properties_.Get());
  }
  case ContentType::kAdPropertiesSequence: {
    return ToV8Traits<IDLSequence<AdProperties>>::ToV8(script_state, member_ad_properties_sequence_);
  }
}

NOTREACHED();
return v8::Local<v8::Value>();
}

void V8UnionAdPropertiesOrAdPropertiesSequence::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<AdProperties>>::Trace(visitor, member_ad_properties_);
TraceIfNeeded<HeapVector<Member<AdProperties>>>::Trace(visitor, member_ad_properties_sequence_);
bindings::UnionBase::Trace(visitor);
}

void V8UnionAdPropertiesOrAdPropertiesSequence::Clear() {
  member_ad_properties_.Clear();
member_ad_properties_sequence_.clear();
}



}  // namespace blink
