// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_UNION_AUTHENTICATIONRESPONSEJSON_REGISTRATIONRESPONSEJSON_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_UNION_AUTHENTICATIONRESPONSEJSON_REGISTRATIONRESPONSEJSON_H_

#include "base/check_op.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/union_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class AuthenticationResponseJSON;
class ExceptionState;
class RegistrationResponseJSON;

class MODULES_EXPORT V8UnionAuthenticationResponseJSONOrRegistrationResponseJSON final : public bindings::UnionBase {
  
  public:
// The type of the content value of this IDL union.
enum class ContentType {
kAuthenticationResponseJSON, kRegistrationResponseJSON
};

static V8UnionAuthenticationResponseJSONOrRegistrationResponseJSON* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  V8UnionAuthenticationResponseJSONOrRegistrationResponseJSON(AuthenticationResponseJSON* value) : content_type_(ContentType::kAuthenticationResponseJSON), member_authentication_response_js_on_(value) {
  DCHECK(value);
}
explicit  V8UnionAuthenticationResponseJSONOrRegistrationResponseJSON(RegistrationResponseJSON* value) : content_type_(ContentType::kRegistrationResponseJSON), member_registration_response_js_on_(value) {
  DCHECK(value);
}

// Returns the type of the content value.
ContentType GetContentType() const {
  return content_type_;
}

bool IsAuthenticationResponseJSON() const {
  return content_type_ == ContentType::kAuthenticationResponseJSON;
}
AuthenticationResponseJSON* GetAsAuthenticationResponseJSON() const {
  DCHECK_EQ(content_type_, ContentType::kAuthenticationResponseJSON);
return member_authentication_response_js_on_.Get();
}
void Set(AuthenticationResponseJSON* value) {
  DCHECK(value);
Clear();
member_authentication_response_js_on_ = value;
content_type_ = ContentType::kAuthenticationResponseJSON;
}

bool IsRegistrationResponseJSON() const {
  return content_type_ == ContentType::kRegistrationResponseJSON;
}
RegistrationResponseJSON* GetAsRegistrationResponseJSON() const {
  DCHECK_EQ(content_type_, ContentType::kRegistrationResponseJSON);
return member_registration_response_js_on_.Get();
}
void Set(RegistrationResponseJSON* value) {
  DCHECK(value);
Clear();
member_registration_response_js_on_ = value;
content_type_ = ContentType::kRegistrationResponseJSON;
}


v8::Local<v8::Value> ToV8(ScriptState* script_state) const override;

void Trace(Visitor* visitor) const override;


  
  private:
void Clear();

static constexpr const char* UnionNameInIDL() {
  return "(AuthenticationResponseJSON or RegistrationResponseJSON)";
}

ContentType content_type_;

Member<AuthenticationResponseJSON> member_authentication_response_js_on_;
Member<RegistrationResponseJSON> member_registration_response_js_on_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_UNION_AUTHENTICATIONRESPONSEJSON_REGISTRATIONRESPONSEJSON_H_
