// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_UNION_DIGITALCREDENTIALFIELDREQUIREMENT_STRING_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_UNION_DIGITALCREDENTIALFIELDREQUIREMENT_STRING_H_

#include "base/check_op.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/union_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class DigitalCredentialFieldRequirement;
class ExceptionState;

class MODULES_EXPORT V8UnionDigitalCredentialFieldRequirementOrString final : public bindings::UnionBase {
  
  public:
// The type of the content value of this IDL union.
enum class ContentType {
kDigitalCredentialFieldRequirement, kString
};

static V8UnionDigitalCredentialFieldRequirementOrString* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  V8UnionDigitalCredentialFieldRequirementOrString(DigitalCredentialFieldRequirement* value) : content_type_(ContentType::kDigitalCredentialFieldRequirement), member_digital_credential_field_requirement_(value) {
  DCHECK(value);
}
explicit  V8UnionDigitalCredentialFieldRequirementOrString(const String& value);
explicit  V8UnionDigitalCredentialFieldRequirementOrString(String&& value);

// Returns the type of the content value.
ContentType GetContentType() const {
  return content_type_;
}

bool IsDigitalCredentialFieldRequirement() const {
  return content_type_ == ContentType::kDigitalCredentialFieldRequirement;
}
DigitalCredentialFieldRequirement* GetAsDigitalCredentialFieldRequirement() const {
  DCHECK_EQ(content_type_, ContentType::kDigitalCredentialFieldRequirement);
return member_digital_credential_field_requirement_.Get();
}
void Set(DigitalCredentialFieldRequirement* value) {
  DCHECK(value);
Clear();
member_digital_credential_field_requirement_ = value;
content_type_ = ContentType::kDigitalCredentialFieldRequirement;
}

bool IsString() const {
  return content_type_ == ContentType::kString;
}
const String& GetAsString() const {
  DCHECK_EQ(content_type_, ContentType::kString);
return member_string_;
}
void Set(const String& value);
void Set(String&& value);


v8::Local<v8::Value> ToV8(ScriptState* script_state) const override;

void Trace(Visitor* visitor) const override;


  
  private:
void Clear();

static constexpr const char* UnionNameInIDL() {
  return "(DOMString or DigitalCredentialFieldRequirement)";
}

ContentType content_type_;

Member<DigitalCredentialFieldRequirement> member_digital_credential_field_requirement_;
String member_string_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_UNION_DIGITALCREDENTIALFIELDREQUIREMENT_STRING_H_
