// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_web_print_job_template_attributes.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_web_printing_resolution.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



WebPrintJobTemplateAttributes* WebPrintJobTemplateAttributes::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  WebPrintJobTemplateAttributes* dictionary = MakeGarbageCollected<WebPrintJobTemplateAttributes>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "WebPrintJobTemplateAttributes";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 WebPrintJobTemplateAttributes::WebPrintJobTemplateAttributes() {
  
}

 WebPrintJobTemplateAttributes::WebPrintJobTemplateAttributes(v8::Isolate* isolate) {
  
}













































void WebPrintJobTemplateAttributes::Trace(Visitor* visitor) const {
  TraceIfNeeded<uint32_t>::Trace(visitor, member_copies_);
TraceIfNeeded<V8WebPrintingMultipleDocumentHandling>::Trace(visitor, member_multiple_document_handling_);
TraceIfNeeded<V8WebPrintColorMode>::Trace(visitor, member_print_color_mode_);
TraceIfNeeded<V8WebPrintQuality>::Trace(visitor, member_print_quality_);
TraceIfNeeded<Member<WebPrintingResolution>>::Trace(visitor, member_printer_resolution_);
TraceIfNeeded<V8WebPrintingSides>::Trace(visitor, member_sides_);
bindings::DictionaryBase::Trace(visitor);
}

bool WebPrintJobTemplateAttributes::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasCopies()) {
  v8_value = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_copies_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasMultipleDocumentHandling()) {
  v8_value = ToV8Traits<V8WebPrintingMultipleDocumentHandling>::ToV8(script_state, member_multiple_document_handling_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
if (hasPrintColorMode()) {
  v8_value = ToV8Traits<V8WebPrintColorMode>::ToV8(script_state, member_print_color_mode_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).ToChecked();
}
if (hasPrintQuality()) {
  v8_value = ToV8Traits<V8WebPrintQuality>::ToV8(script_state, member_print_quality_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).ToChecked();
}
if (hasPrinterResolution()) {
  v8_value = ToV8Traits<WebPrintingResolution>::ToV8(script_state, member_printer_resolution_.Get());
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).ToChecked();
}
if (hasSides()) {
  v8_value = ToV8Traits<V8WebPrintingSides>::ToV8(script_state, member_sides_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[5].Get(isolate), v8_value).ToChecked();
}
return true;
}

void WebPrintJobTemplateAttributes::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "WebPrintJobTemplateAttributes";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("copies");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_copies_, member_copies_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("multipleDocumentHandling");
if (!bindings::GetDictionaryMemberFromV8Object<V8WebPrintingMultipleDocumentHandling, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_multiple_document_handling_, member_multiple_document_handling_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("printColorMode");
if (!bindings::GetDictionaryMemberFromV8Object<V8WebPrintColorMode, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), has_print_color_mode_, member_print_color_mode_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("printQuality");
if (!bindings::GetDictionaryMemberFromV8Object<V8WebPrintQuality, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), has_print_quality_, member_print_quality_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("printerResolution");
if (!bindings::GetDictionaryMemberFromV8Object<WebPrintingResolution, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_printer_resolution_, member_printer_resolution_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("sides");
if (!bindings::GetDictionaryMemberFromV8Object<V8WebPrintingSides, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[5].Get(isolate), has_sides_, member_sides_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> WebPrintJobTemplateAttributes::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"copies",
"multipleDocumentHandling",
"printColorMode",
"printQuality",
"printerResolution",
"sides",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
