// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_web_transport_error_init.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



WebTransportErrorInit* WebTransportErrorInit::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  WebTransportErrorInit* dictionary = MakeGarbageCollected<WebTransportErrorInit>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "WebTransportErrorInit";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 WebTransportErrorInit::WebTransportErrorInit() {
  
}

 WebTransportErrorInit::WebTransportErrorInit(v8::Isolate* isolate) {
  
}



String WebTransportErrorInit::getMessageOr(const String& fallback_value) const {
  if (!hasMessage()) {
  return fallback_value;
}
return member_message_;
}

String WebTransportErrorInit::getMessageOr(String&& fallback_value) const {
  if (!hasMessage()) {
  return std::move(fallback_value);
}
return member_message_;
}

void WebTransportErrorInit::setMessage(const String& value) {
  member_message_ = value;
has_message_ = true;
}

void WebTransportErrorInit::setMessage(String&& value) {
  member_message_ = std::move(value);
has_message_ = true;
}











void WebTransportErrorInit::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_message_);
TraceIfNeeded<uint8_t>::Trace(visitor, member_stream_error_code_);
bindings::DictionaryBase::Trace(visitor);
}

bool WebTransportErrorInit::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (hasMessage()) {
  v8_value = ToV8Traits<IDLString>::ToV8(script_state, member_message_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
if (hasStreamErrorCode()) {
  v8_value = ToV8Traits<IDLOctetClamp>::ToV8(script_state, member_stream_error_code_);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).ToChecked();
}
return true;
}

void WebTransportErrorInit::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "WebTransportErrorInit";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("message");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_message_, member_message_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("streamErrorCode");
if (!bindings::GetDictionaryMemberFromV8Object<IDLOctetClamp, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_stream_error_code_, member_stream_error_code_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> WebTransportErrorInit::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"message",
"streamErrorCode",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
