// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_web_transport_options.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_web_transport_hash.h"
#include "third_party/blink/renderer/core/execution_context/execution_context.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



WebTransportOptions* WebTransportOptions::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  WebTransportOptions* dictionary = MakeGarbageCollected<WebTransportOptions>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "WebTransportOptions";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 WebTransportOptions::WebTransportOptions() {
  
}

 WebTransportOptions::WebTransportOptions(v8::Isolate* isolate) {
  
}



HeapVector<Member<WebTransportHash>> WebTransportOptions::getServerCertificateHashesOr(const HeapVector<Member<WebTransportHash>>& fallback_value) const {
  if (!hasServerCertificateHashes()) {
  return fallback_value;
}
return member_server_certificate_hashes_;
}

HeapVector<Member<WebTransportHash>> WebTransportOptions::getServerCertificateHashesOr(HeapVector<Member<WebTransportHash>>&& fallback_value) const {
  if (!hasServerCertificateHashes()) {
  return std::move(fallback_value);
}
return member_server_certificate_hashes_;
}

void WebTransportOptions::setServerCertificateHashes(const HeapVector<Member<WebTransportHash>>& value) {
  member_server_certificate_hashes_ = value;
has_server_certificate_hashes_ = true;
}

void WebTransportOptions::setServerCertificateHashes(HeapVector<Member<WebTransportHash>>&& value) {
  member_server_certificate_hashes_ = std::move(value);
has_server_certificate_hashes_ = true;
}




void WebTransportOptions::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<Member<WebTransportHash>>>::Trace(visitor, member_server_certificate_hashes_);
bindings::DictionaryBase::Trace(visitor);
}

bool WebTransportOptions::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
ExecutionContext* execution_context = ExecutionContext::From(current_context);
if (RuntimeEnabledFeatures::WebTransportCustomCertificatesEnabled(execution_context)) {
  if (hasServerCertificateHashes()) {
  v8::Local<v8::Value> v8_value;
v8_value = ToV8Traits<IDLSequence<WebTransportHash>>::ToV8(script_state, member_server_certificate_hashes_);
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).ToChecked();
}
}
return true;
}

void WebTransportOptions::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
ExecutionContext* execution_context = ExecutionContext::From(current_context);
if (RuntimeEnabledFeatures::WebTransportCustomCertificatesEnabled(execution_context)) {
  const char* const class_like_name = "WebTransportOptions";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContextType::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("serverCertificateHashes");
constexpr bool is_optional = false;
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<WebTransportHash>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_server_certificate_hashes_, member_server_certificate_hashes_, try_block, exception_state)) {
  return;
}
}
}

const base::span<const v8::Eternal<v8::Name>> WebTransportOptions::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"serverCertificateHashes",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
