// Copyright 2014 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   templates/make_names.h.tmpl
// and input files:
//   ../../third_party/blink/renderer/core/css/media_feature_names.json5


#ifndef THIRD_PARTY_BLINK_RENDERER_CORE_CSS_MEDIA_FEATURE_NAMES_H_
#define THIRD_PARTY_BLINK_RENDERER_CORE_CSS_MEDIA_FEATURE_NAMES_H_

#include "third_party/blink/renderer/platform/wtf/text/atomic_string.h"
#include "third_party/blink/renderer/core/core_export.h"

namespace blink {
namespace media_feature_names {

CORE_EXPORT extern const WTF::AtomicString& kAnyHoverMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kAnyPointerMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kAspectRatioMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kBlockSizeMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kColorMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kColorGamutMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kColorIndexMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kDeviceAspectRatioMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kDeviceHeightMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kDevicePostureMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kDeviceWidthMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kDisplayModeMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kDisplayStateMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kDynamicRangeMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kForcedColorsMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kGridMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kHeightMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kHorizontalViewportSegmentsMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kHoverMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kInlineSizeMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kInvertedColorsMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMaxAspectRatioMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMaxBlockSizeMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMaxColorMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMaxColorIndexMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMaxDeviceAspectRatioMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMaxDeviceHeightMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMaxDeviceWidthMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMaxHeightMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMaxInlineSizeMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMaxMonochromeMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMaxResolutionMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMaxWidthMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMinAspectRatioMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMinBlockSizeMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMinColorMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMinColorIndexMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMinDeviceAspectRatioMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMinDeviceHeightMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMinDeviceWidthMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMinHeightMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMinInlineSizeMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMinMonochromeMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMinResolutionMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMinWidthMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMonochromeMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kNavigationControlsMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kOrientationMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kOriginTrialTestMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kOverflowBlockMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kOverflowInlineMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kPointerMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kPrefersColorSchemeMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kPrefersContrastMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kPrefersReducedDataMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kPrefersReducedMotionMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kPrefersReducedTransparencyMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kResizableMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kResolutionMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kScanMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kScriptingMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kSnappedMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kStuckMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kUpdateMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kVerticalViewportSegmentsMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kVideoDynamicRangeMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kDevicePixelRatioMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMaxDevicePixelRatioMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kMinDevicePixelRatioMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kTransform3dMediaFeature;
CORE_EXPORT extern const WTF::AtomicString& kWidthMediaFeature;

constexpr unsigned kNamesCount = 71;

CORE_EXPORT void Init();

}  // namespace media_feature_names
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_CORE_CSS_MEDIA_FEATURE_NAMES_H_
