// Copyright 2014 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   templates/make_names.h.tmpl
// and input files:
//   ../../third_party/blink/renderer/core/html/keywords.json5


#ifndef THIRD_PARTY_BLINK_RENDERER_CORE_KEYWORDS_H_
#define THIRD_PARTY_BLINK_RENDERER_CORE_KEYWORDS_H_

#include "third_party/blink/renderer/platform/wtf/text/atomic_string.h"
#include "third_party/blink/renderer/core/core_export.h"

namespace blink {
namespace keywords {

CORE_EXPORT extern const WTF::AtomicString& kAnonymous;
CORE_EXPORT extern const WTF::AtomicString& kAsync;
CORE_EXPORT extern const WTF::AtomicString& kAuto;
CORE_EXPORT extern const WTF::AtomicString& kCircle;
CORE_EXPORT extern const WTF::AtomicString& kClose;
CORE_EXPORT extern const WTF::AtomicString& kClosed;
CORE_EXPORT extern const WTF::AtomicString& kCol;
CORE_EXPORT extern const WTF::AtomicString& kColgroup;
CORE_EXPORT extern const WTF::AtomicString& kDecimal;
CORE_EXPORT extern const WTF::AtomicString& kDisc;
CORE_EXPORT extern const WTF::AtomicString& kDisclosureClosed;
CORE_EXPORT extern const WTF::AtomicString& kDisclosureOpen;
CORE_EXPORT extern const WTF::AtomicString& kDone;
CORE_EXPORT extern const WTF::AtomicString& kEager;
CORE_EXPORT extern const WTF::AtomicString& kEmail;
CORE_EXPORT extern const WTF::AtomicString& kEnter;
CORE_EXPORT extern const WTF::AtomicString& kExitFullscreen;
CORE_EXPORT extern const WTF::AtomicString& kFalse;
CORE_EXPORT extern const WTF::AtomicString& kFetch;
CORE_EXPORT extern const WTF::AtomicString& kFont;
CORE_EXPORT extern const WTF::AtomicString& kGo;
CORE_EXPORT extern const WTF::AtomicString& kHidden;
CORE_EXPORT extern const WTF::AtomicString& kHide;
CORE_EXPORT extern const WTF::AtomicString& kHidePopover;
CORE_EXPORT extern const WTF::AtomicString& kHigh;
CORE_EXPORT extern const WTF::AtomicString& kHint;
CORE_EXPORT extern const WTF::AtomicString& kHover;
CORE_EXPORT extern const WTF::AtomicString& kImage;
CORE_EXPORT extern const WTF::AtomicString& kInherit;
CORE_EXPORT extern const WTF::AtomicString& kInvisible;
CORE_EXPORT extern const WTF::AtomicString& kLazy;
CORE_EXPORT extern const WTF::AtomicString& kLow;
CORE_EXPORT extern const WTF::AtomicString& kLowerAlpha;
CORE_EXPORT extern const WTF::AtomicString& kLowerRoman;
CORE_EXPORT extern const WTF::AtomicString& kManual;
CORE_EXPORT extern const WTF::AtomicString& kNext;
CORE_EXPORT extern const WTF::AtomicString& kNoReferrer;
CORE_EXPORT extern const WTF::AtomicString& kNoReferrerWhenDowngrade;
CORE_EXPORT extern const WTF::AtomicString& kNodownload;
CORE_EXPORT extern const WTF::AtomicString& kNofullscreen;
CORE_EXPORT extern const WTF::AtomicString& kNone;
CORE_EXPORT extern const WTF::AtomicString& kNoplaybackrate;
CORE_EXPORT extern const WTF::AtomicString& kNoremoteplayback;
CORE_EXPORT extern const WTF::AtomicString& kNumeric;
CORE_EXPORT extern const WTF::AtomicString& kOff;
CORE_EXPORT extern const WTF::AtomicString& kOn;
CORE_EXPORT extern const WTF::AtomicString& kOpen;
CORE_EXPORT extern const WTF::AtomicString& kOrigin;
CORE_EXPORT extern const WTF::AtomicString& kOriginWhenCrossOrigin;
CORE_EXPORT extern const WTF::AtomicString& kPause;
CORE_EXPORT extern const WTF::AtomicString& kPlaintextOnly;
CORE_EXPORT extern const WTF::AtomicString& kPlay;
CORE_EXPORT extern const WTF::AtomicString& kPlaypause;
CORE_EXPORT extern const WTF::AtomicString& kPrevious;
CORE_EXPORT extern const WTF::AtomicString& kRender;
CORE_EXPORT extern const WTF::AtomicString& kRequestFullscreen;
CORE_EXPORT extern const WTF::AtomicString& kRow;
CORE_EXPORT extern const WTF::AtomicString& kRowgroup;
CORE_EXPORT extern const WTF::AtomicString& kSameOrigin;
CORE_EXPORT extern const WTF::AtomicString& kScript;
CORE_EXPORT extern const WTF::AtomicString& kSearch;
CORE_EXPORT extern const WTF::AtomicString& kSend;
CORE_EXPORT extern const WTF::AtomicString& kShow;
CORE_EXPORT extern const WTF::AtomicString& kShowPicker;
CORE_EXPORT extern const WTF::AtomicString& kShowPopover;
CORE_EXPORT extern const WTF::AtomicString& kSquare;
CORE_EXPORT extern const WTF::AtomicString& kStatic;
CORE_EXPORT extern const WTF::AtomicString& kStrictOrigin;
CORE_EXPORT extern const WTF::AtomicString& kStrictOriginWhenCrossOrigin;
CORE_EXPORT extern const WTF::AtomicString& kStyle;
CORE_EXPORT extern const WTF::AtomicString& kSync;
CORE_EXPORT extern const WTF::AtomicString& kTel;
CORE_EXPORT extern const WTF::AtomicString& kText;
CORE_EXPORT extern const WTF::AtomicString& kToggle;
CORE_EXPORT extern const WTF::AtomicString& kToggleFullscreen;
CORE_EXPORT extern const WTF::AtomicString& kToggleMuted;
CORE_EXPORT extern const WTF::AtomicString& kTogglePopover;
CORE_EXPORT extern const WTF::AtomicString& kTrack;
CORE_EXPORT extern const WTF::AtomicString& kTrue;
CORE_EXPORT extern const WTF::AtomicString& kUnsafeUrl;
CORE_EXPORT extern const WTF::AtomicString& kUpperAlpha;
CORE_EXPORT extern const WTF::AtomicString& kUpperRoman;
CORE_EXPORT extern const WTF::AtomicString& kUrl;
CORE_EXPORT extern const WTF::AtomicString& kUseCredentials;
CORE_EXPORT extern const WTF::AtomicString& kVisible;

constexpr unsigned kNamesCount = 85;

CORE_EXPORT void Init();

}  // namespace keywords
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_CORE_KEYWORDS_H_
