// ui/ozone/platform/wayland/mojom/wayland_buffer_manager.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_OZONE_PLATFORM_WAYLAND_MOJOM_WAYLAND_BUFFER_MANAGER_MOJOM_H_
#define UI_OZONE_PLATFORM_WAYLAND_MOJOM_WAYLAND_BUFFER_MANAGER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include <optional>
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "ui/ozone/platform/wayland/mojom/wayland_buffer_manager.mojom-features.h"
#include "ui/ozone/platform/wayland/mojom/wayland_buffer_manager.mojom-shared.h"
#include "ui/ozone/platform/wayland/mojom/wayland_buffer_manager.mojom-forward.h"
#include "skia/public/mojom/skcolor4f.mojom.h"
#include "mojo/public/mojom/base/version.mojom.h"
#include "ui/gfx/geometry/mojom/geometry.mojom.h"
#include "ui/gfx/mojom/accelerated_widget.mojom.h"
#include "ui/gfx/mojom/buffer_types.mojom.h"
#include "ui/gfx/mojom/gpu_fence_handle.mojom.h"
#include "ui/gfx/mojom/swap_result.mojom.h"
#include "ui/gfx/mojom/frame_data.mojom.h"
#include "ui/ozone/platform/wayland/mojom/wayland_overlay_config.mojom.h"
#include "ui/ozone/platform/wayland/mojom/wayland_presentation_info.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"






namespace ui::ozone::mojom {

class WaylandBufferManagerHostProxy;

template <typename ImplRefTraits>
class WaylandBufferManagerHostStub;

class WaylandBufferManagerHostRequestValidator;


class WaylandBufferManagerHost
    : public WaylandBufferManagerHostInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = true;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = WaylandBufferManagerHostInterfaceBase;
  using Proxy_ = WaylandBufferManagerHostProxy;

  template <typename ImplRefTraits>
  using Stub_ = WaylandBufferManagerHostStub<ImplRefTraits>;

  using RequestValidator_ = WaylandBufferManagerHostRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kSetWaylandBufferManagerGpuMinVersion = 0,
    kCreateDmabufBasedBufferMinVersion = 0,
    kCreateShmBasedBufferMinVersion = 0,
    kCreateSolidColorBufferMinVersion = 0,
    kCreateSinglePixelBufferMinVersion = 0,
    kDestroyBufferMinVersion = 0,
    kCommitOverlaysMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct SetWaylandBufferManagerGpu_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct CreateDmabufBasedBuffer_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct CreateShmBasedBuffer_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct CreateSolidColorBuffer_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct CreateSinglePixelBuffer_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct DestroyBuffer_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct CommitOverlays_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~WaylandBufferManagerHost() = default;

  
  virtual void SetWaylandBufferManagerGpu(::mojo::PendingAssociatedRemote<WaylandBufferManagerGpu> buffer_manager_gpu_associated) = 0;

  
  virtual void CreateDmabufBasedBuffer(::mojo::PlatformHandle dmabuf_fd, const ::gfx::Size& size, const std::vector<uint32_t>& strides, const std::vector<uint32_t>& offsets, const std::vector<uint64_t>& modifiers, uint32_t format, uint32_t planes_count, uint32_t buffer_id) = 0;

  
  virtual void CreateShmBasedBuffer(::mojo::PlatformHandle shm_fd, uint64_t length, const ::gfx::Size& size, uint32_t buffer_id) = 0;

  
  virtual void CreateSolidColorBuffer(const ::gfx::Size& size, const ::SkColor4f& color, uint32_t buffer_id) = 0;

  
  virtual void CreateSinglePixelBuffer(const ::SkColor4f& color, uint32_t buffer_id) = 0;

  
  virtual void DestroyBuffer(uint32_t buffer_id) = 0;

  
  virtual void CommitOverlays(::gfx::AcceleratedWidget widget, uint32_t frame_id, const ::gfx::FrameData& data, std::vector<::wl::WaylandOverlayConfig> overlays) = 0;
};

class WaylandBufferManagerGpuProxy;

template <typename ImplRefTraits>
class WaylandBufferManagerGpuStub;

class WaylandBufferManagerGpuRequestValidator;


class WaylandBufferManagerGpu
    : public WaylandBufferManagerGpuInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = WaylandBufferManagerGpuInterfaceBase;
  using Proxy_ = WaylandBufferManagerGpuProxy;

  template <typename ImplRefTraits>
  using Stub_ = WaylandBufferManagerGpuStub<ImplRefTraits>;

  using RequestValidator_ = WaylandBufferManagerGpuRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kInitializeMinVersion = 0,
    kOnSubmissionMinVersion = 0,
    kOnPresentationMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct Initialize_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct OnSubmission_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct OnPresentation_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~WaylandBufferManagerGpu() = default;

  
  virtual void Initialize(::mojo::PendingRemote<WaylandBufferManagerHost> remote_host, const base::flat_map<::gfx::BufferFormat, std::vector<uint64_t>>& buffer_formats_with_modifiers, bool supports_dma_buf, bool supports_viewporter, bool supports_acquire_fence, bool supports_overlays, uint32_t supported_surface_augmentor_version, bool supports_single_pixel_buffer, const ::base::Version& server_version) = 0;

  
  virtual void OnSubmission(::gfx::AcceleratedWidget widget, uint32_t frame_id, ::gfx::SwapResult swap_result, ::gfx::GpuFenceHandle release_fence_handle, const std::vector<::wl::WaylandPresentationInfo>& presentation_infos) = 0;

  
  virtual void OnPresentation(::gfx::AcceleratedWidget widget, const std::vector<::wl::WaylandPresentationInfo>& presentation_infos) = 0;
};



class  WaylandBufferManagerHostProxy
    : public WaylandBufferManagerHost {
 public:
  using InterfaceType = WaylandBufferManagerHost;

  explicit WaylandBufferManagerHostProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void SetWaylandBufferManagerGpu(::mojo::PendingAssociatedRemote<WaylandBufferManagerGpu> buffer_manager_gpu_associated) final;
  
  void CreateDmabufBasedBuffer(::mojo::PlatformHandle dmabuf_fd, const ::gfx::Size& size, const std::vector<uint32_t>& strides, const std::vector<uint32_t>& offsets, const std::vector<uint64_t>& modifiers, uint32_t format, uint32_t planes_count, uint32_t buffer_id) final;
  
  void CreateShmBasedBuffer(::mojo::PlatformHandle shm_fd, uint64_t length, const ::gfx::Size& size, uint32_t buffer_id) final;
  
  void CreateSolidColorBuffer(const ::gfx::Size& size, const ::SkColor4f& color, uint32_t buffer_id) final;
  
  void CreateSinglePixelBuffer(const ::SkColor4f& color, uint32_t buffer_id) final;
  
  void DestroyBuffer(uint32_t buffer_id) final;
  
  void CommitOverlays(::gfx::AcceleratedWidget widget, uint32_t frame_id, const ::gfx::FrameData& data, std::vector<::wl::WaylandOverlayConfig> overlays) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  WaylandBufferManagerGpuProxy
    : public WaylandBufferManagerGpu {
 public:
  using InterfaceType = WaylandBufferManagerGpu;

  explicit WaylandBufferManagerGpuProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Initialize(::mojo::PendingRemote<WaylandBufferManagerHost> remote_host, const base::flat_map<::gfx::BufferFormat, std::vector<uint64_t>>& buffer_formats_with_modifiers, bool supports_dma_buf, bool supports_viewporter, bool supports_acquire_fence, bool supports_overlays, uint32_t supported_surface_augmentor_version, bool supports_single_pixel_buffer, const ::base::Version& server_version) final;
  
  void OnSubmission(::gfx::AcceleratedWidget widget, uint32_t frame_id, ::gfx::SwapResult swap_result, ::gfx::GpuFenceHandle release_fence_handle, const std::vector<::wl::WaylandPresentationInfo>& presentation_infos) final;
  
  void OnPresentation(::gfx::AcceleratedWidget widget, const std::vector<::wl::WaylandPresentationInfo>& presentation_infos) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  WaylandBufferManagerHostStubDispatch {
 public:
  static bool Accept(WaylandBufferManagerHost* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      WaylandBufferManagerHost* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<WaylandBufferManagerHost>>
class WaylandBufferManagerHostStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  WaylandBufferManagerHostStub() = default;
  ~WaylandBufferManagerHostStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WaylandBufferManagerHostStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WaylandBufferManagerHostStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  WaylandBufferManagerGpuStubDispatch {
 public:
  static bool Accept(WaylandBufferManagerGpu* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      WaylandBufferManagerGpu* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<WaylandBufferManagerGpu>>
class WaylandBufferManagerGpuStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  WaylandBufferManagerGpuStub() = default;
  ~WaylandBufferManagerGpuStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WaylandBufferManagerGpuStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WaylandBufferManagerGpuStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  WaylandBufferManagerHostRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  WaylandBufferManagerGpuRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // ui::ozone::mojom

namespace mojo {

}  // namespace mojo

#endif  // UI_OZONE_PLATFORM_WAYLAND_MOJOM_WAYLAND_BUFFER_MANAGER_MOJOM_H_