// services/webnn/public/mojom/webnn_graph.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_GRAPH_MOJOM_BLINK_H_
#define SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_GRAPH_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include <optional>
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/webnn/public/mojom/webnn_graph.mojom-features.h"
#include "services/webnn/public/mojom/webnn_graph.mojom-shared.h"
#include "services/webnn/public/mojom/webnn_graph.mojom-blink-forward.h"
#include "mojo/public/mojom/base/big_buffer.mojom-blink.h"
#include "services/webnn/public/mojom/webnn_error.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"






namespace webnn::mojom::blink {

class WebNNGraphProxy;

template <typename ImplRefTraits>
class WebNNGraphStub;

class WebNNGraphRequestValidator;
class WebNNGraphResponseValidator;


class WebNNGraph
    : public WebNNGraphInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static inline constexpr uint32_t kSyncMethodOrdinals[] = {
    633434152
  };
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = WebNNGraphInterfaceBase;
  using Proxy_ = WebNNGraphProxy;

  template <typename ImplRefTraits>
  using Stub_ = WebNNGraphStub<ImplRefTraits>;

  using RequestValidator_ = WebNNGraphRequestValidator;
  using ResponseValidator_ = WebNNGraphResponseValidator;
  enum MethodMinVersions : uint32_t {
    kComputeMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct Compute_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~WebNNGraph() = default;

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  
  virtual bool Compute(WTF::HashMap<WTF::String, ::mojo_base::BigBuffer> named_inputs, ComputeResultPtr* out_result);

  using ComputeCallback = base::OnceCallback<void(ComputeResultPtr)>;
  
  virtual void Compute(WTF::HashMap<WTF::String, ::mojo_base::BigBuffer> named_inputs, ComputeCallback callback) = 0;
};



class  WebNNGraphProxy
    : public WebNNGraph {
 public:
  using InterfaceType = WebNNGraph;

  explicit WebNNGraphProxy(mojo::MessageReceiverWithResponder* receiver);
  
  bool Compute(WTF::HashMap<WTF::String, ::mojo_base::BigBuffer> named_inputs, ComputeResultPtr* out_result) final;
  
  void Compute(WTF::HashMap<WTF::String, ::mojo_base::BigBuffer> named_inputs, ComputeCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  WebNNGraphStubDispatch {
 public:
  static bool Accept(WebNNGraph* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      WebNNGraph* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<WebNNGraph>>
class WebNNGraphStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  WebNNGraphStub() = default;
  ~WebNNGraphStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebNNGraphStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebNNGraphStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  WebNNGraphRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  WebNNGraphResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};








class  Clamp {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Clamp, T>::value>;
  using DataView = ClampDataView;
  using Data_ = internal::Clamp_Data;

  template <typename... Args>
  static ClampPtr New(Args&&... args) {
    return ClampPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ClampPtr From(const U& u) {
    return mojo::TypeConverter<ClampPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Clamp>::Convert(*this);
  }


  Clamp();

  Clamp(
      uint64_t input_operand_id,
      uint64_t output_operand_id,
      float min_value,
      float max_value);


  ~Clamp();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ClampPtr>
  ClampPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Clamp::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Clamp::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Clamp::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Clamp::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Clamp::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Clamp_UnserializedMessageContext<
            UserType, Clamp::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Clamp::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Clamp::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Clamp_UnserializedMessageContext<
            UserType, Clamp::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Clamp::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t input_operand_id;
  
  uint64_t output_operand_id;
  
  float min_value;
  
  float max_value;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Clamp::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Clamp::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Clamp::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Clamp::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  Size2d {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Size2d, T>::value>;
  using DataView = Size2dDataView;
  using Data_ = internal::Size2d_Data;

  template <typename... Args>
  static Size2dPtr New(Args&&... args) {
    return Size2dPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static Size2dPtr From(const U& u) {
    return mojo::TypeConverter<Size2dPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Size2d>::Convert(*this);
  }


  Size2d();

  Size2d(
      uint32_t height,
      uint32_t width);


  ~Size2d();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = Size2dPtr>
  Size2dPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Size2d::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Size2d::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Size2d::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Size2d::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Size2d::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Size2d_UnserializedMessageContext<
            UserType, Size2d::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Size2d::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Size2d::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Size2d_UnserializedMessageContext<
            UserType, Size2d::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Size2d::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint32_t height;
  
  uint32_t width;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Size2d::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Size2d::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Size2d::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Size2d::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}







class  ElementWiseBinary {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ElementWiseBinary, T>::value>;
  using DataView = ElementWiseBinaryDataView;
  using Data_ = internal::ElementWiseBinary_Data;
  using Kind = ElementWiseBinary_Kind;

  template <typename... Args>
  static ElementWiseBinaryPtr New(Args&&... args) {
    return ElementWiseBinaryPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ElementWiseBinaryPtr From(const U& u) {
    return mojo::TypeConverter<ElementWiseBinaryPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ElementWiseBinary>::Convert(*this);
  }


  ElementWiseBinary();

  ElementWiseBinary(
      ElementWiseBinary::Kind kind,
      uint64_t lhs_operand,
      uint64_t rhs_operand,
      uint64_t output_operand);


  ~ElementWiseBinary();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ElementWiseBinaryPtr>
  ElementWiseBinaryPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ElementWiseBinary::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ElementWiseBinary::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, ElementWiseBinary::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ElementWiseBinary::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ElementWiseBinary::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ElementWiseBinary_UnserializedMessageContext<
            UserType, ElementWiseBinary::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ElementWiseBinary::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return ElementWiseBinary::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ElementWiseBinary_UnserializedMessageContext<
            UserType, ElementWiseBinary::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ElementWiseBinary::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ElementWiseBinary::Kind kind;
  
  uint64_t lhs_operand;
  
  uint64_t rhs_operand;
  
  uint64_t output_operand;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ElementWiseBinary::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ElementWiseBinary::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ElementWiseBinary::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ElementWiseBinary::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  ElementWiseUnary {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ElementWiseUnary, T>::value>;
  using DataView = ElementWiseUnaryDataView;
  using Data_ = internal::ElementWiseUnary_Data;
  using Kind = ElementWiseUnary_Kind;

  template <typename... Args>
  static ElementWiseUnaryPtr New(Args&&... args) {
    return ElementWiseUnaryPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ElementWiseUnaryPtr From(const U& u) {
    return mojo::TypeConverter<ElementWiseUnaryPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ElementWiseUnary>::Convert(*this);
  }


  ElementWiseUnary();

  ElementWiseUnary(
      ElementWiseUnary::Kind kind,
      uint64_t input_operand_id,
      uint64_t output_operand_id);


  ~ElementWiseUnary();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ElementWiseUnaryPtr>
  ElementWiseUnaryPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ElementWiseUnary::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ElementWiseUnary::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, ElementWiseUnary::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ElementWiseUnary::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ElementWiseUnary::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ElementWiseUnary_UnserializedMessageContext<
            UserType, ElementWiseUnary::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ElementWiseUnary::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return ElementWiseUnary::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ElementWiseUnary_UnserializedMessageContext<
            UserType, ElementWiseUnary::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ElementWiseUnary::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ElementWiseUnary::Kind kind;
  
  uint64_t input_operand_id;
  
  uint64_t output_operand_id;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ElementWiseUnary::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ElementWiseUnary::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ElementWiseUnary::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ElementWiseUnary::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  Expand {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Expand, T>::value>;
  using DataView = ExpandDataView;
  using Data_ = internal::Expand_Data;

  template <typename... Args>
  static ExpandPtr New(Args&&... args) {
    return ExpandPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ExpandPtr From(const U& u) {
    return mojo::TypeConverter<ExpandPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Expand>::Convert(*this);
  }


  Expand();

  Expand(
      uint64_t input_operand_id,
      uint64_t output_operand_id);


  ~Expand();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ExpandPtr>
  ExpandPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Expand::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Expand::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Expand::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Expand::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Expand::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Expand_UnserializedMessageContext<
            UserType, Expand::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Expand::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Expand::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Expand_UnserializedMessageContext<
            UserType, Expand::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Expand::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t input_operand_id;
  
  uint64_t output_operand_id;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Expand::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Expand::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Expand::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Expand::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  ConstantPadding {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ConstantPadding, T>::value>;
  using DataView = ConstantPaddingDataView;
  using Data_ = internal::ConstantPadding_Data;

  template <typename... Args>
  static ConstantPaddingPtr New(Args&&... args) {
    return ConstantPaddingPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ConstantPaddingPtr From(const U& u) {
    return mojo::TypeConverter<ConstantPaddingPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ConstantPadding>::Convert(*this);
  }


  ConstantPadding();

  explicit ConstantPadding(
      float value);


  ~ConstantPadding();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ConstantPaddingPtr>
  ConstantPaddingPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ConstantPadding::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ConstantPadding::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, ConstantPadding::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ConstantPadding::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ConstantPadding::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ConstantPadding_UnserializedMessageContext<
            UserType, ConstantPadding::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ConstantPadding::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return ConstantPadding::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ConstantPadding_UnserializedMessageContext<
            UserType, ConstantPadding::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ConstantPadding::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  float value;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ConstantPadding::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ConstantPadding::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ConstantPadding::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ConstantPadding::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  EdgePadding {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<EdgePadding, T>::value>;
  using DataView = EdgePaddingDataView;
  using Data_ = internal::EdgePadding_Data;

  template <typename... Args>
  static EdgePaddingPtr New(Args&&... args) {
    return EdgePaddingPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static EdgePaddingPtr From(const U& u) {
    return mojo::TypeConverter<EdgePaddingPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, EdgePadding>::Convert(*this);
  }


  EdgePadding();


  ~EdgePadding();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = EdgePaddingPtr>
  EdgePaddingPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, EdgePadding::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, EdgePadding::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, EdgePadding::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        EdgePadding::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        EdgePadding::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::EdgePadding_UnserializedMessageContext<
            UserType, EdgePadding::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<EdgePadding::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return EdgePadding::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::EdgePadding_UnserializedMessageContext<
            UserType, EdgePadding::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<EdgePadding::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }


  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, EdgePadding::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, EdgePadding::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, EdgePadding::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, EdgePadding::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  ReflectionPadding {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ReflectionPadding, T>::value>;
  using DataView = ReflectionPaddingDataView;
  using Data_ = internal::ReflectionPadding_Data;

  template <typename... Args>
  static ReflectionPaddingPtr New(Args&&... args) {
    return ReflectionPaddingPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ReflectionPaddingPtr From(const U& u) {
    return mojo::TypeConverter<ReflectionPaddingPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ReflectionPadding>::Convert(*this);
  }


  ReflectionPadding();


  ~ReflectionPadding();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ReflectionPaddingPtr>
  ReflectionPaddingPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ReflectionPadding::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ReflectionPadding::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, ReflectionPadding::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ReflectionPadding::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ReflectionPadding::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ReflectionPadding_UnserializedMessageContext<
            UserType, ReflectionPadding::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ReflectionPadding::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return ReflectionPadding::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ReflectionPadding_UnserializedMessageContext<
            UserType, ReflectionPadding::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ReflectionPadding::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }


  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ReflectionPadding::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ReflectionPadding::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ReflectionPadding::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ReflectionPadding::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  SymmetricPadding {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<SymmetricPadding, T>::value>;
  using DataView = SymmetricPaddingDataView;
  using Data_ = internal::SymmetricPadding_Data;

  template <typename... Args>
  static SymmetricPaddingPtr New(Args&&... args) {
    return SymmetricPaddingPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static SymmetricPaddingPtr From(const U& u) {
    return mojo::TypeConverter<SymmetricPaddingPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, SymmetricPadding>::Convert(*this);
  }


  SymmetricPadding();


  ~SymmetricPadding();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = SymmetricPaddingPtr>
  SymmetricPaddingPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, SymmetricPadding::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, SymmetricPadding::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, SymmetricPadding::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        SymmetricPadding::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        SymmetricPadding::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::SymmetricPadding_UnserializedMessageContext<
            UserType, SymmetricPadding::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<SymmetricPadding::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return SymmetricPadding::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::SymmetricPadding_UnserializedMessageContext<
            UserType, SymmetricPadding::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<SymmetricPadding::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }


  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, SymmetricPadding::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, SymmetricPadding::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, SymmetricPadding::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, SymmetricPadding::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  Matmul {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Matmul, T>::value>;
  using DataView = MatmulDataView;
  using Data_ = internal::Matmul_Data;

  template <typename... Args>
  static MatmulPtr New(Args&&... args) {
    return MatmulPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static MatmulPtr From(const U& u) {
    return mojo::TypeConverter<MatmulPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Matmul>::Convert(*this);
  }


  Matmul();

  Matmul(
      uint64_t a_operand_id,
      uint64_t b_operand_id,
      uint64_t output_operand_id);


  ~Matmul();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = MatmulPtr>
  MatmulPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Matmul::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Matmul::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Matmul::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Matmul::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Matmul::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Matmul_UnserializedMessageContext<
            UserType, Matmul::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Matmul::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Matmul::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Matmul_UnserializedMessageContext<
            UserType, Matmul::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Matmul::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t a_operand_id;
  
  uint64_t b_operand_id;
  
  uint64_t output_operand_id;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Matmul::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Matmul::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Matmul::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Matmul::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}








class  StartAndSize {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<StartAndSize, T>::value>;
  using DataView = StartAndSizeDataView;
  using Data_ = internal::StartAndSize_Data;

  template <typename... Args>
  static StartAndSizePtr New(Args&&... args) {
    return StartAndSizePtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static StartAndSizePtr From(const U& u) {
    return mojo::TypeConverter<StartAndSizePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, StartAndSize>::Convert(*this);
  }


  StartAndSize();

  StartAndSize(
      uint32_t start,
      uint32_t size);


  ~StartAndSize();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = StartAndSizePtr>
  StartAndSizePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, StartAndSize::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, StartAndSize::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, StartAndSize::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        StartAndSize::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        StartAndSize::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::StartAndSize_UnserializedMessageContext<
            UserType, StartAndSize::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<StartAndSize::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return StartAndSize::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::StartAndSize_UnserializedMessageContext<
            UserType, StartAndSize::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<StartAndSize::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint32_t start;
  
  uint32_t size;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, StartAndSize::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, StartAndSize::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, StartAndSize::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, StartAndSize::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  Elu {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Elu, T>::value>;
  using DataView = EluDataView;
  using Data_ = internal::Elu_Data;

  template <typename... Args>
  static EluPtr New(Args&&... args) {
    return EluPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static EluPtr From(const U& u) {
    return mojo::TypeConverter<EluPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Elu>::Convert(*this);
  }


  Elu();

  Elu(
      uint64_t input_operand_id,
      uint64_t output_operand_id,
      float alpha);


  ~Elu();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = EluPtr>
  EluPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Elu::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Elu::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Elu::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Elu::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Elu::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Elu_UnserializedMessageContext<
            UserType, Elu::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Elu::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Elu::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Elu_UnserializedMessageContext<
            UserType, Elu::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Elu::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t input_operand_id;
  
  uint64_t output_operand_id;
  
  float alpha;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Elu::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Elu::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Elu::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Elu::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  Gather {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Gather, T>::value>;
  using DataView = GatherDataView;
  using Data_ = internal::Gather_Data;

  template <typename... Args>
  static GatherPtr New(Args&&... args) {
    return GatherPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static GatherPtr From(const U& u) {
    return mojo::TypeConverter<GatherPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Gather>::Convert(*this);
  }


  Gather();

  Gather(
      uint64_t input_operand_id,
      uint64_t indices_operand_id,
      uint64_t output_operand_id,
      uint32_t axis);


  ~Gather();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = GatherPtr>
  GatherPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Gather::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Gather::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Gather::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Gather::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Gather::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Gather_UnserializedMessageContext<
            UserType, Gather::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Gather::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Gather::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Gather_UnserializedMessageContext<
            UserType, Gather::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Gather::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t input_operand_id;
  
  uint64_t indices_operand_id;
  
  uint64_t output_operand_id;
  
  uint32_t axis;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Gather::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Gather::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Gather::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Gather::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  HardSigmoid {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<HardSigmoid, T>::value>;
  using DataView = HardSigmoidDataView;
  using Data_ = internal::HardSigmoid_Data;

  template <typename... Args>
  static HardSigmoidPtr New(Args&&... args) {
    return HardSigmoidPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static HardSigmoidPtr From(const U& u) {
    return mojo::TypeConverter<HardSigmoidPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, HardSigmoid>::Convert(*this);
  }


  HardSigmoid();

  HardSigmoid(
      uint64_t input_operand_id,
      uint64_t output_operand_id,
      float alpha,
      float beta);


  ~HardSigmoid();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = HardSigmoidPtr>
  HardSigmoidPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, HardSigmoid::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, HardSigmoid::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, HardSigmoid::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        HardSigmoid::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        HardSigmoid::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::HardSigmoid_UnserializedMessageContext<
            UserType, HardSigmoid::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<HardSigmoid::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return HardSigmoid::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::HardSigmoid_UnserializedMessageContext<
            UserType, HardSigmoid::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<HardSigmoid::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t input_operand_id;
  
  uint64_t output_operand_id;
  
  float alpha;
  
  float beta;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, HardSigmoid::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, HardSigmoid::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, HardSigmoid::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, HardSigmoid::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  LeakyRelu {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<LeakyRelu, T>::value>;
  using DataView = LeakyReluDataView;
  using Data_ = internal::LeakyRelu_Data;

  template <typename... Args>
  static LeakyReluPtr New(Args&&... args) {
    return LeakyReluPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static LeakyReluPtr From(const U& u) {
    return mojo::TypeConverter<LeakyReluPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, LeakyRelu>::Convert(*this);
  }


  LeakyRelu();

  LeakyRelu(
      uint64_t input_operand_id,
      uint64_t output_operand_id,
      float alpha);


  ~LeakyRelu();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = LeakyReluPtr>
  LeakyReluPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, LeakyRelu::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, LeakyRelu::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, LeakyRelu::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        LeakyRelu::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        LeakyRelu::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::LeakyRelu_UnserializedMessageContext<
            UserType, LeakyRelu::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<LeakyRelu::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return LeakyRelu::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::LeakyRelu_UnserializedMessageContext<
            UserType, LeakyRelu::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<LeakyRelu::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t input_operand_id;
  
  uint64_t output_operand_id;
  
  float alpha;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, LeakyRelu::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, LeakyRelu::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, LeakyRelu::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, LeakyRelu::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  Linear {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Linear, T>::value>;
  using DataView = LinearDataView;
  using Data_ = internal::Linear_Data;

  template <typename... Args>
  static LinearPtr New(Args&&... args) {
    return LinearPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static LinearPtr From(const U& u) {
    return mojo::TypeConverter<LinearPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Linear>::Convert(*this);
  }


  Linear();

  Linear(
      uint64_t input_operand_id,
      uint64_t output_operand_id,
      float alpha,
      float beta);


  ~Linear();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = LinearPtr>
  LinearPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Linear::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Linear::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Linear::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Linear::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Linear::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Linear_UnserializedMessageContext<
            UserType, Linear::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Linear::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Linear::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Linear_UnserializedMessageContext<
            UserType, Linear::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Linear::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t input_operand_id;
  
  uint64_t output_operand_id;
  
  float alpha;
  
  float beta;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Linear::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Linear::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Linear::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Linear::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  Prelu {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Prelu, T>::value>;
  using DataView = PreluDataView;
  using Data_ = internal::Prelu_Data;

  template <typename... Args>
  static PreluPtr New(Args&&... args) {
    return PreluPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static PreluPtr From(const U& u) {
    return mojo::TypeConverter<PreluPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Prelu>::Convert(*this);
  }


  Prelu();

  Prelu(
      uint64_t input_operand_id,
      uint64_t slope_operand_id,
      uint64_t output_operand_id);


  ~Prelu();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PreluPtr>
  PreluPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Prelu::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Prelu::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Prelu::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Prelu::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Prelu::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Prelu_UnserializedMessageContext<
            UserType, Prelu::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Prelu::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Prelu::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Prelu_UnserializedMessageContext<
            UserType, Prelu::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Prelu::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t input_operand_id;
  
  uint64_t slope_operand_id;
  
  uint64_t output_operand_id;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Prelu::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Prelu::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Prelu::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Prelu::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  Relu {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Relu, T>::value>;
  using DataView = ReluDataView;
  using Data_ = internal::Relu_Data;

  template <typename... Args>
  static ReluPtr New(Args&&... args) {
    return ReluPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ReluPtr From(const U& u) {
    return mojo::TypeConverter<ReluPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Relu>::Convert(*this);
  }


  Relu();

  Relu(
      uint64_t input_operand_id,
      uint64_t output_operand_id);


  ~Relu();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ReluPtr>
  ReluPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Relu::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Relu::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Relu::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Relu::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Relu::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Relu_UnserializedMessageContext<
            UserType, Relu::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Relu::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Relu::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Relu_UnserializedMessageContext<
            UserType, Relu::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Relu::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t input_operand_id;
  
  uint64_t output_operand_id;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Relu::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Relu::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Relu::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Relu::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  Reshape {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Reshape, T>::value>;
  using DataView = ReshapeDataView;
  using Data_ = internal::Reshape_Data;

  template <typename... Args>
  static ReshapePtr New(Args&&... args) {
    return ReshapePtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ReshapePtr From(const U& u) {
    return mojo::TypeConverter<ReshapePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Reshape>::Convert(*this);
  }


  Reshape();

  Reshape(
      uint64_t input_operand_id,
      uint64_t output_operand_id);


  ~Reshape();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ReshapePtr>
  ReshapePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Reshape::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Reshape::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Reshape::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Reshape::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Reshape::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Reshape_UnserializedMessageContext<
            UserType, Reshape::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Reshape::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Reshape::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Reshape_UnserializedMessageContext<
            UserType, Reshape::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Reshape::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t input_operand_id;
  
  uint64_t output_operand_id;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Reshape::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Reshape::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Reshape::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Reshape::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  Sigmoid {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Sigmoid, T>::value>;
  using DataView = SigmoidDataView;
  using Data_ = internal::Sigmoid_Data;

  template <typename... Args>
  static SigmoidPtr New(Args&&... args) {
    return SigmoidPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static SigmoidPtr From(const U& u) {
    return mojo::TypeConverter<SigmoidPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Sigmoid>::Convert(*this);
  }


  Sigmoid();

  Sigmoid(
      uint64_t input_operand_id,
      uint64_t output_operand_id);


  ~Sigmoid();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = SigmoidPtr>
  SigmoidPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Sigmoid::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Sigmoid::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Sigmoid::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Sigmoid::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Sigmoid::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Sigmoid_UnserializedMessageContext<
            UserType, Sigmoid::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Sigmoid::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Sigmoid::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Sigmoid_UnserializedMessageContext<
            UserType, Sigmoid::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Sigmoid::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t input_operand_id;
  
  uint64_t output_operand_id;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Sigmoid::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Sigmoid::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Sigmoid::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Sigmoid::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  Softmax {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Softmax, T>::value>;
  using DataView = SoftmaxDataView;
  using Data_ = internal::Softmax_Data;

  template <typename... Args>
  static SoftmaxPtr New(Args&&... args) {
    return SoftmaxPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static SoftmaxPtr From(const U& u) {
    return mojo::TypeConverter<SoftmaxPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Softmax>::Convert(*this);
  }


  Softmax();

  Softmax(
      uint64_t input_operand_id,
      uint64_t output_operand_id);


  ~Softmax();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = SoftmaxPtr>
  SoftmaxPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Softmax::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Softmax::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Softmax::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Softmax::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Softmax::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Softmax_UnserializedMessageContext<
            UserType, Softmax::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Softmax::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Softmax::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Softmax_UnserializedMessageContext<
            UserType, Softmax::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Softmax::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t input_operand_id;
  
  uint64_t output_operand_id;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Softmax::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Softmax::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Softmax::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Softmax::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  Softplus {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Softplus, T>::value>;
  using DataView = SoftplusDataView;
  using Data_ = internal::Softplus_Data;

  template <typename... Args>
  static SoftplusPtr New(Args&&... args) {
    return SoftplusPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static SoftplusPtr From(const U& u) {
    return mojo::TypeConverter<SoftplusPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Softplus>::Convert(*this);
  }


  Softplus();

  Softplus(
      uint64_t input_operand_id,
      uint64_t output_operand_id,
      float steepness);


  ~Softplus();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = SoftplusPtr>
  SoftplusPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Softplus::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Softplus::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Softplus::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Softplus::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Softplus::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Softplus_UnserializedMessageContext<
            UserType, Softplus::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Softplus::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Softplus::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Softplus_UnserializedMessageContext<
            UserType, Softplus::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Softplus::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t input_operand_id;
  
  uint64_t output_operand_id;
  
  float steepness;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Softplus::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Softplus::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Softplus::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Softplus::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  Softsign {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Softsign, T>::value>;
  using DataView = SoftsignDataView;
  using Data_ = internal::Softsign_Data;

  template <typename... Args>
  static SoftsignPtr New(Args&&... args) {
    return SoftsignPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static SoftsignPtr From(const U& u) {
    return mojo::TypeConverter<SoftsignPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Softsign>::Convert(*this);
  }


  Softsign();

  Softsign(
      uint64_t input_operand_id,
      uint64_t output_operand_id);


  ~Softsign();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = SoftsignPtr>
  SoftsignPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Softsign::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Softsign::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Softsign::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Softsign::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Softsign::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Softsign_UnserializedMessageContext<
            UserType, Softsign::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Softsign::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Softsign::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Softsign_UnserializedMessageContext<
            UserType, Softsign::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Softsign::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t input_operand_id;
  
  uint64_t output_operand_id;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Softsign::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Softsign::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Softsign::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Softsign::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  Tanh {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Tanh, T>::value>;
  using DataView = TanhDataView;
  using Data_ = internal::Tanh_Data;

  template <typename... Args>
  static TanhPtr New(Args&&... args) {
    return TanhPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static TanhPtr From(const U& u) {
    return mojo::TypeConverter<TanhPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Tanh>::Convert(*this);
  }


  Tanh();

  Tanh(
      uint64_t input_operand_id,
      uint64_t output_operand_id);


  ~Tanh();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = TanhPtr>
  TanhPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Tanh::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Tanh::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Tanh::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Tanh::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Tanh::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Tanh_UnserializedMessageContext<
            UserType, Tanh::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Tanh::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Tanh::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Tanh_UnserializedMessageContext<
            UserType, Tanh::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Tanh::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t input_operand_id;
  
  uint64_t output_operand_id;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Tanh::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Tanh::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Tanh::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Tanh::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}







class  Where {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Where, T>::value>;
  using DataView = WhereDataView;
  using Data_ = internal::Where_Data;

  template <typename... Args>
  static WherePtr New(Args&&... args) {
    return WherePtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static WherePtr From(const U& u) {
    return mojo::TypeConverter<WherePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Where>::Convert(*this);
  }


  Where();

  Where(
      uint64_t condition_operand_id,
      uint64_t true_value_operand_id,
      uint64_t false_value_operand_id,
      uint64_t output_operand_id);


  ~Where();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = WherePtr>
  WherePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Where::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Where::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Where::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Where::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Where::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Where_UnserializedMessageContext<
            UserType, Where::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Where::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Where::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Where_UnserializedMessageContext<
            UserType, Where::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Where::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t condition_operand_id;
  
  uint64_t true_value_operand_id;
  
  uint64_t false_value_operand_id;
  
  uint64_t output_operand_id;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Where::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Where::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Where::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Where::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  PaddingMode {
 public:
  using DataView = PaddingModeDataView;
  using Data_ = internal::PaddingMode_Data;
  using Tag = Data_::PaddingMode_Tag;

  template <typename... Args>
  static PaddingModePtr New(Args&&... args) {
    static_assert(
        sizeof...(args) < 0,
        "Do not use Union::New(); to create a union of a given subtype, use "
        "New<SubType>(), not New() followed by set_<sub_type>(). To represent "
        "an empty union, mark the field or parameter as nullable in the mojom "
        "definition.");
    return nullptr;
  }
  // Construct an instance holding |constant|.
  static PaddingModePtr
  NewConstant(
      ConstantPaddingPtr value) {
    auto result = PaddingModePtr(absl::in_place);
    result->set_constant(std::move(value));
    return result;
  }
  // Construct an instance holding |edge|.
  static PaddingModePtr
  NewEdge(
      EdgePaddingPtr value) {
    auto result = PaddingModePtr(absl::in_place);
    result->set_edge(std::move(value));
    return result;
  }
  // Construct an instance holding |reflection|.
  static PaddingModePtr
  NewReflection(
      ReflectionPaddingPtr value) {
    auto result = PaddingModePtr(absl::in_place);
    result->set_reflection(std::move(value));
    return result;
  }
  // Construct an instance holding |symmetric|.
  static PaddingModePtr
  NewSymmetric(
      SymmetricPaddingPtr value) {
    auto result = PaddingModePtr(absl::in_place);
    result->set_symmetric(std::move(value));
    return result;
  }

  template <typename U>
  static PaddingModePtr From(const U& u) {
    return mojo::TypeConverter<PaddingModePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PaddingMode>::Convert(*this);
  }

  PaddingMode();
  ~PaddingMode();
  // Delete the copy constructor and copy assignment operators because `data_`
  // contains raw pointers that must not be copied.
  PaddingMode(const PaddingMode& other) = delete;
  PaddingMode& operator=(const PaddingMode& other) = delete;

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = PaddingModePtr>
  PaddingModePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, PaddingMode>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename T,
            typename std::enable_if<std::is_same<
                T, PaddingMode>::value>::type* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  size_t Hash(size_t seed) const;

  Tag which() const {
    return tag_;
  }


  
  bool is_constant() const { return tag_ == Tag::kConstant; }

  
  ConstantPaddingPtr& get_constant() const {
    CHECK(tag_ == Tag::kConstant);
    return *(data_.constant);
  }

  
  void set_constant(
      ConstantPaddingPtr constant);
  
  bool is_edge() const { return tag_ == Tag::kEdge; }

  
  EdgePaddingPtr& get_edge() const {
    CHECK(tag_ == Tag::kEdge);
    return *(data_.edge);
  }

  
  void set_edge(
      EdgePaddingPtr edge);
  
  bool is_reflection() const { return tag_ == Tag::kReflection; }

  
  ReflectionPaddingPtr& get_reflection() const {
    CHECK(tag_ == Tag::kReflection);
    return *(data_.reflection);
  }

  
  void set_reflection(
      ReflectionPaddingPtr reflection);
  
  bool is_symmetric() const { return tag_ == Tag::kSymmetric; }

  
  SymmetricPaddingPtr& get_symmetric() const {
    CHECK(tag_ == Tag::kSymmetric);
    return *(data_.symmetric);
  }

  
  void set_symmetric(
      SymmetricPaddingPtr symmetric);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        PaddingMode::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<PaddingMode::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

 private:
  union Union_ {
    Union_() = default;
    ~Union_() = default;
    ConstantPaddingPtr* constant;
    EdgePaddingPtr* edge;
    ReflectionPaddingPtr* reflection;
    SymmetricPaddingPtr* symmetric;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};



class  Activation {
 public:
  using DataView = ActivationDataView;
  using Data_ = internal::Activation_Data;
  using Tag = Data_::Activation_Tag;

  template <typename... Args>
  static ActivationPtr New(Args&&... args) {
    static_assert(
        sizeof...(args) < 0,
        "Do not use Union::New(); to create a union of a given subtype, use "
        "New<SubType>(), not New() followed by set_<sub_type>(). To represent "
        "an empty union, mark the field or parameter as nullable in the mojom "
        "definition.");
    return nullptr;
  }
  // Construct an instance holding |clamp|.
  static ActivationPtr
  NewClamp(
      ClampPtr value) {
    auto result = ActivationPtr(absl::in_place);
    result->set_clamp(std::move(value));
    return result;
  }
  // Construct an instance holding |elu|.
  static ActivationPtr
  NewElu(
      EluPtr value) {
    auto result = ActivationPtr(absl::in_place);
    result->set_elu(std::move(value));
    return result;
  }
  // Construct an instance holding |hard_sigmoid|.
  static ActivationPtr
  NewHardSigmoid(
      HardSigmoidPtr value) {
    auto result = ActivationPtr(absl::in_place);
    result->set_hard_sigmoid(std::move(value));
    return result;
  }
  // Construct an instance holding |leaky_relu|.
  static ActivationPtr
  NewLeakyRelu(
      LeakyReluPtr value) {
    auto result = ActivationPtr(absl::in_place);
    result->set_leaky_relu(std::move(value));
    return result;
  }
  // Construct an instance holding |linear|.
  static ActivationPtr
  NewLinear(
      LinearPtr value) {
    auto result = ActivationPtr(absl::in_place);
    result->set_linear(std::move(value));
    return result;
  }
  // Construct an instance holding |relu|.
  static ActivationPtr
  NewRelu(
      ReluPtr value) {
    auto result = ActivationPtr(absl::in_place);
    result->set_relu(std::move(value));
    return result;
  }
  // Construct an instance holding |sigmoid|.
  static ActivationPtr
  NewSigmoid(
      SigmoidPtr value) {
    auto result = ActivationPtr(absl::in_place);
    result->set_sigmoid(std::move(value));
    return result;
  }
  // Construct an instance holding |softmax|.
  static ActivationPtr
  NewSoftmax(
      SoftmaxPtr value) {
    auto result = ActivationPtr(absl::in_place);
    result->set_softmax(std::move(value));
    return result;
  }
  // Construct an instance holding |softplus|.
  static ActivationPtr
  NewSoftplus(
      SoftplusPtr value) {
    auto result = ActivationPtr(absl::in_place);
    result->set_softplus(std::move(value));
    return result;
  }
  // Construct an instance holding |softsign|.
  static ActivationPtr
  NewSoftsign(
      SoftsignPtr value) {
    auto result = ActivationPtr(absl::in_place);
    result->set_softsign(std::move(value));
    return result;
  }
  // Construct an instance holding |tanh|.
  static ActivationPtr
  NewTanh(
      TanhPtr value) {
    auto result = ActivationPtr(absl::in_place);
    result->set_tanh(std::move(value));
    return result;
  }

  template <typename U>
  static ActivationPtr From(const U& u) {
    return mojo::TypeConverter<ActivationPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Activation>::Convert(*this);
  }

  Activation();
  ~Activation();
  // Delete the copy constructor and copy assignment operators because `data_`
  // contains raw pointers that must not be copied.
  Activation(const Activation& other) = delete;
  Activation& operator=(const Activation& other) = delete;

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = ActivationPtr>
  ActivationPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, Activation>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename T,
            typename std::enable_if<std::is_same<
                T, Activation>::value>::type* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  size_t Hash(size_t seed) const;

  Tag which() const {
    return tag_;
  }


  
  bool is_clamp() const { return tag_ == Tag::kClamp; }

  
  ClampPtr& get_clamp() const {
    CHECK(tag_ == Tag::kClamp);
    return *(data_.clamp);
  }

  
  void set_clamp(
      ClampPtr clamp);
  
  bool is_elu() const { return tag_ == Tag::kElu; }

  
  EluPtr& get_elu() const {
    CHECK(tag_ == Tag::kElu);
    return *(data_.elu);
  }

  
  void set_elu(
      EluPtr elu);
  
  bool is_hard_sigmoid() const { return tag_ == Tag::kHardSigmoid; }

  
  HardSigmoidPtr& get_hard_sigmoid() const {
    CHECK(tag_ == Tag::kHardSigmoid);
    return *(data_.hard_sigmoid);
  }

  
  void set_hard_sigmoid(
      HardSigmoidPtr hard_sigmoid);
  
  bool is_leaky_relu() const { return tag_ == Tag::kLeakyRelu; }

  
  LeakyReluPtr& get_leaky_relu() const {
    CHECK(tag_ == Tag::kLeakyRelu);
    return *(data_.leaky_relu);
  }

  
  void set_leaky_relu(
      LeakyReluPtr leaky_relu);
  
  bool is_linear() const { return tag_ == Tag::kLinear; }

  
  LinearPtr& get_linear() const {
    CHECK(tag_ == Tag::kLinear);
    return *(data_.linear);
  }

  
  void set_linear(
      LinearPtr linear);
  
  bool is_relu() const { return tag_ == Tag::kRelu; }

  
  ReluPtr& get_relu() const {
    CHECK(tag_ == Tag::kRelu);
    return *(data_.relu);
  }

  
  void set_relu(
      ReluPtr relu);
  
  bool is_sigmoid() const { return tag_ == Tag::kSigmoid; }

  
  SigmoidPtr& get_sigmoid() const {
    CHECK(tag_ == Tag::kSigmoid);
    return *(data_.sigmoid);
  }

  
  void set_sigmoid(
      SigmoidPtr sigmoid);
  
  bool is_softmax() const { return tag_ == Tag::kSoftmax; }

  
  SoftmaxPtr& get_softmax() const {
    CHECK(tag_ == Tag::kSoftmax);
    return *(data_.softmax);
  }

  
  void set_softmax(
      SoftmaxPtr softmax);
  
  bool is_softplus() const { return tag_ == Tag::kSoftplus; }

  
  SoftplusPtr& get_softplus() const {
    CHECK(tag_ == Tag::kSoftplus);
    return *(data_.softplus);
  }

  
  void set_softplus(
      SoftplusPtr softplus);
  
  bool is_softsign() const { return tag_ == Tag::kSoftsign; }

  
  SoftsignPtr& get_softsign() const {
    CHECK(tag_ == Tag::kSoftsign);
    return *(data_.softsign);
  }

  
  void set_softsign(
      SoftsignPtr softsign);
  
  bool is_tanh() const { return tag_ == Tag::kTanh; }

  
  TanhPtr& get_tanh() const {
    CHECK(tag_ == Tag::kTanh);
    return *(data_.tanh);
  }

  
  void set_tanh(
      TanhPtr tanh);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Activation::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<Activation::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

 private:
  union Union_ {
    Union_() = default;
    ~Union_() = default;
    ClampPtr* clamp;
    EluPtr* elu;
    HardSigmoidPtr* hard_sigmoid;
    LeakyReluPtr* leaky_relu;
    LinearPtr* linear;
    ReluPtr* relu;
    SigmoidPtr* sigmoid;
    SoftmaxPtr* softmax;
    SoftplusPtr* softplus;
    SoftsignPtr* softsign;
    TanhPtr* tanh;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};



class  Operation {
 public:
  using DataView = OperationDataView;
  using Data_ = internal::Operation_Data;
  using Tag = Data_::Operation_Tag;

  template <typename... Args>
  static OperationPtr New(Args&&... args) {
    static_assert(
        sizeof...(args) < 0,
        "Do not use Union::New(); to create a union of a given subtype, use "
        "New<SubType>(), not New() followed by set_<sub_type>(). To represent "
        "an empty union, mark the field or parameter as nullable in the mojom "
        "definition.");
    return nullptr;
  }
  // Construct an instance holding |arg_min_max|.
  static OperationPtr
  NewArgMinMax(
      ArgMinMaxPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_arg_min_max(std::move(value));
    return result;
  }
  // Construct an instance holding |batch_normalization|.
  static OperationPtr
  NewBatchNormalization(
      BatchNormalizationPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_batch_normalization(std::move(value));
    return result;
  }
  // Construct an instance holding |clamp|.
  static OperationPtr
  NewClamp(
      ClampPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_clamp(std::move(value));
    return result;
  }
  // Construct an instance holding |concat|.
  static OperationPtr
  NewConcat(
      ConcatPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_concat(std::move(value));
    return result;
  }
  // Construct an instance holding |conv2d|.
  static OperationPtr
  NewConv2d(
      Conv2dPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_conv2d(std::move(value));
    return result;
  }
  // Construct an instance holding |element_wise_binary|.
  static OperationPtr
  NewElementWiseBinary(
      ElementWiseBinaryPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_element_wise_binary(std::move(value));
    return result;
  }
  // Construct an instance holding |elu|.
  static OperationPtr
  NewElu(
      EluPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_elu(std::move(value));
    return result;
  }
  // Construct an instance holding |element_wise_unary|.
  static OperationPtr
  NewElementWiseUnary(
      ElementWiseUnaryPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_element_wise_unary(std::move(value));
    return result;
  }
  // Construct an instance holding |expand|.
  static OperationPtr
  NewExpand(
      ExpandPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_expand(std::move(value));
    return result;
  }
  // Construct an instance holding |gather|.
  static OperationPtr
  NewGather(
      GatherPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_gather(std::move(value));
    return result;
  }
  // Construct an instance holding |gemm|.
  static OperationPtr
  NewGemm(
      GemmPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_gemm(std::move(value));
    return result;
  }
  // Construct an instance holding |hard_sigmoid|.
  static OperationPtr
  NewHardSigmoid(
      HardSigmoidPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_hard_sigmoid(std::move(value));
    return result;
  }
  // Construct an instance holding |layer_normalization|.
  static OperationPtr
  NewLayerNormalization(
      LayerNormalizationPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_layer_normalization(std::move(value));
    return result;
  }
  // Construct an instance holding |instance_normalization|.
  static OperationPtr
  NewInstanceNormalization(
      InstanceNormalizationPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_instance_normalization(std::move(value));
    return result;
  }
  // Construct an instance holding |leaky_relu|.
  static OperationPtr
  NewLeakyRelu(
      LeakyReluPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_leaky_relu(std::move(value));
    return result;
  }
  // Construct an instance holding |linear|.
  static OperationPtr
  NewLinear(
      LinearPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_linear(std::move(value));
    return result;
  }
  // Construct an instance holding |matmul|.
  static OperationPtr
  NewMatmul(
      MatmulPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_matmul(std::move(value));
    return result;
  }
  // Construct an instance holding |pad|.
  static OperationPtr
  NewPad(
      PadPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_pad(std::move(value));
    return result;
  }
  // Construct an instance holding |pool2d|.
  static OperationPtr
  NewPool2d(
      Pool2dPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_pool2d(std::move(value));
    return result;
  }
  // Construct an instance holding |prelu|.
  static OperationPtr
  NewPrelu(
      PreluPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_prelu(std::move(value));
    return result;
  }
  // Construct an instance holding |reduce|.
  static OperationPtr
  NewReduce(
      ReducePtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_reduce(std::move(value));
    return result;
  }
  // Construct an instance holding |relu|.
  static OperationPtr
  NewRelu(
      ReluPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_relu(std::move(value));
    return result;
  }
  // Construct an instance holding |resample2d|.
  static OperationPtr
  NewResample2d(
      Resample2dPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_resample2d(std::move(value));
    return result;
  }
  // Construct an instance holding |reshape|.
  static OperationPtr
  NewReshape(
      ReshapePtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_reshape(std::move(value));
    return result;
  }
  // Construct an instance holding |sigmoid|.
  static OperationPtr
  NewSigmoid(
      SigmoidPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_sigmoid(std::move(value));
    return result;
  }
  // Construct an instance holding |slice|.
  static OperationPtr
  NewSlice(
      SlicePtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_slice(std::move(value));
    return result;
  }
  // Construct an instance holding |softmax|.
  static OperationPtr
  NewSoftmax(
      SoftmaxPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_softmax(std::move(value));
    return result;
  }
  // Construct an instance holding |softplus|.
  static OperationPtr
  NewSoftplus(
      SoftplusPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_softplus(std::move(value));
    return result;
  }
  // Construct an instance holding |softsign|.
  static OperationPtr
  NewSoftsign(
      SoftsignPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_softsign(std::move(value));
    return result;
  }
  // Construct an instance holding |split|.
  static OperationPtr
  NewSplit(
      SplitPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_split(std::move(value));
    return result;
  }
  // Construct an instance holding |tanh|.
  static OperationPtr
  NewTanh(
      TanhPtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_tanh(std::move(value));
    return result;
  }
  // Construct an instance holding |transpose|.
  static OperationPtr
  NewTranspose(
      TransposePtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_transpose(std::move(value));
    return result;
  }
  // Construct an instance holding |where|.
  static OperationPtr
  NewWhere(
      WherePtr value) {
    auto result = OperationPtr(absl::in_place);
    result->set_where(std::move(value));
    return result;
  }

  template <typename U>
  static OperationPtr From(const U& u) {
    return mojo::TypeConverter<OperationPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Operation>::Convert(*this);
  }

  Operation();
  ~Operation();
  // Delete the copy constructor and copy assignment operators because `data_`
  // contains raw pointers that must not be copied.
  Operation(const Operation& other) = delete;
  Operation& operator=(const Operation& other) = delete;

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = OperationPtr>
  OperationPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, Operation>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename T,
            typename std::enable_if<std::is_same<
                T, Operation>::value>::type* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  Tag which() const {
    return tag_;
  }


  
  bool is_arg_min_max() const { return tag_ == Tag::kArgMinMax; }

  
  ArgMinMaxPtr& get_arg_min_max() const {
    CHECK(tag_ == Tag::kArgMinMax);
    return *(data_.arg_min_max);
  }

  
  void set_arg_min_max(
      ArgMinMaxPtr arg_min_max);
  
  bool is_batch_normalization() const { return tag_ == Tag::kBatchNormalization; }

  
  BatchNormalizationPtr& get_batch_normalization() const {
    CHECK(tag_ == Tag::kBatchNormalization);
    return *(data_.batch_normalization);
  }

  
  void set_batch_normalization(
      BatchNormalizationPtr batch_normalization);
  
  bool is_clamp() const { return tag_ == Tag::kClamp; }

  
  ClampPtr& get_clamp() const {
    CHECK(tag_ == Tag::kClamp);
    return *(data_.clamp);
  }

  
  void set_clamp(
      ClampPtr clamp);
  
  bool is_concat() const { return tag_ == Tag::kConcat; }

  
  ConcatPtr& get_concat() const {
    CHECK(tag_ == Tag::kConcat);
    return *(data_.concat);
  }

  
  void set_concat(
      ConcatPtr concat);
  
  bool is_conv2d() const { return tag_ == Tag::kConv2d; }

  
  Conv2dPtr& get_conv2d() const {
    CHECK(tag_ == Tag::kConv2d);
    return *(data_.conv2d);
  }

  
  void set_conv2d(
      Conv2dPtr conv2d);
  
  bool is_element_wise_binary() const { return tag_ == Tag::kElementWiseBinary; }

  
  ElementWiseBinaryPtr& get_element_wise_binary() const {
    CHECK(tag_ == Tag::kElementWiseBinary);
    return *(data_.element_wise_binary);
  }

  
  void set_element_wise_binary(
      ElementWiseBinaryPtr element_wise_binary);
  
  bool is_elu() const { return tag_ == Tag::kElu; }

  
  EluPtr& get_elu() const {
    CHECK(tag_ == Tag::kElu);
    return *(data_.elu);
  }

  
  void set_elu(
      EluPtr elu);
  
  bool is_element_wise_unary() const { return tag_ == Tag::kElementWiseUnary; }

  
  ElementWiseUnaryPtr& get_element_wise_unary() const {
    CHECK(tag_ == Tag::kElementWiseUnary);
    return *(data_.element_wise_unary);
  }

  
  void set_element_wise_unary(
      ElementWiseUnaryPtr element_wise_unary);
  
  bool is_expand() const { return tag_ == Tag::kExpand; }

  
  ExpandPtr& get_expand() const {
    CHECK(tag_ == Tag::kExpand);
    return *(data_.expand);
  }

  
  void set_expand(
      ExpandPtr expand);
  
  bool is_gather() const { return tag_ == Tag::kGather; }

  
  GatherPtr& get_gather() const {
    CHECK(tag_ == Tag::kGather);
    return *(data_.gather);
  }

  
  void set_gather(
      GatherPtr gather);
  
  bool is_gemm() const { return tag_ == Tag::kGemm; }

  
  GemmPtr& get_gemm() const {
    CHECK(tag_ == Tag::kGemm);
    return *(data_.gemm);
  }

  
  void set_gemm(
      GemmPtr gemm);
  
  bool is_hard_sigmoid() const { return tag_ == Tag::kHardSigmoid; }

  
  HardSigmoidPtr& get_hard_sigmoid() const {
    CHECK(tag_ == Tag::kHardSigmoid);
    return *(data_.hard_sigmoid);
  }

  
  void set_hard_sigmoid(
      HardSigmoidPtr hard_sigmoid);
  
  bool is_layer_normalization() const { return tag_ == Tag::kLayerNormalization; }

  
  LayerNormalizationPtr& get_layer_normalization() const {
    CHECK(tag_ == Tag::kLayerNormalization);
    return *(data_.layer_normalization);
  }

  
  void set_layer_normalization(
      LayerNormalizationPtr layer_normalization);
  
  bool is_instance_normalization() const { return tag_ == Tag::kInstanceNormalization; }

  
  InstanceNormalizationPtr& get_instance_normalization() const {
    CHECK(tag_ == Tag::kInstanceNormalization);
    return *(data_.instance_normalization);
  }

  
  void set_instance_normalization(
      InstanceNormalizationPtr instance_normalization);
  
  bool is_leaky_relu() const { return tag_ == Tag::kLeakyRelu; }

  
  LeakyReluPtr& get_leaky_relu() const {
    CHECK(tag_ == Tag::kLeakyRelu);
    return *(data_.leaky_relu);
  }

  
  void set_leaky_relu(
      LeakyReluPtr leaky_relu);
  
  bool is_linear() const { return tag_ == Tag::kLinear; }

  
  LinearPtr& get_linear() const {
    CHECK(tag_ == Tag::kLinear);
    return *(data_.linear);
  }

  
  void set_linear(
      LinearPtr linear);
  
  bool is_matmul() const { return tag_ == Tag::kMatmul; }

  
  MatmulPtr& get_matmul() const {
    CHECK(tag_ == Tag::kMatmul);
    return *(data_.matmul);
  }

  
  void set_matmul(
      MatmulPtr matmul);
  
  bool is_pad() const { return tag_ == Tag::kPad; }

  
  PadPtr& get_pad() const {
    CHECK(tag_ == Tag::kPad);
    return *(data_.pad);
  }

  
  void set_pad(
      PadPtr pad);
  
  bool is_pool2d() const { return tag_ == Tag::kPool2d; }

  
  Pool2dPtr& get_pool2d() const {
    CHECK(tag_ == Tag::kPool2d);
    return *(data_.pool2d);
  }

  
  void set_pool2d(
      Pool2dPtr pool2d);
  
  bool is_prelu() const { return tag_ == Tag::kPrelu; }

  
  PreluPtr& get_prelu() const {
    CHECK(tag_ == Tag::kPrelu);
    return *(data_.prelu);
  }

  
  void set_prelu(
      PreluPtr prelu);
  
  bool is_reduce() const { return tag_ == Tag::kReduce; }

  
  ReducePtr& get_reduce() const {
    CHECK(tag_ == Tag::kReduce);
    return *(data_.reduce);
  }

  
  void set_reduce(
      ReducePtr reduce);
  
  bool is_relu() const { return tag_ == Tag::kRelu; }

  
  ReluPtr& get_relu() const {
    CHECK(tag_ == Tag::kRelu);
    return *(data_.relu);
  }

  
  void set_relu(
      ReluPtr relu);
  
  bool is_resample2d() const { return tag_ == Tag::kResample2d; }

  
  Resample2dPtr& get_resample2d() const {
    CHECK(tag_ == Tag::kResample2d);
    return *(data_.resample2d);
  }

  
  void set_resample2d(
      Resample2dPtr resample2d);
  
  bool is_reshape() const { return tag_ == Tag::kReshape; }

  
  ReshapePtr& get_reshape() const {
    CHECK(tag_ == Tag::kReshape);
    return *(data_.reshape);
  }

  
  void set_reshape(
      ReshapePtr reshape);
  
  bool is_sigmoid() const { return tag_ == Tag::kSigmoid; }

  
  SigmoidPtr& get_sigmoid() const {
    CHECK(tag_ == Tag::kSigmoid);
    return *(data_.sigmoid);
  }

  
  void set_sigmoid(
      SigmoidPtr sigmoid);
  
  bool is_slice() const { return tag_ == Tag::kSlice; }

  
  SlicePtr& get_slice() const {
    CHECK(tag_ == Tag::kSlice);
    return *(data_.slice);
  }

  
  void set_slice(
      SlicePtr slice);
  
  bool is_softmax() const { return tag_ == Tag::kSoftmax; }

  
  SoftmaxPtr& get_softmax() const {
    CHECK(tag_ == Tag::kSoftmax);
    return *(data_.softmax);
  }

  
  void set_softmax(
      SoftmaxPtr softmax);
  
  bool is_softplus() const { return tag_ == Tag::kSoftplus; }

  
  SoftplusPtr& get_softplus() const {
    CHECK(tag_ == Tag::kSoftplus);
    return *(data_.softplus);
  }

  
  void set_softplus(
      SoftplusPtr softplus);
  
  bool is_softsign() const { return tag_ == Tag::kSoftsign; }

  
  SoftsignPtr& get_softsign() const {
    CHECK(tag_ == Tag::kSoftsign);
    return *(data_.softsign);
  }

  
  void set_softsign(
      SoftsignPtr softsign);
  
  bool is_split() const { return tag_ == Tag::kSplit; }

  
  SplitPtr& get_split() const {
    CHECK(tag_ == Tag::kSplit);
    return *(data_.split);
  }

  
  void set_split(
      SplitPtr split);
  
  bool is_tanh() const { return tag_ == Tag::kTanh; }

  
  TanhPtr& get_tanh() const {
    CHECK(tag_ == Tag::kTanh);
    return *(data_.tanh);
  }

  
  void set_tanh(
      TanhPtr tanh);
  
  bool is_transpose() const { return tag_ == Tag::kTranspose; }

  
  TransposePtr& get_transpose() const {
    CHECK(tag_ == Tag::kTranspose);
    return *(data_.transpose);
  }

  
  void set_transpose(
      TransposePtr transpose);
  
  bool is_where() const { return tag_ == Tag::kWhere; }

  
  WherePtr& get_where() const {
    CHECK(tag_ == Tag::kWhere);
    return *(data_.where);
  }

  
  void set_where(
      WherePtr where);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Operation::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<Operation::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

 private:
  union Union_ {
    Union_() = default;
    ~Union_() = default;
    ArgMinMaxPtr* arg_min_max;
    BatchNormalizationPtr* batch_normalization;
    ClampPtr* clamp;
    ConcatPtr* concat;
    Conv2dPtr* conv2d;
    ElementWiseBinaryPtr* element_wise_binary;
    EluPtr* elu;
    ElementWiseUnaryPtr* element_wise_unary;
    ExpandPtr* expand;
    GatherPtr* gather;
    GemmPtr* gemm;
    HardSigmoidPtr* hard_sigmoid;
    LayerNormalizationPtr* layer_normalization;
    InstanceNormalizationPtr* instance_normalization;
    LeakyReluPtr* leaky_relu;
    LinearPtr* linear;
    MatmulPtr* matmul;
    PadPtr* pad;
    Pool2dPtr* pool2d;
    PreluPtr* prelu;
    ReducePtr* reduce;
    ReluPtr* relu;
    Resample2dPtr* resample2d;
    ReshapePtr* reshape;
    SigmoidPtr* sigmoid;
    SlicePtr* slice;
    SoftmaxPtr* softmax;
    SoftplusPtr* softplus;
    SoftsignPtr* softsign;
    SplitPtr* split;
    TanhPtr* tanh;
    TransposePtr* transpose;
    WherePtr* where;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};



class  ComputeResult {
 public:
  using DataView = ComputeResultDataView;
  using Data_ = internal::ComputeResult_Data;
  using Tag = Data_::ComputeResult_Tag;

  template <typename... Args>
  static ComputeResultPtr New(Args&&... args) {
    static_assert(
        sizeof...(args) < 0,
        "Do not use Union::New(); to create a union of a given subtype, use "
        "New<SubType>(), not New() followed by set_<sub_type>(). To represent "
        "an empty union, mark the field or parameter as nullable in the mojom "
        "definition.");
    return nullptr;
  }
  // Construct an instance holding |named_outputs|.
  static ComputeResultPtr
  NewNamedOutputs(
      WTF::HashMap<WTF::String, ::mojo_base::BigBuffer> value) {
    auto result = ComputeResultPtr(absl::in_place);
    result->set_named_outputs(std::move(value));
    return result;
  }
  // Construct an instance holding |error|.
  static ComputeResultPtr
  NewError(
      ::webnn::mojom::blink::ErrorPtr value) {
    auto result = ComputeResultPtr(absl::in_place);
    result->set_error(std::move(value));
    return result;
  }

  template <typename U>
  static ComputeResultPtr From(const U& u) {
    return mojo::TypeConverter<ComputeResultPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ComputeResult>::Convert(*this);
  }

  ComputeResult();
  ~ComputeResult();
  // Delete the copy constructor and copy assignment operators because `data_`
  // contains raw pointers that must not be copied.
  ComputeResult(const ComputeResult& other) = delete;
  ComputeResult& operator=(const ComputeResult& other) = delete;

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = ComputeResultPtr>
  ComputeResultPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, ComputeResult>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename T,
            typename std::enable_if<std::is_same<
                T, ComputeResult>::value>::type* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  Tag which() const {
    return tag_;
  }


  
  bool is_named_outputs() const { return tag_ == Tag::kNamedOutputs; }

  
  WTF::HashMap<WTF::String, ::mojo_base::BigBuffer>& get_named_outputs() const {
    CHECK(tag_ == Tag::kNamedOutputs);
    return *(data_.named_outputs);
  }

  
  void set_named_outputs(
      WTF::HashMap<WTF::String, ::mojo_base::BigBuffer> named_outputs);
  
  bool is_error() const { return tag_ == Tag::kError; }

  
  ::webnn::mojom::blink::ErrorPtr& get_error() const {
    CHECK(tag_ == Tag::kError);
    return *(data_.error);
  }

  
  void set_error(
      ::webnn::mojom::blink::ErrorPtr error);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ComputeResult::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<ComputeResult::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

 private:
  union Union_ {
    Union_() = default;
    ~Union_() = default;
    WTF::HashMap<WTF::String, ::mojo_base::BigBuffer>* named_outputs;
    ::webnn::mojom::blink::ErrorPtr* error;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};





class  Operand {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Operand, T>::value>;
  using DataView = OperandDataView;
  using Data_ = internal::Operand_Data;
  using DataType = Operand_DataType;
  using Kind = Operand_Kind;

  template <typename... Args>
  static OperandPtr New(Args&&... args) {
    return OperandPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static OperandPtr From(const U& u) {
    return mojo::TypeConverter<OperandPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Operand>::Convert(*this);
  }


  Operand();

  Operand(
      Operand::Kind kind,
      Operand::DataType data_type,
      WTF::Vector<uint32_t> dimensions,
      const WTF::String& name);


  ~Operand();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = OperandPtr>
  OperandPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Operand::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Operand::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Operand::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Operand::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Operand::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Operand_UnserializedMessageContext<
            UserType, Operand::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Operand::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Operand::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Operand_UnserializedMessageContext<
            UserType, Operand::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Operand::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  Operand::Kind kind;
  
  Operand::DataType data_type;
  
  WTF::Vector<uint32_t> dimensions;
  
  WTF::String name;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Operand::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Operand::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Operand::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Operand::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  ArgMinMax {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ArgMinMax, T>::value>;
  using DataView = ArgMinMaxDataView;
  using Data_ = internal::ArgMinMax_Data;
  using Kind = ArgMinMax_Kind;

  template <typename... Args>
  static ArgMinMaxPtr New(Args&&... args) {
    return ArgMinMaxPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ArgMinMaxPtr From(const U& u) {
    return mojo::TypeConverter<ArgMinMaxPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ArgMinMax>::Convert(*this);
  }


  ArgMinMax();

  ArgMinMax(
      ArgMinMax::Kind kind,
      uint64_t input_operand_id,
      uint64_t output_operand_id,
      WTF::Vector<uint32_t> axes,
      bool keep_dimensions,
      bool select_last_index);


  ~ArgMinMax();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ArgMinMaxPtr>
  ArgMinMaxPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ArgMinMax::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ArgMinMax::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, ArgMinMax::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ArgMinMax::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ArgMinMax::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ArgMinMax_UnserializedMessageContext<
            UserType, ArgMinMax::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ArgMinMax::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return ArgMinMax::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ArgMinMax_UnserializedMessageContext<
            UserType, ArgMinMax::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ArgMinMax::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ArgMinMax::Kind kind;
  
  uint64_t input_operand_id;
  
  uint64_t output_operand_id;
  
  WTF::Vector<uint32_t> axes;
  
  bool keep_dimensions;
  
  bool select_last_index;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ArgMinMax::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ArgMinMax::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ArgMinMax::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ArgMinMax::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  BatchNormalization {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<BatchNormalization, T>::value>;
  using DataView = BatchNormalizationDataView;
  using Data_ = internal::BatchNormalization_Data;

  template <typename... Args>
  static BatchNormalizationPtr New(Args&&... args) {
    return BatchNormalizationPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static BatchNormalizationPtr From(const U& u) {
    return mojo::TypeConverter<BatchNormalizationPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, BatchNormalization>::Convert(*this);
  }


  BatchNormalization();

  BatchNormalization(
      uint64_t input_operand_id,
      uint64_t mean_operand_id,
      uint64_t variance_operand_id,
      uint64_t output_operand_id,
      std::optional<uint64_t> scale_operand_id,
      std::optional<uint64_t> bias_operand_id,
      uint32_t axis,
      float epsilon,
      ActivationPtr activation);

BatchNormalization(const BatchNormalization&) = delete;
BatchNormalization& operator=(const BatchNormalization&) = delete;

  ~BatchNormalization();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = BatchNormalizationPtr>
  BatchNormalizationPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, BatchNormalization::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, BatchNormalization::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, BatchNormalization::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        BatchNormalization::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        BatchNormalization::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::BatchNormalization_UnserializedMessageContext<
            UserType, BatchNormalization::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<BatchNormalization::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return BatchNormalization::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::BatchNormalization_UnserializedMessageContext<
            UserType, BatchNormalization::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<BatchNormalization::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t input_operand_id;
  
  uint64_t mean_operand_id;
  
  uint64_t variance_operand_id;
  
  uint64_t output_operand_id;
  
  std::optional<uint64_t> scale_operand_id;
  
  std::optional<uint64_t> bias_operand_id;
  
  uint32_t axis;
  
  float epsilon;
  
  ActivationPtr activation;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, BatchNormalization::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, BatchNormalization::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, BatchNormalization::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, BatchNormalization::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  Concat {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Concat, T>::value>;
  using DataView = ConcatDataView;
  using Data_ = internal::Concat_Data;

  template <typename... Args>
  static ConcatPtr New(Args&&... args) {
    return ConcatPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ConcatPtr From(const U& u) {
    return mojo::TypeConverter<ConcatPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Concat>::Convert(*this);
  }


  Concat();

  Concat(
      WTF::Vector<uint64_t> input_operand_ids,
      uint64_t output_operand_id,
      uint32_t axis);


  ~Concat();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ConcatPtr>
  ConcatPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Concat::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Concat::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Concat::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Concat::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Concat::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Concat_UnserializedMessageContext<
            UserType, Concat::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Concat::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Concat::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Concat_UnserializedMessageContext<
            UserType, Concat::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Concat::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  WTF::Vector<uint64_t> input_operand_ids;
  
  uint64_t output_operand_id;
  
  uint32_t axis;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Concat::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Concat::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Concat::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Concat::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  Padding2d {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Padding2d, T>::value>;
  using DataView = Padding2dDataView;
  using Data_ = internal::Padding2d_Data;

  template <typename... Args>
  static Padding2dPtr New(Args&&... args) {
    return Padding2dPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static Padding2dPtr From(const U& u) {
    return mojo::TypeConverter<Padding2dPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Padding2d>::Convert(*this);
  }


  Padding2d();

  Padding2d(
      Size2dPtr beginning,
      Size2dPtr ending);

Padding2d(const Padding2d&) = delete;
Padding2d& operator=(const Padding2d&) = delete;

  ~Padding2d();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = Padding2dPtr>
  Padding2dPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Padding2d::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Padding2d::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Padding2d::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Padding2d::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Padding2d::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Padding2d_UnserializedMessageContext<
            UserType, Padding2d::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Padding2d::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Padding2d::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Padding2d_UnserializedMessageContext<
            UserType, Padding2d::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Padding2d::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  Size2dPtr beginning;
  
  Size2dPtr ending;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Padding2d::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Padding2d::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Padding2d::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Padding2d::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  Conv2d {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Conv2d, T>::value>;
  using DataView = Conv2dDataView;
  using Data_ = internal::Conv2d_Data;
  using Type = Conv2d_Type;

  template <typename... Args>
  static Conv2dPtr New(Args&&... args) {
    return Conv2dPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static Conv2dPtr From(const U& u) {
    return mojo::TypeConverter<Conv2dPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Conv2d>::Convert(*this);
  }


  Conv2d();

  Conv2d(
      Conv2d::Type type,
      uint64_t input_operand_id,
      uint64_t filter_operand_id,
      uint64_t output_operand_id,
      Padding2dPtr padding,
      Size2dPtr strides,
      Size2dPtr dilations,
      uint32_t groups,
      InputOperandLayout input_layout,
      std::optional<uint64_t> bias_operand_id,
      ActivationPtr activation);

Conv2d(const Conv2d&) = delete;
Conv2d& operator=(const Conv2d&) = delete;

  ~Conv2d();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = Conv2dPtr>
  Conv2dPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Conv2d::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Conv2d::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Conv2d::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Conv2d::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Conv2d::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Conv2d_UnserializedMessageContext<
            UserType, Conv2d::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Conv2d::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Conv2d::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Conv2d_UnserializedMessageContext<
            UserType, Conv2d::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Conv2d::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  Conv2d::Type type;
  
  uint64_t input_operand_id;
  
  uint64_t filter_operand_id;
  
  uint64_t output_operand_id;
  
  Padding2dPtr padding;
  
  Size2dPtr strides;
  
  Size2dPtr dilations;
  
  uint32_t groups;
  
  InputOperandLayout input_layout;
  
  std::optional<uint64_t> bias_operand_id;
  
  ActivationPtr activation;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Conv2d::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Conv2d::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Conv2d::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Conv2d::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}












class  InstanceNormalization {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<InstanceNormalization, T>::value>;
  using DataView = InstanceNormalizationDataView;
  using Data_ = internal::InstanceNormalization_Data;

  template <typename... Args>
  static InstanceNormalizationPtr New(Args&&... args) {
    return InstanceNormalizationPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static InstanceNormalizationPtr From(const U& u) {
    return mojo::TypeConverter<InstanceNormalizationPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, InstanceNormalization>::Convert(*this);
  }


  InstanceNormalization();

  InstanceNormalization(
      uint64_t input_operand_id,
      uint64_t output_operand_id,
      std::optional<uint64_t> scale_operand_id,
      std::optional<uint64_t> bias_operand_id,
      float epsilon,
      InputOperandLayout layout);


  ~InstanceNormalization();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = InstanceNormalizationPtr>
  InstanceNormalizationPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, InstanceNormalization::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, InstanceNormalization::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, InstanceNormalization::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        InstanceNormalization::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        InstanceNormalization::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::InstanceNormalization_UnserializedMessageContext<
            UserType, InstanceNormalization::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<InstanceNormalization::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return InstanceNormalization::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::InstanceNormalization_UnserializedMessageContext<
            UserType, InstanceNormalization::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<InstanceNormalization::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t input_operand_id;
  
  uint64_t output_operand_id;
  
  std::optional<uint64_t> scale_operand_id;
  
  std::optional<uint64_t> bias_operand_id;
  
  float epsilon;
  
  InputOperandLayout layout;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, InstanceNormalization::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, InstanceNormalization::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, InstanceNormalization::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, InstanceNormalization::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  Pad {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Pad, T>::value>;
  using DataView = PadDataView;
  using Data_ = internal::Pad_Data;

  template <typename... Args>
  static PadPtr New(Args&&... args) {
    return PadPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static PadPtr From(const U& u) {
    return mojo::TypeConverter<PadPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Pad>::Convert(*this);
  }


  Pad();

  Pad(
      uint64_t input_operand_id,
      uint64_t output_operand_id,
      WTF::Vector<uint32_t> beginning_padding,
      WTF::Vector<uint32_t> ending_padding,
      PaddingModePtr mode);

Pad(const Pad&) = delete;
Pad& operator=(const Pad&) = delete;

  ~Pad();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PadPtr>
  PadPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Pad::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Pad::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Pad::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Pad::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Pad::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Pad_UnserializedMessageContext<
            UserType, Pad::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Pad::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Pad::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Pad_UnserializedMessageContext<
            UserType, Pad::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Pad::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t input_operand_id;
  
  uint64_t output_operand_id;
  
  WTF::Vector<uint32_t> beginning_padding;
  
  WTF::Vector<uint32_t> ending_padding;
  
  PaddingModePtr mode;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Pad::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Pad::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Pad::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Pad::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  Reduce {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Reduce, T>::value>;
  using DataView = ReduceDataView;
  using Data_ = internal::Reduce_Data;
  using Kind = Reduce_Kind;

  template <typename... Args>
  static ReducePtr New(Args&&... args) {
    return ReducePtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ReducePtr From(const U& u) {
    return mojo::TypeConverter<ReducePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Reduce>::Convert(*this);
  }


  Reduce();

  Reduce(
      Reduce::Kind kind,
      uint64_t input_operand_id,
      uint64_t output_operand_id,
      WTF::Vector<uint32_t> axes,
      bool keep_dimensions);


  ~Reduce();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ReducePtr>
  ReducePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Reduce::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Reduce::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Reduce::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Reduce::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Reduce::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Reduce_UnserializedMessageContext<
            UserType, Reduce::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Reduce::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Reduce::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Reduce_UnserializedMessageContext<
            UserType, Reduce::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Reduce::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  Reduce::Kind kind;
  
  uint64_t input_operand_id;
  
  uint64_t output_operand_id;
  
  WTF::Vector<uint32_t> axes;
  
  bool keep_dimensions;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Reduce::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Reduce::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Reduce::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Reduce::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  Pool2d {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Pool2d, T>::value>;
  using DataView = Pool2dDataView;
  using Data_ = internal::Pool2d_Data;
  using Kind = Pool2d_Kind;

  template <typename... Args>
  static Pool2dPtr New(Args&&... args) {
    return Pool2dPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static Pool2dPtr From(const U& u) {
    return mojo::TypeConverter<Pool2dPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Pool2d>::Convert(*this);
  }


  Pool2d();

  Pool2d(
      Pool2d::Kind kind,
      uint64_t input_operand_id,
      uint64_t output_operand_id,
      Size2dPtr window_dimensions,
      Padding2dPtr padding,
      Size2dPtr strides,
      Size2dPtr dilations,
      InputOperandLayout layout);

Pool2d(const Pool2d&) = delete;
Pool2d& operator=(const Pool2d&) = delete;

  ~Pool2d();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = Pool2dPtr>
  Pool2dPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Pool2d::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Pool2d::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Pool2d::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Pool2d::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Pool2d::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Pool2d_UnserializedMessageContext<
            UserType, Pool2d::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Pool2d::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Pool2d::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Pool2d_UnserializedMessageContext<
            UserType, Pool2d::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Pool2d::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  Pool2d::Kind kind;
  
  uint64_t input_operand_id;
  
  uint64_t output_operand_id;
  
  Size2dPtr window_dimensions;
  
  Padding2dPtr padding;
  
  Size2dPtr strides;
  
  Size2dPtr dilations;
  
  InputOperandLayout layout;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Pool2d::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Pool2d::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Pool2d::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Pool2d::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  Slice {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Slice, T>::value>;
  using DataView = SliceDataView;
  using Data_ = internal::Slice_Data;

  template <typename... Args>
  static SlicePtr New(Args&&... args) {
    return SlicePtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static SlicePtr From(const U& u) {
    return mojo::TypeConverter<SlicePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Slice>::Convert(*this);
  }


  Slice();

  Slice(
      uint64_t input_operand_id,
      uint64_t output_operand_id,
      WTF::Vector<StartAndSizePtr> starts_and_sizes);

Slice(const Slice&) = delete;
Slice& operator=(const Slice&) = delete;

  ~Slice();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = SlicePtr>
  SlicePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Slice::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Slice::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Slice::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Slice::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Slice::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Slice_UnserializedMessageContext<
            UserType, Slice::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Slice::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Slice::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Slice_UnserializedMessageContext<
            UserType, Slice::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Slice::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t input_operand_id;
  
  uint64_t output_operand_id;
  
  WTF::Vector<StartAndSizePtr> starts_and_sizes;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Slice::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Slice::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Slice::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Slice::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}







class  Gemm {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Gemm, T>::value>;
  using DataView = GemmDataView;
  using Data_ = internal::Gemm_Data;

  template <typename... Args>
  static GemmPtr New(Args&&... args) {
    return GemmPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static GemmPtr From(const U& u) {
    return mojo::TypeConverter<GemmPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Gemm>::Convert(*this);
  }


  Gemm();

  Gemm(
      uint64_t a_operand_id,
      uint64_t b_operand_id,
      uint64_t output_operand_id,
      std::optional<uint64_t> c_operand_id,
      float alpha,
      float beta,
      bool a_transpose,
      bool b_transpose);


  ~Gemm();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = GemmPtr>
  GemmPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Gemm::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Gemm::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Gemm::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Gemm::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Gemm::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Gemm_UnserializedMessageContext<
            UserType, Gemm::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Gemm::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Gemm::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Gemm_UnserializedMessageContext<
            UserType, Gemm::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Gemm::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t a_operand_id;
  
  uint64_t b_operand_id;
  
  uint64_t output_operand_id;
  
  std::optional<uint64_t> c_operand_id;
  
  float alpha;
  
  float beta;
  
  bool a_transpose;
  
  bool b_transpose;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Gemm::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Gemm::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Gemm::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Gemm::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  LayerNormalization {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<LayerNormalization, T>::value>;
  using DataView = LayerNormalizationDataView;
  using Data_ = internal::LayerNormalization_Data;

  template <typename... Args>
  static LayerNormalizationPtr New(Args&&... args) {
    return LayerNormalizationPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static LayerNormalizationPtr From(const U& u) {
    return mojo::TypeConverter<LayerNormalizationPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, LayerNormalization>::Convert(*this);
  }


  LayerNormalization();

  LayerNormalization(
      uint64_t input_operand_id,
      uint64_t output_operand_id,
      std::optional<uint64_t> scale_operand_id,
      std::optional<uint64_t> bias_operand_id,
      WTF::Vector<uint32_t> axes,
      float epsilon);


  ~LayerNormalization();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = LayerNormalizationPtr>
  LayerNormalizationPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, LayerNormalization::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, LayerNormalization::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, LayerNormalization::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        LayerNormalization::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        LayerNormalization::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::LayerNormalization_UnserializedMessageContext<
            UserType, LayerNormalization::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<LayerNormalization::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return LayerNormalization::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::LayerNormalization_UnserializedMessageContext<
            UserType, LayerNormalization::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<LayerNormalization::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t input_operand_id;
  
  uint64_t output_operand_id;
  
  std::optional<uint64_t> scale_operand_id;
  
  std::optional<uint64_t> bias_operand_id;
  
  WTF::Vector<uint32_t> axes;
  
  float epsilon;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, LayerNormalization::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, LayerNormalization::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, LayerNormalization::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, LayerNormalization::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}














class  Split {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Split, T>::value>;
  using DataView = SplitDataView;
  using Data_ = internal::Split_Data;

  template <typename... Args>
  static SplitPtr New(Args&&... args) {
    return SplitPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static SplitPtr From(const U& u) {
    return mojo::TypeConverter<SplitPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Split>::Convert(*this);
  }


  Split();

  Split(
      uint64_t input_operand_id,
      WTF::Vector<uint64_t> output_operand_ids,
      uint32_t axis);


  ~Split();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = SplitPtr>
  SplitPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Split::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Split::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Split::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Split::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Split::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Split_UnserializedMessageContext<
            UserType, Split::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Split::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Split::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Split_UnserializedMessageContext<
            UserType, Split::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Split::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t input_operand_id;
  
  WTF::Vector<uint64_t> output_operand_ids;
  
  uint32_t axis;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Split::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Split::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Split::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Split::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  Transpose {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Transpose, T>::value>;
  using DataView = TransposeDataView;
  using Data_ = internal::Transpose_Data;

  template <typename... Args>
  static TransposePtr New(Args&&... args) {
    return TransposePtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static TransposePtr From(const U& u) {
    return mojo::TypeConverter<TransposePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Transpose>::Convert(*this);
  }


  Transpose();

  Transpose(
      uint64_t input_operand_id,
      uint64_t output_operand_id,
      WTF::Vector<uint32_t> permutation);


  ~Transpose();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = TransposePtr>
  TransposePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Transpose::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Transpose::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Transpose::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Transpose::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Transpose::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Transpose_UnserializedMessageContext<
            UserType, Transpose::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Transpose::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Transpose::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Transpose_UnserializedMessageContext<
            UserType, Transpose::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Transpose::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t input_operand_id;
  
  uint64_t output_operand_id;
  
  WTF::Vector<uint32_t> permutation;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Transpose::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Transpose::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Transpose::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Transpose::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  Resample2d {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Resample2d, T>::value>;
  using DataView = Resample2dDataView;
  using Data_ = internal::Resample2d_Data;
  using InterpolationMode = Resample2d_InterpolationMode;

  template <typename... Args>
  static Resample2dPtr New(Args&&... args) {
    return Resample2dPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static Resample2dPtr From(const U& u) {
    return mojo::TypeConverter<Resample2dPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Resample2d>::Convert(*this);
  }


  Resample2d();

  Resample2d(
      uint64_t input_operand_id,
      uint64_t output_operand_id,
      Resample2d::InterpolationMode mode,
      std::optional<WTF::Vector<float>> scales,
      WTF::Vector<uint32_t> axes);


  ~Resample2d();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = Resample2dPtr>
  Resample2dPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Resample2d::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Resample2d::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, Resample2d::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Resample2d::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Resample2d::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Resample2d_UnserializedMessageContext<
            UserType, Resample2d::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Resample2d::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return Resample2d::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Resample2d_UnserializedMessageContext<
            UserType, Resample2d::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Resample2d::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint64_t input_operand_id;
  
  uint64_t output_operand_id;
  
  Resample2d::InterpolationMode mode;
  
  std::optional<WTF::Vector<float>> scales;
  
  WTF::Vector<uint32_t> axes;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Resample2d::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Resample2d::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Resample2d::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Resample2d::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  GraphInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<GraphInfo, T>::value>;
  using DataView = GraphInfoDataView;
  using Data_ = internal::GraphInfo_Data;

  template <typename... Args>
  static GraphInfoPtr New(Args&&... args) {
    return GraphInfoPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static GraphInfoPtr From(const U& u) {
    return mojo::TypeConverter<GraphInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, GraphInfo>::Convert(*this);
  }


  GraphInfo();

  GraphInfo(
      WTF::HashMap<uint64_t, OperandPtr> id_to_operand_map,
      WTF::Vector<uint64_t> input_operands,
      WTF::Vector<uint64_t> output_operands,
      WTF::Vector<OperationPtr> operations,
      WTF::HashMap<uint64_t, ::mojo_base::BigBuffer> constant_id_to_buffer_map);

GraphInfo(const GraphInfo&) = delete;
GraphInfo& operator=(const GraphInfo&) = delete;

  ~GraphInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = GraphInfoPtr>
  GraphInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, GraphInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, GraphInfo::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, GraphInfo::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        GraphInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::GraphInfo_UnserializedMessageContext<
            UserType, GraphInfo::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<GraphInfo::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return GraphInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::GraphInfo_UnserializedMessageContext<
            UserType, GraphInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<GraphInfo::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  WTF::HashMap<uint64_t, OperandPtr> id_to_operand_map;
  
  WTF::Vector<uint64_t> input_operands;
  
  WTF::Vector<uint64_t> output_operands;
  
  WTF::Vector<OperationPtr> operations;
  
  WTF::HashMap<uint64_t, ::mojo_base::BigBuffer> constant_id_to_buffer_map;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, GraphInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, GraphInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, GraphInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, GraphInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename UnionPtrType>
PaddingModePtr PaddingMode::Clone() const {
  switch (tag_) {
    case Tag::kConstant:
      return NewConstant(
          mojo::Clone(*data_.constant));
    case Tag::kEdge:
      return NewEdge(
          mojo::Clone(*data_.edge));
    case Tag::kReflection:
      return NewReflection(
          mojo::Clone(*data_.reflection));
    case Tag::kSymmetric:
      return NewSymmetric(
          mojo::Clone(*data_.symmetric));
  }
  return nullptr;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, PaddingMode>::value>::type*>
bool PaddingMode::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::kConstant:
      return mojo::Equals(*(data_.constant), *(other.data_.constant));
    case Tag::kEdge:
      return mojo::Equals(*(data_.edge), *(other.data_.edge));
    case Tag::kReflection:
      return mojo::Equals(*(data_.reflection), *(other.data_.reflection));
    case Tag::kSymmetric:
      return mojo::Equals(*(data_.symmetric), *(other.data_.symmetric));
  }

  return false;
}
template <typename UnionPtrType>
ActivationPtr Activation::Clone() const {
  switch (tag_) {
    case Tag::kClamp:
      return NewClamp(
          mojo::Clone(*data_.clamp));
    case Tag::kElu:
      return NewElu(
          mojo::Clone(*data_.elu));
    case Tag::kHardSigmoid:
      return NewHardSigmoid(
          mojo::Clone(*data_.hard_sigmoid));
    case Tag::kLeakyRelu:
      return NewLeakyRelu(
          mojo::Clone(*data_.leaky_relu));
    case Tag::kLinear:
      return NewLinear(
          mojo::Clone(*data_.linear));
    case Tag::kRelu:
      return NewRelu(
          mojo::Clone(*data_.relu));
    case Tag::kSigmoid:
      return NewSigmoid(
          mojo::Clone(*data_.sigmoid));
    case Tag::kSoftmax:
      return NewSoftmax(
          mojo::Clone(*data_.softmax));
    case Tag::kSoftplus:
      return NewSoftplus(
          mojo::Clone(*data_.softplus));
    case Tag::kSoftsign:
      return NewSoftsign(
          mojo::Clone(*data_.softsign));
    case Tag::kTanh:
      return NewTanh(
          mojo::Clone(*data_.tanh));
  }
  return nullptr;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, Activation>::value>::type*>
bool Activation::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::kClamp:
      return mojo::Equals(*(data_.clamp), *(other.data_.clamp));
    case Tag::kElu:
      return mojo::Equals(*(data_.elu), *(other.data_.elu));
    case Tag::kHardSigmoid:
      return mojo::Equals(*(data_.hard_sigmoid), *(other.data_.hard_sigmoid));
    case Tag::kLeakyRelu:
      return mojo::Equals(*(data_.leaky_relu), *(other.data_.leaky_relu));
    case Tag::kLinear:
      return mojo::Equals(*(data_.linear), *(other.data_.linear));
    case Tag::kRelu:
      return mojo::Equals(*(data_.relu), *(other.data_.relu));
    case Tag::kSigmoid:
      return mojo::Equals(*(data_.sigmoid), *(other.data_.sigmoid));
    case Tag::kSoftmax:
      return mojo::Equals(*(data_.softmax), *(other.data_.softmax));
    case Tag::kSoftplus:
      return mojo::Equals(*(data_.softplus), *(other.data_.softplus));
    case Tag::kSoftsign:
      return mojo::Equals(*(data_.softsign), *(other.data_.softsign));
    case Tag::kTanh:
      return mojo::Equals(*(data_.tanh), *(other.data_.tanh));
  }

  return false;
}
template <typename UnionPtrType>
OperationPtr Operation::Clone() const {
  switch (tag_) {
    case Tag::kArgMinMax:
      return NewArgMinMax(
          mojo::Clone(*data_.arg_min_max));
    case Tag::kBatchNormalization:
      return NewBatchNormalization(
          mojo::Clone(*data_.batch_normalization));
    case Tag::kClamp:
      return NewClamp(
          mojo::Clone(*data_.clamp));
    case Tag::kConcat:
      return NewConcat(
          mojo::Clone(*data_.concat));
    case Tag::kConv2d:
      return NewConv2d(
          mojo::Clone(*data_.conv2d));
    case Tag::kElementWiseBinary:
      return NewElementWiseBinary(
          mojo::Clone(*data_.element_wise_binary));
    case Tag::kElu:
      return NewElu(
          mojo::Clone(*data_.elu));
    case Tag::kElementWiseUnary:
      return NewElementWiseUnary(
          mojo::Clone(*data_.element_wise_unary));
    case Tag::kExpand:
      return NewExpand(
          mojo::Clone(*data_.expand));
    case Tag::kGather:
      return NewGather(
          mojo::Clone(*data_.gather));
    case Tag::kGemm:
      return NewGemm(
          mojo::Clone(*data_.gemm));
    case Tag::kHardSigmoid:
      return NewHardSigmoid(
          mojo::Clone(*data_.hard_sigmoid));
    case Tag::kLayerNormalization:
      return NewLayerNormalization(
          mojo::Clone(*data_.layer_normalization));
    case Tag::kInstanceNormalization:
      return NewInstanceNormalization(
          mojo::Clone(*data_.instance_normalization));
    case Tag::kLeakyRelu:
      return NewLeakyRelu(
          mojo::Clone(*data_.leaky_relu));
    case Tag::kLinear:
      return NewLinear(
          mojo::Clone(*data_.linear));
    case Tag::kMatmul:
      return NewMatmul(
          mojo::Clone(*data_.matmul));
    case Tag::kPad:
      return NewPad(
          mojo::Clone(*data_.pad));
    case Tag::kPool2d:
      return NewPool2d(
          mojo::Clone(*data_.pool2d));
    case Tag::kPrelu:
      return NewPrelu(
          mojo::Clone(*data_.prelu));
    case Tag::kReduce:
      return NewReduce(
          mojo::Clone(*data_.reduce));
    case Tag::kRelu:
      return NewRelu(
          mojo::Clone(*data_.relu));
    case Tag::kResample2d:
      return NewResample2d(
          mojo::Clone(*data_.resample2d));
    case Tag::kReshape:
      return NewReshape(
          mojo::Clone(*data_.reshape));
    case Tag::kSigmoid:
      return NewSigmoid(
          mojo::Clone(*data_.sigmoid));
    case Tag::kSlice:
      return NewSlice(
          mojo::Clone(*data_.slice));
    case Tag::kSoftmax:
      return NewSoftmax(
          mojo::Clone(*data_.softmax));
    case Tag::kSoftplus:
      return NewSoftplus(
          mojo::Clone(*data_.softplus));
    case Tag::kSoftsign:
      return NewSoftsign(
          mojo::Clone(*data_.softsign));
    case Tag::kSplit:
      return NewSplit(
          mojo::Clone(*data_.split));
    case Tag::kTanh:
      return NewTanh(
          mojo::Clone(*data_.tanh));
    case Tag::kTranspose:
      return NewTranspose(
          mojo::Clone(*data_.transpose));
    case Tag::kWhere:
      return NewWhere(
          mojo::Clone(*data_.where));
  }
  return nullptr;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, Operation>::value>::type*>
bool Operation::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::kArgMinMax:
      return mojo::Equals(*(data_.arg_min_max), *(other.data_.arg_min_max));
    case Tag::kBatchNormalization:
      return mojo::Equals(*(data_.batch_normalization), *(other.data_.batch_normalization));
    case Tag::kClamp:
      return mojo::Equals(*(data_.clamp), *(other.data_.clamp));
    case Tag::kConcat:
      return mojo::Equals(*(data_.concat), *(other.data_.concat));
    case Tag::kConv2d:
      return mojo::Equals(*(data_.conv2d), *(other.data_.conv2d));
    case Tag::kElementWiseBinary:
      return mojo::Equals(*(data_.element_wise_binary), *(other.data_.element_wise_binary));
    case Tag::kElu:
      return mojo::Equals(*(data_.elu), *(other.data_.elu));
    case Tag::kElementWiseUnary:
      return mojo::Equals(*(data_.element_wise_unary), *(other.data_.element_wise_unary));
    case Tag::kExpand:
      return mojo::Equals(*(data_.expand), *(other.data_.expand));
    case Tag::kGather:
      return mojo::Equals(*(data_.gather), *(other.data_.gather));
    case Tag::kGemm:
      return mojo::Equals(*(data_.gemm), *(other.data_.gemm));
    case Tag::kHardSigmoid:
      return mojo::Equals(*(data_.hard_sigmoid), *(other.data_.hard_sigmoid));
    case Tag::kLayerNormalization:
      return mojo::Equals(*(data_.layer_normalization), *(other.data_.layer_normalization));
    case Tag::kInstanceNormalization:
      return mojo::Equals(*(data_.instance_normalization), *(other.data_.instance_normalization));
    case Tag::kLeakyRelu:
      return mojo::Equals(*(data_.leaky_relu), *(other.data_.leaky_relu));
    case Tag::kLinear:
      return mojo::Equals(*(data_.linear), *(other.data_.linear));
    case Tag::kMatmul:
      return mojo::Equals(*(data_.matmul), *(other.data_.matmul));
    case Tag::kPad:
      return mojo::Equals(*(data_.pad), *(other.data_.pad));
    case Tag::kPool2d:
      return mojo::Equals(*(data_.pool2d), *(other.data_.pool2d));
    case Tag::kPrelu:
      return mojo::Equals(*(data_.prelu), *(other.data_.prelu));
    case Tag::kReduce:
      return mojo::Equals(*(data_.reduce), *(other.data_.reduce));
    case Tag::kRelu:
      return mojo::Equals(*(data_.relu), *(other.data_.relu));
    case Tag::kResample2d:
      return mojo::Equals(*(data_.resample2d), *(other.data_.resample2d));
    case Tag::kReshape:
      return mojo::Equals(*(data_.reshape), *(other.data_.reshape));
    case Tag::kSigmoid:
      return mojo::Equals(*(data_.sigmoid), *(other.data_.sigmoid));
    case Tag::kSlice:
      return mojo::Equals(*(data_.slice), *(other.data_.slice));
    case Tag::kSoftmax:
      return mojo::Equals(*(data_.softmax), *(other.data_.softmax));
    case Tag::kSoftplus:
      return mojo::Equals(*(data_.softplus), *(other.data_.softplus));
    case Tag::kSoftsign:
      return mojo::Equals(*(data_.softsign), *(other.data_.softsign));
    case Tag::kSplit:
      return mojo::Equals(*(data_.split), *(other.data_.split));
    case Tag::kTanh:
      return mojo::Equals(*(data_.tanh), *(other.data_.tanh));
    case Tag::kTranspose:
      return mojo::Equals(*(data_.transpose), *(other.data_.transpose));
    case Tag::kWhere:
      return mojo::Equals(*(data_.where), *(other.data_.where));
  }

  return false;
}
template <typename UnionPtrType>
ComputeResultPtr ComputeResult::Clone() const {
  switch (tag_) {
    case Tag::kNamedOutputs:
      return NewNamedOutputs(
          mojo::Clone(*data_.named_outputs));
    case Tag::kError:
      return NewError(
          mojo::Clone(*data_.error));
  }
  return nullptr;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, ComputeResult>::value>::type*>
bool ComputeResult::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::kNamedOutputs:
      return mojo::Equals(*(data_.named_outputs), *(other.data_.named_outputs));
    case Tag::kError:
      return mojo::Equals(*(data_.error), *(other.data_.error));
  }

  return false;
}
template <typename StructPtrType>
OperandPtr Operand::Clone() const {
  return New(
      mojo::Clone(kind),
      mojo::Clone(data_type),
      mojo::Clone(dimensions),
      mojo::Clone(name)
  );
}

template <typename T, Operand::EnableIfSame<T>*>
bool Operand::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->kind, other_struct.kind))
    return false;
  if (!mojo::Equals(this->data_type, other_struct.data_type))
    return false;
  if (!mojo::Equals(this->dimensions, other_struct.dimensions))
    return false;
  if (!mojo::Equals(this->name, other_struct.name))
    return false;
  return true;
}

template <typename T, Operand::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.kind < rhs.kind)
    return true;
  if (rhs.kind < lhs.kind)
    return false;
  if (lhs.data_type < rhs.data_type)
    return true;
  if (rhs.data_type < lhs.data_type)
    return false;
  if (lhs.dimensions < rhs.dimensions)
    return true;
  if (rhs.dimensions < lhs.dimensions)
    return false;
  if (lhs.name < rhs.name)
    return true;
  if (rhs.name < lhs.name)
    return false;
  return false;
}
template <typename StructPtrType>
ArgMinMaxPtr ArgMinMax::Clone() const {
  return New(
      mojo::Clone(kind),
      mojo::Clone(input_operand_id),
      mojo::Clone(output_operand_id),
      mojo::Clone(axes),
      mojo::Clone(keep_dimensions),
      mojo::Clone(select_last_index)
  );
}

template <typename T, ArgMinMax::EnableIfSame<T>*>
bool ArgMinMax::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->kind, other_struct.kind))
    return false;
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  if (!mojo::Equals(this->axes, other_struct.axes))
    return false;
  if (!mojo::Equals(this->keep_dimensions, other_struct.keep_dimensions))
    return false;
  if (!mojo::Equals(this->select_last_index, other_struct.select_last_index))
    return false;
  return true;
}

template <typename T, ArgMinMax::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.kind < rhs.kind)
    return true;
  if (rhs.kind < lhs.kind)
    return false;
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  if (lhs.axes < rhs.axes)
    return true;
  if (rhs.axes < lhs.axes)
    return false;
  if (lhs.keep_dimensions < rhs.keep_dimensions)
    return true;
  if (rhs.keep_dimensions < lhs.keep_dimensions)
    return false;
  if (lhs.select_last_index < rhs.select_last_index)
    return true;
  if (rhs.select_last_index < lhs.select_last_index)
    return false;
  return false;
}
template <typename StructPtrType>
BatchNormalizationPtr BatchNormalization::Clone() const {
  return New(
      mojo::Clone(input_operand_id),
      mojo::Clone(mean_operand_id),
      mojo::Clone(variance_operand_id),
      mojo::Clone(output_operand_id),
      mojo::Clone(scale_operand_id),
      mojo::Clone(bias_operand_id),
      mojo::Clone(axis),
      mojo::Clone(epsilon),
      mojo::Clone(activation)
  );
}

template <typename T, BatchNormalization::EnableIfSame<T>*>
bool BatchNormalization::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->mean_operand_id, other_struct.mean_operand_id))
    return false;
  if (!mojo::Equals(this->variance_operand_id, other_struct.variance_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  if (!mojo::Equals(this->scale_operand_id, other_struct.scale_operand_id))
    return false;
  if (!mojo::Equals(this->bias_operand_id, other_struct.bias_operand_id))
    return false;
  if (!mojo::Equals(this->axis, other_struct.axis))
    return false;
  if (!mojo::Equals(this->epsilon, other_struct.epsilon))
    return false;
  if (!mojo::Equals(this->activation, other_struct.activation))
    return false;
  return true;
}

template <typename T, BatchNormalization::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.mean_operand_id < rhs.mean_operand_id)
    return true;
  if (rhs.mean_operand_id < lhs.mean_operand_id)
    return false;
  if (lhs.variance_operand_id < rhs.variance_operand_id)
    return true;
  if (rhs.variance_operand_id < lhs.variance_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  if (lhs.scale_operand_id < rhs.scale_operand_id)
    return true;
  if (rhs.scale_operand_id < lhs.scale_operand_id)
    return false;
  if (lhs.bias_operand_id < rhs.bias_operand_id)
    return true;
  if (rhs.bias_operand_id < lhs.bias_operand_id)
    return false;
  if (lhs.axis < rhs.axis)
    return true;
  if (rhs.axis < lhs.axis)
    return false;
  if (lhs.epsilon < rhs.epsilon)
    return true;
  if (rhs.epsilon < lhs.epsilon)
    return false;
  if (lhs.activation < rhs.activation)
    return true;
  if (rhs.activation < lhs.activation)
    return false;
  return false;
}
template <typename StructPtrType>
ClampPtr Clamp::Clone() const {
  return New(
      mojo::Clone(input_operand_id),
      mojo::Clone(output_operand_id),
      mojo::Clone(min_value),
      mojo::Clone(max_value)
  );
}

template <typename T, Clamp::EnableIfSame<T>*>
bool Clamp::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  if (!mojo::Equals(this->min_value, other_struct.min_value))
    return false;
  if (!mojo::Equals(this->max_value, other_struct.max_value))
    return false;
  return true;
}

template <typename T, Clamp::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  if (lhs.min_value < rhs.min_value)
    return true;
  if (rhs.min_value < lhs.min_value)
    return false;
  if (lhs.max_value < rhs.max_value)
    return true;
  if (rhs.max_value < lhs.max_value)
    return false;
  return false;
}
template <typename StructPtrType>
ConcatPtr Concat::Clone() const {
  return New(
      mojo::Clone(input_operand_ids),
      mojo::Clone(output_operand_id),
      mojo::Clone(axis)
  );
}

template <typename T, Concat::EnableIfSame<T>*>
bool Concat::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input_operand_ids, other_struct.input_operand_ids))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  if (!mojo::Equals(this->axis, other_struct.axis))
    return false;
  return true;
}

template <typename T, Concat::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input_operand_ids < rhs.input_operand_ids)
    return true;
  if (rhs.input_operand_ids < lhs.input_operand_ids)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  if (lhs.axis < rhs.axis)
    return true;
  if (rhs.axis < lhs.axis)
    return false;
  return false;
}
template <typename StructPtrType>
Size2dPtr Size2d::Clone() const {
  return New(
      mojo::Clone(height),
      mojo::Clone(width)
  );
}

template <typename T, Size2d::EnableIfSame<T>*>
bool Size2d::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->height, other_struct.height))
    return false;
  if (!mojo::Equals(this->width, other_struct.width))
    return false;
  return true;
}

template <typename T, Size2d::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.height < rhs.height)
    return true;
  if (rhs.height < lhs.height)
    return false;
  if (lhs.width < rhs.width)
    return true;
  if (rhs.width < lhs.width)
    return false;
  return false;
}
template <typename StructPtrType>
Padding2dPtr Padding2d::Clone() const {
  return New(
      mojo::Clone(beginning),
      mojo::Clone(ending)
  );
}

template <typename T, Padding2d::EnableIfSame<T>*>
bool Padding2d::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->beginning, other_struct.beginning))
    return false;
  if (!mojo::Equals(this->ending, other_struct.ending))
    return false;
  return true;
}

template <typename T, Padding2d::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.beginning < rhs.beginning)
    return true;
  if (rhs.beginning < lhs.beginning)
    return false;
  if (lhs.ending < rhs.ending)
    return true;
  if (rhs.ending < lhs.ending)
    return false;
  return false;
}
template <typename StructPtrType>
Conv2dPtr Conv2d::Clone() const {
  return New(
      mojo::Clone(type),
      mojo::Clone(input_operand_id),
      mojo::Clone(filter_operand_id),
      mojo::Clone(output_operand_id),
      mojo::Clone(padding),
      mojo::Clone(strides),
      mojo::Clone(dilations),
      mojo::Clone(groups),
      mojo::Clone(input_layout),
      mojo::Clone(bias_operand_id),
      mojo::Clone(activation)
  );
}

template <typename T, Conv2d::EnableIfSame<T>*>
bool Conv2d::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->type, other_struct.type))
    return false;
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->filter_operand_id, other_struct.filter_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  if (!mojo::Equals(this->padding, other_struct.padding))
    return false;
  if (!mojo::Equals(this->strides, other_struct.strides))
    return false;
  if (!mojo::Equals(this->dilations, other_struct.dilations))
    return false;
  if (!mojo::Equals(this->groups, other_struct.groups))
    return false;
  if (!mojo::Equals(this->input_layout, other_struct.input_layout))
    return false;
  if (!mojo::Equals(this->bias_operand_id, other_struct.bias_operand_id))
    return false;
  if (!mojo::Equals(this->activation, other_struct.activation))
    return false;
  return true;
}

template <typename T, Conv2d::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.type < rhs.type)
    return true;
  if (rhs.type < lhs.type)
    return false;
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.filter_operand_id < rhs.filter_operand_id)
    return true;
  if (rhs.filter_operand_id < lhs.filter_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  if (lhs.padding < rhs.padding)
    return true;
  if (rhs.padding < lhs.padding)
    return false;
  if (lhs.strides < rhs.strides)
    return true;
  if (rhs.strides < lhs.strides)
    return false;
  if (lhs.dilations < rhs.dilations)
    return true;
  if (rhs.dilations < lhs.dilations)
    return false;
  if (lhs.groups < rhs.groups)
    return true;
  if (rhs.groups < lhs.groups)
    return false;
  if (lhs.input_layout < rhs.input_layout)
    return true;
  if (rhs.input_layout < lhs.input_layout)
    return false;
  if (lhs.bias_operand_id < rhs.bias_operand_id)
    return true;
  if (rhs.bias_operand_id < lhs.bias_operand_id)
    return false;
  if (lhs.activation < rhs.activation)
    return true;
  if (rhs.activation < lhs.activation)
    return false;
  return false;
}
template <typename StructPtrType>
ElementWiseBinaryPtr ElementWiseBinary::Clone() const {
  return New(
      mojo::Clone(kind),
      mojo::Clone(lhs_operand),
      mojo::Clone(rhs_operand),
      mojo::Clone(output_operand)
  );
}

template <typename T, ElementWiseBinary::EnableIfSame<T>*>
bool ElementWiseBinary::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->kind, other_struct.kind))
    return false;
  if (!mojo::Equals(this->lhs_operand, other_struct.lhs_operand))
    return false;
  if (!mojo::Equals(this->rhs_operand, other_struct.rhs_operand))
    return false;
  if (!mojo::Equals(this->output_operand, other_struct.output_operand))
    return false;
  return true;
}

template <typename T, ElementWiseBinary::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.kind < rhs.kind)
    return true;
  if (rhs.kind < lhs.kind)
    return false;
  if (lhs.lhs_operand < rhs.lhs_operand)
    return true;
  if (rhs.lhs_operand < lhs.lhs_operand)
    return false;
  if (lhs.rhs_operand < rhs.rhs_operand)
    return true;
  if (rhs.rhs_operand < lhs.rhs_operand)
    return false;
  if (lhs.output_operand < rhs.output_operand)
    return true;
  if (rhs.output_operand < lhs.output_operand)
    return false;
  return false;
}
template <typename StructPtrType>
ElementWiseUnaryPtr ElementWiseUnary::Clone() const {
  return New(
      mojo::Clone(kind),
      mojo::Clone(input_operand_id),
      mojo::Clone(output_operand_id)
  );
}

template <typename T, ElementWiseUnary::EnableIfSame<T>*>
bool ElementWiseUnary::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->kind, other_struct.kind))
    return false;
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  return true;
}

template <typename T, ElementWiseUnary::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.kind < rhs.kind)
    return true;
  if (rhs.kind < lhs.kind)
    return false;
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  return false;
}
template <typename StructPtrType>
ExpandPtr Expand::Clone() const {
  return New(
      mojo::Clone(input_operand_id),
      mojo::Clone(output_operand_id)
  );
}

template <typename T, Expand::EnableIfSame<T>*>
bool Expand::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  return true;
}

template <typename T, Expand::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  return false;
}
template <typename StructPtrType>
ConstantPaddingPtr ConstantPadding::Clone() const {
  return New(
      mojo::Clone(value)
  );
}

template <typename T, ConstantPadding::EnableIfSame<T>*>
bool ConstantPadding::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->value, other_struct.value))
    return false;
  return true;
}

template <typename T, ConstantPadding::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.value < rhs.value)
    return true;
  if (rhs.value < lhs.value)
    return false;
  return false;
}
template <typename StructPtrType>
EdgePaddingPtr EdgePadding::Clone() const {
  return New(
  );
}

template <typename T, EdgePadding::EnableIfSame<T>*>
bool EdgePadding::Equals(const T& other_struct) const {
  return true;
}

template <typename T, EdgePadding::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  return false;
}
template <typename StructPtrType>
ReflectionPaddingPtr ReflectionPadding::Clone() const {
  return New(
  );
}

template <typename T, ReflectionPadding::EnableIfSame<T>*>
bool ReflectionPadding::Equals(const T& other_struct) const {
  return true;
}

template <typename T, ReflectionPadding::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  return false;
}
template <typename StructPtrType>
SymmetricPaddingPtr SymmetricPadding::Clone() const {
  return New(
  );
}

template <typename T, SymmetricPadding::EnableIfSame<T>*>
bool SymmetricPadding::Equals(const T& other_struct) const {
  return true;
}

template <typename T, SymmetricPadding::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  return false;
}
template <typename StructPtrType>
InstanceNormalizationPtr InstanceNormalization::Clone() const {
  return New(
      mojo::Clone(input_operand_id),
      mojo::Clone(output_operand_id),
      mojo::Clone(scale_operand_id),
      mojo::Clone(bias_operand_id),
      mojo::Clone(epsilon),
      mojo::Clone(layout)
  );
}

template <typename T, InstanceNormalization::EnableIfSame<T>*>
bool InstanceNormalization::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  if (!mojo::Equals(this->scale_operand_id, other_struct.scale_operand_id))
    return false;
  if (!mojo::Equals(this->bias_operand_id, other_struct.bias_operand_id))
    return false;
  if (!mojo::Equals(this->epsilon, other_struct.epsilon))
    return false;
  if (!mojo::Equals(this->layout, other_struct.layout))
    return false;
  return true;
}

template <typename T, InstanceNormalization::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  if (lhs.scale_operand_id < rhs.scale_operand_id)
    return true;
  if (rhs.scale_operand_id < lhs.scale_operand_id)
    return false;
  if (lhs.bias_operand_id < rhs.bias_operand_id)
    return true;
  if (rhs.bias_operand_id < lhs.bias_operand_id)
    return false;
  if (lhs.epsilon < rhs.epsilon)
    return true;
  if (rhs.epsilon < lhs.epsilon)
    return false;
  if (lhs.layout < rhs.layout)
    return true;
  if (rhs.layout < lhs.layout)
    return false;
  return false;
}
template <typename StructPtrType>
MatmulPtr Matmul::Clone() const {
  return New(
      mojo::Clone(a_operand_id),
      mojo::Clone(b_operand_id),
      mojo::Clone(output_operand_id)
  );
}

template <typename T, Matmul::EnableIfSame<T>*>
bool Matmul::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->a_operand_id, other_struct.a_operand_id))
    return false;
  if (!mojo::Equals(this->b_operand_id, other_struct.b_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  return true;
}

template <typename T, Matmul::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.a_operand_id < rhs.a_operand_id)
    return true;
  if (rhs.a_operand_id < lhs.a_operand_id)
    return false;
  if (lhs.b_operand_id < rhs.b_operand_id)
    return true;
  if (rhs.b_operand_id < lhs.b_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  return false;
}
template <typename StructPtrType>
PadPtr Pad::Clone() const {
  return New(
      mojo::Clone(input_operand_id),
      mojo::Clone(output_operand_id),
      mojo::Clone(beginning_padding),
      mojo::Clone(ending_padding),
      mojo::Clone(mode)
  );
}

template <typename T, Pad::EnableIfSame<T>*>
bool Pad::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  if (!mojo::Equals(this->beginning_padding, other_struct.beginning_padding))
    return false;
  if (!mojo::Equals(this->ending_padding, other_struct.ending_padding))
    return false;
  if (!mojo::Equals(this->mode, other_struct.mode))
    return false;
  return true;
}

template <typename T, Pad::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  if (lhs.beginning_padding < rhs.beginning_padding)
    return true;
  if (rhs.beginning_padding < lhs.beginning_padding)
    return false;
  if (lhs.ending_padding < rhs.ending_padding)
    return true;
  if (rhs.ending_padding < lhs.ending_padding)
    return false;
  if (lhs.mode < rhs.mode)
    return true;
  if (rhs.mode < lhs.mode)
    return false;
  return false;
}
template <typename StructPtrType>
ReducePtr Reduce::Clone() const {
  return New(
      mojo::Clone(kind),
      mojo::Clone(input_operand_id),
      mojo::Clone(output_operand_id),
      mojo::Clone(axes),
      mojo::Clone(keep_dimensions)
  );
}

template <typename T, Reduce::EnableIfSame<T>*>
bool Reduce::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->kind, other_struct.kind))
    return false;
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  if (!mojo::Equals(this->axes, other_struct.axes))
    return false;
  if (!mojo::Equals(this->keep_dimensions, other_struct.keep_dimensions))
    return false;
  return true;
}

template <typename T, Reduce::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.kind < rhs.kind)
    return true;
  if (rhs.kind < lhs.kind)
    return false;
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  if (lhs.axes < rhs.axes)
    return true;
  if (rhs.axes < lhs.axes)
    return false;
  if (lhs.keep_dimensions < rhs.keep_dimensions)
    return true;
  if (rhs.keep_dimensions < lhs.keep_dimensions)
    return false;
  return false;
}
template <typename StructPtrType>
Pool2dPtr Pool2d::Clone() const {
  return New(
      mojo::Clone(kind),
      mojo::Clone(input_operand_id),
      mojo::Clone(output_operand_id),
      mojo::Clone(window_dimensions),
      mojo::Clone(padding),
      mojo::Clone(strides),
      mojo::Clone(dilations),
      mojo::Clone(layout)
  );
}

template <typename T, Pool2d::EnableIfSame<T>*>
bool Pool2d::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->kind, other_struct.kind))
    return false;
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  if (!mojo::Equals(this->window_dimensions, other_struct.window_dimensions))
    return false;
  if (!mojo::Equals(this->padding, other_struct.padding))
    return false;
  if (!mojo::Equals(this->strides, other_struct.strides))
    return false;
  if (!mojo::Equals(this->dilations, other_struct.dilations))
    return false;
  if (!mojo::Equals(this->layout, other_struct.layout))
    return false;
  return true;
}

template <typename T, Pool2d::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.kind < rhs.kind)
    return true;
  if (rhs.kind < lhs.kind)
    return false;
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  if (lhs.window_dimensions < rhs.window_dimensions)
    return true;
  if (rhs.window_dimensions < lhs.window_dimensions)
    return false;
  if (lhs.padding < rhs.padding)
    return true;
  if (rhs.padding < lhs.padding)
    return false;
  if (lhs.strides < rhs.strides)
    return true;
  if (rhs.strides < lhs.strides)
    return false;
  if (lhs.dilations < rhs.dilations)
    return true;
  if (rhs.dilations < lhs.dilations)
    return false;
  if (lhs.layout < rhs.layout)
    return true;
  if (rhs.layout < lhs.layout)
    return false;
  return false;
}
template <typename StructPtrType>
StartAndSizePtr StartAndSize::Clone() const {
  return New(
      mojo::Clone(start),
      mojo::Clone(size)
  );
}

template <typename T, StartAndSize::EnableIfSame<T>*>
bool StartAndSize::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->start, other_struct.start))
    return false;
  if (!mojo::Equals(this->size, other_struct.size))
    return false;
  return true;
}

template <typename T, StartAndSize::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.start < rhs.start)
    return true;
  if (rhs.start < lhs.start)
    return false;
  if (lhs.size < rhs.size)
    return true;
  if (rhs.size < lhs.size)
    return false;
  return false;
}
template <typename StructPtrType>
SlicePtr Slice::Clone() const {
  return New(
      mojo::Clone(input_operand_id),
      mojo::Clone(output_operand_id),
      mojo::Clone(starts_and_sizes)
  );
}

template <typename T, Slice::EnableIfSame<T>*>
bool Slice::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  if (!mojo::Equals(this->starts_and_sizes, other_struct.starts_and_sizes))
    return false;
  return true;
}

template <typename T, Slice::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  if (lhs.starts_and_sizes < rhs.starts_and_sizes)
    return true;
  if (rhs.starts_and_sizes < lhs.starts_and_sizes)
    return false;
  return false;
}
template <typename StructPtrType>
EluPtr Elu::Clone() const {
  return New(
      mojo::Clone(input_operand_id),
      mojo::Clone(output_operand_id),
      mojo::Clone(alpha)
  );
}

template <typename T, Elu::EnableIfSame<T>*>
bool Elu::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  if (!mojo::Equals(this->alpha, other_struct.alpha))
    return false;
  return true;
}

template <typename T, Elu::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  if (lhs.alpha < rhs.alpha)
    return true;
  if (rhs.alpha < lhs.alpha)
    return false;
  return false;
}
template <typename StructPtrType>
GatherPtr Gather::Clone() const {
  return New(
      mojo::Clone(input_operand_id),
      mojo::Clone(indices_operand_id),
      mojo::Clone(output_operand_id),
      mojo::Clone(axis)
  );
}

template <typename T, Gather::EnableIfSame<T>*>
bool Gather::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->indices_operand_id, other_struct.indices_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  if (!mojo::Equals(this->axis, other_struct.axis))
    return false;
  return true;
}

template <typename T, Gather::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.indices_operand_id < rhs.indices_operand_id)
    return true;
  if (rhs.indices_operand_id < lhs.indices_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  if (lhs.axis < rhs.axis)
    return true;
  if (rhs.axis < lhs.axis)
    return false;
  return false;
}
template <typename StructPtrType>
GemmPtr Gemm::Clone() const {
  return New(
      mojo::Clone(a_operand_id),
      mojo::Clone(b_operand_id),
      mojo::Clone(output_operand_id),
      mojo::Clone(c_operand_id),
      mojo::Clone(alpha),
      mojo::Clone(beta),
      mojo::Clone(a_transpose),
      mojo::Clone(b_transpose)
  );
}

template <typename T, Gemm::EnableIfSame<T>*>
bool Gemm::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->a_operand_id, other_struct.a_operand_id))
    return false;
  if (!mojo::Equals(this->b_operand_id, other_struct.b_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  if (!mojo::Equals(this->c_operand_id, other_struct.c_operand_id))
    return false;
  if (!mojo::Equals(this->alpha, other_struct.alpha))
    return false;
  if (!mojo::Equals(this->beta, other_struct.beta))
    return false;
  if (!mojo::Equals(this->a_transpose, other_struct.a_transpose))
    return false;
  if (!mojo::Equals(this->b_transpose, other_struct.b_transpose))
    return false;
  return true;
}

template <typename T, Gemm::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.a_operand_id < rhs.a_operand_id)
    return true;
  if (rhs.a_operand_id < lhs.a_operand_id)
    return false;
  if (lhs.b_operand_id < rhs.b_operand_id)
    return true;
  if (rhs.b_operand_id < lhs.b_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  if (lhs.c_operand_id < rhs.c_operand_id)
    return true;
  if (rhs.c_operand_id < lhs.c_operand_id)
    return false;
  if (lhs.alpha < rhs.alpha)
    return true;
  if (rhs.alpha < lhs.alpha)
    return false;
  if (lhs.beta < rhs.beta)
    return true;
  if (rhs.beta < lhs.beta)
    return false;
  if (lhs.a_transpose < rhs.a_transpose)
    return true;
  if (rhs.a_transpose < lhs.a_transpose)
    return false;
  if (lhs.b_transpose < rhs.b_transpose)
    return true;
  if (rhs.b_transpose < lhs.b_transpose)
    return false;
  return false;
}
template <typename StructPtrType>
HardSigmoidPtr HardSigmoid::Clone() const {
  return New(
      mojo::Clone(input_operand_id),
      mojo::Clone(output_operand_id),
      mojo::Clone(alpha),
      mojo::Clone(beta)
  );
}

template <typename T, HardSigmoid::EnableIfSame<T>*>
bool HardSigmoid::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  if (!mojo::Equals(this->alpha, other_struct.alpha))
    return false;
  if (!mojo::Equals(this->beta, other_struct.beta))
    return false;
  return true;
}

template <typename T, HardSigmoid::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  if (lhs.alpha < rhs.alpha)
    return true;
  if (rhs.alpha < lhs.alpha)
    return false;
  if (lhs.beta < rhs.beta)
    return true;
  if (rhs.beta < lhs.beta)
    return false;
  return false;
}
template <typename StructPtrType>
LayerNormalizationPtr LayerNormalization::Clone() const {
  return New(
      mojo::Clone(input_operand_id),
      mojo::Clone(output_operand_id),
      mojo::Clone(scale_operand_id),
      mojo::Clone(bias_operand_id),
      mojo::Clone(axes),
      mojo::Clone(epsilon)
  );
}

template <typename T, LayerNormalization::EnableIfSame<T>*>
bool LayerNormalization::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  if (!mojo::Equals(this->scale_operand_id, other_struct.scale_operand_id))
    return false;
  if (!mojo::Equals(this->bias_operand_id, other_struct.bias_operand_id))
    return false;
  if (!mojo::Equals(this->axes, other_struct.axes))
    return false;
  if (!mojo::Equals(this->epsilon, other_struct.epsilon))
    return false;
  return true;
}

template <typename T, LayerNormalization::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  if (lhs.scale_operand_id < rhs.scale_operand_id)
    return true;
  if (rhs.scale_operand_id < lhs.scale_operand_id)
    return false;
  if (lhs.bias_operand_id < rhs.bias_operand_id)
    return true;
  if (rhs.bias_operand_id < lhs.bias_operand_id)
    return false;
  if (lhs.axes < rhs.axes)
    return true;
  if (rhs.axes < lhs.axes)
    return false;
  if (lhs.epsilon < rhs.epsilon)
    return true;
  if (rhs.epsilon < lhs.epsilon)
    return false;
  return false;
}
template <typename StructPtrType>
LeakyReluPtr LeakyRelu::Clone() const {
  return New(
      mojo::Clone(input_operand_id),
      mojo::Clone(output_operand_id),
      mojo::Clone(alpha)
  );
}

template <typename T, LeakyRelu::EnableIfSame<T>*>
bool LeakyRelu::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  if (!mojo::Equals(this->alpha, other_struct.alpha))
    return false;
  return true;
}

template <typename T, LeakyRelu::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  if (lhs.alpha < rhs.alpha)
    return true;
  if (rhs.alpha < lhs.alpha)
    return false;
  return false;
}
template <typename StructPtrType>
LinearPtr Linear::Clone() const {
  return New(
      mojo::Clone(input_operand_id),
      mojo::Clone(output_operand_id),
      mojo::Clone(alpha),
      mojo::Clone(beta)
  );
}

template <typename T, Linear::EnableIfSame<T>*>
bool Linear::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  if (!mojo::Equals(this->alpha, other_struct.alpha))
    return false;
  if (!mojo::Equals(this->beta, other_struct.beta))
    return false;
  return true;
}

template <typename T, Linear::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  if (lhs.alpha < rhs.alpha)
    return true;
  if (rhs.alpha < lhs.alpha)
    return false;
  if (lhs.beta < rhs.beta)
    return true;
  if (rhs.beta < lhs.beta)
    return false;
  return false;
}
template <typename StructPtrType>
PreluPtr Prelu::Clone() const {
  return New(
      mojo::Clone(input_operand_id),
      mojo::Clone(slope_operand_id),
      mojo::Clone(output_operand_id)
  );
}

template <typename T, Prelu::EnableIfSame<T>*>
bool Prelu::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->slope_operand_id, other_struct.slope_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  return true;
}

template <typename T, Prelu::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.slope_operand_id < rhs.slope_operand_id)
    return true;
  if (rhs.slope_operand_id < lhs.slope_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  return false;
}
template <typename StructPtrType>
ReluPtr Relu::Clone() const {
  return New(
      mojo::Clone(input_operand_id),
      mojo::Clone(output_operand_id)
  );
}

template <typename T, Relu::EnableIfSame<T>*>
bool Relu::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  return true;
}

template <typename T, Relu::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  return false;
}
template <typename StructPtrType>
ReshapePtr Reshape::Clone() const {
  return New(
      mojo::Clone(input_operand_id),
      mojo::Clone(output_operand_id)
  );
}

template <typename T, Reshape::EnableIfSame<T>*>
bool Reshape::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  return true;
}

template <typename T, Reshape::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  return false;
}
template <typename StructPtrType>
SigmoidPtr Sigmoid::Clone() const {
  return New(
      mojo::Clone(input_operand_id),
      mojo::Clone(output_operand_id)
  );
}

template <typename T, Sigmoid::EnableIfSame<T>*>
bool Sigmoid::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  return true;
}

template <typename T, Sigmoid::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  return false;
}
template <typename StructPtrType>
SoftmaxPtr Softmax::Clone() const {
  return New(
      mojo::Clone(input_operand_id),
      mojo::Clone(output_operand_id)
  );
}

template <typename T, Softmax::EnableIfSame<T>*>
bool Softmax::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  return true;
}

template <typename T, Softmax::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  return false;
}
template <typename StructPtrType>
SoftplusPtr Softplus::Clone() const {
  return New(
      mojo::Clone(input_operand_id),
      mojo::Clone(output_operand_id),
      mojo::Clone(steepness)
  );
}

template <typename T, Softplus::EnableIfSame<T>*>
bool Softplus::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  if (!mojo::Equals(this->steepness, other_struct.steepness))
    return false;
  return true;
}

template <typename T, Softplus::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  if (lhs.steepness < rhs.steepness)
    return true;
  if (rhs.steepness < lhs.steepness)
    return false;
  return false;
}
template <typename StructPtrType>
SoftsignPtr Softsign::Clone() const {
  return New(
      mojo::Clone(input_operand_id),
      mojo::Clone(output_operand_id)
  );
}

template <typename T, Softsign::EnableIfSame<T>*>
bool Softsign::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  return true;
}

template <typename T, Softsign::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  return false;
}
template <typename StructPtrType>
SplitPtr Split::Clone() const {
  return New(
      mojo::Clone(input_operand_id),
      mojo::Clone(output_operand_ids),
      mojo::Clone(axis)
  );
}

template <typename T, Split::EnableIfSame<T>*>
bool Split::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_ids, other_struct.output_operand_ids))
    return false;
  if (!mojo::Equals(this->axis, other_struct.axis))
    return false;
  return true;
}

template <typename T, Split::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.output_operand_ids < rhs.output_operand_ids)
    return true;
  if (rhs.output_operand_ids < lhs.output_operand_ids)
    return false;
  if (lhs.axis < rhs.axis)
    return true;
  if (rhs.axis < lhs.axis)
    return false;
  return false;
}
template <typename StructPtrType>
TanhPtr Tanh::Clone() const {
  return New(
      mojo::Clone(input_operand_id),
      mojo::Clone(output_operand_id)
  );
}

template <typename T, Tanh::EnableIfSame<T>*>
bool Tanh::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  return true;
}

template <typename T, Tanh::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  return false;
}
template <typename StructPtrType>
TransposePtr Transpose::Clone() const {
  return New(
      mojo::Clone(input_operand_id),
      mojo::Clone(output_operand_id),
      mojo::Clone(permutation)
  );
}

template <typename T, Transpose::EnableIfSame<T>*>
bool Transpose::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  if (!mojo::Equals(this->permutation, other_struct.permutation))
    return false;
  return true;
}

template <typename T, Transpose::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  if (lhs.permutation < rhs.permutation)
    return true;
  if (rhs.permutation < lhs.permutation)
    return false;
  return false;
}
template <typename StructPtrType>
Resample2dPtr Resample2d::Clone() const {
  return New(
      mojo::Clone(input_operand_id),
      mojo::Clone(output_operand_id),
      mojo::Clone(mode),
      mojo::Clone(scales),
      mojo::Clone(axes)
  );
}

template <typename T, Resample2d::EnableIfSame<T>*>
bool Resample2d::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->input_operand_id, other_struct.input_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  if (!mojo::Equals(this->mode, other_struct.mode))
    return false;
  if (!mojo::Equals(this->scales, other_struct.scales))
    return false;
  if (!mojo::Equals(this->axes, other_struct.axes))
    return false;
  return true;
}

template <typename T, Resample2d::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.input_operand_id < rhs.input_operand_id)
    return true;
  if (rhs.input_operand_id < lhs.input_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  if (lhs.mode < rhs.mode)
    return true;
  if (rhs.mode < lhs.mode)
    return false;
  if (lhs.scales < rhs.scales)
    return true;
  if (rhs.scales < lhs.scales)
    return false;
  if (lhs.axes < rhs.axes)
    return true;
  if (rhs.axes < lhs.axes)
    return false;
  return false;
}
template <typename StructPtrType>
WherePtr Where::Clone() const {
  return New(
      mojo::Clone(condition_operand_id),
      mojo::Clone(true_value_operand_id),
      mojo::Clone(false_value_operand_id),
      mojo::Clone(output_operand_id)
  );
}

template <typename T, Where::EnableIfSame<T>*>
bool Where::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->condition_operand_id, other_struct.condition_operand_id))
    return false;
  if (!mojo::Equals(this->true_value_operand_id, other_struct.true_value_operand_id))
    return false;
  if (!mojo::Equals(this->false_value_operand_id, other_struct.false_value_operand_id))
    return false;
  if (!mojo::Equals(this->output_operand_id, other_struct.output_operand_id))
    return false;
  return true;
}

template <typename T, Where::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.condition_operand_id < rhs.condition_operand_id)
    return true;
  if (rhs.condition_operand_id < lhs.condition_operand_id)
    return false;
  if (lhs.true_value_operand_id < rhs.true_value_operand_id)
    return true;
  if (rhs.true_value_operand_id < lhs.true_value_operand_id)
    return false;
  if (lhs.false_value_operand_id < rhs.false_value_operand_id)
    return true;
  if (rhs.false_value_operand_id < lhs.false_value_operand_id)
    return false;
  if (lhs.output_operand_id < rhs.output_operand_id)
    return true;
  if (rhs.output_operand_id < lhs.output_operand_id)
    return false;
  return false;
}
template <typename StructPtrType>
GraphInfoPtr GraphInfo::Clone() const {
  return New(
      mojo::Clone(id_to_operand_map),
      mojo::Clone(input_operands),
      mojo::Clone(output_operands),
      mojo::Clone(operations),
      mojo::Clone(constant_id_to_buffer_map)
  );
}

template <typename T, GraphInfo::EnableIfSame<T>*>
bool GraphInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->id_to_operand_map, other_struct.id_to_operand_map))
    return false;
  if (!mojo::Equals(this->input_operands, other_struct.input_operands))
    return false;
  if (!mojo::Equals(this->output_operands, other_struct.output_operands))
    return false;
  if (!mojo::Equals(this->operations, other_struct.operations))
    return false;
  if (!mojo::Equals(this->constant_id_to_buffer_map, other_struct.constant_id_to_buffer_map))
    return false;
  return true;
}

template <typename T, GraphInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.id_to_operand_map < rhs.id_to_operand_map)
    return true;
  if (rhs.id_to_operand_map < lhs.id_to_operand_map)
    return false;
  if (lhs.input_operands < rhs.input_operands)
    return true;
  if (rhs.input_operands < lhs.input_operands)
    return false;
  if (lhs.output_operands < rhs.output_operands)
    return true;
  if (rhs.output_operands < lhs.output_operands)
    return false;
  if (lhs.operations < rhs.operations)
    return true;
  if (rhs.operations < lhs.operations)
    return false;
  if (lhs.constant_id_to_buffer_map < rhs.constant_id_to_buffer_map)
    return true;
  if (rhs.constant_id_to_buffer_map < lhs.constant_id_to_buffer_map)
    return false;
  return false;
}


}  // webnn::mojom::blink

namespace mojo {


template <>
struct  StructTraits<::webnn::mojom::blink::Operand::DataView,
                                         ::webnn::mojom::blink::OperandPtr> {
  static bool IsNull(const ::webnn::mojom::blink::OperandPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::OperandPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Operand::kind) kind(
      const ::webnn::mojom::blink::OperandPtr& input) {
    return input->kind;
  }

  static decltype(::webnn::mojom::blink::Operand::data_type) data_type(
      const ::webnn::mojom::blink::OperandPtr& input) {
    return input->data_type;
  }

  static const decltype(::webnn::mojom::blink::Operand::dimensions)& dimensions(
      const ::webnn::mojom::blink::OperandPtr& input) {
    return input->dimensions;
  }

  static const decltype(::webnn::mojom::blink::Operand::name)& name(
      const ::webnn::mojom::blink::OperandPtr& input) {
    return input->name;
  }

  static bool Read(::webnn::mojom::blink::Operand::DataView input, ::webnn::mojom::blink::OperandPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::ArgMinMax::DataView,
                                         ::webnn::mojom::blink::ArgMinMaxPtr> {
  static bool IsNull(const ::webnn::mojom::blink::ArgMinMaxPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::ArgMinMaxPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::ArgMinMax::kind) kind(
      const ::webnn::mojom::blink::ArgMinMaxPtr& input) {
    return input->kind;
  }

  static decltype(::webnn::mojom::blink::ArgMinMax::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::ArgMinMaxPtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::ArgMinMax::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::ArgMinMaxPtr& input) {
    return input->output_operand_id;
  }

  static const decltype(::webnn::mojom::blink::ArgMinMax::axes)& axes(
      const ::webnn::mojom::blink::ArgMinMaxPtr& input) {
    return input->axes;
  }

  static decltype(::webnn::mojom::blink::ArgMinMax::keep_dimensions) keep_dimensions(
      const ::webnn::mojom::blink::ArgMinMaxPtr& input) {
    return input->keep_dimensions;
  }

  static decltype(::webnn::mojom::blink::ArgMinMax::select_last_index) select_last_index(
      const ::webnn::mojom::blink::ArgMinMaxPtr& input) {
    return input->select_last_index;
  }

  static bool Read(::webnn::mojom::blink::ArgMinMax::DataView input, ::webnn::mojom::blink::ArgMinMaxPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::BatchNormalization::DataView,
                                         ::webnn::mojom::blink::BatchNormalizationPtr> {
  static bool IsNull(const ::webnn::mojom::blink::BatchNormalizationPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::BatchNormalizationPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::BatchNormalization::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::BatchNormalizationPtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::BatchNormalization::mean_operand_id) mean_operand_id(
      const ::webnn::mojom::blink::BatchNormalizationPtr& input) {
    return input->mean_operand_id;
  }

  static decltype(::webnn::mojom::blink::BatchNormalization::variance_operand_id) variance_operand_id(
      const ::webnn::mojom::blink::BatchNormalizationPtr& input) {
    return input->variance_operand_id;
  }

  static decltype(::webnn::mojom::blink::BatchNormalization::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::BatchNormalizationPtr& input) {
    return input->output_operand_id;
  }

  static decltype(::webnn::mojom::blink::BatchNormalization::scale_operand_id) scale_operand_id(
      const ::webnn::mojom::blink::BatchNormalizationPtr& input) {
    return input->scale_operand_id;
  }

  static decltype(::webnn::mojom::blink::BatchNormalization::bias_operand_id) bias_operand_id(
      const ::webnn::mojom::blink::BatchNormalizationPtr& input) {
    return input->bias_operand_id;
  }

  static decltype(::webnn::mojom::blink::BatchNormalization::axis) axis(
      const ::webnn::mojom::blink::BatchNormalizationPtr& input) {
    return input->axis;
  }

  static decltype(::webnn::mojom::blink::BatchNormalization::epsilon) epsilon(
      const ::webnn::mojom::blink::BatchNormalizationPtr& input) {
    return input->epsilon;
  }

  static const decltype(::webnn::mojom::blink::BatchNormalization::activation)& activation(
      const ::webnn::mojom::blink::BatchNormalizationPtr& input) {
    return input->activation;
  }

  static bool Read(::webnn::mojom::blink::BatchNormalization::DataView input, ::webnn::mojom::blink::BatchNormalizationPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Clamp::DataView,
                                         ::webnn::mojom::blink::ClampPtr> {
  static bool IsNull(const ::webnn::mojom::blink::ClampPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::ClampPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Clamp::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::ClampPtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::Clamp::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::ClampPtr& input) {
    return input->output_operand_id;
  }

  static decltype(::webnn::mojom::blink::Clamp::min_value) min_value(
      const ::webnn::mojom::blink::ClampPtr& input) {
    return input->min_value;
  }

  static decltype(::webnn::mojom::blink::Clamp::max_value) max_value(
      const ::webnn::mojom::blink::ClampPtr& input) {
    return input->max_value;
  }

  static bool Read(::webnn::mojom::blink::Clamp::DataView input, ::webnn::mojom::blink::ClampPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Concat::DataView,
                                         ::webnn::mojom::blink::ConcatPtr> {
  static bool IsNull(const ::webnn::mojom::blink::ConcatPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::ConcatPtr* output) { output->reset(); }

  static const decltype(::webnn::mojom::blink::Concat::input_operand_ids)& input_operand_ids(
      const ::webnn::mojom::blink::ConcatPtr& input) {
    return input->input_operand_ids;
  }

  static decltype(::webnn::mojom::blink::Concat::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::ConcatPtr& input) {
    return input->output_operand_id;
  }

  static decltype(::webnn::mojom::blink::Concat::axis) axis(
      const ::webnn::mojom::blink::ConcatPtr& input) {
    return input->axis;
  }

  static bool Read(::webnn::mojom::blink::Concat::DataView input, ::webnn::mojom::blink::ConcatPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Size2d::DataView,
                                         ::webnn::mojom::blink::Size2dPtr> {
  static bool IsNull(const ::webnn::mojom::blink::Size2dPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::Size2dPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Size2d::height) height(
      const ::webnn::mojom::blink::Size2dPtr& input) {
    return input->height;
  }

  static decltype(::webnn::mojom::blink::Size2d::width) width(
      const ::webnn::mojom::blink::Size2dPtr& input) {
    return input->width;
  }

  static bool Read(::webnn::mojom::blink::Size2d::DataView input, ::webnn::mojom::blink::Size2dPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Padding2d::DataView,
                                         ::webnn::mojom::blink::Padding2dPtr> {
  static bool IsNull(const ::webnn::mojom::blink::Padding2dPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::Padding2dPtr* output) { output->reset(); }

  static const decltype(::webnn::mojom::blink::Padding2d::beginning)& beginning(
      const ::webnn::mojom::blink::Padding2dPtr& input) {
    return input->beginning;
  }

  static const decltype(::webnn::mojom::blink::Padding2d::ending)& ending(
      const ::webnn::mojom::blink::Padding2dPtr& input) {
    return input->ending;
  }

  static bool Read(::webnn::mojom::blink::Padding2d::DataView input, ::webnn::mojom::blink::Padding2dPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Conv2d::DataView,
                                         ::webnn::mojom::blink::Conv2dPtr> {
  static bool IsNull(const ::webnn::mojom::blink::Conv2dPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::Conv2dPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Conv2d::type) type(
      const ::webnn::mojom::blink::Conv2dPtr& input) {
    return input->type;
  }

  static decltype(::webnn::mojom::blink::Conv2d::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::Conv2dPtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::Conv2d::filter_operand_id) filter_operand_id(
      const ::webnn::mojom::blink::Conv2dPtr& input) {
    return input->filter_operand_id;
  }

  static decltype(::webnn::mojom::blink::Conv2d::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::Conv2dPtr& input) {
    return input->output_operand_id;
  }

  static const decltype(::webnn::mojom::blink::Conv2d::padding)& padding(
      const ::webnn::mojom::blink::Conv2dPtr& input) {
    return input->padding;
  }

  static const decltype(::webnn::mojom::blink::Conv2d::strides)& strides(
      const ::webnn::mojom::blink::Conv2dPtr& input) {
    return input->strides;
  }

  static const decltype(::webnn::mojom::blink::Conv2d::dilations)& dilations(
      const ::webnn::mojom::blink::Conv2dPtr& input) {
    return input->dilations;
  }

  static decltype(::webnn::mojom::blink::Conv2d::groups) groups(
      const ::webnn::mojom::blink::Conv2dPtr& input) {
    return input->groups;
  }

  static decltype(::webnn::mojom::blink::Conv2d::input_layout) input_layout(
      const ::webnn::mojom::blink::Conv2dPtr& input) {
    return input->input_layout;
  }

  static decltype(::webnn::mojom::blink::Conv2d::bias_operand_id) bias_operand_id(
      const ::webnn::mojom::blink::Conv2dPtr& input) {
    return input->bias_operand_id;
  }

  static const decltype(::webnn::mojom::blink::Conv2d::activation)& activation(
      const ::webnn::mojom::blink::Conv2dPtr& input) {
    return input->activation;
  }

  static bool Read(::webnn::mojom::blink::Conv2d::DataView input, ::webnn::mojom::blink::Conv2dPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::ElementWiseBinary::DataView,
                                         ::webnn::mojom::blink::ElementWiseBinaryPtr> {
  static bool IsNull(const ::webnn::mojom::blink::ElementWiseBinaryPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::ElementWiseBinaryPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::ElementWiseBinary::kind) kind(
      const ::webnn::mojom::blink::ElementWiseBinaryPtr& input) {
    return input->kind;
  }

  static decltype(::webnn::mojom::blink::ElementWiseBinary::lhs_operand) lhs_operand(
      const ::webnn::mojom::blink::ElementWiseBinaryPtr& input) {
    return input->lhs_operand;
  }

  static decltype(::webnn::mojom::blink::ElementWiseBinary::rhs_operand) rhs_operand(
      const ::webnn::mojom::blink::ElementWiseBinaryPtr& input) {
    return input->rhs_operand;
  }

  static decltype(::webnn::mojom::blink::ElementWiseBinary::output_operand) output_operand(
      const ::webnn::mojom::blink::ElementWiseBinaryPtr& input) {
    return input->output_operand;
  }

  static bool Read(::webnn::mojom::blink::ElementWiseBinary::DataView input, ::webnn::mojom::blink::ElementWiseBinaryPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::ElementWiseUnary::DataView,
                                         ::webnn::mojom::blink::ElementWiseUnaryPtr> {
  static bool IsNull(const ::webnn::mojom::blink::ElementWiseUnaryPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::ElementWiseUnaryPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::ElementWiseUnary::kind) kind(
      const ::webnn::mojom::blink::ElementWiseUnaryPtr& input) {
    return input->kind;
  }

  static decltype(::webnn::mojom::blink::ElementWiseUnary::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::ElementWiseUnaryPtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::ElementWiseUnary::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::ElementWiseUnaryPtr& input) {
    return input->output_operand_id;
  }

  static bool Read(::webnn::mojom::blink::ElementWiseUnary::DataView input, ::webnn::mojom::blink::ElementWiseUnaryPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Expand::DataView,
                                         ::webnn::mojom::blink::ExpandPtr> {
  static bool IsNull(const ::webnn::mojom::blink::ExpandPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::ExpandPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Expand::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::ExpandPtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::Expand::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::ExpandPtr& input) {
    return input->output_operand_id;
  }

  static bool Read(::webnn::mojom::blink::Expand::DataView input, ::webnn::mojom::blink::ExpandPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::ConstantPadding::DataView,
                                         ::webnn::mojom::blink::ConstantPaddingPtr> {
  static bool IsNull(const ::webnn::mojom::blink::ConstantPaddingPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::ConstantPaddingPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::ConstantPadding::value) value(
      const ::webnn::mojom::blink::ConstantPaddingPtr& input) {
    return input->value;
  }

  static bool Read(::webnn::mojom::blink::ConstantPadding::DataView input, ::webnn::mojom::blink::ConstantPaddingPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::EdgePadding::DataView,
                                         ::webnn::mojom::blink::EdgePaddingPtr> {
  static bool IsNull(const ::webnn::mojom::blink::EdgePaddingPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::EdgePaddingPtr* output) { output->reset(); }

  static bool Read(::webnn::mojom::blink::EdgePadding::DataView input, ::webnn::mojom::blink::EdgePaddingPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::ReflectionPadding::DataView,
                                         ::webnn::mojom::blink::ReflectionPaddingPtr> {
  static bool IsNull(const ::webnn::mojom::blink::ReflectionPaddingPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::ReflectionPaddingPtr* output) { output->reset(); }

  static bool Read(::webnn::mojom::blink::ReflectionPadding::DataView input, ::webnn::mojom::blink::ReflectionPaddingPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::SymmetricPadding::DataView,
                                         ::webnn::mojom::blink::SymmetricPaddingPtr> {
  static bool IsNull(const ::webnn::mojom::blink::SymmetricPaddingPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::SymmetricPaddingPtr* output) { output->reset(); }

  static bool Read(::webnn::mojom::blink::SymmetricPadding::DataView input, ::webnn::mojom::blink::SymmetricPaddingPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::InstanceNormalization::DataView,
                                         ::webnn::mojom::blink::InstanceNormalizationPtr> {
  static bool IsNull(const ::webnn::mojom::blink::InstanceNormalizationPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::InstanceNormalizationPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::InstanceNormalization::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::InstanceNormalizationPtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::InstanceNormalization::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::InstanceNormalizationPtr& input) {
    return input->output_operand_id;
  }

  static decltype(::webnn::mojom::blink::InstanceNormalization::scale_operand_id) scale_operand_id(
      const ::webnn::mojom::blink::InstanceNormalizationPtr& input) {
    return input->scale_operand_id;
  }

  static decltype(::webnn::mojom::blink::InstanceNormalization::bias_operand_id) bias_operand_id(
      const ::webnn::mojom::blink::InstanceNormalizationPtr& input) {
    return input->bias_operand_id;
  }

  static decltype(::webnn::mojom::blink::InstanceNormalization::epsilon) epsilon(
      const ::webnn::mojom::blink::InstanceNormalizationPtr& input) {
    return input->epsilon;
  }

  static decltype(::webnn::mojom::blink::InstanceNormalization::layout) layout(
      const ::webnn::mojom::blink::InstanceNormalizationPtr& input) {
    return input->layout;
  }

  static bool Read(::webnn::mojom::blink::InstanceNormalization::DataView input, ::webnn::mojom::blink::InstanceNormalizationPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Matmul::DataView,
                                         ::webnn::mojom::blink::MatmulPtr> {
  static bool IsNull(const ::webnn::mojom::blink::MatmulPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::MatmulPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Matmul::a_operand_id) a_operand_id(
      const ::webnn::mojom::blink::MatmulPtr& input) {
    return input->a_operand_id;
  }

  static decltype(::webnn::mojom::blink::Matmul::b_operand_id) b_operand_id(
      const ::webnn::mojom::blink::MatmulPtr& input) {
    return input->b_operand_id;
  }

  static decltype(::webnn::mojom::blink::Matmul::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::MatmulPtr& input) {
    return input->output_operand_id;
  }

  static bool Read(::webnn::mojom::blink::Matmul::DataView input, ::webnn::mojom::blink::MatmulPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Pad::DataView,
                                         ::webnn::mojom::blink::PadPtr> {
  static bool IsNull(const ::webnn::mojom::blink::PadPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::PadPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Pad::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::PadPtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::Pad::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::PadPtr& input) {
    return input->output_operand_id;
  }

  static const decltype(::webnn::mojom::blink::Pad::beginning_padding)& beginning_padding(
      const ::webnn::mojom::blink::PadPtr& input) {
    return input->beginning_padding;
  }

  static const decltype(::webnn::mojom::blink::Pad::ending_padding)& ending_padding(
      const ::webnn::mojom::blink::PadPtr& input) {
    return input->ending_padding;
  }

  static const decltype(::webnn::mojom::blink::Pad::mode)& mode(
      const ::webnn::mojom::blink::PadPtr& input) {
    return input->mode;
  }

  static bool Read(::webnn::mojom::blink::Pad::DataView input, ::webnn::mojom::blink::PadPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Reduce::DataView,
                                         ::webnn::mojom::blink::ReducePtr> {
  static bool IsNull(const ::webnn::mojom::blink::ReducePtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::ReducePtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Reduce::kind) kind(
      const ::webnn::mojom::blink::ReducePtr& input) {
    return input->kind;
  }

  static decltype(::webnn::mojom::blink::Reduce::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::ReducePtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::Reduce::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::ReducePtr& input) {
    return input->output_operand_id;
  }

  static const decltype(::webnn::mojom::blink::Reduce::axes)& axes(
      const ::webnn::mojom::blink::ReducePtr& input) {
    return input->axes;
  }

  static decltype(::webnn::mojom::blink::Reduce::keep_dimensions) keep_dimensions(
      const ::webnn::mojom::blink::ReducePtr& input) {
    return input->keep_dimensions;
  }

  static bool Read(::webnn::mojom::blink::Reduce::DataView input, ::webnn::mojom::blink::ReducePtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Pool2d::DataView,
                                         ::webnn::mojom::blink::Pool2dPtr> {
  static bool IsNull(const ::webnn::mojom::blink::Pool2dPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::Pool2dPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Pool2d::kind) kind(
      const ::webnn::mojom::blink::Pool2dPtr& input) {
    return input->kind;
  }

  static decltype(::webnn::mojom::blink::Pool2d::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::Pool2dPtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::Pool2d::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::Pool2dPtr& input) {
    return input->output_operand_id;
  }

  static const decltype(::webnn::mojom::blink::Pool2d::window_dimensions)& window_dimensions(
      const ::webnn::mojom::blink::Pool2dPtr& input) {
    return input->window_dimensions;
  }

  static const decltype(::webnn::mojom::blink::Pool2d::padding)& padding(
      const ::webnn::mojom::blink::Pool2dPtr& input) {
    return input->padding;
  }

  static const decltype(::webnn::mojom::blink::Pool2d::strides)& strides(
      const ::webnn::mojom::blink::Pool2dPtr& input) {
    return input->strides;
  }

  static const decltype(::webnn::mojom::blink::Pool2d::dilations)& dilations(
      const ::webnn::mojom::blink::Pool2dPtr& input) {
    return input->dilations;
  }

  static decltype(::webnn::mojom::blink::Pool2d::layout) layout(
      const ::webnn::mojom::blink::Pool2dPtr& input) {
    return input->layout;
  }

  static bool Read(::webnn::mojom::blink::Pool2d::DataView input, ::webnn::mojom::blink::Pool2dPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::StartAndSize::DataView,
                                         ::webnn::mojom::blink::StartAndSizePtr> {
  static bool IsNull(const ::webnn::mojom::blink::StartAndSizePtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::StartAndSizePtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::StartAndSize::start) start(
      const ::webnn::mojom::blink::StartAndSizePtr& input) {
    return input->start;
  }

  static decltype(::webnn::mojom::blink::StartAndSize::size) size(
      const ::webnn::mojom::blink::StartAndSizePtr& input) {
    return input->size;
  }

  static bool Read(::webnn::mojom::blink::StartAndSize::DataView input, ::webnn::mojom::blink::StartAndSizePtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Slice::DataView,
                                         ::webnn::mojom::blink::SlicePtr> {
  static bool IsNull(const ::webnn::mojom::blink::SlicePtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::SlicePtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Slice::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::SlicePtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::Slice::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::SlicePtr& input) {
    return input->output_operand_id;
  }

  static const decltype(::webnn::mojom::blink::Slice::starts_and_sizes)& starts_and_sizes(
      const ::webnn::mojom::blink::SlicePtr& input) {
    return input->starts_and_sizes;
  }

  static bool Read(::webnn::mojom::blink::Slice::DataView input, ::webnn::mojom::blink::SlicePtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Elu::DataView,
                                         ::webnn::mojom::blink::EluPtr> {
  static bool IsNull(const ::webnn::mojom::blink::EluPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::EluPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Elu::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::EluPtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::Elu::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::EluPtr& input) {
    return input->output_operand_id;
  }

  static decltype(::webnn::mojom::blink::Elu::alpha) alpha(
      const ::webnn::mojom::blink::EluPtr& input) {
    return input->alpha;
  }

  static bool Read(::webnn::mojom::blink::Elu::DataView input, ::webnn::mojom::blink::EluPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Gather::DataView,
                                         ::webnn::mojom::blink::GatherPtr> {
  static bool IsNull(const ::webnn::mojom::blink::GatherPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::GatherPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Gather::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::GatherPtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::Gather::indices_operand_id) indices_operand_id(
      const ::webnn::mojom::blink::GatherPtr& input) {
    return input->indices_operand_id;
  }

  static decltype(::webnn::mojom::blink::Gather::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::GatherPtr& input) {
    return input->output_operand_id;
  }

  static decltype(::webnn::mojom::blink::Gather::axis) axis(
      const ::webnn::mojom::blink::GatherPtr& input) {
    return input->axis;
  }

  static bool Read(::webnn::mojom::blink::Gather::DataView input, ::webnn::mojom::blink::GatherPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Gemm::DataView,
                                         ::webnn::mojom::blink::GemmPtr> {
  static bool IsNull(const ::webnn::mojom::blink::GemmPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::GemmPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Gemm::a_operand_id) a_operand_id(
      const ::webnn::mojom::blink::GemmPtr& input) {
    return input->a_operand_id;
  }

  static decltype(::webnn::mojom::blink::Gemm::b_operand_id) b_operand_id(
      const ::webnn::mojom::blink::GemmPtr& input) {
    return input->b_operand_id;
  }

  static decltype(::webnn::mojom::blink::Gemm::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::GemmPtr& input) {
    return input->output_operand_id;
  }

  static decltype(::webnn::mojom::blink::Gemm::c_operand_id) c_operand_id(
      const ::webnn::mojom::blink::GemmPtr& input) {
    return input->c_operand_id;
  }

  static decltype(::webnn::mojom::blink::Gemm::alpha) alpha(
      const ::webnn::mojom::blink::GemmPtr& input) {
    return input->alpha;
  }

  static decltype(::webnn::mojom::blink::Gemm::beta) beta(
      const ::webnn::mojom::blink::GemmPtr& input) {
    return input->beta;
  }

  static decltype(::webnn::mojom::blink::Gemm::a_transpose) a_transpose(
      const ::webnn::mojom::blink::GemmPtr& input) {
    return input->a_transpose;
  }

  static decltype(::webnn::mojom::blink::Gemm::b_transpose) b_transpose(
      const ::webnn::mojom::blink::GemmPtr& input) {
    return input->b_transpose;
  }

  static bool Read(::webnn::mojom::blink::Gemm::DataView input, ::webnn::mojom::blink::GemmPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::HardSigmoid::DataView,
                                         ::webnn::mojom::blink::HardSigmoidPtr> {
  static bool IsNull(const ::webnn::mojom::blink::HardSigmoidPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::HardSigmoidPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::HardSigmoid::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::HardSigmoidPtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::HardSigmoid::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::HardSigmoidPtr& input) {
    return input->output_operand_id;
  }

  static decltype(::webnn::mojom::blink::HardSigmoid::alpha) alpha(
      const ::webnn::mojom::blink::HardSigmoidPtr& input) {
    return input->alpha;
  }

  static decltype(::webnn::mojom::blink::HardSigmoid::beta) beta(
      const ::webnn::mojom::blink::HardSigmoidPtr& input) {
    return input->beta;
  }

  static bool Read(::webnn::mojom::blink::HardSigmoid::DataView input, ::webnn::mojom::blink::HardSigmoidPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::LayerNormalization::DataView,
                                         ::webnn::mojom::blink::LayerNormalizationPtr> {
  static bool IsNull(const ::webnn::mojom::blink::LayerNormalizationPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::LayerNormalizationPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::LayerNormalization::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::LayerNormalizationPtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::LayerNormalization::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::LayerNormalizationPtr& input) {
    return input->output_operand_id;
  }

  static decltype(::webnn::mojom::blink::LayerNormalization::scale_operand_id) scale_operand_id(
      const ::webnn::mojom::blink::LayerNormalizationPtr& input) {
    return input->scale_operand_id;
  }

  static decltype(::webnn::mojom::blink::LayerNormalization::bias_operand_id) bias_operand_id(
      const ::webnn::mojom::blink::LayerNormalizationPtr& input) {
    return input->bias_operand_id;
  }

  static const decltype(::webnn::mojom::blink::LayerNormalization::axes)& axes(
      const ::webnn::mojom::blink::LayerNormalizationPtr& input) {
    return input->axes;
  }

  static decltype(::webnn::mojom::blink::LayerNormalization::epsilon) epsilon(
      const ::webnn::mojom::blink::LayerNormalizationPtr& input) {
    return input->epsilon;
  }

  static bool Read(::webnn::mojom::blink::LayerNormalization::DataView input, ::webnn::mojom::blink::LayerNormalizationPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::LeakyRelu::DataView,
                                         ::webnn::mojom::blink::LeakyReluPtr> {
  static bool IsNull(const ::webnn::mojom::blink::LeakyReluPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::LeakyReluPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::LeakyRelu::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::LeakyReluPtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::LeakyRelu::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::LeakyReluPtr& input) {
    return input->output_operand_id;
  }

  static decltype(::webnn::mojom::blink::LeakyRelu::alpha) alpha(
      const ::webnn::mojom::blink::LeakyReluPtr& input) {
    return input->alpha;
  }

  static bool Read(::webnn::mojom::blink::LeakyRelu::DataView input, ::webnn::mojom::blink::LeakyReluPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Linear::DataView,
                                         ::webnn::mojom::blink::LinearPtr> {
  static bool IsNull(const ::webnn::mojom::blink::LinearPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::LinearPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Linear::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::LinearPtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::Linear::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::LinearPtr& input) {
    return input->output_operand_id;
  }

  static decltype(::webnn::mojom::blink::Linear::alpha) alpha(
      const ::webnn::mojom::blink::LinearPtr& input) {
    return input->alpha;
  }

  static decltype(::webnn::mojom::blink::Linear::beta) beta(
      const ::webnn::mojom::blink::LinearPtr& input) {
    return input->beta;
  }

  static bool Read(::webnn::mojom::blink::Linear::DataView input, ::webnn::mojom::blink::LinearPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Prelu::DataView,
                                         ::webnn::mojom::blink::PreluPtr> {
  static bool IsNull(const ::webnn::mojom::blink::PreluPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::PreluPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Prelu::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::PreluPtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::Prelu::slope_operand_id) slope_operand_id(
      const ::webnn::mojom::blink::PreluPtr& input) {
    return input->slope_operand_id;
  }

  static decltype(::webnn::mojom::blink::Prelu::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::PreluPtr& input) {
    return input->output_operand_id;
  }

  static bool Read(::webnn::mojom::blink::Prelu::DataView input, ::webnn::mojom::blink::PreluPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Relu::DataView,
                                         ::webnn::mojom::blink::ReluPtr> {
  static bool IsNull(const ::webnn::mojom::blink::ReluPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::ReluPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Relu::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::ReluPtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::Relu::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::ReluPtr& input) {
    return input->output_operand_id;
  }

  static bool Read(::webnn::mojom::blink::Relu::DataView input, ::webnn::mojom::blink::ReluPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Reshape::DataView,
                                         ::webnn::mojom::blink::ReshapePtr> {
  static bool IsNull(const ::webnn::mojom::blink::ReshapePtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::ReshapePtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Reshape::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::ReshapePtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::Reshape::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::ReshapePtr& input) {
    return input->output_operand_id;
  }

  static bool Read(::webnn::mojom::blink::Reshape::DataView input, ::webnn::mojom::blink::ReshapePtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Sigmoid::DataView,
                                         ::webnn::mojom::blink::SigmoidPtr> {
  static bool IsNull(const ::webnn::mojom::blink::SigmoidPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::SigmoidPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Sigmoid::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::SigmoidPtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::Sigmoid::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::SigmoidPtr& input) {
    return input->output_operand_id;
  }

  static bool Read(::webnn::mojom::blink::Sigmoid::DataView input, ::webnn::mojom::blink::SigmoidPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Softmax::DataView,
                                         ::webnn::mojom::blink::SoftmaxPtr> {
  static bool IsNull(const ::webnn::mojom::blink::SoftmaxPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::SoftmaxPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Softmax::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::SoftmaxPtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::Softmax::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::SoftmaxPtr& input) {
    return input->output_operand_id;
  }

  static bool Read(::webnn::mojom::blink::Softmax::DataView input, ::webnn::mojom::blink::SoftmaxPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Softplus::DataView,
                                         ::webnn::mojom::blink::SoftplusPtr> {
  static bool IsNull(const ::webnn::mojom::blink::SoftplusPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::SoftplusPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Softplus::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::SoftplusPtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::Softplus::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::SoftplusPtr& input) {
    return input->output_operand_id;
  }

  static decltype(::webnn::mojom::blink::Softplus::steepness) steepness(
      const ::webnn::mojom::blink::SoftplusPtr& input) {
    return input->steepness;
  }

  static bool Read(::webnn::mojom::blink::Softplus::DataView input, ::webnn::mojom::blink::SoftplusPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Softsign::DataView,
                                         ::webnn::mojom::blink::SoftsignPtr> {
  static bool IsNull(const ::webnn::mojom::blink::SoftsignPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::SoftsignPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Softsign::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::SoftsignPtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::Softsign::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::SoftsignPtr& input) {
    return input->output_operand_id;
  }

  static bool Read(::webnn::mojom::blink::Softsign::DataView input, ::webnn::mojom::blink::SoftsignPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Split::DataView,
                                         ::webnn::mojom::blink::SplitPtr> {
  static bool IsNull(const ::webnn::mojom::blink::SplitPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::SplitPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Split::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::SplitPtr& input) {
    return input->input_operand_id;
  }

  static const decltype(::webnn::mojom::blink::Split::output_operand_ids)& output_operand_ids(
      const ::webnn::mojom::blink::SplitPtr& input) {
    return input->output_operand_ids;
  }

  static decltype(::webnn::mojom::blink::Split::axis) axis(
      const ::webnn::mojom::blink::SplitPtr& input) {
    return input->axis;
  }

  static bool Read(::webnn::mojom::blink::Split::DataView input, ::webnn::mojom::blink::SplitPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Tanh::DataView,
                                         ::webnn::mojom::blink::TanhPtr> {
  static bool IsNull(const ::webnn::mojom::blink::TanhPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::TanhPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Tanh::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::TanhPtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::Tanh::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::TanhPtr& input) {
    return input->output_operand_id;
  }

  static bool Read(::webnn::mojom::blink::Tanh::DataView input, ::webnn::mojom::blink::TanhPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Transpose::DataView,
                                         ::webnn::mojom::blink::TransposePtr> {
  static bool IsNull(const ::webnn::mojom::blink::TransposePtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::TransposePtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Transpose::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::TransposePtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::Transpose::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::TransposePtr& input) {
    return input->output_operand_id;
  }

  static const decltype(::webnn::mojom::blink::Transpose::permutation)& permutation(
      const ::webnn::mojom::blink::TransposePtr& input) {
    return input->permutation;
  }

  static bool Read(::webnn::mojom::blink::Transpose::DataView input, ::webnn::mojom::blink::TransposePtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Resample2d::DataView,
                                         ::webnn::mojom::blink::Resample2dPtr> {
  static bool IsNull(const ::webnn::mojom::blink::Resample2dPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::Resample2dPtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Resample2d::input_operand_id) input_operand_id(
      const ::webnn::mojom::blink::Resample2dPtr& input) {
    return input->input_operand_id;
  }

  static decltype(::webnn::mojom::blink::Resample2d::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::Resample2dPtr& input) {
    return input->output_operand_id;
  }

  static decltype(::webnn::mojom::blink::Resample2d::mode) mode(
      const ::webnn::mojom::blink::Resample2dPtr& input) {
    return input->mode;
  }

  static const decltype(::webnn::mojom::blink::Resample2d::scales)& scales(
      const ::webnn::mojom::blink::Resample2dPtr& input) {
    return input->scales;
  }

  static const decltype(::webnn::mojom::blink::Resample2d::axes)& axes(
      const ::webnn::mojom::blink::Resample2dPtr& input) {
    return input->axes;
  }

  static bool Read(::webnn::mojom::blink::Resample2d::DataView input, ::webnn::mojom::blink::Resample2dPtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::Where::DataView,
                                         ::webnn::mojom::blink::WherePtr> {
  static bool IsNull(const ::webnn::mojom::blink::WherePtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::WherePtr* output) { output->reset(); }

  static decltype(::webnn::mojom::blink::Where::condition_operand_id) condition_operand_id(
      const ::webnn::mojom::blink::WherePtr& input) {
    return input->condition_operand_id;
  }

  static decltype(::webnn::mojom::blink::Where::true_value_operand_id) true_value_operand_id(
      const ::webnn::mojom::blink::WherePtr& input) {
    return input->true_value_operand_id;
  }

  static decltype(::webnn::mojom::blink::Where::false_value_operand_id) false_value_operand_id(
      const ::webnn::mojom::blink::WherePtr& input) {
    return input->false_value_operand_id;
  }

  static decltype(::webnn::mojom::blink::Where::output_operand_id) output_operand_id(
      const ::webnn::mojom::blink::WherePtr& input) {
    return input->output_operand_id;
  }

  static bool Read(::webnn::mojom::blink::Where::DataView input, ::webnn::mojom::blink::WherePtr* output);
};


template <>
struct  StructTraits<::webnn::mojom::blink::GraphInfo::DataView,
                                         ::webnn::mojom::blink::GraphInfoPtr> {
  static bool IsNull(const ::webnn::mojom::blink::GraphInfoPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::GraphInfoPtr* output) { output->reset(); }

  static const decltype(::webnn::mojom::blink::GraphInfo::id_to_operand_map)& id_to_operand_map(
      const ::webnn::mojom::blink::GraphInfoPtr& input) {
    return input->id_to_operand_map;
  }

  static const decltype(::webnn::mojom::blink::GraphInfo::input_operands)& input_operands(
      const ::webnn::mojom::blink::GraphInfoPtr& input) {
    return input->input_operands;
  }

  static const decltype(::webnn::mojom::blink::GraphInfo::output_operands)& output_operands(
      const ::webnn::mojom::blink::GraphInfoPtr& input) {
    return input->output_operands;
  }

  static const decltype(::webnn::mojom::blink::GraphInfo::operations)& operations(
      const ::webnn::mojom::blink::GraphInfoPtr& input) {
    return input->operations;
  }

  static  decltype(::webnn::mojom::blink::GraphInfo::constant_id_to_buffer_map)& constant_id_to_buffer_map(
       ::webnn::mojom::blink::GraphInfoPtr& input) {
    return input->constant_id_to_buffer_map;
  }

  static bool Read(::webnn::mojom::blink::GraphInfo::DataView input, ::webnn::mojom::blink::GraphInfoPtr* output);
};


template <>
struct  UnionTraits<::webnn::mojom::blink::PaddingMode::DataView,
                                        ::webnn::mojom::blink::PaddingModePtr> {
  static bool IsNull(const ::webnn::mojom::blink::PaddingModePtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::PaddingModePtr* output) { output->reset(); }

  static ::webnn::mojom::blink::PaddingMode::Tag GetTag(const ::webnn::mojom::blink::PaddingModePtr& input) {
    return input->which();
  }

  static const ::webnn::mojom::blink::ConstantPaddingPtr& constant(const ::webnn::mojom::blink::PaddingModePtr& input) {
    return input->get_constant();
  }

  static const ::webnn::mojom::blink::EdgePaddingPtr& edge(const ::webnn::mojom::blink::PaddingModePtr& input) {
    return input->get_edge();
  }

  static const ::webnn::mojom::blink::ReflectionPaddingPtr& reflection(const ::webnn::mojom::blink::PaddingModePtr& input) {
    return input->get_reflection();
  }

  static const ::webnn::mojom::blink::SymmetricPaddingPtr& symmetric(const ::webnn::mojom::blink::PaddingModePtr& input) {
    return input->get_symmetric();
  }

  static bool Read(::webnn::mojom::blink::PaddingMode::DataView input, ::webnn::mojom::blink::PaddingModePtr* output);
};


template <>
struct  UnionTraits<::webnn::mojom::blink::Activation::DataView,
                                        ::webnn::mojom::blink::ActivationPtr> {
  static bool IsNull(const ::webnn::mojom::blink::ActivationPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::ActivationPtr* output) { output->reset(); }

  static ::webnn::mojom::blink::Activation::Tag GetTag(const ::webnn::mojom::blink::ActivationPtr& input) {
    return input->which();
  }

  static const ::webnn::mojom::blink::ClampPtr& clamp(const ::webnn::mojom::blink::ActivationPtr& input) {
    return input->get_clamp();
  }

  static const ::webnn::mojom::blink::EluPtr& elu(const ::webnn::mojom::blink::ActivationPtr& input) {
    return input->get_elu();
  }

  static const ::webnn::mojom::blink::HardSigmoidPtr& hard_sigmoid(const ::webnn::mojom::blink::ActivationPtr& input) {
    return input->get_hard_sigmoid();
  }

  static const ::webnn::mojom::blink::LeakyReluPtr& leaky_relu(const ::webnn::mojom::blink::ActivationPtr& input) {
    return input->get_leaky_relu();
  }

  static const ::webnn::mojom::blink::LinearPtr& linear(const ::webnn::mojom::blink::ActivationPtr& input) {
    return input->get_linear();
  }

  static const ::webnn::mojom::blink::ReluPtr& relu(const ::webnn::mojom::blink::ActivationPtr& input) {
    return input->get_relu();
  }

  static const ::webnn::mojom::blink::SigmoidPtr& sigmoid(const ::webnn::mojom::blink::ActivationPtr& input) {
    return input->get_sigmoid();
  }

  static const ::webnn::mojom::blink::SoftmaxPtr& softmax(const ::webnn::mojom::blink::ActivationPtr& input) {
    return input->get_softmax();
  }

  static const ::webnn::mojom::blink::SoftplusPtr& softplus(const ::webnn::mojom::blink::ActivationPtr& input) {
    return input->get_softplus();
  }

  static const ::webnn::mojom::blink::SoftsignPtr& softsign(const ::webnn::mojom::blink::ActivationPtr& input) {
    return input->get_softsign();
  }

  static const ::webnn::mojom::blink::TanhPtr& tanh(const ::webnn::mojom::blink::ActivationPtr& input) {
    return input->get_tanh();
  }

  static bool Read(::webnn::mojom::blink::Activation::DataView input, ::webnn::mojom::blink::ActivationPtr* output);
};


template <>
struct  UnionTraits<::webnn::mojom::blink::Operation::DataView,
                                        ::webnn::mojom::blink::OperationPtr> {
  static bool IsNull(const ::webnn::mojom::blink::OperationPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::OperationPtr* output) { output->reset(); }

  static ::webnn::mojom::blink::Operation::Tag GetTag(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->which();
  }

  static const ::webnn::mojom::blink::ArgMinMaxPtr& arg_min_max(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_arg_min_max();
  }

  static const ::webnn::mojom::blink::BatchNormalizationPtr& batch_normalization(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_batch_normalization();
  }

  static const ::webnn::mojom::blink::ClampPtr& clamp(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_clamp();
  }

  static const ::webnn::mojom::blink::ConcatPtr& concat(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_concat();
  }

  static const ::webnn::mojom::blink::Conv2dPtr& conv2d(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_conv2d();
  }

  static const ::webnn::mojom::blink::ElementWiseBinaryPtr& element_wise_binary(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_element_wise_binary();
  }

  static const ::webnn::mojom::blink::EluPtr& elu(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_elu();
  }

  static const ::webnn::mojom::blink::ElementWiseUnaryPtr& element_wise_unary(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_element_wise_unary();
  }

  static const ::webnn::mojom::blink::ExpandPtr& expand(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_expand();
  }

  static const ::webnn::mojom::blink::GatherPtr& gather(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_gather();
  }

  static const ::webnn::mojom::blink::GemmPtr& gemm(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_gemm();
  }

  static const ::webnn::mojom::blink::HardSigmoidPtr& hard_sigmoid(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_hard_sigmoid();
  }

  static const ::webnn::mojom::blink::LayerNormalizationPtr& layer_normalization(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_layer_normalization();
  }

  static const ::webnn::mojom::blink::InstanceNormalizationPtr& instance_normalization(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_instance_normalization();
  }

  static const ::webnn::mojom::blink::LeakyReluPtr& leaky_relu(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_leaky_relu();
  }

  static const ::webnn::mojom::blink::LinearPtr& linear(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_linear();
  }

  static const ::webnn::mojom::blink::MatmulPtr& matmul(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_matmul();
  }

  static const ::webnn::mojom::blink::PadPtr& pad(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_pad();
  }

  static const ::webnn::mojom::blink::Pool2dPtr& pool2d(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_pool2d();
  }

  static const ::webnn::mojom::blink::PreluPtr& prelu(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_prelu();
  }

  static const ::webnn::mojom::blink::ReducePtr& reduce(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_reduce();
  }

  static const ::webnn::mojom::blink::ReluPtr& relu(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_relu();
  }

  static const ::webnn::mojom::blink::Resample2dPtr& resample2d(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_resample2d();
  }

  static const ::webnn::mojom::blink::ReshapePtr& reshape(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_reshape();
  }

  static const ::webnn::mojom::blink::SigmoidPtr& sigmoid(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_sigmoid();
  }

  static const ::webnn::mojom::blink::SlicePtr& slice(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_slice();
  }

  static const ::webnn::mojom::blink::SoftmaxPtr& softmax(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_softmax();
  }

  static const ::webnn::mojom::blink::SoftplusPtr& softplus(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_softplus();
  }

  static const ::webnn::mojom::blink::SoftsignPtr& softsign(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_softsign();
  }

  static const ::webnn::mojom::blink::SplitPtr& split(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_split();
  }

  static const ::webnn::mojom::blink::TanhPtr& tanh(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_tanh();
  }

  static const ::webnn::mojom::blink::TransposePtr& transpose(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_transpose();
  }

  static const ::webnn::mojom::blink::WherePtr& where(const ::webnn::mojom::blink::OperationPtr& input) {
    return input->get_where();
  }

  static bool Read(::webnn::mojom::blink::Operation::DataView input, ::webnn::mojom::blink::OperationPtr* output);
};


template <>
struct  UnionTraits<::webnn::mojom::blink::ComputeResult::DataView,
                                        ::webnn::mojom::blink::ComputeResultPtr> {
  static bool IsNull(const ::webnn::mojom::blink::ComputeResultPtr& input) { return !input; }
  static void SetToNull(::webnn::mojom::blink::ComputeResultPtr* output) { output->reset(); }

  static ::webnn::mojom::blink::ComputeResult::Tag GetTag(const ::webnn::mojom::blink::ComputeResultPtr& input) {
    return input->which();
  }

  static  WTF::HashMap<WTF::String, ::mojo_base::BigBuffer>& named_outputs( ::webnn::mojom::blink::ComputeResultPtr& input) {
    return input->get_named_outputs();
  }

  static const ::webnn::mojom::blink::ErrorPtr& error(const ::webnn::mojom::blink::ComputeResultPtr& input) {
    return input->get_error();
  }

  static bool Read(::webnn::mojom::blink::ComputeResult::DataView input, ::webnn::mojom::blink::ComputeResultPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_GRAPH_MOJOM_BLINK_H_