// Copyright 2014 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   templates/runtime_enabled_features.cc.tmpl
// and input files:
//   ../../third_party/blink/renderer/platform/runtime_enabled_features.json5


#include "build/build_config.h"
#include "build/chromeos_buildflags.h"

#include "third_party/blink/renderer/platform/runtime_enabled_features.h"

#include "third_party/blink/public/common/features.h"
#include "third_party/blink/public/mojom/origin_trial_feature/origin_trial_feature.mojom-shared.h"
#include "third_party/blink/renderer/platform/runtime_feature_state/runtime_feature_state_override_context.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

RuntimeEnabledFeaturesBase::Backup::Backup()
  : is_accelerated_2d_canvas_enabled_(RuntimeEnabledFeaturesBase::is_accelerated_2d_canvas_enabled_),
    is_accelerated_small_canvases_enabled_(RuntimeEnabledFeaturesBase::is_accelerated_small_canvases_enabled_),
    is_accessibility_aria_virtual_content_enabled_(RuntimeEnabledFeaturesBase::is_accessibility_aria_virtual_content_enabled_),
    is_accessibility_expose_display_none_enabled_(RuntimeEnabledFeaturesBase::is_accessibility_expose_display_none_enabled_),
    is_accessibility_expose_html_element_enabled_(RuntimeEnabledFeaturesBase::is_accessibility_expose_html_element_enabled_),
    is_accessibility_expose_ignored_nodes_enabled_(RuntimeEnabledFeaturesBase::is_accessibility_expose_ignored_nodes_enabled_),
    is_accessibility_object_model_enabled_(RuntimeEnabledFeaturesBase::is_accessibility_object_model_enabled_),
    is_accessibility_os_level_bold_text_enabled_(RuntimeEnabledFeaturesBase::is_accessibility_os_level_bold_text_enabled_),
    is_accessibility_page_zoom_enabled_(RuntimeEnabledFeaturesBase::is_accessibility_page_zoom_enabled_),
    is_accessibility_serialization_size_metrics_enabled_(RuntimeEnabledFeaturesBase::is_accessibility_serialization_size_metrics_enabled_),
    is_accessibility_use_ax_position_for_document_markers_enabled_(RuntimeEnabledFeaturesBase::is_accessibility_use_ax_position_for_document_markers_enabled_),
    is_accordion_pattern_enabled_(RuntimeEnabledFeaturesBase::is_accordion_pattern_enabled_),
    is_add_identity_in_can_make_payment_event_enabled_(RuntimeEnabledFeaturesBase::is_add_identity_in_can_make_payment_event_enabled_),
    is_address_space_enabled_(RuntimeEnabledFeaturesBase::is_address_space_enabled_),
    is_ad_interest_group_api_enabled_(RuntimeEnabledFeaturesBase::is_ad_interest_group_api_enabled_),
    is_ad_tagging_enabled_(RuntimeEnabledFeaturesBase::is_ad_tagging_enabled_),
    is_align_content_for_blocks_enabled_(RuntimeEnabledFeaturesBase::is_align_content_for_blocks_enabled_),
    is_allow_content_initiated_data_url_navigations_enabled_(RuntimeEnabledFeaturesBase::is_allow_content_initiated_data_url_navigations_enabled_),
    is_allow_ur_ns_in_iframes_enabled_(RuntimeEnabledFeaturesBase::is_allow_ur_ns_in_iframes_enabled_),
    is_android_downloadable_fonts_matching_enabled_(RuntimeEnabledFeaturesBase::is_android_downloadable_fonts_matching_enabled_),
    is_animation_worklet_enabled_(RuntimeEnabledFeaturesBase::is_animation_worklet_enabled_),
    is_anonymous_iframe_enabled_(RuntimeEnabledFeaturesBase::is_anonymous_iframe_enabled_),
    is_aom_aria_relationship_properties_enabled_(RuntimeEnabledFeaturesBase::is_aom_aria_relationship_properties_enabled_),
    is_app_title_enabled_(RuntimeEnabledFeaturesBase::is_app_title_enabled_),
    is_arrow_keys_in_vertical_writing_modes_enabled_(RuntimeEnabledFeaturesBase::is_arrow_keys_in_vertical_writing_modes_enabled_),
    is_async_clipboard_implicit_permission_enabled_(RuntimeEnabledFeaturesBase::is_async_clipboard_implicit_permission_enabled_),
    is_attribution_reporting_enabled_(RuntimeEnabledFeaturesBase::is_attribution_reporting_enabled_),
    is_attribution_reporting_cross_app_web_enabled_(RuntimeEnabledFeaturesBase::is_attribution_reporting_cross_app_web_enabled_),
    is_attribution_reporting_interface_enabled_(RuntimeEnabledFeaturesBase::is_attribution_reporting_interface_enabled_),
    is_audio_context_set_sink_id_enabled_(RuntimeEnabledFeaturesBase::is_audio_context_set_sink_id_enabled_),
    is_audio_output_devices_enabled_(RuntimeEnabledFeaturesBase::is_audio_output_devices_enabled_),
    is_audio_video_tracks_enabled_(RuntimeEnabledFeaturesBase::is_audio_video_tracks_enabled_),
    is_auto_dark_mode_enabled_(RuntimeEnabledFeaturesBase::is_auto_dark_mode_enabled_),
    is_auto_disable_accessibility_v_2_enabled_(RuntimeEnabledFeaturesBase::is_auto_disable_accessibility_v_2_enabled_),
    is_automation_controlled_enabled_(RuntimeEnabledFeaturesBase::is_automation_controlled_enabled_),
    is_autoplay_ignores_web_audio_enabled_(RuntimeEnabledFeaturesBase::is_autoplay_ignores_web_audio_enabled_),
    is_auto_size_lazy_loaded_images_enabled_(RuntimeEnabledFeaturesBase::is_auto_size_lazy_loaded_images_enabled_),
    is_avoid_caret_visible_selection_adjuster_enabled_(RuntimeEnabledFeaturesBase::is_avoid_caret_visible_selection_adjuster_enabled_),
    is_backdrop_inherit_originating_enabled_(RuntimeEnabledFeaturesBase::is_backdrop_inherit_originating_enabled_),
    is_backface_visibility_interop_enabled_(RuntimeEnabledFeaturesBase::is_backface_visibility_interop_enabled_),
    is_back_forward_cache_enabled_(RuntimeEnabledFeaturesBase::is_back_forward_cache_enabled_),
    is_back_forward_cache_experiment_http_header_enabled_(RuntimeEnabledFeaturesBase::is_back_forward_cache_experiment_http_header_enabled_),
    is_back_forward_cache_not_restored_reasons_enabled_(RuntimeEnabledFeaturesBase::is_back_forward_cache_not_restored_reasons_enabled_),
    is_background_fetch_enabled_(RuntimeEnabledFeaturesBase::is_background_fetch_enabled_),
    is_barcode_detector_enabled_(RuntimeEnabledFeaturesBase::is_barcode_detector_enabled_),
    is_bdi_element_dir_inheritance_enabled_(RuntimeEnabledFeaturesBase::is_bdi_element_dir_inheritance_enabled_),
    is_beforeunload_event_cancel_by_prevent_default_enabled_(RuntimeEnabledFeaturesBase::is_beforeunload_event_cancel_by_prevent_default_enabled_),
    is_bidi_caret_affinity_enabled_(RuntimeEnabledFeaturesBase::is_bidi_caret_affinity_enabled_),
    is_blink_extension_chrome_os_enabled_(RuntimeEnabledFeaturesBase::is_blink_extension_chrome_os_enabled_),
    is_blink_extension_chrome_os_kiosk_enabled_(RuntimeEnabledFeaturesBase::is_blink_extension_chrome_os_kiosk_enabled_),
    is_blink_extension_diagnostics_enabled_(RuntimeEnabledFeaturesBase::is_blink_extension_diagnostics_enabled_),
    is_blink_lifecycle_script_forbidden_enabled_(RuntimeEnabledFeaturesBase::is_blink_lifecycle_script_forbidden_enabled_),
    is_blink_runtime_call_stats_enabled_(RuntimeEnabledFeaturesBase::is_blink_runtime_call_stats_enabled_),
    is_blocking_focus_without_user_activation_enabled_(RuntimeEnabledFeaturesBase::is_blocking_focus_without_user_activation_enabled_),
    is_block_ruby_console_message_enabled_(RuntimeEnabledFeaturesBase::is_block_ruby_console_message_enabled_),
    is_block_ruby_wrapping_inline_ruby_enabled_(RuntimeEnabledFeaturesBase::is_block_ruby_wrapping_inline_ruby_enabled_),
    is_boundary_event_dispatch_tracks_node_removal_enabled_(RuntimeEnabledFeaturesBase::is_boundary_event_dispatch_tracks_node_removal_enabled_),
    is_browser_verified_user_activation_keyboard_enabled_(RuntimeEnabledFeaturesBase::is_browser_verified_user_activation_keyboard_enabled_),
    is_browser_verified_user_activation_mouse_enabled_(RuntimeEnabledFeaturesBase::is_browser_verified_user_activation_mouse_enabled_),
    is_byob_fetch_enabled_(RuntimeEnabledFeaturesBase::is_byob_fetch_enabled_),
    is_cache_storage_code_cache_hint_enabled_(RuntimeEnabledFeaturesBase::is_cache_storage_code_cache_hint_enabled_),
    is_canonicalize_whitespace_strings_enabled_(RuntimeEnabledFeaturesBase::is_canonicalize_whitespace_strings_enabled_),
    is_canvas_2d_canvas_filter_enabled_(RuntimeEnabledFeaturesBase::is_canvas_2d_canvas_filter_enabled_),
    is_canvas_2d_image_chromium_enabled_(RuntimeEnabledFeaturesBase::is_canvas_2d_image_chromium_enabled_),
    is_canvas_2d_layers_enabled_(RuntimeEnabledFeaturesBase::is_canvas_2d_layers_enabled_),
    is_canvas_2d_mesh_enabled_(RuntimeEnabledFeaturesBase::is_canvas_2d_mesh_enabled_),
    is_canvas_2d_scroll_path_into_view_enabled_(RuntimeEnabledFeaturesBase::is_canvas_2d_scroll_path_into_view_enabled_),
    is_canvas_floating_point_enabled_(RuntimeEnabledFeaturesBase::is_canvas_floating_point_enabled_),
    is_canvas_hdr_enabled_(RuntimeEnabledFeaturesBase::is_canvas_hdr_enabled_),
    is_canvas_image_smoothing_enabled_(RuntimeEnabledFeaturesBase::is_canvas_image_smoothing_enabled_),
    is_capability_delegation_display_capture_request_enabled_(RuntimeEnabledFeaturesBase::is_capability_delegation_display_capture_request_enabled_),
    is_capture_controller_enabled_(RuntimeEnabledFeaturesBase::is_capture_controller_enabled_),
    is_captured_mouse_events_enabled_(RuntimeEnabledFeaturesBase::is_captured_mouse_events_enabled_),
    is_captured_surface_control_enabled_(RuntimeEnabledFeaturesBase::is_captured_surface_control_enabled_),
    is_capture_handle_enabled_(RuntimeEnabledFeaturesBase::is_capture_handle_enabled_),
    is_cct_new_rfm_push_behavior_enabled_(RuntimeEnabledFeaturesBase::is_cct_new_rfm_push_behavior_enabled_),
    is_check_visibility_extra_properties_enabled_(RuntimeEnabledFeaturesBase::is_check_visibility_extra_properties_enabled_),
    is_click_to_captured_pointer_enabled_(RuntimeEnabledFeaturesBase::is_click_to_captured_pointer_enabled_),
    is_clipboard_supported_types_enabled_(RuntimeEnabledFeaturesBase::is_clipboard_supported_types_enabled_),
    is_clipboard_svg_enabled_(RuntimeEnabledFeaturesBase::is_clipboard_svg_enabled_),
    is_clipboard_unsanitized_content_enabled_(RuntimeEnabledFeaturesBase::is_clipboard_unsanitized_content_enabled_),
    is_clipboard_well_formed_html_sanitization_write_enabled_(RuntimeEnabledFeaturesBase::is_clipboard_well_formed_html_sanitization_write_enabled_),
    is_clip_path_geometry_box_enabled_(RuntimeEnabledFeaturesBase::is_clip_path_geometry_box_enabled_),
    is_clip_path_reject_empty_paths_enabled_(RuntimeEnabledFeaturesBase::is_clip_path_reject_empty_paths_enabled_),
    is_clip_path_xywh_and_rect_enabled_(RuntimeEnabledFeaturesBase::is_clip_path_xywh_and_rect_enabled_),
    is_close_watcher_enabled_(RuntimeEnabledFeaturesBase::is_close_watcher_enabled_),
    is_coep_reflection_enabled_(RuntimeEnabledFeaturesBase::is_coep_reflection_enabled_),
    is_composite_bg_color_animation_enabled_(RuntimeEnabledFeaturesBase::is_composite_bg_color_animation_enabled_),
    is_composite_box_shadow_animation_enabled_(RuntimeEnabledFeaturesBase::is_composite_box_shadow_animation_enabled_),
    is_composite_clip_path_animation_enabled_(RuntimeEnabledFeaturesBase::is_composite_clip_path_animation_enabled_),
    is_composited_selection_update_enabled_(RuntimeEnabledFeaturesBase::is_composited_selection_update_enabled_),
    is_composition_foreground_markers_enabled_(RuntimeEnabledFeaturesBase::is_composition_foreground_markers_enabled_),
    is_compression_dictionary_transport_enabled_(RuntimeEnabledFeaturesBase::is_compression_dictionary_transport_enabled_),
    is_compression_dictionary_transport_backend_enabled_(RuntimeEnabledFeaturesBase::is_compression_dictionary_transport_backend_enabled_),
    is_computed_accessibility_info_enabled_(RuntimeEnabledFeaturesBase::is_computed_accessibility_info_enabled_),
    is_compute_pressure_enabled_(RuntimeEnabledFeaturesBase::is_compute_pressure_enabled_),
    is_confirmation_of_action_enabled_(RuntimeEnabledFeaturesBase::is_confirmation_of_action_enabled_),
    is_consolidated_movement_xy_enabled_(RuntimeEnabledFeaturesBase::is_consolidated_movement_xy_enabled_),
    is_contacts_manager_enabled_(RuntimeEnabledFeaturesBase::is_contacts_manager_enabled_),
    is_contacts_manager_extra_properties_enabled_(RuntimeEnabledFeaturesBase::is_contacts_manager_extra_properties_enabled_),
    is_content_index_enabled_(RuntimeEnabledFeaturesBase::is_content_index_enabled_),
    is_context_menu_enabled_(RuntimeEnabledFeaturesBase::is_context_menu_enabled_),
    is_cookie_deprecation_facilitated_testing_enabled_(RuntimeEnabledFeaturesBase::is_cookie_deprecation_facilitated_testing_enabled_),
    is_cooperative_scheduling_enabled_(RuntimeEnabledFeaturesBase::is_cooperative_scheduling_enabled_),
    is_coop_restrict_properties_enabled_(RuntimeEnabledFeaturesBase::is_coop_restrict_properties_enabled_),
    is_cors_rfc_1918_enabled_(RuntimeEnabledFeaturesBase::is_cors_rfc_1918_enabled_),
    is_counter_style_change_shoule_collect_inlines_enabled_(RuntimeEnabledFeaturesBase::is_counter_style_change_shoule_collect_inlines_enabled_),
    is_cross_frame_performance_timeline_enabled_(RuntimeEnabledFeaturesBase::is_cross_frame_performance_timeline_enabled_),
    is_css_anchor_positioning_enabled_(RuntimeEnabledFeaturesBase::is_css_anchor_positioning_enabled_),
    is_css_anchor_positioning_cascade_fallback_enabled_(RuntimeEnabledFeaturesBase::is_css_anchor_positioning_cascade_fallback_enabled_),
    is_css_animation_composition_enabled_(RuntimeEnabledFeaturesBase::is_css_animation_composition_enabled_),
    is_css_animation_delay_start_end_enabled_(RuntimeEnabledFeaturesBase::is_css_animation_delay_start_end_enabled_),
    is_css_at_rule_counter_style_image_symbols_enabled_(RuntimeEnabledFeaturesBase::is_css_at_rule_counter_style_image_symbols_enabled_),
    is_css_at_rule_counter_style_speak_as_descriptor_enabled_(RuntimeEnabledFeaturesBase::is_css_at_rule_counter_style_speak_as_descriptor_enabled_),
    is_css_background_clip_unprefix_enabled_(RuntimeEnabledFeaturesBase::is_css_background_clip_unprefix_enabled_),
    is_css_calc_simplification_and_serialization_enabled_(RuntimeEnabledFeaturesBase::is_css_calc_simplification_and_serialization_enabled_),
    is_css_cap_font_units_enabled_(RuntimeEnabledFeaturesBase::is_css_cap_font_units_enabled_),
    is_css_case_sensitive_selector_enabled_(RuntimeEnabledFeaturesBase::is_css_case_sensitive_selector_enabled_),
    is_css_color_contrast_enabled_(RuntimeEnabledFeaturesBase::is_css_color_contrast_enabled_),
    is_css_color_typed_om_enabled_(RuntimeEnabledFeaturesBase::is_css_color_typed_om_enabled_),
    is_css_content_visibility_implies_contain_intrinsic_size_auto_enabled_(RuntimeEnabledFeaturesBase::is_css_content_visibility_implies_contain_intrinsic_size_auto_enabled_),
    is_css_cross_fade_enabled_(RuntimeEnabledFeaturesBase::is_css_cross_fade_enabled_),
    is_css_display_animation_enabled_(RuntimeEnabledFeaturesBase::is_css_display_animation_enabled_),
    is_css_display_ruby_enabled_(RuntimeEnabledFeaturesBase::is_css_display_ruby_enabled_),
    is_css_dynamic_range_limit_enabled_(RuntimeEnabledFeaturesBase::is_css_dynamic_range_limit_enabled_),
    is_css_enumerated_custom_properties_enabled_(RuntimeEnabledFeaturesBase::is_css_enumerated_custom_properties_enabled_),
    is_css_exponential_functions_enabled_(RuntimeEnabledFeaturesBase::is_css_exponential_functions_enabled_),
    is_css_field_sizing_enabled_(RuntimeEnabledFeaturesBase::is_css_field_sizing_enabled_),
    is_css_first_letter_no_new_line_as_preceding_char_enabled_(RuntimeEnabledFeaturesBase::is_css_first_letter_no_new_line_as_preceding_char_enabled_),
    is_css_font_size_adjust_enabled_(RuntimeEnabledFeaturesBase::is_css_font_size_adjust_enabled_),
    is_css_hex_alpha_color_enabled_(RuntimeEnabledFeaturesBase::is_css_hex_alpha_color_enabled_),
    is_css_layout_api_enabled_(RuntimeEnabledFeaturesBase::is_css_layout_api_enabled_),
    is_css_linear_timing_function_enabled_(RuntimeEnabledFeaturesBase::is_css_linear_timing_function_enabled_),
    is_css_logical_overflow_enabled_(RuntimeEnabledFeaturesBase::is_css_logical_overflow_enabled_),
    is_css_marker_nested_pseudo_element_enabled_(RuntimeEnabledFeaturesBase::is_css_marker_nested_pseudo_element_enabled_),
    is_css_masking_interop_enabled_(RuntimeEnabledFeaturesBase::is_css_masking_interop_enabled_),
    is_css_mpc_improvements_enabled_(RuntimeEnabledFeaturesBase::is_css_mpc_improvements_enabled_),
    is_css_nesting_ident_enabled_(RuntimeEnabledFeaturesBase::is_css_nesting_ident_enabled_),
    is_css_numeric_factory_completeness_enabled_(RuntimeEnabledFeaturesBase::is_css_numeric_factory_completeness_enabled_),
    is_css_offset_path_basic_shapes_circle_and_ellipse_enabled_(RuntimeEnabledFeaturesBase::is_css_offset_path_basic_shapes_circle_and_ellipse_enabled_),
    is_css_offset_path_basic_shapes_rectangles_and_polygon_enabled_(RuntimeEnabledFeaturesBase::is_css_offset_path_basic_shapes_rectangles_and_polygon_enabled_),
    is_css_offset_path_coord_box_enabled_(RuntimeEnabledFeaturesBase::is_css_offset_path_coord_box_enabled_),
    is_css_offset_path_ray_enabled_(RuntimeEnabledFeaturesBase::is_css_offset_path_ray_enabled_),
    is_css_offset_path_ray_contain_enabled_(RuntimeEnabledFeaturesBase::is_css_offset_path_ray_contain_enabled_),
    is_css_offset_path_url_enabled_(RuntimeEnabledFeaturesBase::is_css_offset_path_url_enabled_),
    is_css_offset_position_anchor_enabled_(RuntimeEnabledFeaturesBase::is_css_offset_position_anchor_enabled_),
    is_css_overflow_media_features_enabled_(RuntimeEnabledFeaturesBase::is_css_overflow_media_features_enabled_),
    is_css_paint_api_arguments_enabled_(RuntimeEnabledFeaturesBase::is_css_paint_api_arguments_enabled_),
    is_css_parser_ignore_charset_for_urls_enabled_(RuntimeEnabledFeaturesBase::is_css_parser_ignore_charset_for_urls_enabled_),
    is_css_phrase_line_break_enabled_(RuntimeEnabledFeaturesBase::is_css_phrase_line_break_enabled_),
    is_css_position_sticky_static_scroll_position_enabled_(RuntimeEnabledFeaturesBase::is_css_position_sticky_static_scroll_position_enabled_),
    is_css_progress_notation_enabled_(RuntimeEnabledFeaturesBase::is_css_progress_notation_enabled_),
    is_css_pseudo_dir_enabled_(RuntimeEnabledFeaturesBase::is_css_pseudo_dir_enabled_),
    is_css_pseudo_playing_paused_enabled_(RuntimeEnabledFeaturesBase::is_css_pseudo_playing_paused_enabled_),
    is_css_relative_color_enabled_(RuntimeEnabledFeaturesBase::is_css_relative_color_enabled_),
    is_css_resize_auto_enabled_(RuntimeEnabledFeaturesBase::is_css_resize_auto_enabled_),
    is_css_scope_enabled_(RuntimeEnabledFeaturesBase::is_css_scope_enabled_),
    is_css_scroll_snap_events_enabled_(RuntimeEnabledFeaturesBase::is_css_scroll_snap_events_enabled_),
    is_css_scroll_start_enabled_(RuntimeEnabledFeaturesBase::is_css_scroll_start_enabled_),
    is_css_scroll_state_container_queries_enabled_(RuntimeEnabledFeaturesBase::is_css_scroll_state_container_queries_enabled_),
    is_css_selector_fragment_anchor_enabled_(RuntimeEnabledFeaturesBase::is_css_selector_fragment_anchor_enabled_),
    is_css_selector_nth_child_complex_selector_enabled_(RuntimeEnabledFeaturesBase::is_css_selector_nth_child_complex_selector_enabled_),
    is_css_sign_related_functions_enabled_(RuntimeEnabledFeaturesBase::is_css_sign_related_functions_enabled_),
    is_css_snap_changed_event_enabled_(RuntimeEnabledFeaturesBase::is_css_snap_changed_event_enabled_),
    is_css_snap_changing_event_enabled_(RuntimeEnabledFeaturesBase::is_css_snap_changing_event_enabled_),
    is_css_snap_container_queries_enabled_(RuntimeEnabledFeaturesBase::is_css_snap_container_queries_enabled_),
    is_css_spelling_grammar_errors_enabled_(RuntimeEnabledFeaturesBase::is_css_spelling_grammar_errors_enabled_),
    is_css_stepped_value_functions_enabled_(RuntimeEnabledFeaturesBase::is_css_stepped_value_functions_enabled_),
    is_css_sticky_container_queries_enabled_(RuntimeEnabledFeaturesBase::is_css_sticky_container_queries_enabled_),
    is_css_supports_for_import_rules_enabled_(RuntimeEnabledFeaturesBase::is_css_supports_for_import_rules_enabled_),
    is_css_system_accent_color_enabled_(RuntimeEnabledFeaturesBase::is_css_system_accent_color_enabled_),
    is_css_text_auto_space_enabled_(RuntimeEnabledFeaturesBase::is_css_text_auto_space_enabled_),
    is_css_text_box_trim_enabled_(RuntimeEnabledFeaturesBase::is_css_text_box_trim_enabled_),
    is_css_text_spacing_enabled_(RuntimeEnabledFeaturesBase::is_css_text_spacing_enabled_),
    is_css_text_spacing_trim_enabled_(RuntimeEnabledFeaturesBase::is_css_text_spacing_trim_enabled_),
    is_css_text_wrap_balance_by_score_enabled_(RuntimeEnabledFeaturesBase::is_css_text_wrap_balance_by_score_enabled_),
    is_css_text_wrap_pretty_enabled_(RuntimeEnabledFeaturesBase::is_css_text_wrap_pretty_enabled_),
    is_css_transition_discrete_enabled_(RuntimeEnabledFeaturesBase::is_css_transition_discrete_enabled_),
    is_css_tree_scoped_timelines_enabled_(RuntimeEnabledFeaturesBase::is_css_tree_scoped_timelines_enabled_),
    is_css_unknown_container_queries_no_selection_enabled_(RuntimeEnabledFeaturesBase::is_css_unknown_container_queries_no_selection_enabled_),
    is_css_update_media_feature_enabled_(RuntimeEnabledFeaturesBase::is_css_update_media_feature_enabled_),
    is_css_user_select_contain_enabled_(RuntimeEnabledFeaturesBase::is_css_user_select_contain_enabled_),
    is_css_variables_2_image_values_enabled_(RuntimeEnabledFeaturesBase::is_css_variables_2_image_values_enabled_),
    is_css_variables_2_transform_values_enabled_(RuntimeEnabledFeaturesBase::is_css_variables_2_transform_values_enabled_),
    is_css_video_dynamic_range_media_queries_enabled_(RuntimeEnabledFeaturesBase::is_css_video_dynamic_range_media_queries_enabled_),
    is_css_viewport_units_4_enabled_(RuntimeEnabledFeaturesBase::is_css_viewport_units_4_enabled_),
    is_css_view_timeline_inset_shorthand_enabled_(RuntimeEnabledFeaturesBase::is_css_view_timeline_inset_shorthand_enabled_),
    is_custom_elements_get_name_enabled_(RuntimeEnabledFeaturesBase::is_custom_elements_get_name_enabled_),
    is_database_enabled_(RuntimeEnabledFeaturesBase::is_database_enabled_),
    is_data_transfer_clear_string_items_enabled_(RuntimeEnabledFeaturesBase::is_data_transfer_clear_string_items_enabled_),
    is_date_input_inline_block_enabled_(RuntimeEnabledFeaturesBase::is_date_input_inline_block_enabled_),
    is_deprecated_template_shadow_root_enabled_(RuntimeEnabledFeaturesBase::is_deprecated_template_shadow_root_enabled_),
    is_deprecate_unload_opt_out_enabled_(RuntimeEnabledFeaturesBase::is_deprecate_unload_opt_out_enabled_),
    is_desktop_capture_disable_local_echo_control_enabled_(RuntimeEnabledFeaturesBase::is_desktop_capture_disable_local_echo_control_enabled_),
    is_desktop_pw_as_additional_windowing_controls_enabled_(RuntimeEnabledFeaturesBase::is_desktop_pw_as_additional_windowing_controls_enabled_),
    is_desktop_pw_as_sub_apps_enabled_(RuntimeEnabledFeaturesBase::is_desktop_pw_as_sub_apps_enabled_),
    is_details_element_toggle_event_enabled_(RuntimeEnabledFeaturesBase::is_details_element_toggle_event_enabled_),
    is_details_styling_enabled_(RuntimeEnabledFeaturesBase::is_details_styling_enabled_),
    is_device_attributes_enabled_(RuntimeEnabledFeaturesBase::is_device_attributes_enabled_),
    is_device_orientation_request_permission_enabled_(RuntimeEnabledFeaturesBase::is_device_orientation_request_permission_enabled_),
    is_device_posture_enabled_(RuntimeEnabledFeaturesBase::is_device_posture_enabled_),
    is_dialog_new_focus_behavior_enabled_(RuntimeEnabledFeaturesBase::is_dialog_new_focus_behavior_enabled_),
    is_digital_goods_enabled_(RuntimeEnabledFeaturesBase::is_digital_goods_enabled_),
    is_digital_goods_v_2_1_enabled_(RuntimeEnabledFeaturesBase::is_digital_goods_v_2_1_enabled_),
    is_direct_sockets_enabled_(RuntimeEnabledFeaturesBase::is_direct_sockets_enabled_),
    is_dirname_more_input_types_enabled_(RuntimeEnabledFeaturesBase::is_dirname_more_input_types_enabled_),
    is_disable_different_origin_subframe_dialog_suppression_enabled_(RuntimeEnabledFeaturesBase::is_disable_different_origin_subframe_dialog_suppression_enabled_),
    is_disable_hardware_noise_suppression_enabled_(RuntimeEnabledFeaturesBase::is_disable_hardware_noise_suppression_enabled_),
    is_disable_select_all_for_empty_text_enabled_(RuntimeEnabledFeaturesBase::is_disable_select_all_for_empty_text_enabled_),
    is_disable_third_party_session_storage_partitioning_after_general_partitioning_enabled_(RuntimeEnabledFeaturesBase::is_disable_third_party_session_storage_partitioning_after_general_partitioning_enabled_),
    is_disable_third_party_storage_partitioning_enabled_(RuntimeEnabledFeaturesBase::is_disable_third_party_storage_partitioning_enabled_),
    is_dispatch_hidden_visibility_transitions_enabled_(RuntimeEnabledFeaturesBase::is_dispatch_hidden_visibility_transitions_enabled_),
    is_display_cutout_api_enabled_(RuntimeEnabledFeaturesBase::is_display_cutout_api_enabled_),
    is_document_base_uri_fix_enabled_(RuntimeEnabledFeaturesBase::is_document_base_uri_fix_enabled_),
    is_document_cookie_enabled_(RuntimeEnabledFeaturesBase::is_document_cookie_enabled_),
    is_document_domain_enabled_(RuntimeEnabledFeaturesBase::is_document_domain_enabled_),
    is_document_open_origin_alias_removal_enabled_(RuntimeEnabledFeaturesBase::is_document_open_origin_alias_removal_enabled_),
    is_document_open_sandbox_inheritance_removal_enabled_(RuntimeEnabledFeaturesBase::is_document_open_sandbox_inheritance_removal_enabled_),
    is_document_picture_in_picture_api_enabled_(RuntimeEnabledFeaturesBase::is_document_picture_in_picture_api_enabled_),
    is_document_policy_document_domain_enabled_(RuntimeEnabledFeaturesBase::is_document_policy_document_domain_enabled_),
    is_document_policy_negotiation_enabled_(RuntimeEnabledFeaturesBase::is_document_policy_negotiation_enabled_),
    is_document_policy_sync_xhr_enabled_(RuntimeEnabledFeaturesBase::is_document_policy_sync_xhr_enabled_),
    is_document_render_blocking_enabled_(RuntimeEnabledFeaturesBase::is_document_render_blocking_enabled_),
    is_document_write_enabled_(RuntimeEnabledFeaturesBase::is_document_write_enabled_),
    is_dom_parser_uses_html_fast_path_parser_enabled_(RuntimeEnabledFeaturesBase::is_dom_parser_uses_html_fast_path_parser_enabled_),
    is_dom_parts_api_enabled_(RuntimeEnabledFeaturesBase::is_dom_parts_api_enabled_),
    is_dont_fire_dblclick_on_disabled_form_controls_enabled_(RuntimeEnabledFeaturesBase::is_dont_fire_dblclick_on_disabled_form_controls_enabled_),
    is_dynamic_scroll_cull_rect_expansion_enabled_(RuntimeEnabledFeaturesBase::is_dynamic_scroll_cull_rect_expansion_enabled_),
    is_edit_context_enabled_(RuntimeEnabledFeaturesBase::is_edit_context_enabled_),
    is_element_capture_enabled_(RuntimeEnabledFeaturesBase::is_element_capture_enabled_),
    is_empty_clipboard_read_enabled_(RuntimeEnabledFeaturesBase::is_empty_clipboard_read_enabled_),
    is_enforce_anonymity_exposure_enabled_(RuntimeEnabledFeaturesBase::is_enforce_anonymity_exposure_enabled_),
    is_escape_lt_gt_in_attributes_enabled_(RuntimeEnabledFeaturesBase::is_escape_lt_gt_in_attributes_enabled_),
    is_event_timing_interaction_count_enabled_(RuntimeEnabledFeaturesBase::is_event_timing_interaction_count_enabled_),
    is_exclude_broken_image_icon_from_being_lcp_eligible_enabled_(RuntimeEnabledFeaturesBase::is_exclude_broken_image_icon_from_being_lcp_eligible_enabled_),
    is_experimental_content_security_policy_features_enabled_(RuntimeEnabledFeaturesBase::is_experimental_content_security_policy_features_enabled_),
    is_experimental_js_profiler_markers_enabled_(RuntimeEnabledFeaturesBase::is_experimental_js_profiler_markers_enabled_),
    is_experimental_policies_enabled_(RuntimeEnabledFeaturesBase::is_experimental_policies_enabled_),
    is_expose_render_time_non_tao_delayed_image_enabled_(RuntimeEnabledFeaturesBase::is_expose_render_time_non_tao_delayed_image_enabled_),
    is_extended_text_metrics_enabled_(RuntimeEnabledFeaturesBase::is_extended_text_metrics_enabled_),
    is_extra_webgl_video_texture_metadata_enabled_(RuntimeEnabledFeaturesBase::is_extra_webgl_video_texture_metadata_enabled_),
    is_eye_dropper_api_enabled_(RuntimeEnabledFeaturesBase::is_eye_dropper_api_enabled_),
    is_face_detector_enabled_(RuntimeEnabledFeaturesBase::is_face_detector_enabled_),
    is_fake_no_alloc_direct_call_for_testing_enabled_(RuntimeEnabledFeaturesBase::is_fake_no_alloc_direct_call_for_testing_enabled_),
    is_fast_position_iterator_enabled_(RuntimeEnabledFeaturesBase::is_fast_position_iterator_enabled_),
    is_fed_cm_enabled_(RuntimeEnabledFeaturesBase::is_fed_cm_enabled_),
    is_fed_cm_authz_enabled_(RuntimeEnabledFeaturesBase::is_fed_cm_authz_enabled_),
    is_fed_cm_auto_selected_flag_enabled_(RuntimeEnabledFeaturesBase::is_fed_cm_auto_selected_flag_enabled_),
    is_fed_cm_button_mode_enabled_(RuntimeEnabledFeaturesBase::is_fed_cm_button_mode_enabled_),
    is_fed_cm_disconnect_enabled_(RuntimeEnabledFeaturesBase::is_fed_cm_disconnect_enabled_),
    is_fed_cm_domain_hint_enabled_(RuntimeEnabledFeaturesBase::is_fed_cm_domain_hint_enabled_),
    is_fed_cm_error_enabled_(RuntimeEnabledFeaturesBase::is_fed_cm_error_enabled_),
    is_fed_cm_id_p_registration_enabled_(RuntimeEnabledFeaturesBase::is_fed_cm_id_p_registration_enabled_),
    is_fed_cm_idp_signin_status_enabled_(RuntimeEnabledFeaturesBase::is_fed_cm_idp_signin_status_enabled_),
    is_fed_cm_multiple_identity_providers_enabled_(RuntimeEnabledFeaturesBase::is_fed_cm_multiple_identity_providers_enabled_),
    is_fed_cm_selective_disclosure_enabled_(RuntimeEnabledFeaturesBase::is_fed_cm_selective_disclosure_enabled_),
    is_fenced_frames_enabled_(RuntimeEnabledFeaturesBase::is_fenced_frames_enabled_),
    is_fenced_frames_api_changes_enabled_(RuntimeEnabledFeaturesBase::is_fenced_frames_api_changes_enabled_),
    is_fenced_frames_default_mode_enabled_(RuntimeEnabledFeaturesBase::is_fenced_frames_default_mode_enabled_),
    is_fenced_frames_local_unpartitioned_data_access_enabled_(RuntimeEnabledFeaturesBase::is_fenced_frames_local_unpartitioned_data_access_enabled_),
    is_fetch_later_api_enabled_(RuntimeEnabledFeaturesBase::is_fetch_later_api_enabled_),
    is_fetch_upload_streaming_enabled_(RuntimeEnabledFeaturesBase::is_fetch_upload_streaming_enabled_),
    is_file_handling_enabled_(RuntimeEnabledFeaturesBase::is_file_handling_enabled_),
    is_file_handling_icons_enabled_(RuntimeEnabledFeaturesBase::is_file_handling_icons_enabled_),
    is_file_system_enabled_(RuntimeEnabledFeaturesBase::is_file_system_enabled_),
    is_file_system_access_enabled_(RuntimeEnabledFeaturesBase::is_file_system_access_enabled_),
    is_file_system_access_api_experimental_enabled_(RuntimeEnabledFeaturesBase::is_file_system_access_api_experimental_enabled_),
    is_file_system_access_get_cloud_identifiers_enabled_(RuntimeEnabledFeaturesBase::is_file_system_access_get_cloud_identifiers_enabled_),
    is_file_system_access_local_enabled_(RuntimeEnabledFeaturesBase::is_file_system_access_local_enabled_),
    is_file_system_access_locking_scheme_enabled_(RuntimeEnabledFeaturesBase::is_file_system_access_locking_scheme_enabled_),
    is_file_system_access_origin_private_enabled_(RuntimeEnabledFeaturesBase::is_file_system_access_origin_private_enabled_),
    is_file_system_observer_enabled_(RuntimeEnabledFeaturesBase::is_file_system_observer_enabled_),
    is_fledge_enabled_(RuntimeEnabledFeaturesBase::is_fledge_enabled_),
    is_fledge_bidding_and_auction_server_api_enabled_(RuntimeEnabledFeaturesBase::is_fledge_bidding_and_auction_server_api_enabled_),
    is_fledge_clear_origin_joined_ad_interest_groups_enabled_(RuntimeEnabledFeaturesBase::is_fledge_clear_origin_joined_ad_interest_groups_enabled_),
    is_fledge_direct_from_seller_signals_header_ad_slot_enabled_(RuntimeEnabledFeaturesBase::is_fledge_direct_from_seller_signals_header_ad_slot_enabled_),
    is_fledge_feature_detection_enabled_(RuntimeEnabledFeaturesBase::is_fledge_feature_detection_enabled_),
    is_fledge_negative_targeting_enabled_(RuntimeEnabledFeaturesBase::is_fledge_negative_targeting_enabled_),
    is_fledge_trusted_bidding_signals_slot_size_enabled_(RuntimeEnabledFeaturesBase::is_fledge_trusted_bidding_signals_slot_size_enabled_),
    is_fluent_overlay_scrollbars_enabled_(RuntimeEnabledFeaturesBase::is_fluent_overlay_scrollbars_enabled_),
    is_fluent_scrollbars_enabled_(RuntimeEnabledFeaturesBase::is_fluent_scrollbars_enabled_),
    is_flush_parser_before_creating_custom_elements_enabled_(RuntimeEnabledFeaturesBase::is_flush_parser_before_creating_custom_elements_enabled_),
    is_focusgroup_enabled_(RuntimeEnabledFeaturesBase::is_focusgroup_enabled_),
    is_focus_style_invalidation_on_page_activation_enabled_(RuntimeEnabledFeaturesBase::is_focus_style_invalidation_on_page_activation_enabled_),
    is_font_access_enabled_(RuntimeEnabledFeaturesBase::is_font_access_enabled_),
    is_fontations_font_backend_enabled_(RuntimeEnabledFeaturesBase::is_fontations_font_backend_enabled_),
    is_font_matching_ct_migration_enabled_(RuntimeEnabledFeaturesBase::is_font_matching_ct_migration_enabled_),
    is_font_palette_animation_enabled_(RuntimeEnabledFeaturesBase::is_font_palette_animation_enabled_),
    is_font_src_local_matching_enabled_(RuntimeEnabledFeaturesBase::is_font_src_local_matching_enabled_),
    is_forced_colors_enabled_(RuntimeEnabledFeaturesBase::is_forced_colors_enabled_),
    is_forced_colors_preserve_parent_color_enabled_(RuntimeEnabledFeaturesBase::is_forced_colors_preserve_parent_color_enabled_),
    is_force_eager_measure_memory_enabled_(RuntimeEnabledFeaturesBase::is_force_eager_measure_memory_enabled_),
    is_force_reduce_motion_enabled_(RuntimeEnabledFeaturesBase::is_force_reduce_motion_enabled_),
    is_force_taller_select_popup_enabled_(RuntimeEnabledFeaturesBase::is_force_taller_select_popup_enabled_),
    is_formatted_text_enabled_(RuntimeEnabledFeaturesBase::is_formatted_text_enabled_),
    is_form_control_restore_state_if_autocomplete_off_enabled_(RuntimeEnabledFeaturesBase::is_form_control_restore_state_if_autocomplete_off_enabled_),
    is_form_controls_vertical_writing_mode_direction_support_enabled_(RuntimeEnabledFeaturesBase::is_form_controls_vertical_writing_mode_direction_support_enabled_),
    is_form_controls_vertical_writing_mode_support_enabled_(RuntimeEnabledFeaturesBase::is_form_controls_vertical_writing_mode_support_enabled_),
    is_form_controls_vertical_writing_mode_text_support_enabled_(RuntimeEnabledFeaturesBase::is_form_controls_vertical_writing_mode_text_support_enabled_),
    is_form_state_restore_callback_call_with_state_enabled_(RuntimeEnabledFeaturesBase::is_form_state_restore_callback_call_with_state_enabled_),
    is_fractional_scroll_offsets_enabled_(RuntimeEnabledFeaturesBase::is_fractional_scroll_offsets_enabled_),
    is_freeze_frames_on_visibility_enabled_(RuntimeEnabledFeaturesBase::is_freeze_frames_on_visibility_enabled_),
    is_fullscreen_popup_windows_enabled_(RuntimeEnabledFeaturesBase::is_fullscreen_popup_windows_enabled_),
    is_gamepad_button_axis_events_enabled_(RuntimeEnabledFeaturesBase::is_gamepad_button_axis_events_enabled_),
    is_gamepad_multitouch_enabled_(RuntimeEnabledFeaturesBase::is_gamepad_multitouch_enabled_),
    is_get_all_screens_media_enabled_(RuntimeEnabledFeaturesBase::is_get_all_screens_media_enabled_),
    is_get_display_media_enabled_(RuntimeEnabledFeaturesBase::is_get_display_media_enabled_),
    is_get_display_media_requires_user_activation_enabled_(RuntimeEnabledFeaturesBase::is_get_display_media_requires_user_activation_enabled_),
    is_group_effect_enabled_(RuntimeEnabledFeaturesBase::is_group_effect_enabled_),
    is_handwriting_recognition_enabled_(RuntimeEnabledFeaturesBase::is_handwriting_recognition_enabled_),
    is_hanging_whitespace_does_not_depend_on_alignment_enabled_(RuntimeEnabledFeaturesBase::is_hanging_whitespace_does_not_depend_on_alignment_enabled_),
    is_has_ua_visual_transition_enabled_(RuntimeEnabledFeaturesBase::is_has_ua_visual_transition_enabled_),
    is_highlight_inheritance_enabled_(RuntimeEnabledFeaturesBase::is_highlight_inheritance_enabled_),
    is_highlight_pointer_events_enabled_(RuntimeEnabledFeaturesBase::is_highlight_pointer_events_enabled_),
    is_hit_test_opaqueness_enabled_(RuntimeEnabledFeaturesBase::is_hit_test_opaqueness_enabled_),
    is_hit_test_transparency_enabled_(RuntimeEnabledFeaturesBase::is_hit_test_transparency_enabled_),
    is_href_translate_enabled_(RuntimeEnabledFeaturesBase::is_href_translate_enabled_),
    is_html_invoke_actions_v_2_enabled_(RuntimeEnabledFeaturesBase::is_html_invoke_actions_v_2_enabled_),
    is_html_invoke_target_attribute_enabled_(RuntimeEnabledFeaturesBase::is_html_invoke_target_attribute_enabled_),
    is_html_lang_new_inheritance_enabled_(RuntimeEnabledFeaturesBase::is_html_lang_new_inheritance_enabled_),
    is_html_parser_fast_path_bulk_insert_notify_enabled_(RuntimeEnabledFeaturesBase::is_html_parser_fast_path_bulk_insert_notify_enabled_),
    is_html_parser_yield_and_delay_often_for_testing_enabled_(RuntimeEnabledFeaturesBase::is_html_parser_yield_and_delay_often_for_testing_enabled_),
    is_html_popover_hint_enabled_(RuntimeEnabledFeaturesBase::is_html_popover_hint_enabled_),
    is_html_search_element_enabled_(RuntimeEnabledFeaturesBase::is_html_search_element_enabled_),
    is_html_select_element_show_picker_enabled_(RuntimeEnabledFeaturesBase::is_html_select_element_show_picker_enabled_),
    is_html_select_list_element_enabled_(RuntimeEnabledFeaturesBase::is_html_select_list_element_enabled_),
    is_html_unsafe_methods_enabled_(RuntimeEnabledFeaturesBase::is_html_unsafe_methods_enabled_),
    is_implicit_root_scroller_enabled_(RuntimeEnabledFeaturesBase::is_implicit_root_scroller_enabled_),
    is_import_attributes_disallow_unknown_keys_enabled_(RuntimeEnabledFeaturesBase::is_import_attributes_disallow_unknown_keys_enabled_),
    is_incoming_call_notifications_enabled_(RuntimeEnabledFeaturesBase::is_incoming_call_notifications_enabled_),
    is_inert_display_transition_enabled_(RuntimeEnabledFeaturesBase::is_inert_display_transition_enabled_),
    is_infinite_cull_rect_enabled_(RuntimeEnabledFeaturesBase::is_infinite_cull_rect_enabled_),
    is_inherit_user_modify_without_contenteditable_enabled_(RuntimeEnabledFeaturesBase::is_inherit_user_modify_without_contenteditable_enabled_),
    is_inner_html_parser_fastpath_log_failure_enabled_(RuntimeEnabledFeaturesBase::is_inner_html_parser_fastpath_log_failure_enabled_),
    is_input_multiple_fields_ui_enabled_(RuntimeEnabledFeaturesBase::is_input_multiple_fields_ui_enabled_),
    is_insert_line_break_if_phrasing_content_enabled_(RuntimeEnabledFeaturesBase::is_insert_line_break_if_phrasing_content_enabled_),
    is_installed_app_enabled_(RuntimeEnabledFeaturesBase::is_installed_app_enabled_),
    is_interoperable_private_attribution_enabled_(RuntimeEnabledFeaturesBase::is_interoperable_private_attribution_enabled_),
    is_interrupt_composed_scrollbar_disappearance_enabled_(RuntimeEnabledFeaturesBase::is_interrupt_composed_scrollbar_disappearance_enabled_),
    is_intersection_observer_scroll_margin_enabled_(RuntimeEnabledFeaturesBase::is_intersection_observer_scroll_margin_enabled_),
    is_intersection_optimization_enabled_(RuntimeEnabledFeaturesBase::is_intersection_optimization_enabled_),
    is_inverted_colors_enabled_(RuntimeEnabledFeaturesBase::is_inverted_colors_enabled_),
    is_invisible_svg_animation_throttling_enabled_(RuntimeEnabledFeaturesBase::is_invisible_svg_animation_throttling_enabled_),
    is_java_script_compile_hints_magic_runtime_enabled_(RuntimeEnabledFeaturesBase::is_java_script_compile_hints_magic_runtime_enabled_),
    is_keyboard_accessible_tooltip_enabled_(RuntimeEnabledFeaturesBase::is_keyboard_accessible_tooltip_enabled_),
    is_keyboard_focusable_scrollers_enabled_(RuntimeEnabledFeaturesBase::is_keyboard_focusable_scrollers_enabled_),
    is_lang_attribute_aware_form_control_ui_enabled_(RuntimeEnabledFeaturesBase::is_lang_attribute_aware_form_control_ui_enabled_),
    is_layout_align_for_positioned_enabled_(RuntimeEnabledFeaturesBase::is_layout_align_for_positioned_enabled_),
    is_layout_flex_new_row_algorithm_v_3_enabled_(RuntimeEnabledFeaturesBase::is_layout_flex_new_row_algorithm_v_3_enabled_),
    is_layout_ignore_margins_for_sticky_enabled_(RuntimeEnabledFeaturesBase::is_layout_ignore_margins_for_sticky_enabled_),
    is_layout_new_containing_block_enabled_(RuntimeEnabledFeaturesBase::is_layout_new_containing_block_enabled_),
    is_layout_new_measure_cache_enabled_(RuntimeEnabledFeaturesBase::is_layout_new_measure_cache_enabled_),
    is_layout_new_min_max_cache_enabled_(RuntimeEnabledFeaturesBase::is_layout_new_min_max_cache_enabled_),
    is_layout_ng_shape_cache_enabled_(RuntimeEnabledFeaturesBase::is_layout_ng_shape_cache_enabled_),
    is_lazy_initialize_media_controls_enabled_(RuntimeEnabledFeaturesBase::is_lazy_initialize_media_controls_enabled_),
    is_lazy_load_scroll_margin_enabled_(RuntimeEnabledFeaturesBase::is_lazy_load_scroll_margin_enabled_),
    is_lcp_animated_images_web_exposed_enabled_(RuntimeEnabledFeaturesBase::is_lcp_animated_images_web_exposed_enabled_),
    is_lcp_mouseover_heuristics_enabled_(RuntimeEnabledFeaturesBase::is_lcp_mouseover_heuristics_enabled_),
    is_lcp_multiple_updates_per_element_enabled_(RuntimeEnabledFeaturesBase::is_lcp_multiple_updates_per_element_enabled_),
    is_legacy_windows_d_write_font_fallback_enabled_(RuntimeEnabledFeaturesBase::is_legacy_windows_d_write_font_fallback_enabled_),
    is_locked_mode_enabled_(RuntimeEnabledFeaturesBase::is_locked_mode_enabled_),
    is_long_animation_frame_timing_enabled_(RuntimeEnabledFeaturesBase::is_long_animation_frame_timing_enabled_),
    is_long_task_from_long_animation_frame_enabled_(RuntimeEnabledFeaturesBase::is_long_task_from_long_animation_frame_enabled_),
    is_mac_fonts_deprecate_font_traits_workaround_enabled_(RuntimeEnabledFeaturesBase::is_mac_fonts_deprecate_font_traits_workaround_enabled_),
    is_machine_learning_common_enabled_(RuntimeEnabledFeaturesBase::is_machine_learning_common_enabled_),
    is_machine_learning_model_loader_enabled_(RuntimeEnabledFeaturesBase::is_machine_learning_model_loader_enabled_),
    is_machine_learning_neural_network_enabled_(RuntimeEnabledFeaturesBase::is_machine_learning_neural_network_enabled_),
    is_managed_configuration_enabled_(RuntimeEnabledFeaturesBase::is_managed_configuration_enabled_),
    is_masking_grapheme_clusters_enabled_(RuntimeEnabledFeaturesBase::is_masking_grapheme_clusters_enabled_),
    is_measure_memory_enabled_(RuntimeEnabledFeaturesBase::is_measure_memory_enabled_),
    is_media_capabilities_dynamic_range_enabled_(RuntimeEnabledFeaturesBase::is_media_capabilities_dynamic_range_enabled_),
    is_media_capabilities_encoding_info_enabled_(RuntimeEnabledFeaturesBase::is_media_capabilities_encoding_info_enabled_),
    is_media_capabilities_spatial_audio_enabled_(RuntimeEnabledFeaturesBase::is_media_capabilities_spatial_audio_enabled_),
    is_media_capture_enabled_(RuntimeEnabledFeaturesBase::is_media_capture_enabled_),
    is_media_capture_background_blur_enabled_(RuntimeEnabledFeaturesBase::is_media_capture_background_blur_enabled_),
    is_media_capture_camera_controls_enabled_(RuntimeEnabledFeaturesBase::is_media_capture_camera_controls_enabled_),
    is_media_capture_configuration_change_enabled_(RuntimeEnabledFeaturesBase::is_media_capture_configuration_change_enabled_),
    is_media_capture_voice_isolation_enabled_(RuntimeEnabledFeaturesBase::is_media_capture_voice_isolation_enabled_),
    is_media_cast_overlay_button_enabled_(RuntimeEnabledFeaturesBase::is_media_cast_overlay_button_enabled_),
    is_media_controls_expand_gesture_enabled_(RuntimeEnabledFeaturesBase::is_media_controls_expand_gesture_enabled_),
    is_media_controls_overlay_play_button_enabled_(RuntimeEnabledFeaturesBase::is_media_controls_overlay_play_button_enabled_),
    is_media_element_volume_greater_than_one_enabled_(RuntimeEnabledFeaturesBase::is_media_element_volume_greater_than_one_enabled_),
    is_media_engagement_bypass_autoplay_policies_enabled_(RuntimeEnabledFeaturesBase::is_media_engagement_bypass_autoplay_policies_enabled_),
    is_media_latency_hint_enabled_(RuntimeEnabledFeaturesBase::is_media_latency_hint_enabled_),
    is_media_query_navigation_controls_enabled_(RuntimeEnabledFeaturesBase::is_media_query_navigation_controls_enabled_),
    is_media_recorder_use_media_video_encoder_enabled_(RuntimeEnabledFeaturesBase::is_media_recorder_use_media_video_encoder_enabled_),
    is_media_session_enabled_(RuntimeEnabledFeaturesBase::is_media_session_enabled_),
    is_media_session_chapter_information_enabled_(RuntimeEnabledFeaturesBase::is_media_session_chapter_information_enabled_),
    is_media_session_enter_picture_in_picture_enabled_(RuntimeEnabledFeaturesBase::is_media_session_enter_picture_in_picture_enabled_),
    is_media_source_experimental_enabled_(RuntimeEnabledFeaturesBase::is_media_source_experimental_enabled_),
    is_media_source_extensions_for_webcodecs_enabled_(RuntimeEnabledFeaturesBase::is_media_source_extensions_for_webcodecs_enabled_),
    is_media_source_new_abort_and_duration_enabled_(RuntimeEnabledFeaturesBase::is_media_source_new_abort_and_duration_enabled_),
    is_media_stream_track_transfer_enabled_(RuntimeEnabledFeaturesBase::is_media_stream_track_transfer_enabled_),
    is_message_port_close_event_enabled_(RuntimeEnabledFeaturesBase::is_message_port_close_event_enabled_),
    is_middle_click_autoscroll_enabled_(RuntimeEnabledFeaturesBase::is_middle_click_autoscroll_enabled_),
    is_mobile_layout_theme_enabled_(RuntimeEnabledFeaturesBase::is_mobile_layout_theme_enabled_),
    is_model_execution_api_enabled_(RuntimeEnabledFeaturesBase::is_model_execution_api_enabled_),
    is_mojo_js_enabled_(RuntimeEnabledFeaturesBase::is_mojo_js_enabled_),
    is_mojo_js_test_enabled_(RuntimeEnabledFeaturesBase::is_mojo_js_test_enabled_),
    is_monitor_type_surfaces_enabled_(RuntimeEnabledFeaturesBase::is_monitor_type_surfaces_enabled_),
    is_mouse_drag_from_iframe_on_cancelled_mouse_down_enabled_(RuntimeEnabledFeaturesBase::is_mouse_drag_from_iframe_on_cancelled_mouse_down_enabled_),
    is_mouse_drag_on_cancelled_mouse_move_enabled_(RuntimeEnabledFeaturesBase::is_mouse_drag_on_cancelled_mouse_move_enabled_),
    is_mutation_events_enabled_(RuntimeEnabledFeaturesBase::is_mutation_events_enabled_),
    is_navigate_event_commit_behavior_enabled_(RuntimeEnabledFeaturesBase::is_navigate_event_commit_behavior_enabled_),
    is_navigate_event_source_element_enabled_(RuntimeEnabledFeaturesBase::is_navigate_event_source_element_enabled_),
    is_navigation_activation_enabled_(RuntimeEnabledFeaturesBase::is_navigation_activation_enabled_),
    is_navigation_id_enabled_(RuntimeEnabledFeaturesBase::is_navigation_id_enabled_),
    is_navigator_content_utils_enabled_(RuntimeEnabledFeaturesBase::is_navigator_content_utils_enabled_),
    is_net_info_constant_type_enabled_(RuntimeEnabledFeaturesBase::is_net_info_constant_type_enabled_),
    is_net_info_downlink_max_enabled_(RuntimeEnabledFeaturesBase::is_net_info_downlink_max_enabled_),
    is_next_sibling_position_use_next_candidate_enabled_(RuntimeEnabledFeaturesBase::is_next_sibling_position_use_next_candidate_enabled_),
    is_no_idle_encoding_for_web_tests_enabled_(RuntimeEnabledFeaturesBase::is_no_idle_encoding_for_web_tests_enabled_),
    is_non_composed_enter_leave_events_enabled_(RuntimeEnabledFeaturesBase::is_non_composed_enter_leave_events_enabled_),
    is_non_standard_appearance_values_high_usage_enabled_(RuntimeEnabledFeaturesBase::is_non_standard_appearance_values_high_usage_enabled_),
    is_non_standard_appearance_value_slider_vertical_enabled_(RuntimeEnabledFeaturesBase::is_non_standard_appearance_value_slider_vertical_enabled_),
    is_non_standard_appearance_values_low_usage_enabled_(RuntimeEnabledFeaturesBase::is_non_standard_appearance_values_low_usage_enabled_),
    is_no_offset_mapping_for_inconsistent_text_enabled_(RuntimeEnabledFeaturesBase::is_no_offset_mapping_for_inconsistent_text_enabled_),
    is_notification_constructor_enabled_(RuntimeEnabledFeaturesBase::is_notification_constructor_enabled_),
    is_notification_content_image_enabled_(RuntimeEnabledFeaturesBase::is_notification_content_image_enabled_),
    is_notifications_enabled_(RuntimeEnabledFeaturesBase::is_notifications_enabled_),
    is_notification_triggers_enabled_(RuntimeEnabledFeaturesBase::is_notification_triggers_enabled_),
    is_no_vary_search_prefetch_enabled_(RuntimeEnabledFeaturesBase::is_no_vary_search_prefetch_enabled_),
    is_observable_api_enabled_(RuntimeEnabledFeaturesBase::is_observable_api_enabled_),
    is_off_main_thread_css_paint_enabled_(RuntimeEnabledFeaturesBase::is_off_main_thread_css_paint_enabled_),
    is_offscreen_canvas_commit_enabled_(RuntimeEnabledFeaturesBase::is_offscreen_canvas_commit_enabled_),
    is_offset_mapping_unit_variable_enabled_(RuntimeEnabledFeaturesBase::is_offset_mapping_unit_variable_enabled_),
    is_on_device_change_enabled_(RuntimeEnabledFeaturesBase::is_on_device_change_enabled_),
    is_one_pass_raster_invalidation_enabled_(RuntimeEnabledFeaturesBase::is_one_pass_raster_invalidation_enabled_),
    is_option_element_always_use_label_enabled_(RuntimeEnabledFeaturesBase::is_option_element_always_use_label_enabled_),
    is_orientation_event_enabled_(RuntimeEnabledFeaturesBase::is_orientation_event_enabled_),
    is_origin_isolation_header_enabled_(RuntimeEnabledFeaturesBase::is_origin_isolation_header_enabled_),
    is_origin_policy_enabled_(RuntimeEnabledFeaturesBase::is_origin_policy_enabled_),
    is_origin_trials_sample_api_enabled_(RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_enabled_),
    is_origin_trials_sample_api_browser_read_write_enabled_(RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_browser_read_write_enabled_),
    is_origin_trials_sample_api_dependent_enabled_(RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_dependent_enabled_),
    is_origin_trials_sample_api_deprecation_enabled_(RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_deprecation_enabled_),
    is_origin_trials_sample_api_expiry_grace_period_enabled_(RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_expiry_grace_period_enabled_),
    is_origin_trials_sample_api_expiry_grace_period_third_party_enabled_(RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_expiry_grace_period_third_party_enabled_),
    is_origin_trials_sample_api_implied_enabled_(RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_implied_enabled_),
    is_origin_trials_sample_api_invalid_os_enabled_(RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_invalid_os_enabled_),
    is_origin_trials_sample_api_navigation_enabled_(RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_navigation_enabled_),
    is_origin_trials_sample_api_persistent_expiry_grace_period_enabled_(RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_persistent_expiry_grace_period_enabled_),
    is_origin_trials_sample_api_persistent_feature_enabled_(RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_persistent_feature_enabled_),
    is_origin_trials_sample_api_persistent_invalid_os_enabled_(RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_persistent_invalid_os_enabled_),
    is_origin_trials_sample_api_persistent_third_party_deprecation_feature_enabled_(RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_persistent_third_party_deprecation_feature_enabled_),
    is_origin_trials_sample_api_third_party_enabled_(RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_third_party_enabled_),
    is_overscroll_customization_enabled_(RuntimeEnabledFeaturesBase::is_overscroll_customization_enabled_),
    is_page_freeze_opt_in_enabled_(RuntimeEnabledFeaturesBase::is_page_freeze_opt_in_enabled_),
    is_page_freeze_opt_out_enabled_(RuntimeEnabledFeaturesBase::is_page_freeze_opt_out_enabled_),
    is_page_margin_boxes_enabled_(RuntimeEnabledFeaturesBase::is_page_margin_boxes_enabled_),
    is_page_popup_enabled_(RuntimeEnabledFeaturesBase::is_page_popup_enabled_),
    is_page_reveal_event_enabled_(RuntimeEnabledFeaturesBase::is_page_reveal_event_enabled_),
    is_paint_under_invalidation_checking_enabled_(RuntimeEnabledFeaturesBase::is_paint_under_invalidation_checking_enabled_),
    is_parakeet_enabled_(RuntimeEnabledFeaturesBase::is_parakeet_enabled_),
    is_partitioned_cookies_enabled_(RuntimeEnabledFeaturesBase::is_partitioned_cookies_enabled_),
    is_password_reveal_enabled_(RuntimeEnabledFeaturesBase::is_password_reveal_enabled_),
    is_password_strong_label_enabled_(RuntimeEnabledFeaturesBase::is_password_strong_label_enabled_),
    is_pasting_blocks_svg_use_non_local_hrefs_enabled_(RuntimeEnabledFeaturesBase::is_pasting_blocks_svg_use_non_local_hrefs_enabled_),
    is_payment_app_enabled_(RuntimeEnabledFeaturesBase::is_payment_app_enabled_),
    is_payment_handler_minimal_header_ux_enabled_(RuntimeEnabledFeaturesBase::is_payment_handler_minimal_header_ux_enabled_),
    is_payment_instruments_enabled_(RuntimeEnabledFeaturesBase::is_payment_instruments_enabled_),
    is_payment_method_change_event_enabled_(RuntimeEnabledFeaturesBase::is_payment_method_change_event_enabled_),
    is_payment_request_enabled_(RuntimeEnabledFeaturesBase::is_payment_request_enabled_),
    is_payment_request_allow_one_activationless_show_enabled_(RuntimeEnabledFeaturesBase::is_payment_request_allow_one_activationless_show_enabled_),
    is_payment_request_merchant_validation_event_enabled_(RuntimeEnabledFeaturesBase::is_payment_request_merchant_validation_event_enabled_),
    is_pending_beacon_api_enabled_(RuntimeEnabledFeaturesBase::is_pending_beacon_api_enabled_),
    is_percent_based_scrolling_enabled_(RuntimeEnabledFeaturesBase::is_percent_based_scrolling_enabled_),
    is_performance_manager_instrumentation_enabled_(RuntimeEnabledFeaturesBase::is_performance_manager_instrumentation_enabled_),
    is_performance_mark_feature_usage_enabled_(RuntimeEnabledFeaturesBase::is_performance_mark_feature_usage_enabled_),
    is_performance_navigate_system_entropy_enabled_(RuntimeEnabledFeaturesBase::is_performance_navigate_system_entropy_enabled_),
    is_periodic_background_sync_enabled_(RuntimeEnabledFeaturesBase::is_periodic_background_sync_enabled_),
    is_per_method_can_make_payment_quota_enabled_(RuntimeEnabledFeaturesBase::is_per_method_can_make_payment_quota_enabled_),
    is_permission_element_enabled_(RuntimeEnabledFeaturesBase::is_permission_element_enabled_),
    is_permissions_enabled_(RuntimeEnabledFeaturesBase::is_permissions_enabled_),
    is_permissions_request_revoke_enabled_(RuntimeEnabledFeaturesBase::is_permissions_request_revoke_enabled_),
    is_p_na_cl_enabled_(RuntimeEnabledFeaturesBase::is_p_na_cl_enabled_),
    is_pointer_capture_lost_on_removal_during_capture_enabled_(RuntimeEnabledFeaturesBase::is_pointer_capture_lost_on_removal_during_capture_enabled_),
    is_pointer_event_device_id_enabled_(RuntimeEnabledFeaturesBase::is_pointer_event_device_id_enabled_),
    is_position_outside_tab_span_check_sibling_node_enabled_(RuntimeEnabledFeaturesBase::is_position_outside_tab_span_check_sibling_node_enabled_),
    is_precise_memory_info_enabled_(RuntimeEnabledFeaturesBase::is_precise_memory_info_enabled_),
    is_prefer_non_composited_scrolling_enabled_(RuntimeEnabledFeaturesBase::is_prefer_non_composited_scrolling_enabled_),
    is_prefers_reduced_data_enabled_(RuntimeEnabledFeaturesBase::is_prefers_reduced_data_enabled_),
    is_prefixed_video_fullscreen_enabled_(RuntimeEnabledFeaturesBase::is_prefixed_video_fullscreen_enabled_),
    is_pre_paint_ancestors_of_missed_oof_enabled_(RuntimeEnabledFeaturesBase::is_pre_paint_ancestors_of_missed_oof_enabled_),
    is_prerender_2_enabled_(RuntimeEnabledFeaturesBase::is_prerender_2_enabled_),
    is_presentation_enabled_(RuntimeEnabledFeaturesBase::is_presentation_enabled_),
    is_pretty_print_js_on_document_enabled_(RuntimeEnabledFeaturesBase::is_pretty_print_js_on_document_enabled_),
    is_prevent_reading_system_accent_color_enabled_(RuntimeEnabledFeaturesBase::is_prevent_reading_system_accent_color_enabled_),
    is_privacy_sandbox_ads_api_s_enabled_(RuntimeEnabledFeaturesBase::is_privacy_sandbox_ads_api_s_enabled_),
    is_private_network_access_non_secure_contexts_allowed_enabled_(RuntimeEnabledFeaturesBase::is_private_network_access_non_secure_contexts_allowed_enabled_),
    is_private_network_access_null_ip_address_enabled_(RuntimeEnabledFeaturesBase::is_private_network_access_null_ip_address_enabled_),
    is_private_network_access_permission_prompt_enabled_(RuntimeEnabledFeaturesBase::is_private_network_access_permission_prompt_enabled_),
    is_private_state_tokens_enabled_(RuntimeEnabledFeaturesBase::is_private_state_tokens_enabled_),
    is_private_state_tokens_always_allow_issuance_enabled_(RuntimeEnabledFeaturesBase::is_private_state_tokens_always_allow_issuance_enabled_),
    is_push_messaging_enabled_(RuntimeEnabledFeaturesBase::is_push_messaging_enabled_),
    is_push_messaging_subscription_change_enabled_(RuntimeEnabledFeaturesBase::is_push_messaging_subscription_change_enabled_),
    is_quick_intensive_wake_up_throttling_after_loading_enabled_(RuntimeEnabledFeaturesBase::is_quick_intensive_wake_up_throttling_after_loading_enabled_),
    is_quota_change_enabled_(RuntimeEnabledFeaturesBase::is_quota_change_enabled_),
    is_readable_stream_tee_clone_for_branch_2_enabled_(RuntimeEnabledFeaturesBase::is_readable_stream_tee_clone_for_branch_2_enabled_),
    is_reduce_accept_language_enabled_(RuntimeEnabledFeaturesBase::is_reduce_accept_language_enabled_),
    is_reduce_cookie_ip_cs_enabled_(RuntimeEnabledFeaturesBase::is_reduce_cookie_ip_cs_enabled_),
    is_reduce_user_agent_android_version_device_model_enabled_(RuntimeEnabledFeaturesBase::is_reduce_user_agent_android_version_device_model_enabled_),
    is_reduce_user_agent_minor_version_enabled_(RuntimeEnabledFeaturesBase::is_reduce_user_agent_minor_version_enabled_),
    is_reduce_user_agent_platform_os_cpu_enabled_(RuntimeEnabledFeaturesBase::is_reduce_user_agent_platform_os_cpu_enabled_),
    is_reference_box_no_pixel_snapping_enabled_(RuntimeEnabledFeaturesBase::is_reference_box_no_pixel_snapping_enabled_),
    is_region_capture_enabled_(RuntimeEnabledFeaturesBase::is_region_capture_enabled_),
    is_remote_playback_enabled_(RuntimeEnabledFeaturesBase::is_remote_playback_enabled_),
    is_remote_playback_backend_enabled_(RuntimeEnabledFeaturesBase::is_remote_playback_backend_enabled_),
    is_remove_dangling_markup_in_target_enabled_(RuntimeEnabledFeaturesBase::is_remove_dangling_markup_in_target_enabled_),
    is_remove_data_url_in_svg_use_enabled_(RuntimeEnabledFeaturesBase::is_remove_data_url_in_svg_use_enabled_),
    is_remove_mobile_viewport_double_tap_enabled_(RuntimeEnabledFeaturesBase::is_remove_mobile_viewport_double_tap_enabled_),
    is_remove_zoom_adjustment_of_bounding_box_enabled_(RuntimeEnabledFeaturesBase::is_remove_zoom_adjustment_of_bounding_box_enabled_),
    is_render_blocking_status_enabled_(RuntimeEnabledFeaturesBase::is_render_blocking_status_enabled_),
    is_render_priority_attribute_enabled_(RuntimeEnabledFeaturesBase::is_render_priority_attribute_enabled_),
    is_resource_timing_content_type_enabled_(RuntimeEnabledFeaturesBase::is_resource_timing_content_type_enabled_),
    is_resource_timing_use_cors_for_body_sizes_enabled_(RuntimeEnabledFeaturesBase::is_resource_timing_use_cors_for_body_sizes_enabled_),
    is_restrict_gamepad_access_enabled_(RuntimeEnabledFeaturesBase::is_restrict_gamepad_access_enabled_),
    is_rewind_floats_enabled_(RuntimeEnabledFeaturesBase::is_rewind_floats_enabled_),
    is_rtc_audio_jitter_buffer_max_packets_enabled_(RuntimeEnabledFeaturesBase::is_rtc_audio_jitter_buffer_max_packets_enabled_),
    is_rtc_encoded_audio_frame_abs_capture_time_enabled_(RuntimeEnabledFeaturesBase::is_rtc_encoded_audio_frame_abs_capture_time_enabled_),
    is_rtc_encoded_frame_set_metadata_enabled_(RuntimeEnabledFeaturesBase::is_rtc_encoded_frame_set_metadata_enabled_),
    is_rtc_encoded_video_frame_additional_metadata_enabled_(RuntimeEnabledFeaturesBase::is_rtc_encoded_video_frame_additional_metadata_enabled_),
    is_rtc_legacy_callback_based_get_stats_enabled_(RuntimeEnabledFeaturesBase::is_rtc_legacy_callback_based_get_stats_enabled_),
    is_rtc_rtp_encoding_parameters_codec_enabled_(RuntimeEnabledFeaturesBase::is_rtc_rtp_encoding_parameters_codec_enabled_),
    is_rtc_rtp_header_extension_control_enabled_(RuntimeEnabledFeaturesBase::is_rtc_rtp_header_extension_control_enabled_),
    is_rtc_stats_relative_packet_arrival_delay_enabled_(RuntimeEnabledFeaturesBase::is_rtc_stats_relative_packet_arrival_delay_enabled_),
    is_rtc_svc_scalability_mode_enabled_(RuntimeEnabledFeaturesBase::is_rtc_svc_scalability_mode_enabled_),
    is_ruby_inlinify_enabled_(RuntimeEnabledFeaturesBase::is_ruby_inlinify_enabled_),
    is_ruby_simple_pairing_enabled_(RuntimeEnabledFeaturesBase::is_ruby_simple_pairing_enabled_),
    is_run_microtask_before_xml_custom_element_enabled_(RuntimeEnabledFeaturesBase::is_run_microtask_before_xml_custom_element_enabled_),
    is_sanitizer_api_enabled_(RuntimeEnabledFeaturesBase::is_sanitizer_api_enabled_),
    is_scheduler_yield_enabled_(RuntimeEnabledFeaturesBase::is_scheduler_yield_enabled_),
    is_scoped_custom_element_registry_enabled_(RuntimeEnabledFeaturesBase::is_scoped_custom_element_registry_enabled_),
    is_scripted_speech_recognition_enabled_(RuntimeEnabledFeaturesBase::is_scripted_speech_recognition_enabled_),
    is_scripted_speech_synthesis_enabled_(RuntimeEnabledFeaturesBase::is_scripted_speech_synthesis_enabled_),
    is_scrollbar_color_enabled_(RuntimeEnabledFeaturesBase::is_scrollbar_color_enabled_),
    is_scrollbar_width_enabled_(RuntimeEnabledFeaturesBase::is_scrollbar_width_enabled_),
    is_scroll_end_events_enabled_(RuntimeEnabledFeaturesBase::is_scroll_end_events_enabled_),
    is_scroll_timeline_enabled_(RuntimeEnabledFeaturesBase::is_scroll_timeline_enabled_),
    is_scroll_timeline_current_time_enabled_(RuntimeEnabledFeaturesBase::is_scroll_timeline_current_time_enabled_),
    is_scroll_timeline_on_compositor_enabled_(RuntimeEnabledFeaturesBase::is_scroll_timeline_on_compositor_enabled_),
    is_scroll_top_left_interop_enabled_(RuntimeEnabledFeaturesBase::is_scroll_top_left_interop_enabled_),
    is_secure_payment_confirmation_enabled_(RuntimeEnabledFeaturesBase::is_secure_payment_confirmation_enabled_),
    is_secure_payment_confirmation_allow_one_activationless_show_enabled_(RuntimeEnabledFeaturesBase::is_secure_payment_confirmation_allow_one_activationless_show_enabled_),
    is_secure_payment_confirmation_debug_enabled_(RuntimeEnabledFeaturesBase::is_secure_payment_confirmation_debug_enabled_),
    is_secure_payment_confirmation_extensions_enabled_(RuntimeEnabledFeaturesBase::is_secure_payment_confirmation_extensions_enabled_),
    is_secure_payment_confirmation_opt_out_enabled_(RuntimeEnabledFeaturesBase::is_secure_payment_confirmation_opt_out_enabled_),
    is_select_hr_enabled_(RuntimeEnabledFeaturesBase::is_select_hr_enabled_),
    is_send_beacon_throw_for_blob_with_non_simple_type_enabled_(RuntimeEnabledFeaturesBase::is_send_beacon_throw_for_blob_with_non_simple_type_enabled_),
    is_sensor_extra_classes_enabled_(RuntimeEnabledFeaturesBase::is_sensor_extra_classes_enabled_),
    is_serial_enabled_(RuntimeEnabledFeaturesBase::is_serial_enabled_),
    is_serialize_view_transition_state_in_spa_enabled_(RuntimeEnabledFeaturesBase::is_serialize_view_transition_state_in_spa_enabled_),
    is_service_worker_bypass_fetch_handler_enabled_(RuntimeEnabledFeaturesBase::is_service_worker_bypass_fetch_handler_enabled_),
    is_service_worker_client_lifecycle_state_enabled_(RuntimeEnabledFeaturesBase::is_service_worker_client_lifecycle_state_enabled_),
    is_service_worker_race_network_request_enabled_(RuntimeEnabledFeaturesBase::is_service_worker_race_network_request_enabled_),
    is_service_worker_static_router_enabled_(RuntimeEnabledFeaturesBase::is_service_worker_static_router_enabled_),
    is_set_sequential_focus_starting_point_enabled_(RuntimeEnabledFeaturesBase::is_set_sequential_focus_starting_point_enabled_),
    is_shadow_root_attachment_new_behavior_enabled_(RuntimeEnabledFeaturesBase::is_shadow_root_attachment_new_behavior_enabled_),
    is_shared_array_buffer_enabled_(RuntimeEnabledFeaturesBase::is_shared_array_buffer_enabled_),
    is_shared_array_buffer_on_desktop_enabled_(RuntimeEnabledFeaturesBase::is_shared_array_buffer_on_desktop_enabled_),
    is_shared_array_buffer_unrestricted_access_allowed_enabled_(RuntimeEnabledFeaturesBase::is_shared_array_buffer_unrestricted_access_allowed_enabled_),
    is_shared_autofill_enabled_(RuntimeEnabledFeaturesBase::is_shared_autofill_enabled_),
    is_shared_storage_api_enabled_(RuntimeEnabledFeaturesBase::is_shared_storage_api_enabled_),
    is_shared_storage_api_m_118_enabled_(RuntimeEnabledFeaturesBase::is_shared_storage_api_m_118_enabled_),
    is_shared_worker_enabled_(RuntimeEnabledFeaturesBase::is_shared_worker_enabled_),
    is_signature_based_integrity_enabled_(RuntimeEnabledFeaturesBase::is_signature_based_integrity_enabled_),
    is_site_initiated_mirroring_enabled_(RuntimeEnabledFeaturesBase::is_site_initiated_mirroring_enabled_),
    is_skip_ad_enabled_(RuntimeEnabledFeaturesBase::is_skip_ad_enabled_),
    is_skip_touch_event_filter_enabled_(RuntimeEnabledFeaturesBase::is_skip_touch_event_filter_enabled_),
    is_smart_card_enabled_(RuntimeEnabledFeaturesBase::is_smart_card_enabled_),
    is_smart_zoom_enabled_(RuntimeEnabledFeaturesBase::is_smart_zoom_enabled_),
    is_smil_auto_suspend_on_lag_enabled_(RuntimeEnabledFeaturesBase::is_smil_auto_suspend_on_lag_enabled_),
    is_snap_border_widths_before_layout_enabled_(RuntimeEnabledFeaturesBase::is_snap_border_widths_before_layout_enabled_),
    is_soft_navigation_detection_enabled_(RuntimeEnabledFeaturesBase::is_soft_navigation_detection_enabled_),
    is_soft_navigation_heuristics_enabled_(RuntimeEnabledFeaturesBase::is_soft_navigation_heuristics_enabled_),
    is_soft_navigation_heuristics_expose_fp_and_fcp_enabled_(RuntimeEnabledFeaturesBase::is_soft_navigation_heuristics_expose_fp_and_fcp_enabled_),
    is_sparse_object_paint_properties_enabled_(RuntimeEnabledFeaturesBase::is_sparse_object_paint_properties_enabled_),
    is_speculation_rules_document_rules_enabled_(RuntimeEnabledFeaturesBase::is_speculation_rules_document_rules_enabled_),
    is_speculation_rules_document_rules_selector_matches_enabled_(RuntimeEnabledFeaturesBase::is_speculation_rules_document_rules_selector_matches_enabled_),
    is_speculation_rules_eagerness_enabled_(RuntimeEnabledFeaturesBase::is_speculation_rules_eagerness_enabled_),
    is_speculation_rules_fetch_from_header_enabled_(RuntimeEnabledFeaturesBase::is_speculation_rules_fetch_from_header_enabled_),
    is_speculation_rules_implicit_source_enabled_(RuntimeEnabledFeaturesBase::is_speculation_rules_implicit_source_enabled_),
    is_speculation_rules_no_vary_search_hint_enabled_(RuntimeEnabledFeaturesBase::is_speculation_rules_no_vary_search_hint_enabled_),
    is_speculation_rules_no_vary_search_hint_shipped_by_default_enabled_(RuntimeEnabledFeaturesBase::is_speculation_rules_no_vary_search_hint_shipped_by_default_enabled_),
    is_speculation_rules_pointer_down_heuristics_enabled_(RuntimeEnabledFeaturesBase::is_speculation_rules_pointer_down_heuristics_enabled_),
    is_speculation_rules_pointer_hover_heuristics_enabled_(RuntimeEnabledFeaturesBase::is_speculation_rules_pointer_hover_heuristics_enabled_),
    is_speculation_rules_prefetch_future_enabled_(RuntimeEnabledFeaturesBase::is_speculation_rules_prefetch_future_enabled_),
    is_speculation_rules_prefetch_with_subresources_enabled_(RuntimeEnabledFeaturesBase::is_speculation_rules_prefetch_with_subresources_enabled_),
    is_speculation_rules_relative_to_document_enabled_(RuntimeEnabledFeaturesBase::is_speculation_rules_relative_to_document_enabled_),
    is_spell_checker_replace_range_use_insert_text_enabled_(RuntimeEnabledFeaturesBase::is_spell_checker_replace_range_use_insert_text_enabled_),
    is_srcset_max_density_enabled_(RuntimeEnabledFeaturesBase::is_srcset_max_density_enabled_),
    is_stable_blink_features_enabled_(RuntimeEnabledFeaturesBase::is_stable_blink_features_enabled_),
    is_storage_access_api_beyond_cookies_enabled_(RuntimeEnabledFeaturesBase::is_storage_access_api_beyond_cookies_enabled_),
    is_storage_buckets_enabled_(RuntimeEnabledFeaturesBase::is_storage_buckets_enabled_),
    is_storage_buckets_durability_enabled_(RuntimeEnabledFeaturesBase::is_storage_buckets_durability_enabled_),
    is_storage_buckets_locks_enabled_(RuntimeEnabledFeaturesBase::is_storage_buckets_locks_enabled_),
    is_strict_mime_types_for_workers_enabled_(RuntimeEnabledFeaturesBase::is_strict_mime_types_for_workers_enabled_),
    is_stylable_select_enabled_(RuntimeEnabledFeaturesBase::is_stylable_select_enabled_),
    is_stylus_handwriting_enabled_(RuntimeEnabledFeaturesBase::is_stylus_handwriting_enabled_),
    is_suggestion_picker_dark_mode_support_enabled_(RuntimeEnabledFeaturesBase::is_suggestion_picker_dark_mode_support_enabled_),
    is_svg_cross_origin_attribute_enabled_(RuntimeEnabledFeaturesBase::is_svg_cross_origin_attribute_enabled_),
    is_svg_no_pixel_snapping_scale_adjustment_enabled_(RuntimeEnabledFeaturesBase::is_svg_no_pixel_snapping_scale_adjustment_enabled_),
    is_svg_text_fix_hittest_after_scale_enabled_(RuntimeEnabledFeaturesBase::is_svg_text_fix_hittest_after_scale_enabled_),
    is_synthesized_keyboard_events_for_accessibility_actions_enabled_(RuntimeEnabledFeaturesBase::is_synthesized_keyboard_events_for_accessibility_actions_enabled_),
    is_system_wake_lock_enabled_(RuntimeEnabledFeaturesBase::is_system_wake_lock_enabled_),
    is_test_feature_enabled_(RuntimeEnabledFeaturesBase::is_test_feature_enabled_),
    is_test_feature_dependent_enabled_(RuntimeEnabledFeaturesBase::is_test_feature_dependent_enabled_),
    is_test_feature_implied_enabled_(RuntimeEnabledFeaturesBase::is_test_feature_implied_enabled_),
    is_text_decorating_box_enabled_(RuntimeEnabledFeaturesBase::is_text_decorating_box_enabled_),
    is_text_detector_enabled_(RuntimeEnabledFeaturesBase::is_text_detector_enabled_),
    is_text_fragment_api_enabled_(RuntimeEnabledFeaturesBase::is_text_fragment_api_enabled_),
    is_text_fragment_identifiers_enabled_(RuntimeEnabledFeaturesBase::is_text_fragment_identifiers_enabled_),
    is_text_fragment_tap_opens_context_menu_enabled_(RuntimeEnabledFeaturesBase::is_text_fragment_tap_opens_context_menu_enabled_),
    is_text_metrics_baselines_enabled_(RuntimeEnabledFeaturesBase::is_text_metrics_baselines_enabled_),
    is_timeline_scope_enabled_(RuntimeEnabledFeaturesBase::is_timeline_scope_enabled_),
    is_timer_throttling_for_background_tabs_enabled_(RuntimeEnabledFeaturesBase::is_timer_throttling_for_background_tabs_enabled_),
    is_time_zone_change_event_enabled_(RuntimeEnabledFeaturesBase::is_time_zone_change_event_enabled_),
    is_topics_api_enabled_(RuntimeEnabledFeaturesBase::is_topics_api_enabled_),
    is_topics_document_api_enabled_(RuntimeEnabledFeaturesBase::is_topics_document_api_enabled_),
    is_top_level_tpcd_enabled_(RuntimeEnabledFeaturesBase::is_top_level_tpcd_enabled_),
    is_touch_drag_and_context_menu_enabled_(RuntimeEnabledFeaturesBase::is_touch_drag_and_context_menu_enabled_),
    is_touch_drag_on_short_press_enabled_(RuntimeEnabledFeaturesBase::is_touch_drag_on_short_press_enabled_),
    is_touch_event_feature_detection_enabled_(RuntimeEnabledFeaturesBase::is_touch_event_feature_detection_enabled_),
    is_touch_text_editing_redesign_enabled_(RuntimeEnabledFeaturesBase::is_touch_text_editing_redesign_enabled_),
    is_tpcd_enabled_(RuntimeEnabledFeaturesBase::is_tpcd_enabled_),
    is_translate_service_enabled_(RuntimeEnabledFeaturesBase::is_translate_service_enabled_),
    is_trusted_type_before_policy_creation_event_enabled_(RuntimeEnabledFeaturesBase::is_trusted_type_before_policy_creation_event_enabled_),
    is_trusted_types_from_literal_enabled_(RuntimeEnabledFeaturesBase::is_trusted_types_from_literal_enabled_),
    is_trusted_types_use_code_like_enabled_(RuntimeEnabledFeaturesBase::is_trusted_types_use_code_like_enabled_),
    is_unclosed_form_control_is_invalid_enabled_(RuntimeEnabledFeaturesBase::is_unclosed_form_control_is_invalid_enabled_),
    is_unexposed_task_ids_enabled_(RuntimeEnabledFeaturesBase::is_unexposed_task_ids_enabled_),
    is_unowned_animations_skip_css_events_enabled_(RuntimeEnabledFeaturesBase::is_unowned_animations_skip_css_events_enabled_),
    is_unrestricted_measure_user_agent_specific_memory_enabled_(RuntimeEnabledFeaturesBase::is_unrestricted_measure_user_agent_specific_memory_enabled_),
    is_unrestricted_shared_array_buffer_enabled_(RuntimeEnabledFeaturesBase::is_unrestricted_shared_array_buffer_enabled_),
    is_unrestricted_usb_enabled_(RuntimeEnabledFeaturesBase::is_unrestricted_usb_enabled_),
    is_url_attribute_fix_enabled_(RuntimeEnabledFeaturesBase::is_url_attribute_fix_enabled_),
    is_url_pattern_compare_component_enabled_(RuntimeEnabledFeaturesBase::is_url_pattern_compare_component_enabled_),
    is_url_pattern_has_reg_exp_groups_enabled_(RuntimeEnabledFeaturesBase::is_url_pattern_has_reg_exp_groups_enabled_),
    is_url_pattern_regexp_unicode_sets_mode_enabled_(RuntimeEnabledFeaturesBase::is_url_pattern_regexp_unicode_sets_mode_enabled_),
    is_url_pattern_wildcard_more_often_enabled_(RuntimeEnabledFeaturesBase::is_url_pattern_wildcard_more_often_enabled_),
    is_url_search_params_has_and_delete_multiple_args_enabled_(RuntimeEnabledFeaturesBase::is_url_search_params_has_and_delete_multiple_args_enabled_),
    is_use_begin_frame_presentation_feedback_enabled_(RuntimeEnabledFeaturesBase::is_use_begin_frame_presentation_feedback_enabled_),
    is_used_color_scheme_root_scrollbars_enabled_(RuntimeEnabledFeaturesBase::is_used_color_scheme_root_scrollbars_enabled_),
    is_user_activation_same_origin_visibility_enabled_(RuntimeEnabledFeaturesBase::is_user_activation_same_origin_visibility_enabled_),
    is_user_valid_user_invalid_enabled_(RuntimeEnabledFeaturesBase::is_user_valid_user_invalid_enabled_),
    is_v8_idle_tasks_enabled_(RuntimeEnabledFeaturesBase::is_v8_idle_tasks_enabled_),
    is_video_auto_fullscreen_enabled_(RuntimeEnabledFeaturesBase::is_video_auto_fullscreen_enabled_),
    is_video_fullscreen_orientation_lock_enabled_(RuntimeEnabledFeaturesBase::is_video_fullscreen_orientation_lock_enabled_),
    is_video_playback_quality_enabled_(RuntimeEnabledFeaturesBase::is_video_playback_quality_enabled_),
    is_video_rotate_to_fullscreen_enabled_(RuntimeEnabledFeaturesBase::is_video_rotate_to_fullscreen_enabled_),
    is_video_track_generator_enabled_(RuntimeEnabledFeaturesBase::is_video_track_generator_enabled_),
    is_video_track_generator_in_window_enabled_(RuntimeEnabledFeaturesBase::is_video_track_generator_in_window_enabled_),
    is_video_track_generator_in_worker_enabled_(RuntimeEnabledFeaturesBase::is_video_track_generator_in_worker_enabled_),
    is_viewport_height_client_hint_header_enabled_(RuntimeEnabledFeaturesBase::is_viewport_height_client_hint_header_enabled_),
    is_viewport_segments_enabled_(RuntimeEnabledFeaturesBase::is_viewport_segments_enabled_),
    is_view_transition_on_navigation_enabled_(RuntimeEnabledFeaturesBase::is_view_transition_on_navigation_enabled_),
    is_view_transition_types_enabled_(RuntimeEnabledFeaturesBase::is_view_transition_types_enabled_),
    is_visibility_collapse_column_enabled_(RuntimeEnabledFeaturesBase::is_visibility_collapse_column_enabled_),
    is_wake_lock_enabled_(RuntimeEnabledFeaturesBase::is_wake_lock_enabled_),
    is_warn_on_content_visibility_render_access_enabled_(RuntimeEnabledFeaturesBase::is_warn_on_content_visibility_render_access_enabled_),
    is_web_animations_svg_enabled_(RuntimeEnabledFeaturesBase::is_web_animations_svg_enabled_),
    is_web_app_dark_mode_enabled_(RuntimeEnabledFeaturesBase::is_web_app_dark_mode_enabled_),
    is_web_app_launch_handler_enabled_(RuntimeEnabledFeaturesBase::is_web_app_launch_handler_enabled_),
    is_web_app_launch_queue_enabled_(RuntimeEnabledFeaturesBase::is_web_app_launch_queue_enabled_),
    is_web_app_scope_extensions_enabled_(RuntimeEnabledFeaturesBase::is_web_app_scope_extensions_enabled_),
    is_web_apps_lock_screen_enabled_(RuntimeEnabledFeaturesBase::is_web_apps_lock_screen_enabled_),
    is_web_app_tab_strip_enabled_(RuntimeEnabledFeaturesBase::is_web_app_tab_strip_enabled_),
    is_web_app_tab_strip_customizations_enabled_(RuntimeEnabledFeaturesBase::is_web_app_tab_strip_customizations_enabled_),
    is_web_app_translations_enabled_(RuntimeEnabledFeaturesBase::is_web_app_translations_enabled_),
    is_web_app_url_handling_enabled_(RuntimeEnabledFeaturesBase::is_web_app_url_handling_enabled_),
    is_web_app_window_controls_overlay_enabled_(RuntimeEnabledFeaturesBase::is_web_app_window_controls_overlay_enabled_),
    is_web_assembly_js_string_builtins_enabled_(RuntimeEnabledFeaturesBase::is_web_assembly_js_string_builtins_enabled_),
    is_web_auth_enabled_(RuntimeEnabledFeaturesBase::is_web_auth_enabled_),
    is_web_auth_allow_create_in_cross_origin_frame_enabled_(RuntimeEnabledFeaturesBase::is_web_auth_allow_create_in_cross_origin_frame_enabled_),
    is_web_auth_authenticator_attachment_enabled_(RuntimeEnabledFeaturesBase::is_web_auth_authenticator_attachment_enabled_),
    is_web_authentication_hints_enabled_(RuntimeEnabledFeaturesBase::is_web_authentication_hints_enabled_),
    is_web_authentication_js_on_serialization_enabled_(RuntimeEnabledFeaturesBase::is_web_authentication_js_on_serialization_enabled_),
    is_web_authentication_large_blob_extension_enabled_(RuntimeEnabledFeaturesBase::is_web_authentication_large_blob_extension_enabled_),
    is_web_authentication_prf_enabled_(RuntimeEnabledFeaturesBase::is_web_authentication_prf_enabled_),
    is_web_authentication_remote_desktop_support_enabled_(RuntimeEnabledFeaturesBase::is_web_authentication_remote_desktop_support_enabled_),
    is_web_authentication_supplemental_pub_keys_enabled_(RuntimeEnabledFeaturesBase::is_web_authentication_supplemental_pub_keys_enabled_),
    is_web_bluetooth_enabled_(RuntimeEnabledFeaturesBase::is_web_bluetooth_enabled_),
    is_web_bluetooth_get_devices_enabled_(RuntimeEnabledFeaturesBase::is_web_bluetooth_get_devices_enabled_),
    is_web_bluetooth_scanning_enabled_(RuntimeEnabledFeaturesBase::is_web_bluetooth_scanning_enabled_),
    is_web_bluetooth_watch_advertisements_enabled_(RuntimeEnabledFeaturesBase::is_web_bluetooth_watch_advertisements_enabled_),
    is_webcodecs_content_hint_enabled_(RuntimeEnabledFeaturesBase::is_webcodecs_content_hint_enabled_),
    is_webcodecs_copy_to_rgb_enabled_(RuntimeEnabledFeaturesBase::is_webcodecs_copy_to_rgb_enabled_),
    is_web_crypto_curve_25519_enabled_(RuntimeEnabledFeaturesBase::is_web_crypto_curve_25519_enabled_),
    is_web_font_resize_lcp_enabled_(RuntimeEnabledFeaturesBase::is_web_font_resize_lcp_enabled_),
    is_webgl_developer_extensions_enabled_(RuntimeEnabledFeaturesBase::is_webgl_developer_extensions_enabled_),
    is_webgl_draft_extensions_enabled_(RuntimeEnabledFeaturesBase::is_webgl_draft_extensions_enabled_),
    is_webgl_drawing_buffer_storage_enabled_(RuntimeEnabledFeaturesBase::is_webgl_drawing_buffer_storage_enabled_),
    is_webgl_image_chromium_enabled_(RuntimeEnabledFeaturesBase::is_webgl_image_chromium_enabled_),
    is_webgpu_developer_features_enabled_(RuntimeEnabledFeaturesBase::is_webgpu_developer_features_enabled_),
    is_web_hid_enabled_(RuntimeEnabledFeaturesBase::is_web_hid_enabled_),
    is_web_hid_on_service_workers_enabled_(RuntimeEnabledFeaturesBase::is_web_hid_on_service_workers_enabled_),
    is_web_identity_digital_credentials_enabled_(RuntimeEnabledFeaturesBase::is_web_identity_digital_credentials_enabled_),
    is_web_idl_big_int_uses_to_big_int_enabled_(RuntimeEnabledFeaturesBase::is_web_idl_big_int_uses_to_big_int_enabled_),
    is_web_kit_scrollbar_styling_enabled_(RuntimeEnabledFeaturesBase::is_web_kit_scrollbar_styling_enabled_),
    is_web_nfc_enabled_(RuntimeEnabledFeaturesBase::is_web_nfc_enabled_),
    is_web_otp_enabled_(RuntimeEnabledFeaturesBase::is_web_otp_enabled_),
    is_web_otp_assertion_feature_policy_enabled_(RuntimeEnabledFeaturesBase::is_web_otp_assertion_feature_policy_enabled_),
    is_web_preferences_enabled_(RuntimeEnabledFeaturesBase::is_web_preferences_enabled_),
    is_web_printing_enabled_(RuntimeEnabledFeaturesBase::is_web_printing_enabled_),
    is_web_serial_bluetooth_enabled_(RuntimeEnabledFeaturesBase::is_web_serial_bluetooth_enabled_),
    is_web_share_enabled_(RuntimeEnabledFeaturesBase::is_web_share_enabled_),
    is_websocket_stream_enabled_(RuntimeEnabledFeaturesBase::is_websocket_stream_enabled_),
    is_web_transport_custom_certificates_enabled_(RuntimeEnabledFeaturesBase::is_web_transport_custom_certificates_enabled_),
    is_web_usb_enabled_(RuntimeEnabledFeaturesBase::is_web_usb_enabled_),
    is_web_usb_on_dedicated_workers_enabled_(RuntimeEnabledFeaturesBase::is_web_usb_on_dedicated_workers_enabled_),
    is_web_usb_on_service_workers_enabled_(RuntimeEnabledFeaturesBase::is_web_usb_on_service_workers_enabled_),
    is_web_view_xr_equested_with_deprecation_enabled_(RuntimeEnabledFeaturesBase::is_web_view_xr_equested_with_deprecation_enabled_),
    is_web_vtt_regions_enabled_(RuntimeEnabledFeaturesBase::is_web_vtt_regions_enabled_),
    is_web_xr_enabled_(RuntimeEnabledFeaturesBase::is_web_xr_enabled_),
    is_web_xr_enabled_features_enabled_(RuntimeEnabledFeaturesBase::is_web_xr_enabled_features_enabled_),
    is_web_xr_frame_rate_enabled_(RuntimeEnabledFeaturesBase::is_web_xr_frame_rate_enabled_),
    is_web_xr_front_facing_enabled_(RuntimeEnabledFeaturesBase::is_web_xr_front_facing_enabled_),
    is_web_xr_hand_input_enabled_(RuntimeEnabledFeaturesBase::is_web_xr_hand_input_enabled_),
    is_web_xr_hit_test_entity_types_enabled_(RuntimeEnabledFeaturesBase::is_web_xr_hit_test_entity_types_enabled_),
    is_web_xr_image_tracking_enabled_(RuntimeEnabledFeaturesBase::is_web_xr_image_tracking_enabled_),
    is_web_xr_layers_enabled_(RuntimeEnabledFeaturesBase::is_web_xr_layers_enabled_),
    is_web_xr_plane_detection_enabled_(RuntimeEnabledFeaturesBase::is_web_xr_plane_detection_enabled_),
    is_web_xr_pose_motion_data_enabled_(RuntimeEnabledFeaturesBase::is_web_xr_pose_motion_data_enabled_),
    is_wgi_gamepad_trigger_rumble_enabled_(RuntimeEnabledFeaturesBase::is_wgi_gamepad_trigger_rumble_enabled_),
    is_window_default_status_enabled_(RuntimeEnabledFeaturesBase::is_window_default_status_enabled_),
    is_window_placement_fullscreen_on_screens_change_enabled_(RuntimeEnabledFeaturesBase::is_window_placement_fullscreen_on_screens_change_enabled_),
    is_window_placement_permission_alias_enabled_(RuntimeEnabledFeaturesBase::is_window_placement_permission_alias_enabled_),
    is_xml_parser_merge_adjacent_c_data_sections_enabled_(RuntimeEnabledFeaturesBase::is_xml_parser_merge_adjacent_c_data_sections_enabled_),
    is_xywh_and_rect_computed_value_enabled_(RuntimeEnabledFeaturesBase::is_xywh_and_rect_computed_value_enabled_),
    is_zero_copy_tab_capture_enabled_(RuntimeEnabledFeaturesBase::is_zero_copy_tab_capture_enabled_) {}

void RuntimeEnabledFeaturesBase::Backup::Restore() {
  RuntimeEnabledFeaturesBase::is_accelerated_2d_canvas_enabled_ = is_accelerated_2d_canvas_enabled_;
  RuntimeEnabledFeaturesBase::is_accelerated_small_canvases_enabled_ = is_accelerated_small_canvases_enabled_;
  RuntimeEnabledFeaturesBase::is_accessibility_aria_virtual_content_enabled_ = is_accessibility_aria_virtual_content_enabled_;
  RuntimeEnabledFeaturesBase::is_accessibility_expose_display_none_enabled_ = is_accessibility_expose_display_none_enabled_;
  RuntimeEnabledFeaturesBase::is_accessibility_expose_html_element_enabled_ = is_accessibility_expose_html_element_enabled_;
  RuntimeEnabledFeaturesBase::is_accessibility_expose_ignored_nodes_enabled_ = is_accessibility_expose_ignored_nodes_enabled_;
  RuntimeEnabledFeaturesBase::is_accessibility_object_model_enabled_ = is_accessibility_object_model_enabled_;
  RuntimeEnabledFeaturesBase::is_accessibility_os_level_bold_text_enabled_ = is_accessibility_os_level_bold_text_enabled_;
  RuntimeEnabledFeaturesBase::is_accessibility_page_zoom_enabled_ = is_accessibility_page_zoom_enabled_;
  RuntimeEnabledFeaturesBase::is_accessibility_serialization_size_metrics_enabled_ = is_accessibility_serialization_size_metrics_enabled_;
  RuntimeEnabledFeaturesBase::is_accessibility_use_ax_position_for_document_markers_enabled_ = is_accessibility_use_ax_position_for_document_markers_enabled_;
  RuntimeEnabledFeaturesBase::is_accordion_pattern_enabled_ = is_accordion_pattern_enabled_;
  RuntimeEnabledFeaturesBase::is_add_identity_in_can_make_payment_event_enabled_ = is_add_identity_in_can_make_payment_event_enabled_;
  RuntimeEnabledFeaturesBase::is_address_space_enabled_ = is_address_space_enabled_;
  RuntimeEnabledFeaturesBase::is_ad_interest_group_api_enabled_ = is_ad_interest_group_api_enabled_;
  RuntimeEnabledFeaturesBase::is_ad_tagging_enabled_ = is_ad_tagging_enabled_;
  RuntimeEnabledFeaturesBase::is_align_content_for_blocks_enabled_ = is_align_content_for_blocks_enabled_;
  RuntimeEnabledFeaturesBase::is_allow_content_initiated_data_url_navigations_enabled_ = is_allow_content_initiated_data_url_navigations_enabled_;
  RuntimeEnabledFeaturesBase::is_allow_ur_ns_in_iframes_enabled_ = is_allow_ur_ns_in_iframes_enabled_;
  RuntimeEnabledFeaturesBase::is_android_downloadable_fonts_matching_enabled_ = is_android_downloadable_fonts_matching_enabled_;
  RuntimeEnabledFeaturesBase::is_animation_worklet_enabled_ = is_animation_worklet_enabled_;
  RuntimeEnabledFeaturesBase::is_anonymous_iframe_enabled_ = is_anonymous_iframe_enabled_;
  RuntimeEnabledFeaturesBase::is_aom_aria_relationship_properties_enabled_ = is_aom_aria_relationship_properties_enabled_;
  RuntimeEnabledFeaturesBase::is_app_title_enabled_ = is_app_title_enabled_;
  RuntimeEnabledFeaturesBase::is_arrow_keys_in_vertical_writing_modes_enabled_ = is_arrow_keys_in_vertical_writing_modes_enabled_;
  RuntimeEnabledFeaturesBase::is_async_clipboard_implicit_permission_enabled_ = is_async_clipboard_implicit_permission_enabled_;
  RuntimeEnabledFeaturesBase::is_attribution_reporting_enabled_ = is_attribution_reporting_enabled_;
  RuntimeEnabledFeaturesBase::is_attribution_reporting_cross_app_web_enabled_ = is_attribution_reporting_cross_app_web_enabled_;
  RuntimeEnabledFeaturesBase::is_attribution_reporting_interface_enabled_ = is_attribution_reporting_interface_enabled_;
  RuntimeEnabledFeaturesBase::is_audio_context_set_sink_id_enabled_ = is_audio_context_set_sink_id_enabled_;
  RuntimeEnabledFeaturesBase::is_audio_output_devices_enabled_ = is_audio_output_devices_enabled_;
  RuntimeEnabledFeaturesBase::is_audio_video_tracks_enabled_ = is_audio_video_tracks_enabled_;
  RuntimeEnabledFeaturesBase::is_auto_dark_mode_enabled_ = is_auto_dark_mode_enabled_;
  RuntimeEnabledFeaturesBase::is_auto_disable_accessibility_v_2_enabled_ = is_auto_disable_accessibility_v_2_enabled_;
  RuntimeEnabledFeaturesBase::is_automation_controlled_enabled_ = is_automation_controlled_enabled_;
  RuntimeEnabledFeaturesBase::is_autoplay_ignores_web_audio_enabled_ = is_autoplay_ignores_web_audio_enabled_;
  RuntimeEnabledFeaturesBase::is_auto_size_lazy_loaded_images_enabled_ = is_auto_size_lazy_loaded_images_enabled_;
  RuntimeEnabledFeaturesBase::is_avoid_caret_visible_selection_adjuster_enabled_ = is_avoid_caret_visible_selection_adjuster_enabled_;
  RuntimeEnabledFeaturesBase::is_backdrop_inherit_originating_enabled_ = is_backdrop_inherit_originating_enabled_;
  RuntimeEnabledFeaturesBase::is_backface_visibility_interop_enabled_ = is_backface_visibility_interop_enabled_;
  RuntimeEnabledFeaturesBase::is_back_forward_cache_enabled_ = is_back_forward_cache_enabled_;
  RuntimeEnabledFeaturesBase::is_back_forward_cache_experiment_http_header_enabled_ = is_back_forward_cache_experiment_http_header_enabled_;
  RuntimeEnabledFeaturesBase::is_back_forward_cache_not_restored_reasons_enabled_ = is_back_forward_cache_not_restored_reasons_enabled_;
  RuntimeEnabledFeaturesBase::is_background_fetch_enabled_ = is_background_fetch_enabled_;
  RuntimeEnabledFeaturesBase::is_barcode_detector_enabled_ = is_barcode_detector_enabled_;
  RuntimeEnabledFeaturesBase::is_bdi_element_dir_inheritance_enabled_ = is_bdi_element_dir_inheritance_enabled_;
  RuntimeEnabledFeaturesBase::is_beforeunload_event_cancel_by_prevent_default_enabled_ = is_beforeunload_event_cancel_by_prevent_default_enabled_;
  RuntimeEnabledFeaturesBase::is_bidi_caret_affinity_enabled_ = is_bidi_caret_affinity_enabled_;
  RuntimeEnabledFeaturesBase::is_blink_extension_chrome_os_enabled_ = is_blink_extension_chrome_os_enabled_;
  RuntimeEnabledFeaturesBase::is_blink_extension_chrome_os_kiosk_enabled_ = is_blink_extension_chrome_os_kiosk_enabled_;
  RuntimeEnabledFeaturesBase::is_blink_extension_diagnostics_enabled_ = is_blink_extension_diagnostics_enabled_;
  RuntimeEnabledFeaturesBase::is_blink_lifecycle_script_forbidden_enabled_ = is_blink_lifecycle_script_forbidden_enabled_;
  RuntimeEnabledFeaturesBase::is_blink_runtime_call_stats_enabled_ = is_blink_runtime_call_stats_enabled_;
  RuntimeEnabledFeaturesBase::is_blocking_focus_without_user_activation_enabled_ = is_blocking_focus_without_user_activation_enabled_;
  RuntimeEnabledFeaturesBase::is_block_ruby_console_message_enabled_ = is_block_ruby_console_message_enabled_;
  RuntimeEnabledFeaturesBase::is_block_ruby_wrapping_inline_ruby_enabled_ = is_block_ruby_wrapping_inline_ruby_enabled_;
  RuntimeEnabledFeaturesBase::is_boundary_event_dispatch_tracks_node_removal_enabled_ = is_boundary_event_dispatch_tracks_node_removal_enabled_;
  RuntimeEnabledFeaturesBase::is_browser_verified_user_activation_keyboard_enabled_ = is_browser_verified_user_activation_keyboard_enabled_;
  RuntimeEnabledFeaturesBase::is_browser_verified_user_activation_mouse_enabled_ = is_browser_verified_user_activation_mouse_enabled_;
  RuntimeEnabledFeaturesBase::is_byob_fetch_enabled_ = is_byob_fetch_enabled_;
  RuntimeEnabledFeaturesBase::is_cache_storage_code_cache_hint_enabled_ = is_cache_storage_code_cache_hint_enabled_;
  RuntimeEnabledFeaturesBase::is_canonicalize_whitespace_strings_enabled_ = is_canonicalize_whitespace_strings_enabled_;
  RuntimeEnabledFeaturesBase::is_canvas_2d_canvas_filter_enabled_ = is_canvas_2d_canvas_filter_enabled_;
  RuntimeEnabledFeaturesBase::is_canvas_2d_image_chromium_enabled_ = is_canvas_2d_image_chromium_enabled_;
  RuntimeEnabledFeaturesBase::is_canvas_2d_layers_enabled_ = is_canvas_2d_layers_enabled_;
  RuntimeEnabledFeaturesBase::is_canvas_2d_mesh_enabled_ = is_canvas_2d_mesh_enabled_;
  RuntimeEnabledFeaturesBase::is_canvas_2d_scroll_path_into_view_enabled_ = is_canvas_2d_scroll_path_into_view_enabled_;
  RuntimeEnabledFeaturesBase::is_canvas_floating_point_enabled_ = is_canvas_floating_point_enabled_;
  RuntimeEnabledFeaturesBase::is_canvas_hdr_enabled_ = is_canvas_hdr_enabled_;
  RuntimeEnabledFeaturesBase::is_canvas_image_smoothing_enabled_ = is_canvas_image_smoothing_enabled_;
  RuntimeEnabledFeaturesBase::is_capability_delegation_display_capture_request_enabled_ = is_capability_delegation_display_capture_request_enabled_;
  RuntimeEnabledFeaturesBase::is_capture_controller_enabled_ = is_capture_controller_enabled_;
  RuntimeEnabledFeaturesBase::is_captured_mouse_events_enabled_ = is_captured_mouse_events_enabled_;
  RuntimeEnabledFeaturesBase::is_captured_surface_control_enabled_ = is_captured_surface_control_enabled_;
  RuntimeEnabledFeaturesBase::is_capture_handle_enabled_ = is_capture_handle_enabled_;
  RuntimeEnabledFeaturesBase::is_cct_new_rfm_push_behavior_enabled_ = is_cct_new_rfm_push_behavior_enabled_;
  RuntimeEnabledFeaturesBase::is_check_visibility_extra_properties_enabled_ = is_check_visibility_extra_properties_enabled_;
  RuntimeEnabledFeaturesBase::is_click_to_captured_pointer_enabled_ = is_click_to_captured_pointer_enabled_;
  RuntimeEnabledFeaturesBase::is_clipboard_supported_types_enabled_ = is_clipboard_supported_types_enabled_;
  RuntimeEnabledFeaturesBase::is_clipboard_svg_enabled_ = is_clipboard_svg_enabled_;
  RuntimeEnabledFeaturesBase::is_clipboard_unsanitized_content_enabled_ = is_clipboard_unsanitized_content_enabled_;
  RuntimeEnabledFeaturesBase::is_clipboard_well_formed_html_sanitization_write_enabled_ = is_clipboard_well_formed_html_sanitization_write_enabled_;
  RuntimeEnabledFeaturesBase::is_clip_path_geometry_box_enabled_ = is_clip_path_geometry_box_enabled_;
  RuntimeEnabledFeaturesBase::is_clip_path_reject_empty_paths_enabled_ = is_clip_path_reject_empty_paths_enabled_;
  RuntimeEnabledFeaturesBase::is_clip_path_xywh_and_rect_enabled_ = is_clip_path_xywh_and_rect_enabled_;
  RuntimeEnabledFeaturesBase::is_close_watcher_enabled_ = is_close_watcher_enabled_;
  RuntimeEnabledFeaturesBase::is_coep_reflection_enabled_ = is_coep_reflection_enabled_;
  RuntimeEnabledFeaturesBase::is_composite_bg_color_animation_enabled_ = is_composite_bg_color_animation_enabled_;
  RuntimeEnabledFeaturesBase::is_composite_box_shadow_animation_enabled_ = is_composite_box_shadow_animation_enabled_;
  RuntimeEnabledFeaturesBase::is_composite_clip_path_animation_enabled_ = is_composite_clip_path_animation_enabled_;
  RuntimeEnabledFeaturesBase::is_composited_selection_update_enabled_ = is_composited_selection_update_enabled_;
  RuntimeEnabledFeaturesBase::is_composition_foreground_markers_enabled_ = is_composition_foreground_markers_enabled_;
  RuntimeEnabledFeaturesBase::is_compression_dictionary_transport_enabled_ = is_compression_dictionary_transport_enabled_;
  RuntimeEnabledFeaturesBase::is_compression_dictionary_transport_backend_enabled_ = is_compression_dictionary_transport_backend_enabled_;
  RuntimeEnabledFeaturesBase::is_computed_accessibility_info_enabled_ = is_computed_accessibility_info_enabled_;
  RuntimeEnabledFeaturesBase::is_compute_pressure_enabled_ = is_compute_pressure_enabled_;
  RuntimeEnabledFeaturesBase::is_confirmation_of_action_enabled_ = is_confirmation_of_action_enabled_;
  RuntimeEnabledFeaturesBase::is_consolidated_movement_xy_enabled_ = is_consolidated_movement_xy_enabled_;
  RuntimeEnabledFeaturesBase::is_contacts_manager_enabled_ = is_contacts_manager_enabled_;
  RuntimeEnabledFeaturesBase::is_contacts_manager_extra_properties_enabled_ = is_contacts_manager_extra_properties_enabled_;
  RuntimeEnabledFeaturesBase::is_content_index_enabled_ = is_content_index_enabled_;
  RuntimeEnabledFeaturesBase::is_context_menu_enabled_ = is_context_menu_enabled_;
  RuntimeEnabledFeaturesBase::is_cookie_deprecation_facilitated_testing_enabled_ = is_cookie_deprecation_facilitated_testing_enabled_;
  RuntimeEnabledFeaturesBase::is_cooperative_scheduling_enabled_ = is_cooperative_scheduling_enabled_;
  RuntimeEnabledFeaturesBase::is_coop_restrict_properties_enabled_ = is_coop_restrict_properties_enabled_;
  RuntimeEnabledFeaturesBase::is_cors_rfc_1918_enabled_ = is_cors_rfc_1918_enabled_;
  RuntimeEnabledFeaturesBase::is_counter_style_change_shoule_collect_inlines_enabled_ = is_counter_style_change_shoule_collect_inlines_enabled_;
  RuntimeEnabledFeaturesBase::is_cross_frame_performance_timeline_enabled_ = is_cross_frame_performance_timeline_enabled_;
  RuntimeEnabledFeaturesBase::is_css_anchor_positioning_enabled_ = is_css_anchor_positioning_enabled_;
  RuntimeEnabledFeaturesBase::is_css_anchor_positioning_cascade_fallback_enabled_ = is_css_anchor_positioning_cascade_fallback_enabled_;
  RuntimeEnabledFeaturesBase::is_css_animation_composition_enabled_ = is_css_animation_composition_enabled_;
  RuntimeEnabledFeaturesBase::is_css_animation_delay_start_end_enabled_ = is_css_animation_delay_start_end_enabled_;
  RuntimeEnabledFeaturesBase::is_css_at_rule_counter_style_image_symbols_enabled_ = is_css_at_rule_counter_style_image_symbols_enabled_;
  RuntimeEnabledFeaturesBase::is_css_at_rule_counter_style_speak_as_descriptor_enabled_ = is_css_at_rule_counter_style_speak_as_descriptor_enabled_;
  RuntimeEnabledFeaturesBase::is_css_background_clip_unprefix_enabled_ = is_css_background_clip_unprefix_enabled_;
  RuntimeEnabledFeaturesBase::is_css_calc_simplification_and_serialization_enabled_ = is_css_calc_simplification_and_serialization_enabled_;
  RuntimeEnabledFeaturesBase::is_css_cap_font_units_enabled_ = is_css_cap_font_units_enabled_;
  RuntimeEnabledFeaturesBase::is_css_case_sensitive_selector_enabled_ = is_css_case_sensitive_selector_enabled_;
  RuntimeEnabledFeaturesBase::is_css_color_contrast_enabled_ = is_css_color_contrast_enabled_;
  RuntimeEnabledFeaturesBase::is_css_color_typed_om_enabled_ = is_css_color_typed_om_enabled_;
  RuntimeEnabledFeaturesBase::is_css_content_visibility_implies_contain_intrinsic_size_auto_enabled_ = is_css_content_visibility_implies_contain_intrinsic_size_auto_enabled_;
  RuntimeEnabledFeaturesBase::is_css_cross_fade_enabled_ = is_css_cross_fade_enabled_;
  RuntimeEnabledFeaturesBase::is_css_display_animation_enabled_ = is_css_display_animation_enabled_;
  RuntimeEnabledFeaturesBase::is_css_display_ruby_enabled_ = is_css_display_ruby_enabled_;
  RuntimeEnabledFeaturesBase::is_css_dynamic_range_limit_enabled_ = is_css_dynamic_range_limit_enabled_;
  RuntimeEnabledFeaturesBase::is_css_enumerated_custom_properties_enabled_ = is_css_enumerated_custom_properties_enabled_;
  RuntimeEnabledFeaturesBase::is_css_exponential_functions_enabled_ = is_css_exponential_functions_enabled_;
  RuntimeEnabledFeaturesBase::is_css_field_sizing_enabled_ = is_css_field_sizing_enabled_;
  RuntimeEnabledFeaturesBase::is_css_first_letter_no_new_line_as_preceding_char_enabled_ = is_css_first_letter_no_new_line_as_preceding_char_enabled_;
  RuntimeEnabledFeaturesBase::is_css_font_size_adjust_enabled_ = is_css_font_size_adjust_enabled_;
  RuntimeEnabledFeaturesBase::is_css_hex_alpha_color_enabled_ = is_css_hex_alpha_color_enabled_;
  RuntimeEnabledFeaturesBase::is_css_layout_api_enabled_ = is_css_layout_api_enabled_;
  RuntimeEnabledFeaturesBase::is_css_linear_timing_function_enabled_ = is_css_linear_timing_function_enabled_;
  RuntimeEnabledFeaturesBase::is_css_logical_overflow_enabled_ = is_css_logical_overflow_enabled_;
  RuntimeEnabledFeaturesBase::is_css_marker_nested_pseudo_element_enabled_ = is_css_marker_nested_pseudo_element_enabled_;
  RuntimeEnabledFeaturesBase::is_css_masking_interop_enabled_ = is_css_masking_interop_enabled_;
  RuntimeEnabledFeaturesBase::is_css_mpc_improvements_enabled_ = is_css_mpc_improvements_enabled_;
  RuntimeEnabledFeaturesBase::is_css_nesting_ident_enabled_ = is_css_nesting_ident_enabled_;
  RuntimeEnabledFeaturesBase::is_css_numeric_factory_completeness_enabled_ = is_css_numeric_factory_completeness_enabled_;
  RuntimeEnabledFeaturesBase::is_css_offset_path_basic_shapes_circle_and_ellipse_enabled_ = is_css_offset_path_basic_shapes_circle_and_ellipse_enabled_;
  RuntimeEnabledFeaturesBase::is_css_offset_path_basic_shapes_rectangles_and_polygon_enabled_ = is_css_offset_path_basic_shapes_rectangles_and_polygon_enabled_;
  RuntimeEnabledFeaturesBase::is_css_offset_path_coord_box_enabled_ = is_css_offset_path_coord_box_enabled_;
  RuntimeEnabledFeaturesBase::is_css_offset_path_ray_enabled_ = is_css_offset_path_ray_enabled_;
  RuntimeEnabledFeaturesBase::is_css_offset_path_ray_contain_enabled_ = is_css_offset_path_ray_contain_enabled_;
  RuntimeEnabledFeaturesBase::is_css_offset_path_url_enabled_ = is_css_offset_path_url_enabled_;
  RuntimeEnabledFeaturesBase::is_css_offset_position_anchor_enabled_ = is_css_offset_position_anchor_enabled_;
  RuntimeEnabledFeaturesBase::is_css_overflow_media_features_enabled_ = is_css_overflow_media_features_enabled_;
  RuntimeEnabledFeaturesBase::is_css_paint_api_arguments_enabled_ = is_css_paint_api_arguments_enabled_;
  RuntimeEnabledFeaturesBase::is_css_parser_ignore_charset_for_urls_enabled_ = is_css_parser_ignore_charset_for_urls_enabled_;
  RuntimeEnabledFeaturesBase::is_css_phrase_line_break_enabled_ = is_css_phrase_line_break_enabled_;
  RuntimeEnabledFeaturesBase::is_css_position_sticky_static_scroll_position_enabled_ = is_css_position_sticky_static_scroll_position_enabled_;
  RuntimeEnabledFeaturesBase::is_css_progress_notation_enabled_ = is_css_progress_notation_enabled_;
  RuntimeEnabledFeaturesBase::is_css_pseudo_dir_enabled_ = is_css_pseudo_dir_enabled_;
  RuntimeEnabledFeaturesBase::is_css_pseudo_playing_paused_enabled_ = is_css_pseudo_playing_paused_enabled_;
  RuntimeEnabledFeaturesBase::is_css_relative_color_enabled_ = is_css_relative_color_enabled_;
  RuntimeEnabledFeaturesBase::is_css_resize_auto_enabled_ = is_css_resize_auto_enabled_;
  RuntimeEnabledFeaturesBase::is_css_scope_enabled_ = is_css_scope_enabled_;
  RuntimeEnabledFeaturesBase::is_css_scroll_snap_events_enabled_ = is_css_scroll_snap_events_enabled_;
  RuntimeEnabledFeaturesBase::is_css_scroll_start_enabled_ = is_css_scroll_start_enabled_;
  RuntimeEnabledFeaturesBase::is_css_scroll_state_container_queries_enabled_ = is_css_scroll_state_container_queries_enabled_;
  RuntimeEnabledFeaturesBase::is_css_selector_fragment_anchor_enabled_ = is_css_selector_fragment_anchor_enabled_;
  RuntimeEnabledFeaturesBase::is_css_selector_nth_child_complex_selector_enabled_ = is_css_selector_nth_child_complex_selector_enabled_;
  RuntimeEnabledFeaturesBase::is_css_sign_related_functions_enabled_ = is_css_sign_related_functions_enabled_;
  RuntimeEnabledFeaturesBase::is_css_snap_changed_event_enabled_ = is_css_snap_changed_event_enabled_;
  RuntimeEnabledFeaturesBase::is_css_snap_changing_event_enabled_ = is_css_snap_changing_event_enabled_;
  RuntimeEnabledFeaturesBase::is_css_snap_container_queries_enabled_ = is_css_snap_container_queries_enabled_;
  RuntimeEnabledFeaturesBase::is_css_spelling_grammar_errors_enabled_ = is_css_spelling_grammar_errors_enabled_;
  RuntimeEnabledFeaturesBase::is_css_stepped_value_functions_enabled_ = is_css_stepped_value_functions_enabled_;
  RuntimeEnabledFeaturesBase::is_css_sticky_container_queries_enabled_ = is_css_sticky_container_queries_enabled_;
  RuntimeEnabledFeaturesBase::is_css_supports_for_import_rules_enabled_ = is_css_supports_for_import_rules_enabled_;
  RuntimeEnabledFeaturesBase::is_css_system_accent_color_enabled_ = is_css_system_accent_color_enabled_;
  RuntimeEnabledFeaturesBase::is_css_text_auto_space_enabled_ = is_css_text_auto_space_enabled_;
  RuntimeEnabledFeaturesBase::is_css_text_box_trim_enabled_ = is_css_text_box_trim_enabled_;
  RuntimeEnabledFeaturesBase::is_css_text_spacing_enabled_ = is_css_text_spacing_enabled_;
  RuntimeEnabledFeaturesBase::is_css_text_spacing_trim_enabled_ = is_css_text_spacing_trim_enabled_;
  RuntimeEnabledFeaturesBase::is_css_text_wrap_balance_by_score_enabled_ = is_css_text_wrap_balance_by_score_enabled_;
  RuntimeEnabledFeaturesBase::is_css_text_wrap_pretty_enabled_ = is_css_text_wrap_pretty_enabled_;
  RuntimeEnabledFeaturesBase::is_css_transition_discrete_enabled_ = is_css_transition_discrete_enabled_;
  RuntimeEnabledFeaturesBase::is_css_tree_scoped_timelines_enabled_ = is_css_tree_scoped_timelines_enabled_;
  RuntimeEnabledFeaturesBase::is_css_unknown_container_queries_no_selection_enabled_ = is_css_unknown_container_queries_no_selection_enabled_;
  RuntimeEnabledFeaturesBase::is_css_update_media_feature_enabled_ = is_css_update_media_feature_enabled_;
  RuntimeEnabledFeaturesBase::is_css_user_select_contain_enabled_ = is_css_user_select_contain_enabled_;
  RuntimeEnabledFeaturesBase::is_css_variables_2_image_values_enabled_ = is_css_variables_2_image_values_enabled_;
  RuntimeEnabledFeaturesBase::is_css_variables_2_transform_values_enabled_ = is_css_variables_2_transform_values_enabled_;
  RuntimeEnabledFeaturesBase::is_css_video_dynamic_range_media_queries_enabled_ = is_css_video_dynamic_range_media_queries_enabled_;
  RuntimeEnabledFeaturesBase::is_css_viewport_units_4_enabled_ = is_css_viewport_units_4_enabled_;
  RuntimeEnabledFeaturesBase::is_css_view_timeline_inset_shorthand_enabled_ = is_css_view_timeline_inset_shorthand_enabled_;
  RuntimeEnabledFeaturesBase::is_custom_elements_get_name_enabled_ = is_custom_elements_get_name_enabled_;
  RuntimeEnabledFeaturesBase::is_database_enabled_ = is_database_enabled_;
  RuntimeEnabledFeaturesBase::is_data_transfer_clear_string_items_enabled_ = is_data_transfer_clear_string_items_enabled_;
  RuntimeEnabledFeaturesBase::is_date_input_inline_block_enabled_ = is_date_input_inline_block_enabled_;
  RuntimeEnabledFeaturesBase::is_deprecated_template_shadow_root_enabled_ = is_deprecated_template_shadow_root_enabled_;
  RuntimeEnabledFeaturesBase::is_deprecate_unload_opt_out_enabled_ = is_deprecate_unload_opt_out_enabled_;
  RuntimeEnabledFeaturesBase::is_desktop_capture_disable_local_echo_control_enabled_ = is_desktop_capture_disable_local_echo_control_enabled_;
  RuntimeEnabledFeaturesBase::is_desktop_pw_as_additional_windowing_controls_enabled_ = is_desktop_pw_as_additional_windowing_controls_enabled_;
  RuntimeEnabledFeaturesBase::is_desktop_pw_as_sub_apps_enabled_ = is_desktop_pw_as_sub_apps_enabled_;
  RuntimeEnabledFeaturesBase::is_details_element_toggle_event_enabled_ = is_details_element_toggle_event_enabled_;
  RuntimeEnabledFeaturesBase::is_details_styling_enabled_ = is_details_styling_enabled_;
  RuntimeEnabledFeaturesBase::is_device_attributes_enabled_ = is_device_attributes_enabled_;
  RuntimeEnabledFeaturesBase::is_device_orientation_request_permission_enabled_ = is_device_orientation_request_permission_enabled_;
  RuntimeEnabledFeaturesBase::is_device_posture_enabled_ = is_device_posture_enabled_;
  RuntimeEnabledFeaturesBase::is_dialog_new_focus_behavior_enabled_ = is_dialog_new_focus_behavior_enabled_;
  RuntimeEnabledFeaturesBase::is_digital_goods_enabled_ = is_digital_goods_enabled_;
  RuntimeEnabledFeaturesBase::is_digital_goods_v_2_1_enabled_ = is_digital_goods_v_2_1_enabled_;
  RuntimeEnabledFeaturesBase::is_direct_sockets_enabled_ = is_direct_sockets_enabled_;
  RuntimeEnabledFeaturesBase::is_dirname_more_input_types_enabled_ = is_dirname_more_input_types_enabled_;
  RuntimeEnabledFeaturesBase::is_disable_different_origin_subframe_dialog_suppression_enabled_ = is_disable_different_origin_subframe_dialog_suppression_enabled_;
  RuntimeEnabledFeaturesBase::is_disable_hardware_noise_suppression_enabled_ = is_disable_hardware_noise_suppression_enabled_;
  RuntimeEnabledFeaturesBase::is_disable_select_all_for_empty_text_enabled_ = is_disable_select_all_for_empty_text_enabled_;
  RuntimeEnabledFeaturesBase::is_disable_third_party_session_storage_partitioning_after_general_partitioning_enabled_ = is_disable_third_party_session_storage_partitioning_after_general_partitioning_enabled_;
  RuntimeEnabledFeaturesBase::is_disable_third_party_storage_partitioning_enabled_ = is_disable_third_party_storage_partitioning_enabled_;
  RuntimeEnabledFeaturesBase::is_dispatch_hidden_visibility_transitions_enabled_ = is_dispatch_hidden_visibility_transitions_enabled_;
  RuntimeEnabledFeaturesBase::is_display_cutout_api_enabled_ = is_display_cutout_api_enabled_;
  RuntimeEnabledFeaturesBase::is_document_base_uri_fix_enabled_ = is_document_base_uri_fix_enabled_;
  RuntimeEnabledFeaturesBase::is_document_cookie_enabled_ = is_document_cookie_enabled_;
  RuntimeEnabledFeaturesBase::is_document_domain_enabled_ = is_document_domain_enabled_;
  RuntimeEnabledFeaturesBase::is_document_open_origin_alias_removal_enabled_ = is_document_open_origin_alias_removal_enabled_;
  RuntimeEnabledFeaturesBase::is_document_open_sandbox_inheritance_removal_enabled_ = is_document_open_sandbox_inheritance_removal_enabled_;
  RuntimeEnabledFeaturesBase::is_document_picture_in_picture_api_enabled_ = is_document_picture_in_picture_api_enabled_;
  RuntimeEnabledFeaturesBase::is_document_policy_document_domain_enabled_ = is_document_policy_document_domain_enabled_;
  RuntimeEnabledFeaturesBase::is_document_policy_negotiation_enabled_ = is_document_policy_negotiation_enabled_;
  RuntimeEnabledFeaturesBase::is_document_policy_sync_xhr_enabled_ = is_document_policy_sync_xhr_enabled_;
  RuntimeEnabledFeaturesBase::is_document_render_blocking_enabled_ = is_document_render_blocking_enabled_;
  RuntimeEnabledFeaturesBase::is_document_write_enabled_ = is_document_write_enabled_;
  RuntimeEnabledFeaturesBase::is_dom_parser_uses_html_fast_path_parser_enabled_ = is_dom_parser_uses_html_fast_path_parser_enabled_;
  RuntimeEnabledFeaturesBase::is_dom_parts_api_enabled_ = is_dom_parts_api_enabled_;
  RuntimeEnabledFeaturesBase::is_dont_fire_dblclick_on_disabled_form_controls_enabled_ = is_dont_fire_dblclick_on_disabled_form_controls_enabled_;
  RuntimeEnabledFeaturesBase::is_dynamic_scroll_cull_rect_expansion_enabled_ = is_dynamic_scroll_cull_rect_expansion_enabled_;
  RuntimeEnabledFeaturesBase::is_edit_context_enabled_ = is_edit_context_enabled_;
  RuntimeEnabledFeaturesBase::is_element_capture_enabled_ = is_element_capture_enabled_;
  RuntimeEnabledFeaturesBase::is_empty_clipboard_read_enabled_ = is_empty_clipboard_read_enabled_;
  RuntimeEnabledFeaturesBase::is_enforce_anonymity_exposure_enabled_ = is_enforce_anonymity_exposure_enabled_;
  RuntimeEnabledFeaturesBase::is_escape_lt_gt_in_attributes_enabled_ = is_escape_lt_gt_in_attributes_enabled_;
  RuntimeEnabledFeaturesBase::is_event_timing_interaction_count_enabled_ = is_event_timing_interaction_count_enabled_;
  RuntimeEnabledFeaturesBase::is_exclude_broken_image_icon_from_being_lcp_eligible_enabled_ = is_exclude_broken_image_icon_from_being_lcp_eligible_enabled_;
  RuntimeEnabledFeaturesBase::is_experimental_content_security_policy_features_enabled_ = is_experimental_content_security_policy_features_enabled_;
  RuntimeEnabledFeaturesBase::is_experimental_js_profiler_markers_enabled_ = is_experimental_js_profiler_markers_enabled_;
  RuntimeEnabledFeaturesBase::is_experimental_policies_enabled_ = is_experimental_policies_enabled_;
  RuntimeEnabledFeaturesBase::is_expose_render_time_non_tao_delayed_image_enabled_ = is_expose_render_time_non_tao_delayed_image_enabled_;
  RuntimeEnabledFeaturesBase::is_extended_text_metrics_enabled_ = is_extended_text_metrics_enabled_;
  RuntimeEnabledFeaturesBase::is_extra_webgl_video_texture_metadata_enabled_ = is_extra_webgl_video_texture_metadata_enabled_;
  RuntimeEnabledFeaturesBase::is_eye_dropper_api_enabled_ = is_eye_dropper_api_enabled_;
  RuntimeEnabledFeaturesBase::is_face_detector_enabled_ = is_face_detector_enabled_;
  RuntimeEnabledFeaturesBase::is_fake_no_alloc_direct_call_for_testing_enabled_ = is_fake_no_alloc_direct_call_for_testing_enabled_;
  RuntimeEnabledFeaturesBase::is_fast_position_iterator_enabled_ = is_fast_position_iterator_enabled_;
  RuntimeEnabledFeaturesBase::is_fed_cm_enabled_ = is_fed_cm_enabled_;
  RuntimeEnabledFeaturesBase::is_fed_cm_authz_enabled_ = is_fed_cm_authz_enabled_;
  RuntimeEnabledFeaturesBase::is_fed_cm_auto_selected_flag_enabled_ = is_fed_cm_auto_selected_flag_enabled_;
  RuntimeEnabledFeaturesBase::is_fed_cm_button_mode_enabled_ = is_fed_cm_button_mode_enabled_;
  RuntimeEnabledFeaturesBase::is_fed_cm_disconnect_enabled_ = is_fed_cm_disconnect_enabled_;
  RuntimeEnabledFeaturesBase::is_fed_cm_domain_hint_enabled_ = is_fed_cm_domain_hint_enabled_;
  RuntimeEnabledFeaturesBase::is_fed_cm_error_enabled_ = is_fed_cm_error_enabled_;
  RuntimeEnabledFeaturesBase::is_fed_cm_id_p_registration_enabled_ = is_fed_cm_id_p_registration_enabled_;
  RuntimeEnabledFeaturesBase::is_fed_cm_idp_signin_status_enabled_ = is_fed_cm_idp_signin_status_enabled_;
  RuntimeEnabledFeaturesBase::is_fed_cm_multiple_identity_providers_enabled_ = is_fed_cm_multiple_identity_providers_enabled_;
  RuntimeEnabledFeaturesBase::is_fed_cm_selective_disclosure_enabled_ = is_fed_cm_selective_disclosure_enabled_;
  RuntimeEnabledFeaturesBase::is_fenced_frames_enabled_ = is_fenced_frames_enabled_;
  RuntimeEnabledFeaturesBase::is_fenced_frames_api_changes_enabled_ = is_fenced_frames_api_changes_enabled_;
  RuntimeEnabledFeaturesBase::is_fenced_frames_default_mode_enabled_ = is_fenced_frames_default_mode_enabled_;
  RuntimeEnabledFeaturesBase::is_fenced_frames_local_unpartitioned_data_access_enabled_ = is_fenced_frames_local_unpartitioned_data_access_enabled_;
  RuntimeEnabledFeaturesBase::is_fetch_later_api_enabled_ = is_fetch_later_api_enabled_;
  RuntimeEnabledFeaturesBase::is_fetch_upload_streaming_enabled_ = is_fetch_upload_streaming_enabled_;
  RuntimeEnabledFeaturesBase::is_file_handling_enabled_ = is_file_handling_enabled_;
  RuntimeEnabledFeaturesBase::is_file_handling_icons_enabled_ = is_file_handling_icons_enabled_;
  RuntimeEnabledFeaturesBase::is_file_system_enabled_ = is_file_system_enabled_;
  RuntimeEnabledFeaturesBase::is_file_system_access_enabled_ = is_file_system_access_enabled_;
  RuntimeEnabledFeaturesBase::is_file_system_access_api_experimental_enabled_ = is_file_system_access_api_experimental_enabled_;
  RuntimeEnabledFeaturesBase::is_file_system_access_get_cloud_identifiers_enabled_ = is_file_system_access_get_cloud_identifiers_enabled_;
  RuntimeEnabledFeaturesBase::is_file_system_access_local_enabled_ = is_file_system_access_local_enabled_;
  RuntimeEnabledFeaturesBase::is_file_system_access_locking_scheme_enabled_ = is_file_system_access_locking_scheme_enabled_;
  RuntimeEnabledFeaturesBase::is_file_system_access_origin_private_enabled_ = is_file_system_access_origin_private_enabled_;
  RuntimeEnabledFeaturesBase::is_file_system_observer_enabled_ = is_file_system_observer_enabled_;
  RuntimeEnabledFeaturesBase::is_fledge_enabled_ = is_fledge_enabled_;
  RuntimeEnabledFeaturesBase::is_fledge_bidding_and_auction_server_api_enabled_ = is_fledge_bidding_and_auction_server_api_enabled_;
  RuntimeEnabledFeaturesBase::is_fledge_clear_origin_joined_ad_interest_groups_enabled_ = is_fledge_clear_origin_joined_ad_interest_groups_enabled_;
  RuntimeEnabledFeaturesBase::is_fledge_direct_from_seller_signals_header_ad_slot_enabled_ = is_fledge_direct_from_seller_signals_header_ad_slot_enabled_;
  RuntimeEnabledFeaturesBase::is_fledge_feature_detection_enabled_ = is_fledge_feature_detection_enabled_;
  RuntimeEnabledFeaturesBase::is_fledge_negative_targeting_enabled_ = is_fledge_negative_targeting_enabled_;
  RuntimeEnabledFeaturesBase::is_fledge_trusted_bidding_signals_slot_size_enabled_ = is_fledge_trusted_bidding_signals_slot_size_enabled_;
  RuntimeEnabledFeaturesBase::is_fluent_overlay_scrollbars_enabled_ = is_fluent_overlay_scrollbars_enabled_;
  RuntimeEnabledFeaturesBase::is_fluent_scrollbars_enabled_ = is_fluent_scrollbars_enabled_;
  RuntimeEnabledFeaturesBase::is_flush_parser_before_creating_custom_elements_enabled_ = is_flush_parser_before_creating_custom_elements_enabled_;
  RuntimeEnabledFeaturesBase::is_focusgroup_enabled_ = is_focusgroup_enabled_;
  RuntimeEnabledFeaturesBase::is_focus_style_invalidation_on_page_activation_enabled_ = is_focus_style_invalidation_on_page_activation_enabled_;
  RuntimeEnabledFeaturesBase::is_font_access_enabled_ = is_font_access_enabled_;
  RuntimeEnabledFeaturesBase::is_fontations_font_backend_enabled_ = is_fontations_font_backend_enabled_;
  RuntimeEnabledFeaturesBase::is_font_matching_ct_migration_enabled_ = is_font_matching_ct_migration_enabled_;
  RuntimeEnabledFeaturesBase::is_font_palette_animation_enabled_ = is_font_palette_animation_enabled_;
  RuntimeEnabledFeaturesBase::is_font_src_local_matching_enabled_ = is_font_src_local_matching_enabled_;
  RuntimeEnabledFeaturesBase::is_forced_colors_enabled_ = is_forced_colors_enabled_;
  RuntimeEnabledFeaturesBase::is_forced_colors_preserve_parent_color_enabled_ = is_forced_colors_preserve_parent_color_enabled_;
  RuntimeEnabledFeaturesBase::is_force_eager_measure_memory_enabled_ = is_force_eager_measure_memory_enabled_;
  RuntimeEnabledFeaturesBase::is_force_reduce_motion_enabled_ = is_force_reduce_motion_enabled_;
  RuntimeEnabledFeaturesBase::is_force_taller_select_popup_enabled_ = is_force_taller_select_popup_enabled_;
  RuntimeEnabledFeaturesBase::is_formatted_text_enabled_ = is_formatted_text_enabled_;
  RuntimeEnabledFeaturesBase::is_form_control_restore_state_if_autocomplete_off_enabled_ = is_form_control_restore_state_if_autocomplete_off_enabled_;
  RuntimeEnabledFeaturesBase::is_form_controls_vertical_writing_mode_direction_support_enabled_ = is_form_controls_vertical_writing_mode_direction_support_enabled_;
  RuntimeEnabledFeaturesBase::is_form_controls_vertical_writing_mode_support_enabled_ = is_form_controls_vertical_writing_mode_support_enabled_;
  RuntimeEnabledFeaturesBase::is_form_controls_vertical_writing_mode_text_support_enabled_ = is_form_controls_vertical_writing_mode_text_support_enabled_;
  RuntimeEnabledFeaturesBase::is_form_state_restore_callback_call_with_state_enabled_ = is_form_state_restore_callback_call_with_state_enabled_;
  RuntimeEnabledFeaturesBase::is_fractional_scroll_offsets_enabled_ = is_fractional_scroll_offsets_enabled_;
  RuntimeEnabledFeaturesBase::is_freeze_frames_on_visibility_enabled_ = is_freeze_frames_on_visibility_enabled_;
  RuntimeEnabledFeaturesBase::is_fullscreen_popup_windows_enabled_ = is_fullscreen_popup_windows_enabled_;
  RuntimeEnabledFeaturesBase::is_gamepad_button_axis_events_enabled_ = is_gamepad_button_axis_events_enabled_;
  RuntimeEnabledFeaturesBase::is_gamepad_multitouch_enabled_ = is_gamepad_multitouch_enabled_;
  RuntimeEnabledFeaturesBase::is_get_all_screens_media_enabled_ = is_get_all_screens_media_enabled_;
  RuntimeEnabledFeaturesBase::is_get_display_media_enabled_ = is_get_display_media_enabled_;
  RuntimeEnabledFeaturesBase::is_get_display_media_requires_user_activation_enabled_ = is_get_display_media_requires_user_activation_enabled_;
  RuntimeEnabledFeaturesBase::is_group_effect_enabled_ = is_group_effect_enabled_;
  RuntimeEnabledFeaturesBase::is_handwriting_recognition_enabled_ = is_handwriting_recognition_enabled_;
  RuntimeEnabledFeaturesBase::is_hanging_whitespace_does_not_depend_on_alignment_enabled_ = is_hanging_whitespace_does_not_depend_on_alignment_enabled_;
  RuntimeEnabledFeaturesBase::is_has_ua_visual_transition_enabled_ = is_has_ua_visual_transition_enabled_;
  RuntimeEnabledFeaturesBase::is_highlight_inheritance_enabled_ = is_highlight_inheritance_enabled_;
  RuntimeEnabledFeaturesBase::is_highlight_pointer_events_enabled_ = is_highlight_pointer_events_enabled_;
  RuntimeEnabledFeaturesBase::is_hit_test_opaqueness_enabled_ = is_hit_test_opaqueness_enabled_;
  RuntimeEnabledFeaturesBase::is_hit_test_transparency_enabled_ = is_hit_test_transparency_enabled_;
  RuntimeEnabledFeaturesBase::is_href_translate_enabled_ = is_href_translate_enabled_;
  RuntimeEnabledFeaturesBase::is_html_invoke_actions_v_2_enabled_ = is_html_invoke_actions_v_2_enabled_;
  RuntimeEnabledFeaturesBase::is_html_invoke_target_attribute_enabled_ = is_html_invoke_target_attribute_enabled_;
  RuntimeEnabledFeaturesBase::is_html_lang_new_inheritance_enabled_ = is_html_lang_new_inheritance_enabled_;
  RuntimeEnabledFeaturesBase::is_html_parser_fast_path_bulk_insert_notify_enabled_ = is_html_parser_fast_path_bulk_insert_notify_enabled_;
  RuntimeEnabledFeaturesBase::is_html_parser_yield_and_delay_often_for_testing_enabled_ = is_html_parser_yield_and_delay_often_for_testing_enabled_;
  RuntimeEnabledFeaturesBase::is_html_popover_hint_enabled_ = is_html_popover_hint_enabled_;
  RuntimeEnabledFeaturesBase::is_html_search_element_enabled_ = is_html_search_element_enabled_;
  RuntimeEnabledFeaturesBase::is_html_select_element_show_picker_enabled_ = is_html_select_element_show_picker_enabled_;
  RuntimeEnabledFeaturesBase::is_html_select_list_element_enabled_ = is_html_select_list_element_enabled_;
  RuntimeEnabledFeaturesBase::is_html_unsafe_methods_enabled_ = is_html_unsafe_methods_enabled_;
  RuntimeEnabledFeaturesBase::is_implicit_root_scroller_enabled_ = is_implicit_root_scroller_enabled_;
  RuntimeEnabledFeaturesBase::is_import_attributes_disallow_unknown_keys_enabled_ = is_import_attributes_disallow_unknown_keys_enabled_;
  RuntimeEnabledFeaturesBase::is_incoming_call_notifications_enabled_ = is_incoming_call_notifications_enabled_;
  RuntimeEnabledFeaturesBase::is_inert_display_transition_enabled_ = is_inert_display_transition_enabled_;
  RuntimeEnabledFeaturesBase::is_infinite_cull_rect_enabled_ = is_infinite_cull_rect_enabled_;
  RuntimeEnabledFeaturesBase::is_inherit_user_modify_without_contenteditable_enabled_ = is_inherit_user_modify_without_contenteditable_enabled_;
  RuntimeEnabledFeaturesBase::is_inner_html_parser_fastpath_log_failure_enabled_ = is_inner_html_parser_fastpath_log_failure_enabled_;
  RuntimeEnabledFeaturesBase::is_input_multiple_fields_ui_enabled_ = is_input_multiple_fields_ui_enabled_;
  RuntimeEnabledFeaturesBase::is_insert_line_break_if_phrasing_content_enabled_ = is_insert_line_break_if_phrasing_content_enabled_;
  RuntimeEnabledFeaturesBase::is_installed_app_enabled_ = is_installed_app_enabled_;
  RuntimeEnabledFeaturesBase::is_interoperable_private_attribution_enabled_ = is_interoperable_private_attribution_enabled_;
  RuntimeEnabledFeaturesBase::is_interrupt_composed_scrollbar_disappearance_enabled_ = is_interrupt_composed_scrollbar_disappearance_enabled_;
  RuntimeEnabledFeaturesBase::is_intersection_observer_scroll_margin_enabled_ = is_intersection_observer_scroll_margin_enabled_;
  RuntimeEnabledFeaturesBase::is_intersection_optimization_enabled_ = is_intersection_optimization_enabled_;
  RuntimeEnabledFeaturesBase::is_inverted_colors_enabled_ = is_inverted_colors_enabled_;
  RuntimeEnabledFeaturesBase::is_invisible_svg_animation_throttling_enabled_ = is_invisible_svg_animation_throttling_enabled_;
  RuntimeEnabledFeaturesBase::is_java_script_compile_hints_magic_runtime_enabled_ = is_java_script_compile_hints_magic_runtime_enabled_;
  RuntimeEnabledFeaturesBase::is_keyboard_accessible_tooltip_enabled_ = is_keyboard_accessible_tooltip_enabled_;
  RuntimeEnabledFeaturesBase::is_keyboard_focusable_scrollers_enabled_ = is_keyboard_focusable_scrollers_enabled_;
  RuntimeEnabledFeaturesBase::is_lang_attribute_aware_form_control_ui_enabled_ = is_lang_attribute_aware_form_control_ui_enabled_;
  RuntimeEnabledFeaturesBase::is_layout_align_for_positioned_enabled_ = is_layout_align_for_positioned_enabled_;
  RuntimeEnabledFeaturesBase::is_layout_flex_new_row_algorithm_v_3_enabled_ = is_layout_flex_new_row_algorithm_v_3_enabled_;
  RuntimeEnabledFeaturesBase::is_layout_ignore_margins_for_sticky_enabled_ = is_layout_ignore_margins_for_sticky_enabled_;
  RuntimeEnabledFeaturesBase::is_layout_new_containing_block_enabled_ = is_layout_new_containing_block_enabled_;
  RuntimeEnabledFeaturesBase::is_layout_new_measure_cache_enabled_ = is_layout_new_measure_cache_enabled_;
  RuntimeEnabledFeaturesBase::is_layout_new_min_max_cache_enabled_ = is_layout_new_min_max_cache_enabled_;
  RuntimeEnabledFeaturesBase::is_layout_ng_shape_cache_enabled_ = is_layout_ng_shape_cache_enabled_;
  RuntimeEnabledFeaturesBase::is_lazy_initialize_media_controls_enabled_ = is_lazy_initialize_media_controls_enabled_;
  RuntimeEnabledFeaturesBase::is_lazy_load_scroll_margin_enabled_ = is_lazy_load_scroll_margin_enabled_;
  RuntimeEnabledFeaturesBase::is_lcp_animated_images_web_exposed_enabled_ = is_lcp_animated_images_web_exposed_enabled_;
  RuntimeEnabledFeaturesBase::is_lcp_mouseover_heuristics_enabled_ = is_lcp_mouseover_heuristics_enabled_;
  RuntimeEnabledFeaturesBase::is_lcp_multiple_updates_per_element_enabled_ = is_lcp_multiple_updates_per_element_enabled_;
  RuntimeEnabledFeaturesBase::is_legacy_windows_d_write_font_fallback_enabled_ = is_legacy_windows_d_write_font_fallback_enabled_;
  RuntimeEnabledFeaturesBase::is_locked_mode_enabled_ = is_locked_mode_enabled_;
  RuntimeEnabledFeaturesBase::is_long_animation_frame_timing_enabled_ = is_long_animation_frame_timing_enabled_;
  RuntimeEnabledFeaturesBase::is_long_task_from_long_animation_frame_enabled_ = is_long_task_from_long_animation_frame_enabled_;
  RuntimeEnabledFeaturesBase::is_mac_fonts_deprecate_font_traits_workaround_enabled_ = is_mac_fonts_deprecate_font_traits_workaround_enabled_;
  RuntimeEnabledFeaturesBase::is_machine_learning_common_enabled_ = is_machine_learning_common_enabled_;
  RuntimeEnabledFeaturesBase::is_machine_learning_model_loader_enabled_ = is_machine_learning_model_loader_enabled_;
  RuntimeEnabledFeaturesBase::is_machine_learning_neural_network_enabled_ = is_machine_learning_neural_network_enabled_;
  RuntimeEnabledFeaturesBase::is_managed_configuration_enabled_ = is_managed_configuration_enabled_;
  RuntimeEnabledFeaturesBase::is_masking_grapheme_clusters_enabled_ = is_masking_grapheme_clusters_enabled_;
  RuntimeEnabledFeaturesBase::is_measure_memory_enabled_ = is_measure_memory_enabled_;
  RuntimeEnabledFeaturesBase::is_media_capabilities_dynamic_range_enabled_ = is_media_capabilities_dynamic_range_enabled_;
  RuntimeEnabledFeaturesBase::is_media_capabilities_encoding_info_enabled_ = is_media_capabilities_encoding_info_enabled_;
  RuntimeEnabledFeaturesBase::is_media_capabilities_spatial_audio_enabled_ = is_media_capabilities_spatial_audio_enabled_;
  RuntimeEnabledFeaturesBase::is_media_capture_enabled_ = is_media_capture_enabled_;
  RuntimeEnabledFeaturesBase::is_media_capture_background_blur_enabled_ = is_media_capture_background_blur_enabled_;
  RuntimeEnabledFeaturesBase::is_media_capture_camera_controls_enabled_ = is_media_capture_camera_controls_enabled_;
  RuntimeEnabledFeaturesBase::is_media_capture_configuration_change_enabled_ = is_media_capture_configuration_change_enabled_;
  RuntimeEnabledFeaturesBase::is_media_capture_voice_isolation_enabled_ = is_media_capture_voice_isolation_enabled_;
  RuntimeEnabledFeaturesBase::is_media_cast_overlay_button_enabled_ = is_media_cast_overlay_button_enabled_;
  RuntimeEnabledFeaturesBase::is_media_controls_expand_gesture_enabled_ = is_media_controls_expand_gesture_enabled_;
  RuntimeEnabledFeaturesBase::is_media_controls_overlay_play_button_enabled_ = is_media_controls_overlay_play_button_enabled_;
  RuntimeEnabledFeaturesBase::is_media_element_volume_greater_than_one_enabled_ = is_media_element_volume_greater_than_one_enabled_;
  RuntimeEnabledFeaturesBase::is_media_engagement_bypass_autoplay_policies_enabled_ = is_media_engagement_bypass_autoplay_policies_enabled_;
  RuntimeEnabledFeaturesBase::is_media_latency_hint_enabled_ = is_media_latency_hint_enabled_;
  RuntimeEnabledFeaturesBase::is_media_query_navigation_controls_enabled_ = is_media_query_navigation_controls_enabled_;
  RuntimeEnabledFeaturesBase::is_media_recorder_use_media_video_encoder_enabled_ = is_media_recorder_use_media_video_encoder_enabled_;
  RuntimeEnabledFeaturesBase::is_media_session_enabled_ = is_media_session_enabled_;
  RuntimeEnabledFeaturesBase::is_media_session_chapter_information_enabled_ = is_media_session_chapter_information_enabled_;
  RuntimeEnabledFeaturesBase::is_media_session_enter_picture_in_picture_enabled_ = is_media_session_enter_picture_in_picture_enabled_;
  RuntimeEnabledFeaturesBase::is_media_source_experimental_enabled_ = is_media_source_experimental_enabled_;
  RuntimeEnabledFeaturesBase::is_media_source_extensions_for_webcodecs_enabled_ = is_media_source_extensions_for_webcodecs_enabled_;
  RuntimeEnabledFeaturesBase::is_media_source_new_abort_and_duration_enabled_ = is_media_source_new_abort_and_duration_enabled_;
  RuntimeEnabledFeaturesBase::is_media_stream_track_transfer_enabled_ = is_media_stream_track_transfer_enabled_;
  RuntimeEnabledFeaturesBase::is_message_port_close_event_enabled_ = is_message_port_close_event_enabled_;
  RuntimeEnabledFeaturesBase::is_middle_click_autoscroll_enabled_ = is_middle_click_autoscroll_enabled_;
  RuntimeEnabledFeaturesBase::is_mobile_layout_theme_enabled_ = is_mobile_layout_theme_enabled_;
  RuntimeEnabledFeaturesBase::is_model_execution_api_enabled_ = is_model_execution_api_enabled_;
  RuntimeEnabledFeaturesBase::is_mojo_js_enabled_ = is_mojo_js_enabled_;
  RuntimeEnabledFeaturesBase::is_mojo_js_test_enabled_ = is_mojo_js_test_enabled_;
  RuntimeEnabledFeaturesBase::is_monitor_type_surfaces_enabled_ = is_monitor_type_surfaces_enabled_;
  RuntimeEnabledFeaturesBase::is_mouse_drag_from_iframe_on_cancelled_mouse_down_enabled_ = is_mouse_drag_from_iframe_on_cancelled_mouse_down_enabled_;
  RuntimeEnabledFeaturesBase::is_mouse_drag_on_cancelled_mouse_move_enabled_ = is_mouse_drag_on_cancelled_mouse_move_enabled_;
  RuntimeEnabledFeaturesBase::is_mutation_events_enabled_ = is_mutation_events_enabled_;
  RuntimeEnabledFeaturesBase::is_navigate_event_commit_behavior_enabled_ = is_navigate_event_commit_behavior_enabled_;
  RuntimeEnabledFeaturesBase::is_navigate_event_source_element_enabled_ = is_navigate_event_source_element_enabled_;
  RuntimeEnabledFeaturesBase::is_navigation_activation_enabled_ = is_navigation_activation_enabled_;
  RuntimeEnabledFeaturesBase::is_navigation_id_enabled_ = is_navigation_id_enabled_;
  RuntimeEnabledFeaturesBase::is_navigator_content_utils_enabled_ = is_navigator_content_utils_enabled_;
  RuntimeEnabledFeaturesBase::is_net_info_constant_type_enabled_ = is_net_info_constant_type_enabled_;
  RuntimeEnabledFeaturesBase::is_net_info_downlink_max_enabled_ = is_net_info_downlink_max_enabled_;
  RuntimeEnabledFeaturesBase::is_next_sibling_position_use_next_candidate_enabled_ = is_next_sibling_position_use_next_candidate_enabled_;
  RuntimeEnabledFeaturesBase::is_no_idle_encoding_for_web_tests_enabled_ = is_no_idle_encoding_for_web_tests_enabled_;
  RuntimeEnabledFeaturesBase::is_non_composed_enter_leave_events_enabled_ = is_non_composed_enter_leave_events_enabled_;
  RuntimeEnabledFeaturesBase::is_non_standard_appearance_values_high_usage_enabled_ = is_non_standard_appearance_values_high_usage_enabled_;
  RuntimeEnabledFeaturesBase::is_non_standard_appearance_value_slider_vertical_enabled_ = is_non_standard_appearance_value_slider_vertical_enabled_;
  RuntimeEnabledFeaturesBase::is_non_standard_appearance_values_low_usage_enabled_ = is_non_standard_appearance_values_low_usage_enabled_;
  RuntimeEnabledFeaturesBase::is_no_offset_mapping_for_inconsistent_text_enabled_ = is_no_offset_mapping_for_inconsistent_text_enabled_;
  RuntimeEnabledFeaturesBase::is_notification_constructor_enabled_ = is_notification_constructor_enabled_;
  RuntimeEnabledFeaturesBase::is_notification_content_image_enabled_ = is_notification_content_image_enabled_;
  RuntimeEnabledFeaturesBase::is_notifications_enabled_ = is_notifications_enabled_;
  RuntimeEnabledFeaturesBase::is_notification_triggers_enabled_ = is_notification_triggers_enabled_;
  RuntimeEnabledFeaturesBase::is_no_vary_search_prefetch_enabled_ = is_no_vary_search_prefetch_enabled_;
  RuntimeEnabledFeaturesBase::is_observable_api_enabled_ = is_observable_api_enabled_;
  RuntimeEnabledFeaturesBase::is_off_main_thread_css_paint_enabled_ = is_off_main_thread_css_paint_enabled_;
  RuntimeEnabledFeaturesBase::is_offscreen_canvas_commit_enabled_ = is_offscreen_canvas_commit_enabled_;
  RuntimeEnabledFeaturesBase::is_offset_mapping_unit_variable_enabled_ = is_offset_mapping_unit_variable_enabled_;
  RuntimeEnabledFeaturesBase::is_on_device_change_enabled_ = is_on_device_change_enabled_;
  RuntimeEnabledFeaturesBase::is_one_pass_raster_invalidation_enabled_ = is_one_pass_raster_invalidation_enabled_;
  RuntimeEnabledFeaturesBase::is_option_element_always_use_label_enabled_ = is_option_element_always_use_label_enabled_;
  RuntimeEnabledFeaturesBase::is_orientation_event_enabled_ = is_orientation_event_enabled_;
  RuntimeEnabledFeaturesBase::is_origin_isolation_header_enabled_ = is_origin_isolation_header_enabled_;
  RuntimeEnabledFeaturesBase::is_origin_policy_enabled_ = is_origin_policy_enabled_;
  RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_enabled_ = is_origin_trials_sample_api_enabled_;
  RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_browser_read_write_enabled_ = is_origin_trials_sample_api_browser_read_write_enabled_;
  RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_dependent_enabled_ = is_origin_trials_sample_api_dependent_enabled_;
  RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_deprecation_enabled_ = is_origin_trials_sample_api_deprecation_enabled_;
  RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_expiry_grace_period_enabled_ = is_origin_trials_sample_api_expiry_grace_period_enabled_;
  RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_expiry_grace_period_third_party_enabled_ = is_origin_trials_sample_api_expiry_grace_period_third_party_enabled_;
  RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_implied_enabled_ = is_origin_trials_sample_api_implied_enabled_;
  RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_invalid_os_enabled_ = is_origin_trials_sample_api_invalid_os_enabled_;
  RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_navigation_enabled_ = is_origin_trials_sample_api_navigation_enabled_;
  RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_persistent_expiry_grace_period_enabled_ = is_origin_trials_sample_api_persistent_expiry_grace_period_enabled_;
  RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_persistent_feature_enabled_ = is_origin_trials_sample_api_persistent_feature_enabled_;
  RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_persistent_invalid_os_enabled_ = is_origin_trials_sample_api_persistent_invalid_os_enabled_;
  RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_persistent_third_party_deprecation_feature_enabled_ = is_origin_trials_sample_api_persistent_third_party_deprecation_feature_enabled_;
  RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_third_party_enabled_ = is_origin_trials_sample_api_third_party_enabled_;
  RuntimeEnabledFeaturesBase::is_overscroll_customization_enabled_ = is_overscroll_customization_enabled_;
  RuntimeEnabledFeaturesBase::is_page_freeze_opt_in_enabled_ = is_page_freeze_opt_in_enabled_;
  RuntimeEnabledFeaturesBase::is_page_freeze_opt_out_enabled_ = is_page_freeze_opt_out_enabled_;
  RuntimeEnabledFeaturesBase::is_page_margin_boxes_enabled_ = is_page_margin_boxes_enabled_;
  RuntimeEnabledFeaturesBase::is_page_popup_enabled_ = is_page_popup_enabled_;
  RuntimeEnabledFeaturesBase::is_page_reveal_event_enabled_ = is_page_reveal_event_enabled_;
  RuntimeEnabledFeaturesBase::is_paint_under_invalidation_checking_enabled_ = is_paint_under_invalidation_checking_enabled_;
  RuntimeEnabledFeaturesBase::is_parakeet_enabled_ = is_parakeet_enabled_;
  RuntimeEnabledFeaturesBase::is_partitioned_cookies_enabled_ = is_partitioned_cookies_enabled_;
  RuntimeEnabledFeaturesBase::is_password_reveal_enabled_ = is_password_reveal_enabled_;
  RuntimeEnabledFeaturesBase::is_password_strong_label_enabled_ = is_password_strong_label_enabled_;
  RuntimeEnabledFeaturesBase::is_pasting_blocks_svg_use_non_local_hrefs_enabled_ = is_pasting_blocks_svg_use_non_local_hrefs_enabled_;
  RuntimeEnabledFeaturesBase::is_payment_app_enabled_ = is_payment_app_enabled_;
  RuntimeEnabledFeaturesBase::is_payment_handler_minimal_header_ux_enabled_ = is_payment_handler_minimal_header_ux_enabled_;
  RuntimeEnabledFeaturesBase::is_payment_instruments_enabled_ = is_payment_instruments_enabled_;
  RuntimeEnabledFeaturesBase::is_payment_method_change_event_enabled_ = is_payment_method_change_event_enabled_;
  RuntimeEnabledFeaturesBase::is_payment_request_enabled_ = is_payment_request_enabled_;
  RuntimeEnabledFeaturesBase::is_payment_request_allow_one_activationless_show_enabled_ = is_payment_request_allow_one_activationless_show_enabled_;
  RuntimeEnabledFeaturesBase::is_payment_request_merchant_validation_event_enabled_ = is_payment_request_merchant_validation_event_enabled_;
  RuntimeEnabledFeaturesBase::is_pending_beacon_api_enabled_ = is_pending_beacon_api_enabled_;
  RuntimeEnabledFeaturesBase::is_percent_based_scrolling_enabled_ = is_percent_based_scrolling_enabled_;
  RuntimeEnabledFeaturesBase::is_performance_manager_instrumentation_enabled_ = is_performance_manager_instrumentation_enabled_;
  RuntimeEnabledFeaturesBase::is_performance_mark_feature_usage_enabled_ = is_performance_mark_feature_usage_enabled_;
  RuntimeEnabledFeaturesBase::is_performance_navigate_system_entropy_enabled_ = is_performance_navigate_system_entropy_enabled_;
  RuntimeEnabledFeaturesBase::is_periodic_background_sync_enabled_ = is_periodic_background_sync_enabled_;
  RuntimeEnabledFeaturesBase::is_per_method_can_make_payment_quota_enabled_ = is_per_method_can_make_payment_quota_enabled_;
  RuntimeEnabledFeaturesBase::is_permission_element_enabled_ = is_permission_element_enabled_;
  RuntimeEnabledFeaturesBase::is_permissions_enabled_ = is_permissions_enabled_;
  RuntimeEnabledFeaturesBase::is_permissions_request_revoke_enabled_ = is_permissions_request_revoke_enabled_;
  RuntimeEnabledFeaturesBase::is_p_na_cl_enabled_ = is_p_na_cl_enabled_;
  RuntimeEnabledFeaturesBase::is_pointer_capture_lost_on_removal_during_capture_enabled_ = is_pointer_capture_lost_on_removal_during_capture_enabled_;
  RuntimeEnabledFeaturesBase::is_pointer_event_device_id_enabled_ = is_pointer_event_device_id_enabled_;
  RuntimeEnabledFeaturesBase::is_position_outside_tab_span_check_sibling_node_enabled_ = is_position_outside_tab_span_check_sibling_node_enabled_;
  RuntimeEnabledFeaturesBase::is_precise_memory_info_enabled_ = is_precise_memory_info_enabled_;
  RuntimeEnabledFeaturesBase::is_prefer_non_composited_scrolling_enabled_ = is_prefer_non_composited_scrolling_enabled_;
  RuntimeEnabledFeaturesBase::is_prefers_reduced_data_enabled_ = is_prefers_reduced_data_enabled_;
  RuntimeEnabledFeaturesBase::is_prefixed_video_fullscreen_enabled_ = is_prefixed_video_fullscreen_enabled_;
  RuntimeEnabledFeaturesBase::is_pre_paint_ancestors_of_missed_oof_enabled_ = is_pre_paint_ancestors_of_missed_oof_enabled_;
  RuntimeEnabledFeaturesBase::is_prerender_2_enabled_ = is_prerender_2_enabled_;
  RuntimeEnabledFeaturesBase::is_presentation_enabled_ = is_presentation_enabled_;
  RuntimeEnabledFeaturesBase::is_pretty_print_js_on_document_enabled_ = is_pretty_print_js_on_document_enabled_;
  RuntimeEnabledFeaturesBase::is_prevent_reading_system_accent_color_enabled_ = is_prevent_reading_system_accent_color_enabled_;
  RuntimeEnabledFeaturesBase::is_privacy_sandbox_ads_api_s_enabled_ = is_privacy_sandbox_ads_api_s_enabled_;
  RuntimeEnabledFeaturesBase::is_private_network_access_non_secure_contexts_allowed_enabled_ = is_private_network_access_non_secure_contexts_allowed_enabled_;
  RuntimeEnabledFeaturesBase::is_private_network_access_null_ip_address_enabled_ = is_private_network_access_null_ip_address_enabled_;
  RuntimeEnabledFeaturesBase::is_private_network_access_permission_prompt_enabled_ = is_private_network_access_permission_prompt_enabled_;
  RuntimeEnabledFeaturesBase::is_private_state_tokens_enabled_ = is_private_state_tokens_enabled_;
  RuntimeEnabledFeaturesBase::is_private_state_tokens_always_allow_issuance_enabled_ = is_private_state_tokens_always_allow_issuance_enabled_;
  RuntimeEnabledFeaturesBase::is_push_messaging_enabled_ = is_push_messaging_enabled_;
  RuntimeEnabledFeaturesBase::is_push_messaging_subscription_change_enabled_ = is_push_messaging_subscription_change_enabled_;
  RuntimeEnabledFeaturesBase::is_quick_intensive_wake_up_throttling_after_loading_enabled_ = is_quick_intensive_wake_up_throttling_after_loading_enabled_;
  RuntimeEnabledFeaturesBase::is_quota_change_enabled_ = is_quota_change_enabled_;
  RuntimeEnabledFeaturesBase::is_readable_stream_tee_clone_for_branch_2_enabled_ = is_readable_stream_tee_clone_for_branch_2_enabled_;
  RuntimeEnabledFeaturesBase::is_reduce_accept_language_enabled_ = is_reduce_accept_language_enabled_;
  RuntimeEnabledFeaturesBase::is_reduce_cookie_ip_cs_enabled_ = is_reduce_cookie_ip_cs_enabled_;
  RuntimeEnabledFeaturesBase::is_reduce_user_agent_android_version_device_model_enabled_ = is_reduce_user_agent_android_version_device_model_enabled_;
  RuntimeEnabledFeaturesBase::is_reduce_user_agent_minor_version_enabled_ = is_reduce_user_agent_minor_version_enabled_;
  RuntimeEnabledFeaturesBase::is_reduce_user_agent_platform_os_cpu_enabled_ = is_reduce_user_agent_platform_os_cpu_enabled_;
  RuntimeEnabledFeaturesBase::is_reference_box_no_pixel_snapping_enabled_ = is_reference_box_no_pixel_snapping_enabled_;
  RuntimeEnabledFeaturesBase::is_region_capture_enabled_ = is_region_capture_enabled_;
  RuntimeEnabledFeaturesBase::is_remote_playback_enabled_ = is_remote_playback_enabled_;
  RuntimeEnabledFeaturesBase::is_remote_playback_backend_enabled_ = is_remote_playback_backend_enabled_;
  RuntimeEnabledFeaturesBase::is_remove_dangling_markup_in_target_enabled_ = is_remove_dangling_markup_in_target_enabled_;
  RuntimeEnabledFeaturesBase::is_remove_data_url_in_svg_use_enabled_ = is_remove_data_url_in_svg_use_enabled_;
  RuntimeEnabledFeaturesBase::is_remove_mobile_viewport_double_tap_enabled_ = is_remove_mobile_viewport_double_tap_enabled_;
  RuntimeEnabledFeaturesBase::is_remove_zoom_adjustment_of_bounding_box_enabled_ = is_remove_zoom_adjustment_of_bounding_box_enabled_;
  RuntimeEnabledFeaturesBase::is_render_blocking_status_enabled_ = is_render_blocking_status_enabled_;
  RuntimeEnabledFeaturesBase::is_render_priority_attribute_enabled_ = is_render_priority_attribute_enabled_;
  RuntimeEnabledFeaturesBase::is_resource_timing_content_type_enabled_ = is_resource_timing_content_type_enabled_;
  RuntimeEnabledFeaturesBase::is_resource_timing_use_cors_for_body_sizes_enabled_ = is_resource_timing_use_cors_for_body_sizes_enabled_;
  RuntimeEnabledFeaturesBase::is_restrict_gamepad_access_enabled_ = is_restrict_gamepad_access_enabled_;
  RuntimeEnabledFeaturesBase::is_rewind_floats_enabled_ = is_rewind_floats_enabled_;
  RuntimeEnabledFeaturesBase::is_rtc_audio_jitter_buffer_max_packets_enabled_ = is_rtc_audio_jitter_buffer_max_packets_enabled_;
  RuntimeEnabledFeaturesBase::is_rtc_encoded_audio_frame_abs_capture_time_enabled_ = is_rtc_encoded_audio_frame_abs_capture_time_enabled_;
  RuntimeEnabledFeaturesBase::is_rtc_encoded_frame_set_metadata_enabled_ = is_rtc_encoded_frame_set_metadata_enabled_;
  RuntimeEnabledFeaturesBase::is_rtc_encoded_video_frame_additional_metadata_enabled_ = is_rtc_encoded_video_frame_additional_metadata_enabled_;
  RuntimeEnabledFeaturesBase::is_rtc_legacy_callback_based_get_stats_enabled_ = is_rtc_legacy_callback_based_get_stats_enabled_;
  RuntimeEnabledFeaturesBase::is_rtc_rtp_encoding_parameters_codec_enabled_ = is_rtc_rtp_encoding_parameters_codec_enabled_;
  RuntimeEnabledFeaturesBase::is_rtc_rtp_header_extension_control_enabled_ = is_rtc_rtp_header_extension_control_enabled_;
  RuntimeEnabledFeaturesBase::is_rtc_stats_relative_packet_arrival_delay_enabled_ = is_rtc_stats_relative_packet_arrival_delay_enabled_;
  RuntimeEnabledFeaturesBase::is_rtc_svc_scalability_mode_enabled_ = is_rtc_svc_scalability_mode_enabled_;
  RuntimeEnabledFeaturesBase::is_ruby_inlinify_enabled_ = is_ruby_inlinify_enabled_;
  RuntimeEnabledFeaturesBase::is_ruby_simple_pairing_enabled_ = is_ruby_simple_pairing_enabled_;
  RuntimeEnabledFeaturesBase::is_run_microtask_before_xml_custom_element_enabled_ = is_run_microtask_before_xml_custom_element_enabled_;
  RuntimeEnabledFeaturesBase::is_sanitizer_api_enabled_ = is_sanitizer_api_enabled_;
  RuntimeEnabledFeaturesBase::is_scheduler_yield_enabled_ = is_scheduler_yield_enabled_;
  RuntimeEnabledFeaturesBase::is_scoped_custom_element_registry_enabled_ = is_scoped_custom_element_registry_enabled_;
  RuntimeEnabledFeaturesBase::is_scripted_speech_recognition_enabled_ = is_scripted_speech_recognition_enabled_;
  RuntimeEnabledFeaturesBase::is_scripted_speech_synthesis_enabled_ = is_scripted_speech_synthesis_enabled_;
  RuntimeEnabledFeaturesBase::is_scrollbar_color_enabled_ = is_scrollbar_color_enabled_;
  RuntimeEnabledFeaturesBase::is_scrollbar_width_enabled_ = is_scrollbar_width_enabled_;
  RuntimeEnabledFeaturesBase::is_scroll_end_events_enabled_ = is_scroll_end_events_enabled_;
  RuntimeEnabledFeaturesBase::is_scroll_timeline_enabled_ = is_scroll_timeline_enabled_;
  RuntimeEnabledFeaturesBase::is_scroll_timeline_current_time_enabled_ = is_scroll_timeline_current_time_enabled_;
  RuntimeEnabledFeaturesBase::is_scroll_timeline_on_compositor_enabled_ = is_scroll_timeline_on_compositor_enabled_;
  RuntimeEnabledFeaturesBase::is_scroll_top_left_interop_enabled_ = is_scroll_top_left_interop_enabled_;
  RuntimeEnabledFeaturesBase::is_secure_payment_confirmation_enabled_ = is_secure_payment_confirmation_enabled_;
  RuntimeEnabledFeaturesBase::is_secure_payment_confirmation_allow_one_activationless_show_enabled_ = is_secure_payment_confirmation_allow_one_activationless_show_enabled_;
  RuntimeEnabledFeaturesBase::is_secure_payment_confirmation_debug_enabled_ = is_secure_payment_confirmation_debug_enabled_;
  RuntimeEnabledFeaturesBase::is_secure_payment_confirmation_extensions_enabled_ = is_secure_payment_confirmation_extensions_enabled_;
  RuntimeEnabledFeaturesBase::is_secure_payment_confirmation_opt_out_enabled_ = is_secure_payment_confirmation_opt_out_enabled_;
  RuntimeEnabledFeaturesBase::is_select_hr_enabled_ = is_select_hr_enabled_;
  RuntimeEnabledFeaturesBase::is_send_beacon_throw_for_blob_with_non_simple_type_enabled_ = is_send_beacon_throw_for_blob_with_non_simple_type_enabled_;
  RuntimeEnabledFeaturesBase::is_sensor_extra_classes_enabled_ = is_sensor_extra_classes_enabled_;
  RuntimeEnabledFeaturesBase::is_serial_enabled_ = is_serial_enabled_;
  RuntimeEnabledFeaturesBase::is_serialize_view_transition_state_in_spa_enabled_ = is_serialize_view_transition_state_in_spa_enabled_;
  RuntimeEnabledFeaturesBase::is_service_worker_bypass_fetch_handler_enabled_ = is_service_worker_bypass_fetch_handler_enabled_;
  RuntimeEnabledFeaturesBase::is_service_worker_client_lifecycle_state_enabled_ = is_service_worker_client_lifecycle_state_enabled_;
  RuntimeEnabledFeaturesBase::is_service_worker_race_network_request_enabled_ = is_service_worker_race_network_request_enabled_;
  RuntimeEnabledFeaturesBase::is_service_worker_static_router_enabled_ = is_service_worker_static_router_enabled_;
  RuntimeEnabledFeaturesBase::is_set_sequential_focus_starting_point_enabled_ = is_set_sequential_focus_starting_point_enabled_;
  RuntimeEnabledFeaturesBase::is_shadow_root_attachment_new_behavior_enabled_ = is_shadow_root_attachment_new_behavior_enabled_;
  RuntimeEnabledFeaturesBase::is_shared_array_buffer_enabled_ = is_shared_array_buffer_enabled_;
  RuntimeEnabledFeaturesBase::is_shared_array_buffer_on_desktop_enabled_ = is_shared_array_buffer_on_desktop_enabled_;
  RuntimeEnabledFeaturesBase::is_shared_array_buffer_unrestricted_access_allowed_enabled_ = is_shared_array_buffer_unrestricted_access_allowed_enabled_;
  RuntimeEnabledFeaturesBase::is_shared_autofill_enabled_ = is_shared_autofill_enabled_;
  RuntimeEnabledFeaturesBase::is_shared_storage_api_enabled_ = is_shared_storage_api_enabled_;
  RuntimeEnabledFeaturesBase::is_shared_storage_api_m_118_enabled_ = is_shared_storage_api_m_118_enabled_;
  RuntimeEnabledFeaturesBase::is_shared_worker_enabled_ = is_shared_worker_enabled_;
  RuntimeEnabledFeaturesBase::is_signature_based_integrity_enabled_ = is_signature_based_integrity_enabled_;
  RuntimeEnabledFeaturesBase::is_site_initiated_mirroring_enabled_ = is_site_initiated_mirroring_enabled_;
  RuntimeEnabledFeaturesBase::is_skip_ad_enabled_ = is_skip_ad_enabled_;
  RuntimeEnabledFeaturesBase::is_skip_touch_event_filter_enabled_ = is_skip_touch_event_filter_enabled_;
  RuntimeEnabledFeaturesBase::is_smart_card_enabled_ = is_smart_card_enabled_;
  RuntimeEnabledFeaturesBase::is_smart_zoom_enabled_ = is_smart_zoom_enabled_;
  RuntimeEnabledFeaturesBase::is_smil_auto_suspend_on_lag_enabled_ = is_smil_auto_suspend_on_lag_enabled_;
  RuntimeEnabledFeaturesBase::is_snap_border_widths_before_layout_enabled_ = is_snap_border_widths_before_layout_enabled_;
  RuntimeEnabledFeaturesBase::is_soft_navigation_detection_enabled_ = is_soft_navigation_detection_enabled_;
  RuntimeEnabledFeaturesBase::is_soft_navigation_heuristics_enabled_ = is_soft_navigation_heuristics_enabled_;
  RuntimeEnabledFeaturesBase::is_soft_navigation_heuristics_expose_fp_and_fcp_enabled_ = is_soft_navigation_heuristics_expose_fp_and_fcp_enabled_;
  RuntimeEnabledFeaturesBase::is_sparse_object_paint_properties_enabled_ = is_sparse_object_paint_properties_enabled_;
  RuntimeEnabledFeaturesBase::is_speculation_rules_document_rules_enabled_ = is_speculation_rules_document_rules_enabled_;
  RuntimeEnabledFeaturesBase::is_speculation_rules_document_rules_selector_matches_enabled_ = is_speculation_rules_document_rules_selector_matches_enabled_;
  RuntimeEnabledFeaturesBase::is_speculation_rules_eagerness_enabled_ = is_speculation_rules_eagerness_enabled_;
  RuntimeEnabledFeaturesBase::is_speculation_rules_fetch_from_header_enabled_ = is_speculation_rules_fetch_from_header_enabled_;
  RuntimeEnabledFeaturesBase::is_speculation_rules_implicit_source_enabled_ = is_speculation_rules_implicit_source_enabled_;
  RuntimeEnabledFeaturesBase::is_speculation_rules_no_vary_search_hint_enabled_ = is_speculation_rules_no_vary_search_hint_enabled_;
  RuntimeEnabledFeaturesBase::is_speculation_rules_no_vary_search_hint_shipped_by_default_enabled_ = is_speculation_rules_no_vary_search_hint_shipped_by_default_enabled_;
  RuntimeEnabledFeaturesBase::is_speculation_rules_pointer_down_heuristics_enabled_ = is_speculation_rules_pointer_down_heuristics_enabled_;
  RuntimeEnabledFeaturesBase::is_speculation_rules_pointer_hover_heuristics_enabled_ = is_speculation_rules_pointer_hover_heuristics_enabled_;
  RuntimeEnabledFeaturesBase::is_speculation_rules_prefetch_future_enabled_ = is_speculation_rules_prefetch_future_enabled_;
  RuntimeEnabledFeaturesBase::is_speculation_rules_prefetch_with_subresources_enabled_ = is_speculation_rules_prefetch_with_subresources_enabled_;
  RuntimeEnabledFeaturesBase::is_speculation_rules_relative_to_document_enabled_ = is_speculation_rules_relative_to_document_enabled_;
  RuntimeEnabledFeaturesBase::is_spell_checker_replace_range_use_insert_text_enabled_ = is_spell_checker_replace_range_use_insert_text_enabled_;
  RuntimeEnabledFeaturesBase::is_srcset_max_density_enabled_ = is_srcset_max_density_enabled_;
  RuntimeEnabledFeaturesBase::is_stable_blink_features_enabled_ = is_stable_blink_features_enabled_;
  RuntimeEnabledFeaturesBase::is_storage_access_api_beyond_cookies_enabled_ = is_storage_access_api_beyond_cookies_enabled_;
  RuntimeEnabledFeaturesBase::is_storage_buckets_enabled_ = is_storage_buckets_enabled_;
  RuntimeEnabledFeaturesBase::is_storage_buckets_durability_enabled_ = is_storage_buckets_durability_enabled_;
  RuntimeEnabledFeaturesBase::is_storage_buckets_locks_enabled_ = is_storage_buckets_locks_enabled_;
  RuntimeEnabledFeaturesBase::is_strict_mime_types_for_workers_enabled_ = is_strict_mime_types_for_workers_enabled_;
  RuntimeEnabledFeaturesBase::is_stylable_select_enabled_ = is_stylable_select_enabled_;
  RuntimeEnabledFeaturesBase::is_stylus_handwriting_enabled_ = is_stylus_handwriting_enabled_;
  RuntimeEnabledFeaturesBase::is_suggestion_picker_dark_mode_support_enabled_ = is_suggestion_picker_dark_mode_support_enabled_;
  RuntimeEnabledFeaturesBase::is_svg_cross_origin_attribute_enabled_ = is_svg_cross_origin_attribute_enabled_;
  RuntimeEnabledFeaturesBase::is_svg_no_pixel_snapping_scale_adjustment_enabled_ = is_svg_no_pixel_snapping_scale_adjustment_enabled_;
  RuntimeEnabledFeaturesBase::is_svg_text_fix_hittest_after_scale_enabled_ = is_svg_text_fix_hittest_after_scale_enabled_;
  RuntimeEnabledFeaturesBase::is_synthesized_keyboard_events_for_accessibility_actions_enabled_ = is_synthesized_keyboard_events_for_accessibility_actions_enabled_;
  RuntimeEnabledFeaturesBase::is_system_wake_lock_enabled_ = is_system_wake_lock_enabled_;
  RuntimeEnabledFeaturesBase::is_test_feature_enabled_ = is_test_feature_enabled_;
  RuntimeEnabledFeaturesBase::is_test_feature_dependent_enabled_ = is_test_feature_dependent_enabled_;
  RuntimeEnabledFeaturesBase::is_test_feature_implied_enabled_ = is_test_feature_implied_enabled_;
  RuntimeEnabledFeaturesBase::is_text_decorating_box_enabled_ = is_text_decorating_box_enabled_;
  RuntimeEnabledFeaturesBase::is_text_detector_enabled_ = is_text_detector_enabled_;
  RuntimeEnabledFeaturesBase::is_text_fragment_api_enabled_ = is_text_fragment_api_enabled_;
  RuntimeEnabledFeaturesBase::is_text_fragment_identifiers_enabled_ = is_text_fragment_identifiers_enabled_;
  RuntimeEnabledFeaturesBase::is_text_fragment_tap_opens_context_menu_enabled_ = is_text_fragment_tap_opens_context_menu_enabled_;
  RuntimeEnabledFeaturesBase::is_text_metrics_baselines_enabled_ = is_text_metrics_baselines_enabled_;
  RuntimeEnabledFeaturesBase::is_timeline_scope_enabled_ = is_timeline_scope_enabled_;
  RuntimeEnabledFeaturesBase::is_timer_throttling_for_background_tabs_enabled_ = is_timer_throttling_for_background_tabs_enabled_;
  RuntimeEnabledFeaturesBase::is_time_zone_change_event_enabled_ = is_time_zone_change_event_enabled_;
  RuntimeEnabledFeaturesBase::is_topics_api_enabled_ = is_topics_api_enabled_;
  RuntimeEnabledFeaturesBase::is_topics_document_api_enabled_ = is_topics_document_api_enabled_;
  RuntimeEnabledFeaturesBase::is_top_level_tpcd_enabled_ = is_top_level_tpcd_enabled_;
  RuntimeEnabledFeaturesBase::is_touch_drag_and_context_menu_enabled_ = is_touch_drag_and_context_menu_enabled_;
  RuntimeEnabledFeaturesBase::is_touch_drag_on_short_press_enabled_ = is_touch_drag_on_short_press_enabled_;
  RuntimeEnabledFeaturesBase::is_touch_event_feature_detection_enabled_ = is_touch_event_feature_detection_enabled_;
  RuntimeEnabledFeaturesBase::is_touch_text_editing_redesign_enabled_ = is_touch_text_editing_redesign_enabled_;
  RuntimeEnabledFeaturesBase::is_tpcd_enabled_ = is_tpcd_enabled_;
  RuntimeEnabledFeaturesBase::is_translate_service_enabled_ = is_translate_service_enabled_;
  RuntimeEnabledFeaturesBase::is_trusted_type_before_policy_creation_event_enabled_ = is_trusted_type_before_policy_creation_event_enabled_;
  RuntimeEnabledFeaturesBase::is_trusted_types_from_literal_enabled_ = is_trusted_types_from_literal_enabled_;
  RuntimeEnabledFeaturesBase::is_trusted_types_use_code_like_enabled_ = is_trusted_types_use_code_like_enabled_;
  RuntimeEnabledFeaturesBase::is_unclosed_form_control_is_invalid_enabled_ = is_unclosed_form_control_is_invalid_enabled_;
  RuntimeEnabledFeaturesBase::is_unexposed_task_ids_enabled_ = is_unexposed_task_ids_enabled_;
  RuntimeEnabledFeaturesBase::is_unowned_animations_skip_css_events_enabled_ = is_unowned_animations_skip_css_events_enabled_;
  RuntimeEnabledFeaturesBase::is_unrestricted_measure_user_agent_specific_memory_enabled_ = is_unrestricted_measure_user_agent_specific_memory_enabled_;
  RuntimeEnabledFeaturesBase::is_unrestricted_shared_array_buffer_enabled_ = is_unrestricted_shared_array_buffer_enabled_;
  RuntimeEnabledFeaturesBase::is_unrestricted_usb_enabled_ = is_unrestricted_usb_enabled_;
  RuntimeEnabledFeaturesBase::is_url_attribute_fix_enabled_ = is_url_attribute_fix_enabled_;
  RuntimeEnabledFeaturesBase::is_url_pattern_compare_component_enabled_ = is_url_pattern_compare_component_enabled_;
  RuntimeEnabledFeaturesBase::is_url_pattern_has_reg_exp_groups_enabled_ = is_url_pattern_has_reg_exp_groups_enabled_;
  RuntimeEnabledFeaturesBase::is_url_pattern_regexp_unicode_sets_mode_enabled_ = is_url_pattern_regexp_unicode_sets_mode_enabled_;
  RuntimeEnabledFeaturesBase::is_url_pattern_wildcard_more_often_enabled_ = is_url_pattern_wildcard_more_often_enabled_;
  RuntimeEnabledFeaturesBase::is_url_search_params_has_and_delete_multiple_args_enabled_ = is_url_search_params_has_and_delete_multiple_args_enabled_;
  RuntimeEnabledFeaturesBase::is_use_begin_frame_presentation_feedback_enabled_ = is_use_begin_frame_presentation_feedback_enabled_;
  RuntimeEnabledFeaturesBase::is_used_color_scheme_root_scrollbars_enabled_ = is_used_color_scheme_root_scrollbars_enabled_;
  RuntimeEnabledFeaturesBase::is_user_activation_same_origin_visibility_enabled_ = is_user_activation_same_origin_visibility_enabled_;
  RuntimeEnabledFeaturesBase::is_user_valid_user_invalid_enabled_ = is_user_valid_user_invalid_enabled_;
  RuntimeEnabledFeaturesBase::is_v8_idle_tasks_enabled_ = is_v8_idle_tasks_enabled_;
  RuntimeEnabledFeaturesBase::is_video_auto_fullscreen_enabled_ = is_video_auto_fullscreen_enabled_;
  RuntimeEnabledFeaturesBase::is_video_fullscreen_orientation_lock_enabled_ = is_video_fullscreen_orientation_lock_enabled_;
  RuntimeEnabledFeaturesBase::is_video_playback_quality_enabled_ = is_video_playback_quality_enabled_;
  RuntimeEnabledFeaturesBase::is_video_rotate_to_fullscreen_enabled_ = is_video_rotate_to_fullscreen_enabled_;
  RuntimeEnabledFeaturesBase::is_video_track_generator_enabled_ = is_video_track_generator_enabled_;
  RuntimeEnabledFeaturesBase::is_video_track_generator_in_window_enabled_ = is_video_track_generator_in_window_enabled_;
  RuntimeEnabledFeaturesBase::is_video_track_generator_in_worker_enabled_ = is_video_track_generator_in_worker_enabled_;
  RuntimeEnabledFeaturesBase::is_viewport_height_client_hint_header_enabled_ = is_viewport_height_client_hint_header_enabled_;
  RuntimeEnabledFeaturesBase::is_viewport_segments_enabled_ = is_viewport_segments_enabled_;
  RuntimeEnabledFeaturesBase::is_view_transition_on_navigation_enabled_ = is_view_transition_on_navigation_enabled_;
  RuntimeEnabledFeaturesBase::is_view_transition_types_enabled_ = is_view_transition_types_enabled_;
  RuntimeEnabledFeaturesBase::is_visibility_collapse_column_enabled_ = is_visibility_collapse_column_enabled_;
  RuntimeEnabledFeaturesBase::is_wake_lock_enabled_ = is_wake_lock_enabled_;
  RuntimeEnabledFeaturesBase::is_warn_on_content_visibility_render_access_enabled_ = is_warn_on_content_visibility_render_access_enabled_;
  RuntimeEnabledFeaturesBase::is_web_animations_svg_enabled_ = is_web_animations_svg_enabled_;
  RuntimeEnabledFeaturesBase::is_web_app_dark_mode_enabled_ = is_web_app_dark_mode_enabled_;
  RuntimeEnabledFeaturesBase::is_web_app_launch_handler_enabled_ = is_web_app_launch_handler_enabled_;
  RuntimeEnabledFeaturesBase::is_web_app_launch_queue_enabled_ = is_web_app_launch_queue_enabled_;
  RuntimeEnabledFeaturesBase::is_web_app_scope_extensions_enabled_ = is_web_app_scope_extensions_enabled_;
  RuntimeEnabledFeaturesBase::is_web_apps_lock_screen_enabled_ = is_web_apps_lock_screen_enabled_;
  RuntimeEnabledFeaturesBase::is_web_app_tab_strip_enabled_ = is_web_app_tab_strip_enabled_;
  RuntimeEnabledFeaturesBase::is_web_app_tab_strip_customizations_enabled_ = is_web_app_tab_strip_customizations_enabled_;
  RuntimeEnabledFeaturesBase::is_web_app_translations_enabled_ = is_web_app_translations_enabled_;
  RuntimeEnabledFeaturesBase::is_web_app_url_handling_enabled_ = is_web_app_url_handling_enabled_;
  RuntimeEnabledFeaturesBase::is_web_app_window_controls_overlay_enabled_ = is_web_app_window_controls_overlay_enabled_;
  RuntimeEnabledFeaturesBase::is_web_assembly_js_string_builtins_enabled_ = is_web_assembly_js_string_builtins_enabled_;
  RuntimeEnabledFeaturesBase::is_web_auth_enabled_ = is_web_auth_enabled_;
  RuntimeEnabledFeaturesBase::is_web_auth_allow_create_in_cross_origin_frame_enabled_ = is_web_auth_allow_create_in_cross_origin_frame_enabled_;
  RuntimeEnabledFeaturesBase::is_web_auth_authenticator_attachment_enabled_ = is_web_auth_authenticator_attachment_enabled_;
  RuntimeEnabledFeaturesBase::is_web_authentication_hints_enabled_ = is_web_authentication_hints_enabled_;
  RuntimeEnabledFeaturesBase::is_web_authentication_js_on_serialization_enabled_ = is_web_authentication_js_on_serialization_enabled_;
  RuntimeEnabledFeaturesBase::is_web_authentication_large_blob_extension_enabled_ = is_web_authentication_large_blob_extension_enabled_;
  RuntimeEnabledFeaturesBase::is_web_authentication_prf_enabled_ = is_web_authentication_prf_enabled_;
  RuntimeEnabledFeaturesBase::is_web_authentication_remote_desktop_support_enabled_ = is_web_authentication_remote_desktop_support_enabled_;
  RuntimeEnabledFeaturesBase::is_web_authentication_supplemental_pub_keys_enabled_ = is_web_authentication_supplemental_pub_keys_enabled_;
  RuntimeEnabledFeaturesBase::is_web_bluetooth_enabled_ = is_web_bluetooth_enabled_;
  RuntimeEnabledFeaturesBase::is_web_bluetooth_get_devices_enabled_ = is_web_bluetooth_get_devices_enabled_;
  RuntimeEnabledFeaturesBase::is_web_bluetooth_scanning_enabled_ = is_web_bluetooth_scanning_enabled_;
  RuntimeEnabledFeaturesBase::is_web_bluetooth_watch_advertisements_enabled_ = is_web_bluetooth_watch_advertisements_enabled_;
  RuntimeEnabledFeaturesBase::is_webcodecs_content_hint_enabled_ = is_webcodecs_content_hint_enabled_;
  RuntimeEnabledFeaturesBase::is_webcodecs_copy_to_rgb_enabled_ = is_webcodecs_copy_to_rgb_enabled_;
  RuntimeEnabledFeaturesBase::is_web_crypto_curve_25519_enabled_ = is_web_crypto_curve_25519_enabled_;
  RuntimeEnabledFeaturesBase::is_web_font_resize_lcp_enabled_ = is_web_font_resize_lcp_enabled_;
  RuntimeEnabledFeaturesBase::is_webgl_developer_extensions_enabled_ = is_webgl_developer_extensions_enabled_;
  RuntimeEnabledFeaturesBase::is_webgl_draft_extensions_enabled_ = is_webgl_draft_extensions_enabled_;
  RuntimeEnabledFeaturesBase::is_webgl_drawing_buffer_storage_enabled_ = is_webgl_drawing_buffer_storage_enabled_;
  RuntimeEnabledFeaturesBase::is_webgl_image_chromium_enabled_ = is_webgl_image_chromium_enabled_;
  RuntimeEnabledFeaturesBase::is_webgpu_developer_features_enabled_ = is_webgpu_developer_features_enabled_;
  RuntimeEnabledFeaturesBase::is_web_hid_enabled_ = is_web_hid_enabled_;
  RuntimeEnabledFeaturesBase::is_web_hid_on_service_workers_enabled_ = is_web_hid_on_service_workers_enabled_;
  RuntimeEnabledFeaturesBase::is_web_identity_digital_credentials_enabled_ = is_web_identity_digital_credentials_enabled_;
  RuntimeEnabledFeaturesBase::is_web_idl_big_int_uses_to_big_int_enabled_ = is_web_idl_big_int_uses_to_big_int_enabled_;
  RuntimeEnabledFeaturesBase::is_web_kit_scrollbar_styling_enabled_ = is_web_kit_scrollbar_styling_enabled_;
  RuntimeEnabledFeaturesBase::is_web_nfc_enabled_ = is_web_nfc_enabled_;
  RuntimeEnabledFeaturesBase::is_web_otp_enabled_ = is_web_otp_enabled_;
  RuntimeEnabledFeaturesBase::is_web_otp_assertion_feature_policy_enabled_ = is_web_otp_assertion_feature_policy_enabled_;
  RuntimeEnabledFeaturesBase::is_web_preferences_enabled_ = is_web_preferences_enabled_;
  RuntimeEnabledFeaturesBase::is_web_printing_enabled_ = is_web_printing_enabled_;
  RuntimeEnabledFeaturesBase::is_web_serial_bluetooth_enabled_ = is_web_serial_bluetooth_enabled_;
  RuntimeEnabledFeaturesBase::is_web_share_enabled_ = is_web_share_enabled_;
  RuntimeEnabledFeaturesBase::is_websocket_stream_enabled_ = is_websocket_stream_enabled_;
  RuntimeEnabledFeaturesBase::is_web_transport_custom_certificates_enabled_ = is_web_transport_custom_certificates_enabled_;
  RuntimeEnabledFeaturesBase::is_web_usb_enabled_ = is_web_usb_enabled_;
  RuntimeEnabledFeaturesBase::is_web_usb_on_dedicated_workers_enabled_ = is_web_usb_on_dedicated_workers_enabled_;
  RuntimeEnabledFeaturesBase::is_web_usb_on_service_workers_enabled_ = is_web_usb_on_service_workers_enabled_;
  RuntimeEnabledFeaturesBase::is_web_view_xr_equested_with_deprecation_enabled_ = is_web_view_xr_equested_with_deprecation_enabled_;
  RuntimeEnabledFeaturesBase::is_web_vtt_regions_enabled_ = is_web_vtt_regions_enabled_;
  RuntimeEnabledFeaturesBase::is_web_xr_enabled_ = is_web_xr_enabled_;
  RuntimeEnabledFeaturesBase::is_web_xr_enabled_features_enabled_ = is_web_xr_enabled_features_enabled_;
  RuntimeEnabledFeaturesBase::is_web_xr_frame_rate_enabled_ = is_web_xr_frame_rate_enabled_;
  RuntimeEnabledFeaturesBase::is_web_xr_front_facing_enabled_ = is_web_xr_front_facing_enabled_;
  RuntimeEnabledFeaturesBase::is_web_xr_hand_input_enabled_ = is_web_xr_hand_input_enabled_;
  RuntimeEnabledFeaturesBase::is_web_xr_hit_test_entity_types_enabled_ = is_web_xr_hit_test_entity_types_enabled_;
  RuntimeEnabledFeaturesBase::is_web_xr_image_tracking_enabled_ = is_web_xr_image_tracking_enabled_;
  RuntimeEnabledFeaturesBase::is_web_xr_layers_enabled_ = is_web_xr_layers_enabled_;
  RuntimeEnabledFeaturesBase::is_web_xr_plane_detection_enabled_ = is_web_xr_plane_detection_enabled_;
  RuntimeEnabledFeaturesBase::is_web_xr_pose_motion_data_enabled_ = is_web_xr_pose_motion_data_enabled_;
  RuntimeEnabledFeaturesBase::is_wgi_gamepad_trigger_rumble_enabled_ = is_wgi_gamepad_trigger_rumble_enabled_;
  RuntimeEnabledFeaturesBase::is_window_default_status_enabled_ = is_window_default_status_enabled_;
  RuntimeEnabledFeaturesBase::is_window_placement_fullscreen_on_screens_change_enabled_ = is_window_placement_fullscreen_on_screens_change_enabled_;
  RuntimeEnabledFeaturesBase::is_window_placement_permission_alias_enabled_ = is_window_placement_permission_alias_enabled_;
  RuntimeEnabledFeaturesBase::is_xml_parser_merge_adjacent_c_data_sections_enabled_ = is_xml_parser_merge_adjacent_c_data_sections_enabled_;
  RuntimeEnabledFeaturesBase::is_xywh_and_rect_computed_value_enabled_ = is_xywh_and_rect_computed_value_enabled_;
  RuntimeEnabledFeaturesBase::is_zero_copy_tab_capture_enabled_ = is_zero_copy_tab_capture_enabled_;
}

void RuntimeEnabledFeaturesBase::SetStableFeaturesEnabled(bool enable) {
  SetAccelerated2dCanvasEnabled(enable);
  SetAcceleratedSmallCanvasesEnabled(enable);
  SetAccordionPatternEnabled(enable);
  SetAnonymousIframeEnabled(enable);
  SetArrowKeysInVerticalWritingModesEnabled(enable);
  SetAsyncClipboardImplicitPermissionEnabled(enable);
  SetAudioContextSetSinkIdEnabled(enable);
  SetAvoidCaretVisibleSelectionAdjusterEnabled(enable);
  SetBackdropInheritOriginatingEnabled(enable);
  SetBackgroundFetchEnabled(enable);
  SetBdiElementDirInheritanceEnabled(enable);
  SetBeforeunloadEventCancelByPreventDefaultEnabled(enable);
  SetBlockRubyConsoleMessageEnabled(enable);
  SetBlockRubyWrappingInlineRubyEnabled(enable);
  SetByobFetchEnabled(enable);
  SetCanonicalizeWhitespaceStringsEnabled(enable);
  SetCheckVisibilityExtraPropertiesEnabled(enable);
  SetClipboardSupportedTypesEnabled(enable);
  SetClipboardUnsanitizedContentEnabled(enable);
  SetClipboardWellFormedHtmlSanitizationWriteEnabled(enable);
  SetClipPathGeometryBoxEnabled(enable);
  SetClipPathRejectEmptyPathsEnabled(enable);
  SetClipPathXYWHAndRectEnabled(enable);
  SetCounterStyleChangeShouleCollectInlinesEnabled(enable);
  SetCSSAnimationCompositionEnabled(enable);
  SetCSSBackgroundClipUnprefixEnabled(enable);
  SetCSSCapFontUnitsEnabled(enable);
  SetCSSContentVisibilityImpliesContainIntrinsicSizeAutoEnabled(enable);
  SetCSSDisplayAnimationEnabled(enable);
  SetCssDisplayRubyEnabled(enable);
  SetCSSExponentialFunctionsEnabled(enable);
  SetCSSFirstLetterNoNewLineAsPrecedingCharEnabled(enable);
  SetCSSHexAlphaColorEnabled(enable);
  SetCSSLinearTimingFunctionEnabled(enable);
  SetCSSMaskingInteropEnabled(enable);
  SetCSSMPCImprovementsEnabled(enable);
  SetCSSNestingIdentEnabled(enable);
  SetCSSNumericFactoryCompletenessEnabled(enable);
  SetCSSOffsetPathBasicShapesCircleAndEllipseEnabled(enable);
  SetCSSOffsetPathBasicShapesRectanglesAndPolygonEnabled(enable);
  SetCSSOffsetPathCoordBoxEnabled(enable);
  SetCSSOffsetPathRayEnabled(enable);
  SetCSSOffsetPathRayContainEnabled(enable);
  SetCSSOffsetPathUrlEnabled(enable);
  SetCSSOffsetPositionAnchorEnabled(enable);
  SetCSSOverflowMediaFeaturesEnabled(enable);
  SetCSSPhraseLineBreakEnabled(enable);
  SetCSSPseudoDirEnabled(enable);
  SetCSSRelativeColorEnabled(enable);
  SetCSSResizeAutoEnabled(enable);
  SetCSSScopeEnabled(enable);
  SetCSSSelectorNthChildComplexSelectorEnabled(enable);
  SetCSSSpellingGrammarErrorsEnabled(enable);
  SetCSSSupportsForImportRulesEnabled(enable);
  SetCSSTextWrapBalanceByScoreEnabled(enable);
  SetCSSTextWrapPrettyEnabled(enable);
  SetCSSTransitionDiscreteEnabled(enable);
  SetCSSUnknownContainerQueriesNoSelectionEnabled(enable);
  SetCSSUpdateMediaFeatureEnabled(enable);
  SetCSSVariables2ImageValuesEnabled(enable);
  SetCSSVariables2TransformValuesEnabled(enable);
  SetCSSViewportUnits4Enabled(enable);
  SetCSSViewTimelineInsetShorthandEnabled(enable);
  SetCustomElementsGetNameEnabled(enable);
  SetDataTransferClearStringItemsEnabled(enable);
  SetDateInputInlineBlockEnabled(enable);
  SetDetailsElementToggleEventEnabled(enable);
  SetDirnameMoreInputTypesEnabled(enable);
  SetDisableSelectAllForEmptyTextEnabled(enable);
  SetDispatchHiddenVisibilityTransitionsEnabled(enable);
  SetDocumentBaseURIFixEnabled(enable);
  SetDocumentOpenSandboxInheritanceRemovalEnabled(enable);
  SetDontFireDblclickOnDisabledFormControlsEnabled(enable);
  SetEditContextEnabled(enable);
  SetEmptyClipboardReadEnabled(enable);
  SetEnforceAnonymityExposureEnabled(enable);
  SetExcludeBrokenImageIconFromBeingLcpEligibleEnabled(enable);
  SetFedCmEnabled(enable);
  SetFedCmAutoSelectedFlagEnabled(enable);
  SetFedCmDisconnectEnabled(enable);
  SetFedCmErrorEnabled(enable);
  SetFedCmIdpSigninStatusEnabled(enable);
  SetFetchUploadStreamingEnabled(enable);
  SetFileSystemEnabled(enable);
  SetFileSystemAccessLockingSchemeEnabled(enable);
  SetFileSystemAccessOriginPrivateEnabled(enable);
  SetFledgeClearOriginJoinedAdInterestGroupsEnabled(enable);
  SetFledgeDirectFromSellerSignalsHeaderAdSlotEnabled(enable);
  SetFledgeNegativeTargetingEnabled(enable);
  SetFlushParserBeforeCreatingCustomElementsEnabled(enable);
  SetFocusStyleInvalidationOnPageActivationEnabled(enable);
  SetFontMatchingCTMigrationEnabled(enable);
  SetFontPaletteAnimationEnabled(enable);
  SetForcedColorsEnabled(enable);
  SetForcedColorsPreserveParentColorEnabled(enable);
  SetFormControlsVerticalWritingModeSupportEnabled(enable);
  SetFormControlsVerticalWritingModeTextSupportEnabled(enable);
  SetFormStateRestoreCallbackCallWithStateEnabled(enable);
  SetHangingWhitespaceDoesNotDependOnAlignmentEnabled(enable);
  SetHasUAVisualTransitionEnabled(enable);
  SetHrefTranslateEnabled(enable);
  SetHTMLLangNewInheritanceEnabled(enable);
  SetHTMLParserFastPathBulkInsertNotifyEnabled(enable);
  SetHTMLSearchElementEnabled(enable);
  SetHTMLSelectElementShowPickerEnabled(enable);
  SetImportAttributesDisallowUnknownKeysEnabled(enable);
  SetInertDisplayTransitionEnabled(enable);
  SetInheritUserModifyWithoutContenteditableEnabled(enable);
  SetInstalledAppEnabled(enable);
  SetInterruptComposedScrollbarDisappearanceEnabled(enable);
  SetIntersectionObserverScrollMarginEnabled(enable);
  SetInvisibleSVGAnimationThrottlingEnabled(enable);
  SetLayoutAlignForPositionedEnabled(enable);
  SetLayoutNewContainingBlockEnabled(enable);
  SetLayoutNewMeasureCacheEnabled(enable);
  SetLayoutNewMinMaxCacheEnabled(enable);
  SetLazyLoadScrollMarginEnabled(enable);
  SetMacFontsDeprecateFontTraitsWorkaroundEnabled(enable);
  SetManagedConfigurationEnabled(enable);
  SetMeasureMemoryEnabled(enable);
  SetMediaCapabilitiesDynamicRangeEnabled(enable);
  SetMediaSessionEnabled(enable);
  SetMediaSessionEnterPictureInPictureEnabled(enable);
  SetMonitorTypeSurfacesEnabled(enable);
  SetMouseDragFromIframeOnCancelledMouseDownEnabled(enable);
  SetMutationEventsEnabled(enable);
  SetNextSiblingPositionUseNextCandidateEnabled(enable);
  SetNonComposedEnterLeaveEventsEnabled(enable);
  SetNonStandardAppearanceValuesHighUsageEnabled(enable);
  SetNonStandardAppearanceValueSliderVerticalEnabled(enable);
  SetNoOffsetMappingForInconsistentTextEnabled(enable);
  SetNotificationsEnabled(enable);
  SetOffMainThreadCSSPaintEnabled(enable);
  SetOptionElementAlwaysUseLabelEnabled(enable);
  SetOriginIsolationHeaderEnabled(enable);
  SetPastingBlocksSVGUseNonLocalHrefsEnabled(enable);
  SetPaymentHandlerMinimalHeaderUXEnabled(enable);
  SetPaymentMethodChangeEventEnabled(enable);
  SetPaymentRequestAllowOneActivationlessShowEnabled(enable);
  SetPeriodicBackgroundSyncEnabled(enable);
  SetPermissionsEnabled(enable);
  SetPointerCaptureLostOnRemovalDuringCaptureEnabled(enable);
  SetPositionOutsideTabSpanCheckSiblingNodeEnabled(enable);
  SetPrefixedVideoFullscreenEnabled(enable);
  SetPrePaintAncestorsOfMissedOOFEnabled(enable);
  SetPrerender2Enabled(enable);
  SetPresentationEnabled(enable);
  SetPreventReadingSystemAccentColorEnabled(enable);
  SetPushMessagingEnabled(enable);
  SetQuickIntensiveWakeUpThrottlingAfterLoadingEnabled(enable);
  SetReadableStreamTeeCloneForBranch2Enabled(enable);
  SetReduceUserAgentMinorVersionEnabled(enable);
  SetReferenceBoxNoPixelSnappingEnabled(enable);
  SetRemotePlaybackEnabled(enable);
  SetRemoveDanglingMarkupInTargetEnabled(enable);
  SetRemoveDataUrlInSvgUseEnabled(enable);
  SetRemoveMobileViewportDoubleTapEnabled(enable);
  SetRenderBlockingStatusEnabled(enable);
  SetRewindFloatsEnabled(enable);
  SetRTCRtpEncodingParametersCodecEnabled(enable);
  SetRTCRtpHeaderExtensionControlEnabled(enable);
  SetRTCSvcScalabilityModeEnabled(enable);
  SetRubyInlinifyEnabled(enable);
  SetRubySimplePairingEnabled(enable);
  SetRunMicrotaskBeforeXmlCustomElementEnabled(enable);
  SetScriptedSpeechRecognitionEnabled(enable);
  SetScriptedSpeechSynthesisEnabled(enable);
  SetScrollbarColorEnabled(enable);
  SetScrollbarWidthEnabled(enable);
  SetScrollEndEventsEnabled(enable);
  SetScrollTimelineEnabled(enable);
  SetScrollTimelineOnCompositorEnabled(enable);
  SetScrollTopLeftInteropEnabled(enable);
  SetSecurePaymentConfirmationAllowOneActivationlessShowEnabled(enable);
  SetSecurePaymentConfirmationExtensionsEnabled(enable);
  SetSecurePaymentConfirmationOptOutEnabled(enable);
  SetSelectHrEnabled(enable);
  SetSendBeaconThrowForBlobWithNonSimpleTypeEnabled(enable);
  SetShadowRootAttachmentNewBehaviorEnabled(enable);
  SetSkipTouchEventFilterEnabled(enable);
  SetSmilAutoSuspendOnLagEnabled(enable);
  SetSnapBorderWidthsBeforeLayoutEnabled(enable);
  SetSoftNavigationDetectionEnabled(enable);
  SetSpeculationRulesDocumentRulesEnabled(enable);
  SetSpeculationRulesDocumentRulesSelectorMatchesEnabled(enable);
  SetSpeculationRulesEagernessEnabled(enable);
  SetSpeculationRulesFetchFromHeaderEnabled(enable);
  SetSpeculationRulesImplicitSourceEnabled(enable);
  SetSpeculationRulesNoVarySearchHintShippedByDefaultEnabled(enable);
  SetSpeculationRulesRelativeToDocumentEnabled(enable);
  SetSpellCheckerReplaceRangeUseInsertTextEnabled(enable);
  SetStableBlinkFeaturesEnabled(enable);
  SetStorageBucketsEnabled(enable);
  SetSuggestionPickerDarkModeSupportEnabled(enable);
  SetSvgCrossOriginAttributeEnabled(enable);
  SetSvgNoPixelSnappingScaleAdjustmentEnabled(enable);
  SetSvgTextFixHittestAfterScaleEnabled(enable);
  SetTextDecoratingBoxEnabled(enable);
  SetTextFragmentIdentifiersEnabled(enable);
  SetTextMetricsBaselinesEnabled(enable);
  SetTimelineScopeEnabled(enable);
  SetTimerThrottlingForBackgroundTabsEnabled(enable);
  SetTouchEventFeatureDetectionEnabled(enable);
  SetUnownedAnimationsSkipCSSEventsEnabled(enable);
  SetURLAttributeFixEnabled(enable);
  SetURLPatternHasRegExpGroupsEnabled(enable);
  SetURLPatternRegexpUnicodeSetsModeEnabled(enable);
  SetURLPatternWildcardMoreOftenEnabled(enable);
  SetURLSearchParamsHasAndDeleteMultipleArgsEnabled(enable);
  SetUserValidUserInvalidEnabled(enable);
  SetVideoPlaybackQualityEnabled(enable);
  SetViewportHeightClientHintHeaderEnabled(enable);
  SetWakeLockEnabled(enable);
  SetWebAppWindowControlsOverlayEnabled(enable);
  SetWebAuthEnabled(enable);
  SetWebAuthenticationLargeBlobExtensionEnabled(enable);
  SetWebAuthenticationPRFEnabled(enable);
  SetWebCodecsContentHintEnabled(enable);
  SetWebGLDrawingBufferStorageEnabled(enable);
  SetWebIDLBigIntUsesToBigIntEnabled(enable);
  SetWebKitScrollbarStylingEnabled(enable);
  SetWebOTPEnabled(enable);
  SetWebOTPAssertionFeaturePolicyEnabled(enable);
  SetWebSerialBluetoothEnabled(enable);
  SetWebTransportCustomCertificatesEnabled(enable);
  SetWebUSBEnabled(enable);
  SetWebUSBOnDedicatedWorkersEnabled(enable);
  SetWebXREnabled(enable);
  SetWebXREnabledFeaturesEnabled(enable);
  SetWindowPlacementPermissionAliasEnabled(enable);
  SetXMLParserMergeAdjacentCDataSectionsEnabled(enable);
  SetXYWHAndRectComputedValueEnabled(enable);

  // Platform-dependent features
#if BUILDFLAG(IS_ANDROID)
  SetBarcodeDetectorEnabled(enable);
  SetCompositedSelectionUpdateEnabled(enable);
  SetCompositionForegroundMarkersEnabled(enable);
  SetContactsManagerEnabled(enable);
  SetContactsManagerExtraPropertiesEnabled(enable);
  SetContentIndexEnabled(enable);
  SetDigitalGoodsEnabled(enable);
  SetDigitalGoodsV2_1Enabled(enable);
  SetImplicitRootScrollerEnabled(enable);
  SetMediaCaptureEnabled(enable);
  SetMediaControlsOverlayPlayButtonEnabled(enable);
  SetNetInfoDownlinkMaxEnabled(enable);
  SetNotificationContentImageEnabled(enable);
  SetOrientationEventEnabled(enable);
  SetReduceUserAgentAndroidVersionDeviceModelEnabled(enable);
  SetRemotePlaybackBackendEnabled(enable);
  SetTextFragmentTapOpensContextMenuEnabled(enable);
  SetWebBluetoothEnabled(enable);
  SetWebNFCEnabled(enable);
#endif

#if BUILDFLAG(IS_WIN)
  SetAudioOutputDevicesEnabled(enable);
  SetCaptureControllerEnabled(enable);
  SetCaptureHandleEnabled(enable);
  SetDocumentPictureInPictureAPIEnabled(enable);
  SetEyeDropperAPIEnabled(enable);
  SetFileHandlingEnabled(enable);
  SetFileSystemAccessLocalEnabled(enable);
  SetFontAccessEnabled(enable);
  SetGetDisplayMediaEnabled(enable);
  SetInputMultipleFieldsUIEnabled(enable);
  SetInsertLineBreakIfPhrasingContentEnabled(enable);
  SetNavigatorContentUtilsEnabled(enable);
  SetNotificationConstructorEnabled(enable);
  SetNotificationContentImageEnabled(enable);
  SetOnDeviceChangeEnabled(enable);
  SetPagePopupEnabled(enable);
  SetReduceUserAgentPlatformOsCpuEnabled(enable);
  SetRegionCaptureEnabled(enable);
  SetRemotePlaybackBackendEnabled(enable);
  SetSerialEnabled(enable);
  SetSharedWorkerEnabled(enable);
  SetWebAppLaunchHandlerEnabled(enable);
  SetWebBluetoothEnabled(enable);
  SetWebHIDEnabled(enable);
#endif

#if BUILDFLAG(IS_CHROMEOS_ASH)
  SetAudioOutputDevicesEnabled(enable);
  SetBarcodeDetectorEnabled(enable);
  SetCaptureControllerEnabled(enable);
  SetCaptureHandleEnabled(enable);
  SetDeviceAttributesEnabled(enable);
  SetDigitalGoodsEnabled(enable);
  SetDigitalGoodsV2_1Enabled(enable);
  SetDocumentPictureInPictureAPIEnabled(enable);
  SetEyeDropperAPIEnabled(enable);
  SetFileHandlingEnabled(enable);
  SetFileSystemAccessLocalEnabled(enable);
  SetFontAccessEnabled(enable);
  SetForceTallerSelectPopupEnabled(enable);
  SetGetDisplayMediaEnabled(enable);
  SetHandwritingRecognitionEnabled(enable);
  SetInputMultipleFieldsUIEnabled(enable);
  SetInsertLineBreakIfPhrasingContentEnabled(enable);
  SetNavigatorContentUtilsEnabled(enable);
  SetNetInfoDownlinkMaxEnabled(enable);
  SetNotificationConstructorEnabled(enable);
  SetNotificationContentImageEnabled(enable);
  SetOnDeviceChangeEnabled(enable);
  SetPagePopupEnabled(enable);
  SetReduceUserAgentPlatformOsCpuEnabled(enable);
  SetRegionCaptureEnabled(enable);
  SetSerialEnabled(enable);
  SetSharedWorkerEnabled(enable);
  SetUseBeginFramePresentationFeedbackEnabled(enable);
  SetWebAppLaunchHandlerEnabled(enable);
  SetWebBluetoothEnabled(enable);
  SetWebHIDEnabled(enable);
#endif

#if BUILDFLAG(IS_CHROMEOS_LACROS)
  SetAudioOutputDevicesEnabled(enable);
  SetBarcodeDetectorEnabled(enable);
  SetCaptureControllerEnabled(enable);
  SetCaptureHandleEnabled(enable);
  SetDeviceAttributesEnabled(enable);
  SetDigitalGoodsEnabled(enable);
  SetDigitalGoodsV2_1Enabled(enable);
  SetDocumentPictureInPictureAPIEnabled(enable);
  SetEyeDropperAPIEnabled(enable);
  SetFileHandlingEnabled(enable);
  SetFileSystemAccessLocalEnabled(enable);
  SetFontAccessEnabled(enable);
  SetForceTallerSelectPopupEnabled(enable);
  SetGetDisplayMediaEnabled(enable);
  SetHandwritingRecognitionEnabled(enable);
  SetInputMultipleFieldsUIEnabled(enable);
  SetInsertLineBreakIfPhrasingContentEnabled(enable);
  SetNavigatorContentUtilsEnabled(enable);
  SetNetInfoDownlinkMaxEnabled(enable);
  SetNotificationConstructorEnabled(enable);
  SetNotificationContentImageEnabled(enable);
  SetOnDeviceChangeEnabled(enable);
  SetPagePopupEnabled(enable);
  SetReduceUserAgentPlatformOsCpuEnabled(enable);
  SetRegionCaptureEnabled(enable);
  SetSerialEnabled(enable);
  SetSharedWorkerEnabled(enable);
  SetUseBeginFramePresentationFeedbackEnabled(enable);
  SetWebAppLaunchHandlerEnabled(enable);
  SetWebBluetoothEnabled(enable);
  SetWebHIDEnabled(enable);
#endif

#if BUILDFLAG(IS_MAC)
  SetAudioOutputDevicesEnabled(enable);
  SetBarcodeDetectorEnabled(enable);
  SetCaptureControllerEnabled(enable);
  SetCaptureHandleEnabled(enable);
  SetDocumentPictureInPictureAPIEnabled(enable);
  SetEyeDropperAPIEnabled(enable);
  SetFileHandlingEnabled(enable);
  SetFileSystemAccessLocalEnabled(enable);
  SetFontAccessEnabled(enable);
  SetGetDisplayMediaEnabled(enable);
  SetInputMultipleFieldsUIEnabled(enable);
  SetInsertLineBreakIfPhrasingContentEnabled(enable);
  SetNavigatorContentUtilsEnabled(enable);
  SetNotificationConstructorEnabled(enable);
  SetOnDeviceChangeEnabled(enable);
  SetPagePopupEnabled(enable);
  SetReduceUserAgentPlatformOsCpuEnabled(enable);
  SetRegionCaptureEnabled(enable);
  SetRemotePlaybackBackendEnabled(enable);
  SetSerialEnabled(enable);
  SetSharedWorkerEnabled(enable);
  SetWebAppLaunchHandlerEnabled(enable);
  SetWebBluetoothEnabled(enable);
  SetWebHIDEnabled(enable);
#endif

#if BUILDFLAG(IS_LINUX)
  SetAudioOutputDevicesEnabled(enable);
  SetCaptureControllerEnabled(enable);
  SetCaptureHandleEnabled(enable);
  SetDocumentPictureInPictureAPIEnabled(enable);
  SetEyeDropperAPIEnabled(enable);
  SetFileHandlingEnabled(enable);
  SetFileSystemAccessLocalEnabled(enable);
  SetFontAccessEnabled(enable);
  SetGetDisplayMediaEnabled(enable);
  SetInputMultipleFieldsUIEnabled(enable);
  SetInsertLineBreakIfPhrasingContentEnabled(enable);
  SetNavigatorContentUtilsEnabled(enable);
  SetNotificationConstructorEnabled(enable);
  SetNotificationContentImageEnabled(enable);
  SetOnDeviceChangeEnabled(enable);
  SetPagePopupEnabled(enable);
  SetReduceUserAgentPlatformOsCpuEnabled(enable);
  SetRegionCaptureEnabled(enable);
  SetRemotePlaybackBackendEnabled(enable);
  SetSerialEnabled(enable);
  SetSharedWorkerEnabled(enable);
  SetWebAppLaunchHandlerEnabled(enable);
  SetWebHIDEnabled(enable);
#endif

  // Default values for platforms not specifically handled above
#if !BUILDFLAG(IS_ANDROID) && !BUILDFLAG(IS_WIN) && !BUILDFLAG(IS_CHROMEOS_ASH) && !BUILDFLAG(IS_CHROMEOS_LACROS) && !BUILDFLAG(IS_MAC) && !BUILDFLAG(IS_LINUX)
  SetAudioOutputDevicesEnabled(enable);
  SetCaptureControllerEnabled(enable);
  SetCaptureHandleEnabled(enable);
  SetDocumentPictureInPictureAPIEnabled(enable);
  SetFileHandlingEnabled(enable);
  SetFileSystemAccessLocalEnabled(enable);
  SetFontAccessEnabled(enable);
  SetGetDisplayMediaEnabled(enable);
  SetInputMultipleFieldsUIEnabled(enable);
  SetInsertLineBreakIfPhrasingContentEnabled(enable);
  SetNavigatorContentUtilsEnabled(enable);
  SetNotificationConstructorEnabled(enable);
  SetNotificationContentImageEnabled(enable);
  SetOnDeviceChangeEnabled(enable);
  SetPagePopupEnabled(enable);
  SetReduceUserAgentPlatformOsCpuEnabled(enable);
  SetRegionCaptureEnabled(enable);
  SetSerialEnabled(enable);
  SetSharedWorkerEnabled(enable);
  SetWebAppLaunchHandlerEnabled(enable);
  SetWebHIDEnabled(enable);
#endif
}

void RuntimeEnabledFeaturesBase::SetExperimentalFeaturesEnabled(bool enable) {
  SetAccessibilityAriaVirtualContentEnabled(enable);
  SetAccessibilityObjectModelEnabled(enable);
  SetAccessibilityOSLevelBoldTextEnabled(enable);
  SetAccessibilitySerializationSizeMetricsEnabled(enable);
  SetAddressSpaceEnabled(enable);
  SetAlignContentForBlocksEnabled(enable);
  SetAOMAriaRelationshipPropertiesEnabled(enable);
  SetAppTitleEnabled(enable);
  SetAttributionReportingEnabled(enable);
  SetAudioVideoTracksEnabled(enable);
  SetAutoSizeLazyLoadedImagesEnabled(enable);
  SetBackForwardCacheExperimentHTTPHeaderEnabled(enable);
  SetBackForwardCacheNotRestoredReasonsEnabled(enable);
  SetBlockingFocusWithoutUserActivationEnabled(enable);
  SetBoundaryEventDispatchTracksNodeRemovalEnabled(enable);
  SetCacheStorageCodeCacheHintEnabled(enable);
  SetCanvas2dCanvasFilterEnabled(enable);
  SetCanvas2dScrollPathIntoViewEnabled(enable);
  SetCanvasFloatingPointEnabled(enable);
  SetCanvasHDREnabled(enable);
  SetCanvasImageSmoothingEnabled(enable);
  SetCapabilityDelegationDisplayCaptureRequestEnabled(enable);
  SetClickToCapturedPointerEnabled(enable);
  SetClipboardSvgEnabled(enable);
  SetCloseWatcherEnabled(enable);
  SetCompositeBGColorAnimationEnabled(enable);
  SetComputedAccessibilityInfoEnabled(enable);
  SetComputePressureEnabled(enable);
  SetContextMenuEnabled(enable);
  SetCrossFramePerformanceTimelineEnabled(enable);
  SetCSSAnchorPositioningEnabled(enable);
  SetCSSColorContrastEnabled(enable);
  SetCSSColorTypedOMEnabled(enable);
  SetCSSCrossFadeEnabled(enable);
  SetCSSDynamicRangeLimitEnabled(enable);
  SetCssFieldSizingEnabled(enable);
  SetCSSFontSizeAdjustEnabled(enable);
  SetCSSLayoutAPIEnabled(enable);
  SetCSSMarkerNestedPseudoElementEnabled(enable);
  SetCSSPaintAPIArgumentsEnabled(enable);
  SetCSSProgressNotationEnabled(enable);
  SetCSSSelectorFragmentAnchorEnabled(enable);
  SetCSSSignRelatedFunctionsEnabled(enable);
  SetCSSSnapContainerQueriesEnabled(enable);
  SetCSSSteppedValueFunctionsEnabled(enable);
  SetCSSStickyContainerQueriesEnabled(enable);
  SetCSSSystemAccentColorEnabled(enable);
  SetCSSTextAutoSpaceEnabled(enable);
  SetCSSTextSpacingTrimEnabled(enable);
  SetCSSVideoDynamicRangeMediaQueriesEnabled(enable);
  SetDatabaseEnabled(enable);
  SetDesktopCaptureDisableLocalEchoControlEnabled(enable);
  SetDetailsStylingEnabled(enable);
  SetDeviceOrientationRequestPermissionEnabled(enable);
  SetDevicePostureEnabled(enable);
  SetDialogNewFocusBehaviorEnabled(enable);
  SetDirectSocketsEnabled(enable);
  SetDisableHardwareNoiseSuppressionEnabled(enable);
  SetDisableThirdPartySessionStoragePartitioningAfterGeneralPartitioningEnabled(enable);
  SetDisableThirdPartyStoragePartitioningEnabled(enable);
  SetDocumentOpenOriginAliasRemovalEnabled(enable);
  SetDocumentPolicyDocumentDomainEnabled(enable);
  SetDocumentPolicyNegotiationEnabled(enable);
  SetDocumentPolicySyncXHREnabled(enable);
  SetDOMPartsAPIEnabled(enable);
  SetDynamicScrollCullRectExpansionEnabled(enable);
  SetEscapeLtGtInAttributesEnabled(enable);
  SetEventTimingInteractionCountEnabled(enable);
  SetExperimentalContentSecurityPolicyFeaturesEnabled(enable);
  SetExperimentalJSProfilerMarkersEnabled(enable);
  SetExperimentalPoliciesEnabled(enable);
  SetExtendedTextMetricsEnabled(enable);
  SetFaceDetectorEnabled(enable);
  SetFetchLaterAPIEnabled(enable);
  SetFileSystemAccessAPIExperimentalEnabled(enable);
  SetFileSystemObserverEnabled(enable);
  SetFocusgroupEnabled(enable);
  SetFormattedTextEnabled(enable);
  SetFormControlsVerticalWritingModeDirectionSupportEnabled(enable);
  SetFreezeFramesOnVisibilityEnabled(enable);
  SetFullscreenPopupWindowsEnabled(enable);
  SetGamepadButtonAxisEventsEnabled(enable);
  SetGamepadMultitouchEnabled(enable);
  SetGetDisplayMediaRequiresUserActivationEnabled(enable);
  SetHighlightInheritanceEnabled(enable);
  SetHitTestOpaquenessEnabled(enable);
  SetHTMLInvokeActionsV2Enabled(enable);
  SetHTMLInvokeTargetAttributeEnabled(enable);
  SetHTMLPopoverHintEnabled(enable);
  SetHTMLSelectListElementEnabled(enable);
  SetHTMLUnsafeMethodsEnabled(enable);
  SetInnerHTMLParserFastpathLogFailureEnabled(enable);
  SetInteroperablePrivateAttributionEnabled(enable);
  SetIntersectionOptimizationEnabled(enable);
  SetInvertedColorsEnabled(enable);
  SetJavaScriptCompileHintsMagicRuntimeEnabled(enable);
  SetKeyboardAccessibleTooltipEnabled(enable);
  SetKeyboardFocusableScrollersEnabled(enable);
  SetLongAnimationFrameTimingEnabled(enable);
  SetMachineLearningCommonEnabled(enable);
  SetMachineLearningModelLoaderEnabled(enable);
  SetMediaCapabilitiesEncodingInfoEnabled(enable);
  SetMediaCaptureBackgroundBlurEnabled(enable);
  SetMediaCaptureCameraControlsEnabled(enable);
  SetMediaCaptureConfigurationChangeEnabled(enable);
  SetMediaCaptureVoiceIsolationEnabled(enable);
  SetMediaSourceExperimentalEnabled(enable);
  SetMediaSourceExtensionsForWebCodecsEnabled(enable);
  SetMediaSourceNewAbortAndDurationEnabled(enable);
  SetMouseDragOnCancelledMouseMoveEnabled(enable);
  SetNavigateEventCommitBehaviorEnabled(enable);
  SetNavigateEventSourceElementEnabled(enable);
  SetNavigationActivationEnabled(enable);
  SetNavigationIdEnabled(enable);
  SetNotificationTriggersEnabled(enable);
  SetObservableAPIEnabled(enable);
  SetOffscreenCanvasCommitEnabled(enable);
  SetOffsetMappingUnitVariableEnabled(enable);
  SetOnePassRasterInvalidationEnabled(enable);
  SetOriginPolicyEnabled(enable);
  SetOverscrollCustomizationEnabled(enable);
  SetPageRevealEventEnabled(enable);
  SetPasswordStrongLabelEnabled(enable);
  SetPaymentAppEnabled(enable);
  SetPaymentRequestEnabled(enable);
  SetPaymentRequestMerchantValidationEventEnabled(enable);
  SetPendingBeaconAPIEnabled(enable);
  SetPerformanceMarkFeatureUsageEnabled(enable);
  SetPerformanceNavigateSystemEntropyEnabled(enable);
  SetPerMethodCanMakePaymentQuotaEnabled(enable);
  SetPermissionElementEnabled(enable);
  SetPermissionsRequestRevokeEnabled(enable);
  SetPrefersReducedDataEnabled(enable);
  SetPrettyPrintJSONDocumentEnabled(enable);
  SetPrivateNetworkAccessNonSecureContextsAllowedEnabled(enable);
  SetPrivateNetworkAccessNullIpAddressEnabled(enable);
  SetPrivateNetworkAccessPermissionPromptEnabled(enable);
  SetPushMessagingSubscriptionChangeEnabled(enable);
  SetQuotaChangeEnabled(enable);
  SetResourceTimingContentTypeEnabled(enable);
  SetRestrictGamepadAccessEnabled(enable);
  SetRtcAudioJitterBufferMaxPacketsEnabled(enable);
  SetRTCEncodedAudioFrameAbsCaptureTimeEnabled(enable);
  SetRTCEncodedFrameSetMetadataEnabled(enable);
  SetRTCEncodedVideoFrameAdditionalMetadataEnabled(enable);
  SetRTCLegacyCallbackBasedGetStatsEnabled(enable);
  SetRTCStatsRelativePacketArrivalDelayEnabled(enable);
  SetSanitizerAPIEnabled(enable);
  SetSchedulerYieldEnabled(enable);
  SetScopedCustomElementRegistryEnabled(enable);
  SetScrollTimelineCurrentTimeEnabled(enable);
  SetSensorExtraClassesEnabled(enable);
  SetServiceWorkerClientLifecycleStateEnabled(enable);
  SetSetSequentialFocusStartingPointEnabled(enable);
  SetSignatureBasedIntegrityEnabled(enable);
  SetSiteInitiatedMirroringEnabled(enable);
  SetSkipAdEnabled(enable);
  SetSoftNavigationHeuristicsEnabled(enable);
  SetStorageAccessAPIBeyondCookiesEnabled(enable);
  SetStorageBucketsDurabilityEnabled(enable);
  SetStorageBucketsLocksEnabled(enable);
  SetStrictMimeTypesForWorkersEnabled(enable);
  SetStylableSelectEnabled(enable);
  SetSynthesizedKeyboardEventsForAccessibilityActionsEnabled(enable);
  SetSystemWakeLockEnabled(enable);
  SetTextDetectorEnabled(enable);
  SetTextFragmentAPIEnabled(enable);
  SetTimeZoneChangeEventEnabled(enable);
  SetTopLevelTpcdEnabled(enable);
  SetTpcdEnabled(enable);
  SetTrustedTypeBeforePolicyCreationEventEnabled(enable);
  SetTrustedTypesFromLiteralEnabled(enable);
  SetTrustedTypesUseCodeLikeEnabled(enable);
  SetUnclosedFormControlIsInvalidEnabled(enable);
  SetUnrestrictedUsbEnabled(enable);
  SetURLPatternCompareComponentEnabled(enable);
  SetViewportSegmentsEnabled(enable);
  SetWebAnimationsSVGEnabled(enable);
  SetWebAppDarkModeEnabled(enable);
  SetWebAppScopeExtensionsEnabled(enable);
  SetWebAppsLockScreenEnabled(enable);
  SetWebAppTabStripEnabled(enable);
  SetWebAppTabStripCustomizationsEnabled(enable);
  SetWebAppTranslationsEnabled(enable);
  SetWebAppUrlHandlingEnabled(enable);
  SetWebAssemblyJSStringBuiltinsEnabled(enable);
  SetWebAuthAllowCreateInCrossOriginFrameEnabled(enable);
  SetWebAuthenticationHintsEnabled(enable);
  SetWebAuthenticationJSONSerializationEnabled(enable);
  SetWebAuthenticationSupplementalPubKeysEnabled(enable);
  SetWebBluetoothGetDevicesEnabled(enable);
  SetWebBluetoothScanningEnabled(enable);
  SetWebBluetoothWatchAdvertisementsEnabled(enable);
  SetWebCodecsCopyToRGBEnabled(enable);
  SetWebCryptoCurve25519Enabled(enable);
  SetWebFontResizeLCPEnabled(enable);
  SetWebGLDeveloperExtensionsEnabled(enable);
  SetWebPreferencesEnabled(enable);
  SetWebSocketStreamEnabled(enable);
  SetWebViewXRequestedWithDeprecationEnabled(enable);
  SetWebVTTRegionsEnabled(enable);
  SetWebXRFrameRateEnabled(enable);
  SetWebXRFrontFacingEnabled(enable);
  SetWebXRHandInputEnabled(enable);
  SetWebXRHitTestEntityTypesEnabled(enable);
  SetWebXRImageTrackingEnabled(enable);
  SetWebXRLayersEnabled(enable);
  SetWebXRPlaneDetectionEnabled(enable);
  SetWebXRPoseMotionDataEnabled(enable);
  SetWindowPlacementFullscreenOnScreensChangeEnabled(enable);

  // Platform-dependent features
#if BUILDFLAG(IS_ANDROID)
  SetDeviceAttributesEnabled(enable);
  SetGetDisplayMediaEnabled(enable);
  SetHandwritingRecognitionEnabled(enable);
  SetWebAppLaunchHandlerEnabled(enable);
#endif

#if BUILDFLAG(IS_WIN)
  SetCapturedSurfaceControlEnabled(enable);
  SetContentIndexEnabled(enable);
  SetDeviceAttributesEnabled(enable);
  SetElementCaptureEnabled(enable);
  SetFileHandlingIconsEnabled(enable);
  SetHandwritingRecognitionEnabled(enable);
  SetMachineLearningNeuralNetworkEnabled(enable);
  SetNetInfoDownlinkMaxEnabled(enable);
#endif

#if BUILDFLAG(IS_CHROMEOS_ASH)
  SetCapturedSurfaceControlEnabled(enable);
  SetContentIndexEnabled(enable);
  SetElementCaptureEnabled(enable);
  SetFileHandlingIconsEnabled(enable);
  SetFileSystemAccessGetCloudIdentifiersEnabled(enable);
  SetMachineLearningNeuralNetworkEnabled(enable);
  SetRemotePlaybackBackendEnabled(enable);
#endif

#if BUILDFLAG(IS_CHROMEOS_LACROS)
  SetCapturedSurfaceControlEnabled(enable);
  SetContentIndexEnabled(enable);
  SetElementCaptureEnabled(enable);
  SetFileHandlingIconsEnabled(enable);
  SetFileSystemAccessGetCloudIdentifiersEnabled(enable);
  SetMachineLearningNeuralNetworkEnabled(enable);
  SetRemotePlaybackBackendEnabled(enable);
#endif

#if BUILDFLAG(IS_MAC)
  SetCapturedSurfaceControlEnabled(enable);
  SetContentIndexEnabled(enable);
  SetDeviceAttributesEnabled(enable);
  SetElementCaptureEnabled(enable);
  SetFileHandlingIconsEnabled(enable);
  SetHandwritingRecognitionEnabled(enable);
  SetMachineLearningNeuralNetworkEnabled(enable);
  SetNetInfoDownlinkMaxEnabled(enable);
#endif

#if BUILDFLAG(IS_LINUX)
  SetCapturedSurfaceControlEnabled(enable);
  SetContentIndexEnabled(enable);
  SetDeviceAttributesEnabled(enable);
  SetElementCaptureEnabled(enable);
  SetFileHandlingIconsEnabled(enable);
  SetHandwritingRecognitionEnabled(enable);
  SetMachineLearningNeuralNetworkEnabled(enable);
  SetNetInfoDownlinkMaxEnabled(enable);
  SetWebBluetoothEnabled(enable);
#endif

  // Default values for platforms not specifically handled above
#if !BUILDFLAG(IS_ANDROID) && !BUILDFLAG(IS_WIN) && !BUILDFLAG(IS_CHROMEOS_ASH) && !BUILDFLAG(IS_CHROMEOS_LACROS) && !BUILDFLAG(IS_MAC) && !BUILDFLAG(IS_LINUX)
  SetCapturedSurfaceControlEnabled(enable);
  SetContentIndexEnabled(enable);
  SetDeviceAttributesEnabled(enable);
  SetElementCaptureEnabled(enable);
  SetFileHandlingIconsEnabled(enable);
  SetHandwritingRecognitionEnabled(enable);
  SetNetInfoDownlinkMaxEnabled(enable);
  SetRemotePlaybackBackendEnabled(enable);
  SetWebBluetoothEnabled(enable);
#endif
}

void RuntimeEnabledFeaturesBase::SetTestFeaturesEnabled(bool enable) {
  SetAccessibilityExposeDisplayNoneEnabled(enable);
  SetAdTaggingEnabled(enable);
  SetCanvas2dMeshEnabled(enable);
  SetCoepReflectionEnabled(enable);
  SetConfirmationOfActionEnabled(enable);
  SetCSSAtRuleCounterStyleSpeakAsDescriptorEnabled(enable);
  SetCSSCaseSensitiveSelectorEnabled(enable);
  SetCSSEnumeratedCustomPropertiesEnabled(enable);
  SetCSSLogicalOverflowEnabled(enable);
  SetCSSPositionStickyStaticScrollPositionEnabled(enable);
  SetCSSPseudoPlayingPausedEnabled(enable);
  SetCSSScrollSnapEventsEnabled(enable);
  SetCSSScrollStartEnabled(enable);
  SetCSSSnapChangedEventEnabled(enable);
  SetCSSSnapChangingEventEnabled(enable);
  SetCSSTextBoxTrimEnabled(enable);
  SetCSSUserSelectContainEnabled(enable);
  SetDesktopPWAsAdditionalWindowingControlsEnabled(enable);
  SetDesktopPWAsSubAppsEnabled(enable);
  SetDocumentRenderBlockingEnabled(enable);
  SetDOMParserUsesHTMLFastPathParserEnabled(enable);
  SetFakeNoAllocDirectCallForTestingEnabled(enable);
  SetFedCmAuthzEnabled(enable);
  SetFedCmButtonModeEnabled(enable);
  SetFedCmDomainHintEnabled(enable);
  SetFedCmIdPRegistrationEnabled(enable);
  SetFledgeTrustedBiddingSignalsSlotSizeEnabled(enable);
  SetGetAllScreensMediaEnabled(enable);
  SetGroupEffectEnabled(enable);
  SetLayoutFlexNewRowAlgorithmV3Enabled(enable);
  SetLayoutNGShapeCacheEnabled(enable);
  SetLCPAnimatedImagesWebExposedEnabled(enable);
  SetLockedModeEnabled(enable);
  SetMaskingGraphemeClustersEnabled(enable);
  SetMediaCapabilitiesSpatialAudioEnabled(enable);
  SetMediaLatencyHintEnabled(enable);
  SetMediaSessionChapterInformationEnabled(enable);
  SetMediaStreamTrackTransferEnabled(enable);
  SetMessagePortCloseEventEnabled(enable);
  SetMiddleClickAutoscrollEnabled(enable);
  SetModelExecutionAPIEnabled(enable);
  SetMojoJSEnabled(enable);
  SetMojoJSTestEnabled(enable);
  SetNoIdleEncodingForWebTestsEnabled(enable);
  SetPointerEventDeviceIdEnabled(enable);
  SetPrivateStateTokensAlwaysAllowIssuanceEnabled(enable);
  SetReduceCookieIPCsEnabled(enable);
  SetRemoveZoomAdjustmentOfBoundingBoxEnabled(enable);
  SetResourceTimingUseCORSForBodySizesEnabled(enable);
  SetSecurePaymentConfirmationEnabled(enable);
  SetSharedAutofillEnabled(enable);
  SetVideoTrackGeneratorEnabled(enable);
  SetVideoTrackGeneratorInWindowEnabled(enable);
  SetWebAuthAuthenticatorAttachmentEnabled(enable);
  SetWebIdentityDigitalCredentialsEnabled(enable);
  SetWebShareEnabled(enable);
  SetWGIGamepadTriggerRumbleEnabled(enable);

  // Platform-dependent features
#if BUILDFLAG(IS_ANDROID)
  SetFileHandlingEnabled(enable);
  SetFileHandlingIconsEnabled(enable);
  SetFileSystemAccessLocalEnabled(enable);
  SetInputMultipleFieldsUIEnabled(enable);
  SetInsertLineBreakIfPhrasingContentEnabled(enable);
  SetMachineLearningNeuralNetworkEnabled(enable);
  SetSmartZoomEnabled(enable);
#endif

#if BUILDFLAG(IS_WIN)
  SetBarcodeDetectorEnabled(enable);
  SetCapturedMouseEventsEnabled(enable);
  SetContactsManagerEnabled(enable);
  SetContactsManagerExtraPropertiesEnabled(enable);
  SetDigitalGoodsEnabled(enable);
  SetDigitalGoodsV2_1Enabled(enable);
  SetSmartCardEnabled(enable);
  SetWebNFCEnabled(enable);
  SetWebPrintingEnabled(enable);
#endif

#if BUILDFLAG(IS_CHROMEOS_ASH)
  SetCapturedMouseEventsEnabled(enable);
  SetContactsManagerEnabled(enable);
  SetContactsManagerExtraPropertiesEnabled(enable);
  SetSmartCardEnabled(enable);
  SetWebNFCEnabled(enable);
  SetWebPrintingEnabled(enable);
#endif

#if BUILDFLAG(IS_CHROMEOS_LACROS)
  SetCapturedMouseEventsEnabled(enable);
  SetContactsManagerEnabled(enable);
  SetContactsManagerExtraPropertiesEnabled(enable);
  SetSmartCardEnabled(enable);
  SetWebNFCEnabled(enable);
  SetWebPrintingEnabled(enable);
#endif

#if BUILDFLAG(IS_MAC)
  SetCapturedMouseEventsEnabled(enable);
  SetContactsManagerEnabled(enable);
  SetContactsManagerExtraPropertiesEnabled(enable);
  SetDigitalGoodsEnabled(enable);
  SetDigitalGoodsV2_1Enabled(enable);
  SetNotificationContentImageEnabled(enable);
  SetSmartCardEnabled(enable);
  SetWebNFCEnabled(enable);
  SetWebPrintingEnabled(enable);
#endif

#if BUILDFLAG(IS_LINUX)
  SetBarcodeDetectorEnabled(enable);
  SetCapturedMouseEventsEnabled(enable);
  SetContactsManagerEnabled(enable);
  SetContactsManagerExtraPropertiesEnabled(enable);
  SetDigitalGoodsEnabled(enable);
  SetDigitalGoodsV2_1Enabled(enable);
  SetSmartCardEnabled(enable);
  SetWebNFCEnabled(enable);
  SetWebPrintingEnabled(enable);
#endif

  // Default values for platforms not specifically handled above
#if !BUILDFLAG(IS_ANDROID) && !BUILDFLAG(IS_WIN) && !BUILDFLAG(IS_CHROMEOS_ASH) && !BUILDFLAG(IS_CHROMEOS_LACROS) && !BUILDFLAG(IS_MAC) && !BUILDFLAG(IS_LINUX)
  SetBarcodeDetectorEnabled(enable);
  SetCapturedMouseEventsEnabled(enable);
  SetContactsManagerEnabled(enable);
  SetContactsManagerExtraPropertiesEnabled(enable);
  SetDigitalGoodsEnabled(enable);
  SetDigitalGoodsV2_1Enabled(enable);
  SetMachineLearningNeuralNetworkEnabled(enable);
  SetSmartCardEnabled(enable);
  SetWebNFCEnabled(enable);
  SetWebPrintingEnabled(enable);
#endif
}


void RuntimeEnabledFeaturesBase::SetOriginTrialControlledFeaturesEnabled(bool enable) {
  SetAddIdentityInCanMakePaymentEventEnabled(enable);
  SetAdInterestGroupAPIEnabled(enable);
  SetAttributionReportingEnabled(enable);
  SetAttributionReportingCrossAppWebEnabled(enable);
  SetAttributionReportingInterfaceEnabled(enable);
  SetAutoDarkModeEnabled(enable);
  SetBackForwardCacheExperimentHTTPHeaderEnabled(enable);
  SetBackForwardCacheNotRestoredReasonsEnabled(enable);
  SetCacheStorageCodeCacheHintEnabled(enable);
  SetCapturedSurfaceControlEnabled(enable);
  SetCompressionDictionaryTransportEnabled(enable);
  SetComputePressureEnabled(enable);
  SetCoopRestrictPropertiesEnabled(enable);
  SetDatabaseEnabled(enable);
  SetDeprecateUnloadOptOutEnabled(enable);
  SetDigitalGoodsEnabled(enable);
  SetDisableDifferentOriginSubframeDialogSuppressionEnabled(enable);
  SetDisableHardwareNoiseSuppressionEnabled(enable);
  SetDisableThirdPartySessionStoragePartitioningAfterGeneralPartitioningEnabled(enable);
  SetDisableThirdPartyStoragePartitioningEnabled(enable);
  SetDocumentPolicyNegotiationEnabled(enable);
  SetEditContextEnabled(enable);
  SetElementCaptureEnabled(enable);
  SetFencedFramesEnabled(enable);
  SetFencedFramesAPIChangesEnabled(enable);
  SetFetchLaterAPIEnabled(enable);
  SetFledgeEnabled(enable);
  SetFledgeBiddingAndAuctionServerAPIEnabled(enable);
  SetFocusgroupEnabled(enable);
  SetFullscreenPopupWindowsEnabled(enable);
  SetGetAllScreensMediaEnabled(enable);
  SetHrefTranslateEnabled(enable);
  SetJavaScriptCompileHintsMagicRuntimeEnabled(enable);
  SetLongAnimationFrameTimingEnabled(enable);
  SetMediaCaptureBackgroundBlurEnabled(enable);
  SetMediaCaptureConfigurationChangeEnabled(enable);
  SetMediaSourceExtensionsForWebCodecsEnabled(enable);
  SetNavigationIdEnabled(enable);
  SetNotificationTriggersEnabled(enable);
  SetNoVarySearchPrefetchEnabled(enable);
  SetOriginTrialsSampleAPIEnabled(enable);
  SetOriginTrialsSampleAPIBrowserReadWriteEnabled(enable);
  SetOriginTrialsSampleAPIDependentEnabled(enable);
  SetOriginTrialsSampleAPIDeprecationEnabled(enable);
  SetOriginTrialsSampleAPIExpiryGracePeriodEnabled(enable);
  SetOriginTrialsSampleAPIExpiryGracePeriodThirdPartyEnabled(enable);
  SetOriginTrialsSampleAPIImpliedEnabled(enable);
  SetOriginTrialsSampleAPIInvalidOSEnabled(enable);
  SetOriginTrialsSampleAPINavigationEnabled(enable);
  SetOriginTrialsSampleAPIPersistentExpiryGracePeriodEnabled(enable);
  SetOriginTrialsSampleAPIPersistentFeatureEnabled(enable);
  SetOriginTrialsSampleAPIPersistentInvalidOSEnabled(enable);
  SetOriginTrialsSampleAPIPersistentThirdPartyDeprecationFeatureEnabled(enable);
  SetOriginTrialsSampleAPIThirdPartyEnabled(enable);
  SetPageFreezeOptInEnabled(enable);
  SetPageFreezeOptOutEnabled(enable);
  SetParakeetEnabled(enable);
  SetPartitionedCookiesEnabled(enable);
  SetPaymentHandlerMinimalHeaderUXEnabled(enable);
  SetPendingBeaconAPIEnabled(enable);
  SetPerMethodCanMakePaymentQuotaEnabled(enable);
  SetPNaClEnabled(enable);
  SetPrivacySandboxAdsAPIsEnabled(enable);
  SetPrivateNetworkAccessNonSecureContextsAllowedEnabled(enable);
  SetPrivateNetworkAccessPermissionPromptEnabled(enable);
  SetPrivateStateTokensEnabled(enable);
  SetReduceAcceptLanguageEnabled(enable);
  SetRtcAudioJitterBufferMaxPacketsEnabled(enable);
  SetRTCEncodedFrameSetMetadataEnabled(enable);
  SetRTCLegacyCallbackBasedGetStatsEnabled(enable);
  SetRTCStatsRelativePacketArrivalDelayEnabled(enable);
  SetSchedulerYieldEnabled(enable);
  SetSecurePaymentConfirmationOptOutEnabled(enable);
  SetServiceWorkerBypassFetchHandlerEnabled(enable);
  SetServiceWorkerRaceNetworkRequestEnabled(enable);
  SetServiceWorkerStaticRouterEnabled(enable);
  SetSharedStorageAPIEnabled(enable);
  SetSignatureBasedIntegrityEnabled(enable);
  SetSoftNavigationHeuristicsEnabled(enable);
  SetSpeculationRulesDocumentRulesEnabled(enable);
  SetSpeculationRulesDocumentRulesSelectorMatchesEnabled(enable);
  SetSpeculationRulesEagernessEnabled(enable);
  SetSpeculationRulesFetchFromHeaderEnabled(enable);
  SetSpeculationRulesNoVarySearchHintEnabled(enable);
  SetSpeculationRulesPrefetchFutureEnabled(enable);
  SetSpeculationRulesRelativeToDocumentEnabled(enable);
  SetStorageAccessAPIBeyondCookiesEnabled(enable);
  SetTextFragmentIdentifiersEnabled(enable);
  SetTopicsAPIEnabled(enable);
  SetTopicsDocumentAPIEnabled(enable);
  SetTopLevelTpcdEnabled(enable);
  SetTouchEventFeatureDetectionEnabled(enable);
  SetTpcdEnabled(enable);
  SetUnrestrictedSharedArrayBufferEnabled(enable);
  SetWebAppDarkModeEnabled(enable);
  SetWebAppLaunchHandlerEnabled(enable);
  SetWebAppLaunchQueueEnabled(enable);
  SetWebAppScopeExtensionsEnabled(enable);
  SetWebAppTabStripEnabled(enable);
  SetWebAppTabStripCustomizationsEnabled(enable);
  SetWebAppUrlHandlingEnabled(enable);
  SetWebAppWindowControlsOverlayEnabled(enable);
  SetWebAssemblyJSStringBuiltinsEnabled(enable);
  SetWebTransportCustomCertificatesEnabled(enable);
  SetWebViewXRequestedWithDeprecationEnabled(enable);
  SetWebXRImageTrackingEnabled(enable);
  SetWebXRPlaneDetectionEnabled(enable);
}

void RuntimeEnabledFeaturesBase::SetFeatureEnabledFromString(
    const std::string& name, bool enable) {
  static const struct {
    const char* name;
    bool* setting;
  } kFeatures[] = {
    {"AOMAriaRelationshipProperties", &is_aom_aria_relationship_properties_enabled_},
    {"Accelerated2dCanvas", &is_accelerated_2d_canvas_enabled_},
    {"AcceleratedSmallCanvases", &is_accelerated_small_canvases_enabled_},
    {"AccessibilityAriaVirtualContent", &is_accessibility_aria_virtual_content_enabled_},
    {"AccessibilityExposeDisplayNone", &is_accessibility_expose_display_none_enabled_},
    {"AccessibilityExposeHTMLElement", &is_accessibility_expose_html_element_enabled_},
    {"AccessibilityExposeIgnoredNodes", &is_accessibility_expose_ignored_nodes_enabled_},
    {"AccessibilityOSLevelBoldText", &is_accessibility_os_level_bold_text_enabled_},
    {"AccessibilityObjectModel", &is_accessibility_object_model_enabled_},
    {"AccessibilityPageZoom", &is_accessibility_page_zoom_enabled_},
    {"AccessibilitySerializationSizeMetrics", &is_accessibility_serialization_size_metrics_enabled_},
    {"AccessibilityUseAXPositionForDocumentMarkers", &is_accessibility_use_ax_position_for_document_markers_enabled_},
    {"AccordionPattern", &is_accordion_pattern_enabled_},
    {"AdInterestGroupAPI", &is_ad_interest_group_api_enabled_},
    {"AdTagging", &is_ad_tagging_enabled_},
    {"AddIdentityInCanMakePaymentEvent", &is_add_identity_in_can_make_payment_event_enabled_},
    {"AddressSpace", &is_address_space_enabled_},
    {"AlignContentForBlocks", &is_align_content_for_blocks_enabled_},
    {"AllowContentInitiatedDataUrlNavigations", &is_allow_content_initiated_data_url_navigations_enabled_},
    {"AllowURNsInIframes", &is_allow_ur_ns_in_iframes_enabled_},
    {"AndroidDownloadableFontsMatching", &is_android_downloadable_fonts_matching_enabled_},
    {"AnimationWorklet", &is_animation_worklet_enabled_},
    {"AnonymousIframe", &is_anonymous_iframe_enabled_},
    {"AppTitle", &is_app_title_enabled_},
    {"ArrowKeysInVerticalWritingModes", &is_arrow_keys_in_vertical_writing_modes_enabled_},
    {"AsyncClipboardImplicitPermission", &is_async_clipboard_implicit_permission_enabled_},
    {"AttributionReporting", &is_attribution_reporting_enabled_},
    {"AttributionReportingCrossAppWeb", &is_attribution_reporting_cross_app_web_enabled_},
    {"AttributionReportingInterface", &is_attribution_reporting_interface_enabled_},
    {"AudioContextSetSinkId", &is_audio_context_set_sink_id_enabled_},
    {"AudioOutputDevices", &is_audio_output_devices_enabled_},
    {"AudioVideoTracks", &is_audio_video_tracks_enabled_},
    {"AutoDarkMode", &is_auto_dark_mode_enabled_},
    {"AutoDisableAccessibilityV2", &is_auto_disable_accessibility_v_2_enabled_},
    {"AutoSizeLazyLoadedImages", &is_auto_size_lazy_loaded_images_enabled_},
    {"AutomationControlled", &is_automation_controlled_enabled_},
    {"AutoplayIgnoresWebAudio", &is_autoplay_ignores_web_audio_enabled_},
    {"AvoidCaretVisibleSelectionAdjuster", &is_avoid_caret_visible_selection_adjuster_enabled_},
    {"BackForwardCache", &is_back_forward_cache_enabled_},
    {"BackForwardCacheExperimentHTTPHeader", &is_back_forward_cache_experiment_http_header_enabled_},
    {"BackForwardCacheNotRestoredReasons", &is_back_forward_cache_not_restored_reasons_enabled_},
    {"BackdropInheritOriginating", &is_backdrop_inherit_originating_enabled_},
    {"BackfaceVisibilityInterop", &is_backface_visibility_interop_enabled_},
    {"BackgroundFetch", &is_background_fetch_enabled_},
    {"BarcodeDetector", &is_barcode_detector_enabled_},
    {"BdiElementDirInheritance", &is_bdi_element_dir_inheritance_enabled_},
    {"BeforeunloadEventCancelByPreventDefault", &is_beforeunload_event_cancel_by_prevent_default_enabled_},
    {"BidiCaretAffinity", &is_bidi_caret_affinity_enabled_},
    {"BlinkExtensionChromeOS", &is_blink_extension_chrome_os_enabled_},
    {"BlinkExtensionChromeOSKiosk", &is_blink_extension_chrome_os_kiosk_enabled_},
    {"BlinkExtensionDiagnostics", &is_blink_extension_diagnostics_enabled_},
    {"BlinkLifecycleScriptForbidden", &is_blink_lifecycle_script_forbidden_enabled_},
    {"BlinkRuntimeCallStats", &is_blink_runtime_call_stats_enabled_},
    {"BlockRubyConsoleMessage", &is_block_ruby_console_message_enabled_},
    {"BlockRubyWrappingInlineRuby", &is_block_ruby_wrapping_inline_ruby_enabled_},
    {"BlockingFocusWithoutUserActivation", &is_blocking_focus_without_user_activation_enabled_},
    {"BoundaryEventDispatchTracksNodeRemoval", &is_boundary_event_dispatch_tracks_node_removal_enabled_},
    {"BrowserVerifiedUserActivationKeyboard", &is_browser_verified_user_activation_keyboard_enabled_},
    {"BrowserVerifiedUserActivationMouse", &is_browser_verified_user_activation_mouse_enabled_},
    {"ByobFetch", &is_byob_fetch_enabled_},
    {"CCTNewRFMPushBehavior", &is_cct_new_rfm_push_behavior_enabled_},
    {"CSSAnchorPositioning", &is_css_anchor_positioning_enabled_},
    {"CSSAnchorPositioningCascadeFallback", &is_css_anchor_positioning_cascade_fallback_enabled_},
    {"CSSAnimationComposition", &is_css_animation_composition_enabled_},
    {"CSSAnimationDelayStartEnd", &is_css_animation_delay_start_end_enabled_},
    {"CSSAtRuleCounterStyleImageSymbols", &is_css_at_rule_counter_style_image_symbols_enabled_},
    {"CSSAtRuleCounterStyleSpeakAsDescriptor", &is_css_at_rule_counter_style_speak_as_descriptor_enabled_},
    {"CSSBackgroundClipUnprefix", &is_css_background_clip_unprefix_enabled_},
    {"CSSCalcSimplificationAndSerialization", &is_css_calc_simplification_and_serialization_enabled_},
    {"CSSCapFontUnits", &is_css_cap_font_units_enabled_},
    {"CSSCaseSensitiveSelector", &is_css_case_sensitive_selector_enabled_},
    {"CSSColorContrast", &is_css_color_contrast_enabled_},
    {"CSSColorTypedOM", &is_css_color_typed_om_enabled_},
    {"CSSContentVisibilityImpliesContainIntrinsicSizeAuto", &is_css_content_visibility_implies_contain_intrinsic_size_auto_enabled_},
    {"CSSCrossFade", &is_css_cross_fade_enabled_},
    {"CSSDisplayAnimation", &is_css_display_animation_enabled_},
    {"CSSDynamicRangeLimit", &is_css_dynamic_range_limit_enabled_},
    {"CSSEnumeratedCustomProperties", &is_css_enumerated_custom_properties_enabled_},
    {"CSSExponentialFunctions", &is_css_exponential_functions_enabled_},
    {"CSSFirstLetterNoNewLineAsPrecedingChar", &is_css_first_letter_no_new_line_as_preceding_char_enabled_},
    {"CSSFontSizeAdjust", &is_css_font_size_adjust_enabled_},
    {"CSSHexAlphaColor", &is_css_hex_alpha_color_enabled_},
    {"CSSLayoutAPI", &is_css_layout_api_enabled_},
    {"CSSLinearTimingFunction", &is_css_linear_timing_function_enabled_},
    {"CSSLogicalOverflow", &is_css_logical_overflow_enabled_},
    {"CSSMPCImprovements", &is_css_mpc_improvements_enabled_},
    {"CSSMarkerNestedPseudoElement", &is_css_marker_nested_pseudo_element_enabled_},
    {"CSSMaskingInterop", &is_css_masking_interop_enabled_},
    {"CSSNestingIdent", &is_css_nesting_ident_enabled_},
    {"CSSNumericFactoryCompleteness", &is_css_numeric_factory_completeness_enabled_},
    {"CSSOffsetPathBasicShapesCircleAndEllipse", &is_css_offset_path_basic_shapes_circle_and_ellipse_enabled_},
    {"CSSOffsetPathBasicShapesRectanglesAndPolygon", &is_css_offset_path_basic_shapes_rectangles_and_polygon_enabled_},
    {"CSSOffsetPathCoordBox", &is_css_offset_path_coord_box_enabled_},
    {"CSSOffsetPathRay", &is_css_offset_path_ray_enabled_},
    {"CSSOffsetPathRayContain", &is_css_offset_path_ray_contain_enabled_},
    {"CSSOffsetPathUrl", &is_css_offset_path_url_enabled_},
    {"CSSOffsetPositionAnchor", &is_css_offset_position_anchor_enabled_},
    {"CSSOverflowMediaFeatures", &is_css_overflow_media_features_enabled_},
    {"CSSPaintAPIArguments", &is_css_paint_api_arguments_enabled_},
    {"CSSParserIgnoreCharsetForURLs", &is_css_parser_ignore_charset_for_urls_enabled_},
    {"CSSPhraseLineBreak", &is_css_phrase_line_break_enabled_},
    {"CSSPositionStickyStaticScrollPosition", &is_css_position_sticky_static_scroll_position_enabled_},
    {"CSSProgressNotation", &is_css_progress_notation_enabled_},
    {"CSSPseudoDir", &is_css_pseudo_dir_enabled_},
    {"CSSPseudoPlayingPaused", &is_css_pseudo_playing_paused_enabled_},
    {"CSSRelativeColor", &is_css_relative_color_enabled_},
    {"CSSResizeAuto", &is_css_resize_auto_enabled_},
    {"CSSScope", &is_css_scope_enabled_},
    {"CSSScrollSnapEvents", &is_css_scroll_snap_events_enabled_},
    {"CSSScrollStart", &is_css_scroll_start_enabled_},
    {"CSSScrollStateContainerQueries", &is_css_scroll_state_container_queries_enabled_},
    {"CSSSelectorFragmentAnchor", &is_css_selector_fragment_anchor_enabled_},
    {"CSSSelectorNthChildComplexSelector", &is_css_selector_nth_child_complex_selector_enabled_},
    {"CSSSignRelatedFunctions", &is_css_sign_related_functions_enabled_},
    {"CSSSnapChangedEvent", &is_css_snap_changed_event_enabled_},
    {"CSSSnapChangingEvent", &is_css_snap_changing_event_enabled_},
    {"CSSSnapContainerQueries", &is_css_snap_container_queries_enabled_},
    {"CSSSpellingGrammarErrors", &is_css_spelling_grammar_errors_enabled_},
    {"CSSSteppedValueFunctions", &is_css_stepped_value_functions_enabled_},
    {"CSSStickyContainerQueries", &is_css_sticky_container_queries_enabled_},
    {"CSSSupportsForImportRules", &is_css_supports_for_import_rules_enabled_},
    {"CSSSystemAccentColor", &is_css_system_accent_color_enabled_},
    {"CSSTextAutoSpace", &is_css_text_auto_space_enabled_},
    {"CSSTextBoxTrim", &is_css_text_box_trim_enabled_},
    {"CSSTextSpacing", &is_css_text_spacing_enabled_},
    {"CSSTextSpacingTrim", &is_css_text_spacing_trim_enabled_},
    {"CSSTextWrapBalanceByScore", &is_css_text_wrap_balance_by_score_enabled_},
    {"CSSTextWrapPretty", &is_css_text_wrap_pretty_enabled_},
    {"CSSTransitionDiscrete", &is_css_transition_discrete_enabled_},
    {"CSSTreeScopedTimelines", &is_css_tree_scoped_timelines_enabled_},
    {"CSSUnknownContainerQueriesNoSelection", &is_css_unknown_container_queries_no_selection_enabled_},
    {"CSSUpdateMediaFeature", &is_css_update_media_feature_enabled_},
    {"CSSUserSelectContain", &is_css_user_select_contain_enabled_},
    {"CSSVariables2ImageValues", &is_css_variables_2_image_values_enabled_},
    {"CSSVariables2TransformValues", &is_css_variables_2_transform_values_enabled_},
    {"CSSVideoDynamicRangeMediaQueries", &is_css_video_dynamic_range_media_queries_enabled_},
    {"CSSViewTimelineInsetShorthand", &is_css_view_timeline_inset_shorthand_enabled_},
    {"CSSViewportUnits4", &is_css_viewport_units_4_enabled_},
    {"CacheStorageCodeCacheHint", &is_cache_storage_code_cache_hint_enabled_},
    {"CanonicalizeWhitespaceStrings", &is_canonicalize_whitespace_strings_enabled_},
    {"Canvas2dCanvasFilter", &is_canvas_2d_canvas_filter_enabled_},
    {"Canvas2dImageChromium", &is_canvas_2d_image_chromium_enabled_},
    {"Canvas2dLayers", &is_canvas_2d_layers_enabled_},
    {"Canvas2dMesh", &is_canvas_2d_mesh_enabled_},
    {"Canvas2dScrollPathIntoView", &is_canvas_2d_scroll_path_into_view_enabled_},
    {"CanvasFloatingPoint", &is_canvas_floating_point_enabled_},
    {"CanvasHDR", &is_canvas_hdr_enabled_},
    {"CanvasImageSmoothing", &is_canvas_image_smoothing_enabled_},
    {"CapabilityDelegationDisplayCaptureRequest", &is_capability_delegation_display_capture_request_enabled_},
    {"CaptureController", &is_capture_controller_enabled_},
    {"CaptureHandle", &is_capture_handle_enabled_},
    {"CapturedMouseEvents", &is_captured_mouse_events_enabled_},
    {"CapturedSurfaceControl", &is_captured_surface_control_enabled_},
    {"CheckVisibilityExtraProperties", &is_check_visibility_extra_properties_enabled_},
    {"ClickToCapturedPointer", &is_click_to_captured_pointer_enabled_},
    {"ClipPathGeometryBox", &is_clip_path_geometry_box_enabled_},
    {"ClipPathRejectEmptyPaths", &is_clip_path_reject_empty_paths_enabled_},
    {"ClipPathXYWHAndRect", &is_clip_path_xywh_and_rect_enabled_},
    {"ClipboardSupportedTypes", &is_clipboard_supported_types_enabled_},
    {"ClipboardSvg", &is_clipboard_svg_enabled_},
    {"ClipboardUnsanitizedContent", &is_clipboard_unsanitized_content_enabled_},
    {"ClipboardWellFormedHtmlSanitizationWrite", &is_clipboard_well_formed_html_sanitization_write_enabled_},
    {"CloseWatcher", &is_close_watcher_enabled_},
    {"CoepReflection", &is_coep_reflection_enabled_},
    {"CompositeBGColorAnimation", &is_composite_bg_color_animation_enabled_},
    {"CompositeBoxShadowAnimation", &is_composite_box_shadow_animation_enabled_},
    {"CompositeClipPathAnimation", &is_composite_clip_path_animation_enabled_},
    {"CompositedSelectionUpdate", &is_composited_selection_update_enabled_},
    {"CompositionForegroundMarkers", &is_composition_foreground_markers_enabled_},
    {"CompressionDictionaryTransport", &is_compression_dictionary_transport_enabled_},
    {"CompressionDictionaryTransportBackend", &is_compression_dictionary_transport_backend_enabled_},
    {"ComputePressure", &is_compute_pressure_enabled_},
    {"ComputedAccessibilityInfo", &is_computed_accessibility_info_enabled_},
    {"ConfirmationOfAction", &is_confirmation_of_action_enabled_},
    {"ConsolidatedMovementXY", &is_consolidated_movement_xy_enabled_},
    {"ContactsManager", &is_contacts_manager_enabled_},
    {"ContactsManagerExtraProperties", &is_contacts_manager_extra_properties_enabled_},
    {"ContentIndex", &is_content_index_enabled_},
    {"ContextMenu", &is_context_menu_enabled_},
    {"CookieDeprecationFacilitatedTesting", &is_cookie_deprecation_facilitated_testing_enabled_},
    {"CoopRestrictProperties", &is_coop_restrict_properties_enabled_},
    {"CooperativeScheduling", &is_cooperative_scheduling_enabled_},
    {"CorsRFC1918", &is_cors_rfc_1918_enabled_},
    {"CounterStyleChangeShouleCollectInlines", &is_counter_style_change_shoule_collect_inlines_enabled_},
    {"CrossFramePerformanceTimeline", &is_cross_frame_performance_timeline_enabled_},
    {"CssDisplayRuby", &is_css_display_ruby_enabled_},
    {"CssFieldSizing", &is_css_field_sizing_enabled_},
    {"CustomElementsGetName", &is_custom_elements_get_name_enabled_},
    {"DOMParserUsesHTMLFastPathParser", &is_dom_parser_uses_html_fast_path_parser_enabled_},
    {"DOMPartsAPI", &is_dom_parts_api_enabled_},
    {"DataTransferClearStringItems", &is_data_transfer_clear_string_items_enabled_},
    {"Database", &is_database_enabled_},
    {"DateInputInlineBlock", &is_date_input_inline_block_enabled_},
    {"DeprecateUnloadOptOut", &is_deprecate_unload_opt_out_enabled_},
    {"DeprecatedTemplateShadowRoot", &is_deprecated_template_shadow_root_enabled_},
    {"DesktopCaptureDisableLocalEchoControl", &is_desktop_capture_disable_local_echo_control_enabled_},
    {"DesktopPWAsAdditionalWindowingControls", &is_desktop_pw_as_additional_windowing_controls_enabled_},
    {"DesktopPWAsSubApps", &is_desktop_pw_as_sub_apps_enabled_},
    {"DetailsElementToggleEvent", &is_details_element_toggle_event_enabled_},
    {"DetailsStyling", &is_details_styling_enabled_},
    {"DeviceAttributes", &is_device_attributes_enabled_},
    {"DeviceOrientationRequestPermission", &is_device_orientation_request_permission_enabled_},
    {"DevicePosture", &is_device_posture_enabled_},
    {"DialogNewFocusBehavior", &is_dialog_new_focus_behavior_enabled_},
    {"DigitalGoods", &is_digital_goods_enabled_},
    {"DigitalGoodsV2_1", &is_digital_goods_v_2_1_enabled_},
    {"DirectSockets", &is_direct_sockets_enabled_},
    {"DirnameMoreInputTypes", &is_dirname_more_input_types_enabled_},
    {"DisableDifferentOriginSubframeDialogSuppression", &is_disable_different_origin_subframe_dialog_suppression_enabled_},
    {"DisableHardwareNoiseSuppression", &is_disable_hardware_noise_suppression_enabled_},
    {"DisableSelectAllForEmptyText", &is_disable_select_all_for_empty_text_enabled_},
    {"DisableThirdPartySessionStoragePartitioningAfterGeneralPartitioning", &is_disable_third_party_session_storage_partitioning_after_general_partitioning_enabled_},
    {"DisableThirdPartyStoragePartitioning", &is_disable_third_party_storage_partitioning_enabled_},
    {"DispatchHiddenVisibilityTransitions", &is_dispatch_hidden_visibility_transitions_enabled_},
    {"DisplayCutoutAPI", &is_display_cutout_api_enabled_},
    {"DocumentBaseURIFix", &is_document_base_uri_fix_enabled_},
    {"DocumentCookie", &is_document_cookie_enabled_},
    {"DocumentDomain", &is_document_domain_enabled_},
    {"DocumentOpenOriginAliasRemoval", &is_document_open_origin_alias_removal_enabled_},
    {"DocumentOpenSandboxInheritanceRemoval", &is_document_open_sandbox_inheritance_removal_enabled_},
    {"DocumentPictureInPictureAPI", &is_document_picture_in_picture_api_enabled_},
    {"DocumentPolicyDocumentDomain", &is_document_policy_document_domain_enabled_},
    {"DocumentPolicyNegotiation", &is_document_policy_negotiation_enabled_},
    {"DocumentPolicySyncXHR", &is_document_policy_sync_xhr_enabled_},
    {"DocumentRenderBlocking", &is_document_render_blocking_enabled_},
    {"DocumentWrite", &is_document_write_enabled_},
    {"DontFireDblclickOnDisabledFormControls", &is_dont_fire_dblclick_on_disabled_form_controls_enabled_},
    {"DynamicScrollCullRectExpansion", &is_dynamic_scroll_cull_rect_expansion_enabled_},
    {"EditContext", &is_edit_context_enabled_},
    {"ElementCapture", &is_element_capture_enabled_},
    {"EmptyClipboardRead", &is_empty_clipboard_read_enabled_},
    {"EnforceAnonymityExposure", &is_enforce_anonymity_exposure_enabled_},
    {"EscapeLtGtInAttributes", &is_escape_lt_gt_in_attributes_enabled_},
    {"EventTimingInteractionCount", &is_event_timing_interaction_count_enabled_},
    {"ExcludeBrokenImageIconFromBeingLcpEligible", &is_exclude_broken_image_icon_from_being_lcp_eligible_enabled_},
    {"ExperimentalContentSecurityPolicyFeatures", &is_experimental_content_security_policy_features_enabled_},
    {"ExperimentalJSProfilerMarkers", &is_experimental_js_profiler_markers_enabled_},
    {"ExperimentalPolicies", &is_experimental_policies_enabled_},
    {"ExposeRenderTimeNonTaoDelayedImage", &is_expose_render_time_non_tao_delayed_image_enabled_},
    {"ExtendedTextMetrics", &is_extended_text_metrics_enabled_},
    {"ExtraWebGLVideoTextureMetadata", &is_extra_webgl_video_texture_metadata_enabled_},
    {"EyeDropperAPI", &is_eye_dropper_api_enabled_},
    {"FaceDetector", &is_face_detector_enabled_},
    {"FakeNoAllocDirectCallForTesting", &is_fake_no_alloc_direct_call_for_testing_enabled_},
    {"FastPositionIterator", &is_fast_position_iterator_enabled_},
    {"FedCm", &is_fed_cm_enabled_},
    {"FedCmAuthz", &is_fed_cm_authz_enabled_},
    {"FedCmAutoSelectedFlag", &is_fed_cm_auto_selected_flag_enabled_},
    {"FedCmButtonMode", &is_fed_cm_button_mode_enabled_},
    {"FedCmDisconnect", &is_fed_cm_disconnect_enabled_},
    {"FedCmDomainHint", &is_fed_cm_domain_hint_enabled_},
    {"FedCmError", &is_fed_cm_error_enabled_},
    {"FedCmIdPRegistration", &is_fed_cm_id_p_registration_enabled_},
    {"FedCmIdpSigninStatus", &is_fed_cm_idp_signin_status_enabled_},
    {"FedCmMultipleIdentityProviders", &is_fed_cm_multiple_identity_providers_enabled_},
    {"FedCmSelectiveDisclosure", &is_fed_cm_selective_disclosure_enabled_},
    {"FencedFrames", &is_fenced_frames_enabled_},
    {"FencedFramesAPIChanges", &is_fenced_frames_api_changes_enabled_},
    {"FencedFramesDefaultMode", &is_fenced_frames_default_mode_enabled_},
    {"FencedFramesLocalUnpartitionedDataAccess", &is_fenced_frames_local_unpartitioned_data_access_enabled_},
    {"FetchLaterAPI", &is_fetch_later_api_enabled_},
    {"FetchUploadStreaming", &is_fetch_upload_streaming_enabled_},
    {"FileHandling", &is_file_handling_enabled_},
    {"FileHandlingIcons", &is_file_handling_icons_enabled_},
    {"FileSystem", &is_file_system_enabled_},
    {"FileSystemAccess", &is_file_system_access_enabled_},
    {"FileSystemAccessAPIExperimental", &is_file_system_access_api_experimental_enabled_},
    {"FileSystemAccessGetCloudIdentifiers", &is_file_system_access_get_cloud_identifiers_enabled_},
    {"FileSystemAccessLocal", &is_file_system_access_local_enabled_},
    {"FileSystemAccessLockingScheme", &is_file_system_access_locking_scheme_enabled_},
    {"FileSystemAccessOriginPrivate", &is_file_system_access_origin_private_enabled_},
    {"FileSystemObserver", &is_file_system_observer_enabled_},
    {"Fledge", &is_fledge_enabled_},
    {"FledgeBiddingAndAuctionServerAPI", &is_fledge_bidding_and_auction_server_api_enabled_},
    {"FledgeClearOriginJoinedAdInterestGroups", &is_fledge_clear_origin_joined_ad_interest_groups_enabled_},
    {"FledgeDirectFromSellerSignalsHeaderAdSlot", &is_fledge_direct_from_seller_signals_header_ad_slot_enabled_},
    {"FledgeFeatureDetection", &is_fledge_feature_detection_enabled_},
    {"FledgeNegativeTargeting", &is_fledge_negative_targeting_enabled_},
    {"FledgeTrustedBiddingSignalsSlotSize", &is_fledge_trusted_bidding_signals_slot_size_enabled_},
    {"FluentOverlayScrollbars", &is_fluent_overlay_scrollbars_enabled_},
    {"FluentScrollbars", &is_fluent_scrollbars_enabled_},
    {"FlushParserBeforeCreatingCustomElements", &is_flush_parser_before_creating_custom_elements_enabled_},
    {"FocusStyleInvalidationOnPageActivation", &is_focus_style_invalidation_on_page_activation_enabled_},
    {"Focusgroup", &is_focusgroup_enabled_},
    {"FontAccess", &is_font_access_enabled_},
    {"FontMatchingCTMigration", &is_font_matching_ct_migration_enabled_},
    {"FontPaletteAnimation", &is_font_palette_animation_enabled_},
    {"FontSrcLocalMatching", &is_font_src_local_matching_enabled_},
    {"FontationsFontBackend", &is_fontations_font_backend_enabled_},
    {"ForceEagerMeasureMemory", &is_force_eager_measure_memory_enabled_},
    {"ForceReduceMotion", &is_force_reduce_motion_enabled_},
    {"ForceTallerSelectPopup", &is_force_taller_select_popup_enabled_},
    {"ForcedColors", &is_forced_colors_enabled_},
    {"ForcedColorsPreserveParentColor", &is_forced_colors_preserve_parent_color_enabled_},
    {"FormControlRestoreStateIfAutocompleteOff", &is_form_control_restore_state_if_autocomplete_off_enabled_},
    {"FormControlsVerticalWritingModeDirectionSupport", &is_form_controls_vertical_writing_mode_direction_support_enabled_},
    {"FormControlsVerticalWritingModeSupport", &is_form_controls_vertical_writing_mode_support_enabled_},
    {"FormControlsVerticalWritingModeTextSupport", &is_form_controls_vertical_writing_mode_text_support_enabled_},
    {"FormStateRestoreCallbackCallWithState", &is_form_state_restore_callback_call_with_state_enabled_},
    {"FormattedText", &is_formatted_text_enabled_},
    {"FractionalScrollOffsets", &is_fractional_scroll_offsets_enabled_},
    {"FreezeFramesOnVisibility", &is_freeze_frames_on_visibility_enabled_},
    {"FullscreenPopupWindows", &is_fullscreen_popup_windows_enabled_},
    {"GamepadButtonAxisEvents", &is_gamepad_button_axis_events_enabled_},
    {"GamepadMultitouch", &is_gamepad_multitouch_enabled_},
    {"GetAllScreensMedia", &is_get_all_screens_media_enabled_},
    {"GetDisplayMedia", &is_get_display_media_enabled_},
    {"GetDisplayMediaRequiresUserActivation", &is_get_display_media_requires_user_activation_enabled_},
    {"GroupEffect", &is_group_effect_enabled_},
    {"HTMLInvokeActionsV2", &is_html_invoke_actions_v_2_enabled_},
    {"HTMLInvokeTargetAttribute", &is_html_invoke_target_attribute_enabled_},
    {"HTMLLangNewInheritance", &is_html_lang_new_inheritance_enabled_},
    {"HTMLParserFastPathBulkInsertNotify", &is_html_parser_fast_path_bulk_insert_notify_enabled_},
    {"HTMLParserYieldAndDelayOftenForTesting", &is_html_parser_yield_and_delay_often_for_testing_enabled_},
    {"HTMLPopoverHint", &is_html_popover_hint_enabled_},
    {"HTMLSearchElement", &is_html_search_element_enabled_},
    {"HTMLSelectElementShowPicker", &is_html_select_element_show_picker_enabled_},
    {"HTMLSelectListElement", &is_html_select_list_element_enabled_},
    {"HTMLUnsafeMethods", &is_html_unsafe_methods_enabled_},
    {"HandwritingRecognition", &is_handwriting_recognition_enabled_},
    {"HangingWhitespaceDoesNotDependOnAlignment", &is_hanging_whitespace_does_not_depend_on_alignment_enabled_},
    {"HasUAVisualTransition", &is_has_ua_visual_transition_enabled_},
    {"HighlightInheritance", &is_highlight_inheritance_enabled_},
    {"HighlightPointerEvents", &is_highlight_pointer_events_enabled_},
    {"HitTestOpaqueness", &is_hit_test_opaqueness_enabled_},
    {"HitTestTransparency", &is_hit_test_transparency_enabled_},
    {"HrefTranslate", &is_href_translate_enabled_},
    {"ImplicitRootScroller", &is_implicit_root_scroller_enabled_},
    {"ImportAttributesDisallowUnknownKeys", &is_import_attributes_disallow_unknown_keys_enabled_},
    {"IncomingCallNotifications", &is_incoming_call_notifications_enabled_},
    {"InertDisplayTransition", &is_inert_display_transition_enabled_},
    {"InfiniteCullRect", &is_infinite_cull_rect_enabled_},
    {"InheritUserModifyWithoutContenteditable", &is_inherit_user_modify_without_contenteditable_enabled_},
    {"InnerHTMLParserFastpathLogFailure", &is_inner_html_parser_fastpath_log_failure_enabled_},
    {"InputMultipleFieldsUI", &is_input_multiple_fields_ui_enabled_},
    {"InsertLineBreakIfPhrasingContent", &is_insert_line_break_if_phrasing_content_enabled_},
    {"InstalledApp", &is_installed_app_enabled_},
    {"InteroperablePrivateAttribution", &is_interoperable_private_attribution_enabled_},
    {"InterruptComposedScrollbarDisappearance", &is_interrupt_composed_scrollbar_disappearance_enabled_},
    {"IntersectionObserverScrollMargin", &is_intersection_observer_scroll_margin_enabled_},
    {"IntersectionOptimization", &is_intersection_optimization_enabled_},
    {"InvertedColors", &is_inverted_colors_enabled_},
    {"InvisibleSVGAnimationThrottling", &is_invisible_svg_animation_throttling_enabled_},
    {"JavaScriptCompileHintsMagicRuntime", &is_java_script_compile_hints_magic_runtime_enabled_},
    {"KeyboardAccessibleTooltip", &is_keyboard_accessible_tooltip_enabled_},
    {"KeyboardFocusableScrollers", &is_keyboard_focusable_scrollers_enabled_},
    {"LCPAnimatedImagesWebExposed", &is_lcp_animated_images_web_exposed_enabled_},
    {"LCPMouseoverHeuristics", &is_lcp_mouseover_heuristics_enabled_},
    {"LCPMultipleUpdatesPerElement", &is_lcp_multiple_updates_per_element_enabled_},
    {"LangAttributeAwareFormControlUI", &is_lang_attribute_aware_form_control_ui_enabled_},
    {"LayoutAlignForPositioned", &is_layout_align_for_positioned_enabled_},
    {"LayoutFlexNewRowAlgorithmV3", &is_layout_flex_new_row_algorithm_v_3_enabled_},
    {"LayoutIgnoreMarginsForSticky", &is_layout_ignore_margins_for_sticky_enabled_},
    {"LayoutNGShapeCache", &is_layout_ng_shape_cache_enabled_},
    {"LayoutNewContainingBlock", &is_layout_new_containing_block_enabled_},
    {"LayoutNewMeasureCache", &is_layout_new_measure_cache_enabled_},
    {"LayoutNewMinMaxCache", &is_layout_new_min_max_cache_enabled_},
    {"LazyInitializeMediaControls", &is_lazy_initialize_media_controls_enabled_},
    {"LazyLoadScrollMargin", &is_lazy_load_scroll_margin_enabled_},
    {"LegacyWindowsDWriteFontFallback", &is_legacy_windows_d_write_font_fallback_enabled_},
    {"LockedMode", &is_locked_mode_enabled_},
    {"LongAnimationFrameTiming", &is_long_animation_frame_timing_enabled_},
    {"LongTaskFromLongAnimationFrame", &is_long_task_from_long_animation_frame_enabled_},
    {"MacFontsDeprecateFontTraitsWorkaround", &is_mac_fonts_deprecate_font_traits_workaround_enabled_},
    {"MachineLearningCommon", &is_machine_learning_common_enabled_},
    {"MachineLearningModelLoader", &is_machine_learning_model_loader_enabled_},
    {"MachineLearningNeuralNetwork", &is_machine_learning_neural_network_enabled_},
    {"ManagedConfiguration", &is_managed_configuration_enabled_},
    {"MaskingGraphemeClusters", &is_masking_grapheme_clusters_enabled_},
    {"MeasureMemory", &is_measure_memory_enabled_},
    {"MediaCapabilitiesDynamicRange", &is_media_capabilities_dynamic_range_enabled_},
    {"MediaCapabilitiesEncodingInfo", &is_media_capabilities_encoding_info_enabled_},
    {"MediaCapabilitiesSpatialAudio", &is_media_capabilities_spatial_audio_enabled_},
    {"MediaCapture", &is_media_capture_enabled_},
    {"MediaCaptureBackgroundBlur", &is_media_capture_background_blur_enabled_},
    {"MediaCaptureCameraControls", &is_media_capture_camera_controls_enabled_},
    {"MediaCaptureConfigurationChange", &is_media_capture_configuration_change_enabled_},
    {"MediaCaptureVoiceIsolation", &is_media_capture_voice_isolation_enabled_},
    {"MediaCastOverlayButton", &is_media_cast_overlay_button_enabled_},
    {"MediaControlsExpandGesture", &is_media_controls_expand_gesture_enabled_},
    {"MediaControlsOverlayPlayButton", &is_media_controls_overlay_play_button_enabled_},
    {"MediaElementVolumeGreaterThanOne", &is_media_element_volume_greater_than_one_enabled_},
    {"MediaEngagementBypassAutoplayPolicies", &is_media_engagement_bypass_autoplay_policies_enabled_},
    {"MediaLatencyHint", &is_media_latency_hint_enabled_},
    {"MediaQueryNavigationControls", &is_media_query_navigation_controls_enabled_},
    {"MediaRecorderUseMediaVideoEncoder", &is_media_recorder_use_media_video_encoder_enabled_},
    {"MediaSession", &is_media_session_enabled_},
    {"MediaSessionChapterInformation", &is_media_session_chapter_information_enabled_},
    {"MediaSessionEnterPictureInPicture", &is_media_session_enter_picture_in_picture_enabled_},
    {"MediaSourceExperimental", &is_media_source_experimental_enabled_},
    {"MediaSourceExtensionsForWebCodecs", &is_media_source_extensions_for_webcodecs_enabled_},
    {"MediaSourceNewAbortAndDuration", &is_media_source_new_abort_and_duration_enabled_},
    {"MediaStreamTrackTransfer", &is_media_stream_track_transfer_enabled_},
    {"MessagePortCloseEvent", &is_message_port_close_event_enabled_},
    {"MiddleClickAutoscroll", &is_middle_click_autoscroll_enabled_},
    {"MobileLayoutTheme", &is_mobile_layout_theme_enabled_},
    {"ModelExecutionAPI", &is_model_execution_api_enabled_},
    {"MojoJS", &is_mojo_js_enabled_},
    {"MojoJSTest", &is_mojo_js_test_enabled_},
    {"MonitorTypeSurfaces", &is_monitor_type_surfaces_enabled_},
    {"MouseDragFromIframeOnCancelledMouseDown", &is_mouse_drag_from_iframe_on_cancelled_mouse_down_enabled_},
    {"MouseDragOnCancelledMouseMove", &is_mouse_drag_on_cancelled_mouse_move_enabled_},
    {"MutationEvents", &is_mutation_events_enabled_},
    {"NavigateEventCommitBehavior", &is_navigate_event_commit_behavior_enabled_},
    {"NavigateEventSourceElement", &is_navigate_event_source_element_enabled_},
    {"NavigationActivation", &is_navigation_activation_enabled_},
    {"NavigationId", &is_navigation_id_enabled_},
    {"NavigatorContentUtils", &is_navigator_content_utils_enabled_},
    {"NetInfoConstantType", &is_net_info_constant_type_enabled_},
    {"NetInfoDownlinkMax", &is_net_info_downlink_max_enabled_},
    {"NextSiblingPositionUseNextCandidate", &is_next_sibling_position_use_next_candidate_enabled_},
    {"NoIdleEncodingForWebTests", &is_no_idle_encoding_for_web_tests_enabled_},
    {"NoOffsetMappingForInconsistentText", &is_no_offset_mapping_for_inconsistent_text_enabled_},
    {"NoVarySearchPrefetch", &is_no_vary_search_prefetch_enabled_},
    {"NonComposedEnterLeaveEvents", &is_non_composed_enter_leave_events_enabled_},
    {"NonStandardAppearanceValueSliderVertical", &is_non_standard_appearance_value_slider_vertical_enabled_},
    {"NonStandardAppearanceValuesHighUsage", &is_non_standard_appearance_values_high_usage_enabled_},
    {"NonStandardAppearanceValuesLowUsage", &is_non_standard_appearance_values_low_usage_enabled_},
    {"NotificationConstructor", &is_notification_constructor_enabled_},
    {"NotificationContentImage", &is_notification_content_image_enabled_},
    {"NotificationTriggers", &is_notification_triggers_enabled_},
    {"Notifications", &is_notifications_enabled_},
    {"ObservableAPI", &is_observable_api_enabled_},
    {"OffMainThreadCSSPaint", &is_off_main_thread_css_paint_enabled_},
    {"OffscreenCanvasCommit", &is_offscreen_canvas_commit_enabled_},
    {"OffsetMappingUnitVariable", &is_offset_mapping_unit_variable_enabled_},
    {"OnDeviceChange", &is_on_device_change_enabled_},
    {"OnePassRasterInvalidation", &is_one_pass_raster_invalidation_enabled_},
    {"OptionElementAlwaysUseLabel", &is_option_element_always_use_label_enabled_},
    {"OrientationEvent", &is_orientation_event_enabled_},
    {"OriginIsolationHeader", &is_origin_isolation_header_enabled_},
    {"OriginPolicy", &is_origin_policy_enabled_},
    {"OriginTrialsSampleAPI", &is_origin_trials_sample_api_enabled_},
    {"OriginTrialsSampleAPIBrowserReadWrite", &is_origin_trials_sample_api_browser_read_write_enabled_},
    {"OriginTrialsSampleAPIDependent", &is_origin_trials_sample_api_dependent_enabled_},
    {"OriginTrialsSampleAPIDeprecation", &is_origin_trials_sample_api_deprecation_enabled_},
    {"OriginTrialsSampleAPIExpiryGracePeriod", &is_origin_trials_sample_api_expiry_grace_period_enabled_},
    {"OriginTrialsSampleAPIExpiryGracePeriodThirdParty", &is_origin_trials_sample_api_expiry_grace_period_third_party_enabled_},
    {"OriginTrialsSampleAPIImplied", &is_origin_trials_sample_api_implied_enabled_},
    {"OriginTrialsSampleAPIInvalidOS", &is_origin_trials_sample_api_invalid_os_enabled_},
    {"OriginTrialsSampleAPINavigation", &is_origin_trials_sample_api_navigation_enabled_},
    {"OriginTrialsSampleAPIPersistentExpiryGracePeriod", &is_origin_trials_sample_api_persistent_expiry_grace_period_enabled_},
    {"OriginTrialsSampleAPIPersistentFeature", &is_origin_trials_sample_api_persistent_feature_enabled_},
    {"OriginTrialsSampleAPIPersistentInvalidOS", &is_origin_trials_sample_api_persistent_invalid_os_enabled_},
    {"OriginTrialsSampleAPIPersistentThirdPartyDeprecationFeature", &is_origin_trials_sample_api_persistent_third_party_deprecation_feature_enabled_},
    {"OriginTrialsSampleAPIThirdParty", &is_origin_trials_sample_api_third_party_enabled_},
    {"OverscrollCustomization", &is_overscroll_customization_enabled_},
    {"PNaCl", &is_p_na_cl_enabled_},
    {"PageFreezeOptIn", &is_page_freeze_opt_in_enabled_},
    {"PageFreezeOptOut", &is_page_freeze_opt_out_enabled_},
    {"PageMarginBoxes", &is_page_margin_boxes_enabled_},
    {"PagePopup", &is_page_popup_enabled_},
    {"PageRevealEvent", &is_page_reveal_event_enabled_},
    {"PaintUnderInvalidationChecking", &is_paint_under_invalidation_checking_enabled_},
    {"Parakeet", &is_parakeet_enabled_},
    {"PartitionedCookies", &is_partitioned_cookies_enabled_},
    {"PasswordReveal", &is_password_reveal_enabled_},
    {"PasswordStrongLabel", &is_password_strong_label_enabled_},
    {"PastingBlocksSVGUseNonLocalHrefs", &is_pasting_blocks_svg_use_non_local_hrefs_enabled_},
    {"PaymentApp", &is_payment_app_enabled_},
    {"PaymentHandlerMinimalHeaderUX", &is_payment_handler_minimal_header_ux_enabled_},
    {"PaymentInstruments", &is_payment_instruments_enabled_},
    {"PaymentMethodChangeEvent", &is_payment_method_change_event_enabled_},
    {"PaymentRequest", &is_payment_request_enabled_},
    {"PaymentRequestAllowOneActivationlessShow", &is_payment_request_allow_one_activationless_show_enabled_},
    {"PaymentRequestMerchantValidationEvent", &is_payment_request_merchant_validation_event_enabled_},
    {"PendingBeaconAPI", &is_pending_beacon_api_enabled_},
    {"PerMethodCanMakePaymentQuota", &is_per_method_can_make_payment_quota_enabled_},
    {"PercentBasedScrolling", &is_percent_based_scrolling_enabled_},
    {"PerformanceManagerInstrumentation", &is_performance_manager_instrumentation_enabled_},
    {"PerformanceMarkFeatureUsage", &is_performance_mark_feature_usage_enabled_},
    {"PerformanceNavigateSystemEntropy", &is_performance_navigate_system_entropy_enabled_},
    {"PeriodicBackgroundSync", &is_periodic_background_sync_enabled_},
    {"PermissionElement", &is_permission_element_enabled_},
    {"Permissions", &is_permissions_enabled_},
    {"PermissionsRequestRevoke", &is_permissions_request_revoke_enabled_},
    {"PointerCaptureLostOnRemovalDuringCapture", &is_pointer_capture_lost_on_removal_during_capture_enabled_},
    {"PointerEventDeviceId", &is_pointer_event_device_id_enabled_},
    {"PositionOutsideTabSpanCheckSiblingNode", &is_position_outside_tab_span_check_sibling_node_enabled_},
    {"PrePaintAncestorsOfMissedOOF", &is_pre_paint_ancestors_of_missed_oof_enabled_},
    {"PreciseMemoryInfo", &is_precise_memory_info_enabled_},
    {"PreferNonCompositedScrolling", &is_prefer_non_composited_scrolling_enabled_},
    {"PrefersReducedData", &is_prefers_reduced_data_enabled_},
    {"PrefixedVideoFullscreen", &is_prefixed_video_fullscreen_enabled_},
    {"Prerender2", &is_prerender_2_enabled_},
    {"Presentation", &is_presentation_enabled_},
    {"PrettyPrintJSONDocument", &is_pretty_print_js_on_document_enabled_},
    {"PreventReadingSystemAccentColor", &is_prevent_reading_system_accent_color_enabled_},
    {"PrivacySandboxAdsAPIs", &is_privacy_sandbox_ads_api_s_enabled_},
    {"PrivateNetworkAccessNonSecureContextsAllowed", &is_private_network_access_non_secure_contexts_allowed_enabled_},
    {"PrivateNetworkAccessNullIpAddress", &is_private_network_access_null_ip_address_enabled_},
    {"PrivateNetworkAccessPermissionPrompt", &is_private_network_access_permission_prompt_enabled_},
    {"PrivateStateTokens", &is_private_state_tokens_enabled_},
    {"PrivateStateTokensAlwaysAllowIssuance", &is_private_state_tokens_always_allow_issuance_enabled_},
    {"PushMessaging", &is_push_messaging_enabled_},
    {"PushMessagingSubscriptionChange", &is_push_messaging_subscription_change_enabled_},
    {"QuickIntensiveWakeUpThrottlingAfterLoading", &is_quick_intensive_wake_up_throttling_after_loading_enabled_},
    {"QuotaChange", &is_quota_change_enabled_},
    {"RTCEncodedAudioFrameAbsCaptureTime", &is_rtc_encoded_audio_frame_abs_capture_time_enabled_},
    {"RTCEncodedFrameSetMetadata", &is_rtc_encoded_frame_set_metadata_enabled_},
    {"RTCEncodedVideoFrameAdditionalMetadata", &is_rtc_encoded_video_frame_additional_metadata_enabled_},
    {"RTCLegacyCallbackBasedGetStats", &is_rtc_legacy_callback_based_get_stats_enabled_},
    {"RTCRtpEncodingParametersCodec", &is_rtc_rtp_encoding_parameters_codec_enabled_},
    {"RTCRtpHeaderExtensionControl", &is_rtc_rtp_header_extension_control_enabled_},
    {"RTCStatsRelativePacketArrivalDelay", &is_rtc_stats_relative_packet_arrival_delay_enabled_},
    {"RTCSvcScalabilityMode", &is_rtc_svc_scalability_mode_enabled_},
    {"ReadableStreamTeeCloneForBranch2", &is_readable_stream_tee_clone_for_branch_2_enabled_},
    {"ReduceAcceptLanguage", &is_reduce_accept_language_enabled_},
    {"ReduceCookieIPCs", &is_reduce_cookie_ip_cs_enabled_},
    {"ReduceUserAgentAndroidVersionDeviceModel", &is_reduce_user_agent_android_version_device_model_enabled_},
    {"ReduceUserAgentMinorVersion", &is_reduce_user_agent_minor_version_enabled_},
    {"ReduceUserAgentPlatformOsCpu", &is_reduce_user_agent_platform_os_cpu_enabled_},
    {"ReferenceBoxNoPixelSnapping", &is_reference_box_no_pixel_snapping_enabled_},
    {"RegionCapture", &is_region_capture_enabled_},
    {"RemotePlayback", &is_remote_playback_enabled_},
    {"RemotePlaybackBackend", &is_remote_playback_backend_enabled_},
    {"RemoveDanglingMarkupInTarget", &is_remove_dangling_markup_in_target_enabled_},
    {"RemoveDataUrlInSvgUse", &is_remove_data_url_in_svg_use_enabled_},
    {"RemoveMobileViewportDoubleTap", &is_remove_mobile_viewport_double_tap_enabled_},
    {"RemoveZoomAdjustmentOfBoundingBox", &is_remove_zoom_adjustment_of_bounding_box_enabled_},
    {"RenderBlockingStatus", &is_render_blocking_status_enabled_},
    {"RenderPriorityAttribute", &is_render_priority_attribute_enabled_},
    {"ResourceTimingContentType", &is_resource_timing_content_type_enabled_},
    {"ResourceTimingUseCORSForBodySizes", &is_resource_timing_use_cors_for_body_sizes_enabled_},
    {"RestrictGamepadAccess", &is_restrict_gamepad_access_enabled_},
    {"RewindFloats", &is_rewind_floats_enabled_},
    {"RtcAudioJitterBufferMaxPackets", &is_rtc_audio_jitter_buffer_max_packets_enabled_},
    {"RubyInlinify", &is_ruby_inlinify_enabled_},
    {"RubySimplePairing", &is_ruby_simple_pairing_enabled_},
    {"RunMicrotaskBeforeXmlCustomElement", &is_run_microtask_before_xml_custom_element_enabled_},
    {"SanitizerAPI", &is_sanitizer_api_enabled_},
    {"SchedulerYield", &is_scheduler_yield_enabled_},
    {"ScopedCustomElementRegistry", &is_scoped_custom_element_registry_enabled_},
    {"ScriptedSpeechRecognition", &is_scripted_speech_recognition_enabled_},
    {"ScriptedSpeechSynthesis", &is_scripted_speech_synthesis_enabled_},
    {"ScrollEndEvents", &is_scroll_end_events_enabled_},
    {"ScrollTimeline", &is_scroll_timeline_enabled_},
    {"ScrollTimelineCurrentTime", &is_scroll_timeline_current_time_enabled_},
    {"ScrollTimelineOnCompositor", &is_scroll_timeline_on_compositor_enabled_},
    {"ScrollTopLeftInterop", &is_scroll_top_left_interop_enabled_},
    {"ScrollbarColor", &is_scrollbar_color_enabled_},
    {"ScrollbarWidth", &is_scrollbar_width_enabled_},
    {"SecurePaymentConfirmation", &is_secure_payment_confirmation_enabled_},
    {"SecurePaymentConfirmationAllowOneActivationlessShow", &is_secure_payment_confirmation_allow_one_activationless_show_enabled_},
    {"SecurePaymentConfirmationDebug", &is_secure_payment_confirmation_debug_enabled_},
    {"SecurePaymentConfirmationExtensions", &is_secure_payment_confirmation_extensions_enabled_},
    {"SecurePaymentConfirmationOptOut", &is_secure_payment_confirmation_opt_out_enabled_},
    {"SelectHr", &is_select_hr_enabled_},
    {"SendBeaconThrowForBlobWithNonSimpleType", &is_send_beacon_throw_for_blob_with_non_simple_type_enabled_},
    {"SensorExtraClasses", &is_sensor_extra_classes_enabled_},
    {"Serial", &is_serial_enabled_},
    {"SerializeViewTransitionStateInSPA", &is_serialize_view_transition_state_in_spa_enabled_},
    {"ServiceWorkerBypassFetchHandler", &is_service_worker_bypass_fetch_handler_enabled_},
    {"ServiceWorkerClientLifecycleState", &is_service_worker_client_lifecycle_state_enabled_},
    {"ServiceWorkerRaceNetworkRequest", &is_service_worker_race_network_request_enabled_},
    {"ServiceWorkerStaticRouter", &is_service_worker_static_router_enabled_},
    {"SetSequentialFocusStartingPoint", &is_set_sequential_focus_starting_point_enabled_},
    {"ShadowRootAttachmentNewBehavior", &is_shadow_root_attachment_new_behavior_enabled_},
    {"SharedArrayBuffer", &is_shared_array_buffer_enabled_},
    {"SharedArrayBufferOnDesktop", &is_shared_array_buffer_on_desktop_enabled_},
    {"SharedArrayBufferUnrestrictedAccessAllowed", &is_shared_array_buffer_unrestricted_access_allowed_enabled_},
    {"SharedAutofill", &is_shared_autofill_enabled_},
    {"SharedStorageAPI", &is_shared_storage_api_enabled_},
    {"SharedStorageAPIM118", &is_shared_storage_api_m_118_enabled_},
    {"SharedWorker", &is_shared_worker_enabled_},
    {"SignatureBasedIntegrity", &is_signature_based_integrity_enabled_},
    {"SiteInitiatedMirroring", &is_site_initiated_mirroring_enabled_},
    {"SkipAd", &is_skip_ad_enabled_},
    {"SkipTouchEventFilter", &is_skip_touch_event_filter_enabled_},
    {"SmartCard", &is_smart_card_enabled_},
    {"SmartZoom", &is_smart_zoom_enabled_},
    {"SmilAutoSuspendOnLag", &is_smil_auto_suspend_on_lag_enabled_},
    {"SnapBorderWidthsBeforeLayout", &is_snap_border_widths_before_layout_enabled_},
    {"SoftNavigationDetection", &is_soft_navigation_detection_enabled_},
    {"SoftNavigationHeuristics", &is_soft_navigation_heuristics_enabled_},
    {"SoftNavigationHeuristicsExposeFPAndFCP", &is_soft_navigation_heuristics_expose_fp_and_fcp_enabled_},
    {"SparseObjectPaintProperties", &is_sparse_object_paint_properties_enabled_},
    {"SpeculationRulesDocumentRules", &is_speculation_rules_document_rules_enabled_},
    {"SpeculationRulesDocumentRulesSelectorMatches", &is_speculation_rules_document_rules_selector_matches_enabled_},
    {"SpeculationRulesEagerness", &is_speculation_rules_eagerness_enabled_},
    {"SpeculationRulesFetchFromHeader", &is_speculation_rules_fetch_from_header_enabled_},
    {"SpeculationRulesImplicitSource", &is_speculation_rules_implicit_source_enabled_},
    {"SpeculationRulesNoVarySearchHint", &is_speculation_rules_no_vary_search_hint_enabled_},
    {"SpeculationRulesNoVarySearchHintShippedByDefault", &is_speculation_rules_no_vary_search_hint_shipped_by_default_enabled_},
    {"SpeculationRulesPointerDownHeuristics", &is_speculation_rules_pointer_down_heuristics_enabled_},
    {"SpeculationRulesPointerHoverHeuristics", &is_speculation_rules_pointer_hover_heuristics_enabled_},
    {"SpeculationRulesPrefetchFuture", &is_speculation_rules_prefetch_future_enabled_},
    {"SpeculationRulesPrefetchWithSubresources", &is_speculation_rules_prefetch_with_subresources_enabled_},
    {"SpeculationRulesRelativeToDocument", &is_speculation_rules_relative_to_document_enabled_},
    {"SpellCheckerReplaceRangeUseInsertText", &is_spell_checker_replace_range_use_insert_text_enabled_},
    {"SrcsetMaxDensity", &is_srcset_max_density_enabled_},
    {"StableBlinkFeatures", &is_stable_blink_features_enabled_},
    {"StorageAccessAPIBeyondCookies", &is_storage_access_api_beyond_cookies_enabled_},
    {"StorageBuckets", &is_storage_buckets_enabled_},
    {"StorageBucketsDurability", &is_storage_buckets_durability_enabled_},
    {"StorageBucketsLocks", &is_storage_buckets_locks_enabled_},
    {"StrictMimeTypesForWorkers", &is_strict_mime_types_for_workers_enabled_},
    {"StylableSelect", &is_stylable_select_enabled_},
    {"StylusHandwriting", &is_stylus_handwriting_enabled_},
    {"SuggestionPickerDarkModeSupport", &is_suggestion_picker_dark_mode_support_enabled_},
    {"SvgCrossOriginAttribute", &is_svg_cross_origin_attribute_enabled_},
    {"SvgNoPixelSnappingScaleAdjustment", &is_svg_no_pixel_snapping_scale_adjustment_enabled_},
    {"SvgTextFixHittestAfterScale", &is_svg_text_fix_hittest_after_scale_enabled_},
    {"SynthesizedKeyboardEventsForAccessibilityActions", &is_synthesized_keyboard_events_for_accessibility_actions_enabled_},
    {"SystemWakeLock", &is_system_wake_lock_enabled_},
    {"TestFeature", &is_test_feature_enabled_},
    {"TestFeatureDependent", &is_test_feature_dependent_enabled_},
    {"TestFeatureImplied", &is_test_feature_implied_enabled_},
    {"TextDecoratingBox", &is_text_decorating_box_enabled_},
    {"TextDetector", &is_text_detector_enabled_},
    {"TextFragmentAPI", &is_text_fragment_api_enabled_},
    {"TextFragmentIdentifiers", &is_text_fragment_identifiers_enabled_},
    {"TextFragmentTapOpensContextMenu", &is_text_fragment_tap_opens_context_menu_enabled_},
    {"TextMetricsBaselines", &is_text_metrics_baselines_enabled_},
    {"TimeZoneChangeEvent", &is_time_zone_change_event_enabled_},
    {"TimelineScope", &is_timeline_scope_enabled_},
    {"TimerThrottlingForBackgroundTabs", &is_timer_throttling_for_background_tabs_enabled_},
    {"TopLevelTpcd", &is_top_level_tpcd_enabled_},
    {"TopicsAPI", &is_topics_api_enabled_},
    {"TopicsDocumentAPI", &is_topics_document_api_enabled_},
    {"TouchDragAndContextMenu", &is_touch_drag_and_context_menu_enabled_},
    {"TouchDragOnShortPress", &is_touch_drag_on_short_press_enabled_},
    {"TouchEventFeatureDetection", &is_touch_event_feature_detection_enabled_},
    {"TouchTextEditingRedesign", &is_touch_text_editing_redesign_enabled_},
    {"Tpcd", &is_tpcd_enabled_},
    {"TranslateService", &is_translate_service_enabled_},
    {"TrustedTypeBeforePolicyCreationEvent", &is_trusted_type_before_policy_creation_event_enabled_},
    {"TrustedTypesFromLiteral", &is_trusted_types_from_literal_enabled_},
    {"TrustedTypesUseCodeLike", &is_trusted_types_use_code_like_enabled_},
    {"URLAttributeFix", &is_url_attribute_fix_enabled_},
    {"URLPatternCompareComponent", &is_url_pattern_compare_component_enabled_},
    {"URLPatternHasRegExpGroups", &is_url_pattern_has_reg_exp_groups_enabled_},
    {"URLPatternRegexpUnicodeSetsMode", &is_url_pattern_regexp_unicode_sets_mode_enabled_},
    {"URLPatternWildcardMoreOften", &is_url_pattern_wildcard_more_often_enabled_},
    {"URLSearchParamsHasAndDeleteMultipleArgs", &is_url_search_params_has_and_delete_multiple_args_enabled_},
    {"UnclosedFormControlIsInvalid", &is_unclosed_form_control_is_invalid_enabled_},
    {"UnexposedTaskIds", &is_unexposed_task_ids_enabled_},
    {"UnownedAnimationsSkipCSSEvents", &is_unowned_animations_skip_css_events_enabled_},
    {"UnrestrictedMeasureUserAgentSpecificMemory", &is_unrestricted_measure_user_agent_specific_memory_enabled_},
    {"UnrestrictedSharedArrayBuffer", &is_unrestricted_shared_array_buffer_enabled_},
    {"UnrestrictedUsb", &is_unrestricted_usb_enabled_},
    {"UseBeginFramePresentationFeedback", &is_use_begin_frame_presentation_feedback_enabled_},
    {"UsedColorSchemeRootScrollbars", &is_used_color_scheme_root_scrollbars_enabled_},
    {"UserActivationSameOriginVisibility", &is_user_activation_same_origin_visibility_enabled_},
    {"UserValidUserInvalid", &is_user_valid_user_invalid_enabled_},
    {"V8IdleTasks", &is_v8_idle_tasks_enabled_},
    {"VideoAutoFullscreen", &is_video_auto_fullscreen_enabled_},
    {"VideoFullscreenOrientationLock", &is_video_fullscreen_orientation_lock_enabled_},
    {"VideoPlaybackQuality", &is_video_playback_quality_enabled_},
    {"VideoRotateToFullscreen", &is_video_rotate_to_fullscreen_enabled_},
    {"VideoTrackGenerator", &is_video_track_generator_enabled_},
    {"VideoTrackGeneratorInWindow", &is_video_track_generator_in_window_enabled_},
    {"VideoTrackGeneratorInWorker", &is_video_track_generator_in_worker_enabled_},
    {"ViewTransitionOnNavigation", &is_view_transition_on_navigation_enabled_},
    {"ViewTransitionTypes", &is_view_transition_types_enabled_},
    {"ViewportHeightClientHintHeader", &is_viewport_height_client_hint_header_enabled_},
    {"ViewportSegments", &is_viewport_segments_enabled_},
    {"VisibilityCollapseColumn", &is_visibility_collapse_column_enabled_},
    {"WGIGamepadTriggerRumble", &is_wgi_gamepad_trigger_rumble_enabled_},
    {"WakeLock", &is_wake_lock_enabled_},
    {"WarnOnContentVisibilityRenderAccess", &is_warn_on_content_visibility_render_access_enabled_},
    {"WebAnimationsSVG", &is_web_animations_svg_enabled_},
    {"WebAppDarkMode", &is_web_app_dark_mode_enabled_},
    {"WebAppLaunchHandler", &is_web_app_launch_handler_enabled_},
    {"WebAppLaunchQueue", &is_web_app_launch_queue_enabled_},
    {"WebAppScopeExtensions", &is_web_app_scope_extensions_enabled_},
    {"WebAppTabStrip", &is_web_app_tab_strip_enabled_},
    {"WebAppTabStripCustomizations", &is_web_app_tab_strip_customizations_enabled_},
    {"WebAppTranslations", &is_web_app_translations_enabled_},
    {"WebAppUrlHandling", &is_web_app_url_handling_enabled_},
    {"WebAppWindowControlsOverlay", &is_web_app_window_controls_overlay_enabled_},
    {"WebAppsLockScreen", &is_web_apps_lock_screen_enabled_},
    {"WebAssemblyJSStringBuiltins", &is_web_assembly_js_string_builtins_enabled_},
    {"WebAuth", &is_web_auth_enabled_},
    {"WebAuthAllowCreateInCrossOriginFrame", &is_web_auth_allow_create_in_cross_origin_frame_enabled_},
    {"WebAuthAuthenticatorAttachment", &is_web_auth_authenticator_attachment_enabled_},
    {"WebAuthenticationHints", &is_web_authentication_hints_enabled_},
    {"WebAuthenticationJSONSerialization", &is_web_authentication_js_on_serialization_enabled_},
    {"WebAuthenticationLargeBlobExtension", &is_web_authentication_large_blob_extension_enabled_},
    {"WebAuthenticationPRF", &is_web_authentication_prf_enabled_},
    {"WebAuthenticationRemoteDesktopSupport", &is_web_authentication_remote_desktop_support_enabled_},
    {"WebAuthenticationSupplementalPubKeys", &is_web_authentication_supplemental_pub_keys_enabled_},
    {"WebBluetooth", &is_web_bluetooth_enabled_},
    {"WebBluetoothGetDevices", &is_web_bluetooth_get_devices_enabled_},
    {"WebBluetoothScanning", &is_web_bluetooth_scanning_enabled_},
    {"WebBluetoothWatchAdvertisements", &is_web_bluetooth_watch_advertisements_enabled_},
    {"WebCodecsContentHint", &is_webcodecs_content_hint_enabled_},
    {"WebCodecsCopyToRGB", &is_webcodecs_copy_to_rgb_enabled_},
    {"WebCryptoCurve25519", &is_web_crypto_curve_25519_enabled_},
    {"WebFontResizeLCP", &is_web_font_resize_lcp_enabled_},
    {"WebGLDeveloperExtensions", &is_webgl_developer_extensions_enabled_},
    {"WebGLDraftExtensions", &is_webgl_draft_extensions_enabled_},
    {"WebGLDrawingBufferStorage", &is_webgl_drawing_buffer_storage_enabled_},
    {"WebGLImageChromium", &is_webgl_image_chromium_enabled_},
    {"WebGPUDeveloperFeatures", &is_webgpu_developer_features_enabled_},
    {"WebHID", &is_web_hid_enabled_},
    {"WebHIDOnServiceWorkers", &is_web_hid_on_service_workers_enabled_},
    {"WebIDLBigIntUsesToBigInt", &is_web_idl_big_int_uses_to_big_int_enabled_},
    {"WebIdentityDigitalCredentials", &is_web_identity_digital_credentials_enabled_},
    {"WebKitScrollbarStyling", &is_web_kit_scrollbar_styling_enabled_},
    {"WebNFC", &is_web_nfc_enabled_},
    {"WebOTP", &is_web_otp_enabled_},
    {"WebOTPAssertionFeaturePolicy", &is_web_otp_assertion_feature_policy_enabled_},
    {"WebPreferences", &is_web_preferences_enabled_},
    {"WebPrinting", &is_web_printing_enabled_},
    {"WebSerialBluetooth", &is_web_serial_bluetooth_enabled_},
    {"WebShare", &is_web_share_enabled_},
    {"WebSocketStream", &is_websocket_stream_enabled_},
    {"WebTransportCustomCertificates", &is_web_transport_custom_certificates_enabled_},
    {"WebUSB", &is_web_usb_enabled_},
    {"WebUSBOnDedicatedWorkers", &is_web_usb_on_dedicated_workers_enabled_},
    {"WebUSBOnServiceWorkers", &is_web_usb_on_service_workers_enabled_},
    {"WebVTTRegions", &is_web_vtt_regions_enabled_},
    {"WebViewXRequestedWithDeprecation", &is_web_view_xr_equested_with_deprecation_enabled_},
    {"WebXR", &is_web_xr_enabled_},
    {"WebXREnabledFeatures", &is_web_xr_enabled_features_enabled_},
    {"WebXRFrameRate", &is_web_xr_frame_rate_enabled_},
    {"WebXRFrontFacing", &is_web_xr_front_facing_enabled_},
    {"WebXRHandInput", &is_web_xr_hand_input_enabled_},
    {"WebXRHitTestEntityTypes", &is_web_xr_hit_test_entity_types_enabled_},
    {"WebXRImageTracking", &is_web_xr_image_tracking_enabled_},
    {"WebXRLayers", &is_web_xr_layers_enabled_},
    {"WebXRPlaneDetection", &is_web_xr_plane_detection_enabled_},
    {"WebXRPoseMotionData", &is_web_xr_pose_motion_data_enabled_},
    {"WindowDefaultStatus", &is_window_default_status_enabled_},
    {"WindowPlacementFullscreenOnScreensChange", &is_window_placement_fullscreen_on_screens_change_enabled_},
    {"WindowPlacementPermissionAlias", &is_window_placement_permission_alias_enabled_},
    {"XMLParserMergeAdjacentCDataSections", &is_xml_parser_merge_adjacent_c_data_sections_enabled_},
    {"XYWHAndRectComputedValue", &is_xywh_and_rect_computed_value_enabled_},
    {"ZeroCopyTabCapture", &is_zero_copy_tab_capture_enabled_},
  };

  auto feature = std::lower_bound(std::begin(kFeatures), std::end(kFeatures), name, [](const auto& feature, const std::string& name) {
    return feature.name < name;
  });

  if (feature != std::end(kFeatures) && feature->name == name)
    *feature->setting = enable;
  else
    DLOG(ERROR) << "RuntimeEnabledFeature not recognized: " << name;
}

// static
void RuntimeEnabledFeaturesBase::UpdateStatusFromBaseFeatures() {
  struct BaseFeatureToRuntimeFeatureMap {
    const base::Feature& feature;
    void (*enabler)(bool enable);
    bool if_overridden;
  };
  const BaseFeatureToRuntimeFeatureMap mappings[] = {
    {blink::features::kAccessibilityOSLevelBoldText, SetAccessibilityOSLevelBoldTextEnabled,
     false},
    {blink::features::kAccordionPattern, SetAccordionPatternEnabled,
     false},
    {blink::features::kAdInterestGroupAPI, SetAdInterestGroupAPIEnabled,
     false},
    {blink::features::kAddIdentityInCanMakePaymentEvent, SetAddIdentityInCanMakePaymentEventEnabled,
     false},
    {blink::features::kAlignContentForBlocks, SetAlignContentForBlocksEnabled,
     false},
    {blink::features::kAppTitle, SetAppTitleEnabled,
     false},
    {blink::features::kArrowKeysInVerticalWritingModes, SetArrowKeysInVerticalWritingModesEnabled,
     false},
    {blink::features::kAsyncClipboardImplicitPermission, SetAsyncClipboardImplicitPermissionEnabled,
     false},
    {blink::features::kAutoSizeLazyLoadedImages, SetAutoSizeLazyLoadedImagesEnabled,
     false},
    {blink::features::kAvoidCaretVisibleSelectionAdjuster, SetAvoidCaretVisibleSelectionAdjusterEnabled,
     false},
    {blink::features::kBackForwardCacheSendNotRestoredReasons, SetBackForwardCacheNotRestoredReasonsEnabled,
     true},
    {blink::features::kBackdropInheritOriginating, SetBackdropInheritOriginatingEnabled,
     false},
    {blink::features::kBackfaceVisibilityInterop, SetBackfaceVisibilityInteropEnabled,
     false},
    {blink::features::kBdiElementDirInheritance, SetBdiElementDirInheritanceEnabled,
     false},
    {blink::features::kBeforeunloadEventCancelByPreventDefault, SetBeforeunloadEventCancelByPreventDefaultEnabled,
     false},
    {blink::features::kBlinkLifecycleScriptForbidden, SetBlinkLifecycleScriptForbiddenEnabled,
     false},
    {blink::features::kBlockRubyConsoleMessage, SetBlockRubyConsoleMessageEnabled,
     false},
    {blink::features::kBlockRubyWrappingInlineRuby, SetBlockRubyWrappingInlineRubyEnabled,
     false},
    {blink::features::kBlockingFocusWithoutUserActivation, SetBlockingFocusWithoutUserActivationEnabled,
     false},
    {blink::features::kBoundaryEventDispatchTracksNodeRemoval, SetBoundaryEventDispatchTracksNodeRemovalEnabled,
     false},
    {blink::features::kByobFetch, SetByobFetchEnabled,
     false},
    {blink::features::kCCTNewRFMPushBehavior, SetCCTNewRFMPushBehaviorEnabled,
     false},
    {blink::features::kCSSAnchorPositioningCascadeFallback, SetCSSAnchorPositioningCascadeFallbackEnabled,
     false},
    {blink::features::kCSSAnimationDelayStartEnd, SetCSSAnimationDelayStartEndEnabled,
     false},
    {blink::features::kCSSBackgroundClipUnprefix, SetCSSBackgroundClipUnprefixEnabled,
     false},
    {blink::features::kCSSCapFontUnits, SetCSSCapFontUnitsEnabled,
     false},
    {blink::features::kCSSContentVisibilityImpliesContainIntrinsicSizeAuto, SetCSSContentVisibilityImpliesContainIntrinsicSizeAutoEnabled,
     false},
    {blink::features::kCSSCrossFade, SetCSSCrossFadeEnabled,
     false},
    {blink::features::kCSSDisplayAnimation, SetCSSDisplayAnimationEnabled,
     false},
    {blink::features::kCSSDynamicRangeLimit, SetCSSDynamicRangeLimitEnabled,
     false},
    {blink::features::kCSSExponentialFunctions, SetCSSExponentialFunctionsEnabled,
     false},
    {blink::features::kCSSFirstLetterNoNewLineAsPrecedingChar, SetCSSFirstLetterNoNewLineAsPrecedingCharEnabled,
     false},
    {blink::features::kCSSLinearTimingFunction, SetCSSLinearTimingFunctionEnabled,
     false},
    {blink::features::kCSSMPCImprovements, SetCSSMPCImprovementsEnabled,
     false},
    {blink::features::kCSSMaskingInterop, SetCSSMaskingInteropEnabled,
     false},
    {blink::features::kCSSNestingIdent, SetCSSNestingIdentEnabled,
     false},
    {blink::features::kCSSNumericFactoryCompleteness, SetCSSNumericFactoryCompletenessEnabled,
     false},
    {blink::features::kCSSOffsetPathBasicShapesCircleAndEllipse, SetCSSOffsetPathBasicShapesCircleAndEllipseEnabled,
     false},
    {blink::features::kCSSOffsetPathBasicShapesRectanglesAndPolygon, SetCSSOffsetPathBasicShapesRectanglesAndPolygonEnabled,
     false},
    {blink::features::kCSSOffsetPathCoordBox, SetCSSOffsetPathCoordBoxEnabled,
     false},
    {blink::features::kCSSOffsetPathRay, SetCSSOffsetPathRayEnabled,
     false},
    {blink::features::kCSSOffsetPathRayContain, SetCSSOffsetPathRayContainEnabled,
     false},
    {blink::features::kCSSOffsetPathUrl, SetCSSOffsetPathUrlEnabled,
     false},
    {blink::features::kCSSOffsetPositionAnchor, SetCSSOffsetPositionAnchorEnabled,
     false},
    {blink::features::kCSSOverflowMediaFeatures, SetCSSOverflowMediaFeaturesEnabled,
     false},
    {blink::features::kCSSParserIgnoreCharsetForURLs, SetCSSParserIgnoreCharsetForURLsEnabled,
     false},
    {blink::features::kCSSPhraseLineBreak, SetCSSPhraseLineBreakEnabled,
     false},
    {blink::features::kCSSProgressNotation, SetCSSProgressNotationEnabled,
     false},
    {blink::features::kCSSPseudoDir, SetCSSPseudoDirEnabled,
     false},
    {blink::features::kCSSRelativeColor, SetCSSRelativeColorEnabled,
     false},
    {blink::features::kCSSResizeAuto, SetCSSResizeAutoEnabled,
     false},
    {blink::features::kCSSScope, SetCSSScopeEnabled,
     false},
    {blink::features::kCSSScrollSnapEvents, SetCSSScrollSnapEventsEnabled,
     false},
    {blink::features::kCSSScrollStart, SetCSSScrollStartEnabled,
     false},
    {blink::features::kCSSScrollStateContainerQueries, SetCSSScrollStateContainerQueriesEnabled,
     false},
    {blink::features::kCssSelectorFragmentAnchor, SetCSSSelectorFragmentAnchorEnabled,
     false},
    {blink::features::kCSSSignRelatedFunctions, SetCSSSignRelatedFunctionsEnabled,
     false},
    {blink::features::kCSSSnapChangedEvent, SetCSSSnapChangedEventEnabled,
     false},
    {blink::features::kCSSSnapChangingEvent, SetCSSSnapChangingEventEnabled,
     false},
    {blink::features::kCSSSnapContainerQueries, SetCSSSnapContainerQueriesEnabled,
     false},
    {blink::features::kCSSSpellingGrammarErrors, SetCSSSpellingGrammarErrorsEnabled,
     false},
    {blink::features::kCSSSteppedValueFunctions, SetCSSSteppedValueFunctionsEnabled,
     false},
    {blink::features::kCSSStickyContainerQueries, SetCSSStickyContainerQueriesEnabled,
     false},
    {blink::features::kCSSSupportsForImportRules, SetCSSSupportsForImportRulesEnabled,
     false},
    {blink::features::kCSSSystemAccentColor, SetCSSSystemAccentColorEnabled,
     false},
    {blink::features::kCSSTextAutoSpace, SetCSSTextAutoSpaceEnabled,
     false},
    {blink::features::kCSSTextBoxTrim, SetCSSTextBoxTrimEnabled,
     false},
    {blink::features::kCSSTextSpacing, SetCSSTextSpacingEnabled,
     false},
    {blink::features::kCSSTextSpacingTrim, SetCSSTextSpacingTrimEnabled,
     false},
    {blink::features::kCSSTextWrapBalanceByScore, SetCSSTextWrapBalanceByScoreEnabled,
     false},
    {blink::features::kCSSTextWrapPretty, SetCSSTextWrapPrettyEnabled,
     false},
    {blink::features::kCSSTransitionDiscrete, SetCSSTransitionDiscreteEnabled,
     false},
    {blink::features::kCSSUnknownContainerQueriesNoSelection, SetCSSUnknownContainerQueriesNoSelectionEnabled,
     false},
    {blink::features::kCSSUpdateMediaFeature, SetCSSUpdateMediaFeatureEnabled,
     false},
    {blink::features::kCSSVariables2ImageValues, SetCSSVariables2ImageValuesEnabled,
     false},
    {blink::features::kCSSVariables2TransformValues, SetCSSVariables2TransformValuesEnabled,
     false},
    {blink::features::kCSSViewTimelineInsetShorthand, SetCSSViewTimelineInsetShorthandEnabled,
     false},
    {blink::features::kCanonicalizeWhitespaceStrings, SetCanonicalizeWhitespaceStringsEnabled,
     false},
    {blink::features::kCapabilityDelegationDisplayCaptureRequest, SetCapabilityDelegationDisplayCaptureRequestEnabled,
     false},
    {blink::features::kCapturedMouseEvents, SetCapturedMouseEventsEnabled,
     false},
    {blink::features::kCapturedSurfaceControl, SetCapturedSurfaceControlEnabled,
     false},
    {blink::features::kCheckVisibilityExtraProperties, SetCheckVisibilityExtraPropertiesEnabled,
     false},
    {blink::features::kClipPathGeometryBox, SetClipPathGeometryBoxEnabled,
     false},
    {blink::features::kClipPathRejectEmptyPaths, SetClipPathRejectEmptyPathsEnabled,
     false},
    {blink::features::kClipPathXYWHAndRect, SetClipPathXYWHAndRectEnabled,
     false},
    {blink::features::kClipboardSupportedTypes, SetClipboardSupportedTypesEnabled,
     false},
    {blink::features::kClipboardWellFormedHtmlSanitizationWrite, SetClipboardWellFormedHtmlSanitizationWriteEnabled,
     false},
    {blink::features::kCloseWatcher, SetCloseWatcherEnabled,
     false},
    {blink::features::kCompositeClipPathAnimation, SetCompositeClipPathAnimationEnabled,
     false},
    {blink::features::kCompositionForegroundMarkers, SetCompositionForegroundMarkersEnabled,
     false},
    {blink::features::kComputePressure, SetComputePressureEnabled,
     true},
    {blink::features::kCounterStyleChangeShouleCollectInlines, SetCounterStyleChangeShouleCollectInlinesEnabled,
     false},
    {blink::features::kCrossFramePerformanceTimeline, SetCrossFramePerformanceTimelineEnabled,
     false},
    {blink::features::kCssDisplayRuby, SetCssDisplayRubyEnabled,
     false},
    {blink::features::kCssFieldSizing, SetCssFieldSizingEnabled,
     false},
    {blink::features::kCustomElementsGetName, SetCustomElementsGetNameEnabled,
     false},
    {blink::features::kDOMParserUsesHTMLFastPathParser, SetDOMParserUsesHTMLFastPathParserEnabled,
     false},
    {blink::features::kDOMPartsAPI, SetDOMPartsAPIEnabled,
     false},
    {blink::features::kDataTransferClearStringItems, SetDataTransferClearStringItemsEnabled,
     false},
    {blink::features::kDateInputInlineBlock, SetDateInputInlineBlockEnabled,
     false},
    {blink::features::kDeprecateUnloadOptOut, SetDeprecateUnloadOptOutEnabled,
     false},
    {blink::features::kDeprecatedTemplateShadowRoot, SetDeprecatedTemplateShadowRootEnabled,
     false},
    {blink::features::kDesktopPWAsAdditionalWindowingControls, SetDesktopPWAsAdditionalWindowingControlsEnabled,
     false},
    {blink::features::kDesktopPWAsSubApps, SetDesktopPWAsSubAppsEnabled,
     false},
    {blink::features::kDetailsElementToggleEvent, SetDetailsElementToggleEventEnabled,
     false},
    {blink::features::kDetailsStyling, SetDetailsStylingEnabled,
     false},
    {blink::features::kDialogNewFocusBehavior, SetDialogNewFocusBehaviorEnabled,
     false},
    {blink::features::kDirnameMoreInputTypes, SetDirnameMoreInputTypesEnabled,
     false},
    {blink::features::kDisableSelectAllForEmptyText, SetDisableSelectAllForEmptyTextEnabled,
     false},
    {blink::features::kDispatchHiddenVisibilityTransitions, SetDispatchHiddenVisibilityTransitionsEnabled,
     false},
    {blink::features::kDocumentBaseURIFix, SetDocumentBaseURIFixEnabled,
     false},
    {blink::features::kDocumentOpenOriginAliasRemoval, SetDocumentOpenOriginAliasRemovalEnabled,
     true},
    {blink::features::kDocumentOpenSandboxInheritanceRemoval, SetDocumentOpenSandboxInheritanceRemovalEnabled,
     true},
    {blink::features::kDocumentPictureInPictureAPI, SetDocumentPictureInPictureAPIEnabled,
     false},
    {blink::features::kDontFireDblclickOnDisabledFormControls, SetDontFireDblclickOnDisabledFormControlsEnabled,
     false},
    {blink::features::kDynamicScrollCullRectExpansion, SetDynamicScrollCullRectExpansionEnabled,
     false},
    {blink::features::kEditContext, SetEditContextEnabled,
     false},
    {blink::features::kElementCapture, SetElementCaptureEnabled,
     false},
    {blink::features::kEmptyClipboardRead, SetEmptyClipboardReadEnabled,
     false},
    {blink::features::kEnforceAnonymityExposure, SetEnforceAnonymityExposureEnabled,
     false},
    {blink::features::kEscapeLtGtInAttributes, SetEscapeLtGtInAttributesEnabled,
     false},
    {blink::features::kExcludeBrokenImageIconFromBeingLcpEligible, SetExcludeBrokenImageIconFromBeingLcpEligibleEnabled,
     false},
    {blink::features::kFastPositionIterator, SetFastPositionIteratorEnabled,
     false},
    {blink::features::kFencedFramesAPIChanges, SetFencedFramesAPIChangesEnabled,
     false},
    {blink::features::kFencedFramesDefaultMode, SetFencedFramesDefaultModeEnabled,
     false},
    {blink::features::kFetchLaterAPI, SetFetchLaterAPIEnabled,
     true},
    {blink::features::kFileHandlingAPI, SetFileHandlingEnabled,
     false},
    {blink::features::kFileSystemAccessGetCloudIdentifiers, SetFileSystemAccessGetCloudIdentifiersEnabled,
     false},
    {blink::features::kFileSystemAccessLockingScheme, SetFileSystemAccessLockingSchemeEnabled,
     false},
    {blink::features::kFileSystemObserver, SetFileSystemObserverEnabled,
     false},
    {blink::features::kFledgeBiddingAndAuctionServerAPI, SetFledgeBiddingAndAuctionServerAPIEnabled,
     false},
    {blink::features::kFledgeClearOriginJoinedAdInterestGroups, SetFledgeClearOriginJoinedAdInterestGroupsEnabled,
     false},
    {blink::features::kFledgeDirectFromSellerSignalsHeaderAdSlot, SetFledgeDirectFromSellerSignalsHeaderAdSlotEnabled,
     false},
    {blink::features::kFledgeNegativeTargeting, SetFledgeNegativeTargetingEnabled,
     false},
    {blink::features::kFledgeTrustedBiddingSignalsSlotSize, SetFledgeTrustedBiddingSignalsSlotSizeEnabled,
     false},
    {blink::features::kFlushParserBeforeCreatingCustomElements, SetFlushParserBeforeCreatingCustomElementsEnabled,
     false},
    {blink::features::kFocusStyleInvalidationOnPageActivation, SetFocusStyleInvalidationOnPageActivationEnabled,
     false},
    {blink::features::kFontAccess, SetFontAccessEnabled,
     false},
    {blink::features::kFontMatchingCTMigration, SetFontMatchingCTMigrationEnabled,
     false},
    {blink::features::kFontPaletteAnimation, SetFontPaletteAnimationEnabled,
     false},
    {blink::features::kFontationsFontBackend, SetFontationsFontBackendEnabled,
     false},
    {blink::features::kFormControlRestoreStateIfAutocompleteOff, SetFormControlRestoreStateIfAutocompleteOffEnabled,
     false},
    {blink::features::kFormControlsVerticalWritingModeDirectionSupport, SetFormControlsVerticalWritingModeDirectionSupportEnabled,
     false},
    {blink::features::kFormControlsVerticalWritingModeSupport, SetFormControlsVerticalWritingModeSupportEnabled,
     false},
    {blink::features::kFormControlsVerticalWritingModeTextSupport, SetFormControlsVerticalWritingModeTextSupportEnabled,
     false},
    {blink::features::kFormStateRestoreCallbackCallWithState, SetFormStateRestoreCallbackCallWithStateEnabled,
     false},
    {blink::features::kFullscreenPopupWindows, SetFullscreenPopupWindowsEnabled,
     true},
    {blink::features::kGamepadMultitouch, SetGamepadMultitouchEnabled,
     false},
    {blink::features::kGetAllScreensMedia, SetGetAllScreensMediaEnabled,
     false},
    {blink::features::kGetDisplayMediaRequiresUserActivation, SetGetDisplayMediaRequiresUserActivationEnabled,
     false},
    {blink::features::kHTMLInvokeActionsV2, SetHTMLInvokeActionsV2Enabled,
     false},
    {blink::features::kHTMLInvokeTargetAttribute, SetHTMLInvokeTargetAttributeEnabled,
     false},
    {blink::features::kHTMLLangNewInheritance, SetHTMLLangNewInheritanceEnabled,
     false},
    {blink::features::kHTMLParserFastPathBulkInsertNotify, SetHTMLParserFastPathBulkInsertNotifyEnabled,
     false},
    {blink::features::kHTMLParserYieldAndDelayOftenForTesting, SetHTMLParserYieldAndDelayOftenForTestingEnabled,
     false},
    {blink::features::kHTMLPopoverHint, SetHTMLPopoverHintEnabled,
     false},
    {blink::features::kHTMLSearchElement, SetHTMLSearchElementEnabled,
     false},
    {blink::features::kHTMLSelectElementShowPicker, SetHTMLSelectElementShowPickerEnabled,
     false},
    {blink::features::kHTMLUnsafeMethods, SetHTMLUnsafeMethodsEnabled,
     false},
    {blink::features::kHangingWhitespaceDoesNotDependOnAlignment, SetHangingWhitespaceDoesNotDependOnAlignmentEnabled,
     false},
    {blink::features::kHighlightInheritance, SetHighlightInheritanceEnabled,
     false},
    {blink::features::kHitTestOpaqueness, SetHitTestOpaquenessEnabled,
     false},
    {blink::features::kHitTestTransparency, SetHitTestTransparencyEnabled,
     false},
    {blink::features::kImportAttributesDisallowUnknownKeys, SetImportAttributesDisallowUnknownKeysEnabled,
     false},
    {blink::features::kIncomingCallNotifications, SetIncomingCallNotificationsEnabled,
     false},
    {blink::features::kInertDisplayTransition, SetInertDisplayTransitionEnabled,
     false},
    {blink::features::kInheritUserModifyWithoutContenteditable, SetInheritUserModifyWithoutContenteditableEnabled,
     false},
    {blink::features::kInnerHTMLParserFastpathLogFailure, SetInnerHTMLParserFastpathLogFailureEnabled,
     false},
    {blink::features::kInsertLineBreakIfPhrasingContent, SetInsertLineBreakIfPhrasingContentEnabled,
     false},
    {blink::features::kInteroperablePrivateAttribution, SetInteroperablePrivateAttributionEnabled,
     false},
    {blink::features::kInterruptComposedScrollbarDisappearance, SetInterruptComposedScrollbarDisappearanceEnabled,
     false},
    {blink::features::kIntersectionObserverScrollMargin, SetIntersectionObserverScrollMarginEnabled,
     false},
    {blink::features::kIntersectionOptimization, SetIntersectionOptimizationEnabled,
     false},
    {blink::features::kInvertedColors, SetInvertedColorsEnabled,
     false},
    {blink::features::kInvisibleSVGAnimationThrottling, SetInvisibleSVGAnimationThrottlingEnabled,
     false},
    {blink::features::kJavaScriptCompileHintsMagicRuntime, SetJavaScriptCompileHintsMagicRuntimeEnabled,
     false},
    {blink::features::kKeyboardFocusableScrollers, SetKeyboardFocusableScrollersEnabled,
     false},
    {blink::features::kLCPMouseoverHeuristics, SetLCPMouseoverHeuristicsEnabled,
     false},
    {blink::features::kLCPMultipleUpdatesPerElement, SetLCPMultipleUpdatesPerElementEnabled,
     false},
    {blink::features::kLayoutAlignForPositioned, SetLayoutAlignForPositionedEnabled,
     false},
    {blink::features::kLayoutFlexNewRowAlgorithmV3, SetLayoutFlexNewRowAlgorithmV3Enabled,
     false},
    {blink::features::kLayoutIgnoreMarginsForSticky, SetLayoutIgnoreMarginsForStickyEnabled,
     false},
    {blink::features::kLayoutNGShapeCache, SetLayoutNGShapeCacheEnabled,
     false},
    {blink::features::kLayoutNewContainingBlock, SetLayoutNewContainingBlockEnabled,
     false},
    {blink::features::kLayoutNewMeasureCache, SetLayoutNewMeasureCacheEnabled,
     false},
    {blink::features::kLayoutNewMinMaxCache, SetLayoutNewMinMaxCacheEnabled,
     false},
    {blink::features::kLazyLoadScrollMargin, SetLazyLoadScrollMarginEnabled,
     false},
    {blink::features::kLockedMode, SetLockedModeEnabled,
     false},
    {blink::features::kLongAnimationFrameTiming, SetLongAnimationFrameTimingEnabled,
     false},
    {blink::features::kLongTaskFromLongAnimationFrame, SetLongTaskFromLongAnimationFrameEnabled,
     false},
    {blink::features::kMacFontsDeprecateFontTraitsWorkaround, SetMacFontsDeprecateFontTraitsWorkaroundEnabled,
     false},
    {blink::features::kManagedConfiguration, SetManagedConfigurationEnabled,
     false},
    {blink::features::kMaskingGraphemeClusters, SetMaskingGraphemeClustersEnabled,
     false},
    {blink::features::kMediaCapabilitiesDynamicRange, SetMediaCapabilitiesDynamicRangeEnabled,
     false},
    {blink::features::kMediaCaptureVoiceIsolation, SetMediaCaptureVoiceIsolationEnabled,
     false},
    {blink::features::kMediaRecorderUseMediaVideoEncoder, SetMediaRecorderUseMediaVideoEncoderEnabled,
     false},
    {blink::features::kMediaSessionChapterInformation, SetMediaSessionChapterInformationEnabled,
     false},
    {blink::features::kMediaSessionEnterPictureInPicture, SetMediaSessionEnterPictureInPictureEnabled,
     false},
    {blink::features::kMessagePortCloseEvent, SetMessagePortCloseEventEnabled,
     false},
    {blink::features::kEnableModelExecutionAPI, SetModelExecutionAPIEnabled,
     false},
    {blink::features::kMonitorTypeSurfaces, SetMonitorTypeSurfacesEnabled,
     false},
    {blink::features::kMouseDragFromIframeOnCancelledMouseDown, SetMouseDragFromIframeOnCancelledMouseDownEnabled,
     false},
    {blink::features::kMouseDragOnCancelledMouseMove, SetMouseDragOnCancelledMouseMoveEnabled,
     false},
    {blink::features::kMutationEvents, SetMutationEventsEnabled,
     false},
    {blink::features::kNavigateEventCommitBehavior, SetNavigateEventCommitBehaviorEnabled,
     false},
    {blink::features::kNavigateEventSourceElement, SetNavigateEventSourceElementEnabled,
     false},
    {blink::features::kNavigationActivation, SetNavigationActivationEnabled,
     false},
    {blink::features::kNavigationId, SetNavigationIdEnabled,
     false},
    {blink::features::kNetInfoConstantType, SetNetInfoConstantTypeEnabled,
     false},
    {blink::features::kNextSiblingPositionUseNextCandidate, SetNextSiblingPositionUseNextCandidateEnabled,
     false},
    {blink::features::kNoOffsetMappingForInconsistentText, SetNoOffsetMappingForInconsistentTextEnabled,
     false},
    {blink::features::kNonComposedEnterLeaveEvents, SetNonComposedEnterLeaveEventsEnabled,
     false},
    {blink::features::kNonStandardAppearanceValueSliderVertical, SetNonStandardAppearanceValueSliderVerticalEnabled,
     false},
    {blink::features::kNonStandardAppearanceValuesHighUsage, SetNonStandardAppearanceValuesHighUsageEnabled,
     false},
    {blink::features::kNonStandardAppearanceValuesLowUsage, SetNonStandardAppearanceValuesLowUsageEnabled,
     false},
    {blink::features::kObservableAPI, SetObservableAPIEnabled,
     false},
    {blink::features::kOffsetMappingUnitVariable, SetOffsetMappingUnitVariableEnabled,
     false},
    {blink::features::kOnePassRasterInvalidation, SetOnePassRasterInvalidationEnabled,
     false},
    {blink::features::kOptionElementAlwaysUseLabel, SetOptionElementAlwaysUseLabelEnabled,
     false},
    {blink::features::kPageMarginBoxes, SetPageMarginBoxesEnabled,
     false},
    {blink::features::kPageRevealEvent, SetPageRevealEventEnabled,
     false},
    {blink::features::kParakeet, SetParakeetEnabled,
     false},
    {blink::features::kPasswordStrongLabel, SetPasswordStrongLabelEnabled,
     false},
    {blink::features::kPastingBlocksSVGUseNonLocalHrefs, SetPastingBlocksSVGUseNonLocalHrefsEnabled,
     false},
    {blink::features::kPaymentHandlerMinimalHeaderUX, SetPaymentHandlerMinimalHeaderUXEnabled,
     false},
    {blink::features::kPaymentRequestAllowOneActivationlessShow, SetPaymentRequestAllowOneActivationlessShowEnabled,
     false},
    {blink::features::kPerformanceMarkFeatureUsage, SetPerformanceMarkFeatureUsageEnabled,
     false},
    {blink::features::kPerformanceNavigateSystemEntropy, SetPerformanceNavigateSystemEntropyEnabled,
     false},
    {blink::features::kPointerCaptureLostOnRemovalDuringCapture, SetPointerCaptureLostOnRemovalDuringCaptureEnabled,
     false},
    {blink::features::kPointerEventDeviceId, SetPointerEventDeviceIdEnabled,
     false},
    {blink::features::kPositionOutsideTabSpanCheckSiblingNode, SetPositionOutsideTabSpanCheckSiblingNodeEnabled,
     false},
    {blink::features::kPrePaintAncestorsOfMissedOOF, SetPrePaintAncestorsOfMissedOOFEnabled,
     false},
    {blink::features::kPrerender2, SetPrerender2Enabled,
     false},
    {blink::features::kPrettyPrintJSONDocument, SetPrettyPrintJSONDocumentEnabled,
     false},
    {blink::features::kPreventReadingSystemAccentColor, SetPreventReadingSystemAccentColorEnabled,
     false},
    {blink::features::kQuickIntensiveWakeUpThrottlingAfterLoading, SetQuickIntensiveWakeUpThrottlingAfterLoadingEnabled,
     false},
    {blink::features::kRTCEncodedAudioFrameAbsCaptureTime, SetRTCEncodedAudioFrameAbsCaptureTimeEnabled,
     false},
    {blink::features::kRTCEncodedFrameSetMetadata, SetRTCEncodedFrameSetMetadataEnabled,
     false},
    {blink::features::kRTCEncodedVideoFrameAdditionalMetadata, SetRTCEncodedVideoFrameAdditionalMetadataEnabled,
     false},
    {blink::features::kRTCRtpEncodingParametersCodec, SetRTCRtpEncodingParametersCodecEnabled,
     false},
    {blink::features::kRTCRtpHeaderExtensionControl, SetRTCRtpHeaderExtensionControlEnabled,
     false},
    {blink::features::kRTCSvcScalabilityMode, SetRTCSvcScalabilityModeEnabled,
     false},
    {blink::features::kReadableStreamTeeCloneForBranch2, SetReadableStreamTeeCloneForBranch2Enabled,
     false},
    {blink::features::kReduceCookieIPCs, SetReduceCookieIPCsEnabled,
     false},
    {blink::features::kReduceUserAgentAndroidVersionDeviceModel, SetReduceUserAgentAndroidVersionDeviceModelEnabled,
     false},
    {blink::features::kReduceUserAgentMinorVersion, SetReduceUserAgentMinorVersionEnabled,
     false},
    {blink::features::kReduceUserAgentPlatformOsCpu, SetReduceUserAgentPlatformOsCpuEnabled,
     false},
    {blink::features::kReferenceBoxNoPixelSnapping, SetReferenceBoxNoPixelSnappingEnabled,
     false},
    {blink::features::kRemotePlaybackBackend, SetRemotePlaybackBackendEnabled,
     false},
    {blink::features::kRemoveDanglingMarkupInTarget, SetRemoveDanglingMarkupInTargetEnabled,
     false},
    {blink::features::kRemoveDataUrlInSvgUse, SetRemoveDataUrlInSvgUseEnabled,
     false},
    {blink::features::kRemoveZoomAdjustmentOfBoundingBox, SetRemoveZoomAdjustmentOfBoundingBoxEnabled,
     false},
    {blink::features::kRewindFloats, SetRewindFloatsEnabled,
     false},
    {blink::features::kRubyInlinify, SetRubyInlinifyEnabled,
     false},
    {blink::features::kRubySimplePairing, SetRubySimplePairingEnabled,
     false},
    {blink::features::kRunMicrotaskBeforeXmlCustomElement, SetRunMicrotaskBeforeXmlCustomElementEnabled,
     false},
    {blink::features::kSanitizerAPI, SetSanitizerAPIEnabled,
     false},
    {blink::features::kSchedulerYield, SetSchedulerYieldEnabled,
     false},
    {blink::features::kScrollEndEvents, SetScrollEndEventsEnabled,
     false},
    {blink::features::kScrollTimeline, SetScrollTimelineEnabled,
     false},
    {blink::features::kScrollTimelineCurrentTime, SetScrollTimelineCurrentTimeEnabled,
     false},
    {blink::features::kScrollTimelineOnCompositor, SetScrollTimelineOnCompositorEnabled,
     false},
    {blink::features::kScrollbarColor, SetScrollbarColorEnabled,
     false},
    {blink::features::kScrollbarWidth, SetScrollbarWidthEnabled,
     false},
    {blink::features::kSecurePaymentConfirmationAllowOneActivationlessShow, SetSecurePaymentConfirmationAllowOneActivationlessShowEnabled,
     false},
    {blink::features::kSecurePaymentConfirmationExtensions, SetSecurePaymentConfirmationExtensionsEnabled,
     false},
    {blink::features::kSelectHr, SetSelectHrEnabled,
     false},
    {blink::features::kSetSequentialFocusStartingPoint, SetSetSequentialFocusStartingPointEnabled,
     false},
    {blink::features::kShadowRootAttachmentNewBehavior, SetShadowRootAttachmentNewBehaviorEnabled,
     false},
    {blink::features::kSkipTouchEventFilter, SetSkipTouchEventFilterEnabled,
     false},
    {blink::features::kSmartCard, SetSmartCardEnabled,
     false},
    {blink::features::kSmilAutoSuspendOnLag, SetSmilAutoSuspendOnLagEnabled,
     false},
    {blink::features::kSnapBorderWidthsBeforeLayout, SetSnapBorderWidthsBeforeLayoutEnabled,
     false},
    {blink::features::kSoftNavigationDetection, SetSoftNavigationDetectionEnabled,
     false},
    {blink::features::kSoftNavigationHeuristics, SetSoftNavigationHeuristicsEnabled,
     false},
    {blink::features::kSoftNavigationHeuristicsExposeFPAndFCP, SetSoftNavigationHeuristicsExposeFPAndFCPEnabled,
     false},
    {blink::features::kSparseObjectPaintProperties, SetSparseObjectPaintPropertiesEnabled,
     false},
    {blink::features::kSpeculationRulesDocumentRulesSelectorMatches, SetSpeculationRulesDocumentRulesSelectorMatchesEnabled,
     true},
    {blink::features::kSpeculationRulesEagerness, SetSpeculationRulesEagernessEnabled,
     true},
    {blink::features::kSpeculationRulesImplicitSource, SetSpeculationRulesImplicitSourceEnabled,
     false},
    {blink::features::kSpeculationRulesNoVarySearchHint, SetSpeculationRulesNoVarySearchHintEnabled,
     false},
    {blink::features::kSpeculationRulesNoVarySearchHintShippedByDefault, SetSpeculationRulesNoVarySearchHintShippedByDefaultEnabled,
     false},
    {blink::features::kSpeculationRulesPointerDownHeuristics, SetSpeculationRulesPointerDownHeuristicsEnabled,
     false},
    {blink::features::kSpeculationRulesPointerHoverHeuristics, SetSpeculationRulesPointerHoverHeuristicsEnabled,
     false},
    {blink::features::kSpellCheckerReplaceRangeUseInsertText, SetSpellCheckerReplaceRangeUseInsertTextEnabled,
     false},
    {blink::features::kStorageBuckets, SetStorageBucketsEnabled,
     false},
    {blink::features::kStorageBucketsDurability, SetStorageBucketsDurabilityEnabled,
     false},
    {blink::features::kStorageBucketsLocks, SetStorageBucketsLocksEnabled,
     false},
    {blink::features::kStylableSelect, SetStylableSelectEnabled,
     false},
    {blink::features::kSuggestionPickerDarkModeSupport, SetSuggestionPickerDarkModeSupportEnabled,
     false},
    {blink::features::kSvgCrossOriginAttribute, SetSvgCrossOriginAttributeEnabled,
     false},
    {blink::features::kSvgNoPixelSnappingScaleAdjustment, SetSvgNoPixelSnappingScaleAdjustmentEnabled,
     false},
    {blink::features::kSvgTextFixHittestAfterScale, SetSvgTextFixHittestAfterScaleEnabled,
     false},
    {blink::features::kTextFragmentAnchor, SetTextFragmentIdentifiersEnabled,
     false},
    {blink::features::kTextMetricsBaselines, SetTextMetricsBaselinesEnabled,
     false},
    {blink::features::kTimelineScope, SetTimelineScopeEnabled,
     false},
    {blink::features::kURLAttributeFix, SetURLAttributeFixEnabled,
     false},
    {blink::features::kURLPatternRegexpUnicodeSetsMode, SetURLPatternRegexpUnicodeSetsModeEnabled,
     false},
    {blink::features::kURLPatternWildcardMoreOften, SetURLPatternWildcardMoreOftenEnabled,
     false},
    {blink::features::kURLSearchParamsHasAndDeleteMultipleArgs, SetURLSearchParamsHasAndDeleteMultipleArgsEnabled,
     false},
    {blink::features::kUnownedAnimationsSkipCSSEvents, SetUnownedAnimationsSkipCSSEventsEnabled,
     false},
    {blink::features::kUnrestrictedUsb, SetUnrestrictedUsbEnabled,
     false},
    {blink::features::kUseBeginFramePresentationFeedback, SetUseBeginFramePresentationFeedbackEnabled,
     false},
    {blink::features::kUsedColorSchemeRootScrollbars, SetUsedColorSchemeRootScrollbarsEnabled,
     false},
    {blink::features::kUserValidUserInvalid, SetUserValidUserInvalidEnabled,
     false},
    {blink::features::kViewTransitionOnNavigation, SetViewTransitionOnNavigationEnabled,
     false},
    {blink::features::kViewTransitionTypes, SetViewTransitionTypesEnabled,
     false},
    {blink::features::kViewportHeightClientHintHeader, SetViewportHeightClientHintHeaderEnabled,
     false},
    {blink::features::kWGIGamepadTriggerRumble, SetWGIGamepadTriggerRumbleEnabled,
     false},
    {blink::features::kWebAppEnableDarkMode, SetWebAppDarkModeEnabled,
     false},
    {blink::features::kWebAppEnableLaunchHandler, SetWebAppLaunchHandlerEnabled,
     false},
    {blink::features::kDesktopPWAsTabStrip, SetWebAppTabStripEnabled,
     true},
    {blink::features::kDesktopPWAsTabStripCustomizations, SetWebAppTabStripCustomizationsEnabled,
     true},
    {blink::features::kWebAppEnableTranslations, SetWebAppTranslationsEnabled,
     false},
    {blink::features::kWebAuthAllowCreateInCrossOriginFrame, SetWebAuthAllowCreateInCrossOriginFrameEnabled,
     true},
    {blink::features::kWebAuthenticationHints, SetWebAuthenticationHintsEnabled,
     false},
    {blink::features::kWebAuthenticationJSONSerialization, SetWebAuthenticationJSONSerializationEnabled,
     false},
    {blink::features::kWebAuthenticationPRFExtension, SetWebAuthenticationPRFEnabled,
     false},
    {blink::features::kWebAuthenticationSupplementalPubKeys, SetWebAuthenticationSupplementalPubKeysEnabled,
     false},
    {blink::features::kWebCodecsContentHint, SetWebCodecsContentHintEnabled,
     false},
    {blink::features::kWebCodecsCopyToRGB, SetWebCodecsCopyToRGBEnabled,
     false},
    {blink::features::kWebFontResizeLCP, SetWebFontResizeLCPEnabled,
     false},
    {blink::features::kWebIDLBigIntUsesToBigInt, SetWebIDLBigIntUsesToBigIntEnabled,
     false},
    {blink::features::kWebPreferences, SetWebPreferencesEnabled,
     false},
    {blink::features::kWebPrinting, SetWebPrintingEnabled,
     false},
    {blink::features::kWebXREnabledFeatures, SetWebXREnabledFeaturesEnabled,
     false},
    {blink::features::kWindowDefaultStatus, SetWindowDefaultStatusEnabled,
     false},
    {blink::features::kWindowPlacementFullscreenOnScreensChange, SetWindowPlacementFullscreenOnScreensChangeEnabled,
     false},
    {blink::features::kWindowPlacementPermissionAlias, SetWindowPlacementPermissionAliasEnabled,
     false},
    {blink::features::kXMLParserMergeAdjacentCDataSections, SetXMLParserMergeAdjacentCDataSectionsEnabled,
     false},
    {blink::features::kXYWHAndRectComputedValue, SetXYWHAndRectComputedValueEnabled,
     false},
    {blink::features::kZeroCopyTabCapture, SetZeroCopyTabCaptureEnabled,
     false},
  };
  for (const auto& map : mappings) {
    const bool feature_enabled = base::FeatureList::IsEnabled(map.feature);
    const bool is_overridden =
        base::FeatureList::GetInstance()->IsFeatureOverridden(map.feature.name);
    if (map.if_overridden) {
      if (is_overridden)
        map.enabler(feature_enabled);
    } else {
      if (feature_enabled || is_overridden)
        map.enabler(feature_enabled);
    }
  }
}

bool RuntimeEnabledFeaturesBase::BlinkExtensionChromeOSEnabled(const FeatureContext* context) {
  if(context && context->GetRuntimeFeatureStateOverrideContext()
                    ->IsBlinkExtensionChromeOSForceEnabled()) {
    return true;
  }
  if(context && context->GetRuntimeFeatureStateOverrideContext()
                    ->IsBlinkExtensionChromeOSForceDisabled()) {
    return false;
  }

  return BlinkExtensionChromeOSEnabled();
}

bool RuntimeEnabledFeaturesBase::BlinkExtensionChromeOSKioskEnabled(const FeatureContext* context) {
  if(context && context->GetRuntimeFeatureStateOverrideContext()
                    ->IsBlinkExtensionChromeOSKioskForceEnabled()) {
    return true;
  }
  if(context && context->GetRuntimeFeatureStateOverrideContext()
                    ->IsBlinkExtensionChromeOSKioskForceDisabled()) {
    return false;
  }

  return BlinkExtensionChromeOSKioskEnabled();
}

bool RuntimeEnabledFeaturesBase::BlinkExtensionDiagnosticsEnabled(const FeatureContext* context) {
  if(context && context->GetRuntimeFeatureStateOverrideContext()
                    ->IsBlinkExtensionDiagnosticsForceEnabled()) {
    return true;
  }
  if(context && context->GetRuntimeFeatureStateOverrideContext()
                    ->IsBlinkExtensionDiagnosticsForceDisabled()) {
    return false;
  }

  return BlinkExtensionDiagnosticsEnabled();
}

bool RuntimeEnabledFeaturesBase::FedCmIdpSigninStatusEnabled(const FeatureContext* context) {
  if(context && context->GetRuntimeFeatureStateOverrideContext()
                    ->IsFedCmIdpSigninStatusForceEnabled()) {
    return true;
  }
  if(context && context->GetRuntimeFeatureStateOverrideContext()
                    ->IsFedCmIdpSigninStatusForceDisabled()) {
    return false;
  }

  return FedCmIdpSigninStatusEnabled();
}

bool RuntimeEnabledFeaturesBase::TestFeatureEnabled(const FeatureContext* context) {
  if(context && context->GetRuntimeFeatureStateOverrideContext()
                    ->IsTestFeatureForceEnabled()) {
    return true;
  }
  if(context && context->GetRuntimeFeatureStateOverrideContext()
                    ->IsTestFeatureForceDisabled()) {
    return false;
  }

  return TestFeatureEnabled();
}



bool RuntimeEnabledFeaturesBase::AddIdentityInCanMakePaymentEventEnabled(const FeatureContext* context) {
  if (is_add_identity_in_can_make_payment_event_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kAddIdentityInCanMakePaymentEvent);
}


bool RuntimeEnabledFeaturesBase::AdInterestGroupAPIEnabled(const FeatureContext* context) {
  if (RuntimeEnabledFeaturesBase::FledgeEnabled(context))
    return true;
  if (RuntimeEnabledFeaturesBase::ParakeetEnabled(context))
    return true;
  if (is_ad_interest_group_api_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kAdInterestGroupAPI);
}


bool RuntimeEnabledFeaturesBase::AttributionReportingEnabled(const FeatureContext* context) {
  if (is_attribution_reporting_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kAttributionReporting);
}


bool RuntimeEnabledFeaturesBase::AttributionReportingCrossAppWebEnabled(const FeatureContext* context) {
  if (is_attribution_reporting_cross_app_web_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kAttributionReportingCrossAppWeb);
}


bool RuntimeEnabledFeaturesBase::AttributionReportingInterfaceEnabled(const FeatureContext* context) {
  if (RuntimeEnabledFeaturesBase::AttributionReportingEnabled(context))
    return true;
  if (RuntimeEnabledFeaturesBase::AttributionReportingCrossAppWebEnabled(context))
    return true;
  if (is_attribution_reporting_interface_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kAttributionReportingInterface);
}


bool RuntimeEnabledFeaturesBase::AutoDarkModeEnabled(const FeatureContext* context) {
  if (is_auto_dark_mode_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kAutoDarkMode);
}


bool RuntimeEnabledFeaturesBase::BackForwardCacheExperimentHTTPHeaderEnabled(const FeatureContext* context) {
  if (is_back_forward_cache_experiment_http_header_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kBackForwardCacheExperimentHTTPHeader);
}


bool RuntimeEnabledFeaturesBase::BackForwardCacheNotRestoredReasonsEnabled(const FeatureContext* context) {
  if (is_back_forward_cache_not_restored_reasons_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kBackForwardCacheNotRestoredReasons);
}


bool RuntimeEnabledFeaturesBase::CacheStorageCodeCacheHintEnabled(const FeatureContext* context) {
  if (is_cache_storage_code_cache_hint_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kCacheStorageCodeCacheHint);
}


bool RuntimeEnabledFeaturesBase::CapturedSurfaceControlEnabled(const FeatureContext* context) {
  if (is_captured_surface_control_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kCapturedSurfaceControl);
}


bool RuntimeEnabledFeaturesBase::CompressionDictionaryTransportEnabled(const FeatureContext* context) {
  if (is_compression_dictionary_transport_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kCompressionDictionaryTransport);
}


bool RuntimeEnabledFeaturesBase::ComputePressureEnabled(const FeatureContext* context) {
  if (is_compute_pressure_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kComputePressure);
}


bool RuntimeEnabledFeaturesBase::CoopRestrictPropertiesEnabled(const FeatureContext* context) {
  if (is_coop_restrict_properties_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kCoopRestrictProperties);
}


bool RuntimeEnabledFeaturesBase::DatabaseEnabled(const FeatureContext* context) {
  if (is_database_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kDatabase);
}


bool RuntimeEnabledFeaturesBase::DeprecateUnloadOptOutEnabled(const FeatureContext* context) {
  if (is_deprecate_unload_opt_out_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kDeprecateUnloadOptOut);
}


bool RuntimeEnabledFeaturesBase::DigitalGoodsEnabled(const FeatureContext* context) {
  if (is_digital_goods_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kDigitalGoods);
}


bool RuntimeEnabledFeaturesBase::DisableDifferentOriginSubframeDialogSuppressionEnabled(const FeatureContext* context) {
  if (is_disable_different_origin_subframe_dialog_suppression_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kDisableDifferentOriginSubframeDialogSuppression);
}


bool RuntimeEnabledFeaturesBase::DisableHardwareNoiseSuppressionEnabled(const FeatureContext* context) {
  if (is_disable_hardware_noise_suppression_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kDisableHardwareNoiseSuppression);
}


bool RuntimeEnabledFeaturesBase::DisableThirdPartySessionStoragePartitioningAfterGeneralPartitioningEnabled(const FeatureContext* context) {
  if (is_disable_third_party_session_storage_partitioning_after_general_partitioning_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kDisableThirdPartySessionStoragePartitioningAfterGeneralPartitioning);
}


bool RuntimeEnabledFeaturesBase::DisableThirdPartyStoragePartitioningEnabled(const FeatureContext* context) {
  if(context && context->GetRuntimeFeatureStateOverrideContext()
                    ->IsDisableThirdPartyStoragePartitioningForceEnabled()) {
    return true;
  }
  if(context && context->GetRuntimeFeatureStateOverrideContext()
                    ->IsDisableThirdPartyStoragePartitioningForceDisabled()) {
    return false;
  }

  if (is_disable_third_party_storage_partitioning_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kDisableThirdPartyStoragePartitioning);
}


bool RuntimeEnabledFeaturesBase::DocumentPolicyNegotiationEnabled(const FeatureContext* context) {
  if (is_document_policy_negotiation_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kDocumentPolicyNegotiation);
}


bool RuntimeEnabledFeaturesBase::EditContextEnabled(const FeatureContext* context) {
  if (is_edit_context_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kEditContext);
}


bool RuntimeEnabledFeaturesBase::ElementCaptureEnabled(const FeatureContext* context) {
  if (is_element_capture_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kElementCapture);
}


bool RuntimeEnabledFeaturesBase::FencedFramesEnabled(const FeatureContext* context) {
  if (is_fenced_frames_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kFencedFrames);
}


bool RuntimeEnabledFeaturesBase::FencedFramesAPIChangesEnabled(const FeatureContext* context) {
  if (is_fenced_frames_api_changes_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kFencedFramesAPIChanges);
}


bool RuntimeEnabledFeaturesBase::FetchLaterAPIEnabled(const FeatureContext* context) {
  if (is_fetch_later_api_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kFetchLaterAPI);
}


bool RuntimeEnabledFeaturesBase::FledgeEnabled(const FeatureContext* context) {
  if (is_fledge_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kFledge);
}


bool RuntimeEnabledFeaturesBase::FledgeBiddingAndAuctionServerAPIEnabled(const FeatureContext* context) {
  if (is_fledge_bidding_and_auction_server_api_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kFledgeBiddingAndAuctionServerAPI);
}


bool RuntimeEnabledFeaturesBase::FocusgroupEnabled(const FeatureContext* context) {
  if (is_focusgroup_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kFocusgroup);
}


bool RuntimeEnabledFeaturesBase::FullscreenPopupWindowsEnabled(const FeatureContext* context) {
  if (is_fullscreen_popup_windows_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kFullscreenPopupWindows);
}


bool RuntimeEnabledFeaturesBase::GetAllScreensMediaEnabled(const FeatureContext* context) {
  if (!RuntimeEnabledFeaturesBase::GetDisplayMediaEnabled(context))
    return false;
  if (is_get_all_screens_media_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kGetAllScreensMedia);
}


bool RuntimeEnabledFeaturesBase::HrefTranslateEnabled(const FeatureContext* context) {
  if (!RuntimeEnabledFeaturesBase::TranslateServiceEnabled(context))
    return false;
  if (is_href_translate_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kHrefTranslate);
}


bool RuntimeEnabledFeaturesBase::JavaScriptCompileHintsMagicRuntimeEnabled(const FeatureContext* context) {
  if (is_java_script_compile_hints_magic_runtime_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kJavaScriptCompileHintsMagicRuntime);
}


bool RuntimeEnabledFeaturesBase::LongAnimationFrameTimingEnabled(const FeatureContext* context) {
  if (is_long_animation_frame_timing_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kLongAnimationFrameTiming);
}


bool RuntimeEnabledFeaturesBase::MediaCaptureBackgroundBlurEnabled(const FeatureContext* context) {
  if (RuntimeEnabledFeaturesBase::MediaCaptureCameraControlsEnabled(context))
    return true;
  if (is_media_capture_background_blur_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kMediaCaptureBackgroundBlur);
}


bool RuntimeEnabledFeaturesBase::MediaCaptureConfigurationChangeEnabled(const FeatureContext* context) {
  if (RuntimeEnabledFeaturesBase::MediaCaptureBackgroundBlurEnabled(context))
    return true;
  if (is_media_capture_configuration_change_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kMediaCaptureConfigurationChange);
}


bool RuntimeEnabledFeaturesBase::MediaSourceExtensionsForWebCodecsEnabled(const FeatureContext* context) {
  if (is_media_source_extensions_for_webcodecs_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kMediaSourceExtensionsForWebCodecs);
}


bool RuntimeEnabledFeaturesBase::NavigationIdEnabled(const FeatureContext* context) {
  if (is_navigation_id_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kNavigationId);
}


bool RuntimeEnabledFeaturesBase::NotificationTriggersEnabled(const FeatureContext* context) {
  if (is_notification_triggers_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kNotificationTriggers);
}


bool RuntimeEnabledFeaturesBase::NoVarySearchPrefetchEnabled(const FeatureContext* context) {
  if (is_no_vary_search_prefetch_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kNoVarySearchPrefetch);
}


bool RuntimeEnabledFeaturesBase::OriginTrialsSampleAPIEnabled(const FeatureContext* context) {
  if (is_origin_trials_sample_api_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kOriginTrialsSampleAPI);
}


bool RuntimeEnabledFeaturesBase::OriginTrialsSampleAPIBrowserReadWriteEnabled(const FeatureContext* context) {
  if(context && context->GetRuntimeFeatureStateOverrideContext()
                    ->IsOriginTrialsSampleAPIBrowserReadWriteForceEnabled()) {
    return true;
  }
  if(context && context->GetRuntimeFeatureStateOverrideContext()
                    ->IsOriginTrialsSampleAPIBrowserReadWriteForceDisabled()) {
    return false;
  }

  if (is_origin_trials_sample_api_browser_read_write_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kOriginTrialsSampleAPIBrowserReadWrite);
}


bool RuntimeEnabledFeaturesBase::OriginTrialsSampleAPIDependentEnabled(const FeatureContext* context) {
  if (!RuntimeEnabledFeaturesBase::OriginTrialsSampleAPIEnabled(context))
    return false;
  if (is_origin_trials_sample_api_dependent_enabled_)
    return true;
  // The feature does not have an origin trial name and its runtime flag
  // is not enabled.
  return false;
}


bool RuntimeEnabledFeaturesBase::OriginTrialsSampleAPIDeprecationEnabled(const FeatureContext* context) {
  if (is_origin_trials_sample_api_deprecation_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kOriginTrialsSampleAPIDeprecation);
}


bool RuntimeEnabledFeaturesBase::OriginTrialsSampleAPIExpiryGracePeriodEnabled(const FeatureContext* context) {
  if (is_origin_trials_sample_api_expiry_grace_period_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kOriginTrialsSampleAPIExpiryGracePeriod);
}


bool RuntimeEnabledFeaturesBase::OriginTrialsSampleAPIExpiryGracePeriodThirdPartyEnabled(const FeatureContext* context) {
  if (is_origin_trials_sample_api_expiry_grace_period_third_party_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kOriginTrialsSampleAPIExpiryGracePeriodThirdParty);
}


bool RuntimeEnabledFeaturesBase::OriginTrialsSampleAPIImpliedEnabled(const FeatureContext* context) {
  if (RuntimeEnabledFeaturesBase::OriginTrialsSampleAPIEnabled(context))
    return true;
  if (RuntimeEnabledFeaturesBase::OriginTrialsSampleAPIInvalidOSEnabled(context))
    return true;
  if (is_origin_trials_sample_api_implied_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kOriginTrialsSampleAPIImplied);
}


bool RuntimeEnabledFeaturesBase::OriginTrialsSampleAPIInvalidOSEnabled(const FeatureContext* context) {
  if (is_origin_trials_sample_api_invalid_os_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kOriginTrialsSampleAPIInvalidOS);
}


bool RuntimeEnabledFeaturesBase::OriginTrialsSampleAPINavigationEnabled(const FeatureContext* context) {
  if (is_origin_trials_sample_api_navigation_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kOriginTrialsSampleAPINavigation);
}


bool RuntimeEnabledFeaturesBase::OriginTrialsSampleAPIPersistentExpiryGracePeriodEnabled(const FeatureContext* context) {
  if (is_origin_trials_sample_api_persistent_expiry_grace_period_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kOriginTrialsSampleAPIPersistentExpiryGracePeriod);
}


bool RuntimeEnabledFeaturesBase::OriginTrialsSampleAPIPersistentFeatureEnabled(const FeatureContext* context) {
  if (is_origin_trials_sample_api_persistent_feature_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kOriginTrialsSampleAPIPersistentFeature);
}


bool RuntimeEnabledFeaturesBase::OriginTrialsSampleAPIPersistentInvalidOSEnabled(const FeatureContext* context) {
  if (is_origin_trials_sample_api_persistent_invalid_os_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kOriginTrialsSampleAPIPersistentInvalidOS);
}


bool RuntimeEnabledFeaturesBase::OriginTrialsSampleAPIPersistentThirdPartyDeprecationFeatureEnabled(const FeatureContext* context) {
  if (is_origin_trials_sample_api_persistent_third_party_deprecation_feature_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kOriginTrialsSampleAPIPersistentThirdPartyDeprecationFeature);
}


bool RuntimeEnabledFeaturesBase::OriginTrialsSampleAPIThirdPartyEnabled(const FeatureContext* context) {
  if (is_origin_trials_sample_api_third_party_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kOriginTrialsSampleAPIThirdParty);
}


bool RuntimeEnabledFeaturesBase::PageFreezeOptInEnabled(const FeatureContext* context) {
  if (is_page_freeze_opt_in_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kPageFreezeOptIn);
}


bool RuntimeEnabledFeaturesBase::PageFreezeOptOutEnabled(const FeatureContext* context) {
  if (is_page_freeze_opt_out_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kPageFreezeOptOut);
}


bool RuntimeEnabledFeaturesBase::ParakeetEnabled(const FeatureContext* context) {
  if (is_parakeet_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kParakeet);
}


bool RuntimeEnabledFeaturesBase::PartitionedCookiesEnabled(const FeatureContext* context) {
  if (is_partitioned_cookies_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kPartitionedCookies);
}


bool RuntimeEnabledFeaturesBase::PaymentHandlerMinimalHeaderUXEnabled(const FeatureContext* context) {
  if (is_payment_handler_minimal_header_ux_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kPaymentHandlerMinimalHeaderUX);
}


bool RuntimeEnabledFeaturesBase::PendingBeaconAPIEnabled(const FeatureContext* context) {
  if (is_pending_beacon_api_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kPendingBeaconAPI);
}


bool RuntimeEnabledFeaturesBase::PerMethodCanMakePaymentQuotaEnabled(const FeatureContext* context) {
  if (is_per_method_can_make_payment_quota_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kPerMethodCanMakePaymentQuota);
}


bool RuntimeEnabledFeaturesBase::PNaClEnabled(const FeatureContext* context) {
  if (is_p_na_cl_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kPNaCl);
}


bool RuntimeEnabledFeaturesBase::PrivacySandboxAdsAPIsEnabled(const FeatureContext* context) {
  if (is_privacy_sandbox_ads_api_s_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kPrivacySandboxAdsAPIs);
}


bool RuntimeEnabledFeaturesBase::PrivateNetworkAccessNonSecureContextsAllowedEnabled(const FeatureContext* context) {
  if (is_private_network_access_non_secure_contexts_allowed_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kPrivateNetworkAccessNonSecureContextsAllowed);
}


bool RuntimeEnabledFeaturesBase::PrivateNetworkAccessPermissionPromptEnabled(const FeatureContext* context) {
  if (is_private_network_access_permission_prompt_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kPrivateNetworkAccessPermissionPrompt);
}


bool RuntimeEnabledFeaturesBase::PrivateStateTokensEnabled(const FeatureContext* context) {
  if (is_private_state_tokens_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kPrivateStateTokens);
}


bool RuntimeEnabledFeaturesBase::ReduceAcceptLanguageEnabled(const FeatureContext* context) {
  if (is_reduce_accept_language_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kReduceAcceptLanguage);
}


bool RuntimeEnabledFeaturesBase::RtcAudioJitterBufferMaxPacketsEnabled(const FeatureContext* context) {
  if (is_rtc_audio_jitter_buffer_max_packets_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kRtcAudioJitterBufferMaxPackets);
}


bool RuntimeEnabledFeaturesBase::RTCEncodedFrameSetMetadataEnabled(const FeatureContext* context) {
  if (is_rtc_encoded_frame_set_metadata_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kRTCEncodedFrameSetMetadata);
}


bool RuntimeEnabledFeaturesBase::RTCLegacyCallbackBasedGetStatsEnabled(const FeatureContext* context) {
  if (is_rtc_legacy_callback_based_get_stats_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kRTCLegacyCallbackBasedGetStats);
}


bool RuntimeEnabledFeaturesBase::RTCStatsRelativePacketArrivalDelayEnabled(const FeatureContext* context) {
  if (is_rtc_stats_relative_packet_arrival_delay_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kRTCStatsRelativePacketArrivalDelay);
}


bool RuntimeEnabledFeaturesBase::SchedulerYieldEnabled(const FeatureContext* context) {
  if (is_scheduler_yield_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kSchedulerYield);
}


bool RuntimeEnabledFeaturesBase::SecurePaymentConfirmationOptOutEnabled(const FeatureContext* context) {
  if (is_secure_payment_confirmation_opt_out_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kSecurePaymentConfirmationOptOut);
}


bool RuntimeEnabledFeaturesBase::ServiceWorkerBypassFetchHandlerEnabled(const FeatureContext* context) {
  if (is_service_worker_bypass_fetch_handler_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kServiceWorkerBypassFetchHandler);
}


bool RuntimeEnabledFeaturesBase::ServiceWorkerRaceNetworkRequestEnabled(const FeatureContext* context) {
  if (is_service_worker_race_network_request_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kServiceWorkerRaceNetworkRequest);
}


bool RuntimeEnabledFeaturesBase::ServiceWorkerStaticRouterEnabled(const FeatureContext* context) {
  if (is_service_worker_static_router_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kServiceWorkerStaticRouter);
}


bool RuntimeEnabledFeaturesBase::SharedStorageAPIEnabled(const FeatureContext* context) {
  if (is_shared_storage_api_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kSharedStorageAPI);
}


bool RuntimeEnabledFeaturesBase::SignatureBasedIntegrityEnabled(const FeatureContext* context) {
  if (is_signature_based_integrity_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kSignatureBasedIntegrity);
}


bool RuntimeEnabledFeaturesBase::SoftNavigationHeuristicsEnabled(const FeatureContext* context) {
  if (!RuntimeEnabledFeaturesBase::NavigationIdEnabled(context))
    return false;
  if (!RuntimeEnabledFeaturesBase::SoftNavigationDetectionEnabled(context))
    return false;
  if (is_soft_navigation_heuristics_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kSoftNavigationHeuristics);
}


bool RuntimeEnabledFeaturesBase::SpeculationRulesDocumentRulesEnabled(const FeatureContext* context) {
  if (is_speculation_rules_document_rules_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kSpeculationRulesDocumentRules);
}


bool RuntimeEnabledFeaturesBase::SpeculationRulesDocumentRulesSelectorMatchesEnabled(const FeatureContext* context) {
  if (is_speculation_rules_document_rules_selector_matches_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kSpeculationRulesDocumentRulesSelectorMatches);
}


bool RuntimeEnabledFeaturesBase::SpeculationRulesEagernessEnabled(const FeatureContext* context) {
  if (RuntimeEnabledFeaturesBase::SpeculationRulesNoVarySearchHintEnabled(context))
    return true;
  if (is_speculation_rules_eagerness_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kSpeculationRulesEagerness);
}


bool RuntimeEnabledFeaturesBase::SpeculationRulesFetchFromHeaderEnabled(const FeatureContext* context) {
  if (is_speculation_rules_fetch_from_header_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kSpeculationRulesFetchFromHeader);
}


bool RuntimeEnabledFeaturesBase::SpeculationRulesNoVarySearchHintEnabled(const FeatureContext* context) {
  if (is_speculation_rules_no_vary_search_hint_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kSpeculationRulesNoVarySearchHint);
}


bool RuntimeEnabledFeaturesBase::SpeculationRulesPrefetchFutureEnabled(const FeatureContext* context) {
  if (is_speculation_rules_prefetch_future_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kSpeculationRulesPrefetchFuture);
}


bool RuntimeEnabledFeaturesBase::SpeculationRulesRelativeToDocumentEnabled(const FeatureContext* context) {
  if (is_speculation_rules_relative_to_document_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kSpeculationRulesRelativeToDocument);
}


bool RuntimeEnabledFeaturesBase::StorageAccessAPIBeyondCookiesEnabled(const FeatureContext* context) {
  if (is_storage_access_api_beyond_cookies_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kStorageAccessAPIBeyondCookies);
}


bool RuntimeEnabledFeaturesBase::TextFragmentIdentifiersEnabled(const FeatureContext* context) {
  if (is_text_fragment_identifiers_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kTextFragmentIdentifiers);
}


bool RuntimeEnabledFeaturesBase::TopicsAPIEnabled(const FeatureContext* context) {
  if (is_topics_api_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kTopicsAPI);
}


bool RuntimeEnabledFeaturesBase::TopicsDocumentAPIEnabled(const FeatureContext* context) {
  if (is_topics_document_api_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kTopicsDocumentAPI);
}


bool RuntimeEnabledFeaturesBase::TopLevelTpcdEnabled(const FeatureContext* context) {
  if (is_top_level_tpcd_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kTopLevelTpcd);
}


bool RuntimeEnabledFeaturesBase::TouchEventFeatureDetectionEnabled(const FeatureContext* context) {
  if (is_touch_event_feature_detection_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kTouchEventFeatureDetection);
}


bool RuntimeEnabledFeaturesBase::TpcdEnabled(const FeatureContext* context) {
  if (is_tpcd_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kTpcd);
}


bool RuntimeEnabledFeaturesBase::UnrestrictedSharedArrayBufferEnabled(const FeatureContext* context) {
  if (is_unrestricted_shared_array_buffer_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kUnrestrictedSharedArrayBuffer);
}


bool RuntimeEnabledFeaturesBase::WebAppDarkModeEnabled(const FeatureContext* context) {
  if (is_web_app_dark_mode_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kWebAppDarkMode);
}


bool RuntimeEnabledFeaturesBase::WebAppLaunchHandlerEnabled(const FeatureContext* context) {
  if (is_web_app_launch_handler_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kWebAppLaunchHandler);
}


bool RuntimeEnabledFeaturesBase::WebAppLaunchQueueEnabled(const FeatureContext* context) {
  if (RuntimeEnabledFeaturesBase::WebAppLaunchHandlerEnabled(context))
    return true;
  if (RuntimeEnabledFeaturesBase::FileHandlingEnabled(context))
    return true;
  if (is_web_app_launch_queue_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kWebAppLaunchQueue);
}


bool RuntimeEnabledFeaturesBase::WebAppScopeExtensionsEnabled(const FeatureContext* context) {
  if (is_web_app_scope_extensions_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kWebAppScopeExtensions);
}


bool RuntimeEnabledFeaturesBase::WebAppTabStripEnabled(const FeatureContext* context) {
  if (is_web_app_tab_strip_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kWebAppTabStrip);
}


bool RuntimeEnabledFeaturesBase::WebAppTabStripCustomizationsEnabled(const FeatureContext* context) {
  if (is_web_app_tab_strip_customizations_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kWebAppTabStripCustomizations);
}


bool RuntimeEnabledFeaturesBase::WebAppUrlHandlingEnabled(const FeatureContext* context) {
  if (is_web_app_url_handling_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kWebAppUrlHandling);
}


bool RuntimeEnabledFeaturesBase::WebAppWindowControlsOverlayEnabled(const FeatureContext* context) {
  if (is_web_app_window_controls_overlay_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kWebAppWindowControlsOverlay);
}


bool RuntimeEnabledFeaturesBase::WebAssemblyJSStringBuiltinsEnabled(const FeatureContext* context) {
  if (is_web_assembly_js_string_builtins_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kWebAssemblyJSStringBuiltins);
}


bool RuntimeEnabledFeaturesBase::WebTransportCustomCertificatesEnabled(const FeatureContext* context) {
  if (is_web_transport_custom_certificates_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kWebTransportCustomCertificates);
}


bool RuntimeEnabledFeaturesBase::WebViewXRequestedWithDeprecationEnabled(const FeatureContext* context) {
  if (is_web_view_xr_equested_with_deprecation_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kWebViewXRequestedWithDeprecation);
}


bool RuntimeEnabledFeaturesBase::WebXRImageTrackingEnabled(const FeatureContext* context) {
  if (!RuntimeEnabledFeaturesBase::WebXREnabled(context))
    return false;
  if (is_web_xr_image_tracking_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kWebXRImageTracking);
}


bool RuntimeEnabledFeaturesBase::WebXRPlaneDetectionEnabled(const FeatureContext* context) {
  if (!RuntimeEnabledFeaturesBase::WebXREnabled(context))
    return false;
  if (is_web_xr_plane_detection_enabled_)
    return true;
  return context && context->FeatureEnabled(mojom::blink::OriginTrialFeature::kWebXRPlaneDetection);
}


bool RuntimeEnabledFeaturesBase::is_accelerated_2d_canvas_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_accelerated_small_canvases_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_accessibility_aria_virtual_content_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_accessibility_expose_display_none_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_accessibility_expose_html_element_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_accessibility_expose_ignored_nodes_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_accessibility_object_model_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_accessibility_os_level_bold_text_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_accessibility_page_zoom_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_accessibility_serialization_size_metrics_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_accessibility_use_ax_position_for_document_markers_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_accordion_pattern_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_add_identity_in_can_make_payment_event_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_address_space_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_ad_interest_group_api_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_ad_tagging_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_align_content_for_blocks_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_allow_content_initiated_data_url_navigations_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_allow_ur_ns_in_iframes_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_android_downloadable_fonts_matching_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_animation_worklet_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_anonymous_iframe_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_aom_aria_relationship_properties_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_app_title_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_arrow_keys_in_vertical_writing_modes_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_async_clipboard_implicit_permission_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_attribution_reporting_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_attribution_reporting_cross_app_web_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_attribution_reporting_interface_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_audio_context_set_sink_id_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_audio_video_tracks_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_auto_dark_mode_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_auto_disable_accessibility_v_2_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_automation_controlled_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_autoplay_ignores_web_audio_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_auto_size_lazy_loaded_images_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_avoid_caret_visible_selection_adjuster_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_backdrop_inherit_originating_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_backface_visibility_interop_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_back_forward_cache_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_back_forward_cache_experiment_http_header_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_back_forward_cache_not_restored_reasons_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_background_fetch_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_bdi_element_dir_inheritance_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_beforeunload_event_cancel_by_prevent_default_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_bidi_caret_affinity_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_blink_extension_chrome_os_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_blink_extension_chrome_os_kiosk_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_blink_extension_diagnostics_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_blink_lifecycle_script_forbidden_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_blink_runtime_call_stats_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_blocking_focus_without_user_activation_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_block_ruby_console_message_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_block_ruby_wrapping_inline_ruby_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_boundary_event_dispatch_tracks_node_removal_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_browser_verified_user_activation_keyboard_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_browser_verified_user_activation_mouse_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_byob_fetch_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_cache_storage_code_cache_hint_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_canonicalize_whitespace_strings_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_canvas_2d_canvas_filter_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_canvas_2d_image_chromium_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_canvas_2d_layers_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_canvas_2d_mesh_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_canvas_2d_scroll_path_into_view_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_canvas_floating_point_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_canvas_hdr_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_canvas_image_smoothing_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_capability_delegation_display_capture_request_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_cct_new_rfm_push_behavior_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_check_visibility_extra_properties_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_click_to_captured_pointer_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_clipboard_supported_types_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_clipboard_svg_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_clipboard_unsanitized_content_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_clipboard_well_formed_html_sanitization_write_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_clip_path_geometry_box_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_clip_path_reject_empty_paths_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_clip_path_xywh_and_rect_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_close_watcher_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_coep_reflection_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_composite_bg_color_animation_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_composite_box_shadow_animation_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_composite_clip_path_animation_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_compression_dictionary_transport_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_compression_dictionary_transport_backend_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_computed_accessibility_info_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_compute_pressure_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_confirmation_of_action_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_consolidated_movement_xy_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_context_menu_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_cookie_deprecation_facilitated_testing_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_cooperative_scheduling_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_coop_restrict_properties_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_cors_rfc_1918_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_counter_style_change_shoule_collect_inlines_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_cross_frame_performance_timeline_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_anchor_positioning_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_anchor_positioning_cascade_fallback_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_animation_composition_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_animation_delay_start_end_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_at_rule_counter_style_image_symbols_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_at_rule_counter_style_speak_as_descriptor_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_background_clip_unprefix_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_calc_simplification_and_serialization_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_cap_font_units_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_case_sensitive_selector_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_color_contrast_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_color_typed_om_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_content_visibility_implies_contain_intrinsic_size_auto_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_cross_fade_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_display_animation_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_display_ruby_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_dynamic_range_limit_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_enumerated_custom_properties_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_exponential_functions_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_field_sizing_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_first_letter_no_new_line_as_preceding_char_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_font_size_adjust_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_hex_alpha_color_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_layout_api_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_linear_timing_function_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_logical_overflow_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_marker_nested_pseudo_element_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_masking_interop_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_mpc_improvements_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_nesting_ident_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_numeric_factory_completeness_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_offset_path_basic_shapes_circle_and_ellipse_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_offset_path_basic_shapes_rectangles_and_polygon_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_offset_path_coord_box_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_offset_path_ray_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_offset_path_ray_contain_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_offset_path_url_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_offset_position_anchor_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_overflow_media_features_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_paint_api_arguments_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_parser_ignore_charset_for_urls_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_phrase_line_break_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_position_sticky_static_scroll_position_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_progress_notation_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_pseudo_dir_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_pseudo_playing_paused_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_relative_color_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_resize_auto_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_scope_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_scroll_snap_events_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_scroll_start_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_scroll_state_container_queries_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_selector_fragment_anchor_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_selector_nth_child_complex_selector_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_sign_related_functions_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_snap_changed_event_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_snap_changing_event_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_snap_container_queries_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_spelling_grammar_errors_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_stepped_value_functions_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_sticky_container_queries_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_supports_for_import_rules_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_system_accent_color_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_text_auto_space_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_text_box_trim_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_text_spacing_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_text_spacing_trim_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_text_wrap_balance_by_score_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_text_wrap_pretty_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_transition_discrete_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_tree_scoped_timelines_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_unknown_container_queries_no_selection_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_update_media_feature_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_user_select_contain_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_variables_2_image_values_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_variables_2_transform_values_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_video_dynamic_range_media_queries_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_css_viewport_units_4_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_css_view_timeline_inset_shorthand_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_custom_elements_get_name_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_database_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_data_transfer_clear_string_items_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_date_input_inline_block_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_deprecated_template_shadow_root_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_deprecate_unload_opt_out_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_desktop_capture_disable_local_echo_control_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_desktop_pw_as_additional_windowing_controls_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_desktop_pw_as_sub_apps_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_details_element_toggle_event_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_details_styling_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_device_orientation_request_permission_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_device_posture_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_dialog_new_focus_behavior_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_direct_sockets_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_dirname_more_input_types_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_disable_different_origin_subframe_dialog_suppression_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_disable_hardware_noise_suppression_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_disable_select_all_for_empty_text_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_disable_third_party_session_storage_partitioning_after_general_partitioning_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_disable_third_party_storage_partitioning_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_dispatch_hidden_visibility_transitions_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_display_cutout_api_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_document_base_uri_fix_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_document_cookie_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_document_domain_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_document_open_origin_alias_removal_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_document_open_sandbox_inheritance_removal_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_document_policy_document_domain_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_document_policy_negotiation_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_document_policy_sync_xhr_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_document_render_blocking_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_document_write_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_dom_parser_uses_html_fast_path_parser_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_dom_parts_api_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_dont_fire_dblclick_on_disabled_form_controls_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_dynamic_scroll_cull_rect_expansion_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_edit_context_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_empty_clipboard_read_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_enforce_anonymity_exposure_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_escape_lt_gt_in_attributes_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_event_timing_interaction_count_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_exclude_broken_image_icon_from_being_lcp_eligible_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_experimental_content_security_policy_features_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_experimental_js_profiler_markers_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_experimental_policies_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_expose_render_time_non_tao_delayed_image_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_extended_text_metrics_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_extra_webgl_video_texture_metadata_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_face_detector_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_fake_no_alloc_direct_call_for_testing_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_fast_position_iterator_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_fed_cm_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_fed_cm_authz_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_fed_cm_auto_selected_flag_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_fed_cm_button_mode_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_fed_cm_disconnect_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_fed_cm_domain_hint_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_fed_cm_error_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_fed_cm_id_p_registration_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_fed_cm_idp_signin_status_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_fed_cm_multiple_identity_providers_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_fed_cm_selective_disclosure_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_fenced_frames_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_fenced_frames_api_changes_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_fenced_frames_default_mode_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_fenced_frames_local_unpartitioned_data_access_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_fetch_later_api_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_fetch_upload_streaming_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_file_system_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_file_system_access_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_file_system_access_api_experimental_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_file_system_access_locking_scheme_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_file_system_access_origin_private_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_file_system_observer_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_fledge_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_fledge_bidding_and_auction_server_api_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_fledge_clear_origin_joined_ad_interest_groups_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_fledge_direct_from_seller_signals_header_ad_slot_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_fledge_feature_detection_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_fledge_negative_targeting_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_fledge_trusted_bidding_signals_slot_size_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_fluent_overlay_scrollbars_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_fluent_scrollbars_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_flush_parser_before_creating_custom_elements_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_focusgroup_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_focus_style_invalidation_on_page_activation_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_fontations_font_backend_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_font_matching_ct_migration_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_font_palette_animation_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_font_src_local_matching_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_forced_colors_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_forced_colors_preserve_parent_color_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_force_eager_measure_memory_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_force_reduce_motion_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_formatted_text_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_form_control_restore_state_if_autocomplete_off_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_form_controls_vertical_writing_mode_direction_support_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_form_controls_vertical_writing_mode_support_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_form_controls_vertical_writing_mode_text_support_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_form_state_restore_callback_call_with_state_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_fractional_scroll_offsets_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_freeze_frames_on_visibility_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_fullscreen_popup_windows_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_gamepad_button_axis_events_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_gamepad_multitouch_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_get_all_screens_media_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_get_display_media_requires_user_activation_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_group_effect_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_hanging_whitespace_does_not_depend_on_alignment_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_has_ua_visual_transition_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_highlight_inheritance_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_highlight_pointer_events_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_hit_test_opaqueness_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_hit_test_transparency_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_href_translate_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_html_invoke_actions_v_2_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_html_invoke_target_attribute_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_html_lang_new_inheritance_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_html_parser_fast_path_bulk_insert_notify_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_html_parser_yield_and_delay_often_for_testing_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_html_popover_hint_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_html_search_element_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_html_select_element_show_picker_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_html_select_list_element_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_html_unsafe_methods_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_import_attributes_disallow_unknown_keys_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_incoming_call_notifications_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_inert_display_transition_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_infinite_cull_rect_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_inherit_user_modify_without_contenteditable_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_inner_html_parser_fastpath_log_failure_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_installed_app_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_interoperable_private_attribution_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_interrupt_composed_scrollbar_disappearance_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_intersection_observer_scroll_margin_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_intersection_optimization_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_inverted_colors_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_invisible_svg_animation_throttling_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_java_script_compile_hints_magic_runtime_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_keyboard_accessible_tooltip_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_keyboard_focusable_scrollers_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_lang_attribute_aware_form_control_ui_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_layout_align_for_positioned_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_layout_flex_new_row_algorithm_v_3_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_layout_ignore_margins_for_sticky_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_layout_new_containing_block_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_layout_new_measure_cache_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_layout_new_min_max_cache_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_layout_ng_shape_cache_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_lazy_initialize_media_controls_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_lazy_load_scroll_margin_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_lcp_animated_images_web_exposed_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_lcp_mouseover_heuristics_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_lcp_multiple_updates_per_element_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_legacy_windows_d_write_font_fallback_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_locked_mode_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_long_animation_frame_timing_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_long_task_from_long_animation_frame_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_mac_fonts_deprecate_font_traits_workaround_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_machine_learning_common_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_machine_learning_model_loader_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_managed_configuration_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_masking_grapheme_clusters_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_measure_memory_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_media_capabilities_dynamic_range_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_media_capabilities_encoding_info_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_capabilities_spatial_audio_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_capture_background_blur_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_capture_camera_controls_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_capture_configuration_change_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_capture_voice_isolation_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_cast_overlay_button_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_controls_expand_gesture_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_element_volume_greater_than_one_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_engagement_bypass_autoplay_policies_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_latency_hint_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_query_navigation_controls_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_recorder_use_media_video_encoder_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_session_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_media_session_chapter_information_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_session_enter_picture_in_picture_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_media_source_experimental_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_source_extensions_for_webcodecs_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_source_new_abort_and_duration_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_stream_track_transfer_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_message_port_close_event_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_middle_click_autoscroll_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_mobile_layout_theme_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_model_execution_api_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_mojo_js_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_mojo_js_test_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_monitor_type_surfaces_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_mouse_drag_from_iframe_on_cancelled_mouse_down_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_mouse_drag_on_cancelled_mouse_move_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_mutation_events_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_navigate_event_commit_behavior_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_navigate_event_source_element_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_navigation_activation_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_navigation_id_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_net_info_constant_type_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_next_sibling_position_use_next_candidate_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_no_idle_encoding_for_web_tests_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_non_composed_enter_leave_events_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_non_standard_appearance_values_high_usage_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_non_standard_appearance_value_slider_vertical_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_non_standard_appearance_values_low_usage_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_no_offset_mapping_for_inconsistent_text_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_notifications_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_notification_triggers_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_no_vary_search_prefetch_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_observable_api_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_off_main_thread_css_paint_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_offscreen_canvas_commit_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_offset_mapping_unit_variable_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_one_pass_raster_invalidation_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_option_element_always_use_label_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_origin_isolation_header_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_origin_policy_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_browser_read_write_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_dependent_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_deprecation_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_expiry_grace_period_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_expiry_grace_period_third_party_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_implied_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_invalid_os_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_navigation_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_persistent_expiry_grace_period_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_persistent_feature_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_persistent_invalid_os_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_persistent_third_party_deprecation_feature_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_origin_trials_sample_api_third_party_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_overscroll_customization_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_page_freeze_opt_in_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_page_freeze_opt_out_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_page_margin_boxes_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_page_reveal_event_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_paint_under_invalidation_checking_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_parakeet_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_partitioned_cookies_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_password_reveal_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_password_strong_label_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_pasting_blocks_svg_use_non_local_hrefs_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_payment_app_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_payment_handler_minimal_header_ux_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_payment_instruments_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_payment_method_change_event_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_payment_request_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_payment_request_allow_one_activationless_show_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_payment_request_merchant_validation_event_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_pending_beacon_api_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_percent_based_scrolling_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_performance_manager_instrumentation_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_performance_mark_feature_usage_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_performance_navigate_system_entropy_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_periodic_background_sync_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_per_method_can_make_payment_quota_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_permission_element_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_permissions_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_permissions_request_revoke_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_p_na_cl_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_pointer_capture_lost_on_removal_during_capture_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_pointer_event_device_id_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_position_outside_tab_span_check_sibling_node_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_precise_memory_info_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_prefer_non_composited_scrolling_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_prefers_reduced_data_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_prefixed_video_fullscreen_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_pre_paint_ancestors_of_missed_oof_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_prerender_2_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_presentation_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_pretty_print_js_on_document_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_prevent_reading_system_accent_color_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_privacy_sandbox_ads_api_s_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_private_network_access_non_secure_contexts_allowed_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_private_network_access_null_ip_address_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_private_network_access_permission_prompt_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_private_state_tokens_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_private_state_tokens_always_allow_issuance_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_push_messaging_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_push_messaging_subscription_change_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_quick_intensive_wake_up_throttling_after_loading_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_quota_change_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_readable_stream_tee_clone_for_branch_2_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_reduce_accept_language_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_reduce_cookie_ip_cs_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_reduce_user_agent_minor_version_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_reference_box_no_pixel_snapping_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_remote_playback_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_remove_dangling_markup_in_target_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_remove_data_url_in_svg_use_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_remove_mobile_viewport_double_tap_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_remove_zoom_adjustment_of_bounding_box_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_render_blocking_status_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_render_priority_attribute_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_resource_timing_content_type_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_resource_timing_use_cors_for_body_sizes_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_restrict_gamepad_access_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_rewind_floats_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_rtc_audio_jitter_buffer_max_packets_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_rtc_encoded_audio_frame_abs_capture_time_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_rtc_encoded_frame_set_metadata_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_rtc_encoded_video_frame_additional_metadata_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_rtc_legacy_callback_based_get_stats_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_rtc_rtp_encoding_parameters_codec_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_rtc_rtp_header_extension_control_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_rtc_stats_relative_packet_arrival_delay_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_rtc_svc_scalability_mode_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_ruby_inlinify_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_ruby_simple_pairing_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_run_microtask_before_xml_custom_element_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_sanitizer_api_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_scheduler_yield_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_scoped_custom_element_registry_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_scripted_speech_recognition_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_scripted_speech_synthesis_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_scrollbar_color_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_scrollbar_width_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_scroll_end_events_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_scroll_timeline_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_scroll_timeline_current_time_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_scroll_timeline_on_compositor_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_scroll_top_left_interop_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_secure_payment_confirmation_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_secure_payment_confirmation_allow_one_activationless_show_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_secure_payment_confirmation_debug_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_secure_payment_confirmation_extensions_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_secure_payment_confirmation_opt_out_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_select_hr_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_send_beacon_throw_for_blob_with_non_simple_type_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_sensor_extra_classes_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_serialize_view_transition_state_in_spa_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_service_worker_bypass_fetch_handler_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_service_worker_client_lifecycle_state_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_service_worker_race_network_request_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_service_worker_static_router_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_set_sequential_focus_starting_point_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_shadow_root_attachment_new_behavior_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_shared_array_buffer_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_shared_array_buffer_on_desktop_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_shared_array_buffer_unrestricted_access_allowed_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_shared_autofill_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_shared_storage_api_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_shared_storage_api_m_118_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_signature_based_integrity_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_site_initiated_mirroring_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_skip_ad_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_skip_touch_event_filter_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_smil_auto_suspend_on_lag_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_snap_border_widths_before_layout_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_soft_navigation_detection_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_soft_navigation_heuristics_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_soft_navigation_heuristics_expose_fp_and_fcp_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_sparse_object_paint_properties_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_speculation_rules_document_rules_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_speculation_rules_document_rules_selector_matches_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_speculation_rules_eagerness_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_speculation_rules_fetch_from_header_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_speculation_rules_implicit_source_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_speculation_rules_no_vary_search_hint_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_speculation_rules_no_vary_search_hint_shipped_by_default_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_speculation_rules_pointer_down_heuristics_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_speculation_rules_pointer_hover_heuristics_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_speculation_rules_prefetch_future_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_speculation_rules_prefetch_with_subresources_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_speculation_rules_relative_to_document_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_spell_checker_replace_range_use_insert_text_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_srcset_max_density_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_stable_blink_features_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_storage_access_api_beyond_cookies_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_storage_buckets_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_storage_buckets_durability_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_storage_buckets_locks_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_strict_mime_types_for_workers_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_stylable_select_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_stylus_handwriting_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_suggestion_picker_dark_mode_support_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_svg_cross_origin_attribute_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_svg_no_pixel_snapping_scale_adjustment_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_svg_text_fix_hittest_after_scale_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_synthesized_keyboard_events_for_accessibility_actions_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_system_wake_lock_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_test_feature_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_test_feature_dependent_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_test_feature_implied_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_text_decorating_box_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_text_detector_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_text_fragment_api_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_text_fragment_identifiers_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_text_metrics_baselines_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_timeline_scope_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_timer_throttling_for_background_tabs_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_time_zone_change_event_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_topics_api_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_topics_document_api_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_top_level_tpcd_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_touch_drag_and_context_menu_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_touch_drag_on_short_press_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_touch_event_feature_detection_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_touch_text_editing_redesign_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_tpcd_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_translate_service_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_trusted_type_before_policy_creation_event_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_trusted_types_from_literal_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_trusted_types_use_code_like_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_unclosed_form_control_is_invalid_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_unexposed_task_ids_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_unowned_animations_skip_css_events_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_unrestricted_measure_user_agent_specific_memory_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_unrestricted_shared_array_buffer_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_unrestricted_usb_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_url_attribute_fix_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_url_pattern_compare_component_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_url_pattern_has_reg_exp_groups_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_url_pattern_regexp_unicode_sets_mode_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_url_pattern_wildcard_more_often_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_url_search_params_has_and_delete_multiple_args_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_used_color_scheme_root_scrollbars_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_user_activation_same_origin_visibility_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_user_valid_user_invalid_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_v8_idle_tasks_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_video_auto_fullscreen_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_video_fullscreen_orientation_lock_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_video_playback_quality_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_video_rotate_to_fullscreen_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_video_track_generator_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_video_track_generator_in_window_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_video_track_generator_in_worker_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_viewport_height_client_hint_header_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_viewport_segments_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_view_transition_on_navigation_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_view_transition_types_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_visibility_collapse_column_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_wake_lock_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_warn_on_content_visibility_render_access_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_animations_svg_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_app_dark_mode_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_app_launch_queue_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_app_scope_extensions_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_apps_lock_screen_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_app_tab_strip_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_app_tab_strip_customizations_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_app_translations_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_app_url_handling_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_app_window_controls_overlay_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_assembly_js_string_builtins_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_auth_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_auth_allow_create_in_cross_origin_frame_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_auth_authenticator_attachment_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_authentication_hints_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_authentication_js_on_serialization_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_authentication_large_blob_extension_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_authentication_prf_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_authentication_remote_desktop_support_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_authentication_supplemental_pub_keys_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_bluetooth_get_devices_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_bluetooth_scanning_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_bluetooth_watch_advertisements_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_webcodecs_content_hint_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_webcodecs_copy_to_rgb_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_crypto_curve_25519_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_font_resize_lcp_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_webgl_developer_extensions_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_webgl_draft_extensions_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_webgl_drawing_buffer_storage_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_webgl_image_chromium_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_webgpu_developer_features_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_hid_on_service_workers_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_identity_digital_credentials_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_idl_big_int_uses_to_big_int_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_kit_scrollbar_styling_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_otp_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_otp_assertion_feature_policy_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_preferences_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_serial_bluetooth_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_share_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_websocket_stream_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_transport_custom_certificates_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_usb_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_usb_on_dedicated_workers_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_usb_on_service_workers_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_view_xr_equested_with_deprecation_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_vtt_regions_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_xr_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_xr_enabled_features_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_xr_frame_rate_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_xr_front_facing_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_xr_hand_input_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_xr_hit_test_entity_types_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_xr_image_tracking_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_xr_layers_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_xr_plane_detection_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_xr_pose_motion_data_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_wgi_gamepad_trigger_rumble_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_window_default_status_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_window_placement_fullscreen_on_screens_change_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_window_placement_permission_alias_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_xml_parser_merge_adjacent_c_data_sections_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_xywh_and_rect_computed_value_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_zero_copy_tab_capture_enabled_ = false;

// Platform-dependent features
#if BUILDFLAG(IS_ANDROID)
bool RuntimeEnabledFeaturesBase::is_audio_output_devices_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_barcode_detector_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_capture_controller_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_captured_mouse_events_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_captured_surface_control_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_capture_handle_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_composited_selection_update_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_composition_foreground_markers_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_contacts_manager_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_contacts_manager_extra_properties_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_content_index_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_device_attributes_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_digital_goods_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_digital_goods_v_2_1_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_document_picture_in_picture_api_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_element_capture_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_eye_dropper_api_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_file_handling_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_file_handling_icons_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_file_system_access_get_cloud_identifiers_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_file_system_access_local_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_font_access_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_force_taller_select_popup_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_get_display_media_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_handwriting_recognition_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_implicit_root_scroller_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_input_multiple_fields_ui_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_insert_line_break_if_phrasing_content_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_machine_learning_neural_network_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_capture_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_media_controls_overlay_play_button_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_navigator_content_utils_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_net_info_downlink_max_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_notification_constructor_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_notification_content_image_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_on_device_change_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_orientation_event_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_page_popup_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_reduce_user_agent_android_version_device_model_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_reduce_user_agent_platform_os_cpu_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_region_capture_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_remote_playback_backend_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_serial_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_shared_worker_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_smart_card_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_smart_zoom_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_text_fragment_tap_opens_context_menu_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_use_begin_frame_presentation_feedback_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_app_launch_handler_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_bluetooth_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_hid_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_nfc_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_printing_enabled_ = false;
#endif

#if BUILDFLAG(IS_WIN)
bool RuntimeEnabledFeaturesBase::is_audio_output_devices_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_barcode_detector_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_capture_controller_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_captured_mouse_events_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_captured_surface_control_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_capture_handle_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_composited_selection_update_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_composition_foreground_markers_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_contacts_manager_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_contacts_manager_extra_properties_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_content_index_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_device_attributes_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_digital_goods_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_digital_goods_v_2_1_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_document_picture_in_picture_api_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_element_capture_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_eye_dropper_api_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_file_handling_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_file_handling_icons_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_file_system_access_get_cloud_identifiers_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_file_system_access_local_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_font_access_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_force_taller_select_popup_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_get_display_media_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_handwriting_recognition_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_implicit_root_scroller_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_input_multiple_fields_ui_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_insert_line_break_if_phrasing_content_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_machine_learning_neural_network_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_capture_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_controls_overlay_play_button_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_navigator_content_utils_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_net_info_downlink_max_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_notification_constructor_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_notification_content_image_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_on_device_change_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_orientation_event_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_page_popup_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_reduce_user_agent_android_version_device_model_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_reduce_user_agent_platform_os_cpu_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_region_capture_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_remote_playback_backend_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_serial_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_shared_worker_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_smart_card_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_smart_zoom_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_text_fragment_tap_opens_context_menu_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_use_begin_frame_presentation_feedback_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_app_launch_handler_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_bluetooth_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_hid_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_nfc_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_printing_enabled_ = false;
#endif

#if BUILDFLAG(IS_CHROMEOS_ASH)
bool RuntimeEnabledFeaturesBase::is_audio_output_devices_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_barcode_detector_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_capture_controller_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_captured_mouse_events_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_captured_surface_control_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_capture_handle_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_composited_selection_update_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_composition_foreground_markers_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_contacts_manager_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_contacts_manager_extra_properties_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_content_index_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_device_attributes_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_digital_goods_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_digital_goods_v_2_1_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_document_picture_in_picture_api_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_element_capture_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_eye_dropper_api_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_file_handling_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_file_handling_icons_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_file_system_access_get_cloud_identifiers_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_file_system_access_local_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_font_access_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_force_taller_select_popup_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_get_display_media_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_handwriting_recognition_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_implicit_root_scroller_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_input_multiple_fields_ui_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_insert_line_break_if_phrasing_content_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_machine_learning_neural_network_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_capture_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_controls_overlay_play_button_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_navigator_content_utils_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_net_info_downlink_max_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_notification_constructor_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_notification_content_image_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_on_device_change_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_orientation_event_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_page_popup_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_reduce_user_agent_android_version_device_model_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_reduce_user_agent_platform_os_cpu_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_region_capture_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_remote_playback_backend_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_serial_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_shared_worker_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_smart_card_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_smart_zoom_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_text_fragment_tap_opens_context_menu_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_use_begin_frame_presentation_feedback_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_app_launch_handler_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_bluetooth_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_hid_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_nfc_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_printing_enabled_ = false;
#endif

#if BUILDFLAG(IS_CHROMEOS_LACROS)
bool RuntimeEnabledFeaturesBase::is_audio_output_devices_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_barcode_detector_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_capture_controller_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_captured_mouse_events_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_captured_surface_control_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_capture_handle_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_composited_selection_update_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_composition_foreground_markers_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_contacts_manager_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_contacts_manager_extra_properties_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_content_index_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_device_attributes_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_digital_goods_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_digital_goods_v_2_1_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_document_picture_in_picture_api_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_element_capture_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_eye_dropper_api_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_file_handling_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_file_handling_icons_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_file_system_access_get_cloud_identifiers_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_file_system_access_local_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_font_access_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_force_taller_select_popup_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_get_display_media_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_handwriting_recognition_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_implicit_root_scroller_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_input_multiple_fields_ui_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_insert_line_break_if_phrasing_content_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_machine_learning_neural_network_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_capture_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_controls_overlay_play_button_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_navigator_content_utils_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_net_info_downlink_max_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_notification_constructor_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_notification_content_image_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_on_device_change_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_orientation_event_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_page_popup_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_reduce_user_agent_android_version_device_model_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_reduce_user_agent_platform_os_cpu_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_region_capture_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_remote_playback_backend_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_serial_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_shared_worker_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_smart_card_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_smart_zoom_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_text_fragment_tap_opens_context_menu_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_use_begin_frame_presentation_feedback_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_app_launch_handler_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_bluetooth_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_hid_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_nfc_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_printing_enabled_ = false;
#endif

#if BUILDFLAG(IS_MAC)
bool RuntimeEnabledFeaturesBase::is_audio_output_devices_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_barcode_detector_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_capture_controller_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_captured_mouse_events_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_captured_surface_control_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_capture_handle_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_composited_selection_update_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_composition_foreground_markers_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_contacts_manager_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_contacts_manager_extra_properties_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_content_index_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_device_attributes_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_digital_goods_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_digital_goods_v_2_1_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_document_picture_in_picture_api_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_element_capture_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_eye_dropper_api_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_file_handling_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_file_handling_icons_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_file_system_access_get_cloud_identifiers_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_file_system_access_local_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_font_access_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_force_taller_select_popup_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_get_display_media_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_handwriting_recognition_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_implicit_root_scroller_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_input_multiple_fields_ui_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_insert_line_break_if_phrasing_content_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_machine_learning_neural_network_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_capture_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_controls_overlay_play_button_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_navigator_content_utils_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_net_info_downlink_max_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_notification_constructor_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_notification_content_image_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_on_device_change_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_orientation_event_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_page_popup_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_reduce_user_agent_android_version_device_model_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_reduce_user_agent_platform_os_cpu_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_region_capture_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_remote_playback_backend_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_serial_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_shared_worker_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_smart_card_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_smart_zoom_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_text_fragment_tap_opens_context_menu_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_use_begin_frame_presentation_feedback_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_app_launch_handler_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_bluetooth_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_hid_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_nfc_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_printing_enabled_ = false;
#endif

#if BUILDFLAG(IS_LINUX)
bool RuntimeEnabledFeaturesBase::is_audio_output_devices_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_barcode_detector_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_capture_controller_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_captured_mouse_events_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_captured_surface_control_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_capture_handle_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_composited_selection_update_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_composition_foreground_markers_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_contacts_manager_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_contacts_manager_extra_properties_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_content_index_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_device_attributes_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_digital_goods_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_digital_goods_v_2_1_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_document_picture_in_picture_api_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_element_capture_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_eye_dropper_api_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_file_handling_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_file_handling_icons_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_file_system_access_get_cloud_identifiers_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_file_system_access_local_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_font_access_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_force_taller_select_popup_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_get_display_media_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_handwriting_recognition_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_implicit_root_scroller_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_input_multiple_fields_ui_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_insert_line_break_if_phrasing_content_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_machine_learning_neural_network_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_capture_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_controls_overlay_play_button_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_navigator_content_utils_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_net_info_downlink_max_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_notification_constructor_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_notification_content_image_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_on_device_change_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_orientation_event_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_page_popup_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_reduce_user_agent_android_version_device_model_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_reduce_user_agent_platform_os_cpu_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_region_capture_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_remote_playback_backend_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_serial_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_shared_worker_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_smart_card_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_smart_zoom_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_text_fragment_tap_opens_context_menu_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_use_begin_frame_presentation_feedback_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_app_launch_handler_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_bluetooth_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_hid_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_nfc_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_printing_enabled_ = false;
#endif

// Default values for platforms not specifically handled above
#if !BUILDFLAG(IS_ANDROID) && !BUILDFLAG(IS_WIN) && !BUILDFLAG(IS_CHROMEOS_ASH) && !BUILDFLAG(IS_CHROMEOS_LACROS) && !BUILDFLAG(IS_MAC) && !BUILDFLAG(IS_LINUX)
bool RuntimeEnabledFeaturesBase::is_audio_output_devices_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_barcode_detector_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_capture_controller_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_captured_mouse_events_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_captured_surface_control_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_capture_handle_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_composited_selection_update_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_composition_foreground_markers_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_contacts_manager_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_contacts_manager_extra_properties_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_content_index_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_device_attributes_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_digital_goods_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_digital_goods_v_2_1_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_document_picture_in_picture_api_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_element_capture_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_eye_dropper_api_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_file_handling_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_file_handling_icons_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_file_system_access_get_cloud_identifiers_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_file_system_access_local_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_font_access_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_force_taller_select_popup_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_get_display_media_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_handwriting_recognition_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_implicit_root_scroller_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_input_multiple_fields_ui_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_insert_line_break_if_phrasing_content_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_machine_learning_neural_network_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_capture_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_media_controls_overlay_play_button_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_navigator_content_utils_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_net_info_downlink_max_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_notification_constructor_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_notification_content_image_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_on_device_change_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_orientation_event_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_page_popup_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_reduce_user_agent_android_version_device_model_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_reduce_user_agent_platform_os_cpu_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_region_capture_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_remote_playback_backend_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_serial_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_shared_worker_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_smart_card_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_smart_zoom_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_text_fragment_tap_opens_context_menu_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_use_begin_frame_presentation_feedback_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_app_launch_handler_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_bluetooth_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_hid_enabled_ = true;
bool RuntimeEnabledFeaturesBase::is_web_nfc_enabled_ = false;
bool RuntimeEnabledFeaturesBase::is_web_printing_enabled_ = false;
#endif

} // namespace blink
